function out = blkdiag(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z);
%BLKDIAG Constructs a block diagonal matrix based on the input.
%       OUT = BLKDIAG(A,B,C,...) constructs a block diagonal matrix, such that
%                   | A 0 0 ... 0 |       
%               Y = | 0 B 0 ... 0 |
%                   | 0 0 C ... 0 |
%                   | ...         |
%       The input parameters are limited to no more than 26.
%

%       Wes Wang 9/9/94, 9/30/95.
%       Copyright (c) 1995-96 by The MathWorks, Inc.
%       $Revision: 1.1 $  $Date: 1996/04/01 17:52:29 $

out = []; tmp = [];
for i = 1 : nargin
    eval(['tmp = ', setstr(96+i), ';']);
    [n_tmp, m_tmp] = size(tmp);
    [n_out, m_out] = size(out);
    out = [out, zeros(n_out, m_tmp); zeros(n_tmp, m_out), tmp];
end;
