function closebut(fh)
%CLOSEBUT close all figures and SIMULINK blocks diagrams except the figure
%       with the given handle fh. This function is specially useful in the
%       uitools in control of the figures.
%
%       See also: CLOSE, BDCLOSE, HTHELP.

%       Wes Wang 11/20/95
%       Copyright (c) 1995-96 by The MathWorks, Inc.
%       $Revision: 1.1 $  $Date: 1996/04/01 17:52:44 $

x = get(0,'child');
for i = 1:length(fh)
    inx=find(x==fh(i));
    x(inx) = [];
end;
delete(x);
bdclose all;
