function commod(com_fig);
% COMMOD
%
%

%       Copyright (c) 1995-96 by The MathWorks, Inc.
%       $Revision: 1.1 $  $Date: 1996/04/01 17:53:50 $

if nargin < 1
  return;
elseif ~(com_fig > 0)
  return;
end;
handle = get(gcf, 'UserData');
if ~isempty(handle)
    h_axes = handle(1);
    h_plot = handle(2);
    testl  = handle(3:7);
    popmu  = handle(8:12);
    entr_text = handle(13:32);
    entr_valu = handle(33:52);
    exec = handle(53:63);
    data_h = handle(60:63);
    load_save = handle(64:67);
    bar_color = handle(68:69);
    ex_flag = handle(70:76);
else
    error('The GUI figure is distroyed. Close the window and restart COMMGUI.');
end;

set(bar_color(1), 'Visible', 'off');
set(bar_color(2), 'Visible', 'on');
default_color = get(0, 'DefaultUicontrolBackgroundColor');

for i = 1 : length(entr_valu)
  if strcmp(get(entr_valu(i), 'Visible'), 'off')
    set(entr_valu(i), 'String', '');
  end;
end;

Fd = str2num(get(entr_valu(1), 'String'));
Fd = comempty(Fd, entr_valu(1), 1);
source_flag = get(popmu(1), 'Value');
if source_flag == 2
    NN = get(entr_valu(2), 'String');
    if isempty(NN)
        set(entr_valu(2), 'UserData', randint(100,1));
    end;
    NN = comempty(NN, entr_valu(2), 100);
    msgg = get(entr_valu(2), 'UserData');
    data_length = ones(1, size(msgg, 2)) * size(msgg, 1);
else
    data_length = str2num(get(entr_valu(2), 'String'));
    data_length = comempty(data_length, entr_valu(2), 100);
end;
Vaa = str2num(get(entr_valu(13), 'String'));
Vaa = comempty(Vaa, entr_valu(13), .5);

Vaa_len = length(Vaa);

MultipleNumb = str2num(get(entr_valu(3), 'String'));
MultipleNumb = comempty(MultipleNumb, entr_valu(3), 2);
MultipleNumb = comleng(MultipleNumb, Vaa, 'First Entry for channel');

if source_flag == 2
    if size(msgg, 2) < length(MultipleNumb)
        msgg(:, size(msgg,2)+1:length(MultipleNumb)) = msgg(:,1)*ones(1, length(MultipleNumb)-size(msgg,2));
    end;
end;

for loop = 1 : Vaa_len
    set(ex_flag(1:7),'Visible', 'off')
    drawnow
    % source
    set(ex_flag(1),'Color',[1 0 0], 'Visible', 'on')
    drawnow
    if source_flag == 1
        %random Integer
        Seed = str2num(get(entr_valu(4), 'String'));
        Seed = comempty(Seed, entr_valu(4), 12345);
        if isempty(Seed)
            Seed = sum(date) * sum(handle) + loop;
        end;
        Seed = comleng(Seed, Vaa, 'Seed');
        x = randint(data_length(loop), 1, MultipleNumb(loop));
        indx = de2bi(x, MultipleNumb(loop))';
    elseif source_flag == 2
        x = msgg(:, loop);
        indx = de2bi(x, MultipleNumb(loop))';
    elseif source_flag == 3
        %your own source goes here.
    end;
    set(bar_color(2), 'XData',[0 (loop-6/7)/Vaa_len (loop-6/7)/Vaa_len 0])
    set(ex_flag(1),'Color',[1 1 1], 'Visible', 'on')

    % error control coding
    set(ex_flag(2),'Color',[1 0 0], 'Visible', 'on')
    drawnow
    list_valu = get(popmu(2), 'Value');
    
%    indx_bi = de2bi(indx, ceil(log(MN)/log(2)))';
    indx_bi = indx(:);
    if list_valu > 1
        if sum(abs(indx-floor(indx))) > 0
            error('You have to use source coding before error-control coding.');
        end;
        tmp = [...
                 'Hamming ';...
                 'Linear  ';...
                 'Cyclic  ';...
                 'BCH     ';...
                 'RS      ';...
                 'Convolut'...
               ];
        mthd_cod = deblank(tmp(list_valu-1,:));
        Ncd = str2num(get(entr_valu(5), 'String'));
        if list_valu ~= 7
            Ncd = comempty(Ncd, entr_valu(5), 7);
        end;
        Mcd = str2num(get(entr_valu(6), 'String'));
        if list_valu ~= 7
            if Mcd > Ncd
                Mcd = [];
            end;
            default_v = Ncd - ceil(log(Ncd)/log(2));
            if list_valu == 6
                default_v = Ncd -2;
            end
            Mcd = comempty(Mcd, entr_valu(6), default_v);
        end;
        Xcd = get(entr_valu(7), 'String');
        if isempty(Xcd)
            if list_valu == 3
                % block
                [junk, default_v] = hammgen(ceil(log(Ncd)/log(2)));
                Xcd = comempty(Xcd, entr_valu(7), default_v);
                Ncd = 2^ceil(log(Ncd)/log(2)) - 1;
                Mcd = Ncd - ceil(log(Ncd)/log(2));
                set(entr_valu(5), 'String',num2str(Ncd));
                set(entr_valu(6), 'String',num2str(Mcd));
            elseif list_valu == 4
                % cyclic
                default_v = cyclpoly(Ncd, Mcd);
                Xcd = comempty(Xcd, entr_valu(7), default_v);
            elseif list_valu == 7
                % convolution
                Xcd = comempty(Xcd, entr_valu(7), 'fig_10_9');
            end;
        end;
        if list_valu ~= 8
            if list_valu == 7
                [A,B,C,D,N,K,M] = gen2abcd(Xcd);
                Ncd = comempty(Ncd, entr_valu(5), N);        
                Mcd = comempty(Mcd, entr_valu(6), K);        
                Ycd = str2num(get(entr_valu(8), 'String'));
                Ycd = comempty(Ycd, entr_valu(8), Ncd * 2);
            end;
            if isempty(Xcd)
                code_word = encode(indx_bi, Ncd, Mcd, mthd_cod);
            else
                if max((abs(Xcd)>=97) & (abs(Xcd)<=122)) | max((abs(Xcd)>=65) & (abs(Xcd)<=90))
                else
                    Xcd = str2mat(Xcd);
                end;
                code_word = encode(indx_bi, Ncd, Mcd, mthd_cod, Xcd);
            end;
        else
            % your own error-control code goes here.
            % Ncd is param1 
            % Mcd is param2
            % Xcd is param3
            % Ycd is param4
            %code_word = ???(indx, Ncd, Mcd, Xcd, Ycd);
        end;
    else
        code_word = indx_bi;
    end;
    set(bar_color(2), 'XData',[0 (loop-5/7)/Vaa_len (loop-5/7)/Vaa_len  0])
    set(ex_flag(2),'Color',[1 1 1], 'Visible', 'on')

    %modulation
    set(ex_flag(3),'Color',[1 0 0], 'Visible', 'on')
    drawnow
    list_valu = get(popmu(3), 'Value');
    if list_valu > 1
        Fs = str2num(get(entr_valu(9), 'String'));
        Fs = comempty(Fs, entr_valu(9), Fd*5);
        pp2 = str2num(get(entr_valu(10), 'String'));
        default1 = 16;
        default2 = 1;
        if list_valu == 5
            default1 = [1 1 -1 -1];
            default2 = [1 -1 -1 1];
        elseif list_valu == 6
            default2 = Fd;
        end;
        pp2 = comempty(pp2, entr_valu(10), default1);
        pp3 = str2num(get(entr_valu(11), 'String'));
        pp3 = comempty(pp3, entr_valu(11), default2);
        pp4 = str2num(get(entr_valu(12), 'String'));
        pp4 = comempty(pp4, entr_valu(12), 0);
        pp5 = str2num(get(entr_valu(17), 'String'));
        pp5 = comempty(pp5, entr_valu(17), 0);
        pp6 = str2num(get(entr_valu(18), 'String'));
        pp7 = str2num(get(entr_valu(19), 'String'));
        Fc = str2num(get(entr_valu(20), 'String'));
        Fc = comempty(Fc, entr_valu(20), Fs/3);
        if Fs < Fd
            disp('Warning: Modulation sample frequency should be larger than digital frequuncy.');
        end
        if (list_valu == 9)
            % your own modulation goes here
            % modulated == ???
        else
            if (list_valu == 2) ...
               | (list_valu == 3) ...
               | (list_valu == 6) ...
               | (list_valu == 7)
                MLP = pp2;
            elseif (list_valu == 4)
                MLP = sum(pp2);
            elseif (list_valu == 5)
                MLP = length(pp2);
            elseif (list_valu == 8)
                MLP = 2;
            end;
            bit_numb = floor(log(MLP) / log(2));
            bf_mod = vec2mat(code_word, bit_numb);
            bf_mod = bi2de(bf_mod);
            mthd = get(popmu(3), 'String');
            mthd = deblank(mthd(list_valu, :));
            if  get(popmu(5), 'Value') == 1
                %passband
                if isempty(pp2)
                    modulated = dmod(bf_mod, Fc, Fd, [Fs, pp5], mthd);
                elseif isempty(pp3)
                    modulated = dmod(bf_mod, Fc, Fd, [Fs, pp5], mthd, pp2);
                elseif isempty(pp4)
                    modulated = dmod(bf_mod, Fc, Fd, [Fs, pp5], mthd, pp2, pp3);
                else
                    modulated = dmod(bf_mod, Fc, Fd, [Fs, pp5], mthd, pp2, pp3, pp4);
                end;
            else
                %baseband
                if isempty(pp2)
                    modulated = dmodce(bf_mod, Fd, [Fs, pp5], mthd);
                elseif isempty(pp3)
                    modulated = dmodce(bf_mod, Fd, [Fs, pp5], mthd, pp2);
                elseif isempty(pp4)
                    modulated = dmodce(bf_mod, Fd, [Fs, pp5], mthd, pp2, pp3);
                else
                    modulated = dmodce(bf_mod, Fd, [Fs, pp5], mthd, pp2, pp3, pp4);
                end;
            end;
        end;
    else
        modulated = code_word;
    end;
    set(bar_color(2), 'XData',[0 (loop-4/7)/Vaa_len (loop-4/7)/Vaa_len  0])
    set(ex_flag(3),'Color',[1 1 1], 'Visible', 'on')

    %channel:
    set(ex_flag(4),'Color',[1 0 0], 'Visible', 'on')
    drawnow
    sig_eng = sum(modulated .* conj(modulated));
    
    list_valu = get(popmu(4), 'Value');
    
    if list_valu > 1
        p51 = str2num(get(entr_valu(13), 'String'));
        p52 = str2num(get(entr_valu(14), 'String'));
        p52 = comempty(p52, entr_valu(14), 0);
        p53 = str2num(get(entr_valu(15), 'String'));
        p53 = comempty(p53, entr_valu(15), 0);
        p54 = str2num(get(entr_valu(16), 'String'));
        p54 = comempty(p54, entr_valu(16), 0);
        if list_valu == 2
            p52 = p52+loop;
            randn('seed', p52');
            if (get(popmu(3), 'Value') ~= 1) & (get(popmu(5), 'Value') == 1)
                %complex
                nois = randn(length(modulated), 2) * p51(loop);
                nois = nois(:, 1) + j*nois(:, 2);
            else
                % real
                nois = randn(length(modulated), 1) * p51(loop);
            end;
        elseif list_valu == 3
            p53 = p53 + loop;
            rand('seed', p52');
            if (get(popmu(3), 'Value') ~= 1) & (get(popmu(5), 'Value') == 1)
                %complex
                nois = rand(length(modulated), 2) * (p51(loop) - p52(loop)) - p52(loop);
                nois = nois(:, 1) + j*nois(:, 2);
            else
                % real
                nois = randn(length(modulated), 1) * (p51(loop) - p52(loop)) - p52(loop);
            end;
        elseif list_valu == 4
            %N/A
            if (get(popmu(3),'Value') ~= 1)
                disp('Binary noise can apply to the case without modulation only.')
                disp('No noise is added to the simulation.')
                nois = 0;
            else
                p52 = p52 + loop;
                randn('seed', p52');
                nois = rand(length(modulated), 1) < p51(loop);
            end;
        elseif list_valu == 5
            % your noise
            % nois = ???
        end;
        modulated = modulated + nois;
        if list_valu == 4
            modulated = rem(modulated, 2);
        end;
    else
        nois = 0;
    end;
    if list_valu == 4
        if p51(loop) > 0
            snratio = 1/p51(loop);
        else
            snratio = Inf;
        end;
    else
        noi_eng = sum(nois .* conj(nois));
        if noi_eng ~= 0
            snratio = sig_eng/noi_eng;
        else
            snratio = Inf;
        end;
    end;
%    set(data_h(3), 'UserData', [get(data_h(3), 'UserData'), snratio]);
%    set(data_h(3), 'String', mat2str(get(data_h(3), 'UserData'), 6));
    set(bar_color(2), 'XData',[0 (loop-3/7)/Vaa_len (loop-3/7)/Vaa_len   0])
    set(ex_flag(4),'Color',[1 1 1], 'Visible', 'on')

    % demodualtion
    set(ex_flag(5),'Color',[1 0 0], 'Visible', 'on')
    drawnow
    list_valu = get(popmu(3), 'Value');
    band_valu = get(popmu(5), 'Value');
    if list_valu > 1
        if loop == 1
            if isempty(pp6) & band_valu == 1
                [lpfltnum, lpfltden] = butter(5, Fc * 2 / Fs);
            else
                lpfltnum = pp6;
                lpfltden = pp7;
            end;
        end;
        if band_valu == 1
            if list_valu == 2
                demodulated = ddemod(modulated, Fc, Fd, [Fs, pp5], 'ask', pp2, lpfltnum, lpfltden);
            elseif list_valu == 3
                demodulated = ddemod(modulated, Fc, Fd, [Fs, pp5], 'qask', pp2, lpfltnum, lpfltden);
            elseif list_valu == 4
                demodulated = ddemod(modulated, Fc, Fd, [Fs, pp5], 'qask/cir', pp2, pp3, pp4, lpfltnum, lpfltden);
            elseif list_valu == 5
                demodulated = ddemod(modulated, Fc, Fd, [Fs, pp5], 'qask/arb', pp2, pp3, lpfltnum, lpfltden);
            elseif list_valu == 6
                demodulated = ddemod(modulated, Fc, Fd, [Fs, pp5], 'fsk', pp2, pp3);
            elseif list_valu == 7
                demodulated = ddemod(modulated, Fc, Fd, [Fs, pp5], 'psk', pp2, lpfltnum, lpfltden);
            elseif list_valu == 8
                demodulated = ddemod(modulated, Fc, Fd, [Fs, pp5], 'msk');
            elseif list_valu == 9
                % your demodualtion method goes here 
            end;
        else
            if list_valu == 2
                if isempty(pp6)
                    demodulated = ddemodce(modulated, Fd, [Fs, pp5], 'ask', pp2);
                else
                    demodulated = ddemodce(modulated, Fd, [Fs, pp5], 'ask', pp2, lpfltnum, lpfltden);
                end
            elseif list_valu == 3
                if isempty(pp6)
                    demodulated = ddemodce(modulated, Fd, [Fs, pp5], 'qask', pp2);
                else
                    demodulated = ddemodce(modulated, Fd, [Fs, pp5], 'qask', pp2, lpfltnum, lpfltden);
                end;
            elseif list_valu == 4
                if isempty(pp6)
                    demodulated = ddemodce(modulated, Fd, [Fs, pp5], 'qask/cir', pp2, pp3, pp4);
                else
                    demodulated = ddemodce(modulated, Fd, [Fs, pp5], 'qask/cir', pp2, pp3, pp4, lpfltnum, lpfltden);
                end;
            elseif list_valu == 5
                if isempty(pp6)
                    demodulated = ddemodce(modulated, Fd, [Fs, pp5], 'qask/arb', pp2, pp3);
                else
                    demodulated = ddemodce(modulated, Fd, [Fs, pp5], 'qask/arb', pp2, pp3, lpfltnum, lpfltden);
                end;
            elseif list_valu == 6
                demodulated = ddemodce(modulated, Fd, [Fs, pp5], 'fsk', pp2, pp3);
            elseif list_valu == 7
                if isempty(pp6)
                    demodulated = ddemodce(modulated, Fd, [Fs, pp5], 'psk', pp2);
                else
                    demodulated = ddemodce(modulated, Fd, [Fs, pp5], 'psk', pp2, lpfltnum, lpfltden);
                end;
            elseif list_valu == 8
                demodulated = ddemodce(modulated, Fd, [Fs, pp5], 'msk');
            elseif list_valu == 9
                % your demodualtion method goes here 
            end;
        end
    else
        demodulated = modulated;
        bit_numb = 1;
    end;
    demodulated = de2bi(demodulated, bit_numb)';
    demodulated = demodulated(:);
    demodulated = demodulated(1:length(code_word));
    bit_err = sum(abs(demodulated - code_word)) / length(code_word);
%    set(data_h(2), 'UserData', [get(data_h(2), 'UserData'), bit_err]);
%    set(data_h(2), 'String', mat2str(get(data_h(2), 'UserData'),6));
    set(bar_color(2), 'XData',[0 (loop-2/7)/Vaa_len (loop-2/7)/Vaa_len   0])
    set(ex_flag(5),'Color',[1 1 1], 'Visible', 'on')

    %decode
    set(ex_flag(6),'Color',[1 0 0], 'Visible', 'on')
    drawnow
    list_valu = get(popmu(2), 'Value');
    if list_valu > 1        
        if list_valu ~= 8
            if isempty(Xcd)
                msg = decode(demodulated, Ncd, Mcd, mthd_cod);
            elseif isempty(Ycd)
                msg = decode(demodulated, Ncd, Mcd, mthd_cod, Xcd);
            else
                msg = decode(demodulated, Ncd, Mcd, mthd_cod, Xcd, Ycd);
            end;
        else
            % your own error-control code goes here.
            %msg = ???(demodulated, Ncd, Mcd, Xcd, Ycd);
        end;
    else
        msg = demodulated;
    end;
    msg=msg(:);
    set(ex_flag(6),'Color',[1 1 1], 'Visible', 'on')
    set(bar_color(2), 'XData',[0 (loop-1/7)/Vaa_len (loop-1/7)/Vaa_len   0])

    set(ex_flag(7),'Color',[1 0 0], 'Visible', 'on')
    bit_err = sum(abs(msg(1:length(indx_bi)) - indx_bi)) / length(indx_bi);

%    set(data_h(3), 'UserData', [get(data_h(3), 'UserData'), snratio]);
%    set(data_h(3), 'String', mat2str(get(data_h(3), 'UserData'), 6));
    set(data_h(4), 'UserData', [get(data_h(4), 'UserData'), [snratio; bit_err]]);
    tmp = get(data_h(4), 'UserData');
    set(data_h(4),'String', ['snr=',mat2str(tmp(1, :), 4),...
                   '; bit_err_ratio=',mat2str(tmp(2, :), 4)],...
                  'Visible', 'on')

    set(bar_color(2), 'XData',[0 (loop-0/7)/Vaa_len (loop-0/7)/Vaa_len   0])

    set(exec(3), 'Enable','on');
    set(ex_flag(7),'Color',[1 1 1], 'Visible', 'on');
    drawnow;
end;
set(bar_color(2), 'Xdata', [0 0 0 0]);
set(ex_flag(1:7),'Visible', 'off');
set(entr_valu, 'ForegroundColor', [0 0 0]);
