function isp = isprime(X)
%ISPRIME True for prime numbers.
%       ISPRIME(X) is 1 for the elements of X which are prime, 0 otherwise.
%
%       See also PRIMES.

%       Wes Wang 10/10/95 
%       Copyright (c) 1995-96 by The MathWorks, Inc.
%       $Revision: 1.1 $  $Date: 1996/04/01 18:01:16 $
isp = X;
n = max(max(X));
p = primes(n);
for k = 1:prod(size(isp))
   isp(k) = any(X(k) == p);
end
