function p = primes(n)
%PRIMES Generates prime numbers.
%       P = PRIMES(N) produces a row vector in P, which contains the prime
%       numbers less than or equal to N.
%
%       See also: ISPRIME.

%       Wes Wang 10/11/95
%       Copyright (c) 1995-96 by The MathWorks, Inc.
%       $Revision: 1.1 $  $Date: 1996/04/01 18:01:38 $
p = 1:n;
p(1) = 0;
for k = 1:sqrt(n)
   if p(k)
      p(2*k:k:n) = 0*(2*k:k:n);
   end
end
p = p(p>0);

%--end of primes.m---
