% Communications Toolbox SIMULINK files
% Version 1.0  10-Apr-96
%
% Top level file for communications toolbox library:
%   commu       - Communications Toolbox top level library.
%
% Secondary level files for communications toolbox library:
%   com_chan    - Channel sub-library.
%   com_cmpr    - Compression sub-library.
%   com_code    - Error-control code sub-library.
%   com_dimo    - Digital modulation/demodulation sub-library.
%   com_encr    - Encrypt sub-library.
%   com_frmt    - Source coding sub-library.
%   com_mlac    - Multi-access sub-library.
%   com_mux     - Multi-access sub-library.
%   com_smsc    - SIMULINK source sub-library.
%   com_smsk    - SIMULINK sink sub-library.
%   com_sour    - Source/sink sub-library.
%   com_sprd    - Spread spectrum sub-library.
%   com_sync    - Synchronization sub-library.
%   com_tran    - Transmission/Receiving sub-library.
%   com_util    - Utility sub-library.
%
% Third level files for communications toolbox library:
%   comcdbch    - BCH error-control code sub-library.
%   comcdcon    - Convolution error-control code sub-library.
%   comcdcyc    - Cyclic error-control code sub-library.
%   comcdham    - Hamming error-control code sub-library.
%   comcdlin    - Linear block error-control code sub-library.
%   comcdrs     - Reed-Solomon error-control code sub-library.
%
% Source/sink library demonstration files:
%	ttrigwks    - Read/write workspace variables
%	ttrigfil	- Read/write files
%	tsteyesc	- Eye-pattern Diagram and Error-meter
%	tstbterr	- Error-meter
%	turand  	- Uniform random noise generator
%	tgrand  	- Gaussian random  noise generator
%	tirand  	- Random integer generator
%	tprand  	- Poisson integer generator
%	tbrand  	- Binary vector generator
%	tstrayl 	- Rayleigh noise generator
%	tstricia	- Rician noise generator
%	
% Source coding library demonstration files:
%	tstquans	- quantization encode and decode
%	tstdpcm 	- DPCM encode and decode
%	tstquant	- enable quantization encode and decode
%	
%	Error-Control Coding Library
%	tsthammc	- Hamming code vector I/O
%	tsthamsq	- Hamming code sequantial I/O
%	tstbchcd	- BCH code vector I/O
%	tutbchcd	- BCH code vector I/O, 2
%	tstbchsq	- BCH code sequential I/O
%	tstrscod	- RS code integer vector I/O
%	tstrscbv	- RS code binary vector I/O
%	tstrsinv	- RS code integer sequential I/O
%	tstrsbnv	- RS code binary sequential I/O
%	tstcyclc	- Cyclic code, Hamming code, and linear block code vector I/O
%	tstcycsq	- Cyclic code sequential I/O
%	tstlinco	- Linear block code vector I/O
%	tstlinsq	- Linear block code sequential I/O
%	tstconcd	- Convolution code vector I/O
%	tutconcd	- Convolution code vector I/O, 2
%	tstcomsq	- Convolution code Sequential I/O
%	fig_10_9	- Block diagram for building convolution code transfer function
%	exconvcd	- Block diagram for building convolution code transfer function
%	
% Modulation and demodulation demonstration files:
%	test_am2	- DSB-SC AM/ADM passband and baseband
%	test_qa2	- QAM passband and baseband
%	test_fm2	- FM passband and baseband
%	test_fm2	- PM passband and baseband
%	testssba	- SSB AM passband and baseband
%	testamc2	- AM with carrier passband and baseband
%	tstam2cd	- MASK map/demap, passband
%	tstqa2cd	- QASK S-map map/demap, passband
%	tstps2cd	- QASK C-map map/demap, passband
%	tstps3cd	- QASK A-map map/demap, passband
%	tstfs2cd	- MFSK map/demap, passband
%	tstpk2cd	- MPSK map/demap, passband
%	tmpam2cd	- MASK map/demap, baseband
%	tmpqa2cd	- QASK S-map map/demap, baseband
%	tmpps2cd	- QASK C-map map/demap, baseband
%	tmpps3cd	- QASK A-map map/demap, baseband
%	tmpfs2cd	- MFSK map/demap, passband
%	tmppk2cd	- MPSK map/demap, passband
%	tddmmask	- MASK mo/dem, passband
%	tddmqask	- QASK S-map mo/dem, passband
%	tutcdwmo	- QASK S-map with BCH code, passband
%	tddps2cd	- QASK C-map mo/dem, passband
%	tddps3cd	- QASK A-map mo/dem, passband
%	tddmmfsk	- MFSK mo/dem, passband
%	tddmmpsk	- MPSK mo/dem, passband
%	tstam2ce	- MASK mo/dem, baseband
%	tcemqask	- QASK S-map mo/dem, baseband
%	tceps2cd	- QASK C-map mo/dem, baseband
%	tceps3cd	- QASK A-map mo/dem, baseband
%	tcemmfsk	- MFSK mo/dem, baseband
%	tcemmpsk	- MPSK mo/dem, baseband
%	
% Multiple access demonstration files:
%	tsttdma 	- Digital TDMA
%	tsttdmaa	- Time-sharing multiplex
%	tstfdma 	- FDMA
%	tstcdma 	- CDMA
%	
% Special filters demonstration files:
%	tstrcos 	- Raised cosine filter
%	tstrcos2	- Raised cosine filter
%	tstsinc 	- Sinc filter
%	tsthilbt	- Hilbert transform filter
%	
% Synchronization demonstration files:
%	tstpll  	- Phase locked loop
%	
% Utilities and miscellany library demonstration files:
%	testregi	- Register shift and triggered buffer down.
%	tstdist 	- Triggered signal switch
%	

%	Wes Wang 11/29/95
%       Copyright (c) 1995-96 by the MathWorks, Inc.
