function [nb,db,nw,dw,nl,dl]=dsbadmft(Fc,order)
%DSBADMFT   is a function designing filters for DSB SC ADM.
%   [NB,DB,NW,DW,NL,DL]=DSBADMFT(Fc) 
%   outputs the bandpass fileter and two lowpass filters for
%   DSB SC ADM when the carrier frequency is provided.

%       Copyright (c) 1996 by The MathWorks, Inc.
%       $Revision: 1.1 $  $Date: 1996/04/01 19:38:29 $


if nargin < 2
    order = 4;
end;
Fc=Fc*2*pi;
[a,b,c,d]=filtm('buttap', 'lp2bp', 2*Fc, 50, 50, order);
[nb,db]=ss2tf(a,b,c,d);
[z,p,k]=cheb1ap(order,3);
a=1.5*Fc*z;
b=1.5*Fc*p;
c=real(prod(-b));
[nw,dw]=zp2tf(a,b,c);
a=Fc*z/10;
b=Fc*p/10;
c=real(prod(-b));
[nl,dl]=zp2tf(a,b,c);
