function [num,den,nl,dl]=ssbadmft(Fc,Fh,order)
%SSBAMFT   is a function designing filters for SSB SC ADM.
%   generate a 6th order lowpass filter with the cutoff
%   frequency at Fc*2*pi.
%   [NUM,DEN,NL,DL]=DSBAMFT(Fc,ORDER,PART) 
%   generates a filter bandpass filter with pass band ([-Fh Fh] + Fc)*2*pi
%   with ORDER. and a lowpass filter. with cutoff frequency being Fc.

%   Copyright (c) 1996 by The MathWorks, Inc.
%   $Revision: 1.1 $  $Date: 1996/04/01 19:40:41 $

if nargin < 1
    error('There is no specified parameters')
end;
if nargin < 2
    Fh=Fc/10;
end;
if nargin < 3
    order = 6;
end;

[a,b,c,d]=cheby2(order,2,([-Fh, Fh] + Fc)*2*pi,'s');
%[a,b,c,d]=cheby1(order,.2,([-Fh, Fh] + Fc)*2*pi,'s');
%gain=bode(a,b,c,d,1,Fc);
%gain=1/gain;
%c=gain*c;
%d=gain*d;
[num,den]=ss2tf(a,b,c,d);

%the following is for the lowpass filter
%[a,b,c,d]=cheby1(order,2,Fh*2*pi*5,'s');
[a,b,c,d]=cheby1(order,.02,Fh*2*pi*5,'s');
%gain=bode(a,b,c,d,1,Fc/10);
%gain=1/gain;
%c=gain*c;
%d=gain*d;
[nl,dl]=ss2tf(a,b,c,d);

%---here is the end---
