function [out1,out2] = democmdm(option,in2,in3)
%DEMOCMDM Main for command line mode demos in the Wavelet Toolbox.
%       DEMOCMDM creates the window for command line mode demos.
%
%       DEMOCMDM('auto') shows all the command line mode demos
%       in automatic mode.
%
%       DEMOCMDM('loop') shows all the command line mode demos
%       in loop mode.

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 17:15:35 $

global  ShiftTop_Fig Def_Btn_Height  Def_Btn_Width

if nargin==0 , option = 'create'; end

tag_dem_tool    = 'Demo_Tool';
tag_cmdm_tool   = 'Cmdm_Tool';
tag_btn_close   = 'Demo_Close';
tag_sub_close   = 'Cmdm_Close';

if strcmp(option,'create')
        win     = findobj(get(0,'children'),'flat','tag',tag_cmdm_tool);
        if ~isempty(win) , return; end

        % Waiting Frame construction & begin waiting.
        %--------------------------------------------
        mousefrm(0,'watch');

        % Global variables initialization.
        %---------------------------------
        wglobals('ini');
        Btn_Height = Def_Btn_Height;
        Btn_Width  = Def_Btn_Width;

        % Cmdmlet main window initialization.
        %------------------------------------
        win_units       = 'pixels';
        Screen_Size     = get(0,'ScreenSize');
        if Screen_Size(4)<700
           Btn_Height = 0.9*Btn_Height;
           Btn_Width  = 0.9*Btn_Width;
        end
        win_height      = 41*Btn_Height/2;
        win_width       = 13*Btn_Width/4;
        pos_win         = [     Screen_Size(3)*0.01, ...
                                Screen_Size(4)-win_height-ShiftTop_Fig, ...
                                win_width, ...
                                win_height ...
                                ];
        name            = 'Command line mode demos';
        win_democmdm    = mngfig('create',name,pos_win,win_units);
        str_win_democmdm= int2str(win_democmdm);
        set(win_democmdm,'tag',tag_cmdm_tool);

        % Position property of objects.
        %------------------------------
        btn_width       = 3*Btn_Width;
        btn_heigth      = 3*Btn_Height/2;
        btn_left        = (win_width-btn_width)/2;
        btn_low         = pos_win(4)-2*Btn_Height;
        dif_heigth      = 2*Btn_Height;
        pos_dw1d        = [     btn_left                ,...
                                btn_low                 ,...
                                btn_width               ,...
                                btn_heigth      ];

        btn_low         = btn_low-dif_heigth;
        pos_cw1d        = [     btn_left                ,...
                                btn_low                 ,...
                                btn_width               ,...
                                btn_heigth      ];

        btn_low         = btn_low-dif_heigth;
        pos_dw2d        = [     btn_left                ,...
                                btn_low                 ,...
                                btn_width               ,...
                                btn_heigth      ];

        btn_low         = btn_low-dif_heigth;
        pos_comp        = [     btn_left                ,...
                                btn_low                 ,...
                                btn_width               ,...
                                btn_heigth      ];

        btn_low         = btn_low-dif_heigth;
        pos_deno        = [     btn_left                ,...
                                btn_low                 ,...
                                btn_width               ,...
                                btn_heigth      ];

        btn_low         = btn_low-dif_heigth;
        pos_wpck        = [     btn_left                ,...
                                btn_low                 ,...
                                btn_width               ,...
                                btn_heigth      ];

        btn_low         = btn_low-dif_heigth;
        pos_mala        = [     btn_left                ,...
                                btn_low                 ,...
                                btn_width               ,...
                                btn_heigth      ];

        btn_low         = btn_low-dif_heigth;
        pos_casc        = [     btn_left                ,...
                                btn_low                 ,...
                                btn_width               ,...
                                btn_heigth      ];

        btn_low         = btn_low-dif_heigth;
        pos_extm        = [     btn_left                ,...
                                btn_low                 ,...
                                btn_width               ,...
                                btn_heigth      ];

        btn_low         = btn_low-dif_heigth;
        pos_close       = [     btn_left                ,...
                                btn_low                 ,...
                                btn_width               ,...
                                btn_heigth      ];

        % String property of objects.
        %----------------------------
        str_dw1d        = 'Wavelet 1-D';
        str_cw1d        = 'Continuous Wavelet 1-D';
        str_dw2d        = 'Wavelet 2-D';
        str_comp        = 'Compression';
        str_deno        = 'De-noising';
        str_wpck        = 'Wavelet Packets';
        str_mala        = 'Mallat algorithm';
        str_casc        = 'Cascade algorithm';
        str_extm        = 'Border distortion';
        str_close       = 'Close';

        % Callback property of objects.
        %------------------------------
        cba_dw1d        = ['democmdm(''dw1d'',' str_win_democmdm ');'];
        cba_cw1d        = ['democmdm(''cw1d'',' str_win_democmdm ');'];
        cba_dw2d        = ['democmdm(''dw2d'',' str_win_democmdm ');'];
        cba_comp        = ['democmdm(''comp'',' str_win_democmdm ');'];
        cba_deno        = ['democmdm(''deno'',' str_win_democmdm ');'];
        cba_wpck        = ['democmdm(''wpck'',' str_win_democmdm ');'];
        cba_mala        = ['democmdm(''mala'',' str_win_democmdm ');'];
        cba_casc        = ['democmdm(''casc'',' str_win_democmdm ');'];
        cba_extm        = ['democmdm(''extm'',' str_win_democmdm ');'];
        cba_close       = ['democmdm(''close'',' str_win_democmdm ');'];

        % Construction of objects.
        %-------------------------
        pus_dw1d        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_dw1d,...
                                        'String',str_dw1d,...
                                        'Callback',cba_dw1d...
                                        );
        pus_cw1d        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_cw1d,...
                                        'String',str_cw1d,...
                                        'Callback',cba_cw1d...
                                        );
        pus_dw2d        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_dw2d,...
                                        'String',str_dw2d,...
                                        'Callback',cba_dw2d...
                                        );
        pus_comp        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_comp,...
                                        'String',str_comp,...
                                        'Callback',cba_comp...
                                        );
        pus_deno        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_deno,...
                                        'String',str_deno,...
                                        'Callback',cba_deno...
                                        );
        pus_wpck        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_wpck,...
                                        'String',str_wpck,...
                                        'Callback',cba_wpck...
                                        );
        pus_mala        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_mala,...
                                        'String',str_mala,...
                                        'Callback',cba_mala...
                                        );
        pus_casc        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_casc,...
                                        'String',str_casc,...
                                        'Callback',cba_casc...
                                        );

        pus_extm        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_extm,...
                                        'String',str_extm,...
                                        'Callback',cba_extm...
                                        );


        pus_close       = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_close,...
                                        'String',str_close,...
                                        'Callback',cba_close,...
                                        'Tag',tag_btn_close...
                                        );

        % Setting units to normalized.
        %-----------------------------
        set(findobj(win_democmdm,'Units','pixels'),'Units','Normalized');

        axes('Visible','Off')
        set(win_democmdm,'NextPlot','New');

        % End waiting.
        %---------------
        mousefrm(0,'arrow');
        drawnow

%*****************************************************%
%** OPTION = 'dw1d' -  demo DW1D                    **%
%** OPTION = 'cw1d' -  demo CW1D                    **%
%** OPTION = 'dw2d' -  demo DW2D                    **%
%** OPTION = 'comp' -  demo Compression             **%
%** OPTION = 'deno' -  demo De-noising              **%
%** OPTION = 'wpck' -  demo for Wavelet packets     **%
%** OPTION = 'mala' -  demo for Mallat algorithm    **%
%** OPTION = 'casc' -  demo for Cascade algorithm   **%
%** OPTION = 'extm' -  demo for Boundary distortion **%
%*****************************************************%
elseif  strcmp(option,'dw1d') | strcmp(option,'cw1d') | ...
        strcmp(option,'dw2d') | strcmp(option,'comp') | ...
        strcmp(option,'deno') | strcmp(option,'wpck') | ...
        strcmp(option,'mala') | strcmp(option,'casc') | ...
        strcmp(option,'extm')

        if      nargin==1
                win = findobj(get(0,'children'),'flat','tag',tag_cmdm_tool);
                wait_mode = 0; gui = 0;
        elseif  nargin==2
                win = in2; wait_mode = 1; gui = 1;
        else
                win = in2; wait_mode = in3; gui = wait_mode;
        end
        demoname = ['dcmd' option];
        democmdm('enable',win,'off');
        if gui==0,
                eval(demoname);
                democmdm('enable',win,'on');
        else
                if      strcmp(option,'dw1d') , demomode = 'mix7';
                elseif  strcmp(option,'cw1d') , demomode = 'mix6';
                elseif  strcmp(option,'dw2d') , demomode = 'mix9';
                elseif  strcmp(option,'comp') , demomode = 'mix9';
                elseif  strcmp(option,'deno') , demomode = 'mix8';
                elseif  strcmp(option,'wpck') , demomode = 'mix7';
                elseif  strcmp(option,'mala') , demomode = 'mix6';
                elseif  strcmp(option,'casc') , demomode = 'mix9';
                elseif  strcmp(option,'extm') , demomode = 'mix5';
                else
                        demomode = 'manual';
                end
                addclose = ['democmdm(''endshow'');'];
                wshowdrv(demoname,demomode,addclose);
                mousefrm(0,'arrow');
        end
        clear

%*************************************************************%
%** OPTION = 'enable' - Deseable or Enable demoguim window  **%
%*************************************************************%
elseif strcmp(option,'enable')
        % in2 = win handle
        % in3 = 'on' or 'off'   
        %--------------------
        if in3(1:2)=='of'
                mousefrm(0,'watch');
        else
                mousefrm(0,'arrow');
        end
        set(findobj(in2,'style','pushbutton'),'Enable',in3);
        drawnow;

%**************************************************%
%** OPTION = 'auto' - all demos (automatic mode) **%
%**************************************************%
elseif strcmp(option,'auto')
        democmdm('create');
        stop = 0;
        while stop==0
                democmdm('dw1d');
                democmdm('cw1d');
                democmdm('dw2d');
                democmdm('comp');
                democmdm('deno');
                democmdm('wpck');
                democmdm('mala');
                democmdm('casc');
                democmdm('extm');
                stop = 1;
                if nargin==2
                        if strcmp(in2,'loop') , stop = 0 ; end
                end
        end
        win = findobj(get(0,'children'),'flat','tag',tag_cmdm_tool);
        democmdm('close',win);

%************************************************************%
%** OPTION = 'loop' - loop with all demos (automatic mode) **%
%************************************************************%
elseif strcmp(option,'loop')
        democmdm('auto','loop');

%****************************************************%
%** OPTION = 'startshow' - used to finish wshowdrv **%
%****************************************************%
elseif strcmp(option,'startshow')
       % in2 = figNumber;
       % in3 = option
       hndlList  = get(in2,'UserData');
       closeHndl = hndlList(7);
       set(closeHndl,'tag',tag_sub_close);
       if strcmp(in3,'dw2d') | strcmp(in3,'casc')
           out1 = findobj(in2,'style','popupmenu');
           if isempty(out1)
              if strcmp(in3,'dw2d')
                 popstr = str2mat('woman2','sinsin','detfingr','wbarb',...
                                  'detail','geometry','tire');
                 popstr = str2mat(popstr,'mandrill','woman',...
                                  'wifs','facets','tartan');
                 txtstr = 'Image';
              elseif strcmp(in3,'casc')
                 popstr = str2mat('sym4','sym8','db3','db5','db8',...
                                  'coif1','coif5');
                 txtstr = 'Wavelet';

              end
              autoHndl  = hndlList(5);
              pos = get(autoHndl,'Position');
              btnHt = 0.08; spacing = 0.04;
              pos(2) = pos(2)-spacing-btnHt/2;
              pos(4) = btnHt/2;
              t = uicontrol(in2,...
                          'style','text', ...
                          'Units','normalized', ...
                          'Position',pos, ...
                          'BackgroundColor',[0.5 0.5 0.5], ...
                          'String',txtstr);
              pos(2) = pos(2)-btnHt;
              pos(4) = btnHt;
              out1 = uicontrol(in2,...
                          'style','popupmenu', ...
                          'Units','normalized', ...
                          'Position',pos, ...
                          'String',popstr);
           end
       end

%**************************************************%
%** OPTION = 'endshow' - used to finish wshowdrv **%
%**************************************************%
elseif strcmp(option,'endshow')
        win = findobj(get(0,'children'),'flat','tag',tag_cmdm_tool);
        set(findobj(win,'style','pushbutton'),'Enable','on');
        drawnow;

%***********************************************%
%** OPTION = 'close' - close democmdm window  **%
%***********************************************%
elseif strcmp(option,'close')
        mousefrm(0,'watch')
        if nargin==2
                win_democmdm = in2;
        else
                win_democmdm = findobj(get(0,'Children'),'flat',...
                                        'tag',tag_cmdtool);
        end

        % Closing all opened main analysis windows.
        %------------------------------------------
        pus_handles     = findobj(0,'Style','pushbutton');
        hdls            = findobj(pus_handles,'flat','Tag',tag_sub_close);
        for i=1:length(hdls)
                hdl = hdls(i);
                err = 0;
                eval('par = get(hdl,''Parent'');','err = 1;')
                eval(get(hdl,'Callback'),'err = 1;');
                eval('delete(par)','err = 1;')
        end

        % Closing the democmdm window.
        %-----------------------------
        eval('delete(win_democmdm)','err = 1;');
        wglobals('clear')

        win_ini = findobj(get(0,'Children'),'flat','tag',tag_dem_tool);
        if ~isempty(win_ini)
                pus_handles = findobj(win_ini,'Style','pushbutton');
                set(pus_handles,'Enable','on');
        end
        mousefrm(0,'arrow');

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('democmdm','Unknown Option','msg');
        error('*');
end
