function out1 = demoguim(option,in2,in3,in4)
%DEMOGUIM Main for GUI tools demo in the Wavelet Toolbox.
%       DEMOGUIM creates the window for GUI mode demos.
%
%       DEMOGUIM('auto') shows all the GUI mode demos
%       in automatic mode.
%
%       DEMOGUIM('loop') shows all the GUI mode demos
%       in loop mode.

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 17:15:40 $

global  ShiftTop_Fig Def_Btn_Height  Def_Btn_Width

if nargin==0 , option = 'create'; end

tag_dem_tool    = 'Demo_Tool';
tag_guim_tool   = 'Guim_Tool';
tag_btn_close   = 'Demo_Close'; % tag for window
tag_sub_close   = 'Guim_Close'; % tag for sub_window

if strcmp(option,'create')
        win     = findobj(get(0,'children'),'flat','tag',tag_guim_tool);
        if ~isempty(win) , return; end

        % Waiting Frame construction & begin waiting.
        %--------------------------------------------
        mousefrm(0,'watch');

        % Global variables initialization.
        %---------------------------------
        wglobals('ini');
        Btn_Height = Def_Btn_Height;
        Btn_Width  = Def_Btn_Width;

        % Wavelet main window initialization.
        %------------------------------------
        win_units       = 'pixels';
        Screen_Size     = get(0,'ScreenSize');
        if Screen_Size(4)<700
           Btn_Height = 0.9*Btn_Height;
           Btn_Width  = 0.9*Btn_Width;
        end
        win_height      = 33*Btn_Height/2;
        win_width       = 13*Btn_Width/4;
        xleft           = Screen_Size(3)*0.01;
        pos_win         = [     xleft, ...
                                Screen_Size(4)-win_height-ShiftTop_Fig, ...
                                win_width, ...
                                win_height ...
                                ];
        name            = 'Gui mode demo';
        win_demoguim    = mngfig('create',name,pos_win,win_units);
        out1            = win_demoguim;
        str_win_demoguim= int2str(win_demoguim);
        set(win_demoguim,'tag',tag_guim_tool);

        % Position property of objects.
        %------------------------------
        btn_width       = 3*Btn_Width;
        btn_heigth      = 3*Btn_Height/2;
        dif_heigth      = 2*Btn_Height;
        btn_left        = (win_width-btn_width)/2;
        btn_low         = pos_win(4);

        btn_low         = btn_low-dif_heigth;
        pos_dw1d        = [     btn_left                ,...
                                btn_low                 ,...
                                btn_width               ,...
                                btn_heigth      ];

        btn_low         = btn_low-dif_heigth;
        pos_dw2d        = [     btn_left                ,...
                                btn_low                 ,...
                                btn_width               ,...
                                btn_heigth      ];

        btn_low         = btn_low-dif_heigth;
        pos_wvdi        = [     btn_left                ,...
                                btn_low                 ,...
                                btn_width               ,...
                                btn_heigth      ];

        btn_low         = btn_low-dif_heigth;
        pos_wp1d        = [     btn_left                ,...
                                btn_low                 ,...
                                btn_width               ,...
                                btn_heigth      ];

        btn_low         = btn_low-dif_heigth;
        pos_wp2d        = [     btn_left                ,...
                                btn_low                 ,...
                                btn_width               ,...
                                btn_heigth      ];

        btn_low         = btn_low-dif_heigth;
        pos_wpdi        = [     btn_left                ,...
                                btn_low                 ,...
                                btn_width               ,...
                                btn_heigth      ];

        btn_low         = btn_low-dif_heigth;
        pos_cw1d        = [     btn_left                ,...
                                btn_low                 ,...
                                btn_width               ,...
                                btn_heigth      ];

        btn_low         = btn_low-dif_heigth;
        pos_close       = [     btn_left                ,...
                                btn_low                 ,...
                                btn_width               ,...
                                btn_heigth      ];

        % String property of objects.
        %----------------------------
        str_dw1d        = 'Wavelet 1-D';
        str_dw2d        = 'Wavelet 2-D';
        str_wvdi        = 'Wavelet Display';
        str_wp1d        = 'Wavelet Packet 1-D';
        str_wp2d        = 'Wavelet Packet 2-D';
        str_wpdi        = 'Wavelet Packet Display';
        str_cw1d        = 'Continuous Wavelet 1-D';
        str_close       = 'Close';

        % Callback property of objects.
        %------------------------------
        cba_dw1d        = ['demoguim(''dw1d'',' str_win_demoguim ');'];
        cba_dw2d        = ['demoguim(''dw2d'',' str_win_demoguim ');'];
        cba_wvdi        = ['demoguim(''wvdi'',' str_win_demoguim ');'];
        cba_wp1d        = ['demoguim(''wp1d'',' str_win_demoguim ');'];
        cba_wp2d        = ['demoguim(''wp2d'',' str_win_demoguim ');'];
        cba_wpdi        = ['demoguim(''wpdi'',' str_win_demoguim ');'];
        cba_cw1d        = ['demoguim(''cw1d'',' str_win_demoguim ');'];
        cba_close       = ['demoguim(''close'',' str_win_demoguim ');'];

        % Construction of objects.
        %-------------------------
        pus_dw1d        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_dw1d,...
                                        'String',str_dw1d,...
                                        'Callback',cba_dw1d...
                                        );
        pus_dw2d        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_dw2d,...
                                        'String',str_dw2d,...
                                        'Callback',cba_dw2d...
                                        );
        pus_wvdi        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_wvdi,...
                                        'String',str_wvdi,...
                                        'Callback',cba_wvdi...
                                        );
        pus_wp1d        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_wp1d,...
                                        'String',str_wp1d,...
                                        'Callback',cba_wp1d...
                                        );
        pus_wp2d        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_wp2d,...
                                        'String',str_wp2d,...
                                        'Callback',cba_wp2d...
                                        );
        pus_wpdi        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_wpdi,...
                                        'String',str_wpdi,...
                                        'Callback',cba_wpdi...
                                        );
        pus_cw1d        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_cw1d,...
                                        'String',str_cw1d,...
                                        'Callback',cba_cw1d...
                                        );
        pus_close       = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_close,...
                                        'String',str_close,...
                                        'Callback',cba_close,...
                                        'Tag',tag_btn_close...
                                        );

        % Setting units to normalized.
        %-----------------------------
        set(findobj(win_demoguim,'Units','pixels'),'Units','Normalized');

        axes('Visible','Off')
        set(win_demoguim,'NextPlot','New');

        % End waiting.
        %---------------
        mousefrm(0,'arrow');
        drawnow

%***********************************%
%** OPTION = 'dw1d' -  demo DW1D  **%
%** OPTION = 'dw2d' -  demo DW2D  **%
%** OPTION = 'wvdi' -  demo WVDI  **%
%** OPTION = 'wp1d' -  demo WP1D  **%
%** OPTION = 'wp2d' -  demo WP2D  **%
%** OPTION = 'wpdi' -  demo WPDI  **%
%***********************************%
elseif  strcmp(option,'dw1d') | strcmp(option,'dw2d') | ...
        strcmp(option,'wvdi') | strcmp(option,'wp1d') | ...
        strcmp(option,'wp2d') | strcmp(option,'wpdi') | ...
        strcmp(option,'cw1d')
        if nargin==1
                win = findobj(get(0,'children'),'flat','tag',tag_guim_tool);
                wait_mode = 0;
        else
                win = in2;
                wait_mode = 1;
                if nargin==3 , wait_mode = in3; end
        end
        gui = wait_mode;
        demoname = ['dgui' option];
        demoguim('enable',win,'off');
        if gui==0,
                set(findobj(win,'tag',tag_btn_close),'enable','on')
                eval(demoname);
                demoguim('enable',win,'on');
        else
                demomode = 'command';
                addclose = ['demoguim(''endshow'');'];
                wshowdrv(demoname,demomode,addclose);
        end
        clear

%*************************************************************%
%** OPTION = 'enable' - Deseable or Enable demoguim window  **%
%*************************************************************%
elseif strcmp(option,'enable')
        % in2 = win handle
        % in3 = 'on' or 'off'   
        %--------------------
        if in3(1:2)=='of'
                mousefrm(0,'watch');
        else
                mousefrm(0,'arrow');
        end
        set(findobj(in2,'style','pushbutton'),'Enable',in3);
        drawnow;

%**************************************************%
%** OPTION = 'auto' - all demos (automatic mode) **%
%**************************************************%
elseif strcmp(option,'auto')
        clc
        demoguim('create');
        stop = 0;
        while stop==0
                demoguim('dw1d');
                demoguim('dw2d');
                demoguim('wvdi');
                demoguim('wp1d');
                demoguim('wp2d');
                demoguim('wpdi');
                demoguim('cw1d');
                stop = 1;
                if nargin==2
                        if strcmp(in2,'loop') , stop = 0 ; end
                end
        end
        win = findobj(get(0,'children'),'flat','tag',tag_guim_tool);
        demoguim('close',win);

%***********************************************************%
%** OPTION = 'loop' - loop for all demos (automatic mode) **%
%***********************************************************%
elseif strcmp(option,'loop')
        demoguim('auto','loop');

%**************************************************%
%** OPTION = 'endshow' - used to finish wshowdrv **%
%**************************************************%
elseif strcmp(option,'endshow')
        win = findobj(get(0,'children'),'flat','tag',tag_guim_tool);
        set(findobj(win,'style','pushbutton'),'Enable','on');
        drawnow;

%***************************************************%
%** OPTION = 'startshow' - used to start wshowdrv **%
%***************************************************%
elseif strcmp(option,'startshow')
    figNumber = in2;
    out1 = wmemtool('get',figNumber,'Activefig');
    if isempty(out1)
        out1 = feval(in3);
        hndlList  = get(figNumber,'Userdata');
        closeHndl = hndlList(7);
        callbackStr = get(closeHndl,'Callback');
        winact = int2str(out1);
        str1 = ['fig = find(get(0,''children'')==' winact ');'];
        str2 = ['if ~isempty(fig) , clear fig; ' ...
                    in3 '(''close'',' winact '); close(' winact '); end;'];
        set(closeHndl,'Callback',[str1,str2,callbackStr],'tag',tag_sub_close);
    end

%***********************************************%
%** OPTION = 'close' - close demoguim window  **%
%***********************************************%
elseif strcmp(option,'close')
        mousefrm(0,'watch')

        % Closing all opened main analysis windows.
        %------------------------------------------
        pus_handles     = findobj(0,'Style','pushbutton');
        hdls            = findobj(pus_handles,'flat','Tag',tag_sub_close);
        for i=1:length(hdls)
                hdl = hdls(i);
                err = 0;
                eval('par = get(hdl,''Parent'');','err = 1;')
                eval(get(hdl,'Callback'),'err = 1;');
                eval('delete(par)','err = 1;')
        end

        % Closing the demoguim window.
        %-----------------------------
        eval('delete(in2)','err = 1;');
        wglobals('clear')

        win_ini = findobj(get(0,'Children'),'flat','tag',tag_dem_tool);
        if ~isempty(win_ini)
                pus_handles = findobj(win_ini,'Style','pushbutton');
                set(pus_handles,'Enable','on');
        end
        mousefrm(0,'arrow');

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('demoguim','Unknown Option','msg');
        error('*');
end
