%DGUIDW1D Demonstrates 1D wavelet GUI tools in the Wavelet Toolbox. 

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 17:15:55 $

% Demo initialization ====================
if ~exist('DRVShowGUIFlag'), figNumber = 0; end;

global Figures_Stack

clc;
if wshowdrv('init',figNumber)
    if figNumber==0 
        active_fig = dw1dtool;
    else
        active_fig = demoguim('startshow',figNumber,'dw1dtool');
        wshowdrv('setactfig',figNumber,active_fig);
        return;
    end
end
if exist('wait_mode')~=1 , wait_mode = 1; end
if figNumber , active_fig = wshowdrv('getactfig',figNumber); end

dw1dmngr('demo',active_fig,'noisdopp','db2',6);
if wshowdrv('pause',figNumber,wait_mode), return; end;

tag_pop_viewm   = 'View_Mode';
tag_declev      = 'Pop_DecLev';
pop_handles     = findobj(active_fig,'style','popupmenu');
pop_viewm       = findobj(pop_handles,'tag',tag_pop_viewm);
pop_decm        = findobj(pop_handles,'tag',tag_declev);
cba_viewm       = get(pop_viewm,'Callback');
cba_decm        = get(pop_decm,'Callback');

msg = str2mat(...
         'The present Display mode is Full Decomposition mode.', ...
        ['To change the Display mode use the corresponding popupmenu ' ...
         'in the middle of the window.'],...
         'Five display modes are available.'...
        );
if dguiwait('pause',figNumber,0,active_fig,msg); return; end

msg = ['We select the Superimpose Mode.'];
if dguiwait('pause',figNumber,0,active_fig,msg); return; end

set(pop_viewm,'value',4);
eval(cba_viewm);
if wshowdrv('pause',figNumber,wait_mode), return; end;

msg = ['We select the Show and Scroll Mode.'];
if dguiwait('pause',figNumber,0,active_fig,msg); return; end

set(pop_viewm,'value',1);
eval(cba_viewm);
if wshowdrv('pause',figNumber,wait_mode), return; end;

msg = ['We select the Separate Mode.'];
if dguiwait('pause',figNumber,0,active_fig,msg); return; end

set(pop_viewm,'value',3);
eval(cba_viewm);
if wshowdrv('pause',figNumber,wait_mode), return; end;

msg = ['We select the Tree Mode.'];
if dguiwait('pause',figNumber,0,active_fig,msg); return; end

set(pop_viewm,'value',5);
eval(cba_viewm);
if wshowdrv('pause',figNumber,wait_mode), return; end;

msg = ['We go back to the Full Decomposition mode.'];
if dguiwait('pause',figNumber,0,active_fig,msg); return; end

set(pop_viewm,'value',2);
eval(cba_viewm);
if wshowdrv('pause',figNumber,wait_mode), return; end;

msg = ['We select the Full Decomposition at level 2.'];
if dguiwait('pause',figNumber,0,active_fig,msg); return; end

set(pop_decm,'value',2);
eval(cba_decm);
if wshowdrv('pause',figNumber,wait_mode), return; end;

msg = ['We restore the Full Decomposition at level 6.'];
if dguiwait('pause',figNumber,0,active_fig,msg); return; end

set(pop_decm,'value',6);
eval(cba_decm);
if wshowdrv('pause',figNumber,wait_mode), return; end;

f5 = figure('visible','Off');
f4 = figure('visible','Off');
f3 = figure('visible','Off');
f2 = figure('visible','Off');

msg = 'The Compress pushbutton is used to call the compression tool.';
if dguiwait('pause',figNumber,0,active_fig,msg); return; end

out2 = dw1dmngr('comp',active_fig);

msg = 'We compress the signal with the default options.';
if dguiwait('pause',figNumber,0,out2,msg); return; end

dw1dcomp('compress',out2,active_fig);
if wshowdrv('pause',figNumber,wait_mode), delete([f2 f3 f4 f5]); return; end;
delete([out2 f2]); Figures_Stack = []; drawnow; pause(2)
dw1dmngr('return_comp',active_fig,0);

msg = 'The De-noise pushbutton is used to call the de-noising tool.';
if dguiwait('pause',figNumber,0,active_fig,msg); return; end

out3 = dw1dmngr('deno',active_fig);

msg = 'We de-noise the signal with the default options.';
if dguiwait('pause',figNumber,0,out3,msg); return; end

dw1ddeno('denoise',out3,active_fig);
if wshowdrv('pause',figNumber,wait_mode), delete([f3 f4 f5]); return; end;
delete([out3 f3]); Figures_Stack = []; drawnow; pause(2)
dw1dmngr('return_deno',active_fig,0);

msg = 'The Statistics pushbutton is used to call the statistics tool.';
if dguiwait('pause',figNumber,0,active_fig,msg); return; end

out4 = dw1dmngr('stat',active_fig);
dw1dstat('demo',out4);
if wshowdrv('pause',figNumber,wait_mode), delete([f4 f5]); return; end;
delete([out4 f4]); Figures_Stack = []; drawnow; pause(2)

msg = 'The Histograms pushbutton is used to call the histograms tool.';
if dguiwait('pause',figNumber,0,active_fig,msg); return; end

out5 = dw1dmngr('hist',active_fig);
dw1dhist('demo',out5);
if wshowdrv('pause',figNumber,wait_mode), delete([f5]); return; end;

delete([out5 f5]); Figures_Stack = []; drawnow; pause(2)
if figNumber==0
        wshowdrv('pause',figNumber,wait_mode);
        dw1dtool('close',active_fig);
        delete(active_fig)
end
