function wavedemo(option,in2,in3)
%WAVEDEMO wavelet toolbox demos.
%       WAVEDEMO brings up a GUI that allows you to choose
%       between several wavelet toolbox demos.

%       WAVEDEMO('auto') shows all the demos in automatic mode.
%
%       WAVEDEMO('loop') shows all the demos in loop mode.

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 17:16:51 $

global  ShiftTop_Fig Def_Btn_Height  Def_Btn_Width

if nargin==0
        option = 'create';
elseif (nargin==1) & ~isstr(option)
        in2     = option;
        option  = 'pref_b';     
end

tag_dem_tool    = 'Demo_Tool';
tag_btn_close   = 'Demo_Close'; % tag for sub_window

if      strcmp(option,'pref')
        win     = findobj(get(0,'children'),'flat','tag',tag_dem_tool);
        if ~isempty(win) , return; end
        if nargin==1 , in2 = 1; end
        wglobals('pref',in2);
        option = 'create';

elseif  strcmp(option,'pref_b')
        win     = findobj(get(0,'children'),'flat','tag',tag_dem_tool);
        if ~isempty(win) , return; end
        wglobals('pref',in2);
        option = 'create';
end

%*************************************************%
%** OPTION = 'create' - create wavedemo window  **%
%*************************************************%
if strcmp(option,'create')
        win     = findobj(get(0,'children'),'flat','tag',tag_dem_tool);
        if ~isempty(win) , return; end

        % Waiting Frame construction & begin waiting.
        %--------------------------------------------
        mousefrm(0,'watch');
        clc
        disp('Wait ... loading');
        drawnow;

        % Global variables initialization.
        %---------------------------------
        wglobals('ini');
        Btn_Height = Def_Btn_Height;
        Btn_Width  = Def_Btn_Width;

        % Wavelet main window initialization.
        %------------------------------------
        win_units       = 'pixels';
        Screen_Size     = get(0,'ScreenSize');
        if Screen_Size(4)<700
           Btn_Height = 0.9*Btn_Height;
           Btn_Width  = 0.9*Btn_Width;
        end
        win_height      = 19*Btn_Height/2;
        win_width       = 11*Btn_Width/4;
        pos_win         = [     Screen_Size(3)*0.01, ...
                                Screen_Size(4)-win_height-ShiftTop_Fig, ...
                                win_width, ...
                                win_height ...
                                ];
        name            = 'Wavelet Toolbox Demo';
        win_wavedemo    = mngfig('create',name,pos_win,win_units);
        str_win_wavedemo= int2str(win_wavedemo);
        set(win_wavedemo,'tag',tag_dem_tool);

        % Position property of objects.
        %------------------------------
        btn_width       = 2.3*Btn_Width;
        btn_heigth      = 3*Btn_Height/2;
        btn_left        = ceil((win_width-btn_width)/2);
        btn_low         = pos_win(4)-5*Btn_Height/2;
        dif_heigth      = 2*Btn_Height;
        pos_cmdm        = [     btn_left                ,...
                                btn_low                 ,...
                                btn_width               ,...
                                btn_heigth      ];
        btn_low         = btn_low-dif_heigth;
        pos_guim        = [     btn_left        ,...
                                btn_low         ,...
                                btn_width       ,...
                                btn_heigth      ];
        btn_low         = btn_low-dif_heigth;
        pos_sc1d        = [     btn_left        ,...
                                btn_low         ,...
                                btn_width       ,...
                                btn_heigth      ];
        btn_low         = btn_low-dif_heigth;
        pos_close       = [     btn_left        ,...
                                btn_low         ,...
                                btn_width       ,...
                                btn_heigth      ];

        % String property of objects.
        %----------------------------
        str_cmdm        = 'Command line mode';
        str_guim        = 'GUI mode';
        str_sc1d        = 'Short 1D scenario';
        str_close       = 'Close';

        % Callback property of objects.
        %------------------------------
        cba_close       = 'wavedemo(''close'');';

        % Construction of objects.
        %-------------------------
        pus_cmdm        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_cmdm,...
                                        'String',str_cmdm...
                                        );
        pus_guim        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_guim,...
                                        'String',str_guim...
                                        );
        pus_sc1d        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_sc1d,...
                                        'String',str_sc1d...
                                        );
        pus_close       = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_close,...
                                        'String',str_close,...
                                        'Callback',cba_close...
                                        );

        % Callback property of objects.
        %------------------------------
        str_btn         = num2mstr([pus_cmdm;pus_guim;pus_sc1d]);
        cba_cmdm        = ['wavedemo(''democmdm'',' str_btn ');'];
        cba_guim        = ['wavedemo(''demoguim'',' str_btn ');'];
        cba_sc1d        = ['wavedemo(''demoscen'',' str_btn ');'];
        set(pus_cmdm,'Callback',cba_cmdm);
        set(pus_guim,'Callback',cba_guim);
        set(pus_sc1d,'Callback',cba_sc1d);

        % Setting units to normalized.
        %-----------------------------
        set(findobj(win_wavedemo,'Units','pixels'),'Units','Normalized');

        axes('Visible','Off')
        set(win_wavedemo,'NextPlot','New');

        % End waiting.
        %---------------
        clc
        demoscen('compile');
        mousefrm(0,'arrow');
        drawnow

%****************************************************%
%** OPTION = 'democmdm' - Command line mode demos  **%
%****************************************************%
elseif strcmp(option,'democmdm')
        mousefrm(0,'watch')
        set(in2,'Enable','off')
        mousefrm(0,'arrow');
        feval('democmdm');

%*******************************************%
%** OPTION = 'demoguim' - GUI mode demos  **%
%*******************************************%
elseif strcmp(option,'demoguim')
        mousefrm(0,'watch')
        set(in2,'Enable','off')
        mousefrm(0,'arrow');
        feval('demoguim');

%**********************************************%
%** OPTION = 'demoscen' - Short 1D scenario  **%
%**********************************************%
elseif strcmp(option,'demoscen')
        % in3 for auto mode
        %-------------------
        mousefrm(0,'watch')
        set(in2,'Enable','off')
        mousefrm(0,'arrow');
        feval('demoscen','dw1d',1,1);

%**************************************************%
%** OPTION = 'auto' - all demos (automatic mode) **%
%**************************************************%
elseif strcmp(option,'auto')
        wavedemo('create');
        win = findobj(get(0,'children'),'flat','tag',tag_dem_tool);
        btn = findobj(win,'style','pushbutton');
        mousefrm(0,'watch')
        set(btn,'Enable','off')
        stop = 0;
        while stop==0
                feval('democmdm','auto');
                feval('demoguim','auto');
                feval('demoscen','auto');
                stop = 1;
                if nargin==2
                        if strcmp(in2,'loop') , stop = 0 ; end
                end
        end
        set(btn,'Enable','on')
        mousefrm(0,'arrow');
        wavedemo('close');

%************************************************************%
%** OPTION = 'loop' - loop with all demos (automatic mode) **%
%************************************************************%
elseif strcmp(option,'loop')
        wavedemo('auto','loop');

%***********************************************%
%** OPTION = 'close' - close wavedemo window  **%
%***********************************************%
elseif strcmp(option,'close')
        mousefrm(0,'watch')
        win_wavedemo = findobj(get(0,'Children'),'flat',...
                                        'tag',tag_dem_tool);

        % Closing all opened main analysis windows.
        %------------------------------------------
        pus_handles     = findobj(0,'Style','pushbutton');
        hdls            = findobj(pus_handles,'flat','Tag',tag_btn_close);
        for i=1:length(hdls)
                err = 0;
                eval(get(hdls(i),'Callback'),'err = 1;');
        end

        % Closing the wavedemo window.
        %-----------------------------
        close(win_wavedemo);
        wglobals('clear')
        mousefrm(0,'arrow');

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('wavedemo','Unknown Option','msg');
        error('*');
end
