function cw1dmngr(option,win_cw1dtool,in3,in4,in5,in6,in7,in8)
%CW1DMNGR Continuous wavelet 1D manager.
%       cw1dmngr(option,win_cw1dtool,in3,in4,in5,in6,in7,in8)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:06:21 $

% MemBloc0 of stored values.
%---------------------------
n_InfoInit      = 'CW1D_InfoInit';
ind_filename    =  1;
ind_pathname    =  2;
nb0_stored      =  2;

% MemBloc1 of stored values.
%---------------------------
n_param_anal    = 'CWAn1d_Par_Anal';
ind_sig_name    =  1;
ind_sig_size    =  2;
ind_wav_name    =  3;
ind_wav_len     =  4;
ind_lev_anal    =  5;
ind_act_option  =  6;
ind_graph_area  =  7;
nb1_stored      =  7;

% MemBloc2 of stored values.
%---------------------------
n_coefs_sca     = 'Coefs_Scales';
ind_coefs       = 1;
ind_scales      = 2;
nb2_stored      = 2;

%*************************%
%** OPTION = 'anal' -   **%
%*************************%
if strcmp(option,'anal')
        active_option = wmemtool('rmb',win_cw1dtool,n_param_anal, ...
                                                ind_act_option);        
        if ~strcmp(active_option,'load_sig')

                % Test for new Analysis.
                %-----------------------
                % new = wwaitans(win_cw1dtool,'New Analysis ?');
                % if new==0 , return; end

                % Cleaning.
                %----------
                wwaiting('msg',win_cw1dtool,'Wait ... cleaning');
                cw1dutil('clean',win_cw1dtool,'load_sig','new_anal');

                % Setting GUI values.
                %--------------------
                cw1dutil('set_gui',win_cw1dtool,'load_sig');

                % Setting enabled values.
                %------------------------
                cw1dutil('enable',win_cw1dtool,'load_sig');

        end

        % Waiting message.
        %-----------------
        wwaiting('msg',win_cw1dtool,'Wait ... computing');

        % Setting Analysis parameters
        %-----------------------------
        cw1dutil('set_par',win_cw1dtool,option);

        % Setting GUI values.
        %--------------------
        cw1dutil('set_gui',win_cw1dtool,option);
        
        % Computing & Drawing.
        %--------------------
        cw1ddraw('cfs',win_cw1dtool);

        % Setting enabled values.
        %------------------------
        cw1dutil('enable',win_cw1dtool,option);

        % End waiting.
        %-------------
        wwaiting('off',win_cw1dtool);

%****************************%
%** OPTION = 'load_sig' -  **%
%****************************%
elseif strcmp(option,'load_sig')
        % Testing file.
        %-------------
        [xpos,ypos] = wfigutil('left_up',win_cw1dtool,10,30);
        [filename,pathname] = ...
                      uigetfile('*.mat','Load Signal',xpos,ypos);
        if filename~=0 & ~isempty(filename)
                [Signal_Name,ext] = strtok(filename,'.');
                % PROVISOIRE PROBLEME UIGETFILE PC (MAJ/MIN)
                Signal_Name = lower(Signal_Name);
                ext  = lower(ext);
                if ~strcmp(ext,'.mat')
                         msg = 'Invalid file name (ext = .mat) !';
                         errordlg(msg,'Load Signal ERROR','off');
                         return; 
                end
        else
                return;
        end

        % Loading file.
        %--------------
        wwaiting('msg',win_cw1dtool,'Wait ... loading');
        LoSaFlag = 'load'; wloasavf;
        if err
                msg = ['File ' Signal_Name ' not found!'];      
        elseif  exist(deblank(Signal_Name))~=1
                err = 1;
                msg = ['File ' Signal_Name ' doesn''t contain variable ' ...
                                Signal_Name '.'];
        else
                Signal_Anal = eval(Signal_Name);
                siz         = size(Signal_Anal);
                if      min(siz)>1
                        err = 1;
                        msg = [Signal_Name ' is not a one dimensional Signal.'];
                elseif  siz(1)>1
                        Signal_Anal = (Signal_Anal)';
                end
        end
        if err
                wwaiting('off',win_cw1dtool);
                errordlg(msg,'Load Signal ERROR','off');
                return
        end
        Signal_Size     = length(Signal_Anal);

        % Cleaning.
        %----------
        wwaiting('msg',win_cw1dtool,'Wait ... cleaning');
        cw1dutil('clean',win_cw1dtool,option,'');

        % Setting Analysis parameters.
        %-----------------------------
        wmemtool('wmb',win_cw1dtool,n_param_anal,  ...
                                ind_act_option,option,     ...
                                ind_sig_name,Signal_Name,  ...
                                ind_sig_size,Signal_Size   ...
                                );
        wmemtool('wmb',win_cw1dtool,n_InfoInit, ...
                        ind_filename,filename,        ...
                        ind_pathname,pathname         ...
                        );

        % Setting GUI values.
        %--------------------
        cw1dutil('set_gui',win_cw1dtool,option);

        % Drawing.
        %---------
        cw1ddraw('sig',win_cw1dtool,Signal_Anal);       

        % Setting enabled values.
        %------------------------
        cw1dutil('enable',win_cw1dtool,option);

        % End waiting.
        %-------------
        wwaiting('off',win_cw1dtool);

%*************************%
%** OPTION = 'save_cfs' **%
%*************************%
elseif strcmp(option,'save_cfs')
        % Testing file.
        %--------------
        [xpos,ypos] = wfigutil('left_up',win_cw1dtool,10,30);
        [filename,pathname] = uiputfile('*.mat',...
                        'Save Coefficients (WC1D)',xpos,ypos);
        if filename==0 | isempty(filename) , return; end

        % Begin waiting.
        %--------------
        wwaiting('msg',win_cw1dtool,'Wait ... saving coefficients');

        [name,ext] = strtok(filename,'.');
        ext = '.wc1';
        filename = [name ext];

        % Getting Analysis values.
        %-------------------------
        [coefs,scales] = wmemtool('rmb',win_cw1dtool,n_coefs_sca,...
                                        ind_coefs,ind_scales);

        % Saving file.
        %--------------
        saveStr = ['coefs scales'];
        LoSaFlag = 'save'; wloasavf;

        % End waiting.
        %-------------
        wwaiting('off',win_cw1dtool);

        if err
                errargt('cw1dmngr','Save FAILED !','msg');
        end

%*********************%
%** option = 'demo' **%
%*********************%
elseif strcmp(option,'demo')
        % in3 = Signal_Name
        % in4 = Wave_Name
        % in5 = min
        % in6 = step 
        % in7 = max
        % in8 = col_mode
        %------------------
        Signal_Name     = in3;
        Wave_Name       = in4;

        % Loading Signal.
        %----------------
        wwaiting('msg',win_cw1dtool,'Wait ... loading');
        filename = Signal_Name;
        pathname = 'Wave_TBDemo';
        LoSaFlag = 'load'; wloasavf;
        if err==1
                wwaiting('off',win_cw1dtool);
                msg = ['File ' Signal_Name ' not found!'];
                errordlg(msg,'Load ERROR','off');
                return
        end
        Signal_Anal     = eval(Signal_Name);
        Signal_Size     = length(Signal_Anal);

        % Cleaning.
        %----------
        wwaiting('msg',win_cw1dtool,'Wait ... cleaning');
        cw1dutil('clean',win_cw1dtool,option);

        % Setting Analysis parameters
        %-----------------------------
        Wave_Len  = wavattrb('length',Wave_Name);
        wmemtool('wmb',win_cw1dtool,n_param_anal,  ...
                        ind_act_option,option,     ...
                        ind_sig_name,Signal_Name,  ...
                        ind_wav_name,Wave_Name,    ...
                        ind_wav_len,Wave_Len,      ...
                        ind_sig_size,Signal_Size   ...
                        );
        wmemtool('wmb',win_cw1dtool,n_InfoInit, ...
                        ind_filename,filename,  ...
                        ind_pathname,pathname   ...
                        );


        % Setting GUI values.
        %--------------------
        cw1dutil('set_gui',win_cw1dtool,option,in5,in6,in7,in8);

        % Drawing.
        %---------
        cw1ddraw('sig',win_cw1dtool,Signal_Anal);       

        % Computing & Drawing.
        %--------------------
        wwaiting('msg',win_cw1dtool,'Wait ... computing');
        cw1ddraw('cfs',win_cw1dtool);

        % Setting enabled values.
        %------------------------
        cw1dutil('enable',win_cw1dtool,option);

        % End waiting.
        %-------------
        wwaiting('off',win_cw1dtool);

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('cw1dmngr','Unknown Option','msg');
        error('*');
end
