function cw1dutil(option,win_cw1dtool,in3,in4,in5,in6,in7)
%CW1DUTIL Continuous wavelet 1D utilities.
%       cw1dutil(option,win_cw1dtool,in3,in4,in5,in6,in7)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:06:31 $

global Y_Spacing

% Default values.
%----------------
max_lev_anal     = 12;

% MemBloc1 of stored values.
%---------------------------
n_param_anal    = 'CWAn1d_Par_Anal';
ind_sig_name    =  1;
ind_sig_size    =  2;
ind_wav_name    =  3;
ind_wav_len     =  4;
ind_lev_anal    =  5;
ind_act_option  =  6;
ind_graph_area  =  7;
nb1_stored      =  7;

% Tag property of objects.
%-------------------------
tag_m_savecfs   = 'Save_Cfs';
tag_input_txt   = 'Input_Txt';
tag_input_data  = 'Input_Data';
tag_wav_fams    = 'Wav_Fams';
tag_wav_nums    = 'Wav_Nums';
tag_txt_colm    = 'ColM_txt';
tag_pop_colm    = 'ColM_pop';
tag_pus_anal    = 'Pus_Anal';
tag_txt_sca     = 'Sca_txt';
tag_pop_scalem  = 'View_Mode';
tag_min_txt     = 'Min_txt';
tag_min_edi     = 'Min_edi';
tag_max_txt     = 'Max_txt';
tag_max_edi     = 'Max_edi';
tag_stp_txt     = 'Stp_txt';
tag_stp_edi     = 'Stp_edi';
tag_pow_txt     = 'Pow_txt';
tag_pow_pop     = 'Pow_pop';
tag_msc_txt     = 'MSc_txt';
tag_msc_edi     = 'MSc_edi';
tag_cfs_map     = 'Pop_ColorMap';
tag_sli_nbc     = 'Sli_NBColors';
tag_edi_nbc     = 'Edi_NBColors';
tag_txt_map     = 'Txt_Map';
tag_txt_nbc     = 'Txt_Nbc';
tag_axesignal   = 'Axe_Signal';
tag_axeimgrec   = 'Axe_Coefs';
tag_axecolmap   = 'Axe_ColMap';

% Handles of tagged objects.
%---------------------------
axe_handles     = findobj(win_cw1dtool,'Type','axes');
txt_handles     = findobj(win_cw1dtool,'Style','text');
pop_handles     = findobj(win_cw1dtool,'Style','popupmenu');
pus_handles     = findobj(win_cw1dtool,'Style','pushbutton');
edi_handles     = findobj(win_cw1dtool,'Style','edit');

if      strcmp(option,'clean') | strcmp(option,'enable') | ...
        strcmp(option,'set_gui') | strcmp(option,'ch_sm')

        % Handles of tagged objects.
        %---------------------------
        m_savecfs       = findobj('type','uimenu','Tag',tag_m_savecfs);

        txt_input_txt   = findobj(txt_handles,'Tag',tag_input_txt);
        txt_input_data  = findobj(txt_handles,'Tag',tag_input_data);
        pop_wav_fams    = findobj(pop_handles,'Tag',tag_wav_fams);
        pop_wav_nums    = findobj(pop_handles,'Tag',tag_wav_nums);
        txt_sca         = findobj(txt_handles,'Tag',tag_txt_sca);
        pop_scalem      = findobj(pop_handles,'tag',tag_pop_scalem);
        txt_colm        = findobj(txt_handles,'Tag',tag_txt_colm);
        pop_colm        = findobj(pop_handles,'tag',tag_pop_colm);
        pus_anal        = findobj(pus_handles,'Tag',tag_pus_anal);
        min_txt         = findobj(txt_handles,'Tag',tag_min_txt);
        min_edi         = findobj(edi_handles,'Tag',tag_min_edi);
        stp_txt         = findobj(txt_handles,'Tag',tag_stp_txt);
        stp_edi         = findobj(edi_handles,'Tag',tag_stp_edi);
        max_txt         = findobj(txt_handles,'Tag',tag_max_txt);
        max_edi         = findobj(edi_handles,'Tag',tag_max_edi);
        pow_txt         = findobj(txt_handles,'Tag',tag_pow_txt);
        pow_pop         = findobj(pop_handles,'Tag',tag_pow_pop);
        msc_txt         = findobj(txt_handles,'Tag',tag_msc_txt);
        msc_edi         = findobj(edi_handles,'Tag',tag_msc_edi);
        axe_sig         = findobj(axe_handles,'Tag',tag_axesignal);
        axe_cfs         = findobj(axe_handles,'Tag',tag_axeimgrec);
        axe_col         = findobj(axe_handles,'Tag',tag_axecolmap);
end

%*******************************************%
%** OPTION = 'ch_sm' -  change scale mode **%
%*******************************************%
if strcmp(option,'ch_sm')
        new_mode = get(pop_scalem,'Value');
        old_mode = get(pop_scalem,'Userdata');
        if new_mode==old_mode ,  return; end
        set(pop_scalem,'Userdata',new_mode);

        % Borders and double borders.
        %----------------------------
        dy  = Y_Spacing;        dy2 = 2*dy;
        win_units = get(win_cw1dtool,'units');
        if strcmp(win_units,'pixels')
                dy  = Y_Spacing;        dy2 = 2*dy;
        else
                [dx,dy] = wfigutil('prop_size',win_cw1dtool,1,Y_Spacing);
                dy2 = 2*dy;
        end

        p10 = get(txt_colm,'Position');
        p11 = get(pop_colm,'Position');
        p12 = get(pus_anal,'Position');
        if      new_mode==1
                hdl_of = [pow_txt pow_pop msc_txt msc_edi];
                hdl_on = [min_txt,min_edi,stp_txt,stp_edi,max_txt,max_edi];
                p2 = get(max_txt,'Position');

        elseif  new_mode==2
                hdl_of = [min_txt,min_edi,stp_txt,stp_edi,max_txt,max_edi,...
                                        msc_txt,msc_edi];
                hdl_on = [pow_txt,pow_pop];
                p2 = get(pow_pop,'Position');

        elseif  new_mode==3
                hdl_of = [min_txt,min_edi,stp_txt,stp_edi,max_txt,max_edi,...
                                        pow_txt,pow_pop];
                hdl_on = [msc_txt,msc_edi];
                p2 = get(msc_edi,'Position');
        end
        set([hdl_of,txt_colm,pop_colm,pus_anal],'Visible','off');
        p10(2) = p2(2)-p10(4)-2*dy2;
        p11(2) = p10(2)-p11(4)-dy;
        p12(2) = p11(2)-p12(4)-2*dy2;
        set(txt_colm,'Position',p10);
        set(pop_colm,'Position',p11);
        set(pus_anal,'Position',p12);
        set([hdl_on,txt_colm,pop_colm,pus_anal],'Visible','on');

%***************************%
%** OPTION = 'set_par' -  **%
%***************************%
elseif strcmp(option,'set_par')
        % in3 calling option
        %-------------------
        pop_wav_fams    = findobj(pop_handles,'Tag',tag_wav_fams);
        pop_wav_nums    = findobj(pop_handles,'Tag',tag_wav_nums);

        % Reading Analysis Parameters.
        %----------------------------
        Wave_Name = wavattrb('wname',pop_wav_fams,pop_wav_nums,'name');
        Wave_Len  = wavattrb('length',Wave_Name);

        % Setting Analysis parameters
        %-----------------------------
        wmemtool('wmb',win_cw1dtool,n_param_anal,       ...
                        ind_act_option,in3,             ...
                        ind_wav_name,Wave_Name,         ...
                        ind_wav_len,Wave_Len            ...
                        );

%*************************%
%** OPTION = 'clean' -  **%
%*************************%
elseif strcmp(option,'clean')

        % Type of loading.
        %-----------------
        if      strcmp(in3,'load_sig') , str_input_txt  = 'Signal';
        elseif  strcmp(in3,'demo')     , str_input_txt  = 'Test-signal';
        end
        if nargin<4 , in4 = ''; end

        % Testing first use.
        %-------------------
        active_option = wmemtool('rmb',win_cw1dtool,n_param_anal, ...
                                                        ind_act_option);
        if isempty(active_option) , first = 1; else, first = 0; end

        % End of Cleaning when first is true.
        %------------------------------------
        set(txt_input_txt,'String',str_input_txt);
        set([axe_sig,axe_cfs,axe_col],'Visible','on');
        if first ,  return; end

        % Setting enable property of objects.
        %------------------------------------
        set([   pop_wav_fams,   pop_wav_nums,   pus_anal,       ...
                pop_scalem                                      ...
                ],...
                'Enable','off'...
                );
        set(m_savecfs,'Enable','On');

        % Cleaning DynVTool.
        %-------------------
        dynvtool('stop',win_cw1dtool);

        % Cleaning Axes.
        %--------------
        in_cfs_axes = findobj(axe_cfs);
        in_cfs_axes = in_cfs_axes(find(in_cfs_axes~=axe_cfs));
        delete(in_cfs_axes);
        if ~strcmp(in4,'new_anal')
                in_sig_axes = findobj(axe_sig);
                in_sig_axes = in_sig_axes(find(in_sig_axes~=axe_sig));
                delete(in_sig_axes);                    
        end
        set(axe_cfs,...
                'YTicklabelMode','manual',      ...
                'YTick',[],                     ...
                'YTickLabels',[]                ...
                );

        % Cleaning UIC.
        %--------------
        if ~strcmp(in4,'new_anal')
                hdls_UIC = [    txt_sca, pop_scalem,            ...
                                txt_colm, pop_colm,             ...
                                min_txt, min_edi, stp_txt,      ...
                                stp_edi, max_txt, max_edi,      ...
                                pow_txt, pow_pop, pus_anal      ...
                                 ];
                set(hdls_UIC,'Visible','off');
                [str_wav_fams,str_wav_nums] = wavattrb('ini','cwt');
                set(txt_input_data,'String','');
                set(pop_wav_fams,'String',str_wav_fams,'Value',1);
                set(pop_wav_nums,'String',str_wav_nums,'Value',1,'Visible','off');
                set(pop_scalem,'Value',1,'Userdata',0);
                set(pop_colm,'Value',1,'Userdata',0);
                str_pow_pop     = [int2str(1)];
                for k=2:max_lev_anal
                        str_pow_pop = str2mat(str_pow_pop,int2str(k));
                end
                set(pow_pop,'String',str_pow_pop);
                set(min_edi,'String','');
                set(stp_edi,'String','');
                set(max_edi,'String','');
                set(msc_edi,'String','[ ]');
        end

%**********************************************%
%** OPTION = 'set_gui' -  Setting GUI values.**%
%**********************************************%
elseif strcmp(option,'set_gui')
        % in3 = calling option.
        %----------------------
        if      strcmp(in3,'load_sig') | strcmp(in3,'demo')
                [Signal_Name,Signal_Size] = ...
                                wmemtool('rmb',win_cw1dtool,n_param_anal,...
                                                ind_sig_name,ind_sig_size);
                Signal_Size     = max(Signal_Size);
                set(txt_input_data,'String',Signal_Name);

                powmax  = fix(log(Signal_Size)/log(2));
                scamax  = 2^(powmax-1);
                levmax  = min(powmax,max_lev_anal);
                levs    = get(pow_pop,'String');
                set(pow_pop,'String',levs(1:levmax,:));

                str_min_txt     = 'Min  ( > 0)';
                str_stp_txt     = 'Step ( > 0)';
                str_max_txt     = ['Max  ( <= ' int2str(scamax) ')'];
                set(min_txt,'String',str_min_txt);
                set(stp_txt,'String',str_stp_txt);
                set(max_txt,'String',str_max_txt);

                hdls_UIC = [txt_sca , pop_scalem];
                set(hdls_UIC,'Visible','on');
                action = get(pop_scalem,'Callback');
                eval(action);
        end
        if      strcmp(in3,'demo')
                Wave_Name = wmemtool('rmb',win_cw1dtool,n_param_anal,...
                                                ind_wav_name);
                wavattrb('set_wname',Wave_Name,pop_wav_fams,pop_wav_nums);
                set(min_edi,'String',int2str(in4));
                set(stp_edi,'String',int2str(in5));
                set(max_edi,'String',int2str(in6));
                set(pop_colm,'Value',in7);
        end

%*************************************************%
%** OPTION = 'enable' -  Setting enabled values.**%
%*************************************************%
elseif strcmp(option,'enable')
        % in3 = calling option.
        %--------------------------
        if      strcmp(in3,'load_sig')
                set([   pop_wav_fams,   pop_wav_nums,   pus_anal        ...
                        pop_scalem,     pop_colm,       pow_pop         ...
                        ],      ...
                        'Enable','On'   ...
                        );

        elseif  strcmp(in3,'demo')
                set([   pop_wav_fams,   pop_wav_nums,   pus_anal,       ...
                        pop_scalem,     pop_colm,       pow_pop         ...
                        ],      ...
                        'Enable','On'   ...
                        );
                set(m_savecfs,'Enable','On');

        elseif  strcmp(in3,'anal')
                set([   pop_scalem, pop_colm, pow_pop],...
                        'Enable','On'...
                        );
                set(m_savecfs,'Enable','On');

        end

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('cw1dutil','Unknown Option','msg');
        error('*');
end
