function [C,nbclas] = defclass(X,NBC);
%DEFCLASS Definition of classes for matrix codification.
%       [C,nbclas]=defclass(X,NBC)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:07:05 $

%       Uses ERRARGN, WCODEMAT.

% Check arguments.
if errargn('defclass',nargin,[2],nargout,[2]), error('*'), end

X  = X-min(X);
ma = max(X);
if ma==0
        C = ones(size(X));
        return;
else
        X = X/ma;
end
[Y,I] = sort(X);
Ydiff = diff(Y);
INz   = find(Ydiff~=0);
NbNz  = size(INz,2);
if NbNz>=NBC
        nbclas = NBC;
        C = wcodemat(X,NBC,'row');
        return;
else
        Ind = [1 INz+1];
        Yval = Y(Ind);
end
[N,Y] = hist(X,Yval);
Ydiff = diff(Y);
borne = Y(2:length(Y))+Ydiff/2;
borne = [0 borne Inf];
C = zeros(size(X));
nbclas = length(borne)-1;
val = 1:nbclas;
for k = 1:nbclas
        ind = find((borne(k)<=X) & (X<borne(k+1)));
        C(ind) = val(k)*ones(size(ind));
end
