function [out1,out2,out3] = dlgquest(in1,in2,in3,in4,in5)
%DLGQUEST Question dialog.
%       [out1,out2,out3] = dlgquest(in1,in2,in3,in4,in5)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:07:27 $

%       Uses DLGQUEST.


global Answer_Quest

if nargin==0
        out1 = Answer_Quest;
        if ~isempty(out1) , clear global Answer_Quest; end
        return;
end

% Tagged Objects.
%---------------
tag_figquest    = 'Fig_Question';
Fig_Question    = findobj(get(0,'children'),'flat','Tag',tag_figquest);

if strcmp(in1,'validate')
        out1 = get(in2,'String');
        Answer_Quest = out1;
        close(Fig_Question);
        return
elseif strcmp(in1,'close')
        clear global Answer_Quest;
        close(Fig_Question);
        return  
end

Answer_Quest = [];
if errargn('dlgquest',nargin,[3:5],nargout,[0:3]), error('*'); end
if nargin<4,
        default = 1;
        nb_btn  = 2;
        in4 = '';
elseif nargin==4
        if isstr(in4)
                nb_btn  = 3; default = 1; 
        else
                nb_btn  = 2; default = in4; 
        end
else
        default = in5;
        nb_btn  = 3;
end
str_question = in1;

if isempty(Fig_Question)
        Screen_Size     = get(0,'ScreenSize');
        Btn_Height      =  22;
        Btn_Width       =  80; 
        Fra_BkColor     = get(0,'DefaultUicontrolBackgroundcolor');
        y       = 10;   dy      = 5;
        lwin    = 300;  hwin    = 2*y+2*dy+2*Btn_Height;
        if Screen_Size(3)<800 , xwin = 170; else , xwin = 450; end
        if Screen_Size(4)<600 , ywin = 300; else , ywin = 500; end
        bdx = (lwin-nb_btn*Btn_Width)/(nb_btn+1);
                
        pos_yes         = [bdx y Btn_Width Btn_Height];
        pos_no          = pos_yes;
        pos_no(1)       = pos_no(1)+pos_no(3)+bdx;
        pos_can         = pos_no;
        pos_can(1)      = pos_can(1)+pos_can(3)+bdx;
        Fig_Question    = figure(...
                                'Name','Question Dialog',       ...
                                'NumberTitle','off',            ...
                                'Resize','off',                 ...
                                'Menubar','none',               ...
                                'Visible','off',                ...
                                'Color',Fra_BkColor,            ...
                                'Units','Pixels',               ...
                                'Position',[xwin ywin lwin hwin],...
                                'Tag',tag_figquest              ...
                                );
        Yes_Btn         = uicontrol(...
                                'Style','Pushbutton',           ...
                                'Interruptible','yes',          ...
                                'Position',pos_yes,             ...
                                'String',in2                    ...
                                );
        val = num2mstr(Yes_Btn);
        action = ['out1 = dlgquest(''validate'',' val ');'];
        set(Yes_Btn,'Callback',action);

        No_Btn           = uicontrol(...
                                'Style','PushButton',           ...
                                'Interruptible','yes',          ...
                                'Position',pos_no,              ...
                                'String',in3                    ...
                                );
        val = num2mstr(No_Btn);
        action = ['out1 = dlgquest(''validate'',' val ');'];
        set(No_Btn,'Callback',action);
        if nb_btn==3            
                Cancel_Btn       = uicontrol(...
                                        'Style','PushButton',           ...
                                        'Interruptible','yes',          ...
                                        'Position',pos_can,             ...
                                        'String',in4                    ...
                                );
                val = num2mstr(Cancel_Btn);
                action = ['out1 = dlgquest(''validate'',' val ');'];
                set(Cancel_Btn,'Callback',action);
        end

        y = 2*y+Btn_Height;
        uicontrol('Style','Frame',                              ...
                  'BackGroundColor',Fra_BkColor,                ...
                  'Position',[4*dy y lwin-8*dy Btn_Height]);
        uicontrol('Style','Text',                               ...
                  'BackGroundColor',Fra_BkColor,...
                  'Position',[4*dy+3 y+3 lwin-8*dy-6 Btn_Height-6],...
                  'HorizontalAlignment','center',...
                  'String',str_question);

        axes('Visible','Off')
        set(Fig_Question,'NextPlot','New');
else
        figure(Fig_Question);
end
set(Fig_Question,'Visible','on');
out1 = Fig_Question;

