function out1 = dw1dcolo(option,in2,in3)
%DW1DCOLO Discret wavelet 1D coloration manager.
%       out1 = dw1dcolo(option,in2,in3)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:07:33 $


% Miscellaneous values.
%----------------------
Col_SigIni      = 'r';
Col_SSigIni     = 'y';
Col_AppIni      = [0 0 1];      % blue
Col_DetIni      = [0 1 0];      % green

option = option(1:3);

%************************************%
%** OPTION = 'sig' - signal color  **%
%************************************%
if      option=='sig'
        out1 = Col_SigIni;

%************************************************%
%** OPTION = 'ssig' - synthesized signal color **%
%************************************************%
elseif  option=='ssi'
        out1 = Col_SSigIni;

%********************************************%
%** OPTION = 'app' - approximations colors **%
%********************************************%
elseif  option=='app'
        out1 = dw1dcolo('scaled',Col_AppIni,in2);

%*************************************%
%** OPTION = 'det' - details colors **%
%*************************************%
elseif  option=='det'
        out1 = dw1dcolo('scaled',Col_DetIni,in2);

%***************************************%
%** OPTION = 'scaled' - scaled colors **%
%***************************************%
elseif  option=='sca'
        % in2 = basic color [R G B]
        % in3 = NB Colors
        %--------------------------
        out1 = in2;
        dcol = (1-in2)/in3;
        out1 = out1(ones(1,in3),:);
        for k=1:in3-1
                out1(k,:) = out1(k,:)+dcol.^(1/(in3+1-k));
        end

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('dw1dcolo','Unknown Option','msg');
        error('*');
end
