function out1 = dw1dcomp(option,in2,in3,in4,in5)
%DW1DCOMP Discret wavelet 1D compression.
%       out1 = dw1dcomp(option,in2,in3,in4,in5)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:07:38 $

%       Uses WMEMTOOL.

global  Machine                         ...
        Def_Btn_Height  Def_Btn_Width   ...
        Pop_Min_Width   X_Graph_Ratio   ...
        X_Spacing       Y_Spacing       ...
        Def_TxtBkColor  Def_EdiBkColor  ...
        Def_FraBkColor  Def_FraFgColor

if nargin==0, option = 'create'; end

% MemBloc1 of stored values.
%---------------------------
n_param_anal    = 'DWAn1d_Par_Anal';
ind_sig_name    =  1;
ind_sig_size    =  2;
ind_wav_name    =  3;
ind_wav_len     =  4;
ind_lev_anal    =  5;
ind_axe_ref     =  6;
ind_act_option  =  7;
ind_ssig_type   =  8;
nb1_stored      =  8;

% MemBloc2 of stored values.
%---------------------------
n_coefs_longs   = 'Coefs_and_Longs';
ind_coefs       = 1;
ind_longs       = 2;
nb2_stored      = 2;

% MemBloc3 of stored values.(Local Bloc)
%---------------------------------------
n_miscella_loc  = 'DWComp1D_Misc';
ind_hdls_lev    = 1;
ind_hdls_uiauto = 2;
ind_hdls_uivisu = 3;
ind_hdls_axauto = 4;
ind_hdls_axvisu = 5;
ind_status      = 6;
ind_hdl_winorig = 7;
nb3_stored      = 7;

% Tag property of objects.
%-------------------------
tag_sel_sli     = 'Sel_Sli';
tag_sel_edi     = 'Sel_Edi';
tag_norm_val_a  = 'Norm_Val_A';
tag_zeros_val_a = 'Zeros_Val_A';
tag_axe_perfo   = 'Axe_Perfo';
tag_norm_val_v  = 'Norm_Val_V';
tag_zeros_val_v = 'Zeros_Val_V';
tag_lin_norm    = 'Lin_Norm';
tag_lin_zero    = 'Lin_Zero';
tag_txt_comp    = 'Txt_Comp';
tag_lin_orig    = 'Lin_Orig';
tag_lin_comp    = 'Lin_Comp';
tag_txt_mode    = 'Txt_Mode';
tag_pop_mv      = 'Pop_ModeVal';
tag_axe_right_1 = 'axe_right_1';
tag_axe_right_2 = 'axe_right_2';
tag_axe_right_3 = 'axe_right_3';

% Tag property of objects (main window).
%---------------------------------------
tag_pop_viewm   = 'View_Mode';
tag_img_cfs     = 'Img_Cfs';
tag_img_sep     = 'Img_Sep';
                
%*****************************************************************%
%** OPTION = 'create' - constructs the initial dw1dcomp window  **%
%*****************************************************************%
if strcmp(option,'create')

        % Calling figure.
        %----------------
        win_dw1dtool     = in2;
        str_win_dw1dtool = int2str(win_dw1dtool);

        % Window initialization.
        %----------------------
        win_name = 'Wavelet 1-D  --  Compression';
        [win_dw1dcomp,pos_win,cba_close_menu] = ...
                wfigcrea('create',NaN,win_name,'',win_dw1dtool,3,...
                                str2mat('dw1dcomp','cond'));
        str_win_dw1dcomp = int2str(win_dw1dcomp);
        out1      = win_dw1dcomp;
        win_units = 'pixels';

        % Command frame and Dynamical visualization tool construction.
        %-------------------------------------------------------------
        [frame0,pos_frame0,Pos_Graphic_Area] = ...
                        wfigcrea('frame',win_dw1dcomp,'dynv','title');

        % Waiting Frame construction & begin waiting.
        %--------------------------------------------
        wwaiting('create',win_dw1dcomp,X_Graph_Ratio,...
                        'Wait ... initialization');

        % Getting global variables from dw1dtool figure memory block.
        %------------------------------------------------------------
        [Sig_Name,Wav_Name,Lev_Anal,Sig_Size] = ...
                wmemtool('rmb',win_dw1dtool,n_param_anal,...
                                ind_sig_name,ind_wav_name,...
                                ind_lev_anal,ind_sig_size);
        [Wav_Fam,Wav_Num] = wavattrb('fam_num',Wav_Name);
        [coefs,longs]   = wmemtool('rmb',win_dw1dtool,n_coefs_longs,...
                                                ind_coefs,ind_longs);

        % General graphical parameters initialization.
        %---------------------------------------------
        % Borders and double borders.
        dx  = X_Spacing;  dx2 = 2*dx;
        dy  = Y_Spacing;  dy2 = 2*dy;

        % X init position and width of frames.
        x_frame0        = pos_frame0(1);
        cmd_width       = pos_frame0(3);
        h_frame0        = pos_frame0(4);

        % Buttons width
        push_width      = (cmd_width-4*dx)/2;
        txt_width       = Def_Btn_Width;
        pop_width       = Pop_Min_Width;

        % Parameters initialization.
        %---------------------------
        [thresh,rl2scr,n0scr,argmin,suggthr] = wcmpscr(coefs,longs);
        min_sel_sli     = 0;
        max_sel_sli     = thresh(length(thresh));
        default_sel_sli = suggthr;
        default_nbcolors= 128;
        if      Lev_Anal < 10
                btn_height = Def_Btn_Height;
        elseif  Lev_Anal == 10
                btn_height = 9*Def_Btn_Height/10;
        else
                btn_height = 8*Def_Btn_Height/10;
        end

        % Position property of objects.
        %------------------------------
        pos_input_txt   = [     x_frame0+dx2                            ,...
                                h_frame0-3*dy-Def_Btn_Height            ,...
                                txt_width                               ,...
                                Def_Btn_Height                          ];
        pos_input_data  = [     pos_input_txt(1)+pos_input_txt(3)+dx    ,...
                                pos_input_txt(2)                        ,...
                                2*pop_width                             ,...
                                Def_Btn_Height                          ];
        pos_wav_txt     = pos_input_txt;
        pos_wav_txt(2)  = pos_input_txt(2)-Def_Btn_Height-dy2;
        pos_wav_fams    = [     pos_wav_txt(1)+pos_wav_txt(3)+dx        ,...
                                pos_wav_txt(2)                          ,...
                                pop_width                               ,...
                                Def_Btn_Height                          ];
        pos_wav_nums    = [     pos_wav_fams(1)+pos_wav_fams(3)+dx/2    ,...
                                pos_wav_fams(2)                         ,...
                                pop_width-dx/2                          ,...
                                Def_Btn_Height                          ];
        pos_lev_txt     = pos_wav_txt;
        pos_lev_txt(2)  = pos_wav_txt(2)-Def_Btn_Height-dy2;
        pos_lev_data    = [     pos_lev_txt(1)+pos_lev_txt(3)+dx        ,...
                                pos_lev_txt(2)                          ,...
                                pop_width                               ,...
                                Def_Btn_Height                          ];
        px              = x_frame0+(cmd_width-7*push_width/4)/2;
        pos_mode_val    = [     px                                      ,...
                                pos_lev_txt(2)-2*Def_Btn_Height         ,...
                                7*push_width/4                          ,...
                                3*Def_Btn_Height/2                      ];
        pos_sel_txt     = [     px                                      ,...
                                pos_mode_val(2)-3*Def_Btn_Height/2      ,...
                                7*push_width/4                          ,...
                                Def_Btn_Height                          ];
        wx              = (cmd_width-13*txt_width/5)/4;
        wid1            = 15*txt_width/10;
        wid2            = 9*txt_width/10;
        pos_sel_sli     = [     x_frame0+wx                             ,...
                                pos_sel_txt(2)-5*Def_Btn_Height/4       ,...
                                wid1                                    ,...
                                Def_Btn_Height/2                        ];
        pos_sel_edi     = [     pos_sel_sli(1)+pos_sel_sli(3)+wx        ,...
                                pos_sel_txt(2)-3*Def_Btn_Height/2       ,...
                                wid2                                    ,...
                                Def_Btn_Height                          ];
        pos_norm_txt_a  = [     x_frame0+wx                             ,...
                                pos_sel_edi(2)-3*Def_Btn_Height/2       ,...
                                wid1                                    ,...
                                Def_Btn_Height                          ];
        pos_norm_val_a  = [     pos_norm_txt_a(1)+pos_norm_txt_a(3)+wx  ,...
                                pos_sel_edi(2)-3*Def_Btn_Height/2       ,...
                                wid2                                    ,...
                                Def_Btn_Height                          ];
        pos_norm_per_a  = [     pos_norm_val_a(1)+pos_norm_val_a(3)+wx  ,...
                                pos_sel_edi(2)-3*Def_Btn_Height/2       ,...
                                txt_width/5                             ,...
                                Def_Btn_Height                          ];
        pos_zeros_txt_a = [     x_frame0+wx                             ,...
                                pos_norm_txt_a(2)-3*Def_Btn_Height/2    ,...
                                wid1                                    ,...
                                Def_Btn_Height                          ];
        pos_zeros_val_a = [     pos_zeros_txt_a(1)+pos_zeros_txt_a(3)+wx,...
                                pos_norm_txt_a(2)-3*Def_Btn_Height/2    ,...
                                wid2                                    ,...
                                Def_Btn_Height                          ];
        pos_zeros_per_a = [     pos_zeros_val_a(1)+pos_zeros_val_a(3)+wx,...
                                pos_norm_txt_a(2)-3*Def_Btn_Height/2    ,...
                                txt_width/5                             ,...
                                Def_Btn_Height                          ];
        pos_lev_title   = [     x_frame0+dx                             ,...
                                pos_mode_val(2)-3*Def_Btn_Height/2      ,...
                                cmd_width-4*dx                           ,...
                                Def_Btn_Height                          ];
        py              = pos_lev_title(2)-Lev_Anal*(btn_height+dy2);
        pos_norm_txt_v  = [     x_frame0+wx                             ,...
                                py-3*btn_height/2                       ,...
                                wid1                                    ,...
                                btn_height                              ];
        pos_norm_val_v  = [     pos_norm_txt_v(1)+pos_norm_txt_v(3)+wx  ,...
                                py-3*btn_height/2                       ,...
                                wid2                                    ,...
                                btn_height                              ];
        pos_norm_per_v  = [     pos_norm_val_v(1)+pos_norm_val_v(3)+wx  ,...
                                py-3*btn_height/2                       ,...
                                txt_width/5                             ,...
                                btn_height                              ];
        pos_zeros_txt_v = [     x_frame0+wx                             ,...
                                pos_norm_txt_v(2)-3*btn_height/2        ,...
                                wid1                                    ,...
                                btn_height                              ];
        pos_zeros_val_v = [     pos_zeros_txt_v(1)+pos_zeros_txt_v(3)+wx,...
                                pos_norm_txt_v(2)-3*btn_height/2        ,...
                                wid2                                    ,...
                                btn_height                              ];
        pos_zeros_per_v = [     pos_zeros_val_v(1)+pos_zeros_val_v(3)+wx,...
                                pos_norm_txt_v(2)-3*btn_height/2        ,...
                                txt_width/5                             ,...
                                btn_height                              ];
        pos_auto_comp   = [     x_frame0+(cmd_width-3*push_width/2)/2    ,...
                                pos_zeros_txt_a(2)-3*Def_Btn_Height     ,...
                                3*push_width/2                          ,...
                                2*Def_Btn_Height                        ];

        Screen_Size = get(0,'ScreenSize');
        if      Screen_Size(4)<600
                hvisu   = Def_Btn_Height;
                hclose  = Def_Btn_Height;
        elseif  Screen_Size(4)<700
                hvisu   = 3*Def_Btn_Height/2;
                hclose  = 3*Def_Btn_Height/2;
        else
                hvisu   = 2*btn_height;
                hclose  = 3*Def_Btn_Height/2;
        end
        pos_visu_comp   = [     x_frame0+(cmd_width-3*push_width/2)/2    ,...
                                pos_zeros_txt_v(2)-btn_height-hvisu     ,...
                                3*push_width/2                          ,...
                                hvisu                                   ];
        px              = x_frame0+(cmd_width-7*push_width/4)/2;
        pos_close       = [     px                                      ,...
                                pos_frame0(2)+btn_height                ,...
                                7*push_width/4                          ,...
                                hclose                                  ];

        % String property of objects.
        %----------------------------
        str_input_txt   = 'Signal';
        str_input_data  = Sig_Name;
        str_wav_txt     = 'Wavelet';
        str_wav_fams    = Wav_Fam;
        str_wav_nums    = Wav_Num;
        str_lev_txt     = 'Level';
        str_lev_data    = int2str(Lev_Anal);
        str_mode_val    = str2mat(      'Automatic thresholding',...
                                        'Manual thresholding');
        str_sel_txt     = 'Select global threshold';
        str_sel_edi     = sprintf('%1.4g',default_sel_sli);
        if strcmp(Wav_Fam,'bior')
                str_norm_txt    = 'Norm cfs recovery';
        else
                str_norm_txt    = 'Retained energy';
        end
        str_norm_val_a  = sprintf('%1.4g',rl2scr(argmin));
        str_norm_per    = '%';
        str_zeros_txt   = 'Number of zeros';
        str_zeros_val_a = sprintf('%1.4g',n0scr(argmin));
        str_zeros_per   = '%';
        str_lev_title   = 'Level       Select           Threshold';
        str_compress    = 'Compress';
        str_close       = 'Close';

        % Command part construction of the window.
        %-----------------------------------------
        figure(win_dw1dcomp)
        txt_input_txt   = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_input_txt,...
                                        'String',str_input_txt,...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
        txt_input_data  = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_input_data,...
                                        'String',str_input_data,...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        txt_wav_txt     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_wav_txt,...
                                        'String',str_wav_txt,...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
        txt_wav_fams    = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_wav_fams,...
                                        'String',str_wav_fams,...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        if ~isempty(str_wav_nums)
        txt_wav_nums    = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_wav_nums,...
                                        'String',str_wav_nums,...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        end
        txt_lev_txt     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_lev_txt,...
                                        'String',str_lev_txt,...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
        txt_lev_data    = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_lev_data,...
                                        'String',str_lev_data,...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        pop_mode_val    = uicontrol(...
                                        'Style','Popup',...
                                        'Unit',win_units,...
                                        'Position',pos_mode_val,...
                                        'Userdata',1,...
                                        'String',str_mode_val,...
                                        'tag',tag_pop_mv...
                                        );
        drawnow

        % Visual thresholding objects handles.
        %-------------------------------------
        txt_lev_title   = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'Position',pos_lev_title,...
                                        'String',str_lev_title,...
                                        'HorizontalAlignment','left',...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
        wx              = (cmd_width-5*txt_width/2)/4;
        xbtn0           = x_frame0+wx;
        ybtn0           = pos_lev_title(2)-btn_height-dy2;
        xbtn            = xbtn0;
        ybtn            = ybtn0;
        Sig_Anal        = dw1dfile('sig',win_dw1dtool);
        [thr_i,sorh,keepapp]    = ddencmp('cmp','wv',Sig_Anal);

        %%%% B.M. Strategy %%%%
        alpha = 1.5;
        thr = wdcbm(coefs,longs,alpha);
        [perfl2,perf0]  = wscrupd(coefs,longs,Lev_Anal,thr,sorh);
        %%%%%%%%%%%%%%%%%%%%%%%

%       [perfl2,perf0]  = wscrupd(coefs,longs,Lev_Anal,...
%                                       thr_i*ones(Lev_Anal),sorh);

        str_norm_val_v  = sprintf('%1.4g',perfl2);
        str_zeros_val_v = sprintf('%1.4g',perf0);
        hdls_lev        = zeros(6,Lev_Anal);
        for i=Lev_Anal:-1:1
                max_lev_i       = max(abs(detcoef(coefs,longs,i)));
                % val_lev_i     = min(max_lev_i,thr_i);

                %%%% B.M. Strategy %%%%
                val_lev_i       = min(max_lev_i,thr(i));
                %%%%%%%%%%%%%%%%%%%%%%%

                pos_lev_i       = [xbtn ybtn 2*txt_width/6 btn_height];
                str_lev_i       = int2str(i);
                txt_lev_i       = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'Position',pos_lev_i,...
                                        'String',str_lev_i,...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
                xbtn            = xbtn+2*txt_width/6+wx;
                pos_lev_i       = [     xbtn                            ,...
                                        ybtn+btn_height/4               ,...
                                        7*txt_width/6                   ,...
                                        btn_height/2                    ];
                sli_lev_i       = uicontrol(...
                                        'Style','Slider',...
                                        'Unit',win_units,...
                                        'Position',pos_lev_i,...
                                        'Min',0,...
                                        'Max',max_lev_i,...
                                        'Value',val_lev_i...
                                        );
                xbtn            = xbtn+7*txt_width/6+wx;
                pos_lev_i       = [xbtn ybtn txt_width btn_height];
                str_def_lev_i   = sprintf('%1.4g',val_lev_i);
                txt_val_i       = uicontrol(...
                                        'Style','Edit',...
                                        'Unit',win_units,...
                                        'Position',pos_lev_i,...
                                        'String',str_def_lev_i,...
                                        'HorizontalAlignment','center',...
                                        'Backgroundcolor',Def_EdiBkColor...
                                        );

                cba_sli         = ['dw1dcomp(''update_sellev'',' ...
                                        str_win_dw1dcomp ',' ...
                                        str_win_dw1dtool ',' ...
                                        str_lev_i ',''sli'');'];
                cba_edi         = ['dw1dcomp(''update_sellev'',' ...
                                        str_win_dw1dcomp ',' ...
                                        str_win_dw1dtool ',' ...
                                        str_lev_i ',''edi'');'];

                set(sli_lev_i,'Callback',cba_sli);
                set(txt_val_i,'Callback',cba_edi);

                hdls_lev(1,i) = txt_lev_i;
                hdls_lev(2,i) = sli_lev_i;
                hdls_lev(3,i) = txt_val_i;
                xbtn = xbtn0;
                ybtn = ybtn-btn_height-dy2;
        end
        drawnow('discard')

        txt_norm_txt_v  = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'Position',pos_norm_txt_v,...
                                        'HorizontalAlignment','left',...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'String',str_norm_txt...
                                        );
        txt_norm_val_v  = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'Position',pos_norm_val_v,...
                                        'String',str_norm_val_v,...
                                        'Backgroundcolor',Def_TxtBkColor,...
                                        'HorizontalAlignment','center',...
                                        'tag',tag_norm_val_v...
                                        );
        txt_norm_per_v  = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'Position',pos_norm_per_v,...
                                        'HorizontalAlignment','center',...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'String',str_norm_per...
                                        );
        txt_zeros_txt_v = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'Position',pos_zeros_txt_v,...
                                        'HorizontalAlignment','left',...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'String',str_zeros_txt...
                                        );
        txt_zeros_val_v = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'Position',pos_zeros_val_v,...
                                        'String',str_zeros_val_v,...
                                        'Backgroundcolor',Def_TxtBkColor,...
                                        'HorizontalAlignment','center',...
                                        'tag',tag_zeros_val_v...
                                        );
        txt_zeros_per_v = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'Position',pos_zeros_per_v,...
                                        'HorizontalAlignment','center',...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'String',str_zeros_per...
                                        );
        pus_visu_comp   = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_visu_comp,...
                                        'String',str_compress,...
                                        'Visible','off'...
                                        );
        pus_close       = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_close,...
                                        'String',str_close,...
                                        'Interruptible','yes'...
                                        );
        drawnow('discard')

        hdls_uivisu = hdls_lev(1:3,:);
        hdls_uivisu = [ txt_lev_title
                        hdls_uivisu(:)
                        txt_norm_txt_v
                        txt_norm_val_v
                        txt_norm_per_v
                        txt_zeros_txt_v
                        txt_zeros_val_v
                        txt_zeros_per_v
                        pus_visu_comp];
        set(hdls_uivisu,'Visible','off');

        % Automatic thresholding objects handles.
        %----------------------------------------
        txt_sel_txt     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'Position',pos_sel_txt,...
                                        'String',str_sel_txt,...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
        sli_sel_sli     = uicontrol(...
                                        'Style','Slider',...
                                        'Unit',win_units,...
                                        'Position',pos_sel_sli,...
                                        'Min',min_sel_sli,...
                                        'Max',max_sel_sli,...
                                        'Value',default_sel_sli,...
                                        'tag',tag_sel_sli...
                                        );
        edi_sel_edi     = uicontrol(...
                                        'Style','Edit',...
                                        'Unit',win_units,...
                                        'Position',pos_sel_edi,...
                                        'String',str_sel_edi,...
                                        'Backgroundcolor',Def_EdiBkColor,...
                                        'HorizontalAlignment','center',...
                                        'tag',tag_sel_edi...
                                        );
        txt_norm_txt_a  = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'Position',pos_norm_txt_a,...
                                        'HorizontalAlignment','left',...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'String',str_norm_txt...
                                        );
        edi_norm_val_a  = uicontrol(...
                                        'Style','Edit',...
                                        'Unit',win_units,...
                                        'Position',pos_norm_val_a,...
                                        'String',str_norm_val_a,...
                                        'Backgroundcolor',Def_EdiBkColor,...
                                        'HorizontalAlignment','center',...
                                        'tag',tag_norm_val_a...
                                        );
        txt_norm_per_a  = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'Position',pos_norm_per_a,...
                                        'HorizontalAlignment','center',...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'String',str_norm_per...
                                        );
        txt_zeros_txt_a = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'Position',pos_zeros_txt_a,...
                                        'HorizontalAlignment','left',...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'String',str_zeros_txt...
                                        );
        edi_zeros_val_a = uicontrol(...
                                        'Style','Edit',...
                                        'Unit',win_units,...
                                        'Position',pos_zeros_val_a,...
                                        'String',str_zeros_val_a,...
                                        'Backgroundcolor',Def_EdiBkColor,...
                                        'HorizontalAlignment','center',...
                                        'tag',tag_zeros_val_a...
                                        );
        txt_zeros_per_a = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'Position',pos_zeros_per_a,...
                                        'HorizontalAlignment','center',...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'String',str_zeros_per...
                                        );
        pus_auto_comp   = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_auto_comp,...
                                        'String',str_compress...
                                        );
        drawnow

        hdls_uiauto = [ txt_sel_txt
                        sli_sel_sli
                        edi_sel_edi
                        txt_norm_txt_a
                        edi_norm_val_a
                        txt_norm_per_a
                        txt_zeros_txt_a
                        edi_zeros_val_a
                        txt_zeros_per_a
                        pus_auto_comp];

        % Callbacks update.
        %------------------
        str_pop_mode_val= num2mstr(pop_mode_val);
        cba_mode_val    = ['dw1dcomp(''mode'',' ...
                                str_win_dw1dcomp ',' ...
                                str_pop_mode_val ');'];
        cba_sel_sli     = ['dw1dcomp(''update_selglo'',' ...
                                str_win_dw1dcomp ',' ...
                                '''sli''' ');'];
        cba_sel_edi     = ['dw1dcomp(''update_selglo'',' ...
                                str_win_dw1dcomp ',' ...
                                '''edi''' ');'];
        cba_norm_val    = ['dw1dcomp(''update_selglo'',' ...
                                str_win_dw1dcomp ',' ...
                                '''nor''' ');'];
        cba_zeros_val   = ['dw1dcomp(''update_selglo'',' ...
                                str_win_dw1dcomp ',' ...
                                '''zer''' ');'];
        cba_compress    = ['dw1dcomp(''compress'',' ...
                                str_win_dw1dcomp ',' ...
                                str_win_dw1dtool ',' ...
                                str_pop_mode_val ');'];
        set(pop_mode_val,'Callback',cba_mode_val);
        set(sli_sel_sli,'Callback',cba_sel_sli);
        set(edi_sel_edi,'Callback',cba_sel_edi);
        set(edi_norm_val_a,'Callback',cba_norm_val);
        set(edi_zeros_val_a,'Callback',cba_zeros_val);
        set(pus_auto_comp,'Callback',cba_compress);
        set(pus_visu_comp,'Callback',cba_compress);
        set(pus_close,'Callback',cba_close_menu);

        % General graphical parameters initialization.
        %--------------------------------------------
        bdx             = 0.08*pos_win(3);
        bdy             = 0.06*pos_win(4);
        ecy             = 0.03*pos_win(4);
        y_graph         = 2*Def_Btn_Height+dy;
        h_graph         = pos_frame0(4)-y_graph;
        w_graph         = pos_frame0(1);

        if Lev_Anal > 9
                if Screen_Size(4)<600
                        fontsize = 12;
                else
                        fontsize = 14;
                end
        else
                if Screen_Size(4)<600
                        fontsize = 14;
                else
                        fontsize = 16;
                end
        end

        % Axes construction parameters.
        %------------------------------
        w_left          = (w_graph-3*bdx)/2;
        x_left          = bdx;
        w_right         = w_left;
        x_right         = x_left+w_left+5*bdx/4;
        n_axeleft       = Lev_Anal;
        n_axeright      = 3;
        ind_left        = n_axeleft;
        ind_right       = n_axeright;

        % Vertical separation.
        %---------------------
        w_fra   = 0.01*pos_win(3);
        x_fra   = (w_graph-w_fra)/2;
        uicontrol(...
                        'Style','frame',...
                        'Unit',win_units,...
                        'Position',[x_fra,y_graph,w_fra,h_graph],...
                        'Backgroundcolor',Def_FraBkColor,...
                        'Tag','Dw1dcomp_obj'...
                        );

        % Building axes on the right part.
        %---------------------------------
        ecy_right       = 2*ecy;
        h_right         =(h_graph-2*bdy-(n_axeright-1)*ecy_right)/n_axeright;
        y_right         = y_graph+2*bdy/3;
        axe_right       = zeros(1,n_axeright);
        pos_right       = [x_right y_right w_right h_right];
        for k = 1:n_axeright
                axe_right(k) = axes(...
                                'Units',win_units,...
                                'Position',pos_right,...
                                'Drawmode','fast',...
                                'Box','On',...
                                'Tag',['axe_right_' int2str(k)]...
                                );
                pos_right(2) = pos_right(2)+pos_right(4)+ecy_right;
        end
        set(axe_right(1),'visible','off');

        % Displaying the signal.
        %-----------------------
        axes(axe_right(3))
        curr_color = dw1dcolo('sig');
        hdl_sig    = line(1:length(Sig_Anal),Sig_Anal,'erasemode','none',...
                        'Color',curr_color,'tag',tag_lin_orig);
        title('Original signal');       
        xaxis = [1              Sig_Size];
        yaxis = [min(Sig_Anal)  max(Sig_Anal)];
        if xaxis(1)==xaxis(2)
                xaxis = xaxis+[-0.000001 0.000001];
        end
        if yaxis(1)==yaxis(2)
                yaxis = yaxis+[-0.000001 0.000001];
        end
        set(axe_right(3),'Xlim',xaxis,'Ylim',yaxis);

        % Displaying original details coefficients.
        %------------------------------------------
        pop_viewm       = findobj(win_dw1dtool,'tag',tag_pop_viewm);
        view_m_orig     = get(pop_viewm,'Value');
        if      view_m_orig==1
                img_cfs = findobj(win_dw1dtool,'tag',tag_img_cfs);
        elseif  view_m_orig==2 | view_m_orig==5
                img_cfs = [];
        elseif  view_m_orig==3
                img_cfs = findobj(win_dw1dtool,'tag',tag_img_sep);
        elseif  view_m_orig==4
                img_cfs = findobj(win_dw1dtool,'tag',tag_img_cfs);
        end
        colormap(get(win_dw1dtool,'Colormap'));
        [details,set_ylim,ymin,ymax] = dw1dfile('cfs_beg',win_dw1dtool,...
                        [1:Lev_Anal],1);
        [nul,i_min] = min(abs(details(:)));
        if ~isempty(img_cfs)
                col_cfs = get(img_cfs,'Cdata');
        else
                col_cfs =  wcodemat(details,default_nbcolors,'row',1);
        end
        col_min = col_cfs(i_min);

        axes(axe_right(2));
        [nbrow,nbcol]   = size(col_cfs);
        if nbrow>1 , rmin = 1; else rmin = 0; end
        hdl_cfs_orig = image([1 nbcol],[nbrow rmin],col_cfs,'Userdata',col_min);
        clear col_cfs
        levlab = int2str(1);
        for k = 2:Lev_Anal ,levlab = str2mat(levlab,int2str(k)); end
        set(axe_right(2),...
                        'Userdata',hdl_cfs_orig,...
                        'Xlim',[1 Sig_Size],...
                        'YTicklabelMode','manual',...
                        'YTick',[1:Lev_Anal],...
                        'YTickLabels',levlab,...
                        'Tag',tag_axe_right_2);
        title('Original coefficients');
        ylabel('Level number','Fontsize',10);
        set(axe_right(1),...
                        'Xlim',get(axe_right(2),'Xlim'),...
                        'Ylim',get(axe_right(2),'Ylim'));

        % Building axes on the left part.
        %--------------------------------
        ecy_left        = ecy/2;
        h_left          = (h_graph-2*bdy-(n_axeleft-1)*ecy_left)/n_axeleft;
        y_left          = y_graph+bdy;
        axe_left        = zeros(1,n_axeleft);
        pos_left        = [x_left y_left w_left h_left];
        for k = 1:n_axeleft
                if k==1
                        axe_left(k) = axes(...
                                        'Units',win_units,...
                                        'Position',pos_left,...
                                        'Drawmode','fast',...
                                        'Visible','Off',...
                                        'Box','On'...
                                        );
                        xlabel('Original details coefficients');
                else
                        axe_left(k) = axes(...
                                        'Units',win_units,...
                                        'Position',pos_left,...
                                        'XTicklabelMode','manual',...
                                        'XTickLabels',[],...
                                        'Drawmode','fast',...
                                        'Visible','Off',...
                                        'Box','On'...
                                        );
                end
                pos_left(2) = pos_left(2)+pos_left(4)+ecy_left;
        end

        % Displaying details.
        %-------------------
        col_det         = dw1dcolo('det',Lev_Anal);
        txt_left        = ones(Lev_Anal,1);
        for k = Lev_Anal:-1:1
                axes(axe_left(ind_left));
                hdls_lev(4,k) = line('Xdata',1:Sig_Size,...
                                        'Ydata',details(k,:),...
                                        'Color',col_det(k,:));
                ythr    = str2num(get(hdls_lev(3,k),'string'));
                hdls_lev(5,k) = line('Linestyle','--',...
                        'Color','y',...
                        'EraseMode','xor',...
                        'Xdata',[1 Sig_Size],...
                        'Ydata',[ythr ythr]);
                hdls_lev(6,k) = line('Linestyle','--',...
                        'Color','y',...
                        'EraseMode','xor',...
                        'Xdata',[1 Sig_Size],...
                        'Ydata',[-ythr -ythr]);
                txt_left(k) = txtinaxe('create',['d' int2str(k)],...
                                        axe_left(k),'left',...
                                        'on','bold',fontsize);

                maxi = max([ythr,abs(ymax(k)),abs(ymin(k))]);
                if abs(maxi)<eps , maxi = maxi+0.0001; end;
                yec = 0.1*maxi;
                yaxis = [-maxi-yec maxi+yec];

                set(axe_left(ind_left),'Xlim',xaxis,'Ylim',yaxis);
                ind_left = ind_left-1;
        end

        % Displaying perfos.
        %-------------------
        y_axe_perfo     = y_graph+2*bdy/3+h_right+ecy_right;
        h_axe_perfo     = 2*h_right+ecy_right;
        pos_axe_perfo   = [x_left y_axe_perfo w_left h_axe_perfo];
        axe_perfo       = axes(...
                                'Units',win_units,...
                                'Position',pos_axe_perfo,...
                                'Drawmode','fast',...
                                'Visible','off',...
                                'Box','On',...
                                'Tag',tag_axe_perfo);
        if abs(thresh)<eps , epsx  = 0.0001; else , epsx  = 0; end;
        xaxis = [-(max(thresh)/100)-epsx    max(thresh)+(max(thresh)/100)+epsx];
        set(axe_perfo,'Xlim',xaxis,'Ylim',[0 104]);
        lin_zero        = line( 'Xdata',thresh,...
                                'Ydata',n0scr,...
                                'Color','cyan',...
                                'EraseMode','none',...
                                'Tag',tag_lin_zero);
        lin_norm        = line( 'Xdata',thresh,...
                                'Ydata',rl2scr,...
                                'Color','magenta',...
                                'EraseMode','none',...
                                'Tag',tag_lin_norm);
        lin_perfo       = line( 'Xdata',[suggthr suggthr],...
                                'Ydata',[0.5 104],...
                                'Color','y',...
                                'EraseMode','xor',...
                                'linestyle',':');
        set(axe_perfo,'Userdata',lin_perfo);

        % Set a text as a super title. 
        %-----------------------------
        title(' ');
        wtxttitl(axe_perfo,'Automatic thresholding',tag_txt_mode);


        % Displaying legend.
        %-------------------
        y_axe_legend    = y_graph+h_right/2;
        h_axe_legend    = h_right/2;
        pos_axe_legend  = [x_left y_axe_legend w_left h_axe_legend];
        axe_legend      = wlegend(win_dw1dcomp,pos_axe_legend,Wav_Fam);

        % Sets of graphical objects.
        %---------------------------
        hdls_axauto     = [     axe_perfo
                                get(axe_perfo,'Children')
                                axe_legend
                                get(axe_legend,'Children')];
        hdls_axvisu     = hdls_lev(4:6,:);
        hdls_axvisu     = [     axe_left(:)
                                txt_left(:)
                                hdls_axvisu(:)];
        set(hdls_axvisu,'Visible','off');
        set(hdls_axauto,'Visible','on');

        % Memory blocks update.
        %----------------------
        wmemtool('ini',win_dw1dcomp,n_miscella_loc,nb3_stored);
        wmemtool('wmb',win_dw1dcomp,n_miscella_loc,                     ...
                                        ind_hdls_lev,hdls_lev,          ...
                                        ind_hdls_uiauto,hdls_uiauto,    ...
                                        ind_hdls_uivisu,hdls_uivisu,    ...
                                        ind_hdls_axauto,hdls_axauto,    ...
                                        ind_hdls_axvisu,hdls_axvisu,    ...
                                        ind_status,0,                   ...
                                        ind_hdl_winorig,win_dw1dtool    ...
                                        );

        % Axes attachment.
        %-----------------
        axe_cmd = [axe_right(3) axe_left(1:n_axeleft)];
        axe_act = [axe_right(1:2)];
        dynvtool('attach',win_dw1dcomp,[],axe_cmd,axe_act,[1 0],'','','');
        dynvtool('put',win_dw1dcomp);

        % Setting units to normalized.
        %-----------------------------
        set(findobj(win_dw1dcomp,'Units','pixels'),'Units','Normalized');

        % End waiting.
        %-------------
        wwaiting('off',win_dw1dcomp);

%***************************************%
%** OPTION = 'compress' - COMPRESSION **%
%***************************************%
elseif strcmp(option,'compress')
        win_dw1dcomp    = in2;
        win_dw1dtool    = in3;
        if nargin==4
                pop_mode_val = in4;
        else
                pop_mode_val = findobj(win_dw1dcomp,'tag',tag_pop_mv);
        end

        % Waiting message.
        %-----------------
        wwaiting('msg',win_dw1dcomp,'Wait ... computing');

        % Handles of tagged objects.
        %---------------------------
        axe_handles     = findobj(win_dw1dcomp,'Type','axes');
        txt_handles     = findobj(win_dw1dcomp,'Type','text');
        lin_handles     = findobj(win_dw1dcomp,'Type','line');
        axe_right_1     = findobj(axe_handles,'flat','Tag',tag_axe_right_1);
        axe_right_2     = findobj(axe_handles,'flat','Tag',tag_axe_right_2);
        axe_right_3     = findobj(axe_handles,'flat','Tag',tag_axe_right_3);
        txt_perfcmp     = findobj(txt_handles,'flat','Tag',tag_txt_comp);
        lin_norm        = findobj(lin_handles,'Tag',tag_lin_norm);
        lin_zero        = findobj(lin_handles,'Tag',tag_lin_zero);

        % Setting the compressed coefs axes invisible.
        %---------------------------------------------
        lin_compsig     = get(axe_right_3,'userdata');
        if ~isempty(lin_compsig)
                vis     = get(lin_compsig,'Visible');
                if vis(1:2)=='on'
                        mngaxe('vis',axe_right_1,'off');
                        axes(axe_right_3);
                        title('Original signal');
                        set(lin_compsig,'Visible','off');
                        set(txt_perfcmp,'Visible','off');
                end
        end
        drawnow

        % Getting memory blocks.
        %-----------------------
        [Wav_Name,Lev_Anal,Sig_Size] = ...
                        wmemtool('rmb',win_dw1dtool,n_param_anal,       ...
                                ind_wav_name,ind_lev_anal,ind_sig_size);
        [coefs,longs]   = wmemtool('rmb',win_dw1dtool,n_coefs_longs,...
                                                ind_coefs,ind_longs);

        % Loading the original signal.
        %-----------------------------
        Sig_Anal = dw1dfile('sig',win_dw1dtool);

        % Compression depending on the selected thresholding mode.
        %----------------------------------------------------------
        if (get(pop_mode_val,'value'))==1
                sli_handles     = findobj(win_dw1dcomp,'Style','slider');
                sli_sel_sli     = findobj(sli_handles,'Tag',tag_sel_sli);
                threshold       = get(sli_sel_sli,'Value');
                [xc,cxc,lxc]    = wdencmp('gbl',coefs,longs,...
                                            Wav_Name,Lev_Anal,threshold,'h',1);
                Wav_Fam = wavattrb('fam_num',Wav_Name);
                if strcmp(Wav_Fam,'bior')
                        perfl2  = 100*(norm(xc)/norm(Sig_Anal))^2;
                else
                        [perfl2,perf0,new_thresh] = ... 
                                key2info(lin_norm,lin_zero,threshold,'T');
                end

        else
                hdls_lev = wmemtool('rmb',win_dw1dcomp,n_miscella_loc,...
                                                        ind_hdls_lev);
                threshold       = zeros(1,Lev_Anal);
                for     i=1:Lev_Anal
                        threshold(i) = get(hdls_lev(2,i),'value');
                end
                [xc,cxc,lxc,perf0,perfl2] = wdencmp('lvd',coefs,longs,...
                                            Wav_Name,Lev_Anal,threshold,'h');
        end

        % Displaying compressed signal.
        %------------------------------
        axes(axe_right_3);
        if ~isempty(lin_compsig)
                set(lin_compsig,'Ydata',xc);
                set(lin_compsig,'Visible','on');
        else
                curr_color      = dw1dcolo('ssig');
                lin_compsig     = line( 'Xdata',1:length(xc),...
                                        'Ydata',xc,...
                                        'color',curr_color,'tag',tag_lin_comp);
                set(axe_right_3,'userdata',lin_compsig)
        end     

        % Set a text as a super title.
        %-----------------------------
        str_norm_txt    = 'Retained energy ';
        title('Original and compressed signals');
        txt_comp        = [str_norm_txt num2str(perfl2) ...
                        ' % -- Zeros ' num2str(perf0) ' %'];
        wtxttitl(axe_right_3,txt_comp,tag_txt_comp);

        % Displaying thresholded details coefficients.
        %---------------------------------------------
        axes(axe_right_1);
        col_cfs         = zeros(Lev_Anal,Sig_Size);
        for k = 1:Lev_Anal
                x               = detcoef(cxc,lxc,k);
                x               = x(ones(1,2^k),:);
                x               = x(:)';                
                col_cfs(k,:)    = wkeep(x,Sig_Size);            
        end
        clear x
        nz_cfs          = find(col_cfs~=0);
        [nbrow,nbcol]   = size(col_cfs);
        hdl_img_cfs     = get(axe_right_2,'Userdata');
        col_min         = get(hdl_img_cfs,'Userdata');
        col_cfs_orig    = get(hdl_img_cfs,'Cdata');
        col_cfs         = col_min*ones(nbrow,nbcol);
        col_cfs(nz_cfs) = col_cfs_orig(nz_cfs);

        if nbrow>1 , rmin = 1; else rmin = 0; end
        image([1 nbcol],[nbrow rmin],col_cfs);
        levlab = int2str(1);
        for k = 2:Lev_Anal ,levlab = str2mat(levlab,int2str(k)); end
        set(axe_right_1,...
                        'Xlim',get(axe_right_2,'Xlim'),...
                        'YTicklabelMode','manual',...
                        'YTick',[1:Lev_Anal],...
                        'YTickLabels',levlab,...
                        'Tag',tag_axe_right_1);
        title('Thresholded coefficients');
        ylabel('Level number','Fontsize',10);
        mngaxe('vis',axe_right_1,'on');

        % Memory blocks update.
        %----------------------
        wmemtool('wmb',win_dw1dcomp,n_miscella_loc,ind_status,1);

        % End waiting.
        %-------------
        wwaiting('off',win_dw1dcomp);

%***********************************%
%** OPTION = 'mode' - MODE CHOICE **%
%***********************************%
elseif strcmp(option,'mode')
        win_dw1dcomp    = in2;
        pop_mode_val    = in3;

        mode_val        = get(pop_mode_val,'value');
        old_mode        = get(pop_mode_val,'userdata');
        if mode_val==old_mode
                return;
        else
                set(pop_mode_val,'userdata',mode_val);
        end

        % Handles of tagged objects.
        %---------------------------
        axe_handles     = findobj(win_dw1dcomp,'Type','axes');
        txt_handles     = findobj(win_dw1dcomp,'Type','text');
        axe_right_1     = findobj(axe_handles,'flat','Tag',tag_axe_right_1);
        axe_right_3     = findobj(axe_handles,'flat','Tag',tag_axe_right_3);
        txt_perfcmp     = findobj(txt_handles,'Tag',tag_txt_comp);
        txt_mode        = findobj(txt_handles,'Tag',tag_txt_mode);

        % Getting memory blocks.
        %-----------------------
        [hdls_uiauto,hdls_uivisu,hdls_axauto,hdls_axvisu] = ...
                        wmemtool('rmb',win_dw1dcomp,n_miscella_loc,     ...
                                ind_hdls_uiauto,ind_hdls_uivisu,        ...
                                ind_hdls_axauto,ind_hdls_axvisu         ...
                                );

        % Changing mode.
        %---------------
        dynvtool('delline',win_dw1dcomp);
        dynvtool('delbox',win_dw1dcomp);
        dynvtool('get',win_dw1dcomp,0);
        if mode_val==1
                set(hdls_uivisu,'Visible','off')
                set(hdls_uiauto,'Visible','on')
                set(hdls_axvisu,'Visible','off');
                set(hdls_axauto,'Visible','on');
                set(txt_mode,'String','Automatic thresholding');
        else
                set(hdls_uivisu,'Visible','on');
                set(hdls_uiauto,'Visible','off');
                set(hdls_axvisu,'Visible','on');
                set(hdls_axauto,'Visible','off');
                set(txt_mode,'String','Manual thresholding');
        end
        axes(axe_right_3);
        set(get(axe_right_3,'userdata'),'Visible','off');
        title('Original signal');       
        mngaxe('vis',axe_right_1,'off');
        set(txt_perfcmp,'Visible','off');
        set(txt_mode,'Visible','on');

        % Memory blocks update.
        %----------------------
        wmemtool('wmb',win_dw1dcomp,n_miscella_loc,ind_status,0);

%***************************************************************%
%** OPTION = 'update_selglo' - UPDATE INFOS FOR GLOBAL THRESH **%
%***************************************************************%
elseif strcmp(option,'update_selglo')
        win_dw1dcomp    = in2;
        upd_orig        = in3;

        % Handles of tagged objects continuing.
        %-------------------------------------
        axe_handles     = findobj(win_dw1dcomp,'Type','axes');
        txt_handles     = findobj(win_dw1dcomp,'Type','text');
        sli_handles     = findobj(win_dw1dcomp,'Style','slider');
        edi_handles     = findobj(win_dw1dcomp,'Style','edit');
        lin_handles     = findobj(win_dw1dcomp,'Type','line');
        axe_perfo       = findobj(axe_handles,'Tag',tag_axe_perfo);
        axe_right_1     = findobj(axe_handles,'flat','Tag',tag_axe_right_1);
        axe_right_3     = findobj(axe_handles,'flat','Tag',tag_axe_right_3);
        txt_perfcmp     = findobj(txt_handles,'flat','Tag',tag_txt_comp);
        sli_sel_sli     = findobj(sli_handles,'Tag',tag_sel_sli);
        edi_sel_edi     = findobj(edi_handles,'Tag',tag_sel_edi);
        edi_norm_val_a  = findobj(edi_handles,'Tag',tag_norm_val_a);
        edi_zeros_val_a = findobj(edi_handles,'Tag',tag_zeros_val_a);
        lin_norm        = findobj(lin_handles,'Tag',tag_lin_norm);
        lin_zero        = findobj(lin_handles,'Tag',tag_lin_zero);

        % Setting the compressed coefs axes invisible.
        %---------------------------------------------
        lin_compsig     = get(axe_right_3,'userdata');
        if ~isempty(lin_compsig)
                vis     = get(lin_compsig,'Visible');
                if vis(1:2)=='on'
                        mngaxe('vis',axe_right_1,'off');
                        axes(axe_right_3);
                        title('Original signal');
                        set(lin_compsig,'Visible','off');
                        set(txt_perfcmp,'Visible','off');
                end
        end
        drawnow

        % Updating compression information.
        %----------------------------------
        if      upd_orig=='sli'
                new_thresh      = get(sli_sel_sli,'value');
                [new_rl2scr,new_n0scr,new_thresh] = ... 
                        key2info(lin_norm,lin_zero,new_thresh,'T');
        elseif  upd_orig=='edi'
                new_thresh      = str2num(get(edi_sel_edi,'string'));
                [new_rl2scr,new_n0scr,new_thresh] = ...
                        key2info(lin_norm,lin_zero,new_thresh,'T');
        elseif  upd_orig=='nor'
                new_rl2scr      = str2num(get(edi_norm_val_a,'string'));
                [new_rl2scr,new_n0scr,new_thresh] = ... 
                        key2info(lin_norm,lin_zero,new_rl2scr,'N');
        elseif  upd_orig=='zer'
                new_n0scr       = str2num(get(edi_zeros_val_a,'string'));
                [new_rl2scr,new_n0scr,new_thresh] = ... 
                        key2info(lin_norm,lin_zero,new_n0scr,'Z');
        end
        if isempty(new_thresh)|isempty(new_rl2scr)|isempty(new_n0scr)
                new_thresh      = get(sli_sel_sli,'value');
                [new_rl2scr,new_n0scr,new_thresh] = ... 
                        key2info(lin_norm,lin_zero,new_thresh,'T');
        end

        set(sli_sel_sli,'value',new_thresh);
        set(edi_sel_edi,'string',sprintf('%1.4g',new_thresh));
        set(edi_norm_val_a,'string',sprintf('%1.4g',new_rl2scr));
        set(edi_zeros_val_a,'string',sprintf('%1.4g',new_n0scr));

        newline = 1;
        xnew    = [new_thresh new_thresh];
        lin_per = get(axe_perfo,'Userdata');
        xold    = get(lin_per,'Xdata');
        if ~isempty(xold)
                if size(xold)==[1 2]
                        if abs(xold - xnew)<sqrt(eps)
                                newline = 0;
                        end
                end
        end
        if newline
                if      strcmp(Machine(1:3),'PCW')
                        hdls_axauto = wmemtool('rmb',win_dw1dcomp,...
                                        n_miscella_loc,ind_hdls_axauto);
                        ii = find(hdls_axauto==lin_per);
                        yper = get(lin_per,'Ydata');
                        delete(lin_per)
                        axes(axe_perfo);
                        lin_per = line(...
                                        'Xdata',xnew,...
                                        'ydata',yper,...
                                        'Color','y',...
                                        'linestyle',':');
                        set(axe_perfo,'Userdata',lin_per);
                        hdls_axauto(ii) = lin_per;
                        wmemtool('wmb',win_dw1dcomp,n_miscella_loc,...
                                ind_hdls_axauto,hdls_axauto);

                else
                        set(lin_per,'Xdata',xnew);
                end

        end

        % Memory blocks update.
        %----------------------
        wmemtool('wmb',win_dw1dcomp,n_miscella_loc,ind_status,0);

%*********************************************************************%
%** OPTION = 'update_sellev' - UPDATE INFOS FOR VISUAL THRESHOLDING **%
%*********************************************************************%
elseif strcmp(option,'update_sellev')
        win_dw1dcomp    = in2;
        win_dw1dtool    = in3;
        lev_i           = in4;
        type_hdl        = in5;
        
        % Getting memory blocks.
        %-----------------------
        hdls_lev = wmemtool('rmb',win_dw1dcomp,n_miscella_loc,ind_hdls_lev);

        % Updating threshold.
        %---------------------
        if      strcmp(type_hdl,'sli')
                new_thresh      =  get(hdls_lev(2,lev_i),'value');
                set(hdls_lev(3,lev_i),'string',sprintf('%1.4g',new_thresh));

        elseif strcmp(type_hdl,'edi')
                valstr = get(hdls_lev(3,lev_i),'string');
                [new_thresh,count,err] = sscanf(valstr,'%f');
                if (count~=1) | ~isempty(err)
                        new_thresh = get(hdls_lev(2,lev_i),'Value');
                        set(hdls_lev(3,lev_i),'string',sprintf('%1.4g',new_thresh));
                        return
                else
                        mi = get(hdls_lev(2,lev_i),'Min');
                        ma = get(hdls_lev(2,lev_i),'Max');
                        if      new_thresh<mi , new_thresh = mi;
                        elseif  new_thresh>ma , new_thresh = ma;
                        end
                        set(hdls_lev(2,lev_i),'Value',new_thresh);
                        set(hdls_lev(3,lev_i),'string',sprintf('%1.4g',new_thresh));
                end
        end

        % Getting memory blocks.
        %-----------------------
        [Lev_Anal,Sig_Size]     = wmemtool('rmb',win_dw1dtool,n_param_anal,...
                                        ind_lev_anal,ind_sig_size);
        thr = zeros(Lev_Anal);
        for i=1:Lev_Anal
                thr(i) = get(hdls_lev(2,i),'value');
        end

        % Handles of tagged objects.
        %---------------------------
        axe_handles     = findobj(win_dw1dcomp,'Type','axes');
        txtui_handles   = findobj(win_dw1dcomp,'Style','text');
        txtax_handles   = findobj(win_dw1dcomp,'Type','text');
        axe_right_1     = findobj(axe_handles,'flat','Tag',tag_axe_right_1);
        axe_right_3     = findobj(axe_handles,'flat','Tag',tag_axe_right_3);
        txt_norm_val_v  = findobj(txtui_handles,'Tag',tag_norm_val_v);
        txt_zeros_val_v = findobj(txtui_handles,'Tag',tag_zeros_val_v);
        txt_perfcmp     = findobj(txtax_handles,'flat','Tag',tag_txt_comp);

        % Setting the compressed coefs axes invisible.
        %---------------------------------------------
        lin_compsig     = get(axe_right_3,'userdata');
        if ~isempty(lin_compsig)
                vis     = get(lin_compsig,'Visible');
                if vis(1:2)=='on'
                        mngaxe('vis',axe_right_1,'off');
                        axes(axe_right_3);
                        title('Original signal');
                        set(lin_compsig,'Visible','off');
                        set(txt_perfcmp,'Visible','off');
                end
        end
        drawnow

        % Getting memory blocks.
        %-----------------------
        [coefs,longs]           = wmemtool('rmb',win_dw1dtool,n_coefs_longs,...
                                                ind_coefs,ind_longs);

        % Updating information.
        %----------------------
        ynew = [new_thresh new_thresh];
        if      strcmp(Machine(1:3),'PCW')
                hdls_axvisu = wmemtool('rmb',win_dw1dcomp,...
                                        n_miscella_loc,ind_hdls_axvisu);
                i5      = find(hdls_axvisu==hdls_lev(5,lev_i));
                i6      = find(hdls_axvisu==hdls_lev(6,lev_i));
                xval    = get(hdls_lev(5,lev_i),'Xdata');
                axe_det = get(hdls_lev(5,lev_i),'Parent');
                axes(axe_det)
                delete(hdls_lev(5:6,lev_i))
                hdls_lev(5,lev_i) = line(...
                                        'Linestyle','--',       ...
                                        'Color','y',            ...
                                        'Xdata',xval,           ...
                                        'Ydata',ynew            ...
                                        );
                hdls_lev(6,lev_i) = line(...
                                        'Linestyle','--',       ...
                                        'Color','y',            ...
                                        'Xdata',xval,           ...
                                        'Ydata',-ynew           ...
                                        );
                hdls_axvisu(i5) = hdls_lev(5,lev_i);
                hdls_axvisu(i6) = hdls_lev(6,lev_i);
                wmemtool('wmb',win_dw1dcomp,n_miscella_loc,     ...
                                ind_hdls_lev,hdls_lev,          ...
                                ind_hdls_axvisu,hdls_axvisu     ...
                                );
        else
                set(hdls_lev(5,lev_i),'Ydata', ynew);
                set(hdls_lev(6,lev_i),'Ydata',-ynew);
        end
        [perfl2,perf0]  = wscrupd(coefs,longs,Lev_Anal,thr,'h');
        set(txt_norm_val_v,'string',sprintf('%1.4g',perfl2));
        set(txt_zeros_val_v,'string',sprintf('%1.4g',perf0));

        % Memory blocks update.
        %----------------------
        wmemtool('wmb',win_dw1dcomp,n_miscella_loc,ind_status,0);

                
%**************************************%
%** OPTION = 'close' -  CLOSE FIGURE **%
%**************************************%
elseif strcmp(option,'close')
        win_dw1dcomp    = in2;

        [status,hdl_winorig] = wmemtool('rmb',win_dw1dcomp,n_miscella_loc,...
                                        ind_status,ind_hdl_winorig);
        if status==1

                % Test for Updating.
                %--------------------
                status = wwaitans(win_dw1dcomp,...
                                  'Update the synthesized signal ?',2,'cancel');

        end
        if status==1
                wwaiting('msg',win_dw1dcomp,'Wait ... computing');
                axe_handles     = findobj(win_dw1dcomp,'Type','axes');
                lin_handles     = findobj(axe_handles,'Type','line');
                lin_comp        = findobj(lin_handles,'tag',tag_lin_comp);

                % Writing Synthesized. Signal Type.
                %----------------------------------
                wmemtool('wmb',hdl_winorig,n_param_anal,ind_ssig_type,'cs');

                dw1dmngr('return_comp',hdl_winorig,status,lin_comp);
                wwaiting('off',win_dw1dcomp);
        elseif  status==0
                dw1dmngr('return_comp',hdl_winorig,status);
        else

        end
        out1 = status;

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('dw1dcomp','Unknown Option','msg');
        error('*');
end
