function out1 = dw1ddeno(option,in2,in3,in4,in5)
%DW1DDENO Wavelet 1D de-noising.
%       out1 = dw1ddeno(option,in2,in3,in4,in5)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:07:49 $
                       
%       Uses WMEMTOOL.

global  Machine                         ...
        Def_Btn_Height  Def_Btn_Width   ...
        Pop_Min_Width   X_Graph_Ratio   ...
        X_Spacing       Y_Spacing       ...
        Def_TxtBkColor  Def_EdiBkColor  ...
        Def_FraBkColor  Def_FraFgColor

if nargin==0, option = 'create'; end

% MemBloc1 of stored values.
%---------------------------
n_param_anal    = 'DWAn1d_Par_Anal';
ind_sig_name    =  1;
ind_sig_size    =  2;
ind_wav_name    =  3;
ind_wav_len     =  4;
ind_lev_anal    =  5;
ind_axe_ref     =  6;
ind_act_option  =  7;
ind_ssig_type   =  8;
nb1_stored      =  8;

% MemBloc2 of stored values.
%---------------------------
n_coefs_longs   = 'Coefs_and_Longs';
ind_coefs       = 1;
ind_longs       = 2;
nb2_stored      = 2;

% MemBloc3 of stored values.(Local Bloc)
%---------------------------------------
n_miscella_loc  = 'DWDeno1D_Misc';
ind_hdls_lev    = 1;
ind_hdls_uiauto = 2;
ind_hdls_uivisu = 3;
ind_status      = 4;
ind_hdl_winorig = 5;
nb3_stored      = 5;

% Tag property of objects.
%-------------------------
tag_cmd_frame   = 'Cmd_Frame';
tag_meth_val    = 'Meth_Val';
tag_noise_val   = 'Noise_Val';
tag_txt_mth     = 'Txt_mode_th';
tag_pop_mv      = 'Pop_ModeVal';
tag_lin_orig    = 'Lin_orig';
tag_lin_deno    = 'Lin_deno';
tag_thres_up    = 'Auto_Thresh_Up';
tag_thres_down  = 'Auto_Thresh_Down';
tag_manthr_up   = 'Man_Thresh_Up';
tag_manthr_down = 'Man_Thresh_Down';
tag_axe_right_1 = 'axe_right_1';
tag_axe_right_2 = 'axe_right_2';
tag_axe_right_3 = 'axe_right_3';

% Tag property of objects (main window).
%---------------------------------------
tag_pop_viewm   = 'View_Mode';
tag_img_cfs     = 'Img_Cfs';
tag_img_sep     = 'Img_Sep';

%*****************************************************************%
%** OPTION = 'create' - constructs the initial dw1ddeno window  **%
%*****************************************************************%
if strcmp(option,'create')

        % Calling figure.
        %----------------
        win_dw1dtool     = in2;
        str_win_dw1dtool = int2str(win_dw1dtool);

        % Window initialization.
        %----------------------
        win_name = 'Wavelet 1-D  --  De-noising';
        [win_dw1ddeno,pos_win,cba_close_menu] = ...
                wfigcrea('create',NaN,win_name,'',win_dw1dtool,3,...
                                str2mat('dw1ddeno','cond'));
        str_win_dw1ddeno = int2str(win_dw1ddeno);
        win_units = 'pixels';
        out1      = win_dw1ddeno;

        % Command frame and Dynamical visualization tool construction.
        %-------------------------------------------------------------
        [frame0,pos_frame0,Pos_Graphic_Area] = ...
                        wfigcrea('frame',win_dw1ddeno,'dynv','title');

        % Waiting Frame construction & begin waiting.
        %--------------------------------------------
        wwaiting('create',win_dw1ddeno,X_Graph_Ratio,...
                        'Wait ... initialization');

        % Getting global variables from dw1dtool figure memory block.
        %------------------------------------------------------------
        [Sig_Name,Wav_Name,Lev_Anal,Sig_Size] = ...
                        wmemtool('rmb',win_dw1dtool,n_param_anal,       ...
                                ind_sig_name,ind_wav_name,              ...
                                ind_lev_anal,ind_sig_size);
        [Wav_Fam,Wav_Num] = wavattrb('fam_num',Wav_Name);
        [coefs,longs]   = wmemtool('rmb',win_dw1dtool,n_coefs_longs,    ...
                                                ind_coefs,ind_longs);

        % General graphical parameters initialization.
        %--------------------------------------------

        % Borders and double borders.
        dx  = X_Spacing;  dx2 = 2*dx;
        dy  = Y_Spacing;  dy2 = 2*dy;

        % X init position and width of frames.
        x_frame0        = pos_frame0(1);
        cmd_width       = pos_frame0(3);
        h_frame0        = pos_frame0(4);

        % Buttons width
        push_width      = (cmd_width-4*dx)/2;
        txt_width       = Def_Btn_Width;
        pop_width       = Pop_Min_Width;

        % Parameters initialization.
        %---------------------------
        default_nbcolors = 128;
        btn_height = Def_Btn_Height;
        
        % Position property of objects.
        %------------------------------
        pos_input_txt   = [     x_frame0+dx2                            ,...
                                h_frame0-3*dy-Def_Btn_Height            ,...
                                txt_width                               ,...
                                Def_Btn_Height                          ];
        pos_input_data  = [     pos_input_txt(1)+pos_input_txt(3)+dx    ,...
                                pos_input_txt(2)                        ,...
                                2*pop_width                             ,...
                                Def_Btn_Height                          ];
        pos_wav_txt     = pos_input_txt;
        pos_wav_txt(2)  = pos_input_txt(2)-Def_Btn_Height-dy2;
        pos_wav_fams    = [     pos_wav_txt(1)+pos_wav_txt(3)+dx        ,...
                                pos_wav_txt(2)                          ,...
                                pop_width                               ,...
                                Def_Btn_Height                          ];
        pos_wav_nums    = [     pos_wav_fams(1)+pos_wav_fams(3)+dx/2    ,...
                                pos_wav_fams(2)                         ,...
                                pop_width-dx/2                          ,...
                                Def_Btn_Height                          ];
        pos_lev_txt     = pos_wav_txt;
        pos_lev_txt(2)  = pos_wav_txt(2)-Def_Btn_Height-dy2;
        pos_lev_data    = [     pos_lev_txt(1)+pos_lev_txt(3)+dx        ,...
                                pos_lev_txt(2)                          ,...
                                pop_width                               ,...
                                Def_Btn_Height                          ];

        % Inside frame 2.

        px              = x_frame0+(cmd_width-13*txt_width/5)/2;
        pos_mode_val    = [     px                                      ,...
                                pos_lev_txt(2)-2*Def_Btn_Height         ,...
                                13*txt_width/5                          ,...
                                3*Def_Btn_Height/2                      ];
        px              = x_frame0+(cmd_width-5*txt_width/2)/2;
        pos_meth_txt    = [     px                                      ,...
                                pos_mode_val(2)-3*Def_Btn_Height/2      ,...
                                5*txt_width/2                           ,...
                                Def_Btn_Height                          ];
        pos_meth_val    = [     px                                      ,...
                                pos_meth_txt(2)-3*Def_Btn_Height/2      ,...
                                5*txt_width/2                           ,...
                                Def_Btn_Height                          ];
        pos_noise_txt   = [     px                                      ,...
                                pos_meth_val(2)-3*Def_Btn_Height/2      ,...
                                5*txt_width/2                           ,...
                                Def_Btn_Height                          ];
        pos_noise_val   = [     px                                      ,...
                                pos_noise_txt(2)-3*Def_Btn_Height/2     ,...
                                5*txt_width/2                           ,...
                                Def_Btn_Height                          ];
        pos_lev_title   = [     x_frame0+dx                             ,...
                                pos_mode_val(2)-3*Def_Btn_Height/2      ,...
                                cmd_width-4*dx                           ,...
                                Def_Btn_Height                          ];
        pos_auto_deno   = [     x_frame0+(cmd_width-3*push_width/2)/2    ,...
                                pos_noise_val(2)-3*Def_Btn_Height       ,...
                                3*push_width/2                          ,...
                                2*Def_Btn_Height                        ];
        py              = pos_lev_title(2)-Lev_Anal*(btn_height+dy2);

        Screen_Size = get(0,'ScreenSize');
        if      Screen_Size(4)<600
                hvisu   = Def_Btn_Height;
                hclose  = Def_Btn_Height;
        elseif  Screen_Size(4)<700
                hvisu   = 3*Def_Btn_Height/2;
                hclose  = 3*Def_Btn_Height/2;
        else
                hvisu   = 2*btn_height;
                hclose  = 3*Def_Btn_Height/2;
        end
        py              = py - Def_Btn_Height-hvisu;

        pos_visu_deno   = [     x_frame0+(cmd_width-3*push_width/2)/2    ,...
                                py                                      ,...
                                3*push_width/2                          ,...
                                hvisu                                   ];
        px              = x_frame0+(cmd_width-7*push_width/4)/2;
        pos_close       = [     px                                      ,...
                                pos_frame0(2)+Def_Btn_Height            ,...
                                7*push_width/4                          ,...
                                hclose                                  ];

        % String property of objects.
        %----------------------------
        str_input_txt   = 'Signal';
        str_input_data  = Sig_Name;
        str_wav_txt     = 'Wavelet';
        str_wav_fams    = Wav_Fam;
        str_wav_nums    = Wav_Num;
        str_lev_txt     = 'Level';
        str_lev_data    = int2str(Lev_Anal);
        str_mode_val    = str2mat(      'Automatic soft thresholding',...
                                        'Automatic hard thresholding',...
                                        'Manual soft thresholding',...
                                        'Manual hard thresholding');
        str_meth_txt    = 'Select thresholding method';
        str_meth_val    = str2mat(...
                                        'Fixed form threshold',...
                                        'Rigorous SURE',...
                                        'Heuristic SURE',...
                                        'Minimax'...
                                        );
        str_noise_txt   = 'Select noise structure';
        str_noise_val   = str2mat(...
                                        'Unscaled white noise',...
                                        'Scaled white noise',...
                                        'Non-white noise'...
                                        );
        str_lev_title   = 'Level       Select           Threshold';
        str_denoise     = 'De-noise';
        str_close       = 'Close';

        % Command part construction of the window.
        %-----------------------------------------
        txt_input_txt   = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_input_txt,...
                                        'String',str_input_txt,...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
        txt_input_data  = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_input_data,...
                                        'String',str_input_data,...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        txt_wav_txt     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_wav_txt,...
                                        'String',str_wav_txt,...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
        txt_wav_fams    = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_wav_fams,...
                                        'String',str_wav_fams,...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        if ~isempty(str_wav_nums)
        txt_wav_nums    = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_wav_nums,...
                                        'String',str_wav_nums,...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        end
        txt_lev_txt     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_lev_txt,...
                                        'String',str_lev_txt,...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
        txt_lev_data    = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_lev_data,...
                                        'String',str_lev_data,...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        drawnow

        pop_mode_val    = uicontrol(...
                                        'Style','Popup',...
                                        'Unit',win_units,...
                                        'Position',pos_mode_val,...
                                        'Userdata',1,...
                                        'String',str_mode_val,...
                                        'tag',tag_pop_mv ...
                                        );
        txt_lev_title   = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'Position',pos_lev_title,...
                                        'String',str_lev_title,...
                                        'HorizontalAlignment','left',...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
        wx              = (cmd_width-5*txt_width/2)/4;
        xbtn0           = x_frame0+wx;
        ybtn0           = pos_lev_title(2)-Def_Btn_Height-dy2;
        xbtn            = xbtn0;
        ybtn            = ybtn0;
                
        Sig_Anal        = dw1dfile('sig',win_dw1dtool,1);

        [thr_i,sorh,keepapp]    = ddencmp('den','wv',Sig_Anal);

        %%%% B.M. Strategy %%%%
        alpha = 3;
        thr = wdcbm(coefs,longs,alpha);
        %%%%%%%%%%%%%%%%%%%%%%%

        hdls_lev        = zeros(6,Lev_Anal);
        for i=Lev_Anal:-1:1
                max_lev_i       = max(abs(detcoef(coefs,longs,i)));
                % val_lev_i     = min(max_lev_i,thr_i);

                %%%% B.M. Strategy %%%%
                val_lev_i       = min(max_lev_i,thr(i));
                %%%%%%%%%%%%%%%%%%%%%%%

                pos_lev_i       = [xbtn ybtn 2*txt_width/6 btn_height];
                str_lev_i       = int2str(i);
                txt_lev_i       = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'Position',pos_lev_i,...
                                        'String',str_lev_i,...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
                xbtn            = xbtn+2*txt_width/6+wx;
                pos_lev_i       = [     xbtn                            ,...
                                        ybtn+btn_height/4               ,...
                                        7*txt_width/6                   ,...
                                        btn_height/2                    ];
                sli_lev_i       = uicontrol(...
                                        'Style','Slider',...
                                        'Unit',win_units,...
                                        'Position',pos_lev_i,...
                                        'Min',0,...
                                        'Max',max_lev_i,...
                                        'Value',val_lev_i...
                                        );
                xbtn            = xbtn+7*txt_width/6+wx;
                pos_lev_i       = [xbtn ybtn txt_width btn_height];
                str_def_lev_i   = sprintf('%1.4g',val_lev_i);
                txt_val_i       = uicontrol(...
                                        'Style','Edit',...
                                        'Unit',win_units,...
                                        'Position',pos_lev_i,...
                                        'String',str_def_lev_i,...
                                        'HorizontalAlignment','center',...
                                        'Backgroundcolor',Def_EdiBkColor...
                                        );

                cba_sli         = ['dw1ddeno(''update_sellev'',' ...
                                        str_win_dw1ddeno ',' ...
                                        str_win_dw1dtool ',' ...
                                        str_lev_i ',''sli'');'];
                cba_edi         = ['dw1ddeno(''update_sellev'',' ...
                                        str_win_dw1ddeno ',' ...
                                        str_win_dw1dtool ',' ...
                                        str_lev_i ',''edi'');'];

                set(sli_lev_i,'Callback',cba_sli);
                set(txt_val_i,'Callback',cba_edi);

                hdls_lev(1,i) = txt_lev_i;
                hdls_lev(2,i) = sli_lev_i;
                hdls_lev(3,i) = txt_val_i;
                xbtn = xbtn0;
                ybtn = ybtn-btn_height-dy2;
        end
        drawnow('discard')

        pus_visu_deno   = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_visu_deno,...
                                        'String',str_denoise,...
                                        'Visible','off'...
                                        );
        pus_close       = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_close,...
                                        'String',str_close,...
                                        'Interruptible','yes'...
                                        );

        % Manual thresholding objects handles.
        %-------------------------------------
        hdls_uivisu = hdls_lev(1:3,:);
        hdls_uivisu = [ txt_lev_title
                        hdls_uivisu(:)
                        pus_visu_deno];
        set(hdls_uivisu,'Visible','off');
        drawnow

        txt_meth_txt    = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'Position',pos_meth_txt,...
                                        'String',str_meth_txt,...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
        pop_meth_val    = uicontrol(...
                                        'Style','Popup',...
                                        'Unit',win_units,...
                                        'Position',pos_meth_val,...
                                        'String',str_meth_val,...
                                        'HorizontalAlignment','center',...
                                        'Userdata',1,...
                                        'Tag',tag_meth_val...
                                        );
        txt_noise_txt   = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'Position',pos_noise_txt,...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'String',str_noise_txt...
                                        );
        pop_noise_val   = uicontrol(...
                                        'Style','Popup',...
                                        'Unit',win_units,...
                                        'Position',pos_noise_val,...
                                        'String',str_noise_val,...
                                        'HorizontalAlignment','center',...
                                        'Userdata',1,...
                                        'Tag',tag_noise_val...
                                        );
        pus_auto_deno   = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_auto_deno,...
                                        'String',str_denoise...
                                        );
        drawnow

        % Callbacks update.
        %------------------
        str_pop_mode_val= num2mstr(pop_mode_val);
        cba_mode_val    = ['dw1ddeno(''mode'',' ...
                                str_win_dw1ddeno ',' ...
                                str_pop_mode_val ');'];
        cba_denoise     = ['dw1ddeno(''denoise'',' ...
                                str_win_dw1ddeno ',' ...
                                str_win_dw1dtool ',' ...
                                str_pop_mode_val ');'];
        cba_upd_thr1    = ['dw1ddeno(''update_thresh'',' ...
                                str_win_dw1ddeno ',' ...
                                str_win_dw1dtool ',1);'];
        cba_upd_thr2    = ['dw1ddeno(''update_thresh'',' ...
                                str_win_dw1ddeno ',' ...
                                str_win_dw1dtool ',2);'];

        set(pop_meth_val,'Callback',cba_upd_thr1);
        set(pop_noise_val,'Callback',cba_upd_thr2);
        set(pop_mode_val,'Callback',cba_mode_val);
        set(pus_auto_deno,'Callback',cba_denoise);
        set(pus_visu_deno,'Callback',cba_denoise);
        set(pus_close,'Callback',cba_close_menu);

        % Automatic thresholding objects handles.
        %----------------------------------------
        hdls_uiauto = [ txt_meth_txt
                        pop_meth_val
                        txt_noise_txt
                        pop_noise_val
                        pus_auto_deno];

        % General graphical parameters initialization.
        %--------------------------------------------
        bdx             = 0.08*pos_win(3);
        bdy             = 0.06*pos_win(4);
        ecy             = 0.03*pos_win(4);
        y_graph         = 2*Def_Btn_Height+dy;
        h_graph         = pos_frame0(4)-y_graph;
        w_graph         = pos_frame0(1);

        if Lev_Anal > 9
                if Screen_Size(4)<600
                        fontsize = 12;
                else
                        fontsize = 14;
                end
        else
                if Screen_Size(4)<600
                        fontsize = 14;
                else
                        fontsize = 16;
                end
        end

        % Axes construction parameters.
        %------------------------------
        w_left          = (w_graph-3*bdx)/2;
        x_left          = bdx;
        w_right         = w_left;
        x_right         = x_left+w_left+5*bdx/4;
        n_axeleft       = Lev_Anal;
        n_axeright      = 3;
        ind_left        = n_axeleft;
        ind_right       = n_axeright;

        % Vertical separation.
        %---------------------
        w_fra   = 0.01*pos_win(3);
        x_fra   = (w_graph-w_fra)/2;
        uicontrol(...
                        'Style','frame',...
                        'Unit',win_units,...
                        'Position',[x_fra,y_graph,w_fra,h_graph],...
                        'Backgroundcolor',Def_FraBkColor,...
                        'Tag','Dw1ddeno_obj'...
                        );

        % Building axes on the right part.
        %---------------------------------
        ecy_right = 2*ecy;
        h_right =(h_graph-2*bdy-(n_axeright-1)*ecy_right)/n_axeright;
        y_right = y_graph+bdy;
        axe_right = zeros(1,n_axeright);
        pos_right = [x_right y_right w_right h_right];
        for k = 1:n_axeright
                axe_right(k) = axes(...
                                'Units',win_units,...
                                'Position',pos_right,...
                                'Drawmode','fast',...
                                'Box','On',...
                                'Tag',['axe_right_' int2str(k)]...
                                );
                pos_right(2) = pos_right(2)+pos_right(4)+ecy_right;
        end
        set(axe_right(1),'visible','off');

        % Displaying the signal.
        %-----------------------
        axes(axe_right(3))
        curr_color      = dw1dcolo('sig');
        hdl_sig = line(1:length(Sig_Anal),Sig_Anal,'erasemode','none',...
                        'Color',curr_color,'tag',tag_lin_orig);
        title('Original signal');       
        xaxis = [1              Sig_Size];
        yaxis = [min(Sig_Anal)  max(Sig_Anal)];
        if xaxis(1)==xaxis(2)
                xaxis = xaxis+[-0.000001 0.000001];
        end
        if yaxis(1)==yaxis(2)
                yaxis = yaxis+[-0.000001 0.000001];
        end
        set(axe_right(3),'Xlim',xaxis,'Ylim',yaxis);

        % Displaying original details coefficients.
        %------------------------------------------
        pop_viewm       = findobj(win_dw1dtool,'tag',tag_pop_viewm);
        view_m_orig     = get(pop_viewm,'Value');
        if      view_m_orig==1
                img_cfs = findobj(win_dw1dtool,'tag',tag_img_cfs);
        elseif  view_m_orig==2
                img_cfs = [];
        elseif  view_m_orig==3
                img_cfs = findobj(win_dw1dtool,'tag',tag_img_sep);
        elseif  view_m_orig==4
                img_cfs = findobj(win_dw1dtool,'tag',tag_img_cfs);
        end
        colormap(get(win_dw1dtool,'Colormap'));
        [details,set_ylim,ymin,ymax] = dw1dfile('cfs_beg',win_dw1dtool,...
                        [1:Lev_Anal],1);
        [nul,i_min] = min(abs(details(:)));
        if ~isempty(img_cfs)
                col_cfs = get(img_cfs,'Cdata');
        else
                col_cfs =  wcodemat(details,default_nbcolors,'row',1);
        end
        col_min = col_cfs(i_min);

        axes(axe_right(2));
        [nbrow,nbcol]   = size(col_cfs);
        if nbrow>1 , rmin = 1; else rmin = 0; end
        hdl_cfs_orig = image([1 nbcol],[nbrow rmin],col_cfs,'Userdata',col_min);
        clear col_cfs
        levlab = int2str(1);
        for k = 2:Lev_Anal ,levlab = str2mat(levlab,int2str(k)); end
        set(axe_right(2),...
                        'Userdata',hdl_cfs_orig,...
                        'Xlim',[1 Sig_Size],...
                        'YTicklabelMode','manual',...
                        'YTick',[1:Lev_Anal],...
                        'YTickLabels',levlab,...
                        'Tag',tag_axe_right_2);

        title('Original coefficients');
        ylabel('Level number','Fontsize',10);
        set(axe_right(1),...
                        'Xlim',get(axe_right(2),'Xlim'),...
                        'Ylim',get(axe_right(2),'Ylim'));

        % Building axes on the left part.
        %--------------------------------
        ecy_left        = ecy/2;
        h_left          = (h_graph-2*bdy-(n_axeleft-1)*ecy_left)/n_axeleft;
        y_left          = y_graph+0.75*bdy;

        axe_left        = zeros(1,n_axeleft);
        pos_left        = [x_left y_left w_left h_left];
        for k = 1:n_axeleft
                if k==1
                        axe_left(k) = axes(...
                                        'Units',win_units,...
                                        'Position',pos_left,...
                                        'Drawmode','fast',...
                                        'Box','On'...
                                        );
                else
                        axe_left(k) = axes(...
                                        'Units',win_units,...
                                        'Position',pos_left,...
                                        'XTicklabelMode','manual',...
                                        'XTickLabels',[],...
                                        'Drawmode','fast',...
                                        'Box','On'...
                                        );
                end
                pos_left(2) = pos_left(2)+pos_left(4)+ecy_left;
        end
        set(axe_left(n_axeleft),'Tag','Axe_Left_Max')

        % Displaying details.
        %-------------------
        col_det         = dw1dcolo('det',Lev_Anal);
        txt_left        = ones(Lev_Anal,1);
        str_methval     = str2mat(...
                                'sqtwolog',...
                                'rigrsure',...
                                'heursure',...
                                'minimaxi'...
                                );
        str_noiseval    = str2mat(...
                                'sln',...
                                'one',...
                                'mln'...
                                );
        tptr            = str_methval(get(pop_meth_val,'value'),:);
        scal            = str_noiseval(get(pop_noise_val,'value'),:);
        auto_thr        = thrwda1d(coefs,longs,tptr,scal,Lev_Anal);
        for k = Lev_Anal:-1:1
                axes(axe_left(ind_left));
                hdls_lev(4,k) = line('Xdata',1:Sig_Size,...
                                        'Ydata',details(k,:),...
                                        'Color',col_det(k,:));
                a_thr   = str2num(get(hdls_lev(3,k),'string'));
                hdls_lev(5,k) = line('Linestyle','--',...
                        'Color','y',...
                        'EraseMode','xor',...
                        'Tag',tag_manthr_up,...
                        'Visible','off',...
                        'Xdata',[1 Sig_Size],...
                        'Ydata',[a_thr a_thr]);
                hdls_lev(6,k) = line('Linestyle','--',...
                        'Color','y',...
                        'EraseMode','xor',...
                        'Tag',tag_manthr_down,...
                        'Visible','off',...
                        'Xdata',[1 Sig_Size],...
                        'Ydata',[-a_thr -a_thr]);
                m_thr   = min(auto_thr(k),max(abs(details(k,:))));
                line(   'Linestyle','--',...
                        'Color','y',...
                        'EraseMode','xor',...
                        'Tag',tag_thres_up,...
                        'Userdata',k,...
                        'Xdata',[1 Sig_Size],...
                        'Ydata',[m_thr m_thr]);
                line(   'Linestyle','--',...
                        'Color','y',...
                        'EraseMode','xor',...
                        'Tag',tag_thres_down,...
                        'Userdata',k,...
                        'Xdata',[1 Sig_Size],...
                        'Ydata',[-m_thr -m_thr]);
                txt_left(k) = txtinaxe('create',['d' int2str(k)],...
                                        axe_left(k),'left',...
                                        'on','bold',fontsize);

                maxi = max([m_thr,abs(ymax(k)),abs(ymin(k))]);
                if abs(maxi)<eps , maxi = maxi+0.0001; end;
                yec = 0.1*maxi;
                yaxis = [-maxi-yec maxi+yec];

                set(axe_left(ind_left),'Xlim',xaxis,'Ylim',yaxis);
                ind_left = ind_left-1;
        end
        axes(axe_left(Lev_Anal))
        title('Original details coefficients');
        wtxttitl(axe_left(Lev_Anal),'Automatic soft thresholding',tag_txt_mth);

        % Axes attachment.
        %-----------------
        axe_cmd = [axe_right(3) axe_left(1:n_axeleft)];
        axe_act = [axe_right(1:2)];
        dynvtool('attach',win_dw1ddeno,[],axe_cmd,axe_act,[1 0],'','','');
        dynvtool('put',win_dw1ddeno);

        % Memory blocks update.
        %----------------------
        wmemtool('ini',win_dw1ddeno,n_miscella_loc,nb3_stored);
        wmemtool('wmb',win_dw1ddeno,n_miscella_loc,                     ...
                                        ind_hdls_lev,hdls_lev,          ...
                                        ind_hdls_uiauto,hdls_uiauto,    ...
                                        ind_hdls_uivisu,hdls_uivisu,    ...
                                        ind_status,0,                   ...
                                        ind_hdl_winorig,win_dw1dtool    ...
                                        );

        % Setting units to normalized.
        %-----------------------------
        set(findobj(win_dw1ddeno,'Units','pixels'),'Units','Normalized');

        % End waiting.
        %-------------
        drawnow
        wwaiting('off',win_dw1ddeno);

%*************************************%
%** OPTION = 'denoise' - DE-NOISING **%
%*************************************%
elseif strcmp(option,'denoise')
        win_dw1ddeno    = in2;
        win_dw1dtool    = in3;
        if nargin==4
                pop_mode_val = in4;
        else
                pop_mode_val = findobj(win_dw1ddeno,'tag',tag_pop_mv);
        end

        % Waiting message.
        %-----------------
        wwaiting('msg',win_dw1ddeno,'Wait ... computing');

        % Handles of tagged objects.
        %---------------------------
        axe_handles     = findobj(win_dw1ddeno,'Type','axes');
        axe_right_1     = findobj(axe_handles,'flat','Tag',tag_axe_right_1);
        axe_right_2     = findobj(axe_handles,'flat','Tag',tag_axe_right_2);
        axe_right_3     = findobj(axe_handles,'flat','Tag',tag_axe_right_3);
        pop_handles     = findobj(win_dw1ddeno,'Style','popupmenu');
        pop_meth_val    = findobj(pop_handles,'Tag',tag_meth_val);
        pop_noise_val   = findobj(pop_handles,'Tag',tag_noise_val);

        % Setting the de-noised coefs axes invisible.
        %--------------------------------------------
        lin_denosig     = get(axe_right_3,'userdata');
        if ~isempty(lin_denosig)
                vis     = get(lin_denosig,'Visible');
                if vis(1:2)=='on'
                        mngaxe('vis',axe_right_1,'off');
                        axes(axe_right_3);
                        title('Original signal');
                        set(lin_denosig,'Visible','off');
                end
        end
        drawnow

        % Getting memory blocks.
        %-----------------------
        [Wav_Name,Lev_Anal,Sig_Size] = ...
                        wmemtool('rmb',win_dw1dtool,n_param_anal, ...
                                        ind_wav_name,ind_lev_anal,ind_sig_size);
        [coefs,longs]   = wmemtool('rmb',win_dw1dtool,n_coefs_longs,    ...
                                                ind_coefs,ind_longs);

        % De-noising depending on the selected thresholding mode.
        %--------------------------------------------------------
        mode_val        = get(pop_mode_val,'value');
        str_sorh        = ['s' 'h' 's' 'h'];
        sorh            = str_sorh(mode_val);
        if mode_val==1 | mode_val==2
                str_meth_val    = str2mat(...
                                        'sqtwolog',...
                                        'rigrsure',...
                                        'heursure',...
                                        'minimaxi'...
                                        );
                str_noise_val   = str2mat(...
                                        'sln',...
                                        'one',...
                                        'mln'...
                                        );
                tptr    = str_meth_val(get(pop_meth_val,'value'),:);
                scal    = str_noise_val(get(pop_noise_val,'value'),:);
                [xc,cxc,lxc] = wden(coefs,longs,tptr,...
                                        sorh,scal,Lev_Anal,Wav_Name);
        else
                hdls_lev        = wmemtool('rmb',win_dw1ddeno,n_miscella_loc,...
                                                        ind_hdls_lev);
                threshold       = zeros(1,Lev_Anal);
                for     i=1:Lev_Anal
                        threshold(i) = get(hdls_lev(2,i),'value');
                end
                [xc,cxc,lxc] = wdencmp('lvd',coefs,longs,...
                                            Wav_Name,Lev_Anal,threshold,sorh);
        end

        % Displaying denoised signal.
        %----------------------------
        axes(axe_right_3);
        hdl_denosig = get(axe_right_3,'userdata');
        if ~isempty(hdl_denosig)
                set(hdl_denosig,'Ydata',xc);
                set(hdl_denosig,'Visible','on');
        else
                curr_color      = dw1dcolo('ssig');
                hdl_denosig     = line(1:length(xc),xc,'color',curr_color,...
                                                'tag',tag_lin_deno);
                set(axe_right_3,'userdata',hdl_denosig)
        end     
        title('Original and de-noised signals');

        % Displaying thresholded details coefficients.
        %---------------------------------------------
        axes(axe_right_1);
        col_cfs         = zeros(Lev_Anal,Sig_Size);
        for k = 1:Lev_Anal
                x               = detcoef(cxc,lxc,k);
                x               = x(ones(1,2^k),:);
                x               = x(:)';                
                col_cfs(k,:)    = wkeep(x,Sig_Size);            
        end
        clear x
        nz_cfs          = find(col_cfs~=0);
        [nbrow,nbcol]   = size(col_cfs);
        hdl_img_cfs     = get(axe_right_2,'Userdata');
        col_min         = get(hdl_img_cfs,'Userdata');
        col_cfs_orig    = get(hdl_img_cfs,'Cdata');
        col_cfs         = col_min*ones(nbrow,nbcol);
        col_cfs(nz_cfs) = col_cfs_orig(nz_cfs);

        if nbrow>1 , rmin = 1; else rmin = 0; end
        image([1 nbcol],[nbrow rmin],col_cfs);
        levlab = int2str(1);
        for k = 2:Lev_Anal ,levlab = str2mat(levlab,int2str(k)); end
        set(axe_right_1,...
                        'Xlim',get(axe_right_2,'Xlim'),...
                        'YTicklabelMode','manual',...
                        'YTick',[1:Lev_Anal],...
                        'YTickLabels',levlab,...
                        'Tag',tag_axe_right_1);
        title('Thresholded coefficients');
        ylabel('Level number','Fontsize',10);
        mngaxe('vis',axe_right_1,'on');

        % Memory blocks update.
        %----------------------
        wmemtool('wmb',win_dw1ddeno,n_miscella_loc,ind_status,1);

        % End waiting.
        %-------------
        drawnow
        wwaiting('off',win_dw1ddeno);

%***********************************%
%** OPTION = 'mode' - MODE CHOICE **%
%***********************************%
elseif strcmp(option,'mode')
        win_dw1ddeno    = in2;
        pop_mode_val    = in3;
        mode_val        = get(pop_mode_val,'value');
        old_mode        = get(pop_mode_val,'userdata');
        if mode_val==old_mode
                return;
        else
                set(pop_mode_val,'userdata',mode_val);
        end

        % Handles of tagged objects.
        %---------------------------
        axe_handles     = findobj(win_dw1ddeno,'Type','axes');
        lin_handles     = findobj(axe_handles,'Type','line');
        axe_right_1     = findobj(axe_handles,'flat','Tag',tag_axe_right_1);
        axe_right_3     = findobj(axe_handles,'flat','Tag',tag_axe_right_3);
        axe_left_max    = findobj(axe_handles,'flat','Tag','Axe_Left_Max');
        man_thr_up      = findobj(lin_handles,'Tag',tag_manthr_up);
        man_thr_down    = findobj(lin_handles,'Tag',tag_manthr_down);
        auto_thr_up     = findobj(lin_handles,'Tag',tag_thres_up);
        auto_thr_down   = findobj(lin_handles,'Tag',tag_thres_down);
        txt_mth         = findobj(axe_left_max,'tag',tag_txt_mth);

        % Getting memory blocks.
        %-----------------------
        [hdls_uiauto,hdls_uivisu] = ...
                        wmemtool('rmb',win_dw1ddeno,n_miscella_loc,...
                                        ind_hdls_uiauto,ind_hdls_uivisu);

        % Changing mode.
        %---------------
        dynvtool('get',win_dw1ddeno,0);
        if mode_val==1 | mode_val==2
                set(hdls_uivisu,'Visible','off')
                set(hdls_uiauto,'Visible','on')
                set(man_thr_up,'Visible','off')
                set(man_thr_down,'Visible','off')
                set(auto_thr_up,'Visible','on')
                set(auto_thr_down,'Visible','on')
                axes(axe_left_max)
                if mode_val==2
                        set(txt_mth,'string','Automatic hard thresholding');
                else
                        set(txt_mth,'string','Automatic soft thresholding');
                end
        else
                set(hdls_uivisu,'Visible','on');
                set(hdls_uiauto,'Visible','off');
                set(man_thr_up,'Visible','on')
                set(man_thr_down,'Visible','on')
                set(auto_thr_up,'Visible','off')
                set(auto_thr_down,'Visible','off')
                axes(axe_left_max)
                if mode_val==4
                        set(txt_mth,'string','Manual hard thresholding');
                else
                        set(txt_mth,'string','Manual soft thresholding');
                end
        end

        hdl_denosig = get(axe_right_3,'userdata');
        if ~isempty(hdl_denosig)
                axes(axe_right_3);
                set(hdl_denosig,'Visible','off');
                title('Original signal');       
                mngaxe('vis',axe_right_1,'off');
        end

        % Memory blocks update.
        %----------------------
        wmemtool('wmb',win_dw1ddeno,n_miscella_loc,ind_status,0);

%*********************************************************************%
%** OPTION = 'update_sellev' - UPDATE INFOS FOR VISUAL THRESHOLDING **%
%*********************************************************************%
elseif strcmp(option,'update_sellev')
        win_dw1ddeno    = in2;
        win_dw1dtool    = in3;
        lev_i           = in4;
        type_hdl        = in5;

        % Getting memory blocks.
        %-----------------------
        hdls_lev = wmemtool('rmb',win_dw1ddeno,n_miscella_loc,ind_hdls_lev);

        % Updating threshold.
        %---------------------
        if      strcmp(type_hdl,'sli')
                new_thresh      =  get(hdls_lev(2,lev_i),'value');
                set(hdls_lev(3,lev_i),'string',sprintf('%1.4g',new_thresh));

        elseif strcmp(type_hdl,'edi')
                valstr = get(hdls_lev(3,lev_i),'string');
                [new_thresh,count,err] = sscanf(valstr,'%f');
                if (count~=1) | ~isempty(err)
                        new_thresh = get(hdls_lev(2,lev_i),'Value');
                        set(hdls_lev(3,lev_i),'string',sprintf('%1.4g',new_thresh));
                        return
                else
                        mi = get(hdls_lev(2,lev_i),'Min');
                        ma = get(hdls_lev(2,lev_i),'Max');
                        if      new_thresh<mi , new_thresh = mi;
                        elseif  new_thresh>ma , new_thresh = ma;
                        end
                        set(hdls_lev(2,lev_i),'Value',new_thresh);
                        set(hdls_lev(3,lev_i),'string',sprintf('%1.4g',new_thresh));
                end
        end
        
        % Handles of tagged objects.
        %---------------------------
        axe_handles     = findobj(win_dw1ddeno,'Type','axes');
        axe_right_1     = findobj(axe_handles,'flat','Tag',tag_axe_right_1);
        axe_right_3     = findobj(axe_handles,'flat','Tag',tag_axe_right_3);

        % Setting the de-noised coefs axes invisible.
        %--------------------------------------------
        lin_denosig     = get(axe_right_3,'userdata');
        if ~isempty(lin_denosig)
                vis     = get(lin_denosig,'Visible');
                if vis(1:2)=='on'
                        mngaxe('vis',axe_right_1,'off');
                        axes(axe_right_3);
                        title('Original signal');
                        set(lin_denosig,'Visible','off');
                end
        end
        drawnow

        % Updating information.
        %----------------------
        ynew    = [new_thresh new_thresh];
        if      strcmp(Machine(1:3),'PCW')
                xval    = get(hdls_lev(5,lev_i),'Xdata');
                axe_det = get(hdls_lev(5,lev_i),'Parent');
                axes(axe_det)
                delete(hdls_lev(5:6,lev_i))
                hdls_lev(5,lev_i) = line(...
                                        'Linestyle','--',       ...
                                        'Color','y',            ...
                                        'Xdata',xval,           ...
                                        'Ydata',ynew,           ...
                                        'Tag',tag_manthr_up     ...
                                        );
                hdls_lev(6,lev_i) = line(...
                                        'Linestyle','--',       ...
                                        'Color','y',            ...
                                        'Xdata',xval,           ...
                                        'Ydata',-ynew,          ...
                                        'Tag',tag_manthr_down   ...
                                        );
                wmemtool('wmb',win_dw1ddeno,n_miscella_loc,     ...
                                ind_hdls_lev,hdls_lev           ...
                                );
        else
                set(hdls_lev(5,lev_i),'Ydata', ynew);
                set(hdls_lev(6,lev_i),'Ydata',-ynew);
        end

%************************************************************************%
%** OPTION = 'update_thresh' - UPDATE INFOS FOR AUTOMATIC THRESHOLDING **%
%************************************************************************%
elseif strcmp(option,'update_thresh')
        % in4 = 1 for meth_val and in4 = 2 for noise_val.
        %------------------------------------------------
        win_dw1ddeno    = in2;
        win_dw1dtool    = in3;
        flg_pop         = in4;
        
        % Handles of tagged objects.
        %---------------------------
        axe_handles     = findobj(win_dw1ddeno,'Type','axes');
        lin_handles     = findobj(win_dw1ddeno,'Type','line');
        pop_handles     = findobj(win_dw1ddeno,'Style','popupmenu');
        axe_right_1     = findobj(axe_handles,'flat','Tag',tag_axe_right_1);
        axe_right_3     = findobj(axe_handles,'flat','Tag',tag_axe_right_3);
        auto_thr_up     = findobj(lin_handles,'Tag',tag_thres_up);
        auto_thr_down   = findobj(lin_handles,'Tag',tag_thres_down);
        pop_meth_val    = findobj(pop_handles,'Tag',tag_meth_val);
        pop_noise_val   = findobj(pop_handles,'Tag',tag_noise_val);

        meth_val        = get(pop_meth_val,'value');
        noise_val       = get(pop_noise_val,'value');
        if flg_pop==1
                old_meth = get(pop_meth_val,'userdata');
                if old_meth==meth_val
                        return;
                else
                        set(pop_meth_val,'userdata',meth_val);
                end

        else
                old_noise = get(pop_noise_val,'userdata');
                if old_noise==noise_val
                        return;
                else
                        set(pop_noise_val,'userdata',noise_val);
                end

        end

        % Setting the de-noised coefs axes invisible.
        %--------------------------------------------
        lin_denosig     = get(axe_right_3,'userdata');
        if ~isempty(lin_denosig)
                vis     = get(lin_denosig,'Visible');
                if vis(1:2)=='on'
                        mngaxe('vis',axe_right_1,'off');
                        axes(axe_right_3);
                        title('Original signal');
                        set(lin_denosig,'Visible','off');
                end
        end
        drawnow

        % Getting memory blocks.
        %-----------------------
        Lev_Anal        = wmemtool('rmb',win_dw1dtool,n_param_anal,...
                                        ind_lev_anal);
        [coefs,longs]   = wmemtool('rmb',win_dw1dtool,n_coefs_longs,    ...
                                                ind_coefs,ind_longs);

        hdls_lev        = wmemtool('rmb',win_dw1ddeno,n_miscella_loc,...
                                                ind_hdls_lev);

        % Computing the new thresholds.
        %------------------------------
        str_methval     = str2mat(...
                                'sqtwolog',...
                                'rigrsure',...
                                'heursure',...
                                'minimaxi'...
                                );
        str_noiseval    = str2mat(...
                                'sln',...
                                'one',...
                                'mln'...
                                );
        tptr            = str_methval(meth_val,:);
        scal            = str_noiseval(noise_val,:);
        auto_thr        = thrwda1d(coefs,longs,tptr,scal,Lev_Anal);

        % Updating information.
        %----------------------
        if      strcmp(Machine(1:3),'PCW')
                xval     = get(auto_thr_up(1),'Xdata');
                delete([auto_thr_up;auto_thr_down]);
                for k = 1:Lev_Anal
                        axe_det = get(hdls_lev(4,k),'Parent');
                        axes(axe_det);
                        thr     = min(auto_thr(k),max(abs(get(hdls_lev(4,k),'Ydata'))));
                        ynew    = [thr thr];
                        line(...
                                'Linestyle','--',       ...
                                'Color','y',            ...
                                'Userdata',k,           ...
                                'Xdata',xval,           ...
                                'Ydata',ynew,           ...
                                'Tag',tag_thres_up      ...
                                );
                        line(...
                                'Linestyle','--',       ...
                                'Color','y',            ...
                                'Userdata',k,           ...
                                'Xdata',xval,           ...
                                'Ydata',-ynew,          ...
                                'Tag',tag_thres_down    ...
                                );
                end
        else
                for k = 1:Lev_Anal
                        thr      = min(auto_thr(k),max(abs(get(hdls_lev(4,k),'Ydata'))));
                        ynew     = [thr thr];
                        hdl_up   = findobj(auto_thr_up,'Userdata',k);
                        hdl_down = findobj(auto_thr_down,'Userdata',k);
                        set(hdl_up,'Ydata',ynew);
                        set(hdl_down,'Ydata',-ynew);
                end
        end

        % Memory blocks update.
        %----------------------
        wmemtool('wmb',win_dw1ddeno,n_miscella_loc,ind_status,0);

%**************************************%
%** OPTION = 'close' -  CLOSE FIGURE **%
%**************************************%
elseif strcmp(option,'close')
        win_dw1ddeno    = in2;

        [status,hdl_winorig] = wmemtool('rmb',win_dw1ddeno,n_miscella_loc,...
                                        ind_status,ind_hdl_winorig);
        if status==1

                % Test for Updating.
                %--------------------
                status = wwaitans(win_dw1ddeno,...
                                  'Update the synthesized signal ?',2,'cond');
        end

        if status==1
                wwaiting('msg',win_dw1ddeno,'Wait ... computing');
                axe_handles     = findobj(win_dw1ddeno,'Type','axes');
                lin_handles     = findobj(axe_handles,'Type','line');
                lin_deno        = findobj(lin_handles,'tag',tag_lin_deno);

                % Writing Synthesized. Signal Type.
                %----------------------------------
                wmemtool('wmb',hdl_winorig,n_param_anal,ind_ssig_type,'ds');

                dw1dmngr('return_deno',hdl_winorig,status,lin_deno);
                wwaiting('off',win_dw1ddeno);
        elseif  status==0
                dw1dmngr('return_deno',hdl_winorig,status);
        else

        end
        out1 = status;

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('dw1ddeno','Unknown Option','msg');
        error('*');
end
