function dw1ddisp(option,win_dw1dtool,in3,in4)
%DW1DDISP Discret wavelet 1D display mode options.
%       dw1ddisp(option,win_dw1dtool,in3,in4)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:07:54 $

global  Def_Btn_Height  Def_Btn_Width   Pop_Min_Width   ...
        X_Spacing       Y_Spacing       X_Graph_Ratio   ...
        Lst_ColorMap    Def_TxtBkColor  Def_EdiBkColor  ...
        Def_FraBkColor  Machine

% MemBloc1 of stored values.
%---------------------------
n_param_anal    = 'DWAn1d_Par_Anal';
ind_sig_name    =  1;
ind_sig_size    =  2;
ind_wav_name    =  3;
ind_wav_len     =  4;
ind_lev_anal    =  5;
ind_axe_ref     =  6;
ind_act_option  =  7;
ind_ssig_type   =  8;
nb1_stored      =  8;

% Tag property of objects.
%-------------------------
tag_m_windows   = 'M_Windows';
tag_pop_viewm   = 'View_Mode';
tag_pus_dispopt = 'Pus_Options';
tag_valapp_scr  = 'ValApp_Scr';
tag_valdet_scr  = 'ValDet_Scr';
tag_win_disp    = 'DispOpt1D';

% Local Tag property of objects.
%-------------------------------
tag_app_on      = 'Chk_App';
tag_s_app       = 'Chk_SA';
tag_ss_app      = 'Chk_SSA';
tag_app_num     = 'Chk_ANum';
tag_det_on      = 'Chk_Det';
tag_s_det       = 'Chk_SD';
tag_ss_det      = 'Chk_SSD';
tag_det_num     = 'Chk_DNum';
tag_cfs_on      = 'Chk_Cfs';
tag_txt_ccfs    = 'Txt_CCfs';
tag_pop_ccfs    = 'Pop_CCfs';
tag_app_txt     = 'App_Txt';
tag_app_all     = 'App_All';
tag_app_none    = 'App_None';
tag_det_txt     = 'Det_Txt';
tag_det_all     = 'Det_All';
tag_det_none    = 'Det_None';

if      strcmp(option,'chk_sel')
        % in3 = chk_value
        % in4 = 'a' or 'd'
        %------------------
        chk_handles     = findobj(win_dw1dtool,'Style','checkbox');
        chk             = findobj(chk_handles,'tag',in4);
        set(chk,'Value',in3);
        return

elseif  strcmp(option,'app_on')
        % in3 = num mode
        %------------------
        chk_handles     = findobj(win_dw1dtool,'Style','checkbox');
        chk_on          = findobj(chk_handles,'tag',tag_app_on);
        chk_sa          = findobj(chk_handles,'tag',tag_s_app);
        chk_ssa         = findobj(chk_handles,'tag',tag_ss_app);
        if in3==4
                pus_handles     = findobj(win_dw1dtool,'Style','pushbutton');
                txt_handles     = findobj(win_dw1dtool,'Style','text');
                pall            = findobj(pus_handles,'tag',tag_app_all);
                pnone           = findobj(pus_handles,'tag',tag_app_none);
                txt             = findobj(txt_handles,'tag',tag_app_txt);
                chk_app         = findobj(chk_handles,'tag',tag_app_num);
        else
                pall = [];      pnone = [];     txt = [];       chk_app = [];
        end
        if  get(chk_on,'Value')==1
                set([chk_sa ; chk_ssa ; pall ; pnone ; txt ; chk_app]...
                                        ,'Visible','on');
        else
                set([chk_sa ; chk_ssa ; pall ; pnone ; txt ; chk_app]...
                                        ,'Visible','off');
        end
        return

elseif  strcmp(option,'det_on')
        % in3 = num mode
        %------------------
        chk_handles     = findobj(win_dw1dtool,'Style','checkbox');
        chk_on          = findobj(chk_handles,'tag',tag_det_on);
        chk_sd          = findobj(chk_handles,'tag',tag_s_det);
        chk_ssd         = findobj(chk_handles,'tag',tag_ss_det);
        if in3==4
                pus_handles     = findobj(win_dw1dtool,'Style','pushbutton');
                txt_handles     = findobj(win_dw1dtool,'Style','text');
                pall            = findobj(pus_handles,'tag',tag_det_all);
                pnone           = findobj(pus_handles,'tag',tag_det_none);
                txt             = findobj(txt_handles,'tag',tag_det_txt);
                chk_det         = findobj(chk_handles,'tag',tag_det_num);
        else
                pall = [];      pnone = [];     txt = [];       chk_det = [];
        end
        if  get(chk_on,'Value')==1
                set([chk_sd ; chk_ssd ; pall ; pnone ; txt ; chk_det]...
                                        ,'Visible','on');
        else
                set([chk_sd ; chk_ssd ; pall ; pnone ; txt ; chk_det]...
                                        ,'Visible','off');
        end
        return

elseif strcmp(option,'cfs_on')
        chk_on  = findobj(win_dw1dtool,'tag',tag_cfs_on);
        txt     = findobj(win_dw1dtool,'tag',tag_txt_ccfs);
        pop     = findobj(win_dw1dtool,'tag',tag_pop_ccfs);
        if  get(chk_on,'Value')==1
                set([txt pop],'Visible','on');
        else
                set([txt pop],'Visible','off'); 
        end
        return

elseif strcmp(option,'ena_pop')
        % in3 = flg_axe
        pop_handles = findobj(win_dw1dtool,'Style','popupmenu');
        pop_app = findobj(pop_handles,'tag',tag_valapp_scr);
        pop_det = findobj(pop_handles,'tag',tag_valdet_scr);
        if in3(1)==1
                set(pop_app,'Enable','on');
        else
                set(pop_app,'Enable','off');
        end
        if in3(2)==1
                set(pop_det,'Enable','on');
        else
                set(pop_det,'Enable','off');
        end             
        return
end
        
uic_handles     = findobj(win_dw1dtool,'type','uicontrol');
pus_handles     = findobj(uic_handles,'Style','pushbutton');
pop_handles     = findobj(uic_handles,'Style','popupmenu');
pop_viewm       = findobj(pop_handles,'tag',tag_pop_viewm);
num_mode        = get(pop_viewm,'Value');

%**************************%
%** OPTION = 'create' -  **%
%**************************%
if strcmp(option,'create')

        % Begin waiting.
        %--------------
        if      strcmp(Machine(1:3),'PCW') | strcmp(Machine(1:3),'MAC')
                mousefrm(0,'watch');
        else
                wwaiting('msg',win_dw1dtool,'Wait ... ');
        end

        win_units       = 'pixels';
        win_height      = 21*Def_Btn_Height+45*Y_Spacing;
        win_width       = Def_Btn_Width+2*Pop_Min_Width+6*X_Spacing;
        old_units       = get(win_dw1dtool,'Units');
        set(win_dw1dtool,'Units','pixels');
        pos_wcall       = get(win_dw1dtool,'Position');
        set(win_dw1dtool,'Units',old_units);
        width0          = pos_wcall(3);
        height0         = pos_wcall(4);
        if win_height~=height0 , resize_win = 1; else , resize_win = 0; end;

        if pos_wcall(1)<win_width
                x_left0         = pos_wcall(1)+pos_wcall(3)-win_width;
        else
                x_left0         = pos_wcall(1)-win_width;
        end
        pos_win         = [     x_left0,        ...
                                pos_wcall(2),   ...
                                win_width,      ...
                                win_height      ...
                                ];
        win_dw1d_more   = findobj(get(0,'children'),'flat','tag',tag_win_disp);
        fig_name = ['More Display Options : Fig.' int2str(win_dw1dtool)];
        if ~isempty(win_dw1d_more)
                old_win = get(win_dw1d_more,'Userdata');
                if old_win~=win_dw1dtool

                        msg = ['Fig. ' int2str(old_win) ' : ' ...
                                'Keep Display Options ?' ];

                        % Test for keeping display options.
                        %----------------------------------
                        new = wwaitans(old_win,msg,1,'cancel');
                        if new==-1 , return; end
                        if new==0
                                dw1ddisp('cancel',old_win,win_dw1d_more);
                        end

                        hdl_m =  findobj(0,'type','uimenu','tag',tag_m_windows);
                        hdl_m =  findobj(hdl_m,'type','uimenu');
                        strwd = ['fig. ' int2str(win_dw1d_more) ' : '];
                        for k=1:length(hdl_m)
                                lab = get(hdl_m(k),'Label');
                                if findstr(lab,strwd)
                                        set(hdl_m(k),'Label',[strwd fig_name]);
                                end
                        end

                        dw1dutil('enable',old_win,'end_more_disp');
                        figure(win_dw1dtool);  
                end
        end
        dw1dutil('enable',win_dw1dtool,'more_disp');

        % fig_name = ['More Display Options'];
        if ~isempty(win_dw1d_more)
                hdl_m =  findobj(0,'type','uimenu','tag',tag_m_windows);

                hdl_in  = findobj(win_dw1d_more,'type','uicontrol');
                delete(hdl_in);
                set(win_dw1d_more,'Name',fig_name,'Userdata',win_dw1dtool);
        else
                win_dw1d_more   = figure(...
                                'Unit',win_units,               ...
                                'NumberTitle','off',            ...
                                'Name',fig_name,  ...
                                'Position',pos_win,             ...
                                'Color',Def_FraBkColor,         ...
                                'BackingStore','off',           ...
                                'Userdata',win_dw1dtool,        ...
                                'NextPlot','New',               ...
                                'Tag',tag_win_disp              ...
                                );
                extfig(win_dw1d_more,'','','w');
        end
        figure(win_dw1d_more);

        % Borders and double borders.
        %----------------------------
        dx  = X_Spacing;        dx2 = 2*dx;
        dy  = Y_Spacing;        dy2 = 2*dy;

        % Position property of objects.
        %------------------------------
        Screen_Size = get(0,'Screensize');
        if Screen_Size(4)<600
                Level_Anal = wmemtool('rmb',win_dw1dtool,...
                                        n_param_anal,ind_lev_anal);
                if Level_Anal>6 & (num_mode==3 | num_mode==4)
                        hpush = Def_Btn_Height;
                else
                        hpush = 3*Def_Btn_Height/2;
                end
        else
                hpush = 3*Def_Btn_Height/2;
        end

        % Position property of objects.
        %------------------------------
        x_left0         = 0;

        pos_txt_mname   = [     dx2                             ,...
                                win_height-Def_Btn_Height-dy2   ,...
                                win_width-2*dx2                 ,...
                                Def_Btn_Height                  ...
                                ];

        push_width      = (win_width-3*dx2)/2;
        xleft           = (win_width-7*push_width/4)/2;
        pos_close       = [     xleft                                   ,...
                                Def_Btn_Height                          ,...
                                7*push_width/4                          ,...
                                hpush                                   ];

        xleft = pos_close(1);
        ylow = pos_close(2)+pos_close(4)+dy2;
        width = (pos_close(3)-dx2)/2;
        pos_apply       = [     xleft                                   ,...
                                ylow                                    ,...
                                width                                   ,...
                                hpush                                   ];
        xleft = pos_apply(1)+pos_apply(3)+dx2;
        pos_cancel      = [     xleft                                   ,...
                                ylow                                    ,...
                                width                                   ,...
                                hpush                                   ];

        % String property of objects.
        %----------------------------
        str_mname       = get(pop_viewm,'String');
        str_mname       = [deblank(str_mname(num_mode,:)) ' Options'];
        str_apply       = 'Apply';
        str_cancel      = 'Cancel';
        str_close       = 'Close';
        str_cfs_on      = 'Show Coefs. Axes';
        str_txt_ccfs    = 'Coloration Mode';
        str_pop_ccfs    = ...
                        str2mat(...
                                'init + by level + abs',        ...
                                'init + by level',              ...
                                'init + all levels + abs',      ...
                                'init + all levels',            ...
                                'current + by level + abs',     ...
                                'current + by level',           ...
                                'current + all levels + abs',   ...
                                'current + all levels'          ...
                                );
        opt_act = wmemtool('rmb',win_dw1dtool,n_param_anal,ind_act_option);
        if strcmp(opt_act,'synt')
                ini_str = 'Ori. Synth. Sig.';
        else
                ini_str = 'Signal';
        end
        str_s_app       = ['Show ' ini_str];

        ss_type = wmemtool('rmb',win_dw1dtool,n_param_anal,ind_ssig_type);
        if      ss_type=='ss', str_ss_app = 'Synth.';
        elseif  ss_type=='ds', str_ss_app = 'Deno.';
        elseif  ss_type=='cs', str_ss_app = 'Comp.';
        end
        str_ss_app      = ['Show ' str_ss_app ' Signal'];
        str_s_det       = str_s_app;
        str_ss_det      = str_ss_app;
        if      (num_mode==1) | (num_mode==4)
                str_app_on      = 'Show Approx. Axes';
                str_det_on      = 'Show Detail Axes';
        elseif  (num_mode==3)
                str_app_on      = 'Show Left Signal Axes';
                str_det_on      = 'Show Right Signal Axes';
        end
        if      (num_mode==3)
                str_app_txt     = 'Approximations Axes';
                str_det_txt     = 'Details Axes';
        elseif  (num_mode==4)
                str_app_txt     = 'Approximation levels';
                str_det_txt     = 'Detail levels';
        end
        if      (num_mode==3) | (num_mode==4)
                str_app_all     = 'All';
                str_app_none    = 'None';
                str_det_all     = 'All';
                str_det_none    = 'None';
        end

        % Callback property of objects.
        %------------------------------
        action          = '';
        str_wincall     = int2str(win_dw1dtool);
        str_winloc      = int2str(win_dw1d_more);
        str_numm        = int2str(num_mode);
        cba_close    = ['dw1ddisp(''close'',' str_wincall ',' str_winloc ');'];
        cba_apply    = ['dw1ddisp(''apply'',' str_wincall ',' str_winloc ');'];
        cba_cancel   = ['dw1ddisp(''cancel'',' str_wincall ',' str_winloc ');'];
        cba_app_on   = ['dw1ddisp(''app_on'',' str_winloc ',' str_numm ');'];
        cba_det_on   = ['dw1ddisp(''det_on'',' str_winloc ',' str_numm ');'];
        cba_app_all  = ['dw1ddisp(''chk_sel'',' str_winloc ...
                                        ',1,''' tag_app_num ''');'];
        cba_app_none = ['dw1ddisp(''chk_sel'',' str_winloc ...
                                        ',0,''' tag_app_num ''');'];
        cba_det_all  = ['dw1ddisp(''chk_sel'',' str_winloc ...
                                         ',1,''' tag_det_num ''');'];
        cba_det_none = ['dw1ddisp(''chk_sel'',' str_winloc ...
                                        ',0,''' tag_det_num ''');'];
        cba_cfs_on = ['dw1ddisp(''cfs_on'',' str_winloc ');'];

        txt_mname       = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Text',                 ...
                                        'Unit',win_units,               ...
                                        'HorizontalAlignment','center', ...
                                        'Position',pos_txt_mname,       ...
                                        'String',str_mname,             ...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        pus_apply       = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Pushbutton',           ...
                                        'Unit',win_units,               ...
                                        'Position',pos_apply,           ...
                                        'String',str_apply,             ...
                                        'Interruptible','yes',          ...
                                        'Callback',cba_apply            ...
                                        );

        pus_cancel      = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Pushbutton',           ...
                                        'Unit',win_units,               ...
                                        'Position',pos_cancel,          ...
                                        'String',str_cancel,            ...
                                        'Interruptible','yes',          ...
                                        'Callback',cba_cancel           ...
                                        );

        pus_close       = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Pushbutton',           ...
                                        'Unit',win_units,               ...
                                        'Position',pos_close,           ...
                                        'String',str_close,             ...
                                        'Interruptible','yes',          ...
                                        'Callback',cba_close            ...
                                        );

        ylow            = pos_txt_mname(2);

%%%%%%%%%%---------- Mode : "Show and Scroll" --------%%%%%%%%%%
        if      num_mode==1
                [flg_axe,flg_sa,flg_app,flg_sd,flg_det,ccfs_m] = ...
                                dw1dvmod('get_vm',win_dw1dtool,num_mode);
                val_flg = [flg_axe(1) flg_sa flg_axe(2) flg_sd];
                vis_str = getonoff([1 flg_axe([1 1]) 1 flg_axe([2 2])]);
                val_cfs = flg_axe(3);
                if val_cfs==0
                        vis_txt_ccfs = 'off';   vis_pop_ccfs = 'off';
                else
                        vis_txt_ccfs = 'on';    vis_pop_ccfs = 'on';
                end

                % Position property of objects.
                %------------------------------
                ylow            = ylow-Def_Btn_Height-3*dy2;
                pos_app_on      = [     2*dx2,                  ...
                                        ylow,                   ...
                                        2*(Def_Btn_Width+dx2),  ...
                                        Def_Btn_Height          ...
                                        ];
                ylow            = ylow-Def_Btn_Height-dy;
                pos_s_app       = [     3*dx2,                  ...
                                        ylow,                   ...
                                        2*Def_Btn_Width+dx2,    ...
                                        Def_Btn_Height          ...
                                        ];
                ylow            = ylow-Def_Btn_Height;
                pos_ss_app      = [     3*dx2,                  ...
                                        ylow,                   ...
                                        2*Def_Btn_Width+dx2,    ...
                                        Def_Btn_Height          ...
                                        ];

                ylow            = ylow-Def_Btn_Height-3*dy2;
                pos_det_on      = [     2*dx2,                  ...
                                        ylow,                   ...
                                        2*(Def_Btn_Width+dx2),  ...
                                        Def_Btn_Height          ...
                                        ];
                ylow            = ylow-Def_Btn_Height-dy;
                pos_s_det       = [     3*dx2,                  ...
                                        ylow,                   ...
                                        2*Def_Btn_Width+dx2,    ...
                                        Def_Btn_Height          ...
                                        ];
                ylow            = ylow-Def_Btn_Height;
                pos_ss_det      = [     3*dx2,                  ...
                                        ylow,                   ...
                                        2*Def_Btn_Width+dx2,    ...
                                        Def_Btn_Height          ...
                                        ];
                ylow            = ylow-Def_Btn_Height-3*dy2;
                pos_cfs_on      = [     2*dx2,                  ...
                                        ylow,                   ...
                                        2*(Def_Btn_Width+dx2),  ...
                                        Def_Btn_Height          ...
                                        ];
                ylow            = ylow-Def_Btn_Height-dy;
                pos_txt_ccfs    = [     2*dx2,                  ...
                                        ylow,                   ...
                                        2*(Def_Btn_Width+dx2),  ...
                                        Def_Btn_Height          ...
                                        ];
                ylow            = ylow-Def_Btn_Height-dy;
                pos_pop_ccfs    = [     2*dx2,                  ...
                                        ylow,                   ...
                                        2*(Def_Btn_Width+dx2),  ...
                                        Def_Btn_Height          ...
                                        ];

                chk_app_on      = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Checkbox',     ...
                                        'Unit',win_units,       ...
                                        'Position',pos_app_on,  ...
                                        'HorizontalAlignment','left',   ...
                                        'String',str_app_on,    ...
                                        'Visible',vis_str(1,:), ...
                                        'Value',val_flg(1),     ...
                                        'Tag',tag_app_on,       ...
                                        'Callback',cba_app_on   ...
                                        );

                chk_s_app       = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Checkbox',     ...
                                        'Unit',win_units,       ...
                                        'Position',pos_s_app,   ...
                                        'HorizontalAlignment','left',   ...
                                        'String',str_s_app,     ...
                                        'Visible',vis_str(2,:), ...
                                        'Value',val_flg(2),     ...
                                        'Tag',tag_s_app         ...
                                        );

                chk_ss_app      = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Checkbox',     ...
                                        'Unit',win_units,       ...
                                        'Position',pos_ss_app,  ...
                                        'HorizontalAlignment','left',   ...
                                        'String',str_ss_app,    ...
                                        'Visible',vis_str(3,:), ...
                                        'Value',val_flg(3),     ...
                                        'Tag',tag_ss_app        ...
                                        );

                chk_det_on      = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Checkbox',     ...
                                        'Unit',win_units,       ...
                                        'Position',pos_det_on,  ...
                                        'HorizontalAlignment','left',   ...
                                        'String',str_det_on,    ...
                                        'Visible',vis_str(4,:), ...
                                        'Value',val_flg(4),     ...
                                        'Tag',tag_det_on,       ...
                                        'Callback',cba_det_on   ...
                                        );
                chk_s_det       = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Checkbox',     ...
                                        'Unit',win_units,       ...
                                        'Position',pos_s_det,   ...
                                        'HorizontalAlignment','left',   ...
                                        'String',str_s_det,     ...
                                        'Visible',vis_str(5,:), ...
                                        'Value',val_flg(5),     ...
                                        'Tag',tag_s_det ...
                                        );

                chk_ss_det      = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Checkbox',     ...
                                        'Unit',win_units,       ...
                                        'Position',pos_ss_det,  ...
                                        'HorizontalAlignment','left',   ...
                                        'String',str_ss_det,    ...
                                        'Visible',vis_str(6,:), ...
                                        'Value',val_flg(6),     ...
                                        'Tag',tag_ss_det        ...
                                        );
                dw1ddisp('ena_pop',win_dw1dtool,flg_axe(1:2));


%%%%%%%%%%---------- Mode : "Full Decomposition" --------%%%%%%%%%%
        elseif  num_mode==2     % No Options

%%%%%%%%%%---------- Mode : "Separate" --------%%%%%%%%%%
        elseif  num_mode==3
                Level_Anal = wmemtool('rmb',win_dw1dtool,n_param_anal,...
                                                        ind_lev_anal);
                nb_inline       = 3;
                nb_lines        = max(2,ceil(Level_Anal/nb_inline))+1;
                nb              = nb_inline+1;

                if Level_Anal > 6
                        btn_height = 4*Def_Btn_Height/5;
                        if Screen_Size(4)<600
                                chk_height = Def_Btn_Height;
                        else
                                chk_height = btn_height;
                        end
                else
                        btn_height = Def_Btn_Height;
                        chk_height = Def_Btn_Height;
                end

                [flg_axe,sa_flg,app_flg,sd_flg,det_flg,ccfs_m] = ...
                                dw1dvmod('get_vm',win_dw1dtool,num_mode);
                l_s_flg = flg_axe(1);
                r_s_flg = flg_axe(2);   
                val_cfs = flg_axe(3);
                val_flg = [l_s_flg , sa_flg , r_s_flg , sd_flg];
                vis_str = getonoff([1 l_s_flg l_s_flg 1 r_s_flg r_s_flg ]);
                if val_cfs==0
                        vis_txt_ccfs = 'off';   vis_pop_ccfs = 'off';
                else
                        vis_txt_ccfs = 'on';    vis_pop_ccfs = 'on';
                end

                % Position property of objects.
                %------------------------------
                ylow            = ylow-Def_Btn_Height-3*dy2;
                pos_app_on      = [     dx2,                    ...
                                        ylow,                   ...
                                        2*(Def_Btn_Width+1.5*dx2),...
                                        Def_Btn_Height          ...
                                        ];
                ylow            = ylow-Def_Btn_Height-dy;
                pos_s_app       = [     3*dx2,                  ...
                                        ylow,                   ...
                                        2*Def_Btn_Width+dx2,    ...
                                        Def_Btn_Height          ...
                                        ];
                ylow            = ylow-Def_Btn_Height;
                pos_ss_app      = [     3*dx2,                  ...
                                        ylow,                   ...
                                        2*Def_Btn_Width+dx2,    ...
                                        Def_Btn_Height          ...
                                        ];
                px              = x_left0+(win_width-3*push_width/2)/2;
                ylow            = ylow-3*btn_height/2-dy;
                pos_app_txt     = [     px,                     ...
                                        ylow,                   ...
                                        3*push_width/2,         ...
                                        btn_height              ...             
                                        ];
                wx              = (win_width-nb*Def_Btn_Width/2)/(nb+1);
                xbtchk0         = x_left0+Def_Btn_Width/2+2*wx;
                ybtchk0         = pos_app_txt(2)-6*btn_height/5-dy;
                ylow            = ybtchk0;
                pos_app_all     = [     x_left0+wx,                     ...
                                        ylow,                           ...
                                        Def_Btn_Width/2,                ...
                                        btn_height                      ...
                                        ];
                ylow            = ylow-6*btn_height/5;
                pos_app_none    = [     pos_app_all(1),                 ...
                                        ylow,                           ...
                                        Def_Btn_Width/2,                ...
                                        btn_height                      ...
                                        ];

                wx              = (win_width-nb*Def_Btn_Width/2)/(nb+1);
                xbtchk          = xbtchk0;
                ybtchk          = ybtchk0;
                pos_chk_app     = zeros(Level_Anal,4);
                for i=1:Level_Anal
                        pos_chk_app(i,:) = ...
                                [xbtchk ybtchk Def_Btn_Width/2 chk_height];
                        if rem(i,nb_inline)==0
                                xbtchk = xbtchk0;
                                ybtchk = ybtchk-6*btn_height/5;
                        else
                                xbtchk = xbtchk+Def_Btn_Width/2+wx;
                        end
                end

                mi = min(pos_app_none(2),pos_chk_app(Level_Anal,2));
                ylow            = mi-Def_Btn_Height-2*dy2;
                pos_det_on      = [     dx2,                    ...
                                        ylow,                   ...
                                        2*(Def_Btn_Width+1.5*dx2),      ...
                                        Def_Btn_Height          ...
                                        ];
                ylow            = ylow-Def_Btn_Height-dy;
                pos_s_det       = [     3*dx2,                  ...
                                        ylow,                   ...
                                        2*Def_Btn_Width+dx2,    ...
                                        Def_Btn_Height          ...
                                        ];
                ylow            = ylow-Def_Btn_Height;
                pos_ss_det      = [     3*dx2,                  ...
                                        ylow,                   ...
                                        2*Def_Btn_Width+dx2,    ...
                                        Def_Btn_Height          ...
                                        ];
                px              = x_left0+(win_width-3*push_width/2)/2;
                ylow            = ylow-3*btn_height/2-dy;
                pos_det_txt     = [     px,                     ...
                                        ylow,                   ...
                                        3*push_width/2,         ...
                                        btn_height              ...             
                                        ];
                xbtchk0         = x_left0+Def_Btn_Width/2+2*wx;
                ybtchk0         = pos_det_txt(2)-6*btn_height/5-dy;
                wx              = (win_width-nb*Def_Btn_Width/2)/(nb+1);
                ylow            = ybtchk0;
                pos_det_all     = [     x_left0+wx,                     ...
                                        ylow,                           ...
                                        Def_Btn_Width/2,                ...
                                        btn_height                      ...
                                        ];
                ylow            = ylow-6*btn_height/5;
                pos_det_none    = [     pos_det_all(1),                 ...
                                        ylow,                           ...
                                        Def_Btn_Width/2,                ...
                                        btn_height                      ...
                                        ];

                wx              = (win_width-nb*Def_Btn_Width/2)/(nb+1);
                xbtchk          = xbtchk0;
                ybtchk          = ybtchk0;
                pos_chk_det     = zeros(Level_Anal,4);
                for i=1:Level_Anal
                        pos_chk_det(i,:) = ...
                                [xbtchk ybtchk Def_Btn_Width/2 chk_height];
                        if rem(i,nb_inline)==0
                                xbtchk = xbtchk0;
                                ybtchk = ybtchk-6*btn_height/5;
                        else
                                xbtchk = xbtchk+Def_Btn_Width/2+wx;
                        end
                end

                mi = min(pos_det_none(2),pos_chk_det(Level_Anal,2));
                ylow            = mi-Def_Btn_Height-2*dy2;
                pos_cfs_on      = [     dx2,                    ...
                                        ylow,                   ...
                                        2*(Def_Btn_Width+1.5*dx2),      ...
                                        Def_Btn_Height          ...
                                        ];
                ylow            = ylow-Def_Btn_Height-dy;
                pos_txt_ccfs    = [     2*dx2,                  ...
                                        ylow,                   ...
                                        2*(Def_Btn_Width+dx2),  ...
                                        Def_Btn_Height          ...
                                        ];
                ylow            = ylow-Def_Btn_Height-dy;
                pos_pop_ccfs    = [     2*dx2,                  ...
                                        ylow,                   ...
                                        2*(Def_Btn_Width+dx2),  ...
                                        Def_Btn_Height          ...
                                        ];

                chk_app_on      = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Checkbox',     ...
                                        'Unit',win_units,       ...
                                        'Position',pos_app_on,  ...
                                        'HorizontalAlignment','left',   ...
                                        'String',str_app_on,    ...
                                        'Visible',vis_str(1,:), ...
                                        'Value',val_flg(1),     ...
                                        'Tag',tag_app_on,       ...
                                        'Callback',cba_app_on   ...
                                        );

                chk_s_app       = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Checkbox',     ...
                                        'Unit',win_units,       ...
                                        'Position',pos_s_app,   ...
                                        'HorizontalAlignment','left',   ...
                                        'String',str_s_app,     ...
                                        'Visible',vis_str(2,:), ...
                                        'Value',val_flg(2),     ...
                                        'Tag',tag_s_app         ...
                                        );

                chk_ss_app      = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Checkbox',     ...
                                        'Unit',win_units,       ...
                                        'Position',pos_ss_app,  ...
                                        'HorizontalAlignment','left',   ...
                                        'String',str_ss_app,    ...
                                        'Visible',vis_str(3,:), ...
                                        'Value',val_flg(3),     ...
                                        'Tag',tag_ss_app        ...
                                        );

                txt_app_txt     = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'Position',pos_app_txt,...
                                        'String',str_app_txt,...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'HorizontalAlignment','center', ...
                                        'Visible','on',...
                                        'Tag',tag_app_txt...
                                        );
                pus_app_all     = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','PushButton',...
                                        'Unit',win_units,...
                                        'Position',pos_app_all,...
                                        'String',str_app_all,...
                                        'Visible','on',...
                                        'Tag',tag_app_all,...
                                        'Callback',cba_app_all  ...
                                        );
                pus_app_none    = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','PushButton',...
                                        'Unit',win_units,...
                                        'Position',pos_app_none,...
                                        'String',str_app_none,...
                                        'Visible','on',...
                                        'Tag',tag_app_none,...
                                        'Callback',cba_app_none ...
                                        );


                Chk_App_Lst     = zeros(Level_Anal,1);
                for i=1:Level_Anal
                        Chk_App_Lst(i) = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Checkbox',             ...
                                        'Unit',win_units,               ...
                                        'Position',pos_chk_app(i,:),    ...
                                        'Value',app_flg(i),             ...
                                        'String',int2str(i),            ...
                                        'Visible','on',                 ...
                                        'Userdata',i,                   ...
                                        'Tag',tag_app_num               ...
                                        );
                end
                set(pus_app_all,'Userdata',Chk_App_Lst);

                chk_det_on      = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Checkbox',     ...
                                        'Unit',win_units,       ...
                                        'Position',pos_det_on,  ...
                                        'HorizontalAlignment','left',   ...
                                        'String',str_det_on,    ...
                                        'Visible',vis_str(4,:), ...
                                        'Value',val_flg(4),     ...
                                        'Tag',tag_det_on,       ...
                                        'Callback',cba_det_on   ...
                                        );
                chk_s_det       = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Checkbox',     ...
                                        'Unit',win_units,       ...
                                        'Position',pos_s_det,   ...
                                        'HorizontalAlignment','left',   ...
                                        'String',str_s_det,     ...
                                        'Visible',vis_str(5,:), ...
                                        'Value',val_flg(5),     ...
                                        'Tag',tag_s_det ...
                                        );

                chk_ss_det      = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Checkbox',     ...
                                        'Unit',win_units,       ...
                                        'Position',pos_ss_det,  ...
                                        'HorizontalAlignment','left',   ...
                                        'String',str_ss_det,    ...
                                        'Visible',vis_str(6,:), ...
                                        'Value',val_flg(6),     ...
                                        'Tag',tag_ss_det        ...
                                        );

                txt_det_txt     = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'Position',pos_det_txt,...
                                        'String',str_det_txt,...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'HorizontalAlignment','center', ...
                                        'Visible','on',...
                                        'Tag',tag_det_txt...
                                        );
                pus_det_all     = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','PushButton',...
                                        'Unit',win_units,...
                                        'Position',pos_det_all,...
                                        'String',str_det_all,...
                                        'Visible','on',...
                                        'Tag',tag_det_all,...
                                        'Callback',cba_det_all  ...
                                        );
                pus_det_none    = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','PushButton',...
                                        'Unit',win_units,...
                                        'Position',pos_det_none,...
                                        'String',str_det_none,...
                                        'Visible','on',...
                                        'Tag',tag_det_none,...
                                        'Callback',cba_det_none ...
                                        );

                Chk_Det_Lst     = zeros(Level_Anal,1);
                for i=1:Level_Anal
                        Chk_Det_Lst(i) = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Checkbox',             ...
                                        'Unit',win_units,               ...
                                        'Position',pos_chk_det(i,:),    ...
                                        'Value',det_flg(i),             ...
                                        'String',int2str(i),            ...
                                        'Visible','on',                 ...
                                        'Tag',tag_det_num               ...
                                        );
                end
                set(pus_det_all,'Userdata',Chk_Det_Lst);
                drawnow;

%%%%%%%%%%---------- Mode : "Superimpose" --------%%%%%%%%%%
        elseif  num_mode==4
                Level_Anal = wmemtool('rmb',win_dw1dtool,n_param_anal,...
                                                        ind_lev_anal);
                nb_inline       = 3;
                nb_lines        = max(2,ceil(Level_Anal/nb_inline))+1;
                nb              = nb_inline+1;

                if Level_Anal > 6
                        btn_height = 4*Def_Btn_Height/5;
                        if Screen_Size(4)<600
                                chk_height = Def_Btn_Height;
                        else
                                chk_height = btn_height;
                        end
                else
                        btn_height = Def_Btn_Height;
                        chk_height = Def_Btn_Height;
                end

                [flg_axe,flg_sa,flg_app,flg_sd,flg_det,ccfs_m] = ...
                                dw1dvmod('get_vm',win_dw1dtool,num_mode);
                if flg_axe(3)== 0
                        vis_txt_ccfs = 'off';   vis_pop_ccfs = 'off';
                else
                        vis_txt_ccfs = 'on';    vis_pop_ccfs = 'on';
                end
                vis_str = getonoff([1 flg_axe([1 1]) 1 flg_axe([2 2])]);
                val_flg = [flg_axe(1) flg_sa flg_axe(2) flg_sd flg_axe(3)];
                val_app = flg_app;
                val_det = flg_det;
                val_cfs = flg_axe(3);

                % Position property of objects.
                %------------------------------
                ylow            = ylow-Def_Btn_Height-3*dy2;
                pos_app_on      = [     dx2,                    ...
                                        ylow,                   ...
                                        2*(Def_Btn_Width+1.5*dx2),...
                                        Def_Btn_Height          ...
                                        ];
                ylow            = ylow-Def_Btn_Height-dy;
                pos_s_app       = [     3*dx2,                  ...
                                        ylow,                   ...
                                        2*Def_Btn_Width+dx2,    ...
                                        Def_Btn_Height          ...
                                        ];
                ylow            = ylow-Def_Btn_Height;
                pos_ss_app      = [     3*dx2,                  ...
                                        ylow,                   ...
                                        2*Def_Btn_Width+dx2,    ...
                                        Def_Btn_Height          ...
                                        ];
                px              = x_left0+(win_width-3*push_width/2)/2;
                ylow            = ylow-3*btn_height/2;
                pos_app_txt     = [     px,                     ...
                                        ylow,                   ...
                                        3*push_width/2,         ...
                                        btn_height              ...             
                                        ];
                wx              = (win_width-nb*Def_Btn_Width/2)/(nb+1);
                ylow            = ylow-6*btn_height/5;
                pos_app_all     = [     x_left0+wx,                     ...
                                        ylow,                           ...
                                        Def_Btn_Width/2,                ...
                                        btn_height                      ...
                                        ];
                ylow            = ylow-6*btn_height/5;
                pos_app_none    = [     pos_app_all(1),                 ...
                                        ylow,                           ...
                                        Def_Btn_Width/2,                ...
                                        btn_height                      ...
                                        ];

                wx              = (win_width-nb*Def_Btn_Width/2)/(nb+1);
                xbtchk0         = x_left0+Def_Btn_Width/2+2*wx;
                ybtchk0         = pos_app_txt(2)-6*btn_height/5;
                xbtchk          = xbtchk0;
                ybtchk          = ybtchk0;
                pos_chk_app     = zeros(Level_Anal,4);
                for i=1:Level_Anal
                        pos_chk_app(i,:) = ...
                                [xbtchk ybtchk Def_Btn_Width/2 chk_height];
                        if rem(i,nb_inline)==0
                                xbtchk = xbtchk0;
                                ybtchk = ybtchk-6*btn_height/5;
                        else
                                xbtchk = xbtchk+Def_Btn_Width/2+wx;
                        end
                end

                mi = min(pos_app_none(2),pos_chk_app(Level_Anal,2));
                ylow            = mi-Def_Btn_Height-2*dy2;
                pos_det_on      = [     dx2,                    ...
                                        ylow,                   ...
                                        2*(Def_Btn_Width+1.5*dx2),      ...
                                        Def_Btn_Height          ...
                                        ];
                ylow = ylow-Def_Btn_Height-dy;
                pos_s_det       = [     3*dx2,                  ...
                                        ylow,                   ...
                                        2*Def_Btn_Width+dx2,    ...
                                        Def_Btn_Height          ...
                                        ];
                ylow            = ylow-Def_Btn_Height;
                pos_ss_det      = [     3*dx2,                  ...
                                        ylow,                   ...
                                        2*Def_Btn_Width+dx2,    ...
                                        Def_Btn_Height          ...
                                        ];
                px              = x_left0+(win_width-3*push_width/2)/2;
                ylow            = ylow-3*btn_height/2;
                pos_det_txt     = [     px,                     ...
                                        ylow,                   ...
                                        3*push_width/2,         ...
                                        btn_height              ...             
                                        ];
                wx              = (win_width-nb*Def_Btn_Width/2)/(nb+1);
                ylow            = ylow-6*btn_height/5;
                pos_det_all     = [     x_left0+wx,                     ...
                                        ylow,                           ...
                                        Def_Btn_Width/2,                ...
                                        btn_height                      ...
                                        ];
                ylow            = ylow-6*btn_height/5;
                pos_det_none    = [     pos_det_all(1),                 ...
                                        ylow,                           ...
                                        Def_Btn_Width/2,                ...
                                        btn_height                      ...
                                        ];

                wx              = (win_width-nb*Def_Btn_Width/2)/(nb+1);
                xbtchk0         = x_left0+Def_Btn_Width/2+2*wx;
                ybtchk0         = pos_det_txt(2)-6*btn_height/5;
                xbtchk          = xbtchk0;
                ybtchk          = ybtchk0;
                pos_chk_det     = zeros(Level_Anal,4);
                for i=1:Level_Anal
                        pos_chk_det(i,:) = ...
                                [xbtchk ybtchk Def_Btn_Width/2 chk_height];
                        if rem(i,nb_inline)==0
                                xbtchk = xbtchk0;
                                ybtchk = ybtchk-6*btn_height/5;
                        else
                                xbtchk = xbtchk+Def_Btn_Width/2+wx;
                        end
                end

                mi = min(pos_det_none(2),pos_chk_det(Level_Anal,2));
                ylow            = mi-Def_Btn_Height-2*dy2;
                pos_cfs_on = [  dx2,                    ...
                                ylow,                   ...
                                2*(Def_Btn_Width+1.5*dx2),      ...
                                Def_Btn_Height          ...
                                ];
                ylow = ylow-Def_Btn_Height-dy;
                pos_txt_ccfs = [2*dx2,                  ...
                                ylow,                   ...
                                2*(Def_Btn_Width+dx2),  ...
                                Def_Btn_Height          ...
                                ];
                ylow = ylow-Def_Btn_Height-dy;
                pos_pop_ccfs = [2*dx2,                  ...
                                ylow,                   ...
                                2*(Def_Btn_Width+dx2),  ...
                                Def_Btn_Height          ...
                                ];

                chk_app_on = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Checkbox',     ...
                                        'Unit',win_units,       ...
                                        'Position',pos_app_on,  ...
                                        'HorizontalAlignment','left',   ...
                                        'String',str_app_on,    ...
                                        'Visible',vis_str(1,:), ...
                                        'Value',val_flg(1),     ...
                                        'Tag',tag_app_on,       ...
                                        'Callback',cba_app_on   ...
                                        );

                chk_s_app = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Checkbox',     ...
                                        'Unit',win_units,       ...
                                        'Position',pos_s_app,   ...
                                        'HorizontalAlignment','left',   ...
                                        'String',str_s_app,     ...
                                        'Visible',vis_str(2,:), ...
                                        'Value',val_flg(2),     ...
                                        'Tag',tag_s_app         ...
                                        );

                chk_ss_app = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Checkbox',     ...
                                        'Unit',win_units,       ...
                                        'Position',pos_ss_app,  ...
                                        'HorizontalAlignment','left',   ...
                                        'String',str_ss_app,    ...
                                        'Visible',vis_str(3,:), ...
                                        'Value',val_flg(3),     ...
                                        'Tag',tag_ss_app        ...
                                        );

                txt_app_txt     = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Text',                 ...
                                        'Unit',win_units,               ...
                                        'Position',pos_app_txt,         ...
                                        'String',str_app_txt,           ...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'Visible',vis_str(3,:),         ...
                                        'Tag',tag_app_txt               ...
                                        );
                pus_app_all     = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','PushButton',           ...
                                        'Unit',win_units,               ...
                                        'Position',pos_app_all,         ...
                                        'String',str_app_all,           ...
                                        'Visible',vis_str(3,:),         ...
                                        'Tag',tag_app_all,              ...
                                        'Callback',cba_app_all          ...
                                        );
                pus_app_none    = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','PushButton',           ...
                                        'Unit',win_units,               ...
                                        'Position',pos_app_none,        ...
                                        'String',str_app_none,          ...
                                        'Visible',vis_str(3,:),         ...
                                        'Tag',tag_app_none,             ...
                                        'Callback',cba_app_none         ...
                                        );


                Chk_App_Lst     = zeros(Level_Anal,1);
                for i=1:Level_Anal
                        Chk_App_Lst(i) = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Checkbox',             ...
                                        'Unit',win_units,               ...
                                        'Position',pos_chk_app(i,:),    ...
                                        'Value',val_app(i),             ...
                                        'String',int2str(i),            ...
                                        'Visible',vis_str(3,:),         ...
                                        'Tag',tag_app_num               ...
                                        );
                end
                set(pus_app_all,'Userdata',Chk_App_Lst);

                chk_det_on = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Checkbox',     ...
                                        'Unit',win_units,       ...
                                        'Position',pos_det_on,  ...
                                        'HorizontalAlignment','left',   ...
                                        'String',str_det_on,    ...
                                        'Visible',vis_str(4,:), ...
                                        'Value',val_flg(4),     ...
                                        'Tag',tag_det_on,       ...
                                        'Callback',cba_det_on   ...
                                        );
                chk_s_det = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Checkbox',     ...
                                        'Unit',win_units,       ...
                                        'Position',pos_s_det,   ...
                                        'HorizontalAlignment','left',   ...
                                        'String',str_s_det,     ...
                                        'Visible',vis_str(5,:), ...
                                        'Value',val_flg(5),     ...
                                        'Tag',tag_s_det         ...
                                        );

                chk_ss_det = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Checkbox',     ...
                                        'Unit',win_units,       ...
                                        'Position',pos_ss_det,  ...
                                        'HorizontalAlignment','left',   ...
                                        'String',str_ss_det,    ...
                                        'Visible',vis_str(6,:), ...
                                        'Value',val_flg(6),     ...
                                        'Tag',tag_ss_det        ...
                                        );

                txt_det_txt     = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Text',                 ...
                                        'Unit',win_units,               ...
                                        'Position',pos_det_txt,         ...
                                        'String',str_det_txt,           ...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'Visible',vis_str(6,:),         ...
                                        'Tag',tag_det_txt               ...
                                        );
                pus_det_all     = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','PushButton',           ...
                                        'Unit',win_units,               ...
                                        'Position',pos_det_all,         ...
                                        'String',str_det_all,           ...
                                        'Visible',vis_str(6,:),         ...
                                        'Tag',tag_det_all,              ...
                                        'Callback',cba_det_all          ...
                                        );
                pus_det_none    = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','PushButton',           ...
                                        'Unit',win_units,               ...
                                        'Position',pos_det_none,        ...
                                        'String',str_det_none,          ...
                                        'Visible',vis_str(6,:),         ...
                                        'Tag',tag_det_none,             ...
                                        'Callback',cba_det_none         ...
                                        );

                Chk_Det_Lst     = zeros(Level_Anal,1);
                for i=1:Level_Anal
                        Chk_Det_Lst(i) = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Checkbox',             ...
                                        'Unit',win_units,               ...
                                        'Position',pos_chk_det(i,:),    ...
                                        'Value',val_det(i),             ...
                                        'String',int2str(i),            ...
                                        'Visible',vis_str(6,:),         ...
                                        'Tag',tag_det_num               ...
                                        );
                end
                set(pus_det_all,'Userdata',Chk_Det_Lst);
                drawnow;

%%%%%%%%%%---------- Mode : "Tree Mode" --------%%%%%%%%%%
        elseif  num_mode==5

        end
%%%%%%%%%%--------------------------------------------------%%%%%%%%%%
        if find(num_mode==[1 3 4])
                chk_cfs_on = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Checkbox',     ...
                                        'Unit',win_units,       ...
                                        'Position',pos_cfs_on,  ...
                                        'HorizontalAlignment','left',   ...
                                        'String',str_cfs_on,    ...
                                        'Visible','on',         ...
                                        'Value',val_cfs,        ...
                                        'Tag',tag_cfs_on,       ...
                                        'Callback',cba_cfs_on   ...
                                        );

                txt_ccfs        = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Text',                 ...
                                        'Unit',win_units,               ...
                                        'Position',pos_txt_ccfs,        ...
                                        'Visible',vis_txt_ccfs,         ...
                                        'String',str_txt_ccfs,          ...
                                        'BackGroundColor',Def_FraBkColor,...
                                        'tag',tag_txt_ccfs              ...
                                        );

                pop_ccfs        = uicontrol(...
                                        'Parent',win_dw1d_more, ...
                                        'Style','Popup',                ...
                                        'Unit',win_units,               ...
                                        'Position',pos_pop_ccfs,        ...
                                        'Visible',vis_pop_ccfs,         ...
                                        'String',str_pop_ccfs,          ...
                                        'Value',ccfs_m,                 ...
                                        'Tag',tag_pop_ccfs              ...
                                        );
        end

        %  Normalization.
        %----------------
        set(findobj(win_dw1d_more,'units','pixels'),'units','normalized');

        % End waiting.
        %---------------
        if      strcmp(Machine(1:3),'PCW') | strcmp(Machine(1:3),'MAC')
                mousefrm(0,'arrow');
        else
                wwaiting('off',win_dw1dtool);
        end

%*************************%
%** OPTION = 'apply' -  **%
%*************************%
elseif strcmp(option,'apply')
        % in3 = win_dw1d_more
        %--------------------
        win_dw1d_more   = in3;
        chk_handles     = findobj(win_dw1d_more,'Style','checkbox');
        pus_handles     = findobj(win_dw1d_more,'Style','pushbutton');
        chk_app_on      = findobj(chk_handles,'Tag',tag_app_on);
        chk_s_app       = findobj(chk_handles,'Tag',tag_s_app);
        chk_ss_app      = findobj(chk_handles,'Tag',tag_ss_app);
        chk_det_on      = findobj(chk_handles,'Tag',tag_det_on);
        chk_s_det       = findobj(chk_handles,'Tag',tag_s_det);
        chk_ss_det      = findobj(chk_handles,'Tag',tag_ss_det);
        chk_cfs_on      = findobj(chk_handles,'Tag',tag_cfs_on);
        txt_ccfs        = findobj(win_dw1d_more,'tag',tag_txt_ccfs);
        pop_ccfs        = findobj(win_dw1d_more,'tag',tag_pop_ccfs);
        flg_axe         = [     get(chk_app_on,'Value'),        ...
                                get(chk_det_on,'Value'),        ...
                                get(chk_cfs_on,'Value')         ...
                                ];
        flg_sa          = [     get(chk_s_app,'Value'),         ...
                                get(chk_ss_app,'Value')         ...
                                ];
        flg_sd          = [     get(chk_s_det,'Value'),         ...
                                get(chk_ss_det,'Value')         ...
                                ];
        val_cfs         = get(pop_ccfs,'Value');

        if      num_mode==1
                new_vm = dw1dvmod('set_vm',win_dw1dtool,num_mode,...
                                flg_axe,flg_sa,1,flg_sd,1,val_cfs);
                dw1ddisp('ena_pop',win_dw1dtool,flg_axe(1:2));
                
        elseif  num_mode==2

        elseif  num_mode==3
                pus_app_all     = findobj(pus_handles,'Tag',tag_app_all);
                pus_det_all     = findobj(pus_handles,'Tag',tag_det_all);
                chk_app_lst     = get(pus_app_all,'Userdata');
                chk_det_lst     = get(pus_det_all,'Userdata');
                lev_anal        = length(chk_app_lst);
                flg_app         = zeros(1,lev_anal);
                flg_det         = zeros(1,lev_anal);
                for k = 1:lev_anal
                        flg_app(k) = get(chk_app_lst(k),'Value');
                        flg_det(k) = get(chk_det_lst(k),'Value');
                end
                new_vm = dw1dvmod('set_vm',win_dw1dtool,num_mode,...
                                flg_axe,flg_sa,flg_app,flg_sd,flg_det,val_cfs);
 
        elseif  num_mode==4
                pus_app_all     = findobj(pus_handles,'Tag',tag_app_all);
                pus_det_all     = findobj(pus_handles,'Tag',tag_det_all);
                chk_app_lst     = get(pus_app_all,'Userdata');
                chk_det_lst     = get(pus_det_all,'Userdata');
                lev_anal        = length(chk_app_lst);
                flg_app         = zeros(1,lev_anal);
                flg_det         = zeros(1,lev_anal);
                for k = 1:lev_anal
                        flg_app(k) = get(chk_app_lst(k),'Value');
                        flg_det(k) = get(chk_det_lst(k),'Value');
                end
                new_vm = dw1dvmod('set_vm',win_dw1dtool,num_mode,...
                                flg_axe,flg_sa,flg_app,flg_sd,flg_det,val_cfs);

        elseif  num_mode==5

        end

        % Changing view mode options
        %---------------------------
        if find(val_cfs==[5 6 7 8]) & (new_vm==0)
                xlim_selbox = dynvtool('getbox',win_dw1dtool); 
                if ~isempty(xlim_selbox) , new_vm = 1; end
        end


        % Begin waiting.
        %--------------
        if      strcmp(Machine(1:3),'PCW') | strcmp(Machine(1:3),'MAC')
                mousefrm(0,'watch')
        else
                wwaiting('msg',win_dw1dtool,'Wait ... computing');
        end

        if      num_mode==1
                fname = 'dw1dscrm';
        elseif  num_mode==2
                fname = 'dw1ddecm';
        elseif  num_mode==3
                fname = 'dw1dsepm';
        elseif  num_mode==4
                fname = 'dw1dsupm';
        elseif  num_mode==5
                fname = 'dw1dtrem';
        end
        feval(fname,'view',win_dw1dtool,-1);

        % End waiting.
        %---------------
        if      strcmp(Machine(1:3),'PCW') | strcmp(Machine(1:3),'MAC')
                mousefrm(0,'arrow')
        else
                wwaiting('off',win_dw1dtool);
        end
        figure(win_dw1d_more)

%*************************%
%** OPTION = 'cancel' - **%
%*************************%
elseif strcmp(option,'cancel')
        % in3 = win_dw1d_more
        %--------------------
        win_dw1d_more   = in3;
        chk_handles     = findobj(win_dw1d_more,'Style','checkbox');
        pus_handles     = findobj(win_dw1d_more,'Style','pushbutton');
        chk_app_on      = findobj(chk_handles,'Tag',tag_app_on);
        chk_s_app       = findobj(chk_handles,'Tag',tag_s_app);
        chk_ss_app      = findobj(chk_handles,'Tag',tag_ss_app);
        chk_det_on      = findobj(chk_handles,'Tag',tag_det_on);
        chk_s_det       = findobj(chk_handles,'Tag',tag_s_det);
        chk_ss_det      = findobj(chk_handles,'Tag',tag_ss_det);
        chk_cfs_on      = findobj(chk_handles,'Tag',tag_cfs_on);
        txt_ccfs        = findobj(win_dw1d_more,'tag',tag_txt_ccfs);
        pop_ccfs        = findobj(win_dw1d_more,'tag',tag_pop_ccfs);

        if      num_mode==1
                [flg_axe,flg_sa,flg_app,flg_sd,flg_det,ccfs_m] = ...
                                dw1dvmod('get_vm',win_dw1dtool,num_mode,0);
                val_flg = [flg_axe(1) flg_sa flg_axe(2) flg_sd];
                vis_str = getonoff([1 flg_axe([1 1]) 1 flg_axe([2 2])]);
                val_cfs = flg_axe(3);
                if val_cfs==0
                        vis_txt_ccfs = 'off';   vis_pop_ccfs = 'off';
                else
                        vis_txt_ccfs = 'on';    vis_pop_ccfs = 'on';
                end

        elseif  num_mode==2

        elseif  num_mode==3
                Level_Anal = wmemtool('rmb',win_dw1dtool,n_param_anal,...
                                                ind_lev_anal);

                [flg_axe,sa_flg,app_flg,sd_flg,det_flg,ccfs_m] = ...
                                dw1dvmod('get_vm',win_dw1dtool,num_mode,0);
                l_s_flg = flg_axe(1);
                r_s_flg = flg_axe(2);   
                val_cfs = flg_axe(3);
                val_flg = [l_s_flg , sa_flg , r_s_flg , sd_flg];
                vis_str = getonoff([1 l_s_flg l_s_flg 1 r_s_flg r_s_flg ]);
                if val_cfs==0
                        vis_txt_ccfs = 'off';   vis_pop_ccfs = 'off';
                else
                        vis_txt_ccfs = 'on';    vis_pop_ccfs = 'on';
                end
                pus_app_all     = findobj(pus_handles,'Tag',tag_app_all);
                pus_det_all     = findobj(pus_handles,'Tag',tag_det_all);
                chk_app_lst     = get(pus_app_all,'Userdata');
                chk_det_lst     = get(pus_det_all,'Userdata');
                for k=1:Level_Anal , set(chk_app_lst(k),'Value',app_flg(k)); end
                for k=1:Level_Anal , set(chk_det_lst(k),'Value',det_flg(k)); end

        elseif  num_mode==4
                Level_Anal = wmemtool('rmb',win_dw1dtool,n_param_anal,...
                                                ind_lev_anal);
                [flg_axe,flg_sa,flg_app,flg_sd,flg_det,ccfs_m] = ...
                                dw1dvmod('get_vm',win_dw1dtool,num_mode,0);
                if flg_axe(3)== 0
                        vis_txt_ccfs = 'off';   vis_pop_ccfs = 'off';
                else
                        vis_txt_ccfs = 'on';    vis_pop_ccfs = 'on';
                end
                vis_str = getonoff([1 flg_axe([1 1]) 1 flg_axe([2 2])]);
                val_flg = [1 flg_sa 1 flg_sd flg_axe(3)];
                val_app = flg_app;
                val_det = flg_det;
                val_cfs = flg_axe(3);

                pus_app_all     = findobj(pus_handles,'Tag',tag_app_all);
                pus_app_none    = findobj(pus_handles,'Tag',tag_app_none);
                pus_det_all     = findobj(pus_handles,'Tag',tag_det_all);
                pus_det_none    = findobj(pus_handles,'Tag',tag_det_none);
                txt_handles     = findobj(win_dw1d_more,'Style','text');
                txt_app_txt     = findobj(txt_handles,'Tag',tag_app_txt);
                txt_det_txt     = findobj(txt_handles,'Tag',tag_det_txt);
                chk_app_lst     = get(pus_app_all,'Userdata');
                chk_det_lst     = get(pus_det_all,'Userdata');
                for k=1:Level_Anal , set(chk_app_lst(k),'Value',val_app(k)); end
                for k=1:Level_Anal , set(chk_det_lst(k),'Value',val_det(k)); end
                set([txt_app_txt; pus_app_all; pus_app_none; chk_app_lst],...
                                'Visible',vis_str(3,:));
                set([txt_det_txt; pus_det_all; pus_det_none; chk_det_lst],...
                                'Visible',vis_str(6,:));

        elseif  num_mode==5

        end
        if find(num_mode==[1 3 4])
                set(chk_app_on, 'Visible',vis_str(1,:),'Value',val_flg(1));
                set(chk_s_app,  'Visible',vis_str(2,:),'Value',val_flg(2));
                set(chk_ss_app, 'Visible',vis_str(3,:),'Value',val_flg(3));
                set(chk_det_on, 'Visible',vis_str(4,:),'Value',val_flg(4));
                set(chk_s_det,  'Visible',vis_str(5,:),'Value',val_flg(5));
                set(chk_ss_det, 'Visible',vis_str(6,:),'Value',val_flg(6));
                set(chk_cfs_on, 'Value',val_cfs);
                set(txt_ccfs,   'Visible',vis_txt_ccfs);
                set(pop_ccfs,   'Visible',vis_pop_ccfs,'Value',ccfs_m);
        end

        % Restore old view mode options
        %-------------------------------
        dw1ddisp('apply',win_dw1dtool,win_dw1d_more);

%*************************%
%** OPTION = 'close' -  **%
%*************************%
elseif strcmp(option,'close')
        close(in3);
        dw1dutil('enable',win_dw1dtool,'end_more_disp');

        % End waiting.
        %---------------
        wwaiting('off',win_dw1dtool);

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('dw1ddisp','Unknown Option','msg');
        error('*');
end




