function out1 = dw1dmngr(option,win_dw1dtool,in3,in4,in5)
%DW1DMNGR Discret wavelet 1D general manager.
%       out1 = dw1dmngr(option,win_dw1dtool,in3,in4,in5)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:08:15 $

% Default values.
%----------------
max_lev_anal     = 12;

% MemBloc0 of stored values.
%---------------------------
n_InfoInit      = 'DW1D_InfoInit';
ind_filename    =  1;
ind_pathname    =  2;
nb0_stored      =  2;

% MemBloc1 of stored values.
%---------------------------
n_param_anal    = 'DWAn1d_Par_Anal';
ind_sig_name    =  1;
ind_sig_size    =  2;
ind_wav_name    =  3;
ind_wav_len     =  4;
ind_lev_anal    =  5;
ind_axe_ref     =  6;
ind_act_option  =  7;
ind_ssig_type   =  8;
nb1_stored      =  8;

% MemBloc2 of stored values.
%---------------------------
n_coefs_longs   = 'Coefs_and_Longs';
ind_coefs       = 1;
ind_longs       = 2;
nb2_stored      = 2;

%***********************************************%
%** OPTION = 'ini' - Only for precompilation. **%
%***********************************************%
if strcmp(option,'ini') , return; end
%***********************************************%

%*************************%
%** OPTION = 'anal' -   **%
%*************************%
if strcmp(option,'anal')
        active_option = wmemtool('rmb',win_dw1dtool,n_param_anal,...
                                        ind_act_option);
        if ~strcmp(active_option,'load_sig')

                % Test for new Analysis.
                %-----------------------
                % new = wwaitans(win_dw1dtool,'New Analysis ?');
                % if new==0 , return; end

                % Cleaning.
                %----------
                Signal_Anal = dw1dfile('sig',win_dw1dtool);
                wwaiting('msg',win_dw1dtool,'Wait ... cleaning');
                dw1dutil('clean',win_dw1dtool,'load_sig','new_anal');

                % Setting GUI values.
                %--------------------
                dw1dutil('set_gui',win_dw1dtool,'load_sig','new_anal');

                % Drawing.
                %---------
                dw1dvdrv('plot_sig',win_dw1dtool,Signal_Anal);

                % Setting enabled values.
                %------------------------
                dw1dutil('enable',win_dw1dtool,'load_sig');

        else
                wmemtool('wmb',win_dw1dtool,n_param_anal,ind_act_option,'anal');
        end

        % Waiting message.
        %-----------------
        wwaiting('msg',win_dw1dtool,'Wait ... computing');
        drawnow

        % Setting Analysis parameters
        %-----------------------------
        dw1dutil('set_par',win_dw1dtool,option);

        % Setting GUI values.
        %--------------------
        dw1dutil('set_gui',win_dw1dtool,option);
        mousefrm(0,'watch');

        % Computing
        %-----------
        if strcmp(active_option,'load_dec')
                dw1dfile('anal',win_dw1dtool,'new_anal');
        else
                dw1dfile('anal',win_dw1dtool);
        end

        % Drawing.
        %---------
        dw1dvdrv('plot_anal',win_dw1dtool);

        % Setting enabled values.
        %------------------------
        dw1dutil('enable',win_dw1dtool,option);

        % End waiting.
        %-------------
        wwaiting('off',win_dw1dtool);

%*************************%
%** OPTION = 'synt' -   **%
%*************************%
elseif strcmp(option,'synt')
        active_option = wmemtool('rmb',win_dw1dtool,n_param_anal,...
                                        ind_act_option);
        if ~strcmp(active_option,'load_cfs')

                % Test for new Synthesis.
                %-----------------------
                % new = wwaitans(win_dw1dtool,'New Synthesis ?');
                % if new==0 , return; end

                % Cleaning.
                %----------
                wwaiting('msg',win_dw1dtool,'Wait ... cleaning');
                dw1dutil('clean',win_dw1dtool,'load_cfs','new_synt');

                % Setting GUI values.
                %--------------------
                dw1dutil('set_gui',win_dw1dtool,'load_cfs');

                % Drawing.
                %---------
                dw1dvdrv('plot_cfs',win_dw1dtool);

                % Setting enabled values.
                %------------------------
                dw1dutil('enable',win_dw1dtool,'load_cfs');

        else
                wmemtool('wmb',win_dw1dtool,n_param_anal,ind_act_option,'synt');
        end

        % Begin waiting.
        %--------------
        wwaiting('msg',win_dw1dtool,'Wait ... computing');

        % Setting Analysis parameters
        %-----------------------------
        dw1dutil('set_par',win_dw1dtool,option);

        % Setting GUI values.
        %--------------------
        dw1dutil('set_gui',win_dw1dtool,option);

        % Computing
        %-----------
        dw1dfile('anal',win_dw1dtool,'synt');

        % Computing & Drawing.
        %----------------------
        dw1dvdrv('plot_synt',win_dw1dtool);

        % Setting enabled values.
        %------------------------
        dw1dutil('enable',win_dw1dtool,option);

        % End waiting.
        %-------------
        wwaiting('off',win_dw1dtool);

%*************************%
%** OPTION = 'stat' -   **%
%*************************%
elseif strcmp(option,'stat')
        mousefrm(0,'watch');
        drawnow;
        out1 = feval('dw1dstat','create',win_dw1dtool);

%*************************%
%** OPTION = 'hist' -   **%
%*************************%
elseif strcmp(option,'hist')
        mousefrm(0,'watch');
        drawnow;
        out1 = feval('dw1dhist','create',win_dw1dtool);

%*************************%
%** OPTION = 'comp' -   **%
%*************************%
elseif strcmp(option,'comp')
        mousefrm(0,'watch');
        drawnow;
        dw1dutil('enable',win_dw1dtool,option);
        out1 = feval('dw1dcomp','create',win_dw1dtool);

%*************************%
%** OPTION = 'deno' -   **%
%*************************%
elseif strcmp(option,'deno')
        mousefrm(0,'watch');
        drawnow;
        dw1dutil('enable',win_dw1dtool,option);
        out1 = feval('dw1ddeno','create',win_dw1dtool);

%********************************************%
%** OPTION = 'return_comp' or 'return_deno'**%
%********************************************%
elseif strcmp(option,'return_comp') | strcmp(option,'return_deno')
        % in3 = 1 : preserve compression
        % in3 = 0 : discard compression
        % in4 = hld_lin (optional)
        %--------------------------------------

        if in3==1
                % Begin waiting.
                %--------------
                wwaiting('msg',win_dw1dtool,'Wait ... drawing');

                % Computing
                %-----------
                dw1dfile('comp_ss',win_dw1dtool,in4);
                
                % Cleaning axes & drawing.
                %------------------------
                dw1dvmod('ss_vm',win_dw1dtool,[1 4],1,0);
                dw1dvmod('ss_vm',win_dw1dtool,[2 3 5],1);
                dw1dvmod('ch_vm',win_dw1dtool,2);

                % End waiting.
                %-------------
                wwaiting('off',win_dw1dtool);
        end
        dw1dutil('enable',win_dw1dtool,option);

%****************************%
%** OPTION = 'load_sig' -  **%
%****************************%
elseif strcmp(option,'load_sig')
        % Testing file.
        %-------------
        [xpos,ypos] = wfigutil('left_up',win_dw1dtool,10,30);
        [filename,pathname] = ...
                        uigetfile('*.mat','Load Signal',xpos,ypos);
        if filename~=0 & ~isempty(filename)
                [Signal_Name,ext] = strtok(filename,'.');
                % PROVISOIRE PROBLEME UIGETFILE PC (MAJ/MIN)
                Signal_Name = lower(Signal_Name);
                ext  = lower(ext);
                if ~strcmp(ext,'.mat')
                        msg = 'Invalid file name (ext = .mat) !';
                        errordlg(msg,'Load Signal ERROR','off');
                        return; 
                end
        else
                return;
        end

        % Loading file.
        %--------------
        wwaiting('msg',win_dw1dtool,'Wait ... loading');
        LoSaFlag = 'load'; wloasavf;
        if err
                msg = ['File ' Signal_Name ' not found!'];
        elseif  exist(deblank(Signal_Name))~=1
                err = 1;
                msg = ['File ' Signal_Name ' doesn''t contain variable ' ...
                               Signal_Name '.'];
        else
                Signal_Anal = eval(Signal_Name);
                siz         = size(Signal_Anal);
                if min(siz)>1
                        err = 1;
                        msg = [Signal_Name ' is not a one dimensional Signal.'];
                elseif  siz(1)>1
                        Signal_Anal = (Signal_Anal)';
                end
        end
        if err
                wwaiting('off',win_dw1dtool);
                errordlg(msg,'Load Signal ERROR','off');
                return
        end
        Signal_Size = length(Signal_Anal);

        % Cleaning.
        %----------
        wwaiting('msg',win_dw1dtool,'Wait ... cleaning');
        dw1dutil('clean',win_dw1dtool,option,'');

        % Setting Analysis parameters.
        %-----------------------------
        wmemtool('wmb',win_dw1dtool,n_param_anal,...
                        ind_act_option,option,     ...
                        ind_sig_name,Signal_Name,  ...
                        ind_sig_size,Signal_Size   ...
                        );
        wmemtool('wmb',win_dw1dtool,n_InfoInit, ...
                        ind_filename,filename,  ...
                        ind_pathname,pathname   ...
                        );

        % Setting GUI values.
        %--------------------
        dw1dutil('set_gui',win_dw1dtool,option,'');

        % Drawing.
        %---------
        dw1dvdrv('plot_sig',win_dw1dtool,Signal_Anal);

        % Setting enabled values.
        %------------------------
        dw1dutil('enable',win_dw1dtool,option);

        % End waiting.
        %-------------
        wwaiting('off',win_dw1dtool);

%*************************%
%** option = 'load_cfs' **%
%*************************%
elseif strcmp(option,'load_cfs')
        % Testing file.
        %--------------
        if nargin==2
                [xpos,ypos] = wfigutil('left_up',win_dw1dtool,10,30);
                [filename,pathname] = uigetfile('*.mat',...
                                'Load Coefficients (1D)',xpos,ypos);
                if filename==0 | isempty(filename) , return; end

                % Begin waiting.
                %--------------
                wwaiting('msg',win_dw1dtool,'Wait ... loading');

                % Loading file.
                %--------------
                LoSaFlag = 'load'; wloasavf;
                if err==1
                        msg = ['File ' filename ' not found!'];
                else
                        if      ~exist('coefs') , err = 1; var = 'coefs';
                        elseif  ~exist('longs') , err = 1; var = 'longs';
                        end
                        if err==1
                                msg = ['variable : ' var ' , not found !'];
                        end
                end
                if err==1
                        wwaiting('off',win_dw1dtool);
                        errargt('dw1dmngr',msg,'msg');
                        return;
                end
                lev = length(longs)-2;
                if lev>max_lev_anal
                        wwaiting('off',win_dw1dtool);
                        warndlg(['The level of the decomposition is too large (max =' ...
                                int2str(max_lev_anal) ' ).'],'Load Coefficients (1D)');
                        return  
                end
                [Signal_Name,ext] = strtok(filename,'.');
                Signal_Name = lower(Signal_Name);
                in3         = '';

        elseif nargin==3

        end

        % Cleaning.
        %----------
        wwaiting('msg',win_dw1dtool,'Wait ... cleaning');
        dw1dutil('clean',win_dw1dtool,option,in3);

        if nargin==2
                % Getting Analysis parameters.
                %-----------------------------
                len             = length(longs);
                Signal_Size     = longs(len);
                Level_Anal      = len-2;

                % Setting Analysis parameters
                %-----------------------------
                wmemtool('wmb',win_dw1dtool,n_param_anal,       ...
                                ind_act_option,option,          ...
                                ind_sig_name,Signal_Name,       ...
                                ind_lev_anal,Level_Anal,        ...
                                ind_sig_size,Signal_Size        ...
                                );
                wmemtool('wmb',win_dw1dtool,n_InfoInit, ...
                        ind_filename,filename,          ...
                        ind_pathname,pathname           ...
                        );

                % Setting coefs and longs.
                %-------------------------
                wmemtool('wmb',win_dw1dtool,n_coefs_longs,      ...
                                ind_coefs,coefs,ind_longs,longs);
        end

        % Setting GUI values.
        %--------------------
        dw1dutil('set_gui',win_dw1dtool,option);

        % Drawing.
        %---------
        dw1dvdrv('plot_cfs',win_dw1dtool);

        % Setting enabled values.
        %------------------------
        dw1dutil('enable',win_dw1dtool,option);

        % End waiting.
        %-------------
        wwaiting('off',win_dw1dtool);

%*************************%
%** option = 'load_dec' **%
%*************************%
elseif strcmp(option,'load_dec')
        % Testing file.
        %--------------
        [xpos,ypos] = wfigutil('left_up',win_dw1dtool,10,30);
        [filename,pathname] = uigetfile('*.wa1',...
                        'Load Wavelet Analysis (1D)',xpos,ypos);
        if filename==0 | isempty(filename) , return; end

        % Begin waiting.
        %--------------
        wwaiting('msg',win_dw1dtool,'Wait ... loading');

        % Loading file.
        %--------------
        LoSaFlag = 'load'; wloasavf;
        if err==1
                msg = ['File ' filename ' not found!'];
                wwaiting('off',win_dw1dtool);
                errargt('dw1dmngr',msg,'msg');
                return;
        end
        if ~exist('coefs')         , err = 1; var = 'coefs';
        elseif ~exist('longs')     , err = 1; var = 'longs';
        elseif ~exist('wave_name') , err = 1; var = 'wave_name';
        elseif ~exist('data_name') , err = 1; var = 'data_name';
        end
        if err==1
           wwaiting('off',win_dw1dtool);
           msg = ['variable : ' var ' , not found !'];
           errargt('dw1dmngr',msg,'msg');
           return;
        end
        lev = length(longs)-2;
        if lev>max_lev_anal
                wwaiting('off',win_dw1dtool);
                warndlg(['The level of the decomposition is too large (max =' ...
                                int2str(max_lev_anal) ' ).'],'Load Wavelet Analysis (1D)');
                return
        end

        % Cleaning.
        %----------
        wwaiting('msg',win_dw1dtool,'Wait ... cleaning');
        dw1dutil('clean',win_dw1dtool,option);

        % Getting Analysis parameters.
        %-----------------------------
        len             = length(longs);
        Signal_Size     = longs(len);
        Level_Anal      = len-2;
        Signal_Name     = data_name;
        Wave_Name       = wave_name;
        Wave_Len        = wavattrb('length',Wave_Name);

        % Setting Analysis parameters
        %-----------------------------
        wmemtool('wmb',win_dw1dtool,n_param_anal,               ...
                                ind_act_option,option,          ...
                                ind_sig_name,Signal_Name,       ...
                                ind_wav_name,Wave_Name,         ...
                                ind_wav_len,Wave_Len,           ...
                                ind_lev_anal,Level_Anal,        ...
                                ind_sig_size,Signal_Size        ...
                                );
        wmemtool('wmb',win_dw1dtool,n_InfoInit, ...
                        ind_filename,filename,  ...
                        ind_pathname,pathname   ...
                        );

        % Setting coefs and longs.
        %-------------------------
        wmemtool('wmb',win_dw1dtool,n_coefs_longs,      ...
                                ind_coefs,coefs,ind_longs,longs);

        % Setting GUI values.
        %--------------------
        dw1dutil('set_gui',win_dw1dtool,option);

        % Computing
        %-----------
        sig_rec = dw1dfile('anal',win_dw1dtool,'load_dec');

        % Drawing.
        %---------
        dw1dvdrv('plot_sig',win_dw1dtool,sig_rec,1);
        dw1dvdrv('plot_anal',win_dw1dtool);

        % Setting enabled values.
        %------------------------
        dw1dutil('enable',win_dw1dtool,option);

        % End waiting.
        %-------------
        wwaiting('off',win_dw1dtool);

%*********************%
%** option = 'demo' **%
%*********************%
elseif strcmp(option,'demo')
        % in3 = Signal_Name
        % in4 = Wave_Name
        % in5 = Level_Anal
        %------------------
        Signal_Name     = in3;
        Wave_Name       = in4;
        Level_Anal      = in5;

        % Begin waiting.
        %--------------
        wwaiting('msg',win_dw1dtool,'Wait ... loading');

        % Loading Signal.
        %----------------
        filename = Signal_Name;
        pathname = 'Wave_TBDemo';
        LoSaFlag = 'load'; wloasavf;
        if err
                wwaiting('off',win_dw1dtool);
                msg = ['File ' Signal_Name ' not found!'];
                errordlg(msg,'Load ERROR','off');
                return
        end
        Signal_Anal = eval(Signal_Name);
        Signal_Size = length(Signal_Anal);

        % Cleaning.
        %----------
        wwaiting('msg',win_dw1dtool,'Wait ... cleaning');
        dw1dutil('clean',win_dw1dtool,option);

        % Setting Analysis parameters
        %-----------------------------
        Wave_Len        = wavattrb('length',Wave_Name);
        wmemtool('wmb',win_dw1dtool,n_param_anal,           ...
                                ind_act_option,option,      ...
                                ind_sig_name,Signal_Name,   ...
                                ind_wav_name,Wave_Name,     ...
                                ind_wav_len,Wave_Len,       ...
                                ind_lev_anal,Level_Anal,    ...
                                ind_sig_size,Signal_Size    ...
                                );
        wmemtool('wmb',win_dw1dtool,n_InfoInit, ...
                        ind_filename,filename,  ...
                        ind_pathname,pathname   ...
                        );

        % Setting GUI values.
        %--------------------
        dw1dutil('set_gui',win_dw1dtool,option);

        % Drawing.
        %---------
        dw1dvdrv('plot_sig',win_dw1dtool,Signal_Anal,1);

        % Computing
        %-----------
        dw1dfile('anal',win_dw1dtool);
        
        % Drawing.
        %---------
        dw1dvdrv('plot_anal',win_dw1dtool);

        % Setting enabled values.
        %------------------------
        dw1dutil('enable',win_dw1dtool,option);

        % End waiting.
        %-------------
        wwaiting('off',win_dw1dtool);

%**************************%
%** option = 'save_synt' **%
%**************************%
elseif strcmp(option,'save_synt')
        % Testing file.
        %--------------
        [xpos,ypos] = wfigutil('left_up',win_dw1dtool,10,30);
        [filename,pathname] = uiputfile('*.mat',...
                        'Save Synthesized Signal',xpos,ypos);
        if filename==0 | isempty(filename) , return; end
        [name,ext] = strtok(filename,'.');
        ext = '.mat';
        filename = [name ext];

        % Begin waiting.
        %--------------
        wwaiting('msg',win_dw1dtool,'Wait ... saving');

        % Getting Analysis values.
        %-------------------------
        ssig = dw1dfile('ssig',win_dw1dtool);

        % Saving file.
        %--------------
        saveStr = lower(name);
        eval([saveStr '= ssig ;']);
        LoSaFlag = 'save'; wloasavf;

        % End waiting.
        %-------------
        wwaiting('off',win_dw1dtool);

        if err
                errargt('dw1dmngr','Save FAILED !','msg');
        end

%*************************%
%** option = 'save_cfs' **%
%*************************%
elseif strcmp(option,'save_cfs')
        % Testing file.
        %--------------
        [xpos,ypos] = wfigutil('left_up',win_dw1dtool,10,30);
        [filename,pathname] = uiputfile('*.mat',...
                        'Save Coefficients (1D)',xpos,ypos);
        if filename==0 | isempty(filename) , return; end

        % Begin waiting.
        %--------------
        wwaiting('msg',win_dw1dtool,'Wait ... saving coefficients');

        [name,ext] = strtok(filename,'.');
        ext = '.mat';
        filename = [name ext];

        % Getting Analysis values.
        %-------------------------
        [coefs,longs] = wmemtool('rmb',win_dw1dtool,n_coefs_longs,...
                                        ind_coefs,ind_longs);

        % Saving file.
        %--------------
        saveStr = ['coefs longs'];
        LoSaFlag = 'save'; wloasavf;

        % End waiting.
        %-------------
        wwaiting('off',win_dw1dtool);

        if err
                errargt('dw1dmngr','Save FAILED !','msg');
        end

%*************************%
%** option = 'save_dec' **%
%*************************%
elseif strcmp(option,'save_dec')
        % Testing file.
        %--------------
        [xpos,ypos] = wfigutil('left_up',win_dw1dtool,10,30);
        [filename,pathname] = uiputfile('*.wa1',...
                        'Save Wavelet Analysis (1D)',xpos,ypos);
        if filename==0 | isempty(filename) , return; end

        % Begin waiting.
        %--------------
        wwaiting('msg',win_dw1dtool,'Wait ... saving decomposition');

        [name,ext] = strtok(filename,'.');
        ext = '.wa1';
        filename = [name ext];

        % Getting Analysis parameters.
        %-----------------------------
        [wave_name,data_name] = ...
                        wmemtool('rmb',win_dw1dtool,n_param_anal,  ...
                                ind_wav_name,ind_sig_name);

        % Getting Analysis values.
        %-------------------------
        [coefs,longs] = wmemtool('rmb',win_dw1dtool,n_coefs_longs,...
                                        ind_coefs,ind_longs);


        % Saving file.
        %--------------
        saveStr = ['coefs longs wave_name data_name'];
        LoSaFlag = 'save'; wloasavf;

        % End waiting.
        %-------------
        wwaiting('off',win_dw1dtool);

        if err
                errargt('dw1dmngr','Save FAILED !','msg');
        end

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('dw1dmngr','Unknown Option','msg');
        error('*');
end
