function [out1,out2] = dw1dscrm(option,win_dw1dtool,in3,in4,in5)
%DW1DSCRM Discret wavelet 1D show and scroll mode manager.
%       [out1,out2] = dw1dscrm(option,win_dw1dtool,in3,in4,in5)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:08:21 $

% Default values.
%----------------
default_nbcolors = 128;

% MemBloc1 of stored values.
%---------------------------
n_param_anal    = 'DWAn1d_Par_Anal';
ind_sig_name    =  1;
ind_sig_size    =  2;
ind_wav_name    =  3;
ind_wav_len     =  4;
ind_lev_anal    =  5;
ind_axe_ref     =  6;
ind_act_option  =  7;
ind_ssig_type   =  8;
nb1_stored      =  8;

% MemBloc2 of stored values.
%---------------------------
n_coefs_longs   = 'Coefs_and_Longs';
ind_coefs       = 1;
ind_longs       = 2;
nb2_stored      = 2;

% MemBloc4 of stored values.
%---------------------------
n_miscella      = 'DWAn1d_Miscella';
ind_graph_area  =  1;
ind_view_mode   =  2;
ind_savepath    =  3;
nb4_stored      =  3;

% Tag property of objects.
%-------------------------
tag_valapp_scr  = 'ValApp_Scr';
tag_txtapp_scr  = 'TxtApp_Scr';
tag_valdet_scr  = 'ValDet_Scr';
tag_txtdet_scr  = 'TxtDet_Scr';

tag_axeappini   = 'Axe_AppIni';
tag_axedetini   = 'Axe_DetIni';
tag_axecfsini   = 'Axe_CfsIni';
tag_axecolmap   = 'Axe_ColMap';
tag_s_inapp     = 'Sig_in_App';
tag_ss_inapp    = 'SSig_in_App';
tag_s_indet     = 'Sig_in_Det';
tag_ss_indet    = 'SSig_in_Det';
tag_app         = 'App';
tag_det         = 'Det';
tag_img_cfs     = 'Img_Cfs';
tag_img_sca     = 'Img_Sca';

axe_handles     = findobj(win_dw1dtool,'Type','axes');
txt_handles     = findobj(win_dw1dtool,'Style','text');
pop_handles     = findobj(win_dw1dtool,'Style','popupmenu');
axe_app_ini     = findobj(axe_handles,'flat','Tag',tag_axeappini);
axe_det_ini     = findobj(axe_handles,'flat','Tag',tag_axedetini);
axe_cfs_ini     = findobj(axe_handles,'flat','Tag',tag_axecfsini);
axe_col_map     = findobj(axe_handles,'flat','Tag',tag_axecolmap);

if strcmp(option,'app')
        pop = findobj(pop_handles,'Tag',tag_valapp_scr);
        num = get(pop,'Value');
        old = findobj(axe_app_ini,'Tag',tag_app);
        if ~isempty(old)
                hdl_line = findobj(old,'Userdata',num);
                if ~isempty(hdl_line)
                        ii = find(old==hdl_line);
                        old(ii) = [];
                        num = 0;
                        eval(['delete(old)'],'err = 1;')
                        return
                end
        end

        % Begin waiting.
        %---------------
        wwaiting('msg',win_dw1dtool,'Wait ... computing');

        eval(['delete(old)'],'err = 1;')
        x = dw1dfile('app',win_dw1dtool,num);
        Level_Anal = wmemtool('rmb',win_dw1dtool,n_param_anal,...
                                                ind_lev_anal);
        axes(axe_app_ini);
        col_app = dw1dcolo('app',Level_Anal);
        line('Xdata',[1:length(x)],'Ydata',x,...
                'Color',col_app(num,:),'Tag',tag_app,'Userdata',num);
        str_tit = get(get(axe_app_ini,'title'),'String');
        ind = findstr(str_tit,'level');
        str_tit = [str_tit(1:ind+5) int2str(num)];
        title(str_tit);

        % End waiting.
        %-------------
        wwaiting('off',win_dw1dtool);

elseif strcmp(option,'det')
        pop = findobj(pop_handles,'Tag',tag_valdet_scr);
        num = get(pop,'Value');
        old = findobj(axe_det_ini,'Tag',tag_det);
        if ~isempty(old)
                hdl_line = findobj(old,'Userdata',num);
                if ~isempty(hdl_line)
                        ii = find(old==hdl_line);
                        old(ii) = [];
                        num = 0;
                        eval(['delete(old)'],'err = 1;')
                        return                  
                end
        end

        % Begin waiting.
        %---------------
        wwaiting('msg',win_dw1dtool,'Wait ... computing');

        eval(['delete(old)'],'err = 1;')
        ll = findobj(axe_det_ini,'type','line','Visible','On');
        if isempty(ll)
                [x,set_ylim,ymin,ymax] = dw1dfile('det',win_dw1dtool,num,1);
        else
                set_ylim = 0;
                x = dw1dfile('det',win_dw1dtool,num);
        end
        Level_Anal = wmemtool('rmb',win_dw1dtool,n_param_anal,ind_lev_anal);
        axes(axe_det_ini);
        col_det = dw1dcolo('det',Level_Anal);
        line('Xdata',[1:length(x)],'Ydata',x,...
                'Color',col_det(num,:),'Tag',tag_det,'Userdata',num);
        if set_ylim , set(axe_det_ini,'Ylim',[ymin,ymax]); end
        str_tit = get(get(axe_det_ini,'title'),'String');
        ind = findstr(str_tit,'level');
        str_tit = [str_tit(1:ind+5) int2str(num)];
        title(str_tit);

        % End waiting.
        %-------------
        wwaiting('off',win_dw1dtool);

elseif strcmp(option,'plot_sig')
        % in3 = signal
        % in4 = display mode
        % in5 = sig  visibility  
        %----------------------
        if      nargin==3 , in4 = 1; in5 = 1;
        elseif  nargin==4 , in5 = 1; 
        end
        if in4==1 , v = 1; else , v = 0; end
        axe_hdl = dw1dscrm('axes',win_dw1dtool,[1 1 1],1);
        vsig = getonoff(in5);
        set(axe_hdl(1),'Visible',vsig);
        set(axe_hdl(2:4),'Visible',getonoff(v));

        % Drawing.
        %---------
        axes(axe_hdl(1));
        title('Loaded Signal');
        col_s   = dw1dcolo('sig');
        line('Xdata',[1:length(in3)],'Ydata',in3,...
                'Color',col_s,'Visible',vsig,'Tag',tag_s_inapp);

        axes(axe_hdl(2));
        xmin = 1;               xmax = length(in3);
        ymin = min(in3)-eps;    ymax = max(in3)+eps;
        line('Xdata',[xmin:xmax],'Ydata',in3,...
                'Color',col_s,'Visible','Off','Tag',tag_s_indet);
        set(axe_hdl(1:3),'Xlim',[xmin xmax],'Ylim',[ymin ymax]);

elseif strcmp(option,'plot_anal')
        lin_handles     = findobj(axe_handles,'Type','line');
        ss_in_app       = findobj(lin_handles,'Tag',tag_ss_inapp);
        if isempty(ss_in_app)
                col_ss  = dw1dcolo('ssig');
                ss_rec  = dw1dfile('ssig',win_dw1dtool);
                axes(axe_app_ini);
                line('Xdata',[1:length(ss_rec)],'Ydata',ss_rec,'Zdata',2*ones(size(ss_rec)),...
                        'Color',col_ss,'Visible','Off','Tag',tag_ss_inapp);

                axes(axe_det_ini);
                line('Xdata',[1:length(ss_rec)],'Ydata',ss_rec,'Zdata',2*ones(size(ss_rec)),...
                        'Color',col_ss,'Visible','Off','Tag',tag_ss_indet);

                clear ss_rec
        end

        Level_Anal = wmemtool('rmb',win_dw1dtool,n_param_anal,ind_lev_anal);
        axes(axe_app_ini);
        [app_rec,set_ylim,ymin,ymax] = dw1dfile('app',win_dw1dtool,1,1);
        ylim = get(axe_app_ini,'Ylim');
        if ylim(1)<ymin , ymin = ylim(1); end
        if ylim(2)>ymax , ymax = ylim(2); end
        col_app = dw1dcolo('app',Level_Anal);
        line('Xdata',[1:length(app_rec)],'Ydata',app_rec,...
                'Color',col_app(1,:),'Tag',tag_app,'Userdata',1);
        title(['Signal and Approximation at level ' int2str(1)])
        set(axe_app_ini,'Ylim',[ymin,ymax]);
        clear app_rec

        axes(axe_det_ini);
        [det_rec,set_ylim,ymin,ymax] = dw1dfile('det',win_dw1dtool,1,1);
        col_det = dw1dcolo('det',Level_Anal);
        line('Xdata',[1:length(det_rec)],'Ydata',det_rec,...
                'Color',col_det(1,:),'Tag',tag_det,'Userdata',1);
        if set_ylim , set(axe_det_ini,'Ylim',[ymin,ymax]); end
        title(['Detail at level ' int2str(1)])
        clear det_rec

        clear longs coefs
        axes(axe_cfs_ini);
        [det_cfs,xlim1,xlim2,ymax,ymin,nb_cla,levs,ccfs_vm] = ...
                                dw1dmisc('col_cfs',win_dw1dtool);
        img_cfs = image([1 xlim2],[ymax ymin],det_cfs,  ...
                        'Tag',tag_img_cfs,              ...
                        'Userdata',[ccfs_vm,levs,xlim1,xlim2,nb_cla]);
        levlab = int2str(levs(1));
        for k = 2:length(levs)
            levlab = str2mat(levlab,int2str(levs(k)));
        end
        set(axe_cfs_ini,'YTicklabelMode','manual',  ...
                        'YTick',[1:length(levs)],   ...
                        'YTickLabels',levlab,       ...
                        'Tag',tag_axecfsini         ...
                        );
        title('Details Coefficients');
        clear dec_cfs

        axes(axe_col_map);
        image([0 1],[0 1],[1:nb_cla],'Tag',tag_img_sca);
        set(axe_col_map,...
                'XTickLabels',[],'YTickLabels',[],...
                'XTick',[],'YTick',[],'Tag',tag_axecolmap);
        wsetxlab(axe_col_map,'Scale of colors from MIN to MAX',-10);

        % Reference axes used by stat. & histo & ...
        %-------------------------------------------
        wmemtool('wmb',win_dw1dtool,n_param_anal,ind_axe_ref,axe_app_ini);

        % Axes attachment.
        %-----------------
        dw1dscrm('dynvtool',win_dw1dtool);

elseif strcmp(option,'plot_cfs')
        % in3 = display mode
        %------------------
        if nargin==2 , in3 = 1; end
        if in3==1 , v = 1; else , v = 0; end
        v = 0;  % force l'affichage des coefficients

        axe_hdl = dw1dscrm('axes',win_dw1dtool,[1 v 1],1);
        set(axe_hdl(2),'Visible',getonoff(v));
        set(axe_hdl(1,3:4),'Visible','On');

        Signal_Size = wmemtool('rmb',win_dw1dtool,n_param_anal,ind_sig_size);
        xmin = 1;       xmax = Signal_Size;
        ta3 = 'Loaded Details Coefficients (Colored)';
        if v
                set(axe_hdl(1:3),'Xlim',[xmin xmax]);
        else
                [coefs,longs]   = wmemtool('rmb',win_dw1dtool,...
                                                n_coefs_longs,ind_coefs,ind_longs);
                coefs = coefs(longs(1)+1:length(coefs));
                longs = longs(2:length(longs)-1);
                nbd   = length(longs);
                ymin = min(coefs);
                ymax = max(coefs);
                if ymin==ymax , dy = 0.001; else ,dy = (ymax-ymin)/20; end
                ymin = ymin-dy; ymax = ymax+dy;
                set(axe_hdl(1),'Xlim',[1 length(coefs)],'Ylim',[ymin ymax]);
                axes(axe_hdl(1));
                title(['Loaded Details Coefficients from level '...
                         int2str(nbd) ' to level 1.']);
                line('Xdata',[1:length(coefs)],'Ydata',coefs,'Color','y');
                x = 0;
                for k = 1:nbd-1
                        x = x+longs(k);
                        line('Xdata',[x x],'Ydata',[ymin ymax],'Color','m');
                end
                drawnow
                set(axe_hdl(2:3),'Xlim',[xmin xmax]);
        end

        axes(axe_hdl(3));
        [det_cfs,xlim1,xlim2,ylim2,ylim1,nb_cla,levs,ccfs_vm] = ...
                                dw1dmisc('col_cfs',win_dw1dtool);
        levlab = int2str(levs(1));
        for k = 2:length(levs)
            levlab = str2mat(levlab,int2str(levs(k)));
        end
        img_cfs = image([1 xlim2],[ylim2 ylim1],det_cfs,        ...
                        'Tag',tag_img_cfs,              ...
                        'Userdata',[ccfs_vm,levs,xlim1,xlim2,nb_cla]);
        title(ta3);
        set(axe_hdl(3),'YTicklabelMode','manual',   ...
                        'YTick',[1:length(levs)],   ...
                        'YTickLabels',levlab,       ...
                        'Tag',tag_axecfsini         ...
                        );

        axes(axe_hdl(4));
        image([0 1],[0 1],[1:nb_cla],'Tag',tag_img_sca);
        set(axe_hdl(4),...
                'XTickLabels',[],'YTickLabels',[],...
                'XTick',[],'YTick',[],'Tag',tag_axecolmap);
        wsetxlab(axe_hdl(4),'Scale of colors from MIN to MAX',-10);

        if v==0
                set(axe_hdl(1),'Xlim',[1 length(coefs)],'Ylim',[ymin ymax]);
        end

elseif strcmp(option,'plot_synt')

        % Getting  Synthesis parameters.
        %------------------------------
        Level_Anal = wmemtool('rmb',win_dw1dtool,n_param_anal,ind_lev_anal);

        % Computing Decomposition.
        %-------------------------

        col_s   = dw1dcolo('sig');
        col_ss  = dw1dcolo('ssig');
        col_app = dw1dcolo('app',Level_Anal);
        col_det = dw1dcolo('det',Level_Anal);

        delete(get(axe_app_ini,'Children'));
        axe_hdl = dw1dscrm('axes',win_dw1dtool,[1 1 1],0);
        set(axe_hdl,'Visible','On');

        axes(axe_app_ini);
        sig_rec = dw1dfile('sig',win_dw1dtool);
        line('Xdata',[1:length(sig_rec)],'Ydata',sig_rec,...
                'Color',col_s,'Tag',tag_s_inapp);
        line('Xdata',[1:length(sig_rec)],'Ydata',sig_rec,'Zdata',2*ones(size(sig_rec)),...
                        'Color',col_ss,'Visible','Off','Tag',tag_ss_inapp);

        app_rec = dw1dfile('app',win_dw1dtool,1);
        line('Xdata',[1:length(app_rec)],'Ydata',app_rec,...
                'Color',col_app(1,:),'Tag',tag_app,'Userdata',1);
        title(['Original Synthesized Signal and Approximation at level ' ...
                        int2str(1)])
        clear app_rec
        axes(axe_det_ini);
        [det_rec,set_ylim,ymin,ymax] = dw1dfile('det',win_dw1dtool,1,1);
        line('Xdata',[1:length(sig_rec)],'Ydata',sig_rec,...
                'Color',col_s,'Visible','Off','Tag',tag_s_indet);
        line('Xdata',[1:length(sig_rec)],'Ydata',sig_rec,'Zdata',2*ones(size(sig_rec)),...
                'Color',col_ss,'Visible','Off','Tag',tag_ss_indet);

        line('Xdata',[1:length(det_rec)],'Ydata',det_rec,...
                'Color',col_det(1,:),'Tag',tag_det,'Userdata',1);
        if set_ylim , set(axe_det_ini,'Ylim',[ymin ymax]); end
        title(['Detail at level ' int2str(1)])

        axes(axe_cfs_ini);
        title('Details Coefficients');

        axes(axe_col_map);
        wsetxlab(axe_col_map,'Scale of colors from MIN to MAX',-10);

        % Reference axes used by stat. & histo & ...
        %-------------------------------------------
        wmemtool('wmb',win_dw1dtool,n_param_anal,ind_axe_ref,axe_app_ini);

        % Axes attachment.
        %-----------------
        dw1dscrm('dynvtool',win_dw1dtool);

elseif strcmp(option,'view')
        % in3 = old_mode
        %       in3 = -1 : same mode
        %       in3 =  0 : clean 
        %       in3 =  1 : scr mode
        %       in3 =  2 : dec mode
        %       in3 =  3 : sep mode
        %       in3 =  4 : sup mode
        %       in3 =  5 : tre mode
        %-------------------------------
        old_mode = in3;
        [flg_axe,flg_sa,flg_app,flg_sd,flg_det,ccfs_m] = ...
                                dw1dvmod('get_vm',win_dw1dtool,1);
        v_flg = [flg_sa , flg_app , flg_sd , flg_det , flg_axe(3)];
        if flg_axe(1)== 0 , v_flg(1:3) = zeros(1,3); end
        if flg_axe(2)== 0 , v_flg(4:6) = zeros(1,3); end
        if flg_axe(3)== 0 , v_flg(7)   = 0; end

        pop_app         = findobj(pop_handles,'Tag',tag_valapp_scr);
        lev_a           = get(pop_app,'Value');
        pop_det         = findobj(pop_handles,'Tag',tag_valdet_scr);
        lev_d           = get(pop_det,'Value');

        vis_str         = getonoff(v_flg);
        v_s_app         = vis_str(1,:);
        v_ss_app        = vis_str(2,:);
        v_app           = vis_str(3,:);
        v_s_det         = vis_str(4,:);
        v_ss_det        = vis_str(5,:);
        v_det           = vis_str(6,:);
        v_cfs           = vis_str(7,:);

        axe_hdl         = dw1dscrm('axes',win_dw1dtool,flg_axe);
        lin_handles     = findobj(axe_hdl,'Type','line');
        img_handles     = findobj(axe_hdl,'Type','image');
        s_in_app        = findobj(lin_handles,'Tag',tag_s_inapp);       
        s_in_det        = findobj(lin_handles,'Tag',tag_s_indet);
        app             = findobj(lin_handles,'Tag',tag_app,'Userdata',lev_a);
        ss_in_app       = findobj(lin_handles,'Tag',tag_ss_inapp);
        ss_in_det       = findobj(lin_handles,'Tag',tag_ss_indet);
        det             = findobj(lin_handles,'Tag',tag_det,'Userdata',lev_d);
        img_cfs         = findobj(img_handles,'Tag',tag_img_cfs);       
        img_sca         = findobj(img_handles,'Tag',tag_img_sca);       

        [Wave_Name,opt_act,Level_Anal,ss_type] = ...
                        wmemtool('rmb',win_dw1dtool,n_param_anal,...
                                ind_wav_name,ind_act_option,ind_lev_anal,...
                                                                ind_ssig_type);
        if      ss_type=='ss', str_ss = 'Synthesized Signal';
        elseif  ss_type=='ds', str_ss = 'De-noised Signal';
        elseif  ss_type=='cs', str_ss = 'Compressed Signal';
        end

        if strcmp(opt_act,'synt')
                ini_str = 'Orig. Synt. Sig.';
        else
                ini_str = 'Signal';
        end
        if v_flg(1)==1
                if      v_flg(2)==1
                        str_tit = [ini_str ', ' str_ss ' and']; 
                else    
                        str_tit = [ini_str ' and'];     
                end
        else
                if      v_flg(2)==1
                        str_tit = [str_ss ' and'];      
                else    
                        str_tit = '';   
                end
        end
        axes(axe_hdl(1));
        title([ str_tit ' Approximation at level ' int2str(lev_a)]);

        if v_flg(4)==1
                if      v_flg(5)==1
                        str_tit = [ini_str ', ' str_ss ' and']; 
                else    
                        str_tit = [ini_str ' and'];     
                end
        else
                if      v_flg(5)==1
                        str_tit = [str_ss ' and'];      
                else    
                        str_tit = '';   
                end
        end
        axes(axe_hdl(2));
        title([ str_tit ' Detail at level ' int2str(lev_d)]);

        if isempty(s_in_app)
                x = dw1dfile('sig',win_dw1dtool);
                xmin = 1;               xmax = length(x);
                ymin = min(x)-eps;      ymax = max(x)+eps;
                set(axe_hdl(1:3),'Xlim',[xmin xmax]);
                col_s   = dw1dcolo('sig');
                axes(axe_hdl(1));
                line('Xdata',[xmin:xmax],'Ydata',x,...
                        'Color',col_s,'Visible',v_s_app,'Tag',tag_s_inapp);
                axes(axe_hdl(2));
                line('Xdata',[xmin:xmax],'Ydata',x,...
                        'Color',col_s,'Visible',v_s_det,'Tag',tag_s_indet);
        else
                set(s_in_app,'Visible',v_s_app);
                set(s_in_det,'Visible',v_s_det);
        end
        if isempty(ss_in_app)
                x = dw1dfile('ssig',win_dw1dtool);
                col_ss  = dw1dcolo('ssig');
                axes(axe_hdl(1));
                line('Xdata',[1:length(x)],'Ydata',x,'Zdata',2*ones(size(x)),...
                        'Color',col_ss,'Visible',v_ss_app,'Tag',tag_ss_inapp);


                axes(axe_hdl(2));
                line('Xdata',[1:length(x)],'Ydata',x,'Zdata',2*ones(size(x)),...
                        'Color',col_ss,'Visible',v_ss_det,'Tag',tag_ss_indet);

        else
                set(ss_in_app,'Visible',v_ss_app);
                set(ss_in_det,'Visible',v_ss_det);
        end
        if isempty(app)
                x = dw1dfile('app',win_dw1dtool,lev_a);
                axes(axe_hdl(1));
                col_app = dw1dcolo('app',Level_Anal);
                line('Xdata',[1:length(x)],'Ydata',x,...
                        'Color',col_app(lev_a,:),'Visible',v_app,       ...
                        'Tag',tag_app,'Userdata',lev_a);
        else
                set(app,'Visible',v_app);
        end

        if isempty(det)
                ll = findobj([s_in_det,ss_in_det], 'Visible','on');
                if isempty(ll)
                        [x,set_ylim,ymin,ymax] = ...
                                dw1dfile('det',win_dw1dtool,lev_d,1);
                else
                        set_ylim = 0;
                        x = dw1dfile('det',win_dw1dtool,lev_d);
                end
                axes(axe_hdl(2));
                col_det = dw1dcolo('det',Level_Anal);
                line('Xdata',[1:length(x)],'Ydata',x,...
                        'Color',col_det(lev_d,:),'Visible',v_det,       ...
                        'Tag',tag_det,'Userdata',lev_d);
                if set_ylim , set(axe_hdl(2),'Ylim',[ymin,ymax]); end
        else
                set(det,'Visible',v_det);
        end

        ax_hdl = axe_hdl(3);
        [rep,ccfs_vm,levs,xlim,nb_cla] = ...                            
        dw1dmisc('tst_vm',win_dw1dtool,1,ax_hdl,[1:Level_Anal]);
        if rep==1 ,  delete(img_cfs); img_cfs = []; end
        if isempty(img_cfs)
                [x,xlim1,xlim2,ymax,ymin,nb_cla,levs,ccfs_vm] = ...
                        dw1dmisc('col_cfs',win_dw1dtool,...
                                                ccfs_vm,levs,xlim,nb_cla);
                axes(ax_hdl);
                img_cfs = image([1 xlim2],[ymax ymin],x,        ...
                                'Visible',v_cfs,                ...
                                'Tag',tag_img_cfs,              ...
                                'Userdata',[ccfs_vm,levs,xlim1,xlim2,nb_cla]);
                xlim = get(axe_hdl(1),'Xlim');
                levlab = int2str(levs(1));
                for k = 2:length(levs)
                    levlab = str2mat(levlab,int2str(levs(k)));
                end
                set(axe_hdl(3), ...
                                'Xlim',xlim,               ...     
                                'YTicklabelMode','manual', ...
                                'YTick',[1:length(levs)],  ...
                                'YTickLabels',levlab,      ...
                                'Tag',tag_axecfsini        ...
                                );
                clear x
                axes(axe_hdl(4));
                image([0 1],[0 1],[1:nb_cla],'Visible',v_cfs,'Tag',tag_img_sca);
                set(axe_hdl(4),...
                        'XTickLabels',[],'YTickLabels',[],...
                        'XTick',[],'YTick',[],'Tag',tag_axecolmap);
        else
                set([img_cfs img_sca],'Visible',v_cfs);
        end
        set(axe_hdl(3:4),'Visible',v_cfs);

        axes(axe_hdl(3));
        title('Details Coefficients');
        if strcmp(deblankl(v_cfs),'on') 
                drawnow
                wsetxlab(axe_hdl(4),'Scale of colors from MIN to MAX',-10);
        end

        % Axes attachment.
        %-----------------
        dw1dscrm('dynvtool',win_dw1dtool,old_mode);

        % Reference axes used by stat. & histo & ...
        %-------------------------------------------
        wmemtool('wmb',win_dw1dtool,n_param_anal,ind_axe_ref,axe_hdl(1));

elseif strcmp(option,'dynvtool')
        % in3 = -1 : same mode
        % in3 =  0 : clean 
        % in3 =  1 : scr mode
        % in3 =  2 : dec mode
        % in3 =  3 : sep mode
        % in3 =  4 : sup mode
        % in3 =  5 : tre mode
        %--------------------

        % Axes attachment.
        %-----------------
        if nargin==2 , in3 = 0; end
        if find(in3==[0 2 3 5])
                dynvtool('attach',win_dw1dtool,...
                        [],[axe_app_ini axe_det_ini],[axe_cfs_ini],[1 0],...
                        '','','');
                dynvtool('put',win_dw1dtool);
        end
        
elseif strcmp(option,'axes')
        % in3 flag for axes visibility
        % in4 flag for clearing axes
        % in4 = 1 , clear axes.
        %---------------------------
        if      nargin==2 
                flg_axe = [1 1 1];      clear_axes = 1;
        elseif nargin==3
                flg_axe = in3;          clear_axes = 0;
        elseif nargin==4
                flg_axe = in3;          clear_axes = in4;       
        end

        % Axes Positions.
        %----------------
        nb_axes = sum(flg_axe);
        pos_graph = wmemtool('rmb',win_dw1dtool,n_miscella,ind_graph_area);
        pos_win = get(win_dw1dtool,'Position');
        bdx     = 0.06*pos_win(3);
        bdy     = 0.08*pos_win(4);
        bdy0    = 0.04*pos_win(4);
        bdy1    = 0.04*pos_win(4);
        bdy2    = 0.06*pos_win(4);
        %--------------------- Scale of Colors Axes ----------------------%
        h_col   = 0.02*pos_win(4);
        w_col   = pos_graph(3)/3;
        x_col   = pos_graph(1)+w_col;
        y_col   = pos_graph(2)+bdy0;
        pos_ax          = zeros(4,4);
        pos_ax(4,:)     = [x_col , y_col , w_col , h_col];
        %-----------------------------------------------------------------%
        if nb_axes==0 , nb_axes = 3 ;end
        xleft   = pos_graph(1)+bdx;
        width   = pos_graph(3)-2*bdx;
        hy = pos_graph(4)-(nb_axes-1)*bdy-bdy0-bdy2;
        if      flg_axe(3)==1
                ylow            = y_col+h_col+bdy1;
                height          = (hy-bdy1-h_col)/nb_axes;
                pos_ax(3,:)     = [xleft , ylow , width , height];
                ylow = ylow+height+bdy;

        else
                ylow = pos_graph(2)+bdy0;
                height  = hy/nb_axes;
        end
        if      flg_axe(2)==1
                pos_ax(2,:)     = [xleft , ylow , width , height];
                ylow = ylow+height+bdy;
        end

        if      flg_axe(1)==1
                pos_ax(1,:)     = [xleft , ylow , width , height];      
        end
        axe_hdl = findobj(axe_handles,'flat','Tag',tag_axeappini);
        if ~isempty(axe_hdl)
                out1(1) = axe_hdl;
                out1(2) = findobj(axe_handles,'flat','Tag',tag_axedetini);
                out1(3) = findobj(axe_handles,'flat','Tag',tag_axecfsini);
                out1(4) = findobj(axe_handles,'flat','Tag',tag_axecolmap);
                if clear_axes , mngaxe('del_in',out1) ; end             
        else
                figure(win_dw1dtool);
                win_units       = get(win_dw1dtool,'Units');
                out1(1) = axes(...
                                'Units',win_units,      ...
                                'Visible','Off',        ...
                                'DrawMode','Normal',    ...
                                'box','on',             ...
                                'NextPlot','Add',       ...
                                'Tag',tag_axeappini     ...
                                );
                out1(2) = axes(...
                                'Units',win_units,      ...
                                'Visible','Off',        ...
                                'DrawMode','Normal',    ...
                                'box','on',             ...
                                'NextPlot','Add',       ...
                                'Tag',tag_axedetini     ...
                                );
                out1(3) = axes(...
                                'Units',win_units,      ...
                                'Ydir','reverse',       ...
                                'Visible','Off',        ...
                                'DrawMode','Fast',      ...
                                'box','on',             ...
                                'NextPlot','Replace',   ...
                                'Tag',tag_axecfsini     ...
                                );
                out1(4) = axes(...
                                'Units',win_units,      ...
                                'Visible','Off',        ...
                                'DrawMode','Fast',      ...
                                'XTicklabelMode','manual',...
                                'YTicklabelMode','manual',...
                                'XTickLabels',[],       ...
                                'YTickLabels',[],       ...
                                'XTick',[],'YTick',[],  ...
                                'Box','On',             ...
                                'Tag',tag_axecolmap     ...
                                );
        end
        flg_vis = [flg_axe flg_axe(3)];
        for k =1:4
                if flg_vis(k)==0
                        h = findobj(out1(k));
                        set(h,'Visible','off');
                else
                        set(out1(k),'Visible','on','Position',pos_ax(k,:));
                end
        end

elseif strcmp(option,'del_ss')
        lin_handles     = findobj(axe_handles,'Type','line');
        ss_app          = findobj(lin_handles,'Tag',tag_ss_inapp);
        ss_det          = findobj(lin_handles,'Tag',tag_ss_indet);
        delete([ss_app ss_det]);

elseif strcmp(option,'clear')
        % in3 = 0 : clean 
        % in3 = 1 : scr mode
        % in3 = 2 : dec mode
        % in3 = 3 : sep mode
        % in3 = 4 : sup mode
        % in3 = 5 : tre mode
        %--------------------
        new_mode = in3;
        if find(new_mode==[0 2 3 5]);
                dynvtool('off',win_dw1dtool);
        end
        mngaxe('vis',[axe_app_ini,axe_det_ini,axe_cfs_ini,axe_col_map],'off');
        if (new_mode==0) | (new_mode==2) | (new_mode==3) | (new_mode==5)
                mngaxe('del_in',[axe_app_ini,axe_det_ini,...
                                axe_cfs_ini,axe_col_map]);
                drawnow;
        elseif (new_mode==4)
                old_app = findobj(axe_app_ini,'Tag',tag_app);
                old_det = findobj(axe_det_ini,'Tag',tag_det);
                delete([old_app' old_det']);
        end

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('dw1dscrm','Unknown Option','msg');
        error('*');
end
        
