function out1 = dw1dstat(option,in2,in3,in4,in5,in6)
%DW1DSTAT Discret wavelet 1D statistics.
%       out1 = dw1dstat(option,in2,in3,in4,in5,in6)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:08:32 $

global  Def_Btn_Height  Def_Btn_Width   ...
        Pop_Min_Width   X_Graph_Ratio   ...
        X_Spacing       Y_Spacing       ...
        Def_TxtBkColor  Def_EdiBkColor  ...
        Def_FraBkColor  Def_FraFgColor

if nargin==0, option = 'create'; end

% MemBloc1 of stored values.
%---------------------------
n_param_anal    = 'DWAn1d_Par_Anal';
ind_sig_name    =  1;
ind_sig_size    =  2;
ind_wav_name    =  3;
ind_wav_len     =  4;
ind_lev_anal    =  5;
ind_axe_ref     =  6;
ind_act_option  =  7;
ind_ssig_type   =  8;
nb1_stored      =  8;

% MemBloc3 of stored values. (Local Bloc)
%----------------------------------------
n_miscella_loc  = 'DWStat1D_Misc';
ind_selbox      = 1;
ind_curr_sig    = 2;
ind_curr_color  = 3;
nb3_stored      = 3;

% Tag property of objects.
%-------------------------
tag_appdet_txt  = 'Appdet_Txt';
tag_appdet_val  = 'Appdet_Val';
tag_sel_cfs     = 'Sel_Cfs';
tag_sel_rec     = 'Sel_Rec';
tag_orig_sig    = 'Orig_sig';
tag_synt_sig    = 'Synt_sig';
tag_app_sig     = 'App_sig';
tag_det_sig     = 'Det_sig';
tag_bins_txt    = 'Bins_Txt';
tag_bins_data   = 'Bins_Data';
tag_levels      = 'Levels';
tag_mean_val    = 'Mean_Val';
tag_med_val     = 'Med_Val';
tag_mode_val    = 'Mode_Val';
tag_max_val     = 'Max_Val';
tag_min_val     = 'Min_Val';
tag_range_val   = 'Range_Val';
tag_std_val     = 'Std_Val';
tag_mad_val     = 'Mad_Val';
tag_madm_val    = 'Madm_Val';
tag_ax_signal   = 'Ax_Signal';
tag_ax_hist     = 'Ax_Hist';
tag_ax_cumhist  = 'Ax_Cumhist';
tag_show_stat   = 'Show_Stat';

%*****************************************************************%
%** OPTION = 'create' - constructs the initial dw1dstat window  **%
%*****************************************************************%
if strcmp(option,'create')

        % Calling figure.
        %----------------
        win_dw1dtool     = in2;
        str_win_dw1dtool = int2str(win_dw1dtool);

        % Window initialization.
        %----------------------
        win_name = 'Wavelet 1-D  --  Statistics';
        [win_dw1dstat,pos_win,cba_close_menu] = ...
                wfigcrea('create',NaN,win_name,'',win_dw1dtool,...
                        str2mat('-p','-0','-w'),'dw1dstat');
        str_numwin = int2str(win_dw1dstat);
        win_units  = 'pixels';
        out1       = win_dw1dstat;

        % Command frame and Dynamical visualization tool construction.
        %-------------------------------------------------------------
        [frame0,pos_frame0,Pos_Graphic_Area] = ...
                        wfigcrea('frame',win_dw1dstat,'','title');

        % Waiting Frame construction & begin waiting.
        %--------------------------------------------
        wwaiting('create',win_dw1dstat,X_Graph_Ratio,...
                        'Wait ... initialization');

        % Getting global variables from dw1dtool figure memory block.
        %------------------------------------------------------------
        [Sig_Name,Wav_Name,Lev_Anal,Sig_Size,Axe_Ref] = ...
                wmemtool('rmb',win_dw1dtool,n_param_anal,  ...
                        ind_sig_name,ind_wav_name,         ...
                        ind_lev_anal,ind_sig_size,ind_axe_ref);
        [Wav_Fam,Wav_Num] = wavattrb('fam_num',Wav_Name);

        % General graphical parameters initialization.
        %--------------------------------------------

        % Borders and double borders.
        dx  = X_Spacing;  dx2 = 2*dx;
        dy  = Y_Spacing;  dy2 = 2*dy;

        % X init position and width of frames.
        gra_width       = Pos_Graphic_Area(3);
        x_frame0        = pos_frame0(1);
        cmd_width       = pos_frame0(3);
        h_frame0        = pos_frame0(4);

        % Buttons width
        push_width      = (cmd_width-4*dx)/2;
        txt_width       = Def_Btn_Width;
        pop_width       = Pop_Min_Width;

        % Parameters initialization.
        %---------------------------
        default_bins    = 30;

        % Position property of objects.
        %------------------------------

        pos_input_txt   = [     x_frame0+dx2                            ,...
                                h_frame0-3*dy-Def_Btn_Height            ,...
                                txt_width                               ,...
                                Def_Btn_Height                          ];
        pos_input_data  = [     pos_input_txt(1)+pos_input_txt(3)+dx    ,...
                                pos_input_txt(2)                        ,...
                                2*pop_width                             ,...
                                Def_Btn_Height                          ];
        pos_wav_txt     = pos_input_txt;
        pos_wav_txt(2)  = pos_input_txt(2)-Def_Btn_Height-dy2;
        pos_wav_fams    = [     pos_wav_txt(1)+pos_wav_txt(3)+dx        ,...
                                pos_wav_txt(2)                          ,...
                                pop_width                               ,...
                                Def_Btn_Height                          ];
        pos_wav_nums    = [     pos_wav_fams(1)+pos_wav_fams(3)+dx/2    ,...
                                pos_wav_fams(2)                         ,...
                                pop_width-dx/2                          ,...
                                Def_Btn_Height                          ];
        pos_lev_txt     = pos_wav_txt;
        pos_lev_txt(2)  = pos_wav_txt(2)-Def_Btn_Height-dy2;
        pos_lev_data    = [     pos_lev_txt(1)+pos_lev_txt(3)+dx        ,...
                                pos_lev_txt(2)                          ,...
                                pop_width                               ,...
                                Def_Btn_Height                          ];
        w_chk           = 7*push_width/4;
        h_chk           = 3*Def_Btn_Height/2;
        d_higth         = Def_Btn_Height;

        % For 640x480 resolution
        %-----------------------
        scr_size        = get(0,'ScreenSize');
        if scr_size(4)<600 , d_higth = d_higth/2; end

        x_left          = x_frame0+(cmd_width-w_chk)/2;
        pos_orig_sig    = [     x_left                                  ,...
                                pos_lev_txt(2)-Def_Btn_Height-10*dy     ,...
                                w_chk                                   ,...
                                h_chk                   ];
        pos_synt_sig    = [     x_left                                  ,...
                                pos_orig_sig(2)-Def_Btn_Height-d_higth  ,...
                                w_chk                                   ,...
                                h_chk                   ];
        pos_app_sig     = [     x_left                                  ,...
                                pos_synt_sig(2)-Def_Btn_Height-d_higth  ,...
                                w_chk                           ,...
                                h_chk                   ];           
        pos_det_sig     = [     x_left                                  ,...
                                pos_app_sig(2)-Def_Btn_Height-d_higth   ,...
                                w_chk                                   ,...
                                h_chk                   ];
        pos_close       = [     x_left                                  ,...
                                pos_frame0(2)+Def_Btn_Height            ,...
                                w_chk                           ,...
                                h_chk                   ];
        x_left          = x_frame0+(cmd_width-3*push_width/2)/2;
        pos_appdet_txt  = [     x_left                                  ,...
                                pos_det_sig(2)-h_chk                    ,...
                                3*push_width/2                          ,...
                                Def_Btn_Height                          ];
        pos_appdet_val  = [     x_left                                  ,...
                                pos_appdet_txt(2)-h_chk                 ,...
                                3*push_width/2                          ,...
                                Def_Btn_Height                          ];

        x_left          = x_frame0+(cmd_width-5*push_width/4)/2;
        pos_sel_cfs     = [     x_left                                  ,...
                                pos_appdet_val(2)-2*Def_Btn_Height      ,...
                                5*push_width/4                          ,...
                                Def_Btn_Height                          ];
        pos_sel_rec     = [     pos_sel_cfs(1)                          ,...
                                pos_sel_cfs(2)-h_chk                    ,...
                                5*push_width/4                          ,...
                                Def_Btn_Height                          ];

        x_left          = x_frame0+(cmd_width-3*pop_width)/2;
        pos_bins_txt    = [     x_left                                  ,...
                                pos_sel_rec(2)-Def_Btn_Height-d_higth   ,...
                                2*pop_width                             ,...
                                Def_Btn_Height                          ];
        pos_bins_data   = pos_bins_txt;
        pos_bins_data(1)= pos_bins_txt(1)+pos_bins_txt(3)+dx;
        pos_bins_data(3)= pop_width;

        x_left          = x_frame0+(cmd_width-3*push_width/2)/2;
        pos_show_stat   = [     x_left                                  ,...
                                pos_bins_data(2)-2*Def_Btn_Height-d_higth,...
                                3*push_width/2                          ,...
                                2*Def_Btn_Height                        ];

        % Frame 1.

        h_frame1        = 3*Def_Btn_Height+8*dy;
        pos_frame1      = [     dx2                                     ,...
                                dy2                                     ,...
                                gra_width-2*dx2                         ,...
                                h_frame1                                ];

        wx              = (pos_frame1(3)-4*dx)/8;
        pos_mean_txt    = [     pos_frame1(1)+dx                        ,...
                                pos_frame1(2)+h_frame1-Def_Btn_Height-dy2,...
                                4*wx/5                                  ,...
                                Def_Btn_Height                          ];
        pos_med_txt     = [     pos_mean_txt(1)                         ,...
                                pos_mean_txt(2)-Def_Btn_Height-dy2      ,...
                                4*wx/5                                  ,...
                                Def_Btn_Height                          ];
        pos_mode_txt    = [     pos_mean_txt(1)                         ,...
                                pos_med_txt(2)-Def_Btn_Height-dy2       ,...
                                4*wx/5                                  ,...
                                Def_Btn_Height                          ];
        x_left          = pos_mean_txt(1)+pos_mean_txt(3)+dx+6*wx/5;
        pos_max_txt     = [     x_left                                  ,...
                                pos_frame1(2)+h_frame1-Def_Btn_Height-dy2,...
                                wx                                      ,...
                                Def_Btn_Height                          ];
        pos_min_txt     = [     pos_max_txt(1)                          ,...
                                pos_max_txt(2)-Def_Btn_Height-dy2       ,...
                                wx                                      ,...
                                Def_Btn_Height                          ];
        pos_range_txt   = [     pos_max_txt(1)                          ,...
                                pos_min_txt(2)-Def_Btn_Height-dy2       ,...
                                wx                                      ,...
                                Def_Btn_Height                          ];
        x_left          = pos_max_txt(1)+pos_max_txt(3)+dx+6*wx/5;
        pos_std_txt     = [     x_left                                  ,...
                                pos_frame1(2)+h_frame1-Def_Btn_Height-dy2,...
                                13*wx/5                                 ,...
                                Def_Btn_Height                          ];
        pos_mad_txt     = [     pos_std_txt(1)                          ,...
                                pos_std_txt(2)-Def_Btn_Height-dy2       ,...
                                13*wx/5                                 ,...
                                Def_Btn_Height                          ];
        pos_madm_txt    = [     pos_mad_txt(1)                          ,...
                                pos_mad_txt(2)-Def_Btn_Height-dy2       ,...
                                13*wx/5                                 ,...
                                Def_Btn_Height                          ];
        pos_mean_val    = [     pos_mean_txt(1)+pos_mean_txt(3)         ,...
                                pos_mean_txt(2)                         ,...
                                6*wx/5                                  ,...
                                Def_Btn_Height                          ];
        pos_med_val     = [     pos_med_txt(1)+pos_med_txt(3)           ,...
                                pos_med_txt(2)                          ,...
                                6*wx/5                                  ,...
                                Def_Btn_Height                          ];
        pos_mode_val    = [     pos_mode_txt(1)+pos_mode_txt(3)         ,...
                                pos_mode_txt(2)                         ,...
                                6*wx/5                                  ,...
                                Def_Btn_Height                          ];
        pos_max_val     = [     pos_max_txt(1)+pos_max_txt(3)           ,...
                                pos_max_txt(2)                          ,...
                                6*wx/5                                  ,...
                                Def_Btn_Height                          ];
        pos_min_val     = [     pos_min_txt(1)+pos_min_txt(3)           ,...
                                pos_min_txt(2)                          ,...
                                6*wx/5                                  ,...
                                Def_Btn_Height                          ];
        pos_range_val   = [     pos_range_txt(1)+pos_range_txt(3)       ,...
                                pos_range_txt(2)                        ,...
                                6*wx/5                                  ,...
                                Def_Btn_Height                          ];
        pos_std_val     = [     pos_std_txt(1)+pos_std_txt(3)           ,...
                                pos_std_txt(2)                          ,...
                                6*wx/5                                  ,...
                                Def_Btn_Height                          ];
        pos_mad_val     = [     pos_mad_txt(1)+pos_mad_txt(3)           ,...
                                pos_mad_txt(2)                          ,...
                                6*wx/5                                  ,...
                                Def_Btn_Height                          ];
        pos_madm_val    = [     pos_madm_txt(1)+pos_madm_txt(3)         ,...
                                pos_madm_txt(2)                         ,...
                                6*wx/5                                  ,...
                                Def_Btn_Height                          ];

        % String property of objects.
        %----------------------------
        str_input_txt   = 'Signal';
        str_input_data  = Sig_Name;
        str_wav_txt     = 'Wavelet';
        str_wav_fams    = Wav_Fam;
        str_wav_nums    = Wav_Num;
        str_lev_txt     = 'Level';
        str_lev_data    = int2str(Lev_Anal);

        ss_type = wmemtool('rmb',win_dw1dtool,n_param_anal,ind_ssig_type);
        if      ss_type=='ss', str_ss = 'Synthesized signal';
        elseif  ss_type=='ds', str_ss = 'De-noised signal';
        elseif  ss_type=='cs', str_ss = 'Compressed signal';
        end
        str_synt_sig    = str_ss;

        str_orig_sig    = 'Original signal';
        str_app_sig     = 'Approximation';
        str_det_sig     = 'Detail';
        str_app_txt     = 'Approximation at';
        str_det_txt     = 'Detail at';
        str_sel_cfs     = 'Coefficients';
        str_sel_rec     = 'Reconstructed';
        str_bins_txt    = 'Number of bins';
        str_bins_data   = int2str(default_bins);
        str_show_stat   = 'Show statistics';
        str_close       = 'Close';
        str_mean_txt    = 'Mean';
        str_med_txt     = 'Median';
        str_mode_txt    = 'Mode';
        str_max_txt     = 'Maximum';
        str_min_txt     = 'Minimum';
        str_range_txt   = 'Range';
        str_std_txt     = 'Standard deviation';
        str_mad_txt     = 'Median absolute deviation';
        str_madm_txt    = 'Mean absolute deviation';
        str_appdet_val  = [];
        for i = 1:Lev_Anal
                str_appdet_val  = str2mat(str_appdet_val,['Level ' int2str(i)]);
        end
        str_appdet_val  = str_appdet_val(2:Lev_Anal+1,:);

        % Command part construction of the window.
        %-----------------------------------------
        figure(win_dw1dstat)
        txt_input_txt   = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_input_txt,...
                                        'String',str_input_txt,...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
        txt_input_data  = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_input_data,...
                                        'String',str_input_data,...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        txt_wav_txt     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_wav_txt,...
                                        'String',str_wav_txt,...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
        txt_wav_fams    = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_wav_fams,...
                                        'String',str_wav_fams,...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        if ~isempty(str_wav_nums)
        txt_wav_nums    = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_wav_nums,...
                                        'String',str_wav_nums,...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        end
        txt_lev_txt     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_lev_txt,...
                                        'String',str_lev_txt,...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
        txt_lev_data    = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_lev_data,...
                                        'String',str_lev_data,...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        drawnow

        rad_orig_sig    = uicontrol(...
                                        'Style','Radiobutton',...
                                        'Unit',win_units,...
                                        'Position',pos_orig_sig,...
                                        'String',str_orig_sig,...
                                        'Enable','off',...
                                        'Value',1,...
                                        'Userdata',1,...
                                        'Tag',tag_orig_sig...
                                        );
        rad_synt_sig    = uicontrol(...
                                        'Style','Radiobutton',...
                                        'Unit',win_units,...
                                        'Position',pos_synt_sig,...
                                        'String',str_synt_sig,...
                                        'Enable','off',...
                                        'Tag',tag_synt_sig...
                                        );
        rad_app_sig     = uicontrol(...
                                        'Style','Radiobutton',...
                                        'Unit',win_units,...
                                        'Position',pos_app_sig,...
                                        'String',str_app_sig,...
                                        'Enable','off',...
                                        'Tag',tag_app_sig...
                                        );
        rad_det_sig     = uicontrol(...
                                        'Style','Radiobutton',...
                                        'Unit',win_units,...
                                        'Position',pos_det_sig,...
                                        'String',str_det_sig,...
                                        'Enable','off',...
                                        'Tag',tag_det_sig...
                                        );
        drawnow

        txt_appdet_txt  = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'Position',pos_appdet_txt,...
                                        'String',str_app_txt,...
                                        'Visible','off',...
                                        'Tag',tag_appdet_txt,...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
        pop_appdet_val  = uicontrol(...
                                        'Style','Popup',...
                                        'Unit',win_units,...
                                        'Position',pos_appdet_val,...
                                        'String',str_appdet_val,...
                                        'Visible','off',...
                                        'Userdata',1,...
                                        'Tag',tag_appdet_val...
                                        );
        rad_sel_cfs     = uicontrol(...
                                        'Style','Radiobutton',...
                                        'Unit',win_units,...
                                        'Position',pos_sel_cfs,...
                                        'String',str_sel_cfs,...
                                        'Visible','off',...
                                        'Tag',tag_sel_cfs,...
                                        'Userdata',0,...
                                        'Value',0);
        rad_sel_rec     = uicontrol(...
                                        'Style','Radiobutton',...
                                        'Unit',win_units,...
                                        'Position',pos_sel_rec,...
                                        'String',str_sel_rec,...
                                        'Visible','off',...
                                        'Tag',tag_sel_rec,...
                                        'Userdata',1,...
                                        'Value',1);
        drawnow

        txt_bins_txt    = uicontrol(...
                                        'Style','text',...
                                        'Unit',win_units,...
                                        'Position',pos_bins_txt,...
                                        'String',str_bins_txt,...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'Visible','off',...
                                        'Tag',tag_bins_txt...
                                        );
        edi_bins_data   = uicontrol(...
                                        'Style','Edit',...
                                        'Units',win_units,...
                                        'Position',pos_bins_data,...
                                        'String',str_bins_data,...
                                        'Backgroundcolor',Def_EdiBkColor,...
                                        'Visible','off',...
                                        'Tag',tag_bins_data...
                                        );
        pus_show_stat   = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_show_stat,...
                                        'String',str_show_stat,...
                                        'Visible','off',...
                                        'Userdata',[],...
                                        'Tag',tag_show_stat...
                                        );
        pus_close       = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_close,...
                                        'String',str_close,...
                                        'Interruptible','yes'...
                                        );
        drawnow

        coeff_vari_pos  = 2;
        pos_bins_txt(2) = pos_det_sig(2)-coeff_vari_pos*2*pos_det_sig(4)/3;
        pos_bins_data(2)= pos_bins_txt(2);
        pos_show_stat(2)= pos_bins_data(2)-3*2*pos_det_sig(4)/3;
        set(txt_bins_txt,'Position',pos_bins_txt,'Visible','on');
        set(edi_bins_data,'Position',pos_bins_data,'Visible','on');
        set(pus_show_stat,'Position',pos_show_stat,'Visible','on');
        drawnow

        % Frame 1 construction.

        fra_frame1      = uicontrol(...
                                        'Style','frame',...
                                        'Unit',win_units,...
                                        'Position',pos_frame1,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_TxtBkColor,...
                                        'Foregroundcolor','k'...
                                        );
        txt_mean_txt    = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_mean_txt,...
                                        'String',str_mean_txt,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        txt_mean_val    = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_mean_val,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'Tag',tag_mean_val...
                                        );
        txt_med_txt     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_med_txt,...
                                        'String',str_med_txt,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        txt_med_val     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_med_val,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'Tag',tag_med_val...
                                        );
        drawnow
        txt_mode_txt    = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_mode_txt,...
                                        'String',str_mode_txt,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        txt_mode_val    = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_mode_val,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'Tag',tag_mode_val...
                                        );
        txt_max_txt     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_max_txt,...
                                        'String',str_max_txt,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        txt_max_val     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_max_val,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'Tag',tag_max_val...
                                        );
        txt_min_txt     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_min_txt,...
                                        'String',str_min_txt,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        txt_min_val     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_min_val,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'Tag',tag_min_val...
                                        );
        drawnow
        txt_range_txt   = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_range_txt,...
                                        'String',str_range_txt,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        txt_range_val   = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_range_val,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'Tag',tag_range_val...
                                        );
        txt_std_txt     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_std_txt,...
                                        'String',str_std_txt,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        txt_std_val     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_std_val,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'Tag',tag_std_val...
                                        );
        txt_mad_txt     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_mad_txt,...
                                        'String',str_mad_txt,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        txt_mad_val     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_mad_val,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'Tag',tag_mad_val...
                                        );
        txt_madm_txt    = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_madm_txt,...
                                        'String',str_madm_txt,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        txt_madm_val    = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_madm_val,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'Tag',tag_madm_val...
                                        );
        drawnow

        % Sets of handles.
        %-----------------
        infos_hdls      = [     fra_frame1
                                txt_mean_txt
                                txt_med_txt
                                txt_mode_txt
                                txt_max_txt
                                txt_min_txt
                                txt_range_txt
                                txt_std_txt
                                txt_mad_txt
                                txt_madm_txt
                                txt_mean_val
                                txt_med_val
                                txt_mode_val
                                txt_max_val
                                txt_min_val
                                txt_range_val
                                txt_std_val
                                txt_mad_val
                                txt_madm_val];
        set1_hdls       = [     txt_appdet_txt
                                pop_appdet_val
                                rad_sel_cfs
                                rad_sel_rec];
        set2_hdls       = [     txt_bins_txt
                                edi_bins_data
                                pus_show_stat];

        % Selected box limits.
        %---------------------
        xlim_selbox = dynvtool('getbox',win_dw1dtool); 
        if      ~isempty(xlim_selbox)
                xlim_selbox = [min(xlim_selbox) max(xlim_selbox)];
        else
                xlim_selbox = get(Axe_Ref,'XLim');
        end
        xlim_selbox     = round(xlim_selbox);
        xlim1           = xlim_selbox(1);       
        xlim2           = xlim_selbox(2);
        if      xlim1<1,                xlim1 = 1;              end
        if      xlim2>Sig_Size,         xlim2 = Sig_Size;       end
        if      (xlim2<1) | (xlim1>Sig_Size), return,           end
        selbox          = [xlim1 xlim2];

        % Callbacks update.
        %------------------
        str_infos_hdls          = num2mstr(infos_hdls);
        str_group_hdls          = num2mstr([set2_hdls;set1_hdls]);
        str_set2_hdls           = num2mstr(set2_hdls);
        str_rad_orig_sig        = num2mstr(rad_orig_sig);
        str_rad_synt_sig        = num2mstr(rad_synt_sig);
        str_rad_app_sig         = num2mstr(rad_app_sig);
        str_rad_det_sig         = num2mstr(rad_det_sig);
        str_pop_appdet_val      = num2mstr(pop_appdet_val);
        str_rad_sel_rec         = num2mstr(rad_sel_rec);
        str_rad_sel_cfs         = num2mstr(rad_sel_cfs);
        str_edi_bins_data       = num2mstr(edi_bins_data);

        cba_orig_sig            = ['dw1dstat(''select'',' ...
                                        str_numwin ',' ...
                                        str_rad_orig_sig ',' ...
                                        str_infos_hdls ',' ...
                                        str_group_hdls ',' ...
                                        str_set2_hdls ...
                                        ');'];
        cba_synt_sig            = ['dw1dstat(''select'',' ...
                                        str_numwin ',' ...
                                        str_rad_synt_sig ',' ...
                                        str_infos_hdls ',' ...
                                        str_group_hdls ',' ...
                                        str_set2_hdls ...
                                        ');'];
        cba_app_sig             = ['dw1dstat(''select'',' ...
                                        str_numwin ',' ...
                                        str_rad_app_sig ',' ...
                                        str_infos_hdls ',' ...
                                        str_group_hdls ',' ...
                                        str_group_hdls ...
                                        ');'];
        cba_det_sig             = ['dw1dstat(''select'',' ...
                                        str_numwin ',' ...
                                        str_rad_det_sig ',' ...
                                        str_infos_hdls ',' ...
                                        str_group_hdls ',' ...
                                        str_group_hdls ...
                                        ');'];
        cba_pop_appdet_val      = ['dw1dstat(''upd'',' ...
                                        str_numwin ',''lvl'','  ...
                                        str_infos_hdls ','      ...
                                        str_pop_appdet_val      ...
                                        ');'];
        cba_sel_rec             = ['dw1dstat(''upd'',' ...
                                        str_numwin ',''cfs'','  ...
                                        str_infos_hdls ','      ...
                                        str_rad_sel_rec ...
                                        ');'];
        cba_sel_cfs             = ['dw1dstat(''upd'',' ...
                                        str_numwin ',''cfs'','  ...
                                        str_infos_hdls ','      ...
                                        str_rad_sel_cfs ...
                                        ');'];
        cba_bins_data           = ['dw1dstat(''update_bins'',' ...
                                        str_numwin ',' ...
                                        str_edi_bins_data ...
                                        ');'];
        cba_show_stat           = ['dw1dstat(''draw'',' ...
                                        str_numwin ',' ...
                                        str_win_dw1dtool ',' ...
                                        str_infos_hdls ');'];

        set(rad_orig_sig,'Callback',cba_orig_sig);
        set(rad_synt_sig,'Callback',cba_synt_sig);
        set(rad_app_sig,'Callback',cba_app_sig);
        set(rad_det_sig,'Callback',cba_det_sig);
        set(pop_appdet_val,'Callback',cba_pop_appdet_val);
        set(rad_sel_rec,'Callback',cba_sel_rec);
        set(rad_sel_cfs,'Callback',cba_sel_cfs);
        set(edi_bins_data,'Callback',cba_bins_data);
        set(pus_show_stat,'Callback',cba_show_stat);
        set(pus_close,'Callback',cba_close_menu);

        % Memory blocks update.
        %----------------------
        wmemtool('ini',win_dw1dstat,n_miscella_loc,nb3_stored);
        wmemtool('wmb',win_dw1dstat,n_miscella_loc,ind_selbox,selbox);

        % Axes construction.
        %-------------------
        xspace          = gra_width/10;
        yspace          = pos_frame0(4)/10;
        axe_height      = (pos_frame0(4)-Def_Btn_Height-h_frame1-4*dy)/2-yspace;
        axe_width       = gra_width-2*xspace;
        half_width      = axe_width/2-xspace/2;         
        pos_ax_signal   = [xspace h_frame1+2*dy2+axe_height+4*yspace/3 ...
                                 axe_width axe_height];
        pos_ax_hist     = [xspace h_frame1+2*dy2+yspace/3 ...
                                 half_width axe_height];
        pos_ax_cumhist  = [2*xspace+half_width h_frame1+2*dy2+yspace/3 ...
                                 half_width axe_height];
        axe_ax_signal   = axes(...
                                'Units',win_units,...
                                'Position',pos_ax_signal,...
                                'Visible','Off',...
                                'box','on',...
                                'NextPlot','Replace',...
                                'Drawmode','fast',...
                                'Tag',tag_ax_signal...
                                );
        axe_ax_hist     = axes(...
                                'Units',win_units,...
                                'Position',pos_ax_hist,...
                                'Visible','Off',...
                                'box','on',...
                                'NextPlot','Replace',...
                                'Drawmode','fast',...
                                'Tag',tag_ax_hist...
                                );
        axe_ax_cumhist  = axes(...
                                'Units',win_units,...
                                'Position',pos_ax_cumhist,...
                                'Visible','Off',...
                                'box','on',...
                                'NextPlot','Replace',...
                                'Drawmode','fast',...
                                'Tag',tag_ax_cumhist...
                                );
        drawnow

        % Displaying the window title.
        %-----------------------------
        str_nb_val      = [' (' int2str(Sig_Size) ' values)'];
        str_wintitle    = [Sig_Name,str_nb_val,' analyzed at level ',...
                           int2str(Lev_Anal),' with ',Wav_Name];
        str_wintitle    = [str_wintitle '.  Components :   ' ,...
                           int2str(selbox(1)) ' --> ' ...
                           int2str(selbox(2))];
        wfigtitl('string',win_dw1dstat,str_wintitle,'off');

        % Setting units to normalized.
        %-----------------------------
        set(findobj(win_dw1dstat,'Units','pixels'),'Units','Normalized');

        % End waiting.
        %-------------
        wwaiting('off',win_dw1dstat);
        set([rad_orig_sig rad_synt_sig rad_app_sig rad_det_sig],'Enable','on');

%***********************************************%
%** OPTION = 'select' - SIGNAL TYPE SELECTION **%
%***********************************************%
elseif strcmp(option,'select')
        win_dw1dstat    = in2;
        sel_rad_btn     = in3;
        infos_hdls      = in4;
        group_hdls      = in5;
        curr_hdls       = in6;

        % Set to the current selection.
        %------------------------------
        rad_handles     = findobj(win_dw1dstat,'Style','radiobutton');
        rad_orig_sig    = findobj(rad_handles,'Tag',tag_orig_sig);
        rad_synt_sig    = findobj(rad_handles,'Tag',tag_synt_sig);
        rad_app_sig     = findobj(rad_handles,'Tag',tag_app_sig);
        rad_det_sig     = findobj(rad_handles,'Tag',tag_det_sig);
        rad_opt         = [rad_orig_sig rad_synt_sig rad_app_sig rad_det_sig];

        old_rad         = findobj(rad_opt,'Userdata',1);
        set(rad_opt,'Value',0,'Userdata',[]);
        set(sel_rad_btn,'Value',1,'Userdata',1)
        if old_rad==sel_rad_btn , return; end

        % Reset all.
        %-----------
        axe_handles     = findobj(win_dw1dstat,'Type','axes');
        axe_ax_signal   = findobj(axe_handles,'flat','Tag',tag_ax_signal);
        axe_ax_hist     = findobj(axe_handles,'flat','Tag',tag_ax_hist);
        axe_ax_cumhist  = findobj(axe_handles,'flat','Tag',tag_ax_cumhist);
        set([infos_hdls',group_hdls'],'Visible','off');
        mngaxe('vis',[axe_ax_signal,axe_ax_hist,axe_ax_cumhist],'off');
        drawnow

        % Redraw the command part depending on the current selection.
        %------------------------------------------------------------
        pos_det_sig             = get(rad_det_sig,'Position');
        pos_bins_txt            = get(curr_hdls(1),'Position');
        pos_bins_data           = get(curr_hdls(2),'Position');
        pos_show_stat           = get(curr_hdls(3),'Position');
        coeff_vari_pos          = 9;
        if      sel_rad_btn==rad_app_sig
                set(curr_hdls(4),'String','Approximation at')
        elseif  sel_rad_btn==rad_det_sig
                set(curr_hdls(4),'String','Detail at')
        elseif  sel_rad_btn==rad_orig_sig | sel_rad_btn==rad_synt_sig
                coeff_vari_pos          = 2;
        end
        pos_bins_txt(2) = pos_det_sig(2)-coeff_vari_pos*2*pos_det_sig(4)/3;
        pos_bins_data(2)= pos_bins_txt(2);
        pos_show_stat(2)= pos_bins_data(2)-3*2*pos_det_sig(4)/3;
        set(curr_hdls(1),'Position',pos_bins_txt);
        set(curr_hdls(2),'Position',pos_bins_data);
        set(curr_hdls(3),'Position',pos_show_stat);
        set(curr_hdls,'Visible','On');

%***************************************%
%** OPTION = 'upd' - UPDATE :         **%
%**     COEFFICIENTS TYPE SELECTION   **%
%**     LEVEL NUMBER SELECTION        **%
%***************************************%
elseif strcmp(option,'upd')
        win_dw1dstat    = in2;
        opt             = in3;
        infos_hdls      = in4;

        % Set to the current selection.
        %------------------------------
        if      opt=='cfs'
                sel_rad_btn     = in5;
                rad_handles     = findobj(win_dw1dstat,'Style','radiobutton');
                rad_sel_rec     = findobj(rad_handles,'Tag',tag_sel_rec);
                rad_sel_cfs     = findobj(rad_handles,'Tag',tag_sel_cfs);
                rad_opt         = [rad_sel_rec rad_sel_cfs];
                old_rad         = findobj(rad_opt,'Userdata',1);
                set(rad_opt,'Value',0,'Userdata',0);
                set(sel_rad_btn,'Value',1,'Userdata',1)
                if old_rad==sel_rad_btn , return; end

        elseif  opt=='lvl'
                pop_level       = in5;
                val_pop = get(pop_level,'value');
                usr_pop = get(pop_level,'userdata');
                if usr_pop==val_pop , return; end
                set(pop_level,'userdata',val_pop);

        end

        % Reset all.
        %-----------
        axe_handles     = findobj(win_dw1dstat,'Type','axes');
        axe_ax_signal   = findobj(axe_handles,'flat','Tag',tag_ax_signal);
        axe_ax_hist     = findobj(axe_handles,'flat','Tag',tag_ax_hist);
        axe_ax_cumhist  = findobj(axe_handles,'flat','Tag',tag_ax_cumhist);
        set(infos_hdls,'Visible','off');
        mngaxe('vis',[axe_ax_signal,axe_ax_hist,axe_ax_cumhist],'off');
        drawnow

%**********************************************%
%** OPTION = 'draw' - DRAW AXES              **%
%**********************************************%
elseif strcmp(option,'draw')
        win_dw1dstat    = in2;
        win_dw1dtool    = in3;
        infos_hdls      = in4;

        % Handles of tagged objects.
        %---------------------------
        pus_show_stat   = findobj(win_dw1dstat,...
                                        'Style','pushbutton',...
                                        'Tag',tag_show_stat...
                                        );
        rad_handles     = findobj(win_dw1dstat,'Style','radiobutton');
        edi_handles     = findobj(win_dw1dstat,'Style','edit');
        txt_handles     = findobj(win_dw1dstat,'Style','text');
        pop_handles     = findobj(win_dw1dstat,'Style','popupmenu');
        rad_sel_cfs     = findobj(rad_handles,'Tag',tag_sel_cfs);
        rad_orig_sig    = findobj(rad_handles,'Tag',tag_orig_sig);
        rad_synt_sig    = findobj(rad_handles,'Tag',tag_synt_sig);
        rad_app_sig     = findobj(rad_handles,'Tag',tag_app_sig);
        rad_det_sig     = findobj(rad_handles,'Tag',tag_det_sig);
        edi_bins_data   = findobj(edi_handles,'Tag',tag_bins_data);
        txt_mean_val    = findobj(txt_handles,'Tag',tag_mean_val);
        txt_med_val     = findobj(txt_handles,'Tag',tag_med_val);
        txt_mode_val    = findobj(txt_handles,'Tag',tag_mode_val);
        txt_max_val     = findobj(txt_handles,'Tag',tag_max_val)';
        txt_min_val     = findobj(txt_handles,'Tag',tag_min_val);
        txt_range_val   = findobj(txt_handles,'Tag',tag_range_val);
        txt_std_val     = findobj(txt_handles,'Tag',tag_std_val);
        txt_mad_val     = findobj(txt_handles,'Tag',tag_mad_val);
        txt_madm_val    = findobj(txt_handles,'Tag',tag_madm_val);
        pop_appdet_val  = findobj(pop_handles,'Tag',tag_appdet_val);

        % Handles of tagged objects continuing.
        %-------------------------------------
        axe_handles     = findobj(win_dw1dstat,'Type','axes');
        axe_ax_signal   = findobj(axe_handles,'flat','Tag',tag_ax_signal);
        axe_ax_hist     = findobj(axe_handles,'flat','Tag',tag_ax_hist);
        axe_ax_cumhist  = findobj(axe_handles,'flat','Tag',tag_ax_cumhist);

        % Main parameters selection before drawing.
        %------------------------------------------
        sel_cfs         = (get(rad_sel_cfs,'Value')~=0);
        orig_sig        = (get(rad_orig_sig,'Value')~=0);
        synt_sig        = (get(rad_synt_sig,'Value')~=0);
        app_sig         = (get(rad_app_sig,'Value')~=0);
        det_sig         = (get(rad_det_sig,'Value')~=0);

        % Check the bins number.
        %-----------------------
        default_bins    = 30;
        old_params      = get(pus_show_stat,'Userdata');
        if ~isempty(old_params)
                default_bins = old_params(1);
        end
        nb_bins         = str2num(get(edi_bins_data,'String'));
        if isempty(nb_bins)
                nb_bins = default_bins;   
                set(edi_bins_data,'String',int2str(default_bins))
        elseif nb_bins<2
                nb_bins = default_bins;
                set(edi_bins_data,'String',int2str(default_bins))
        end
        level = get(pop_appdet_val,'value');
        new_params = [  nb_bins sel_cfs orig_sig synt_sig       ...
                        app_sig det_sig level                   ...
                        ];

        if      ~isempty(old_params) & (new_params==old_params)
                vis = get(axe_ax_hist,'Visible');
                if vis(1:2)=='on', return, end
        end

        % Deseable new selection.
        %-------------------------
        set([pop_handles;rad_handles;edi_handles],'Enable','off');

        % Updating parameters.
        %--------------------- 
        set(pus_show_stat,'Userdata',new_params);

        % Show the status line.
        %----------------------
        wfigtitl('vis',win_dw1dstat,'on');

        % Cleaning the graphical part.
        %-----------------------------
        set(infos_hdls,'Visible','off');
        mngaxe('vis',[axe_ax_signal,axe_ax_hist,axe_ax_cumhist],'off');
        drawnow

        % Waiting message.
        %-----------------
        wwaiting('msg',win_dw1dstat,'Wait ... computing');

        % Getting memory blocks.
        %-----------------------
        [Sig_Name,Wav_Name,Lev_Anal] = ...
                        wmemtool('rmb',win_dw1dtool,n_param_anal, ...
                                        ind_sig_name,ind_wav_name,ind_lev_anal);
        selbox_orig = wmemtool('rmb',win_dw1dstat,n_miscella_loc,ind_selbox);

        % Definition of the complete selection box.
        %-----------------------------------------
        selbox_orig     = selbox_orig(1):selbox_orig(2);

        % Current signal construction.
        %-----------------------------
        if orig_sig
                curr_sig        = dw1dfile('sig',win_dw1dtool);
                curr_color      = dw1dcolo('sig');
                str_title       = 'Original signal';
        elseif synt_sig
                curr_sig        = dw1dfile('ssig',win_dw1dtool);
                curr_color      = dw1dcolo('ssig');

                ss_type = wmemtool('rmb',win_dw1dtool,n_param_anal,...
                                                        ind_ssig_type);
                if      ss_type=='ss', str_ss = 'Synthesized signal';
                elseif  ss_type=='ds', str_ss = 'De_noised signal';
                elseif  ss_type=='cs', str_ss = 'Compressed signal';
                end
                str_title       = str_ss;

        elseif app_sig
                if sel_cfs
                        [curr_sig,set_ylim,ymin,ymax] = ...
                                dw1dfile('app_cfs',win_dw1dtool,level,1);
                        str_title= 'Coefficients of ';
                else
                        [curr_sig,set_ylim,ymin,ymax] = ...
                                dw1dfile('app',win_dw1dtool,level,1);
                        str_title= 'Reconstructed ';
                end
                col_app         = dw1dcolo('app',Lev_Anal);
                curr_color      = col_app(level,:);
                str_title       = [str_title 'approximation at level ' ...
                                        int2str(level)];
        elseif det_sig
                if sel_cfs
                        [curr_sig,set_ylim,ymin,ymax] = ...
                                dw1dfile('det_cfs',win_dw1dtool,level,1);

                        str_title= 'Coefficients of ';
                else
                        [curr_sig,set_ylim,ymin,ymax] = ...
                                dw1dfile('det',win_dw1dtool,level,1);
                        str_title= 'Reconstructed ';
                end
                col_det         = dw1dcolo('det',Lev_Anal);
                curr_color      = col_det(level,:);
                str_title       = [str_title 'detail at level ' ...
                                        int2str(level)];
        end
        selbox  = selbox_orig;
        if sel_cfs & ~orig_sig & ~synt_sig
                min_box = ceil(min(selbox)/2^level);
                max_box = ceil(max(selbox)/2^level);
                selbox  = min_box:max_box;
        end
        if length(selbox)>2
                curr_sig = curr_sig(selbox);
        else
                warndlg(['          Not enough coefficients ' ...
                        'remaining at level ' ...
                        int2str(level)],...
                        'Wavelet 1-D -- Statistics');
                wwaiting('off',win_dw1dstat);
                return;
        end

        % Displaying the signal.
        %-----------------------
        xaxis = [min(selbox)    max(selbox)];
        yaxis = [min(curr_sig)  max(curr_sig)];
        if xaxis(1)==xaxis(2)
                xaxis = xaxis+[-0.000001 0.000001];
        end
        if yaxis(1)==yaxis(2)
                yaxis = yaxis+[-0.000001 0.000001];
        end
        if (app_sig | det_sig) & set_ylim
                if yaxis(1)<ymin , yaxis(1) = ymin; end
                if yaxis(2)>ymax , yaxis(2) = ymax; end
        end
        axes(axe_ax_signal);
        plot(selbox,curr_sig,'Color',curr_color);
        set(axe_ax_signal,'Visible','on','Xlim',xaxis,'Ylim',yaxis,...
                'Tag',tag_ax_signal);
        title(str_title);

        % Displaying histogram.
        %----------------------
        his             = wgethist(curr_sig,nb_bins);
        [xx,imod]       = max(his(2,:));
        mode_val        = (his(1,imod)+his(1,imod+1))/2;
        his(2,:)        = his(2,:)/length(curr_sig);
        axes(axe_ax_hist);
        wplothis(axe_ax_hist,his,curr_color);
        title('Histogram');

        % Displaying cumulated histogram.
        %--------------------------------
        for i=6:4:length(his(2,:));
                his(2,i)        = his(2,i)+his(2,i-4);
                his(2,i+1)      = his(2,i);
        end
        axes(axe_ax_cumhist);
        wplothis(axe_ax_cumhist,[his(1,:);his(2,:)],curr_color);
        title('Cumulative histogram');

        % Displaying statistics.
        %-----------------------
        mean_val        = mean(curr_sig);
        max_val         = max(curr_sig);
        min_val         = min(curr_sig);
        sig_abs_cent    = abs(curr_sig-mean_val);
        range_val       = max_val-min_val;
        std_val         = std(curr_sig);
        med_val         = median(curr_sig);
        set(txt_mean_val,'string',sprintf('%1.4g',mean_val));
        set(txt_med_val,'string',sprintf('%1.4g',med_val));
        set(txt_mode_val,'string',sprintf('%1.4g',mode_val));
        set(txt_max_val,'string',sprintf('%1.4g',max_val));
        set(txt_min_val,'string',sprintf('%1.4g',min_val));
        set(txt_range_val,'string',sprintf('%1.4g',range_val));
        set(txt_std_val,'string',sprintf('%1.4g',std_val));
        set(txt_mad_val,'string',...
                        sprintf('%1.4g',median(abs(curr_sig-med_val))));
        set(txt_madm_val,'string',...
                        sprintf('%1.4g',mean(abs(curr_sig-mean_val))));

        % Memory blocks update.
        %----------------------
        wmemtool('wmb',win_dw1dstat,n_miscella_loc,...
                        ind_curr_sig,curr_sig,ind_curr_color,curr_color);

        % End waiting.
        %-------------
        wwaiting('off',win_dw1dstat);

        % Setting infos visible.
        %-----------------------
        set(infos_hdls,'Visible','on');

        % Enable new selection.
        %----------------------
        set([pop_handles;rad_handles;edi_handles],'Enable','on');

%**************************************************************%
%** OPTION = 'update_bins' - UPDATE HISTOGRAMS WITH NEW BINS **%
%**************************************************************%
elseif strcmp(option,'update_bins')
        win_dw1dstat    = in2;
        edi_bins_data   = in3;

        % Handles of tagged objects.
        %---------------------------
        pus_show_stat   = findobj(win_dw1dstat,...
                                        'Style','pushbutton',...
                                        'Tag',tag_show_stat...
                                        );
        axe_handles     = findobj(win_dw1dstat,'Type','axes');
        axe_ax_hist     = findobj(axe_handles,'flat','Tag',tag_ax_hist);
        axe_ax_cumhist  = findobj(axe_handles,'flat','Tag',tag_ax_cumhist);

        % Return if no current display.
        %------------------------------
        vis     = get(axe_ax_hist,'Visible');
        if vis(1:2)=='of', return, end

        % Check the bins number.
        %-----------------------
        default_bins    = 30;
        old_params      = get(pus_show_stat,'Userdata');
        if ~isempty(old_params)
                default_bins = old_params(1);
        end
        nb_bins         = str2num(get(edi_bins_data,'String'));
        if isempty(nb_bins)
                nb_bins = default_bins;   
                set(edi_bins_data,'String',int2str(default_bins))
        elseif nb_bins<2
                nb_bins = default_bins;
                set(edi_bins_data,'String',int2str(default_bins))
        end
        if default_bins==nb_bins , return; end

        % Getting memory blocks.
        %-----------------------
        [curr_sig,curr_color] = wmemtool('rmb',win_dw1dstat,n_miscella_loc,...
                                ind_curr_sig,ind_curr_color);

        % Updating histograms.
        %---------------------
        if ~isempty(curr_sig)
                old_params(1) = nb_bins;
                set(pus_show_stat,'Userdata',old_params);
                his             = wgethist(curr_sig,nb_bins);
                his(2,:)        = his(2,:)/length(curr_sig);
                axes(axe_ax_hist);
                wplothis(axe_ax_hist,his,curr_color);
                title('Histogram');

                for i=6:4:length(his(2,:));
                        his(2,i)        = his(2,i)+his(2,i-4);
                        his(2,i+1)      = his(2,i);
                end
                axes(axe_ax_cumhist);
                wplothis(axe_ax_cumhist,[his(1,:);his(2,:)],curr_color);
                title('Cumulative histogram');
        end

%****************************************%
%** OPTION = 'demo' -  DEMOS or TESTS  **%
%****************************************%
elseif strcmp(option,'demo')
        win_dw1dstat    = in2;
        pus_show_stat   = findobj(win_dw1dstat,...
                                        'Style','pushbutton',...
                                        'Tag',tag_show_stat...
                                        );
        eval(get(pus_show_stat,'Callback'));

%****************************************%
%** OPTION = 'close' -  CLOSE FIGURE   **%
%****************************************%
elseif strcmp(option,'close')

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('dw1dstat','Unknown Option','msg');
        error('*');
end

