function [out1,out2] = dw1dsupm(option,win_dw1dtool,in3,in4,in5)
%DW1DSUPM Discret wavelet 1D superimpose mode manager.
%       [out1,out2] = dw1dsupm(option,win_dw1dtool,in3,in4,in5)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:08:38 $

% Default values.
%----------------
default_nbcolors = 128;

% MemBloc1 of stored values.
%---------------------------
n_param_anal    = 'DWAn1d_Par_Anal';
ind_sig_name    =  1;
ind_sig_size    =  2;
ind_wav_name    =  3;
ind_wav_len     =  4;
ind_lev_anal    =  5;
ind_axe_ref     =  6;
ind_act_option  =  7;
ind_ssig_type   =  8;
nb1_stored      =  8;

% Tag property of objects.
%-------------------------
tag_axeappini   = 'Axe_AppIni';
tag_axedetini   = 'Axe_DetIni';
tag_axecfsini   = 'Axe_CfsIni';
tag_axecolmap   = 'Axe_ColMap';
tag_s_inapp     = 'Sig_in_App';
tag_ss_inapp    = 'SSig_in_App';
tag_s_indet     = 'Sig_in_Det';
tag_ss_indet    = 'SSig_in_Det';
tag_app         = 'App';
tag_det         = 'Det';
tag_img_cfs     = 'Img_Cfs';
tag_img_sca     = 'Img_Sca';

axe_handles = findobj(win_dw1dtool,'Type','axes');
txt_handles = findobj(win_dw1dtool,'Style','text');

if strcmp(option,'view')
        % in3 = old_mode
        %       in3 = -1 : same mode
        %       in3 =  0 : clean 
        %       in3 =  1 : scr mode
        %       in3 =  2 : dec mode
        %       in3 =  3 : sep mode
        %       in3 =  4 : sup mode
        %       in3 =  5 : tre mode
        %------------------------------------------
        [Wave_Name,opt_act,Level_Anal] = ...
                        wmemtool('rmb',win_dw1dtool,n_param_anal,...
                                ind_wav_name,ind_act_option,ind_lev_anal);
        old_mode = in3;
        [flg_axe,flg_sa,flg_app,flg_sd,flg_det,ccfs_m] = ...
                        dw1dvmod('get_vm',win_dw1dtool,4);
        lev2    = Level_Anal+2;
        v_flg   = [flg_sa , flg_app , flg_sd , flg_det , flg_axe(3)];
        if flg_axe(1)== 0 , v_flg(1:lev2) = zeros(1,lev2); end
        if flg_axe(2)== 0 , v_flg(lev2+1:2*lev2) = zeros(1,lev2); end
        if flg_axe(3)== 0 , v_flg(2*lev2+1) = 0; end

        vis_str         = getonoff(v_flg);
        v_s_app         = vis_str(1,:);
        v_ss_app        = vis_str(2,:);
        v_app           = vis_str(3:lev2,:);
        v_s_det         = vis_str(lev2+1,:);
        v_ss_det        = vis_str(lev2+2,:);
        v_det           = vis_str(lev2+3:2*lev2,:);
        v_cfs           = vis_str(2*lev2+1,:);

        axe_hdl = dw1dscrm('axes',win_dw1dtool,flg_axe);

        lin_handles     = findobj(axe_hdl,'Type','line');
        img_handles     = findobj(axe_hdl,'Type','image');
        s_in_app        = findobj(lin_handles,'Tag',tag_s_inapp);       
        s_in_det        = findobj(lin_handles,'Tag',tag_s_indet);
        app             = findobj(lin_handles,'Tag',tag_app);
        ss_in_app       = findobj(lin_handles,'Tag',tag_ss_inapp);      
        ss_in_det       = findobj(lin_handles,'Tag',tag_ss_indet);
        det             = findobj(lin_handles,'Tag',tag_det);
        img_cfs         = findobj(img_handles,'Tag',tag_img_cfs);       
        img_sca         = findobj(img_handles,'Tag',tag_img_sca);       

        if isempty(s_in_app)
                x = dw1dfile('sig',win_dw1dtool);
                xmin = 1;               xmax = length(x);
                ymin = min(x)-eps;      ymax = max(x)+eps;
                set(axe_hdl(1:3),'Xlim',[xmin xmax]);
                col_s   = dw1dcolo('sig');
                axes(axe_hdl(1));
                line('Xdata',[xmin:xmax],'Ydata',x,...
                        'Color',col_s,'Visible',v_s_app,'Tag',tag_s_inapp);
                axes(axe_hdl(2));
                line('Xdata',[xmin:xmax],'Ydata',x,...
                        'Color',col_s,'Visible',v_s_det,'Tag',tag_s_indet);
        else
                set(s_in_app,'Visible',v_s_app);
                set(s_in_det,'Visible',v_s_det);
        end
        if isempty(ss_in_app)
                x = dw1dfile('ssig',win_dw1dtool);
                col_ss  = dw1dcolo('ssig');
                axes(axe_hdl(1));
                line('Xdata',[1:length(x)],'Ydata',x,...
                        'Color',col_ss,'Visible',v_ss_app,      ...
                        'Tag',tag_ss_inapp);
                axes(axe_hdl(2));
                line('Xdata',[1:length(x)],'Ydata',x,...
                        'Color',col_ss,'Visible',v_ss_det,      ...
                        'Tag',tag_ss_indet);
        else
                set(ss_in_app,'Visible',v_ss_app);
                set(ss_in_det,'Visible',v_ss_det);
        end

        if isempty(app)
                x       = dw1dfile('app',win_dw1dtool,1:Level_Anal);
                app     = zeros(1,Level_Anal);
                col_app = dw1dcolo('app',Level_Anal);
                axes(axe_hdl(1));
                for k = 1:Level_Anal
                        app(k)  = line( 'Xdata',[1:size(x,2)],  ...
                                        'Ydata',x(k,:),         ...
                                        'Color',col_app(k,:),   ...
                                        'Visible',v_app(k,:),   ...
                                        'Tag',tag_app,          ...
                                        'Userdata',k            ...
                                        );
                end
        else
                for k =1:Level_Anal
                        lin = app(k);
                        ind = get(lin,'Userdata');
                        set(lin,'Visible',v_app(ind,:)); 
                end
        end

        if strcmp(opt_act,'synt')
                ini_str = 'Orig. Synt. Sig.';
        else
                ini_str = 'Signal';
        end

        ss_type = wmemtool('rmb',win_dw1dtool,n_param_anal,ind_ssig_type);
        if      ss_type=='ss', str_ss = 'Synthesized Signal';
        elseif  ss_type=='ds', str_ss = 'De-noised Signal';
        elseif  ss_type=='cs', str_ss = 'Compressed Signal';
        end

        if v_flg(1)==1
                if      v_flg(2)==1
                        str_tit = [ini_str ', ' str_ss];        
                else    
                        str_tit = ini_str;      
                end
        else
                if      v_flg(2)==1
                        str_tit = str_ss;       
                else    
                        str_tit = '';   
                end
        end
        ind = find(flg_app==1);
        if ~isempty(ind)
                if isempty(str_tit) , s = '' ; else , s = ' and '; end
                str_tit = [str_tit s 'Approximation(s) at level(s) :'];
                for k = ind
                        str_tit = [str_tit ' ' int2str(k)];
                end
        end
        axes(axe_hdl(1));       
        title(str_tit);
        if isempty(det)
                ll = findobj([s_in_det,ss_in_det],'Visible','on');
                if isempty(ll)
                        [x,set_ylim,ymin,ymax] = ...
                                dw1dfile('det',win_dw1dtool,1:Level_Anal,1);
                        ymin = min(ymin);
                        ymax = max(ymax);
                        set_ylim = prod(set_ylim);
                else
                        set_ylim = 0;
                        x= dw1dfile('det',win_dw1dtool,1:Level_Anal);
                end
                det     = zeros(1,Level_Anal);
                col_det = dw1dcolo('det',Level_Anal);
                axes(axe_hdl(2));
                for k = 1:Level_Anal
                        det(k)  = line( 'Xdata',[1:size(x,2)],  ...
                                        'Ydata',x(k,:),         ...
                                        'Color',col_det(k,:),   ...
                                        'Visible',v_det(k,:),   ...
                                        'Tag',tag_det,          ...
                                        'Userdata',k            ...
                                        );
                end
                if set_ylim , set(axe_hdl(2),'Ylim',[ymin ymax]); end
        else
                for k =1:Level_Anal
                        lin = det(k);
                        ind = get(lin,'Userdata');
                        set(lin,'Visible',v_det(ind,:)); 
                end
        end
        if v_flg(lev2+1)==1
                if      v_flg(lev2+2)==1
                        str_tit = [ini_str ', ' str_ss];        
                else    
                        str_tit = ini_str;      
                end
        else
                if      v_flg(lev2+2)==1
                        str_tit = str_ss;       
                else    
                        str_tit = '';   
                end
        end
        ind = find(flg_det==1);
        if ~isempty(ind)
                if isempty(str_tit) , s = '' ; else , s = ' and '; end
                str_tit = [str_tit s 'Detail(s) at level(s) :'];
                for k = ind
                        str_tit = [str_tit ' ' int2str(k)];
                end
        end
        axes(axe_hdl(2));
        title(str_tit);

        ax_hdl = axe_hdl(3);
        [rep,ccfs_vm,levs,xlim,nb_cla] = ...
        dw1dmisc('tst_vm',win_dw1dtool,4,ax_hdl,[1:Level_Anal]);
        if rep==1 ,  delete(img_cfs); img_cfs = []; end
        if isempty(img_cfs)
                [x,xlim1,xlim2,ymax,ymin,nb_cla,levs,ccfs_vm] = ...
                        dw1dmisc('col_cfs',win_dw1dtool,        ...
                                                ccfs_vm,levs,xlim,nb_cla);
                axes(ax_hdl);
                img_cfs = image([1 xmax],[ymax ymin],x,...
                        'Visible',v_cfs,'Tag',tag_img_cfs,...
                        'Userdata',[ccfs_vm,levs,xlim1,xlim2,nb_cla]);
                xlim = get(axe_hdl(1),'Xlim');
                levlab = int2str(levs(1));
                for k = 2:length(levs)
                    levlab = str2mat(levlab,int2str(levs(k)));
                end
                set(axe_hdl(3), ...
                                'Xlim',xlim,                 ...     
                                'YTicklabelMode','manual',   ...
                                'YTick',[1:length(levs)],    ...
                                'YTickLabels',levlab,        ...
                                'Tag',tag_axecfsini          ...
                                );
                clear x
                axes(axe_hdl(4));
                image([0 1],[0 1],[1:nb_cla],'Visible',v_cfs,...
                                        'Tag',tag_img_sca);
                set(axe_hdl(4),...
                        'XTickLabels',[],'YTickLabels',[],...
                        'XTick',[],'YTick',[],'Tag',tag_axecolmap);
        else
                set([img_cfs img_sca],'Visible',v_cfs);
        end
        set(axe_hdl(3:4),'Visible',v_cfs);

        axes(axe_hdl(3));
        title('Details Coefficients');
        if strcmp(deblankl(v_cfs),'on') 
                drawnow
                wsetxlab(axe_hdl(4),'Scale of colors from MIN to MAX',-10);
        end

        % Axes attachment.
        %-----------------
        dw1dsupm('dynvtool',win_dw1dtool,old_mode);

        % Reference axes used by stat. & histo & ...
        %-------------------------------------------
        wmemtool('wmb',win_dw1dtool,n_param_anal,ind_axe_ref,axe_hdl(1));

elseif strcmp(option,'dynvtool')
        % Axes attachment.
        %-----------------
        if find(in3==[0 2 3 5])
                axe_app_ini = findobj(axe_handles,'flat','Tag',tag_axeappini);
                axe_det_ini = findobj(axe_handles,'flat','Tag',tag_axedetini);
                axe_cfs_ini = findobj(axe_handles,'flat','Tag',tag_axecfsini);
                dynvtool('attach',win_dw1dtool,...
                        [],[axe_app_ini axe_det_ini],[axe_cfs_ini],[1 0],...
                        '','','');
                dynvtool('put',win_dw1dtool);
        end

elseif strcmp(option,'del_ss')
        lin_handles     = findobj(axe_handles,'Type','line');
        ss_app          = findobj(lin_handles,'Tag',tag_ss_inapp);
        ss_det          = findobj(lin_handles,'Tag',tag_ss_indet);
        delete([ss_app ss_det]);

elseif strcmp(option,'clear')
        % in3 = 0 : clean 
        % in3 = 1 : scr mode
        % in3 = 2 : dec mode
        % in3 = 3 : sep mode
        % in3 = 4 : sup mode
        % in3 = 5 : tre mode
        %--------------------
        new_mode = in3;
        if find(new_mode==[0 2 3 5]);
                dynvtool('off',win_dw1dtool);
        end
        axe_app_ini     = findobj(axe_handles,'flat','Tag',tag_axeappini);
        axe_det_ini     = findobj(axe_handles,'flat','Tag',tag_axedetini);
        axe_cfs_ini     = findobj(axe_handles,'flat','Tag',tag_axecfsini);
        axe_col_map     = findobj(axe_handles,'flat','Tag',tag_axecolmap);

        if new_mode==1
                lin_handles     = findobj(axe_handles,'Type','line');
                img_handles     = findobj(axe_handles,'Type','image');
                s_in_app        = findobj(lin_handles,'Tag',tag_s_inapp);       
                s_in_det        = findobj(lin_handles,'Tag',tag_s_indet);
                ss_in_app       = findobj(lin_handles,'Tag',tag_ss_inapp);
                ss_in_det       = findobj(lin_handles,'Tag',tag_ss_indet);
                img_cfs         = findobj(img_handles,'Tag',tag_img_cfs);
                old_app = findobj(axe_app_ini,'Tag',tag_app);
                out1    = findobj(old_app,'Userdata',1);
                if ~isempty(out1)
                        old_app = old_app(find(old_app~=out1));
                end
                old_det = findobj(axe_det_ini,'Tag',tag_det);
                out2    = findobj(old_det,'Userdata',1);
                if ~isempty(out2)
                        old_det = old_det(find(old_det~=out2));
                end
                set([   s_in_app s_in_det out1  ...
                        ss_in_app ss_in_det out2 img_cfs],'Visible','off');
                delete([old_app' old_det']);

        elseif (new_mode==0) | (new_mode==2) | (new_mode==3) | (new_mode==5)
                mngaxe('vis',[  axe_app_ini,axe_det_ini,...
                                axe_cfs_ini,axe_col_map],'off');
                mngaxe('del_in',[axe_app_ini,axe_det_ini,...
                                        axe_cfs_ini,axe_col_map]);
                drawnow;
        end

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('dw1dsupm','Unknown Option','msg');
        error('*');
end
        
