function out1 = dw1dtool(option,in2)
%DW1DTOOL Discret Wacelet 1D tool.
%       out1 = dw1dtool(option,in2)
%
%       option = 'create' , 'close'

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:08:43 $

global  Def_Btn_Height  Def_Btn_Width   Pop_Min_Width   ...
        X_Spacing       Y_Spacing       X_Graph_Ratio   ...
        Lst_ColorMap    Def_TxtBkColor  Def_EdiBkColor  ...
        Def_FraBkColor  Def_FraFgColor

% Test inputs.
%-------------
if nargin==0
        option  = 'create'; in2 = [];
elseif nargin==1
        in2 = [];
end
[continu,option,in2] = wfigcrea('test',option,in2);
if ~continu , return; end 

% Default values.
%----------------
max_lev_anal     = 12;
min_nbcolors     = 2;
max_nbcolors     = 128;
default_nbcolors = 128;

% MemBloc0 of stored values.
%---------------------------
n_InfoInit      = 'DW1D_InfoInit';
ind_filename    =  1;
ind_pathname    =  2;
nb0_stored      =  2;

% MemBloc1 of stored values.
%---------------------------
n_param_anal    = 'DWAn1d_Par_Anal';
ind_sig_name    =  1;
ind_sig_size    =  2;
ind_wav_name    =  3;
ind_wav_len     =  4;
ind_lev_anal    =  5;
ind_axe_ref     =  6;
ind_act_option  =  7;
ind_ssig_type   =  8;
nb1_stored      =  8;

% MemBloc2 of stored values.
%---------------------------
n_coefs_longs   = 'Coefs_and_Longs';
ind_coefs       = 1;
ind_longs       = 2;
nb2_stored      = 2;

% MemBloc3 of stored values.
%---------------------------
n_synt_sig      = 'Synt_Sig';
ind_ssig        =  1;
nb3_stored      =  1;

% MemBloc4 of stored values.
%---------------------------
n_miscella      = 'DWAn1d_Miscella';
ind_graph_area  =  1;
ind_view_mode   =  2;
ind_savepath    =  3;
nb4_stored      =  3;

% Tag property of objects.
%-------------------------
tag_m_files     = 'Files';
tag_m_savesyn   = 'Save_Syn';
tag_m_savecfs   = 'Save_Cfs';
tag_m_savedec   = 'Save_Dec';
tag_input_txt   = 'Input_Txt';
tag_input_data  = 'Input_Data';
tag_wav_fams    = 'Wav_Fams';
tag_wav_nums    = 'Wav_Nums';
tag_lev_data    = 'Lev_Data';
tag_pus_anal    = 'Pus_Anal';
tag_pus_deno    = 'Pus_Deno';
tag_pus_comp    = 'Pus_Comp';
tag_pus_hist    = 'Pus_Hist';
tag_pus_stat    = 'Pus_Stat';
tag_pop_viewm   = 'View_Mode';
tag_pus_dispopt = 'Pus_Options';
tag_valapp_scr  = 'ValApp_Scr';
tag_txtapp_scr  = 'TxtApp_Scr';
tag_valdet_scr  = 'ValDet_Scr';
tag_txtdet_scr  = 'TxtDet_Scr';
tag_declev      = 'Pop_DecLev';
tag_txtdeclev   = 'Txt_DecLev';

tag_cfs_map     = 'Pop_ColorMap';
tag_sli_nbc     = 'Sli_NBColors';
tag_edi_nbc     = 'Edi_NBColors';
tag_txt_map     = 'Txt_Map';
tag_txt_nbc     = 'Txt_Nbc';
tag_btn_close   = 'Wave_Close';

tag_m_options   = 'M_Options';
tag_Def_DispM   = 'Default_DispM';

%*****************************************************************%
%** OPTION = 'create' - constructs the initial dw1dtool window  **%
%*****************************************************************%
if strcmp(option,'create')

        % Wavelet 1-D window initialization.
        %-----------------------------------
        win_name = 'Wavelet 1-D';
        [win_dw1dtool,pos_win,cba_close_menu] = ...
                wfigcrea('create',in2,win_name,'DW1Dtool','',3,'dw1dtool');
        str_numwin = int2str(win_dw1dtool);
        win_units  = 'pixels';
        out1       = win_dw1dtool;

        % Menu construction for current figure.
        %--------------------------------------
        lst_menu  = findobj(win_dw1dtool,'type','uimenu','Parent',win_dw1dtool);
        m_files   = wfindmen(lst_menu,'file');
        set(m_files,'tag',tag_m_files);
        m_loadsig = uimenu(m_files,...
                                'Label','Load Signal ',         ...
                                'Position',1,                   ...
                                'Callback',                     ...
                                ['dw1dmngr(''load_sig'','       ...
                                        str_numwin ');']        ...
                                );

        m_loadcfs = uimenu(m_files,...
                                'Label','Load Coefficients ',   ...
                                'Position',2,                   ...
                                'Callback',                     ...
                                ['dw1dmngr(''load_cfs'','       ...
                                        str_numwin ');']        ...
                                );
        m_loaddec = uimenu(m_files,...
                                'Label','Load Decomposition ',  ...
                                'Position',3,                   ...
                                'Callback',                     ...
                                ['dw1dmngr(''load_dec'','       ...
                                        str_numwin ');']        ...
                                );
        m_savesyn = uimenu(m_files,...
                                'Label','Save Synthesized Signal',...
                                'Position',4,                   ...
                                'Separator','on',               ...
                                'Enable','Off',                 ...
                                'Tag',tag_m_savesyn,            ...
                                'Callback',                     ...
                                ['dw1dmngr(''save_synt'','      ...
                                        str_numwin ');']        ...
                                );
        m_savecfs = uimenu(m_files,...
                                'Label','Save Coefficients ',   ...
                                'Position',5,                   ...
                                'Enable','Off',                 ...
                                'Tag',tag_m_savecfs,            ...
                                'Callback',                     ...
                                ['dw1dmngr(''save_cfs'','       ...
                                        str_numwin ');']        ...
                                );
        m_savedec = uimenu(m_files,...
                                'Label','Save Decomposition ',  ...
                                'Position',6,                   ...
                                'Enable','Off',                 ...
                                'Tag',tag_m_savedec,            ...
                                'Callback',                     ...
                                ['dw1dmngr(''save_dec'','       ...
                                        str_numwin ');']        ...
                                );
        m_loadtst = uimenu(m_files,...
                                'Label','Demo Analysis ',       ...
                                'Position',7,                   ...
                                'Separator','on'                ...
                                );

        % Submenu of test signals.
        %-------------------------
        names(1,:)  = 'Sum of sines                          ';
        names(2,:)  = 'Frequency breakdown                   ';
        names(3,:)  = 'Uniform white noise                   ';
        names(4,:)  = 'AR(3) noise                           ';
        names(5,:)  = 'Noisy polynomial                      ';
        names(6,:)  = 'Noisy polynomial                      ';
        names(7,:)  = 'Step signal                           ';
        names(8,:)  = 'Two nearby discontinuities            ';
        names(9,:)  = 'Two nearby discontinuities            ';
        names(10,:) = 'Second derivative breakdown           ';
        names(11,:) = 'Second derivative breakdown           ';
        names(12,:) = 'Ramp + white noise                    ';
        names(13,:) = 'Ramp + colored noise                  ';
        names(14,:) = 'Sine + white noise                    ';
        names(15,:) = 'Triangle + sine                       ';
        names(16,:) = 'Triangle + sine + noise               ';
        names(17,:) = 'Electrical consumption                ';
        names(18,:) = 'Cantor curve                          ';
        names(19,:) = 'Koch curve                            ';

        files = str2mat('sumsin','freqbrk','whitnois','warma','noispol');
        files = str2mat(files,'noispol','wstep','nearbrk','nearbrk','scddvbrk');
        files = str2mat(files,'scddvbrk','wnoislop','cnoislop','noissin');
        files = str2mat(files,'trsin','wntrsin','leleccum','wcantor','vonkoch');

        waves = str2mat('db3','db5','db3','db3','db2','db3','db2','db2');
        waves = str2mat(waves,'db7','db1','db4','db3','db3','db5','db5','db5');
        waves = str2mat(waves,'db3','db1','db1');

        levels = ['5';'5';'5';'5';'4';'4';'5';'5';'5';'2';'2';'6';'6';'5';...
                        '6';'7';'5';'5';'5'];

        beg_call_str = ['dw1dmngr(''demo'',' str_numwin ','''];
        for i=1:size(files,1)
                libel = ['with ' waves(i,:) ' at level ' levels(i,:) ...
                                '  --->  ' names(i,:)];
                action = [beg_call_str files(i,:) ''',''' ...
                                waves(i,:) ''',' levels(i,:) ');'];
                uimenu(m_loadtst,'Label',libel,'Callback',action);
        end

        names(1,:)  = 'Noisy blocks                          ';
        names(2,:)  = 'Noisy bumps                           ';
        names(3,:)  = 'Noisy heavysin                        ';
        names(4,:)  = 'Noisy Doppler                         ';
        names(5,:)  = 'Noisy quadchirp                       ';
        names(6,:)  = 'Noisy mishmash                        ';
        files = str2mat('noisbloc','noisbump','heavysin',...
                        'noisdopp','noischir','noismima');
        waves   = str2mat('sym8','sym4','sym8','sym4','db1 ','db3 ');
        levels  = ['5';'5';'5';'5';'5';'5'];
        beg_call_str = ['dw1dmngr(''demo'',' str_numwin ','''];
        for i=1:size(files,1)
                libel = ['with ' waves(i,:) ' at level ' levels(i,:) ...
                                '  --->  ' names(i,:)];
                action = [beg_call_str files(i,:) ''',''' ...
                                waves(i,:) ''',' levels(i,:) ');'];
                if i==1 , sep = 'on' ; else sep = 'off'; end
                uimenu(m_loadtst,'Separator',sep,...
                                'Label',libel,'Callback',action);
        end
        drawnow

        % Adding option for choosing Default Display Mode.
        %-------------------------------------------------
        DW1D_Display_Mode = 2;
        m_opt  = findobj(win_dw1dtool,'type','uimenu','tag',tag_m_options);
        m_disp = uimenu(m_opt,                          ...
                        'Label','Default Display Mode', ...
                        'Separator','on'                ...
                        );
        nbm     = 5;
        dm      = zeros(1,nbm);
        dm(1)   = uimenu(m_disp,                        ...
                        'Label','Show and Scroll',      ...
                        'Checked','Off'                 ...
                        );
        dm(2)   = uimenu(m_disp,                        ...
                        'Label','Full Decomposition',   ...
                        'Checked','Off'                 ...
                        );
        dm(3)   = uimenu(m_disp,                        ...
                        'Label','Separate Mode',        ...
                        'Checked','Off'                 ...
                        );
        dm(4)   = uimenu(m_disp,                        ...
                        'Label','Superimpose Mode',     ...
                        'Checked','Off'                 ...
                        );
        dm(5)   = uimenu(m_disp,                        ...
                        'Label','Tree Mode',            ...
                        'Checked','Off'                 ...
                        );
        dmstr = num2mstr(dm);
        for k = 1:nbm
                set(dm(k),                              ...
                        'Userdata',k,                   ...
                        'CallBack',...
                        ['dw1dvdrv(''default'',' str_numwin ...
                        ','  dmstr ',' int2str(k) ');']);
        end
        dw1dvdrv('default',win_dw1dtool,dm,DW1D_Display_Mode);

        % Command frame and Dynamical visualization tool construction.
        %-------------------------------------------------------------
        [frame0,pos_frame0,Pos_Graphic_Area] = ...
                        wfigcrea('frame',win_dw1dtool,'dynv','title');

        % Waiting Frame construction & begin waiting.
        %--------------------------------------------
        wwaiting('create',win_dw1dtool,X_Graph_Ratio,...
                        'Wait ... initialization');

        % Borders and double borders.
        %----------------------------
        dx  = X_Spacing;        dx2 = 2*dx;
        dy  = Y_Spacing;        dy2 = 2*dy;

        % Position property of objects.
        %------------------------------
        x_frame0        = pos_frame0(1);
        cmd_width       = pos_frame0(3);
        y_low           = pos_win(4)-Def_Btn_Height-dy2;
        x_left          = x_frame0+dx2;
        pos_input_txt   = [     x_left                          ,...
                                y_low                           ,...
                                Def_Btn_Width                   ,...
                                Def_Btn_Height                  ];

        pos_input_data  = [     pos_input_txt(1)+pos_input_txt(3)+dx    ,...
                                pos_input_txt(2)                        ,...
                                2*Pop_Min_Width                         ,...
                                Def_Btn_Height                          ];

        pos_wav_txt     = pos_input_txt;
        pos_wav_txt(2)  = pos_input_txt(2)-Def_Btn_Height-dy2;

        pos_wav_fams    = [     pos_wav_txt(1)+pos_wav_txt(3)+dx        ,...
                                pos_wav_txt(2)                          ,...
                                Pop_Min_Width                           ,...
                                Def_Btn_Height                          ];

        pos_wav_nums    = pos_wav_fams;
        pos_wav_nums(1) = pos_wav_fams(1)+pos_wav_fams(3);

        pos_lev_txt     = pos_wav_txt;
        pos_lev_txt(2)  = pos_wav_txt(2)-Def_Btn_Height-dy2;

        pos_lev_data    = [     pos_lev_txt(1)+pos_lev_txt(3)+dx        ,...
                                pos_lev_txt(2)                          ,...
                                Pop_Min_Width                           ,...
                                Def_Btn_Height                          ];
        bdx             = (cmd_width-1.5*Def_Btn_Width)/2;
        x_left          = x_frame0+bdx;
        y_low           = pos_lev_data(2)-Def_Btn_Height-4*dy2;
        pos_anal        = [     x_left                                  ,...
                                y_low                                   ,...
                                1.5*Def_Btn_Width                       ,...
                                1.5*Def_Btn_Height                      ];

        x_left          = x_frame0+dx2;
        y_low           = pos_anal(2)-1.5*Def_Btn_Height-2*dy2;
        push_width      = (cmd_width-3*dx2)/2;

        pos_stat        = [     x_left                                  ,...
                                y_low                                   ,...
                                push_width                              ,...
                                1.5*Def_Btn_Height                      ];

        pos_comp        = pos_stat;
        pos_comp(1)     = pos_stat(1)+pos_stat(3)+dx2;

        y_low           = y_low-1.5*Def_Btn_Height-dy;
        pos_hist        = [     x_left                                  ,...
                                y_low                                   ,...
                                push_width                              ,...
                                1.5*Def_Btn_Height                      ];
        pos_deno        = pos_hist;
        pos_deno(1)     = pos_hist(1)+pos_hist(3)+dx2;

        x_left          = x_frame0+dx2;
        y_low           = pos_hist(2)-1.5*Def_Btn_Height-2*dy2;
        pos_viewm_txt   = [     x_left                          ,...
                                y_low                           ,...
                                2*Def_Btn_Width                 ,...
                                Def_Btn_Height                  ];

        pop_width       = cmd_width-4*dx2;       
        x_left          = x_frame0+(cmd_width-pop_width)/2;
        y_low           = pos_viewm_txt(2)-Def_Btn_Height-dy;
        pos_pop_viewm   = [     x_left                                  ,...
                                y_low                                   ,...
                                pop_width                               ,...
                                Def_Btn_Height                          ];

        pos_pus_dispopt = [     x_left                                  ,...
                                y_low                                   ,...
                                pop_width                               ,...
                                Def_Btn_Height                          ];

        px              = x_frame0+(cmd_width-7*push_width/4)/2;
        pos_close       = [     px                                      ,...
                                pos_frame0(2)+Def_Btn_Height            ,...
                                7*push_width/4                          ,...
                                3*Def_Btn_Height/2                      ];

        y_low           = pos_pop_viewm(2)-Def_Btn_Height-dy2;
        x_left          = pos_frame0(1)+dx2;
        pos_txtapp_scr  = [     x_left                                  ,...
                                y_low                                   ,...
                                Pop_Min_Width/2+dx/4                    ,...
                                Def_Btn_Height                          ];
        pos_valapp_scr  = [     pos_txtapp_scr(1)+pos_txtapp_scr(3)+dx  ,...
                                y_low                                   ,...
                                Pop_Min_Width                           ,...
                                Def_Btn_Height                          ];
        pos_txtdet_scr  = [     pos_valapp_scr(1)+pos_valapp_scr(3)+dx2 ,...
                                y_low                   ,...
                                Pop_Min_Width/2+dx/4                    ,...
                                Def_Btn_Height                          ];
        pos_valdet_scr  = [     pos_txtdet_scr(1)+pos_txtdet_scr(3)+dx,...
                                y_low                                   ,...
                                Pop_Min_Width                           ,...
                                Def_Btn_Height                          ];

        y_low           = pos_pop_viewm(2)-Def_Btn_Height-dy2;
        x_left          = pos_frame0(1)+dx2;
        pos_txtlev_dec  = [     x_left                                  ,...
                                y_low                                   ,...
                                Def_Btn_Width                           ,...
                                Def_Btn_Height                          ];
        pos_declev      = [     pos_txtlev_dec(1)+Def_Btn_Width+dx2     ,...
                                pos_txtlev_dec(2)                       ,...
                                Pop_Min_Width                           ,...
                                Def_Btn_Height                          ];

        xleft = x_frame0+(cmd_width-2*Def_Btn_Width-dx-Def_Btn_Width/2.4)/2;
        ylow    = 5*Def_Btn_Height;
        pos_txt_map     = [     xleft,          ...
                                ylow,           ...
                                Def_Btn_Width,  ...
                                Def_Btn_Height];
        pos_pop_map     = pos_txt_map;
        pos_pop_map(1)  = pos_pop_map(1)+pos_txt_map(3);
        pos_txt_nbc     = pos_txt_map;
        pos_txt_nbc(2)  = pos_txt_nbc(2)-Def_Btn_Height-dy;
        pos_sli_nbc     = [     pos_txt_nbc(1)+pos_txt_nbc(3),...
                                pos_txt_nbc(2)+dy               ,...
                                Def_Btn_Width                   ,...
                                pos_txt_nbc(4)-2*dy             ...
                                ];
        pos_edi_nbc     = [     pos_sli_nbc(1)+pos_sli_nbc(3)+dx,       ...
                                pos_txt_nbc(2),                         ...
                                Def_Btn_Width/2.4,                      ...
                                Def_Btn_Height                          ...
                                ];


        % String property of objects.
        %----------------------------
        str_input_txt   = 'Signal';
        str_input_data  = '';
        str_wav_txt     = 'Wavelet';
        [str_wav_fams,str_wav_nums] = wavattrb('ini','dwt');
        str_lev_txt     = 'Level';
        str_levels      = [int2str(1)];
        for k=2:max_lev_anal , str_levels = str2mat(str_levels,int2str(k)); end;
        str_anal        = 'Analyze';
        str_stat        = 'Statistics';
        str_comp        = 'Compress';
        str_hist        = 'Histograms';
        str_deno        = 'De-noise';
        str_viewm_txt   = 'Display mode : ';
        str_pop_viewm   = str2mat(...
                                'Show and Scroll','Full Decomposition', ...
                                'Separate Mode','Superimpose Mode',     ...
                                'Tree Mode'                             ...
                                );
        str_pus_dispopt = 'More Display Options';
        str_close       = 'Close';

        str_txtapp_scr  = 'App.';
        str_valapp_scr  = str_levels;
        str_txtdet_scr  = 'Det.';
        str_valdet_scr  = str_levels;

        str_txtlev_dec  = 'at level';
        str_declev      = str_levels;

        str_txt_map     = 'Colormap';
        str_txt_nbc     = 'Nb. Colors';
        str_cfs_map     = Lst_ColorMap;
        str_edi_nbc     = int2str(size(get(win_dw1dtool,'Colormap'),1));

        % Callback property of objects.
        %------------------------------
        action          = '';
        cba_anal        = ['dw1dmngr(''anal'',' str_numwin ');'];
        cba_stat        = ['dw1dmngr(''stat'',' str_numwin ');'];
        cba_comp        = ['dw1dmngr(''comp'',' str_numwin ');'];
        cba_hist        = ['dw1dmngr(''hist'',' str_numwin ');'];
        cba_deno        = ['dw1dmngr(''deno'',' str_numwin ');'];
        cba_viewm       = ['dw1dvmod(''ch_vm'',' str_numwin ');'];
        cba_mdisp       = ['dw1ddisp(''create'',' str_numwin ');'];
        cba_app_scr     = ['dw1dscrm(''app'',' str_numwin ');'];
        cba_det_scr     = ['dw1dscrm(''det'',' str_numwin ');'];
        cba_declev      = ['dw1ddecm(''dec'',' str_numwin ');'];

        % Command part of the window.
        %----------------------------
        figure(win_dw1dtool);
        txt_input_txt           = uicontrol(...
                                        'Style','text',                 ...
                                        'Unit',win_units,               ...
                                        'HorizontalAlignment','left',   ...
                                        'Position',pos_input_txt,       ...
                                        'String',str_input_txt,         ...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'Tag',tag_input_txt             ...
                                        );
        txt_input_data          = uicontrol(...
                                        'Style','Text',                 ...
                                        'Units',win_units,              ...
                                        'Position',pos_input_data,      ...
                                        'String',str_input_data,        ...
                                        'Backgroundcolor',Def_TxtBkColor,...
                                        'Tag',tag_input_data            ...
                                        );
        txt_wav_txt     = uicontrol(...
                                        'Style','text',                 ...
                                        'Unit',win_units,               ...
                                        'HorizontalAlignment','left',   ...
                                        'Position',pos_wav_txt,         ...
                                        'String',str_wav_txt,           ...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
        pop_wav_fams    = uicontrol(...
                                        'Style','Popup',        ...
                                        'Unit',win_units,       ...
                                        'Position',pos_wav_fams,...
                                        'String',str_wav_fams,  ...
                                        'Enable','off',         ...
                                        'Tag',tag_wav_fams      ...
                                        );
        pop_wav_nums    = uicontrol(...
                                        'Style','Popup',        ...
                                        'Unit',win_units,       ...
                                        'Position',pos_wav_nums,...
                                        'String',str_wav_nums,  ...
                                        'Visible','off',        ...
                                        'Enable','off',         ...
                                        'Tag',tag_wav_nums      ...
                                        );
        txt_lev_txt     = uicontrol(...
                                        'Style','text',                 ...
                                        'Unit',win_units,               ...
                                        'HorizontalAlignment','left',   ...
                                        'Position',pos_lev_txt,         ...
                                        'String',str_lev_txt,           ...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
        pop_lev_data    = uicontrol(...
                                        'Style','Popup',        ...
                                        'Unit',win_units,       ...
                                        'Position',pos_lev_data,...
                                        'String',str_levels,    ...
                                        'Enable','off',         ...
                                        'Tag',tag_lev_data      ...
                                        );
        pus_anal        = uicontrol(...
                                        'Style','Pushbutton',   ...
                                        'Unit',win_units,       ...
                                        'Position',pos_anal,    ...
                                        'String',str_anal,      ...
                                        'Enable','off',         ...
                                        'Tag',tag_pus_anal,     ...
                                        'Callback',cba_anal,    ...
                                        'Interruptible','yes'   ...
                                        );

        pus_stat        = uicontrol(...
                                        'Style','Pushbutton',   ...
                                        'Unit',win_units,       ...
                                        'Position',pos_stat,    ...
                                        'String',str_stat,      ...
                                        'Enable','off',         ...
                                        'Tag',tag_pus_stat,     ...
                                        'Callback',cba_stat     ...
                                        );
        pus_comp        = uicontrol(...
                                        'Style','Pushbutton',   ...
                                        'Unit',win_units,       ...
                                        'Position',pos_comp,    ...
                                        'String',str_comp,      ...
                                        'Enable','off',         ...
                                        'Tag',tag_pus_comp,     ...
                                        'Callback',cba_comp     ...
                                        );
        pus_hist        = uicontrol(...
                                        'Style','Pushbutton',   ...
                                        'Unit',win_units,       ...
                                        'Position',pos_hist,    ...
                                        'String',str_hist,      ...
                                        'Enable','off',         ...
                                        'Tag',tag_pus_hist,     ...
                                        'Callback',cba_hist     ...
                                        );
        pus_deno        = uicontrol(...
                                        'Style','Pushbutton',   ...
                                        'Unit',win_units,       ...
                                        'Position',pos_deno,    ...
                                        'String',str_deno,      ...
                                        'Enable','off',         ...
                                        'Tag',tag_pus_deno,     ...
                                        'Callback',cba_deno     ...
                                        );

        txt_viewm_txt   = uicontrol(...
                                        'Style','text',                 ...
                                        'Unit',win_units,               ...
                                        'HorizontalAlignment','left',   ...
                                        'Position',pos_viewm_txt,       ...
                                        'String',str_viewm_txt,         ...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
        view_mode       = 1;
        pop_viewm       = uicontrol(...
                                        'Style','Popup',                ...
                                        'Unit',win_units,               ...
                                        'Position',pos_pop_viewm,       ...
                                        'String',str_pop_viewm,         ...
                                        'Value',view_mode,              ...
                                        'UserData',view_mode,           ...
                                        'Enable','off',                 ...
                                        'Callback',cba_viewm,           ...
                                        'Tag',tag_pop_viewm             ...
                                        );

        pus_dispopt     = uicontrol(...
                                        'Style','Pushbutton',           ...
                                        'Unit',win_units,               ...
                                        'Position',pos_pus_dispopt,     ...
                                        'String',str_pus_dispopt,       ...
                                        'Visible','off',                ...
                                        'Enable','off',                 ...
                                        'Tag',tag_pus_dispopt,          ...
                                        'Interruptible','yes',          ...
                                        'Callback',cba_mdisp            ...
                                        );

        pus_close       = uicontrol(...
                                        'Style','Pushbutton',           ...
                                        'Unit',win_units,               ...
                                        'Position',pos_close,           ...
                                        'String',str_close,             ...
                                        'Interruptible','yes',          ...
                                        'Callback',cba_close_menu,      ...
                                        'Tag',tag_btn_close             ...     
                                        );

        txt_txtapp_scr  = uicontrol(...
                                        'Style','Text',                 ...
                                        'Unit',win_units,               ...
                                        'Position',pos_txtapp_scr,      ...
                                        'Visible','Off',                ...
                                        'String',str_txtapp_scr,        ...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'Tag',tag_txtapp_scr            ...
                                        );
        pop_valapp_scr  = uicontrol(...
                                        'Style','Popup',                ...
                                        'Unit',win_units,               ...
                                        'Position',pos_valapp_scr,      ...
                                        'Visible','Off',                ...
                                        'String',str_valapp_scr,        ...
                                        'Enable','off',                 ...
                                        'Tag',tag_valapp_scr,           ...
                                        'Callback',cba_app_scr          ...
                                        );
        txt_txtdet_scr  = uicontrol(...
                                        'Style','Text',                 ...
                                        'Unit',win_units,               ...
                                        'Position',pos_txtdet_scr,      ...
                                        'Visible','Off',                ...
                                        'String',str_txtdet_scr,        ...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'Tag',tag_txtdet_scr            ...
                                        );
        pop_valdet_scr  = uicontrol(...
                                        'Style','Popup',                ...
                                        'Unit',win_units,               ...
                                        'Position',pos_valdet_scr,      ...
                                        'Visible','Off',                ...
                                        'String',str_valdet_scr,        ...
                                        'Enable','off',                 ...
                                        'Tag',tag_valdet_scr,           ...
                                        'Callback',cba_det_scr          ...
                                        );

        txt_txtlev_dec = uicontrol(...
                                        'Style','Text',                 ...
                                        'Unit',win_units,               ...
                                        'Position',pos_txtlev_dec,      ...
                                        'Visible','Off',                ...
                                        'String',str_txtlev_dec,        ...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'Tag',tag_txtdeclev             ...
                                        );
        pop_declev      = uicontrol(...
                                        'Style','Popup',        ...
                                        'Unit',win_units,       ...
                                        'Position',pos_declev,  ...
                                        'Visible','Off',        ...
                                        'String',str_declev,    ...
                                        'Enable','off',         ...
                                        'Tag',tag_declev,       ...
                                        'Callback',cba_declev   ...
                                        );

        txt_map         = uicontrol(...
                                        'Style','Text',                 ...
                                        'Unit',win_units,               ...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'Position',pos_txt_map,         ...
                                        'HorizontalAlignment','left',   ...
                                        'String',str_txt_map,           ...
                                        'Tag',tag_txt_map               ...
                                        );
        pop_cfs_map     = uicontrol(...
                                        'Style','Popup',...
                                        'Unit',win_units,...
                                        'Position',pos_pop_map,...
                                        'String',str_cfs_map,...
                                        'Callback',action,...
                                        'Tag',tag_cfs_map...
                                        );

        txt_nbc         = uicontrol(...
                                        'Style','Text',                 ...
                                        'Unit',win_units,               ...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'Position',pos_txt_nbc,         ...
                                        'HorizontalAlignment','left',   ...
                                        'String',str_txt_nbc,           ...
                                        'Tag',tag_txt_nbc               ...
                                        );
        
        sli_nbc         = uicontrol(...
                                        'Style','Slider',...
                                        'Unit',win_units,...
                                        'Position',pos_sli_nbc,...
                                        'Min',min_nbcolors,...
                                        'Max',max_nbcolors,...
                                        'Value',default_nbcolors,...
                                        'Tag',tag_sli_nbc...
                                        );                              

        edi_nbc         = uicontrol(...
                                        'Style','Edit',                 ...
                                        'Unit',win_units,               ...
                                        'Backgroundcolor',Def_EdiBkColor,...
                                        'Position',pos_edi_nbc,         ...
                                        'String',str_edi_nbc,           ...
                                        'Callback',action,              ...
                                        'Tag',tag_edi_nbc               ...
                                        );

        % Initial Mode.
        %--------------
        pos_txt1        = get(txt_txtapp_scr,'Position');
        pos_opt         = get(pus_dispopt,'Position');
        pos_opt(2)      = pos_txt1(2)-Def_Btn_Height-2*dy2;
        set(pus_dispopt,'Position',pos_opt);
        set([   txt_txtapp_scr, txt_txtdet_scr,...
                pop_valapp_scr, pop_valdet_scr, pus_dispopt],'Visible','on');
        drawnow

        %  Normalisation.
        %----------------
        Pos_Graphic_Area = Pos_Graphic_Area./[pos_win(3:4),pos_win(3:4)];
        set(findobj(win_dw1dtool,'units','pixels'),'units','normalized');

        % Callbacks update.
        %------------------
        cba_pop_wav_fams = [    'wavattrb(''gettnum'','         ...
                                num2mstr(pop_wav_fams) ','      ...
                                num2mstr(pop_wav_nums) ');'];
        set(pop_wav_fams,'Callback',cba_pop_wav_fams);

        cba_pop_wav_nums = [    'wnumbtn(1,'            ...
                                num2mstr([pop_wav_fams pop_wav_nums]) ',' ...
                                num2mstr([m_files pus_anal]) ');'];
        set(pop_wav_nums,'Callback',cba_pop_wav_nums);

        cba_pop_cfs_map = [     'mapcolor(''pal'','     ...
                                str_numwin ','                  ...
                                num2mstr(pop_cfs_map) ');'];
        cba_edi_nbc = [ 'mapcolor(''nbc'','             ...
                                str_numwin ','                  ...
                                num2mstr([pop_cfs_map edi_nbc]) ');'];

        cba_sli_nbc = [ 'mapcolor(''nbc'','             ...
                                str_numwin ','                  ...
                                num2mstr([pop_cfs_map sli_nbc]) ');'];

        set(pop_cfs_map,'Callback',cba_pop_cfs_map);
        set(edi_nbc,'Callback',cba_edi_nbc);
        set(sli_nbc,'Callback',cba_sli_nbc);
        drawnow;

        % Memory for stored values.
        %--------------------------
        wmemtool('ini',win_dw1dtool,n_InfoInit,nb0_stored);
        wmemtool('ini',win_dw1dtool,n_param_anal,nb1_stored);
        wmemtool('ini',win_dw1dtool,n_coefs_longs,nb2_stored);
        wmemtool('ini',win_dw1dtool,n_synt_sig,nb3_stored);
        wmemtool('ini',win_dw1dtool,n_miscella,nb4_stored);
        wmemtool('wmb',win_dw1dtool,n_miscella,...
                                ind_graph_area,Pos_Graphic_Area);

        % Colormap Initial Value.
        %------------------------
        mapcolor('set',win_dw1dtool,'pink',[pop_cfs_map],default_nbcolors);

        % Initialize View Mode Parametres.
        %---------------------------------
        dw1dvmod('ini_vm',win_dw1dtool);

        % End waiting.
        %---------------
        wwaiting('off',win_dw1dtool);

%***********************************************%
%** OPTION = 'close' - close dw1dtool window  **%
%***********************************************%
elseif strcmp(option,'close')
        % in2 = win_dw1dtool
        %--------------------
        feval('dw1dfile','del',in2);
        called_win = findobj(get(0,'children'),'flat','Userdata',in2);
        close(called_win);

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('dw1dtool','Unknown Option','msg');
        error('*');
end
