function dw1dutil(option,in2,in3,in4)
%DW1DUTIL Discret wavelet 1D utilities.
%       dw1dutil(option,in2,in3,in4)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:08:54 $

% Default values.
%----------------
max_lev_anal     = 12;

% MemBloc1 of stored values.
%---------------------------
n_param_anal    = 'DWAn1d_Par_Anal';
ind_sig_name    =  1;
ind_sig_size    =  2;
ind_wav_name    =  3;
ind_wav_len     =  4;
ind_lev_anal    =  5;
ind_axe_ref     =  6;
ind_act_option  =  7;
ind_ssig_type   =  8;
nb1_stored      =  8;

% Tag property of objects.
%-------------------------
tag_m_files     = 'Files';
tag_m_savesyn   = 'Save_Syn';
tag_m_savecfs   = 'Save_Cfs';
tag_m_savedec   = 'Save_Dec';
tag_cmd_frame   = 'Cmd_Frame';
tag_input_txt   = 'Input_Txt';
tag_input_data  = 'Input_Data';
tag_wav_fams    = 'Wav_Fams';
tag_wav_nums    = 'Wav_Nums';
tag_lev_data    = 'Lev_Data';
tag_pus_anal    = 'Pus_Anal';
tag_pus_deno    = 'Pus_Deno';
tag_pus_comp    = 'Pus_Comp';
tag_pus_hist    = 'Pus_Hist';
tag_pus_stat    = 'Pus_Stat';
tag_pop_viewm   = 'View_Mode';
tag_pus_dispopt = 'Pus_Options';
tag_valapp_scr  = 'ValApp_Scr';
tag_txtapp_scr  = 'TxtApp_Scr';
tag_valdet_scr  = 'ValDet_Scr';
tag_txtdet_scr  = 'TxtDet_Scr';
tag_declev      = 'Pop_DecLev';
tag_txtdeclev   = 'Txt_DecLev';

% Figure handle.
%---------------
win_dw1dtool    = in2;

% Handles of tagged objects.
%---------------------------
axe_handles     = findobj(win_dw1dtool,'Type','axes');
uic_handles     = findobj(win_dw1dtool,'type','uicontrol');
txt_handles     = findobj(uic_handles,'Style','text');
pop_handles     = findobj(uic_handles,'Style','popupmenu');
pus_handles     = findobj(uic_handles,'Style','pushbutton');
pus_dispopt     = findobj(uic_handles,'tag',tag_pus_dispopt);

if      strcmp(option,'clean') | strcmp(option,'enable') | ...
        strcmp(option,'set_gui')

        % Handles of tagged objects.
        %---------------------------
        uim_handles     = findobj(win_dw1dtool,'Type','uimenu');
        m_files         = findobj(uim_handles,'flat','Tag',tag_m_files);
        m_savesyn       = findobj(m_files,'Tag',tag_m_savesyn);
        m_savecfs       = findobj(m_files,'Tag',tag_m_savecfs);
        m_savedec       = findobj(m_files,'Tag',tag_m_savedec);

        txt_input_txt   = findobj(txt_handles,'Tag',tag_input_txt);
        txt_input_data  = findobj(txt_handles,'Tag',tag_input_data);
        pop_wav_fams    = findobj(pop_handles,'Tag',tag_wav_fams);
        pop_wav_nums    = findobj(pop_handles,'Tag',tag_wav_nums);
        pop_lev_data    = findobj(pop_handles,'Tag',tag_lev_data);
        pus_anal        = findobj(pus_handles,'Tag',tag_pus_anal);
        pus_deno        = findobj(pus_handles,'Tag',tag_pus_deno);
        pus_comp        = findobj(pus_handles,'Tag',tag_pus_comp);
        pus_hist        = findobj(pus_handles,'Tag',tag_pus_hist);
        pus_stat        = findobj(pus_handles,'Tag',tag_pus_stat);
        pop_viewm       = findobj(pop_handles,'tag',tag_pop_viewm);
        pop_app_scr     = findobj(pop_handles,'Tag',tag_valapp_scr);
        pop_det_scr     = findobj(pop_handles,'Tag',tag_valdet_scr);
        pop_lev_dec     = findobj(pop_handles,'Tag',tag_declev);
        txt_app_scr     = findobj(txt_handles,'Tag',tag_txtapp_scr);
        txt_det_scr     = findobj(txt_handles,'Tag',tag_txtdet_scr);
        txt_lev_dec     = findobj(txt_handles,'Tag',tag_txtdeclev);
end

%***************************%
%** OPTION = 'set_par' -  **%
%***************************%
if strcmp(option,'set_par')
        % in3 calling option
        %-------------------
        pop_wav_fams    = findobj(pop_handles,'Tag',tag_wav_fams);
        pop_wav_nums    = findobj(pop_handles,'Tag',tag_wav_nums);
        pop_lev_data    = findobj(pop_handles,'Tag',tag_lev_data);

        % Reading Analysis Parameters.
        %----------------------------
        Wave_Name = wavattrb('wname',pop_wav_fams,pop_wav_nums,'name');
        Wave_Len  = wavattrb('length',Wave_Name);

        if strcmp(in3,'synt')
                lev_str = get(pop_lev_data,'String');
                num     = get(pop_lev_data,'Value');
                Level_Anal = str2num(lev_str(num,:));
        else
                Level_Anal = get(pop_lev_data,'Value');
        end

        % Setting Analysis parameters
        %-----------------------------
        wmemtool('wmb',win_dw1dtool,n_param_anal,               ...
                                ind_wav_name,Wave_Name,         ...
                                ind_wav_len,Wave_Len,           ...
                                ind_lev_anal,Level_Anal         ...
                        );

%*************************%
%** OPTION = 'clean' -  **%
%*************************%
elseif strcmp(option,'clean')

        % Type of loading.
        %-----------------
        if      strcmp(in3,'load_sig') , str_input_txt  = 'Signal';
        elseif  strcmp(in3,'load_dec') , str_input_txt  = 'Decompos.';
        elseif  strcmp(in3,'load_cfs') , str_input_txt  = 'Coefficients';
        elseif  strcmp(in3,'demo')     , str_input_txt  = 'Test-signal';
        end
        if nargin<4 , in4 = ''; end

        if      strcmp(in3,'load_cfs') | strcmp(in3,'synt')
                str_btn = 'Synthesize';
                cba_btn = ['dw1dmngr(''synt'',' int2str(win_dw1dtool) ');'];
        else
                str_btn = 'Analyze';
                cba_btn = ['dw1dmngr(''anal'',' int2str(win_dw1dtool) ');'];
        end
        set(pus_anal,'String',str_btn,'Callback',cba_btn);

        % Writing Synthesized Signal Type.
        %----------------------------------
        wmemtool('wmb',win_dw1dtool,n_param_anal,ind_ssig_type,'ss');

        % Cleaning files.
        %----------------
        dw1dfile('del',win_dw1dtool);

        % Testing first use.
        %-------------------
        active_option = wmemtool('rmb',win_dw1dtool,n_param_anal, ...
                                                        ind_act_option);
        if isempty(active_option) , first = 1; else, first = 0; end

        % End of Cleaning when first is true.
        %------------------------------------
        if first , set(txt_input_txt,'String',str_input_txt); return; end

        cba_disp = ['dw1ddisp(''create'',' int2str(win_dw1dtool) ');'];
        set(pus_dispopt,...
                        'Style','pushbutton',                   ...
                        'String','More Display Options',        ...
                        'Callback',cba_disp);

        % Setting enable property of objects.
        %------------------------------------
        set([   m_savesyn,      m_savecfs,      m_savedec],'Enable','Off');
        set([   pop_wav_fams,   pop_wav_nums,   pop_lev_data,   ...
                pus_anal,       pus_deno,                       ...
                pus_comp,       pus_hist,       pus_stat,       ...
                pop_viewm,      pus_dispopt,                    ...
                pop_lev_dec,    pop_app_scr,    pop_det_scr     ...
                        ],...
                'Enable','off'...
                );

        % Cleaning DynVTool.
        %-------------------
        dynvtool('stop',win_dw1dtool);

        % Cleaning GUI.
        %--------------
        dw1dvmod('ch_vm',win_dw1dtool,1);
        if strcmp(in4,'new_anal') | strcmp(in4,'new_synt')
                default = 0;
        else
                default = 1;
        end
        set(txt_input_txt,'String',str_input_txt);
        if default
                str_input_data  = '';
                str_lev_data    = [int2str(1)];
                for k=2:max_lev_anal
                    str_lev_data = str2mat(str_lev_data,int2str(k));
                end;
                [str_wav_fams,str_wav_nums] = wavattrb('ini','dwt');
                set(txt_input_data,'String',str_input_data);
                set(pop_wav_fams,'String',str_wav_fams,'Value',1);
                set(pop_wav_nums,'String',str_wav_nums,'Value',1,'Visible','off');
                set(pop_lev_data,'String',str_lev_data,'Value',1);
                set(pop_lev_dec,'String',str_lev_data,'Value',1);
                set(pop_app_scr,'String',str_lev_data,'Value',1);
                set(pop_det_scr,'String',str_lev_data,'Value',1);
        else
                set(pop_lev_dec,'Value',1);
                set(pop_app_scr,'Value',1);
                set(pop_det_scr,'Value',1);
        end

%**********************************************%
%** OPTION = 'set_gui' -  Setting GUI values.**%
%**********************************************%
elseif strcmp(option,'set_gui')
        % in3 = calling option.
        % in4  : optional (new_anal or new_synt).
        %-----------------------------------------
        if nargin<4 , in4 = ''; end
        if      strcmp(in3,'load_sig')
                [Signal_Name,Signal_Size] = ...
                        wmemtool('rmb',win_dw1dtool,n_param_anal,...
                                        ind_sig_name,ind_sig_size);
                Signal_Size     = max(Signal_Size);
                levm            = wmaxlev(Signal_Size,'haar');
                levmax          = min(levm,max_lev_anal);
                str_lev_data    = get(pop_lev_data,'String');
                str_lev_data    = str_lev_data(1:levmax,:);
                if isempty(in4)
                        set(pop_lev_data,'String',str_lev_data,...
                                        'Value',min(levmax,5));
                else
                        set(pop_lev_data,'String',str_lev_data);
                end
                set(txt_input_data,'String',Signal_Name);
                set(pop_lev_dec,'String',str_lev_data);
                set(pop_app_scr,'String',str_lev_data);
                set(pop_det_scr,'String',str_lev_data);

        elseif  strcmp(in3,'demo') | strcmp(in3,'load_dec')
                [Signal_Name,Signal_Size,Wave_Name,Level_Anal] =        ...
                        wmemtool('rmb',win_dw1dtool,n_param_anal,       ...
                                        ind_sig_name,ind_sig_size,      ...
                                        ind_wav_name,ind_lev_anal);
                Signal_Size     = max(Signal_Size);
                levm            = wmaxlev(Signal_Size,'haar');
                if levm<Level_Anal , levm  = Level_Anal; end

                levmax          = min(levm,max_lev_anal);
                levs            = get(pop_lev_data,'String');
                set(pop_lev_data,'String',levs(1:levmax,:));

                levels  = levs(1:Level_Anal,:);
                set(txt_input_data,'String',Signal_Name);
                wavattrb('set_wname',Wave_Name,pop_wav_fams,pop_wav_nums);
                set(pop_lev_data,'Value',Level_Anal);
                set(pop_lev_dec,'String',levels,'Value',Level_Anal);
                set(pop_app_scr,'String',levels,'Value',1);
                set(pop_det_scr,'String',levels,'Value',1);
                dw1dvmod('ini_vm',win_dw1dtool);

        elseif  strcmp(in3,'load_cfs')
                [Signal_Name,Signal_Size,Wave_Name,Level_Anal] =        ...
                        wmemtool('rmb',win_dw1dtool,n_param_anal,       ...
                                        ind_sig_name,ind_sig_size,      ...
                                        ind_wav_name,ind_lev_anal);
                levels  = [int2str(1)];
                for k=2:Level_Anal , levels = str2mat(levels,int2str(k)); end
                set(txt_input_data,'String',Signal_Name);
                set(pop_lev_data,'String',int2str(Level_Anal));
                set(pop_lev_dec,'String',levels,'Value',Level_Anal);
                set(pop_app_scr,'String',levels,'Value',1);
                set(pop_det_scr,'String',levels,'Value',1);
                dw1dvmod('ini_vm',win_dw1dtool);

        elseif  strcmp(in3,'synt')
                Level_Anal = wmemtool('rmb',win_dw1dtool,n_param_anal,...
                                                        ind_lev_anal);
                set(pop_lev_dec,'Value',Level_Anal);
                set(pop_app_scr,'Value',1);
                set(pop_det_scr,'Value',1);
                dw1dvmod('ini_vm',win_dw1dtool);

        elseif  strcmp(in3,'anal')
                Level_Anal = wmemtool('rmb',win_dw1dtool,n_param_anal,...
                                                        ind_lev_anal);
                levels  = [int2str(1)];
                for k=2:Level_Anal , levels = str2mat(levels,int2str(k)); end
                set(pop_lev_dec,'String',levels,'Value',Level_Anal);
                set(pop_app_scr,'String',levels,'Value',1);
                set(pop_det_scr,'String',levels,'Value',1);
                dw1dvmod('ini_vm',win_dw1dtool);
        end

%*************************************************%
%** OPTION = 'enable' -  Setting enabled values.**%
%*************************************************%
elseif strcmp(option,'enable')
        % in3 = calling option.
        %--------------------------
        if      strcmp(in3,'load_sig')
                set([   pop_wav_fams,   pop_wav_nums,   pop_lev_data,   ...
                        pus_anal                                        ...
                        ],      ...
                        'Enable','On'   ...
                        );

        elseif  strcmp(in3,'load_cfs')
                set([   pop_wav_fams,   pop_wav_nums,   pop_lev_data,   ...
                        pus_anal                                        ...
                        ],      ...
                        'Enable','On'   ...
                        );

        elseif  strcmp(in3,'demo') | strcmp(in3,'load_dec')
                set([   pop_wav_fams,   pop_wav_nums,   pop_lev_data,   ...
                        pus_anal,                                       ...
                        pus_deno,       pus_comp,       pus_hist,       ...
                        pus_stat,       pop_viewm,      pus_dispopt,    ...
                        pop_app_scr, pop_det_scr,       pop_lev_dec     ...
                                ],      ...
                        'Enable','On'   ...
                        );
                set([m_savesyn, m_savecfs, m_savedec],'Enable','on');

        elseif  strcmp(in3,'anal') |strcmp(in3,'synt')
                set([   pus_deno,       pus_comp,       pus_hist,       ...
                        pus_stat,       pop_viewm,      pus_dispopt,    ...
                        pop_app_scr,    pop_det_scr,    pop_lev_dec     ...
                        ],...
                        'Enable','on'...
                        );
                set([m_savesyn, m_savecfs, m_savedec],'Enable','on');

        elseif  strcmp(in3,'comp') |strcmp(in3,'deno')
                set([m_files , pus_anal , pus_deno , pus_comp],'Enable','off');

        elseif  strcmp(in3,'return_comp') |strcmp(in3,'return_deno')
                set([m_files , pus_anal , pus_deno , pus_comp],'Enable','on');

        elseif  strcmp(in3,'more_disp')
                set([   pus_anal,       pus_deno,       pus_comp,       ...
                        pop_viewm,      pus_dispopt                     ...
                        ],...
                        'Enable','off'...
                        );
                set(m_files,'Enable','off');

        elseif  strcmp(in3,'end_more_disp')
                set([   pus_anal,       pus_deno,       pus_comp,       ...
                        pop_viewm,      pus_dispopt                     ...
                        ],...
                        'Enable','on'...
                        );
                set(m_files,'Enable','on');
        end

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('dw1dutil','Unknown Option','msg');
        error('*');
end
