function dw1dvdrv(option,win_dw1dtool,in3,in4)
%DW1DVDRV Discret wavelet 1D view mode driver.

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:08:59 $

%       Uses DW1DSCRM, DW1DVMOD.

%--------------------
% option :
%  'default'
%  'plot_sig'
%  'plot_cfs'
%  'plot_anal'
%  'plot_synt'
%--------------------

%--------------------------------------
% mode 1 : scroll mode          = 'scr'
% mode 2 : decomposition mode   = 'dec'
% mode 3 : separate mode        = 'sep'
% mode 4 : superimposed mode    = 'sup'
% mode 5 : tree mode            = 'tre'
%--------------------------------------

% Tag property of objects.
%-------------------------
tag_pop_viewm   = 'View_Mode';
tag_Def_DispM   = 'Default_DispM';

if      strcmp(option,'default')
        % in3 = tab menu
        % in4 = num menu
        %----------------
        set(in3,'Checked','Off','Tag','');
        set(in3(in4),'Checked','On','Tag',tag_Def_DispM);
        return;
else
        men = findobj(win_dw1dtool,'type','uimenu','tag',tag_Def_DispM);
        DW1D_Display_Mode = get(men,'Userdata');
end

if      strcmp(option,'plot_sig')
        % in3 = Signal Anal
        % in4 = view_sig (optional)
        %--------------------------
        if      nargin==3
                vsig = 1;
        else
                if DW1D_Display_Mode==1
                        vsig = 1;
                else
                        vsig = 0;
                end
        end
        dw1dscrm('plot_sig',win_dw1dtool,in3,DW1D_Display_Mode,vsig);

elseif  strcmp(option,'plot_cfs')
        dw1dscrm('plot_cfs',win_dw1dtool,DW1D_Display_Mode);

elseif  strcmp(option,'plot_anal')
        if      DW1D_Display_Mode==1
                dw1dscrm('plot_anal',win_dw1dtool);
        else
                pop_viewm = findobj(win_dw1dtool,'tag',tag_pop_viewm);
                set(pop_viewm,'Value',DW1D_Display_Mode);
                dw1dvmod('ch_vm',win_dw1dtool,1);
        end

elseif  strcmp(option,'plot_synt')
        if      DW1D_Display_Mode==1
                dw1dscrm('plot_synt',win_dw1dtool);
        else
                pop_viewm = findobj(win_dw1dtool,'tag',tag_pop_viewm);
                set(pop_viewm,'Value',DW1D_Display_Mode);
                dw1dvmod('ch_vm',win_dw1dtool,1);
        end
end
