function dw2darro(option,win_dw2dtool,in3,in4)
%DW2DARRO Discret wavelet 2D arrows drawing.
%       dw2darro(option,win_dw2dtool,in3,in4)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:09:09 $

% Tag property of objects.
%-------------------------
tag_axearrow    = 'Axe_Arrow';
tag_axeimgbig   = 'Axe_ImgBig';
tag_axeimgini   = 'Axe_ImgIni';
tag_axeimgvis   = 'Axe_ImgVis';
tag_axeimgsel   = 'Axe_ImgSel';
tag_axeimgdec   = 'Axe_ImgDec';
tag_axeimgsyn   = 'Axe_ImgSyn';
tag_arrow       = 'Wave_Arrow';

% Miscellaneous values.
%----------------------
BoxTitleSel_Col = 'g';

axe_handles     = findobj(win_dw2dtool,'Type','axes');
arrow_hdls      = findobj(axe_handles,'tag',tag_arrow);

%*****************************%
%** OPTION = 'ini_arrow' -  **%
%*****************************%
if strcmp(option,'ini_arrow')
        Screen_Size = get(0,'Screensize');
        if      Screen_Size(4)<600
                fontsize = 12;
        else
                fontsize = 16;
        end
        axe_arrow = axes(...
                                'Position',[0 0 1 1],           ...
                                'Xlim',[0 1],'Ylim',[0 1],      ...
                                'NextPlot','Add',               ...
                                'DrawMode','Normal',            ...
                                'Visible','off',                ...
                                'Tag',tag_axearrow              ...
                                );
        axes(axe_arrow);
        ar0     = wavarrow('ini',axe_arrow,2,'w');
        set(ar0,'Userdata','a0');
        ar1     = wavarrow('ini',axe_arrow,2,'w');
        set(ar1,'Userdata','a1');
        t0      = text(...
                        'Units','normalized',           ...
                        'Visible','off',                ...
                        'HorizontalAlignment','center', ...
                        'string','dwt','FontSize',fontsize,     ...
                        'FontWeight','bold','Color','y',...
                        'Userdata','t0',                ...
                        'tag',tag_arrow);
        ar2     = wavarrow('ini',axe_arrow,2,BoxTitleSel_Col);
        set(ar2,'Userdata','a2');
        ar3     = wavarrow('ini',axe_arrow,2,'w');
        set(ar3,'Userdata','a3');
        t31     = text(...
                        'Units','normalized',           ...
                        'Visible','off',                ...
                        'HorizontalAlignment','center', ...
                        'string','idwt','FontSize',fontsize,    ...
                        'FontWeight','bold','Color','y',...
                        'Userdata','t31',               ...
                        'tag',tag_arrow);
        t32     = text(...
                        'Units','normalized',           ...
                        'Visible','off',                ...
                        'HorizontalAlignment','center', ...
                        'string','','FontSize',fontsize,        ...
                        'FontWeight','bold','Color','y',...
                        'Userdata','t32',               ...
                        'tag',tag_arrow);

%*****************************%
%** OPTION = 'vis_arrow' -  **%
%*****************************%
elseif strcmp(option,'vis_arrow')
        % in3 = 'on' or 'off'
        % in4 optional (return_deno or return_comp)
        %------------------------------------------             
        txt = get(findobj(arrow_hdls,'Userdata','t0'),'String');
        if strcmp(txt,'dwt')
                ar = findobj(arrow_hdls,'Userdata','a1');
        else
                ar = findobj(arrow_hdls,'Userdata','a0');
        end
        arrow_hdls = arrow_hdls(find(arrow_hdls~=ar));
        if nargin==4
                txt = findobj(arrow_hdls,'Userdata','t32');
                set(txt,'String',in4);
        end             
        set(arrow_hdls,'Visible',in3);

%*************************%
%** OPTION = 'clean' -  **%
%*************************%
elseif strcmp(option,'clean')
        % in3 = 'on' or 'off'
        %------------------------------------------             
        txt = get(findobj(arrow_hdls,'Userdata','t0'),'String');
        if strcmp(txt,'dwt')
                ar = findobj(arrow_hdls,'Userdata','a1');
        else
                ar = findobj(arrow_hdls,'Userdata','a0');
        end
        arrow_hdls = arrow_hdls(find(arrow_hdls~=ar));
        txt = findobj(arrow_hdls,'Userdata','t32');
        set(txt,'String','');
        set(arrow_hdls,'Visible',in3);


%*****************************%
%** OPTION = 'set_arrow' -  **%
%*****************************%
elseif strcmp(option,'set_arrow')
        % in3 calling option
        %-------------------
        Axe_ImgIni      = findobj(axe_handles,'flat','Tag',tag_axeimgini);
        Axe_ImgSel      = findobj(axe_handles,'flat','Tag',tag_axeimgsel);
        Axe_ImgVis      = findobj(axe_handles,'flat','Tag',tag_axeimgvis);
        Axe_ImgSyn      = findobj(axe_handles,'flat','Tag',tag_axeimgsyn);
        ar0 = findobj(arrow_hdls,'Userdata','a0');
        ar1 = findobj(arrow_hdls,'Userdata','a1');
        ar2 = findobj(arrow_hdls,'Userdata','a2');
        ar3 = findobj(arrow_hdls,'Userdata','a3');
        t0  = findobj(arrow_hdls,'Userdata','t0');
        t31 = findobj(arrow_hdls,'Userdata','t31');
        t32 = findobj(arrow_hdls,'Userdata','t32');

        pini = get(Axe_ImgIni,'Position');
        psel = get(Axe_ImgSel,'Position');
        pvis = get(Axe_ImgVis,'Position');
        psyn = get(Axe_ImgSyn,'Position');
        [bdx,bdy] = wfigutil('prop_size',win_dw2dtool,15,15);
        mul = 1/6;
        xini = pini(1)+pini(3);
        yini = pini(2);
        xsel = psel(1)-bdx;
        ysel = psel(2)+psel(4)+bdy;
        dx = xsel-xini;
        dy = yini-ysel;
        pt1 = [xini+mul*dx yini-mul*dy];
        pt2 = [xsel-mul*dx ysel+mul*dy];
        wavarrow('set',ar0,pt1,pt2,0.6,2,'w','off');
        wavarrow('set',ar1,pt2,pt1,0.6,2,'w','off');
        if strcmp(in3,'load_cfs')
                ar00 = ar1;
                txt = 'idwt';
        else
                ar00 = ar0;
                txt = 'dwt';
        end 
        set(t0,'Position',[xini+dx/2 yini-dy/2],'String',txt);

        xvis = pvis(1)+pvis(3)/2;
        yvis = pvis(2);
        ysel = psel(2)+psel(4)+bdy+bdy/2;
        dy   = yvis-ysel;
        wavarrow('set',ar2,[xvis ysel+mul*dy],[xvis yvis-mul*dy],0.6,2,BoxTitleSel_Col,'off');

        xsyn = psyn(1)+psyn(3);
        ysyn = psyn(2)+psyn(4)/2;
        dx   = xsel-xsyn;
        wavarrow('set',ar3,[xsel-mul*dx ysyn],[xsyn+mul*dx ysyn],0.6,2,'w','off');
        set(t31,'Position',[xsel-dx/2 ysyn+0.02],'String','idwt');
        set(t32,'Position',[xsel-dx/2 ysyn-0.02],'String','');
        set([ar00 ar2 ar3 t0 t31],'Visible','on');

%*****************************%
%** OPTION = 'del_arrow' -  **%
%*****************************%
elseif strcmp(option,'del_arrow')
        delete(arrow_hdls)

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('dw2darro','Unknown Option','msg');
        error('*');
end
