function out1 = dw2ddeno(option,in2,in3,in4,in5,in6)
%DW2DDENO Discret wavelet 2D de-noising.
%       out1 = dw2ddeno(option,in2,in3,in4,in5,in6)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:09:20 $

%       Uses WMEMTOOL.

global  Machine                         ...
        Def_Btn_Height  Def_Btn_Width   ...
        Pop_Min_Width   X_Graph_Ratio   ...
        X_Spacing       Y_Spacing       ...
        Def_TxtBkColor  Def_EdiBkColor  ...
        Def_FraBkColor  Def_FraFgColor  ...
        Def_AxeXColor

if nargin==0, option = 'create'; end

% MemBloc1 of stored values.
%---------------------------
n_param_anal    = 'DWAn2d_Par_Anal';
ind_img_name    =  1;
ind_wav_name    =  2;
ind_lev_anal    =  3;
ind_img_t_name  =  4;
ind_img_size    =  5;
ind_nbcolors    =  6;
ind_act_option  =  7;
ind_simg_type   =  8;
nb1_stored      =  8;

% MemBloc2.1 and 2.2 of stored values.
%------------------------------------
n_coefs         = 'MemCoefs';
n_sizes         = 'MemSizes';

% MemBloc3 of stored values. (Local Bloc)
%----------------------------------------
n_miscella_loc  = 'DWDeno2D_Misc';
ind_hdls_lev    = 1;
ind_status      = 2;
ind_hdl_winorig = 3;
ind_max_lev     = 4;
ind_val_lev     = 5;
ind_hdl_thr_min = 6;
ind_hdl_thr_max = 7;
nb3_stored      = 7;

% Tag property of objects.
%-------------------------
tag_cmd_frame   = 'Cmd_Frame';
tag_dirdet_val  = 'Dirdet_Val';
tag_axe_deno    = 'Axe_Deno';
tag_img_deno    = 'Img_Deno';
tag_axe_orig    = 'Axe_Orig';
tag_img_orig    = 'Img_Orig';
tag_txt_orig    = 'Txt_Orig';
tag_pop_mv      = 'Pop_ModeVal';
                
%*****************************************************************%
%** OPTION = 'create' - constructs the initial dw2ddeno window  **%
%*****************************************************************%
if strcmp(option,'create')

        % Calling figure.
        %----------------
        win_dw2dtool     = in2;
        str_win_dw2dtool = int2str(win_dw2dtool);

        % Window initialization.
        %----------------------
        win_name = 'Wavelet 2-D  --  De-noising';
        [win_dw2ddeno,pos_win,cba_close_menu] = ...
                wfigcrea('create',NaN,win_name,'',win_dw2dtool,3,...
                                str2mat('dw2ddeno','cond'));
        str_win_dw2ddeno = int2str(win_dw2ddeno);
        win_units = 'pixels';
        out1      = win_dw2ddeno;

        % Command frame and Dynamical visualization tool construction.
        %-------------------------------------------------------------
        [frame0,pos_frame0,Pos_Graphic_Area] = ...
                        wfigcrea('frame',win_dw2ddeno,'dynv','title');

        % Waiting Frame construction & begin waiting.
        %--------------------------------------------
        wwaiting('create',win_dw2ddeno,X_Graph_Ratio,...
                        'Wait ... computing');

        % Getting  Analysis parameters.
        %------------------------------
        [Img_Name,Img_Size,NB_ColorsInPal,Wav_Name,Lev_Anal] = ...
        wmemtool('rmb',win_dw2dtool,n_param_anal,       ...
                                ind_img_name,           ...
                                ind_img_size,           ...
                                ind_nbcolors,           ...
                                ind_wav_name,           ...
                                ind_lev_anal            ...
                                );
        [Wav_Fam,Wav_Num] = wavattrb('fam_num',Wav_Name);

        % Getting Analysis values.
        %-------------------------
        coefs = wmemtool('get',win_dw2dtool,n_coefs);
        sizes = wmemtool('get',win_dw2dtool,n_sizes);

        % Original image.
        %----------------
        Img_Anal        = get(dw2drwcd('r_orig',win_dw2dtool),'Cdata');

        % General graphical parameters initialization.
        %--------------------------------------------

        % Borders and double borders.
        dx  = X_Spacing;  dx2 = 2*dx;
        dy  = Y_Spacing;  dy2 = 2*dy;

        % X init position and width of frames.
        x_frame0        = pos_frame0(1);
        cmd_width       = pos_frame0(3);
        h_frame0        = pos_frame0(4);

        % Buttons width
        push_width      = (cmd_width-4*dx)/2;
        txt_width       = Def_Btn_Width;
        pop_width       = Pop_Min_Width;

        % Position property of objects.
        %------------------------------
        pos_input_txt   = [     x_frame0+dx2                            ,...
                                h_frame0-3*dy-Def_Btn_Height            ,...
                                txt_width                               ,...
                                Def_Btn_Height                          ];
        pos_input_data  = [     pos_input_txt(1)+pos_input_txt(3)+dx    ,...
                                pos_input_txt(2)                        ,...
                                2*pop_width                             ,...
                                Def_Btn_Height                          ];
        pos_wav_txt     = pos_input_txt;
        pos_wav_txt(2)  = pos_input_txt(2)-Def_Btn_Height-dy2;
        pos_wav_fams    = [     pos_wav_txt(1)+pos_wav_txt(3)+dx        ,...
                                pos_wav_txt(2)                          ,...
                                pop_width                               ,...
                                Def_Btn_Height                          ];
        pos_wav_nums    = [     pos_wav_fams(1)+pos_wav_fams(3)+dx/2    ,...
                                pos_wav_fams(2)                         ,...
                                pop_width-dx/2                          ,...
                                Def_Btn_Height                          ];
        pos_lev_txt     = pos_wav_txt;
        pos_lev_txt(2)  = pos_wav_txt(2)-Def_Btn_Height-dy2;
        pos_lev_data    = [     pos_lev_txt(1)+pos_lev_txt(3)+dx        ,...
                                pos_lev_txt(2)                          ,...
                                pop_width                               ,...
                                Def_Btn_Height                          ];
        px              = x_frame0+(cmd_width-13*txt_width/5)/2;
        pos_mode_val    = [     px                                      ,...
                                pos_lev_txt(2)-3*Def_Btn_Height         ,...
                                13*txt_width/5                          ,...
                                3*Def_Btn_Height/2                      ];
        pos_dirdet_val  = [     px                                      ,...
                                pos_mode_val(2)-2*Def_Btn_Height        ,...
                                13*txt_width/5                          ,...
                                3*Def_Btn_Height/2                      ];
        pos_lev_title   = [     x_frame0+dx                             ,...
                                pos_dirdet_val(2)-3*Def_Btn_Height/2    ,...
                                cmd_width-4*dx                           ,...
                                Def_Btn_Height                          ];
        py              = pos_lev_title(2)-Lev_Anal*(Def_Btn_Height+dy2);
        pos_visu_deno   = [     x_frame0+(cmd_width-3*push_width/2)/2    ,...
                                py-3*Def_Btn_Height                     ,...
                                3*push_width/2                          ,...
                                2*Def_Btn_Height                        ];
        px              = x_frame0+(cmd_width-7*push_width/4)/2;
        pos_close       = [     px                                      ,...
                                pos_frame0(2)+Def_Btn_Height            ,...
                                7*push_width/4                          ,...
                                3*Def_Btn_Height/2                      ];

        % String property of objects.
        %----------------------------
        str_input_txt   = 'Image';
        str_input_data  = Img_Name;
        str_wav_txt     = 'Wavelet';
        str_wav_fams    = Wav_Fam;
        str_wav_nums    = Wav_Num;
        str_lev_txt     = 'Level';
        str_lev_data    = int2str(Lev_Anal);
        str_mode_val    = str2mat(      'Manual soft thresholding',...
                                        'Manual hard thresholding');
        str_dirdet_val  = str2mat(      'Horizontal details coefs',...
                                        'Diagonal details coefs',...
                                        'Vertical details coefs');
        str_lev_title   = 'Level       Select           Threshold';
        str_denoise     = 'De-noise';
        str_close       = 'Close';

        % Command part construction of the window.
        %-----------------------------------------
        figure(win_dw2ddeno)
        txt_input_txt   = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_input_txt,...
                                        'String',str_input_txt,...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
        txt_input_data  = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_input_data,...
                                        'String',str_input_data,...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        txt_wav_txt     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_wav_txt,...
                                        'String',str_wav_txt,...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
        txt_wav_fams    = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_wav_fams,...
                                        'String',str_wav_fams,...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        if ~isempty(str_wav_nums)
        txt_wav_nums    = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_wav_nums,...
                                        'String',str_wav_nums,...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        end
        txt_lev_txt     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_lev_txt,...
                                        'String',str_lev_txt,...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
        txt_lev_data    = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_lev_data,...
                                        'String',str_lev_data,...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        drawnow

        pop_mode_val    = uicontrol(...
                                        'Style','Popup',...
                                        'Unit',win_units,...
                                        'Position',pos_mode_val,...
                                        'Userdata',1,...
                                        'String',str_mode_val,...
                                        'tag',tag_pop_mv ...
                                        );
        pop_dirdet_val  = uicontrol(...
                                        'Style','Popup',...
                                        'Unit',win_units,...
                                        'Position',pos_dirdet_val,...
                                        'String',str_dirdet_val,...
                                        'Tag',tag_dirdet_val...
                                        );
        txt_lev_title   = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'Position',pos_lev_title,...
                                        'String',str_lev_title,...
                                        'HorizontalAlignment','left',...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
        wx              = (cmd_width-5*txt_width/2)/4;
        xbtn0           = x_frame0+wx;
        ybtn0           = pos_lev_title(2)-Def_Btn_Height-dy2;
        xbtn            = xbtn0;
        ybtn            = ybtn0;
        [thr,sorh,keepapp]      = ddencmp('den','wv',Img_Anal);
        str_lev_anal    = num2mstr(Lev_Anal);
        hdls_lev        = zeros(3,Lev_Anal);
        max_lev         = zeros(3,Lev_Anal);
        val_lev         = zeros(3,Lev_Anal);

        for d=1:3
                for i=Lev_Anal:-1:1
                        dir             = lower(str_dirdet_val(d,1));
                        c               = detcoef2(dir,coefs,sizes,i);
                        max_lev(d,i)    = max(abs(c(:)));
                        val_lev(d,i)    = min(max_lev(d,i),thr);

                    if d==1

                        pos_lev = [xbtn ybtn 2*txt_width/6 Def_Btn_Height];
                        str_lev = int2str(i);
                        txt_lev = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'Position',pos_lev,...
                                        'String',str_lev,...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
                        xbtn    = xbtn+2*txt_width/6+wx;
                        pos_lev = [     xbtn                    ,...
                                        ybtn+Def_Btn_Height/4   ,...
                                        7*txt_width/6           ,...
                                        Def_Btn_Height/2        ];
                        sli_lev = uicontrol(...
                                        'Style','Slider',...
                                        'Unit',win_units,...
                                        'Position',pos_lev,...
                                        'Min',0,...
                                        'Max',max_lev(d,i),...
                                        'Value',val_lev(d,i)...
                                        );
                        xbtn            = xbtn+7*txt_width/6+wx;
                        pos_lev         = [xbtn ybtn txt_width Def_Btn_Height];
                        str_def_lev     = sprintf('%1.4g',val_lev(d,i));
                        txt_val = uicontrol(...
                                        'Style','Edit',...
                                        'Unit',win_units,...
                                        'Position',pos_lev,...
                                        'String',str_def_lev,...
                                        'HorizontalAlignment','center',...
                                        'Backgroundcolor',Def_EdiBkColor...
                                        );

                        cba_sli = ['dw2ddeno(''update_sellev'',' ...
                                        str_win_dw2ddeno ',' ...
                                        str_win_dw2dtool ',' ...
                                        str_lev_anal ',' ...
                                        str_lev ',''sli'');'];
                        cba_edi = ['dw2ddeno(''update_sellev'',' ...
                                        str_win_dw2ddeno ',' ...
                                        str_win_dw2dtool ',' ...
                                        str_lev_anal ',' ...
                                        str_lev ',''edi'');'];

                        set(sli_lev,'Callback',cba_sli);
                        set(txt_val,'Callback',cba_edi);


                        hdls_lev(1,i) = txt_lev;
                        hdls_lev(2,i) = sli_lev;
                        hdls_lev(3,i) = txt_val;
                        xbtn = xbtn0;
                        ybtn = ybtn-Def_Btn_Height-dy2;
                   end
                end
        end
        drawnow('discard')

        pus_visu_deno   = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_visu_deno,...
                                        'String',str_denoise...
                                        );
        pus_close       = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_close,...
                                        'String',str_close,...
                                        'Interruptible','yes'...
                                        );
        drawnow

        % Displaying the window title.
        %-----------------------------
        str_nb_val      = [' (' int2str(Img_Size(2)) ' x ' int2str(Img_Size(1)) ')'];
        str_wintitle    = [Img_Name,str_nb_val,' analyzed at level ',...
                           int2str(Lev_Anal),' with ',Wav_Name];
        wfigtitl('string',win_dw2ddeno,str_wintitle,'on');
        drawnow

        % Callbacks update.
        %------------------
        str_pop_mode_val        = num2mstr(pop_mode_val);
        str_pop_dirdet_val      = num2mstr(pop_dirdet_val);
        cba_mode_val    = ['dw2ddeno(''mode'',' ...
                                str_win_dw2ddeno ',' ...
                                str_pop_mode_val ');'];
        cba_dirdet_val  = ['dw2ddeno(''dirdet'',' ...
                                str_win_dw2ddeno ',' ...
                                str_lev_anal ',' ...
                                str_pop_dirdet_val ');'];
        cba_denoise     = ['dw2ddeno(''denoise'',' ...
                                str_win_dw2ddeno ',' ...
                                str_win_dw2dtool ',' ...
                                str_pop_mode_val ');'];
        set(pop_mode_val,'Callback',cba_mode_val);
        set(pop_dirdet_val,'Callback',cba_dirdet_val);
        set(pus_visu_deno,'Callback',cba_denoise);
        set(pus_close,'Callback',cba_close_menu);

        % General graphical parameters initialization.
        %--------------------------------------------
        bdx_l           = 0.10*pos_win(3);
        bdx_r           = 0.06*pos_win(3);
        bdx             = 0.08*pos_win(3);
        ecx             = 0.04*pos_win(3);
        bdy             = 0.07*pos_win(4);
        ecy             = 0.03*pos_win(4);
        y_graph         = 2*Def_Btn_Height+dy;
        h_graph         = pos_frame0(4)-y_graph-Def_Btn_Height;
        w_graph         = pos_frame0(1);

        % Building axes for original image.
        %----------------------------------
        x_axe           = bdx;
        w_axe           = (w_graph-ecx-3*bdx/2)/2;
        y_axe           = y_graph+h_graph-w_axe-bdy;
        h_axe           = w_axe;
        cx_ori          = x_axe+w_axe/2;
        cy_ori          = y_axe+h_axe/2;
        cx_den          = cx_ori+w_axe+ecx;
        cy_den          = cy_ori;
        [w_used,h_used] = wpropimg(Img_Size,w_axe,h_axe,'pixels');
        pos_axe         = [cx_ori-w_used/2 cy_ori-h_used/2 w_used h_used];
        axe_orig        = axes(...
                                'Units',win_units,...
                                'Position',pos_axe,...
                                'Drawmode','fast',...
                                'Box','On',...
                                'Tag',tag_axe_orig);

        % Displaying original image.
        %---------------------------
        set(win_dw2ddeno,'Colormap',get(win_dw2dtool,'Colormap'));
        image([1 Img_Size(1)],[1,Img_Size(2)],...
                wimgcode('cod',0,Img_Anal,NB_ColorsInPal,0),...
                'tag',tag_img_orig);
        set(axe_orig,'Tag',tag_axe_orig);

        % Set a text as a super title.
        %-----------------------------
        title('Original image')
        wtxttitl(axe_orig,'Manual soft thresholding',tag_txt_orig);

        % Building axes for denoised image.
        %----------------------------------
        pos_axe         = [cx_den-w_used/2 cy_den-h_used/2 w_used h_used];
        axe_deno        = axes(...
                                'Units',win_units,...
                                'Position',pos_axe,...
                                'Drawmode','fast',...
                                'Visible','off',...
                                'Box','On',...
                                'Xlim',get(axe_orig,'Xlim'),...
                                'Ylim',get(axe_orig,'Ylim'),...
                                'Tag',tag_axe_deno);

        % Building axes for histograms.
        %------------------------------
        direct          = str2mat('Horizontal','Diagonal','Vertical');
        x_axe           = bdx;
        y_axe           = y_graph+bdy;
        h_axe           = (h_graph-w_axe-3*bdy-(Lev_Anal-1)*ecy)/Lev_Anal;
        w_axe           = (w_graph-2*ecx-3*bdx/2)/3;
        pos_axe         = [x_axe y_axe w_axe h_axe];
        axe_hist        = zeros(Lev_Anal,3);
        for k = 1:Lev_Anal
                pos_axe(1) = bdx_l;
                pos_axe(2) = y_graph+bdy+(k-1)*(h_axe+ecy);
                for kk=1:3
                        axe_hist(k,kk) = axes(...
                                        'Units',win_units,...
                                        'Position',pos_axe,...
                                        'Drawmode','fast',...
                                        'Visible','off',...
                                        'Box','On'...
                                        );
                        pos_axe(1) = pos_axe(1)+pos_axe(3)+ecx;
                end
        end

        % Displaying details coefficients histograms.
        %--------------------------------------------
        Screen_Size = get(0,'ScreenSize');
        if Screen_Size(4)<600
                fontsize = 12;
        else
                fontsize = 16;
        end
        col_det         = dw1dcolo('det',Lev_Anal);
        nb_bins         = min(NB_ColorsInPal,50);
        for level = 1:Lev_Anal
                for kk=1:3      
                        axes(axe_hist(level,kk));
                        dir             = lower(str_dirdet_val(kk,1));
                        curr_img        = detcoef2(dir,coefs,sizes,level);
                        curr_color      = col_det(level,:);
                        his             = wgethist(curr_img(:),nb_bins);
                        his(2,:)        = his(2,:)/length(curr_img(:));
                        wplothis(axe_hist(level,kk),his,curr_color);
                        if kk==1

                                txt_hist(kk) = ...
                                txtinaxe('create',['L' int2str(level)],...
                                        axe_hist(level,kk),'left','on',...
                                        'bold',fontsize);
                                set(txt_hist(kk),'color',Def_AxeXColor);
                        end
                        if level==1
                                xlabel([deblank(direct(kk,:)) ...
                                        ' Details'],'color',Def_AxeXColor);
                        end

                        xthr    = val_lev(kk,level);
                        hdl_thr_min(kk,level) = line('Linestyle','--',...
                                'Color','y',...
                                'EraseMode','xor',...
                                'Xdata',[xthr xthr],...
                                'Ydata',get(axe_hist(level,kk),'Ylim'));
                        hdl_thr_max(kk,level) = line('Linestyle','--',...
                                'Color','y',...
                                'EraseMode','xor',...
                                'Xdata',[-xthr -xthr],...
                                'Ydata',get(axe_hist(level,kk),'Ylim'));
                        xmax    = max_lev(kk,level)+10*(max_lev(kk,level))/100;
                        if xmax==0, xmax=0.1; end
                        xaxis   = [-xmax xmax];
                        set(axe_hist(level,kk),'Xlim',xaxis);
                end
        end
        drawnow

        % Memory blocks update.
        %----------------------
        wmemtool('ini',win_dw2ddeno,n_miscella_loc,nb3_stored);
        wmemtool('wmb',win_dw2ddeno,n_miscella_loc,                     ...
                                        ind_hdls_lev,hdls_lev,          ...
                                        ind_status,0,                   ...
                                        ind_hdl_winorig,win_dw2dtool,   ...
                                        ind_max_lev,max_lev,            ...
                                        ind_val_lev,val_lev,            ...
                                        ind_hdl_thr_min,hdl_thr_min,    ...
                                        ind_hdl_thr_max,hdl_thr_max     ...
                                        );

        % Axes attachment.
        %-----------------
        axe_cmd = [axe_orig axe_deno];
        axe_act = [];
        dynvtool('attach',win_dw2ddeno,[],axe_cmd,axe_act,[1 1],'','','');
        dynvtool('put',win_dw2ddeno);

        % Setting units to normalized.
        %-----------------------------
        set(findobj(win_dw2ddeno,'Units','pixels'),'Units','Normalized');

        % End waiting.
        %-------------
        wwaiting('off',win_dw2ddeno);

%*************************************%
%** OPTION = 'denoise' - DE-NOISING **%
%*************************************%
elseif strcmp(option,'denoise')
        win_dw2ddeno    = in2;
        win_dw2dtool    = in3;
        if nargin==4
                pop_mode_val = in4;
        else
                pop_mode_val = findobj(win_dw2ddeno,'tag',tag_pop_mv);
        end

        % Waiting message.
        %-----------------
        wwaiting('msg',win_dw2ddeno,'Wait ... computing');

        % Handles of tagged objects.
        %---------------------------
        axe_handles     = findobj(win_dw2ddeno,'Type','axes');
        axe_deno        = findobj(axe_handles,'flat','Tag',tag_axe_deno);
        axe_orig        = findobj(axe_handles,'flat','Tag',tag_axe_orig);

        % Setting de-noised axes invisible.
        %----------------------------------
        mngaxe('vis',axe_deno,'off');

        % Getting  Analysis parameters.
        %------------------------------
        [Img_Size,NB_ColorsInPal,Wav_Name,Lev_Anal] = ...
                wmemtool('rmb',win_dw2dtool,n_param_anal,       ...
                                ind_img_size,           ...
                                ind_nbcolors,           ...
                                ind_wav_name,           ...
                                ind_lev_anal            ...
                                );

        % Getting Analysis values.
        %-------------------------
        coefs = wmemtool('get',win_dw2dtool,n_coefs);
        sizes = wmemtool('get',win_dw2dtool,n_sizes);
        val_lev = wmemtool('rmb',win_dw2ddeno,n_miscella_loc,ind_val_lev);

        % De-noising.
        %------------
        mode_val        = get(pop_mode_val,'value');
        str_sorh        = ['s' 'h'];
        sorh            = str_sorh(mode_val);
        [xc,cxc,lxc,perf0]      = wdencmp('lvd',coefs,sizes,...
                                    Wav_Name,Lev_Anal,val_lev,sorh);

        % Displaying de-noised image.
        %----------------------------
        axes(axe_deno);
        image([1 Img_Size(1)],[1,Img_Size(2)],...
                wimgcode('cod',0,xc,NB_ColorsInPal,0),...
                'tag',tag_img_deno);
        set(axe_deno,   'Xlim',get(axe_orig,'Xlim'),...
                        'Ylim',get(axe_orig,'Ylim'),...
                        'Tag',tag_axe_deno);
        title('De-noised image');

        % Memory blocks update.
        %----------------------
        wmemtool('wmb',win_dw2ddeno,n_miscella_loc,ind_status,1);

        % End waiting.
        %-------------
        wwaiting('off',win_dw2ddeno);

%******************************************%
%** OPTION = 'dirdet' - DIRECTION CHOICE **%
%******************************************%
elseif strcmp(option,'dirdet')
        win_dw2ddeno    = in2;
        Lev_Anal        = in3;
        pop_dirdet_val  = in4;

        % Getting Analysis values.
        %-------------------------
        [hdls_lev,max_lev,val_lev] = wmemtool('rmb',win_dw2ddeno,n_miscella_loc,...
                                                        ind_hdls_lev,...
                                                        ind_max_lev,...
                                                        ind_val_lev);

        % Update the level threshold values.
        %-----------------------------------
        dir = get(pop_dirdet_val,'Value');
        for i=Lev_Anal:-1:1
                set(hdls_lev(2,i),'Max',max_lev(dir,i));
                set(hdls_lev(2,i),'Value',val_lev(dir,i));
                set(hdls_lev(3,i),'String',num2str(val_lev(dir,i)));
        end

%***********************************%
%** OPTION = 'mode' - MODE CHOICE **%
%***********************************%
elseif strcmp(option,'mode')
        win_dw2ddeno    = in2;
        pop_mode_val    = in3;

        mode_val        = get(pop_mode_val,'value');
        old_mode        = get(pop_mode_val,'userdata');
        if mode_val==old_mode
                return;
        else
                set(pop_mode_val,'userdata',mode_val);
        end


        % Handles of tagged objects.
        %---------------------------
        axe_handles     = findobj(win_dw2ddeno,'Type','axes');
        txt_handles     = findobj(win_dw2ddeno,'Type','text');
        axe_deno        = findobj(axe_handles,'flat','Tag',tag_axe_deno);
        axe_orig        = findobj(axe_handles,'flat','Tag',tag_axe_orig);
        txt_orig        = findobj(txt_handles,'Tag',tag_txt_orig);

        % Setting de-noised axes invisible.
        %----------------------------------
        mngaxe('vis',axe_deno,'off');

        % Changing mode.
        %---------------
        axes(axe_orig);
        if mode_val==2
                set(txt_orig,'String','Manual hard thresholding');
        else
                set(txt_orig,'String','Manual soft thresholding');
        end

        % Memory blocks update.
        %----------------------
        wmemtool('wmb',win_dw2ddeno,n_miscella_loc,ind_status,0);

%*********************************************************************%
%** OPTION = 'update_sellev' - UPDATE INFOS FOR VISUAL THRESHOLDING **%
%*********************************************************************%
elseif strcmp(option,'update_sellev')
        win_dw2ddeno    = in2;
        win_dw2dtool    = in3;
        Lev_Anal        = in4;
        lev_i           = in5;
        type_hdl        = in6;

        % Getting Analysis values.
        %-------------------------
        [hdls_lev,hdl_thr_min,hdl_thr_max,val_lev] = ...
                        wmemtool('rmb',win_dw2ddeno,n_miscella_loc,...
                                                ind_hdls_lev,...
                                                ind_hdl_thr_min,...
                                                ind_hdl_thr_max,...
                                                ind_val_lev);
        % Updating threshold.
        %---------------------
        if strcmp(type_hdl,'sli')
                new_thresh = get(hdls_lev(2,lev_i),'Value');
                set(hdls_lev(3,lev_i),'string',sprintf('%1.4g',new_thresh));
        elseif strcmp(type_hdl,'edi')
                valstr = get(hdls_lev(3,lev_i),'string');
                [new_thresh,count,err] = sscanf(valstr,'%f');
                if (count~=0) | ~isempty(err)
                        new_thresh = get(hdls_lev(2,lev_i),'Value');
                        set(hdls_lev(3,lev_i),'string',sprintf('%1.4g',new_thresh));
                        return
                else
                        mi = get(hdls_lev(2,lev_i),'Min');
                        ma = get(hdls_lev(2,lev_i),'Max');
                        if      new_thresh<mi , new_thresh = mi;
                        elseif  new_thresh>ma , new_thresh = ma;
                        end
                        set(hdls_lev(2,lev_i),'Value',new_thresh);
                        set(hdls_lev(3,lev_i),'string',sprintf('%1.4g',new_thresh));
                end
        end

        % Waiting message.
        %-----------------
        wwaiting('msg',win_dw2ddeno,'Wait ... computing');

        % Handles of tagged objects.
        %---------------------------
        axe_handles     = findobj(win_dw2ddeno,'Type','axes');
        pop_handles     = findobj(win_dw2ddeno,'Style','popupmenu');
        axe_deno        = findobj(axe_handles,'flat','Tag',tag_axe_deno);
        pop_dirdet_val  = findobj(pop_handles,'Tag',tag_dirdet_val);

        % Getting Analysis values.
        %-------------------------
        coefs = wmemtool('get',win_dw2dtool,n_coefs);
        sizes = wmemtool('get',win_dw2dtool,n_sizes);

        % Setting de-noised axes invisible.
        %----------------------------------
        mngaxe('vis',axe_deno,'off');

        % Updating information.
        %----------------------
        dir                     = get(pop_dirdet_val,'Value');
        new_thresh              = get(hdls_lev(2,lev_i),'Value');
        val_lev(dir,lev_i)      = new_thresh;
        set(hdls_lev(3,lev_i),'string',sprintf('%1.4g',new_thresh));
        if      strcmp(Machine(1:3),'PCW')
                axe_thr = get(hdl_thr_min(dir,lev_i),'Parent');
                ythmin  = get(hdl_thr_min(dir,lev_i),'Ydata');
                ythmax  = get(hdl_thr_max(dir,lev_i),'Ydata');
                delete([hdl_thr_min(dir,lev_i) hdl_thr_max(dir,lev_i)])
                axes(axe_thr);
                hdl_thr_min(dir,lev_i) = ...
                        line(...
                                'Linestyle','--',...
                                'Color','y',...
                                'Xdata',[new_thresh new_thresh],...
                                'Ydata',ythmin);
                hdl_thr_max(dir,lev_i) = ...
                        line(...
                                'Linestyle','--',...
                                'Color','y',...
                                'Xdata',[-new_thresh -new_thresh],...
                                'Ydata',ythmax);
                wmemtool('wmb',win_dw2ddeno,n_miscella_loc,...
                                        ind_hdl_thr_min,hdl_thr_min,    ...
                                        ind_hdl_thr_max,hdl_thr_max     ...
                                        );
        else
                set(hdl_thr_min(dir,lev_i),'Xdata',[new_thresh new_thresh]);
                set(hdl_thr_max(dir,lev_i),'Xdata',[-new_thresh -new_thresh]);
        end

        wmemtool('wmb',win_dw2ddeno,n_miscella_loc,ind_val_lev,val_lev);

        % Memory blocks update.
        %----------------------
        wmemtool('wmb',win_dw2ddeno,n_miscella_loc,ind_status,0);

        % End waiting.
        %-------------
        wwaiting('off',win_dw2ddeno);
                
%**************************************%
%** OPTION = 'close' -  CLOSE FIGURE **%
%**************************************%
elseif strcmp(option,'close')
        win_dw2ddeno    = in2;

        % Returning or not the denoised image in the 2D current analysis.
        %----------------------------------------------------------------
        [status,hdl_winorig] = wmemtool('rmb',win_dw2ddeno,n_miscella_loc,...
                                        ind_status,ind_hdl_winorig);
        if status==1

                % Test for Updating.
                %--------------------
                status = wwaitans(win_dw2ddeno,...
                                  'Update the synthesized image ?',2,'cancel');
        end
        if status==1
                wwaiting('msg',win_dw2ddeno,'Wait ... computing');
                img = findobj(win_dw2ddeno,'type','image','tag',tag_img_deno);
                dw2dmngr('return_deno',hdl_winorig,status,img);
                wwaiting('off',win_dw2ddeno);
        elseif  status==0
                dw2dmngr('return_deno',hdl_winorig,status);
        else

        end
        out1 = status;

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('dw2ddeno','Unknown Option','msg');
        error('*');
end
