function out1 = dw2dimgs(option,in2,in3,in4)
%DW2DIMGS Discret wavelet 2D image selection.
%       out1 = dw2dimgs(option,in2,in3,in4)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:09:30 $

% Tag property of objects.
%-------------------------
tag_imgsel      = 'Img_Select';
tag_imgdec      = 'Img_Dec';

% Miscellaneous values.
%----------------------
Col_BoxAxeSel   = 'y';
Width_LineSel   = 3;
BoxTitleSel_Col = 'g';

%***************************%
%** OPTION = 'get_img' -  **%
%***************************%
if strcmp(option,'get_img')
        win_dw2dtool    = get(0,'CurrentFigure');
        sel_obj         = get(win_dw2dtool,'currentobject');

        % Getting Axes handles.
        %----------------------
        img_hdl = findobj(win_dw2dtool,'type','image');
        Img_Dec = findobj(img_hdl,'tag',tag_imgdec);
        obj_sel = findobj(img_hdl,'Tag',tag_imgsel);
        ind     = find(sel_obj==[Img_Dec;obj_sel]);
        if ~isempty(ind)
                if ~isempty(obj_sel)
                        set(obj_sel,'Tag',tag_imgdec);
                        axe = get(obj_sel,'parent');
                        set(axe,'Xcolor',Col_BoxAxeSel, ...
                                'Ycolor',Col_BoxAxeSel, ...
                                'LineWidth',0.5         ...
                                );
                        col_lab = get(win_dw2dtool,'DefaultAxesXColor');
                        set(get(axe,'xlabel'),'Color',col_lab);
                        if obj_sel==sel_obj , out1 = []; return; end
                end
                axe = get(sel_obj,'parent');
                set(axe,...
                        'Xcolor',BoxTitleSel_Col,       ...
                        'Ycolor',BoxTitleSel_Col,       ...
                        'LineWidth',Width_LineSel,      ...
                        'Box','On'                      ...
                        );
                set(sel_obj,'Tag',tag_imgsel);
                out1 = sel_obj;
        end

%*************************%
%** OPTION = 'clean' -  **%
%*************************%
elseif strcmp(option,'clean')
        % in2 = win_dw2dtool
        %----------------------------
        img_hdl = findobj(in2,'type','image');
        obj_sel = findobj(img_hdl,'Tag',tag_imgsel);
        if ~isempty(obj_sel)
                set(obj_sel,'Tag',tag_imgdec);
                axe = get(obj_sel,'parent');
                set(axe,'Xcolor',Col_BoxAxeSel, ...
                        'Ycolor',Col_BoxAxeSel, ...
                        'LineWidth',0.5         ...
                );
                col_lab = get(in2,'DefaultAxesXColor');
                set(get(axe,'xlabel'),'Color',col_lab);
                out1 = [];
        end

%***************************%
%** OPTION = 'cleanif' -  **%
%***************************%
elseif strcmp(option,'cleanif')
        % for view_dec
        % in2 = win_dw2dtool
        % in3 = new_lev_dec
        % in4 = old_lev_dec
        %----------------------------
        img_hdl = findobj(in2,'type','image');
        obj_sel = findobj(img_hdl,'Tag',tag_imgsel);
        if ~isempty(obj_sel)
                us = get(obj_sel,'Userdata');
                %---------------------------%
                %- us = [0;k;m]
                %- k = level ;
                %- m = 1 : v ; m = 2 : d ;             
                %- m = 3 : h ; m = 4 : a ;     
                %----------------------------%
                if (us(2)<=in3)
                        if (in4>in3) | (us(3)<4) , return; end
                end
                set(obj_sel,'Tag',tag_imgdec);
                axe = get(obj_sel,'parent');
                set(axe,'Xcolor',Col_BoxAxeSel, ...
                        'Ycolor',Col_BoxAxeSel, ...
                        'LineWidth',0.5         ...
                );
                col_lab = get(in2,'DefaultAxesXColor');
                set(get(axe,'xlabel'),'Color',col_lab);
        end

%***********************%
%** OPTION = 'get' -  **%
%***********************%
elseif strcmp(option,'get')
        % in2 = win_dw2dtool
        %------------------
        img_hdl = findobj(in2,'type','image');
        out1    = findobj(img_hdl,'Tag',tag_imgsel);

%**********************************************%
%** OPTION = 'compile' -  for precompilation **%
%**********************************************%
elseif strcmp(option,'compile')

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('dw2dimgs','Unknown Option','msg');
        error('*');
end
