function out1 = dw2dmngr(option,win_dw2dtool,in3,in4,in5)
%DW2DMNGR Discrete wavelet 2D general manager.
%       out1 = dw2dmngr(option,win_dw2dtool,in3,in4,in5)
%
%       option = 'load_img'
%       option = 'load_dec'
%       option = 'load_cfs'
%       option = 'demo'
%       option = 'save_synt'
%       option = 'save_cfs'
%       option = 'save_dec'
%       option = 'analyze'
%       option = 'synthesize'
%       option = 'step2'
%       option = 'view_dec'
%       option = 'select'
%       option = 'view_mode'
%       option = 'fullsize'
%       option = 'return_comp'
%       option = 'return_deno'
%       option = 'set_graphic'
%       option = 'mode_sel'
%       option = 'compile'

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:09:35 $

global  Def_Btn_Height  Def_Btn_Width   Pop_Min_Width   ...
        X_Spacing       Y_Spacing                       ...
        X_Graph_Ratio   Terminal_Prop                   ...
        Lst_ColorMap    Def_TxtBkColor  Def_EdiBkColor  ...
        Def_FraBkColor  Def_FraFgColor  Def_AxeFontSize

%**********************************************%
%** OPTION = 'compile' -  for precompilation **%
%**********************************************%
if strcmp(option,'compile') , return; end

% Default values.
%----------------
max_lev_anal    = 5;

% Image Coding Value.
%-------------------
codemat_v       = wimgcode('get');

% Default values.
%----------------
max_lev_anal     = 5;
min_nbcolors     = 2;
max_nbcolors     = 256;
default_nbcolors = 255;
min_bright       = -2;
max_bright       = 2;
default_bright   = 0;

% Tag property of objects.
%-------------------------
tag_m_files     = 'Files';
tag_m_savesyn   = 'Save_Syn';
tag_m_savecfs   = 'Save_Cfs';
tag_m_savedec   = 'Save_Dec';
tag_cmd_frame   = 'Cmd_Frame';

tag_txt_input   = 'Type_Input';
tag_input_data  = 'Input_Data';
tag_wav_fams    = 'Wav_Fams';
tag_wav_num     = 'Wav_Num';
tag_pop_lev     = 'Pop_Lev';
tag_pus_anal    = 'Pus_Anal';
tag_pus_deno    = 'Pus_Deno';
tag_pus_comp    = 'Pus_Comp';
tag_pus_hist    = 'Pus_Hist';
tag_pus_stat    = 'Pus_Stat';
tag_pop_declev  = 'Pop_DecLev';
tag_pus_visu    = 'Pus_Visu';
tag_pus_big     = 'Pus_Big';
tag_pus_rec     = 'Pus_Rec';
tag_pop_viewm   = 'Pop_ViewM';
tag_txt_full    = 'Txt_Full';
tag_pus_full    = str2mat(...
                        'Pus_Full.1','Pus_Full.2',...
                        'Pus_Full.3','Pus_Full.4'...
                        );

tag_cfs_map     = 'Pop_ColorMap';
tag_sli_nbc     = 'Sli_NBColors';
tag_edi_nbc     = 'Edi_NBColors';
tag_sli_bri     = 'Sli_Brightness';

tag_btnaxeset   = 'Btn_Axe_Set';
tag_axefigutil  = 'Axe_FigUtil';
tag_linetree    = 'Tree_lines';
tag_txttree     = 'Tree_txt';
tag_axeimgbig   = 'Axe_ImgBig';
tag_axeimgini   = 'Axe_ImgIni';
tag_axeimgvis   = 'Axe_ImgVis';
tag_axeimgsel   = 'Axe_ImgSel';
tag_axeimgdec   = 'Axe_ImgDec';
tag_axeimgsyn   = 'Axe_ImgSyn';
tag_axeimghdls  = 'Img_Handles';
tag_imgdec      = 'Img_Dec';

% MemBloc0 of stored values.
%---------------------------
n_InfoInit      = 'DW2D_InfoInit';
ind_filename    =  1;
ind_pathname    =  2;
nb0_stored      =  2;

% MemBloc1 of stored values.
%---------------------------
n_param_anal    = 'DWAn2d_Par_Anal';
ind_img_name    =  1;
ind_wav_name    =  2;
ind_lev_anal    =  3;
ind_img_t_name  =  4;
ind_img_size    =  5;
ind_nbcolors    =  6;
ind_act_option  =  7;
ind_simg_type   =  8;
nb1_stored      =  8;

% MemBloc2.1 and 2.2 of stored values.
%------------------------------------
n_coefs         = 'MemCoefs';
n_sizes         = 'MemSizes';

% MemBloc3 of stored values.
%---------------------------
n_miscella      = 'DWAn2d_Miscella';
ind_graph_area  =  1;
ind_pos_axebig  =  2;
ind_pos_axeini  =  3;
ind_pos_axevis  =  4;
ind_pos_axedec  =  5;
ind_pos_axesyn  =  6;
ind_pos_axesel  =  7;
ind_view_status =  8;
ind_save_status =  9;
ind_sel_funct   = 10;
nb3_stored      = 10;

% Miscellaneous values.
%----------------------
square_viewm    = 1;
tree_viewm      = 2;
Col_BoxAxeSel   = 'y';
Col_Selected    = 'w';
Width_LineSel   = 3;
BoxTitleSel_Col = 'g';
drag_funct      = 'wselobj(''dw2dmngr'',0,''Img'');';
boxsel_funct    = 'dw2dimgs(''get_img'');';

% View Status
%----------------------------------------------------------------%
% 'none'        : init 
% 's_l*'        : square        * = lev_dec (1 --> Level_Anal)
% 'f1l*'        : full ini      * = lev_dec (1 --> Level_Anal)
% 'f2l*'        : full syn      * = lev_dec (1 --> Level_Anal)
% 'f3l*'        : full vis      * = lev_dec (1 --> Level_Anal)
% 'f4l*'        : full dec      * = lev_dec (1 --> Level_Anal)
% 'b*l*'        : big
%                       first   * = index   (1 --> 4*Level_Anal)
%                       second  * = lev_dec (1 --> Level_Anal)
% 't_l*'        : tree          * = lev_dec (1 --> Level_Anal)  
%----------------------------------------------------------------%

% Handles of tagged objects.
%---------------------------
str_numwin      = int2str(win_dw2dtool);
uim_handles     = findobj(win_dw2dtool,'Type','uimenu');
uic_handles     = findobj(win_dw2dtool,'Type','uicontrol');
axe_handles     = findobj(win_dw2dtool,'Type','axes');
txt_handles     = findobj(uic_handles,'Style','text');
pop_handles     = findobj(uic_handles,'Style','popupmenu');
pus_handles     = findobj(uic_handles,'Style','pushbutton');

m_files         = findobj(uim_handles,'flat','Tag',tag_m_files);
m_savesyn       = findobj(m_files,'Tag',tag_m_savesyn);
m_savecfs       = findobj(m_files,'Tag',tag_m_savecfs);
m_savedec       = findobj(m_files,'Tag',tag_m_savedec);

txt_input_txt   = findobj(txt_handles,'Tag',tag_txt_input);
txt_input_data  = findobj(txt_handles,'Tag',tag_input_data);
pop_wav_fams    = findobj(pop_handles,'Tag',tag_wav_fams);
pop_wav_nums    = findobj(pop_handles,'Tag',tag_wav_num);
pop_lev_data    = findobj(pop_handles,'Tag',tag_pop_lev);
pus_anal        = findobj(pus_handles,'Tag',tag_pus_anal);
pus_deno        = findobj(pus_handles,'Tag',tag_pus_deno);
pus_comp        = findobj(pus_handles,'Tag',tag_pus_comp);
pus_hist        = findobj(pus_handles,'Tag',tag_pus_hist);
pus_stat        = findobj(pus_handles,'Tag',tag_pus_stat);
pop_declev      = findobj(pop_handles,'Tag',tag_pop_declev);
pus_visu        = findobj(pus_handles,'Tag',tag_pus_visu);
pus_big         = findobj(pus_handles,'Tag',tag_pus_big);
pus_rec         = findobj(pus_handles,'Tag',tag_pus_rec);
pop_viewm       = findobj(pop_handles,'Tag',tag_pop_viewm);
txt_full        = findobj(txt_handles,'Tag',tag_txt_full);
for k =1:size(tag_pus_full,1)
        pus_full(k) = (findobj(pus_handles,'Tag',tag_pus_full(k,:)))';
end
pop_cfs_map     = findobj(pop_handles,'Tag',tag_cfs_map);
sli_nbc         = findobj(uic_handles,'Tag',tag_sli_nbc);
edi_nbc         = findobj(uic_handles,'Tag',tag_edi_nbc);
sli_bri         = findobj(uic_handles,'Tag',tag_sli_bri);

Axe_ImgBig      = findobj(axe_handles,'flat','Tag',tag_axeimgbig);
Axe_ImgIni      = findobj(axe_handles,'flat','Tag',tag_axeimgini);
Axe_ImgVis      = findobj(axe_handles,'flat','Tag',tag_axeimgvis);
Axe_ImgSel      = findobj(axe_handles,'flat','Tag',tag_axeimgsel);
Axe_ImgSyn      = findobj(axe_handles,'flat','Tag',tag_axeimgsyn);

%****************************%
%** OPTION = 'load_img' -  **%
%****************************%
if strcmp(option,'load_img')
        % Testing file.
        %-------------
        [xpos,ypos] = wfigutil('left_up',win_dw2dtool,10,30);
        [filename,pathname] = uigetfile('*.mat','Load Image',xpos,ypos);
        if filename~=0 & ~isempty(filename)
                [Img_Name,ext] = strtok(filename,'.');
                % PROVISOIRE PROBLEME UIGETFILE PC (MAJ/MIN)
                Img_Name = lower(Img_Name);
                ext  = lower(ext);
                if ~strcmp(ext,'.mat')
                        msg = 'Invalid file name (ext = .mat) !';
                        errordlg(msg,'Load Image ERROR','off');
                        return; 
                end
        else
                return;
        end

        % Begin waiting.
        %--------------
        wwaiting('msg',win_dw2dtool,'Wait ... loading');

        % Cleaning.
        %----------
        dw2dutil('clean',win_dw2dtool,option);

        % Loading file.
        %--------------
        LoSaFlag = 'load'; wloasavf;
        if      err==1
                msg = ['File ' Img_Name ' not found!'];
        elseif  exist('X')==1           
                Img_True_Name   = 'X';
        elseif  exist(deblank(Img_Name))==1             
                Img_True_Name   = Img_Name;
        else
                err = 1;
                msg = ['File ' Img_Name ' doesn''t contain variable ' ...
                                Img_Name ' nor variable X.'];
        end
        if err==0
                Img_Size        = fliplr(size(eval(Img_True_Name)));
                if min(Img_Size)<2
                        err = 1;
                        msg = [Img_Name ' is not an Image.'];
                end
        end
        if err
                wwaiting('off',win_dw2dtool);
                errordlg(msg,'Load Image ERROR','off');
                return
        end
        if exist('map')==1
                self_map        = 1;
        else
                mi = min(min(eval(Img_True_Name)));
                ma = max(max(eval(Img_True_Name)));
                if mi<=0 , ma = ma-mi+1; end
                if ma>default_nbcolors
                        ma = default_nbcolors; 
                elseif ma<2
                        ma = 2;
                end
                map             = pink(ma);
                self_map        = 0;
        end
        NB_ColorsInPal = size(map,1);

        % Setting Analysis parameters.
        %-----------------------------
        wmemtool('wmb',win_dw2dtool,n_param_anal,     ...
                        ind_act_option,option,        ...
                        ind_img_name,Img_Name,        ...
                        ind_img_t_name,Img_True_Name, ...
                        ind_img_size,Img_Size,        ...
                        ind_nbcolors,NB_ColorsInPal,  ...
                        ind_simg_type,'ss'            ...
                        );
        wmemtool('wmb',win_dw2dtool,n_InfoInit, ...
                        ind_filename,filename,  ...
                        ind_pathname,pathname   ...
                        );

        % Setting GUI values.
        %--------------------
        levm            = wmaxlev(Img_Size,'haar');
        levmax          = min(levm,max_lev_anal);
        str_lev_data    = get(pop_lev_data,'String');
        str_lev_data    = str_lev_data(1:levmax,:);
        set(pop_lev_data,'String',str_lev_data,'Value',min(levmax,2));
        set(txt_input_data,'String',Img_Name);
        str_pop_map = Lst_ColorMap;
        if self_map
                str_pop_map = str2mat(str_pop_map,'self');
                set(pop_cfs_map,'String',str_pop_map,'Userdata',map);
        else
                set(pop_cfs_map,'String',str_pop_map,'Userdata','');
        end
        mapcolor('set',win_dw2dtool,'pink',...
                        [pop_cfs_map edi_nbc],NB_ColorsInPal);

        % Drawing axes.
        %--------------
        dw2dutil('pos_axe_init',win_dw2dtool,option);

        % Drawing Original Image
        %-----------------------
        axes(Axe_ImgIni);
        image([1 Img_Size(1)],[1,Img_Size(2)],...
                wimgcode('cod',0,eval(Img_True_Name),NB_ColorsInPal,codemat_v));
        title('Original Image');
        set(Axe_ImgIni,'Tag',tag_axeimgini)

        % Setting enabled values.
        %------------------------
        dw2dutil('enable',win_dw2dtool,option);

        % End waiting.
        %-------------
        wwaiting('off',win_dw2dtool);

%*************************%
%** OPTION = 'load_dec' **%
%*************************%
elseif strcmp(option,'load_dec')
        % Testing file.
        %--------------
        [xpos,ypos] = wfigutil('left_up',win_dw2dtool,10,30);
        [filename,pathname] = uigetfile('*.wa2',...
                        'Load Wavelet Analysis (2D)',xpos,ypos);
        if filename==0 | isempty(filename), return; end

        % Loading file.
        %--------------
        LoSaFlag = 'load'; wloasavf;
        if err==1
                msg = ['File ' filename ' not found!'];
                errordlg(msg,'Load ERROR','off');
                return;
        end
        if ~exist('coefs')         , err = 1; var = 'coefs';
        elseif ~exist('sizes')     , err = 1; var = 'sizes';
        elseif ~exist('wave_name') , err = 1; var = 'wave_name';
        else
           if  ~exist('map'), map = pink(default_nbcolors); end
           if  ~exist('data_name') , data_name = 'no name'; end
        end
        if err==1
           msg = ['variable : ' var ' , not found !'];
           errargt('dw2dmngr',msg,'msg');
           return;
        end
        lev = size(sizes,1)-2;
        if lev>max_lev_anal
                warndlg(['The level of the decomposition is too large (max =' ...
                        int2str(max_lev_anal) ' ).'],'Load Wavelet Analysis (2D)');
                return  
        end

        % Begin waiting.
        %--------------
        wwaiting('msg',win_dw2dtool,'Wait ... loading');

        % Cleaning.
        %----------
        dw2dutil('clean',win_dw2dtool,option);

        % Getting Analysis parameters.
        %-----------------------------
        s_img           = size(sizes);
        Img_Size        = fliplr(sizes(s_img(1),:));
        Level_Anal      = s_img(1)-2;
        NB_ColorsInPal  = size(map,1);

        % Setting coefs and sizes.
        %-------------------------
        wmemtool('put',win_dw2dtool,n_coefs,coefs);
        wmemtool('put',win_dw2dtool,n_sizes,sizes);

        % Setting GUI values.
        %--------------------
        levm            = wmaxlev(Img_Size,'haar');
        levmax          = min(levm,max_lev_anal);
        str_lev_data    = get(pop_lev_data,'String');
        str_lev_data    = str_lev_data(1:levmax,:);
        set(pop_lev_data,'String',str_lev_data);

        set(txt_input_data,'String',data_name);
        wavattrb('set_wname',wave_name,pop_wav_fams,pop_wav_nums);
        set(pop_lev_data,'Value',Level_Anal);
        levels = [int2str(1)];
        for k=2:Level_Anal , levels = str2mat(levels,int2str(k)); end;
        set(pop_declev,'String',levels,'Value',Level_Anal);

        str_pop_map = Lst_ColorMap;
        pink_map = pink(NB_ColorsInPal);
        self_map = max(max(abs(map-pink_map)));
        if self_map>0
                str_pop_map = str2mat(str_pop_map,'self');
                set(pop_cfs_map,'String',str_pop_map,'Userdata',map);
        else
                set(pop_cfs_map,'String',str_pop_map,'Userdata','');
        end

        mapcolor('set',win_dw2dtool,'pink',...
                        [pop_cfs_map edi_nbc],NB_ColorsInPal);

        % Setting Analysis parameters.
        %-----------------------------
        wmemtool('wmb',win_dw2dtool,n_param_anal,     ...
                        ind_act_option,option,        ...
                        ind_wav_name,wave_name,       ...
                        ind_lev_anal,Level_Anal,      ...
                        ind_img_name,data_name,       ...
                        ind_img_t_name,'',            ...
                        ind_img_size,Img_Size,        ...
                        ind_nbcolors,NB_ColorsInPal,  ...
                        ind_simg_type,'ss'            ...
                        );
        wmemtool('wmb',win_dw2dtool,n_InfoInit, ...
                        ind_filename,filename,  ...
                        ind_pathname,pathname   ...
                        );

        % Drawing axes.
        %--------------
        dw2dutil('pos_axe_init',win_dw2dtool,option);

        % Calling Analysis
        %-----------------
        dw2dmngr('step2',win_dw2dtool,option);

        % Computing Original Image.
        %--------------------------
        X = appcoef2(coefs,sizes,wave_name,0);

        % Drawing Original Image
        %-----------------------
        X = wimgcode('cod',0,X,NB_ColorsInPal,codemat_v);
        axes(Axe_ImgIni);
        image([1 Img_Size(1)],[1,Img_Size(2)],X);
        title('Reconstructed Image');
        set(Axe_ImgIni,'Tag',tag_axeimgini)
        axes(Axe_ImgSyn);
        image([1 Img_Size(1)],[1 Img_Size(2)],X);
        set(Axe_ImgSyn,...
                        'XTicklabelMode','manual',      ...
                        'YTicklabelMode','manual',      ...
                        'XTickLabels',[],               ...
                        'YTickLabels',[],               ...
                        'Box','On',                     ...
                        'Tag',tag_axeimgsyn             ...
                        );
        title('Synthesized Image');

        % Setting enabled values.
        %------------------------
        dw2dutil('enable',win_dw2dtool,option);

        % End waiting.
        %-------------
        wwaiting('off',win_dw2dtool);

%*************************%
%** OPTION = 'load_cfs' **%
%*************************%
elseif strcmp(option,'load_cfs')
        % in3 = 'new_synt' optional).
        %----------------------------
        if nargin==2
                % Testing file.
                %--------------
                [xpos,ypos] = wfigutil('left_up',win_dw2dtool,10,30);
                [filename,pathname] = uigetfile('*.mat',...
                                'Load Coefficients (2D)',xpos,ypos);
                if filename==0 | isempty(filename), return; end
                % Loading file.
                %--------------
                LoSaFlag = 'load'; wloasavf;
                if err==1
                        msg = ['File ' filename ' not found!'];
                        errordlg(msg,'Load ERROR','off');
                        return;
                end
                if      ~exist('coefs') , err = 1; var = 'coefs';
                elseif  ~exist('sizes') , err = 1; var = 'sizes';
                end
                if err==1
                        msg = ['variable : ' var ' , not found !'];
                        errargt('dw2dmngr',msg,'msg'); 
                        return
                end
                lev = size(sizes,1)-2;
                if lev>max_lev_anal
                        warndlg(['The level of the decomposition is too large (max =' ...
                                int2str(max_lev_anal) ' ).'],'Load Coefficients (2D)');
                        return  
                end
                in3     = '';
                [Img_Name,ext] = strtok(filename,'.');
                Img_Name = lower(Img_Name);

                % Begin waiting.
                %--------------
                wwaiting('msg',win_dw2dtool,'Wait ... loading');

                % Cleaning.
                %----------
                dw2dutil('clean',win_dw2dtool,option);

                % Getting Analysis parameters.
                %-----------------------------
                s_img           = size(sizes);
                Img_Size        = fliplr(sizes(s_img(1),:));
                Level_Anal      = s_img(1)-2;

                % Setting coefs and sizes.
                %-------------------------
                wmemtool('put',win_dw2dtool,n_coefs,coefs);
                wmemtool('put',win_dw2dtool,n_sizes,sizes);

                % Setting GUI values.
                %--------------------
                set(txt_input_data,'String',Img_Name);
                levels = [int2str(1)];
                for k=2:Level_Anal , levels = str2mat(levels,int2str(k)); end;
                set(pop_lev_data,'String',int2str(Level_Anal),'Value',1);
                set(pop_declev,'String',levels,'Value',Level_Anal);

                % Computing (approximate) colormap.
                %----------------------------------
                tmp = appcoef2(coefs,sizes,'haar',Level_Anal);
                NB_ColorsInPal = ceil(max(max(tmp)))/(2^Level_Anal);
                if NB_ColorsInPal<2
                        NB_ColorsInPal = 2;
                elseif NB_ColorsInPal>default_nbcolors
                        NB_ColorsInPal=default_nbcolors;
                end
                mapcolor('set',win_dw2dtool,'pink',...
                                [pop_cfs_map edi_nbc],NB_ColorsInPal);


                % Setting Analysis parameters.
                %-----------------------------
                wmemtool('wmb',win_dw2dtool,n_param_anal,    ...
                               ind_act_option,option,        ...
                               ind_lev_anal,Level_Anal,      ...
                               ind_img_size,Img_Size,        ...
                               ind_img_name,Img_Name,        ...
                               ind_nbcolors,NB_ColorsInPal,  ...
                               ind_simg_type,'ss'            ...
                               );
                wmemtool('wmb',win_dw2dtool,n_InfoInit, ...
                                ind_filename,filename,  ...
                                ind_pathname,pathname   ...
                                );

        else
                % Begin waiting.
                %--------------
                wwaiting('msg',win_dw2dtool,'Wait ... cleaning');

                % Cleaning.
                %----------
                dw2dutil('clean',win_dw2dtool,option,in3);
        end

        % Drawing axes.
        %--------------
        dw2dutil('pos_axe_init',win_dw2dtool,option);

        % Calling Analysis
        %-----------------
        dw2dmngr('step2',win_dw2dtool,option);

        % Setting enabled values.
        %------------------------
        dw2dutil('enable',win_dw2dtool,option);

        % End waiting.
        %-------------
        wwaiting('off',win_dw2dtool);

%*********************%
%** OPTION = 'demo' **%
%*********************%
elseif strcmp(option,'demo')
        Img_Name        = in3;
        Wave_Name       = in4;
        Level_Anal      = in5;

        % Loading Image.
        %---------------
        wwaiting('msg',win_dw2dtool,'Wait ... loading');
        filename = Img_Name;
        pathname = 'Wave_TBDemo';
        LoSaFlag = 'load'; wloasavf;
        if      err==1
                wwaiting('off',win_dw2dtool);
                msg = ['File ' Img_Name ' not found!'];
                errordlg(msg,'Load ERROR','off');
                return
        elseif  exist('X')==1           
                Img_True_Name   = 'X';
        elseif  exist(deblank(Img_Name))==1             
                Img_True_Name   = Img_Name;
        else
                err = 1;
                msg = ['File ' Img_Name ' doesn''t contain variable ' ...
                                Img_Name ' nor variable X.'];
        end
        if err==0
                Img_Size        = fliplr(size(eval(Img_True_Name)));
                if min(Img_Size)<2
                        err = 1;
                        msg = [Img_Name ' is not an Image.'];
                end
        end
        if err
                wwaiting('off',win_dw2dtool);
                errordlg(msg,'Load Image ERROR','off');
                return  
        end
        if exist('map')==1
                self_map = 1;
        else
                mi = min(min(eval(Img_True_Name)));
                ma = max(max(eval(Img_True_Name)));
                if mi<=0 , ma = ma-mi+1; end
                if ma>default_nbcolors
                        ma = default_nbcolors; 
                elseif ma<2
                        ma = 2;
                end
                map      = pink(ma);
                self_map = 0;
        end
        NB_ColorsInPal = size(map,1);

        % Cleaning.
        %----------
        wwaiting('msg',win_dw2dtool,'Wait ... cleaning');
        dw2dutil('clean',win_dw2dtool,option);

        % Setting GUI values.
        %--------------------
        set(txt_input_data,'String',Img_Name);
        wavattrb('set_wname',Wave_Name,pop_wav_fams,pop_wav_nums);
        set(pop_lev_data,'Value',Level_Anal);
        levels = [int2str(1)];
        for k=2:Level_Anal , levels = str2mat(levels,int2str(k)); end;
        set(pop_declev,'String',levels,'Value',Level_Anal);
        str_pop_map = Lst_ColorMap;
        if self_map
                str_pop_map = str2mat(str_pop_map,'self');
                set(pop_cfs_map,'String',str_pop_map,'Userdata',map);
        else
                set(pop_cfs_map,'String',str_pop_map,'Userdata','');
        end
        mapcolor('set',win_dw2dtool,'pink',...
                        [pop_cfs_map edi_nbc],NB_ColorsInPal);

        % Setting Analysis parameters
        %-----------------------------
        wmemtool('wmb',win_dw2dtool,n_param_anal,    ...
                        ind_act_option,option,       ...
                        ind_img_name,Img_Name,       ...
                        ind_wav_name,Wave_Name,      ...
                        ind_lev_anal,Level_Anal,     ...
                        ind_img_t_name,Img_True_Name,...
                        ind_img_size,Img_Size,       ...
                        ind_nbcolors,NB_ColorsInPal, ...
                        ind_simg_type,'ss'           ...
                        );
        wmemtool('wmb',win_dw2dtool,n_InfoInit, ...
                        ind_filename,filename,  ...
                        ind_pathname,pathname   ...
                        );

        % Drawing axes.
        %--------------
        dw2dutil('pos_axe_init',win_dw2dtool,option);

        % Drawing Original Image
        %-----------------------
        axes(Axe_ImgIni)
        image([1 Img_Size(1)],[1,Img_Size(2)],...
                wimgcode('cod',0,eval(Img_True_Name),NB_ColorsInPal,codemat_v));
        title('Original Image');
        set(Axe_ImgIni,'Tag',tag_axeimgini)

        % Calling Analysis.
        %-----------------
        dw2dmngr('step2',win_dw2dtool,option);

        % Setting enabled values.
        %------------------------
        dw2dutil('enable',win_dw2dtool,option);

        % End waiting.
        %-------------
        wwaiting('off',win_dw2dtool);

%**************************%
%** OPTION = 'save_synt' **%
%**************************%
elseif strcmp(option,'save_synt')
        % Testing file.
        %--------------
        [xpos,ypos] = wfigutil('left_up',win_dw2dtool,10,30);
        [filename,pathname] = uiputfile('*.mat',...
                        'Save Synthesized Image',xpos,ypos);
        if filename==0 | isempty(filename) , return; end
        [name,ext] = strtok(filename,'.');
        ext = '.mat';
        filename = [name ext];

        % Begin waiting.
        %--------------
        wwaiting('msg',win_dw2dtool,'Wait ... saving');

        % Getting colormap.
        %------------------
        map = get(pop_cfs_map,'Userdata');
        if isempty(map)
                nb_colors = wmemtool('rmb',win_dw2dtool,...
                                n_param_anal,ind_nbcolors);
                map = pink(nb_colors);
        end

        % Getting Synthesized Image.
        %---------------------------
        str_name = lower(name);
        img = dw2drwcd('r_synt',win_dw2dtool);
        eval([str_name '= get(img,''Cdata'');']);

        % Saving file.
        %--------------
        saveStr = [str_name ' map'];
        LoSaFlag = 'save'; wloasavf;

        % End waiting.
        %-------------
        wwaiting('off',win_dw2dtool);

        if err
                errargt('dw2dmngr','Save FAILED !','msg');
        end


%*************************%
%** OPTION = 'save_cfs' **%
%*************************%
elseif strcmp(option,'save_cfs')
        % Testing file.
        %--------------
        [xpos,ypos] = wfigutil('left_up',win_dw2dtool,10,30);
        [filename,pathname] = uiputfile('*.mat',...
                        'Save Coefficients (2D)',xpos,ypos);
        if filename==0 | isempty(filename) , return; end

        % Begin waiting.
        %--------------
        wwaiting('msg',win_dw2dtool,'Wait ... saving coefficients');

        [name,ext] = strtok(filename,'.');
        ext = '.mat';
        filename = [name ext];

        % Getting Analysis values.
        %-------------------------
        coefs = wmemtool('get',win_dw2dtool,n_coefs);
        sizes = wmemtool('get',win_dw2dtool,n_sizes);

        % Saving file.
        %--------------
        saveStr = ['coefs sizes'];
        LoSaFlag = 'save'; wloasavf;

        % End waiting.
        %-------------
        wwaiting('off',win_dw2dtool);

        if err
                errargt('dw2dmngr','Save FAILED !','msg');
        end


%*************************%
%** OPTION = 'save_dec' **%
%*************************%
elseif strcmp(option,'save_dec')
        % Testing file.
        %--------------
        [xpos,ypos] = wfigutil('left_up',win_dw2dtool,10,30);
        [filename,pathname] = uiputfile('*.wa2',...
                        'Save Wavelet Analysis (2D)',xpos,ypos);
        if filename==0 | isempty(filename) , return; end

        % Begin waiting.
        %--------------
        wwaiting('msg',win_dw2dtool,'Wait ... saving decomposition');

        [name,ext] = strtok(filename,'.');
        ext = '.wa2';
        filename = [name ext];

        % Getting Analysis parameters.
        %-----------------------------
        [wave_name,data_name,level_anal,nb_colors] =    ...
                wmemtool('rmb',win_dw2dtool,n_param_anal,       ...
                                                ind_wav_name,   ...
                                                ind_img_name,   ...
                                                ind_lev_anal,   ...
                                                ind_nbcolors    ...
                                        );

        map = get(pop_cfs_map,'Userdata');
        if isempty(map) , map = pink(nb_colors); end


        % Getting Analysis values.
        %-------------------------
        coefs = wmemtool('get',win_dw2dtool,n_coefs);
        sizes = wmemtool('get',win_dw2dtool,n_sizes);

        % Saving file.
        %--------------
        saveStr = ['coefs sizes wave_name data_name map'];
        LoSaFlag = 'save'; wloasavf;

        % End waiting.
        %-------------
        wwaiting('off',win_dw2dtool);

        if err
                errargt('dw2dmngr','Save FAILED !','msg');
        end

%****************************%
%** OPTION = 'analyze' -   **%
%****************************%
elseif strcmp(option,'analyze')
        active_option = wmemtool('rmb',win_dw2dtool,n_param_anal, ...
                                                ind_act_option);        

        if ~strcmp(active_option,'load_img')

                % Test for new Analysis.
                %-----------------------
                % new = wwaitans(win_dw2dtool,'New Analysis ?');
                % if new==0 , return; end

                wwaiting('msg',win_dw2dtool,'Wait ... computing');
                dw2dutil('clean2',win_dw2dtool,option);
                wmemtool('wmb',win_dw2dtool,n_param_anal,ind_simg_type,'ss');
        end

        % Reading Analysis Parameters.
        %----------------------------
        Wave_Name = wavattrb('wname',pop_wav_fams,pop_wav_nums,'name');
        Level_Anal = get(pop_lev_data,'Value');

        % Setting GUI values.
        %--------------------
        levels = [int2str(1)];
        for k=2:Level_Anal , levels = str2mat(levels,int2str(k)); end;
        set(pop_declev,'String',levels,'Value',Level_Anal);

        % Setting Analysis parameters.
        %-----------------------------
        wmemtool('wmb',win_dw2dtool,n_param_anal,               ...
                                        ind_act_option,option,  ...
                                        ind_wav_name,Wave_Name, ...
                                        ind_lev_anal,Level_Anal ...
                                        );

        % Calling Analysis.
        %------------------
        dw2dmngr('step2',win_dw2dtool,option);

        % Setting enabled values.
        %------------------------
        dw2dutil('enable',win_dw2dtool,option);

%*****************************%
%** OPTION = 'synthesize' - **%
%*****************************%
elseif strcmp(option,'synthesize')
        active_option = wmemtool('rmb',win_dw2dtool,n_param_anal, ...
                                                ind_act_option);
        if ~strcmp(active_option,'load_cfs')

                % Test for new Synthesis.
                %-----------------------
                % new = wwaitans(win_dw2dtool,'New Synthesis ?');
                % if new==0 , return; end

                wwaiting('msg',win_dw2dtool,'Wait ... computing');
                dw2dmngr('load_cfs',win_dw2dtool,'new_synt');
        end

        % Begin waiting.
        %--------------
        wwaiting('msg',win_dw2dtool,'Wait ... computing');

        % Reading Analysis Parameters.
        %----------------------------
        Wave_Name = wavattrb('wname',pop_wav_fams,pop_wav_nums,'name');

        % Getting & Setting Analysis parameters.
        %---------------------------------------
        [Img_Size,NB_ColorsInPal,Level_Anal] =  ...
                        wmemtool('rmb',win_dw2dtool,n_param_anal,       ...
                                                        ind_img_size,   ...
                                                        ind_nbcolors,   ...
                                                        ind_lev_anal    ...
                                                        );
        wmemtool('wmb',win_dw2dtool,n_param_anal,               ...
                                        ind_act_option,option,  ...
                                        ind_wav_name,Wave_Name  ...
                                        );

        % Setting GUI values.
        %--------------------
        levels  = [int2str(1)];
        for k=2:Level_Anal , levels = str2mat(levels,int2str(k)); end
        set(pop_lev_data,'String',int2str(Level_Anal));
        set(pop_declev,'String',levels,'Value',Level_Anal);

        % Getting Analysis values.
        %-------------------------
        coefs = wmemtool('get',win_dw2dtool,n_coefs);
        sizes = wmemtool('get',win_dw2dtool,n_sizes);

        % Getting Select Function.
        %------------------------
        [view_status,select_funct] = wmemtool('rmb',win_dw2dtool,n_miscella,...
                                        ind_view_status,ind_sel_funct);

        % Setting axes properties.
        %-------------------------
        Axe_ImgDec      = wmemtool('get',win_dw2dtool,tag_axeimgdec);
        Axe_ImgDec      = Axe_ImgDec(1:4*Level_Anal);
        Img_Handles     = wmemtool('get',win_dw2dtool,tag_axeimghdls);

        % Computing Synthesized Image.
        %-----------------------------
        lev_view        = get(pop_declev,'Value');
        view_mode       = view_status(1);
        for k=Level_Anal-1:-1:1
                X = appcoef2(coefs,sizes,Wave_Name,k);
                if (k~=lev_view) & ( view_mode=='s' | view_mode=='f')
                        vis = 'Off';
                else
                        vis = 'On';
                end
                num_img = 4*k;
                axes(Axe_ImgDec(num_img));
                %----------------------------------------%
                %-   k = level ;
                %-   m = 1 : v ;        m = 2 : d ;             
                %-   m = 3 : h ;        m = 4 : a ;     
                %----------------------------------------%
                trunc_p = [k Img_Size(2) Img_Size(1)];
                Img_Handles(num_img) = ...
                                image([1 Img_Size(1)],[1,Img_Size(2)],...
                                        wimgcode('cod',1,X,NB_ColorsInPal,codemat_v,trunc_p),...
                                        'Visible',vis,...
                                        'UserData',[0;k;4],...
                                        'Tag',tag_imgdec,...
                                        'ButtonDownFcn',select_funct...
                                        );
                set(Axe_ImgDec(num_img),                                ...
                                'Visible',vis,                          ...
                                'Xcolor',Col_BoxAxeSel,                 ...
                                'Ycolor',Col_BoxAxeSel,                 ...
                                'XTicklabelMode','manual',              ...
                                'YTicklabelMode','manual',              ...
                                'XTickLabels',[],'YTickLabels',[],      ...
                                'XTick',[],'YTick',[],'Box','On',       ...
                                'Tag',tag_axeimgdec                     ...
                                );
        end
        wmemtool('put',win_dw2dtool,tag_axeimghdls,Img_Handles);

        X = appcoef2(coefs,sizes,Wave_Name,0);

        % Drawing Synthesized Image.
        %--------------------------
        if (view_mode=='f') , vis = 'Off'; else , vis = 'On'; end
        axes(Axe_ImgIni);
        image(...
                [1 Img_Size(1)],[1 Img_Size(2)],                ...
                wimgcode('cod',0,X,NB_ColorsInPal,codemat_v),   ...
                'Visible',vis                                   ...
                );
        set(Axe_ImgIni,'Visible',vis,'Tag',tag_axeimgini);
        title('Original Synthesized Image');
        axes(Axe_ImgSyn);
        image(...
                [1 Img_Size(1)],[1 Img_Size(2)],        ...
                wimgcode('cod',0,X,NB_ColorsInPal,codemat_v),   ...
                'Visible',vis                           ...
                );
        set(Axe_ImgSyn,'Visible',vis,'Tag',tag_axeimgsyn);
        title('Synthesized Image');

        delete(findobj(Axe_ImgVis,'Type','image'));

        % Setting enabled values.
        %------------------------
        dw2dutil('enable',win_dw2dtool,option);

        % End waiting.
        %-------------
        wwaiting('off',win_dw2dtool);

%*****************************************************%
%** OPTION = 'step2' - (load_dec & demo & analyze)  **%
%*****************************************************%
elseif strcmp(option,'step2')
        % in3 = calling option  
        %---------------------

        % Getting  Analysis parameters.
        %------------------------------
        [       Img_Name,Img_Size,...
                NB_ColorsInPal,Wave_Name,Level_Anal] = ...
                        wmemtool('rmb',win_dw2dtool,n_param_anal,       ...
                                                ind_img_name,           ...
                                                ind_img_size,           ...
                                                ind_nbcolors,           ...
                                                ind_wav_name,           ...
                                                ind_lev_anal            ...
                                                );

        % Setting axes properties.
        %-------------------------
        Axe_ImgDec      = wmemtool('get',win_dw2dtool,tag_axeimgdec);
        Axe_ImgDec      = Axe_ImgDec(1:4*Level_Anal);
        set(Axe_ImgDec,'Visible','On');

        % Getting Select Function.
        %------------------------
        select_funct = wmemtool('rmb',win_dw2dtool,n_miscella,ind_sel_funct);

        % Begin waiting.
        %---------------
        wwaiting('msg',win_dw2dtool,'Wait ... computing');

        % Computing.
        %-----------
        if strcmp(in3,'demo') | strcmp(in3,'analyze')
                Img_Anal        = get(dw2drwcd('r_orig',win_dw2dtool),'Cdata');
                [coefs,sizes]   = wavedec2(Img_Anal,Level_Anal,Wave_Name);
                clear Img_Anal

                % Setting coefs and sizes.
                %-------------------------
                wmemtool('put',win_dw2dtool,n_coefs,coefs);
                wmemtool('put',win_dw2dtool,n_sizes,sizes);
        else
                % Getting Analysis values.
                %-------------------------
                coefs = wmemtool('get',win_dw2dtool,n_coefs);
                sizes = wmemtool('get',win_dw2dtool,n_sizes);
        end
        
        % App flag.
        %----------
        if strcmp(in3,'load_cfs') | strcmp(in3,'new_synt')
                app_flg = 0;
        else
                app_flg = 1;
        end
        
        % Decomposition drawing
        %----------------------
        size0 = sizes(1,:);
        Img_Handles = zeros(1,4*Level_Anal);
        for k=1:Level_Anal
                for m=1:4
                        if      m==1 , Y = detcoef2('v',coefs,sizes,k);
                        elseif  m==2 , Y = detcoef2('d',coefs,sizes,k);
                        elseif  m==3 , Y = detcoef2('h',coefs,sizes,k);
                        elseif  m==4
                                if app_flg | k==Level_Anal
                                        Y = appcoef2(coefs,sizes,Wave_Name,k);
                                else
                                        Y = zeros(size(Y));
                                end
                        else, error('*');
                        end
                        if (m==4) & (k~=Level_Anal)
                                vis = 'Off'; 
                        else
                                vis = 'On'; 
                        end
                        num_img = 4*(k-1)+m;
                        axes(Axe_ImgDec(num_img));
                        %----------------------------------------%
                        %-   k = level ;
                        %-   m = 1 : v ;        m = 2 : d ;             
                        %-   m = 3 : h ;        m = 4 : a ;     
                        %----------------------------------------%
                        trunc_p = [k Img_Size(2) Img_Size(1)];
                        Img_Handles(num_img) = ...
                                image([1 Img_Size(1)],[1 Img_Size(2)],...
                                        wimgcode('cod',1,Y,NB_ColorsInPal,codemat_v,trunc_p),...
                                        'Visible',vis,                  ...
                                        'UserData',[0;k;m],             ...
                                        'Tag',tag_imgdec,               ...
                                        'ButtonDownFcn',select_funct    ...
                                        );
                        set(Axe_ImgDec(num_img),                        ...
                                'Xcolor',Col_BoxAxeSel,                 ...
                                'Ycolor',Col_BoxAxeSel,                 ...
                                'XTicklabelMode','manual',              ...
                                'YTicklabelMode','manual',              ...
                                'XTickLabels',[],'YTickLabels',[],      ...
                                'XTick',[],'YTick',[],'Box','On',       ...
                                'Tag',tag_axeimgdec                     ...
                                );
                end
        end
        wmemtool('put',win_dw2dtool,tag_axeimghdls,Img_Handles);

        % Decomposition Title.
        %---------------------
        wsetxlab(Axe_ImgSel,['Decomposition at level ' int2str(Level_Anal)],-10);

        % Synthesized Image (same that original).
        %----------------------------------------
        if strcmp(in3,'demo') | strcmp(in3,'analyze')
                X = appcoef2(coefs,sizes,Wave_Name,0);
                gx      = get(Axe_ImgSyn,'Xgrid');
                gy      = get(Axe_ImgSyn,'Ygrid');
                strtit  = get(get(Axe_ImgSyn,'title'),'String');
                axes(Axe_ImgSyn);
                image([1 Img_Size(1)],[1 Img_Size(2)],...
                        wimgcode('cod',0,X,NB_ColorsInPal,codemat_v));...
                set(Axe_ImgSyn,...
                        'Visible','On',                 ...
                        'Xgrid',gx,'Ygrid',gy,          ...
                        'XTicklabelMode','manual',      ...
                        'YTicklabelMode','manual',      ...
                        'XTickLabels',[],               ...
                        'YTickLabels',[],               ...
                        'Box','On',                     ...
                        'Tag',tag_axeimgsyn             ...
                );
                title(strtit);
        end

        % Setting Dynamic Visualization tool.
        %------------------------------------
        dynvtool('attach',win_dw2dtool,...
                        [],...
                        [Axe_ImgIni Axe_ImgBig Axe_ImgSyn Axe_ImgVis],...
                        [Axe_ImgDec],...
                        [1 1],'','','','int','r');

        dynvtool('put',win_dw2dtool);

        % Setting view_status.
        %---------------------
        view_status     = ['s_l' int2str(Level_Anal)];
        wmemtool('wmb',win_dw2dtool,n_miscella,         ...
                                ind_view_status,view_status,    ...
                                ind_save_status,view_status     ...
                                );

        % End waiting.
        %-------------
        wwaiting('off',win_dw2dtool);

%**********************************************%
%** OPTION = 'view_dec' - view decomposition **%
%**********************************************%
elseif strcmp(option,'view_dec')
        % Getting position parameters.
        %-----------------------------
        [view_status,save_status] = ...
                wmemtool('rmb',win_dw2dtool,n_miscella,         ...
                                        ind_view_status,ind_save_status ...
                                        );
        new_lev_view = get(pop_declev,'Value');
        k = findstr(view_status,'l');
        lev_old = str2num(view_status(k+1:length(view_status)));
        if new_lev_view==lev_old , return; end
        dw2dimgs('cleanif',win_dw2dtool,new_lev_view,lev_old);
        view_status     = [view_status(1:k) int2str(new_lev_view)];
        wmemtool('wmb',win_dw2dtool,n_miscella,ind_view_status,view_status);

        % Begin waiting.
        %--------------
        wwaiting('msg',win_dw2dtool,'Wait ... drawing');

        % Drawing.
        %---------
        dw2dmngr('set_graphic',win_dw2dtool,option);

        % End waiting.
        %-------------
        wwaiting('off',win_dw2dtool);

%************************%
%** OPTION = 'select'  **%
%************************%
elseif strcmp(option,'select')
        % Getting active option.
        %------------------------
        active_option = wmemtool('rmb',win_dw2dtool,n_param_anal,...
                                                        ind_act_option);

        % Getting Select Function.
        %------------------------
        select_funct = wmemtool('rmb',win_dw2dtool,n_miscella,  ...
                                                ind_sel_funct);
        if strcmp(select_funct,drag_funct) , drag = 1; else , drag = 0; end

        Drag_Tools      = [pus_visu,pus_big,pus_rec];
        if nargin==3 , in4 = 0; end
        if strcmp(in3,'end_big')
                % End Big Image.
                %---------------
                dw2dmngr('set_graphic',win_dw2dtool,option,'end');
                handles = [     pus_anal,...
                                pop_declev,     pus_visu,       ...
                                pus_rec,                        ...
                                pop_viewm,      pus_full        ...
                                ];
                set(handles,'Enable','On');
                if drag==0
                        cba_pus_big  = ['dw2dmngr(''select'','  ...
                                        str_numwin ','  ...
                                        num2mstr(pus_big) ');'];
                else
                        cba_pus_big = '';
                end
                bk_col = get(pus_visu,'BackGroundColor');
                set(pus_big,...
                        'String','Full Size',           ...
                        'BackGroundColor',bk_col,       ...
                        'Callback',cba_pus_big          ...
                        );
                val = get(pop_viewm,'Value');
                if (val==square_viewm)
                        dw2darro('vis_arrow',win_dw2dtool,'on');
                end
                ind = 0;

        elseif drag==1
                obj_sel         = in3;
                end_point       = in4;
                x = end_point(1);       y = end_point(2);
                ind = 0;
                for k = 1:size(Drag_Tools,2)
                        p = get(Drag_Tools(k),'Position');
                        if      (p(1)<=x) & (x<=p(1)+p(3)) & ...
                                (p(2)<=y) & (y<=p(2)+p(4))
                                ind = k;
                                break;
                        end
                end
        elseif drag==0
                obj_sel = dw2dimgs('get',win_dw2dtool);
                if ~isempty(obj_sel)
                        ind = find(in3==Drag_Tools);
                else
                        ind = 0;
                end
        end

        if ind~=0
                % Getting  Analysis parameters.
                %------------------------------
                if strcmp(get(Drag_Tools(ind),'Enable'),'off') , return; end

                Img_Handles     = wmemtool('get',win_dw2dtool,...
                                                tag_axeimghdls);
                indimg          = find(Img_Handles==obj_sel);
                if isempty(indimg) , return; end

                % Begin waiting.
                %--------------
                wwaiting('msg',win_dw2dtool,'Wait ... computing');

                [Img_Size,Wave_Name,Level_Anal] = ...
                        wmemtool('rmb',win_dw2dtool,n_param_anal,       ...
                                                ind_img_size,           ...
                                                ind_wav_name,           ...
                                                ind_lev_anal            ...
                                                );


                Axe_ImgDec      = wmemtool('get',win_dw2dtool,...
                                                        tag_axeimgdec);
                Axe_ImgDec      = Axe_ImgDec(1:4*Level_Anal);
        
                % Computing.
                %-----------
                %---------------------------------%
                %-   m = 1 : v ;        m = 2 : d ;             
                %-   m = 3 : h ;        m = 4 : a ;     
                %---------------------------------%
                us = get(Img_Handles(indimg),'UserData');
                us = get(obj_sel,'UserData');
                level   = us(2,:);
                m       = us(3,:);
                str_lev = int2str(level);
                if      m==1
                        opt     = 'v';
                        typestr = 'Vertical detail';
                elseif  m==2
                        opt     = 'd';
                        typestr = 'Diagonal detail';
                elseif  m==3
                        opt     = 'h';
                        typestr = 'Horizontal detail';
                elseif  m==4
                        opt     = 'a';
                        typestr = 'Approximation';
                else
                        error('*');
                end

                if ind==1       %-- Visualize
                        X = get(obj_sel,'CData');
                        strxlab = [typestr ' coef. at level ' str_lev];
                        axe = get(obj_sel,'Parent');
                        xl = get(axe,'Xlim');
                        yl = get(axe,'Ylim');

                elseif ind==2   %-- big image
                        X = get(obj_sel,'CData');
                        strxlab = [typestr ' coef. at level ' str_lev];
                        axe = get(obj_sel,'Parent');
                        xl = get(axe,'Xlim');
                        yl = get(axe,'Ylim');

                elseif ind==3   %-- Reconstruction
                        NB_ColorsInPal  = wmemtool('rmb',win_dw2dtool,  ...
                                                        n_param_anal,   ...
                                                        ind_nbcolors    ...
                                                        );
                        coefs = wmemtool('get',win_dw2dtool,n_coefs);
                        sizes = wmemtool('get',win_dw2dtool,n_sizes);

                        X = wrcoef2(opt,coefs,sizes,Wave_Name,level);
                        if opt=='a' , flg_code = 0; else , flg_code = 1; end
                        X = wimgcode('cod',flg_code,X,NB_ColorsInPal,codemat_v);
                        strxlab = ['Recons. ' typestr...
                                        ' coef. of level ' str_lev];
                        xl = get(Axe_ImgIni,'Xlim');
                        yl = get(Axe_ImgIni,'Ylim');
                end
                if ind~=2       % Drawing (little image)
                        gx = get(Axe_ImgVis,'Xgrid');
                        gy = get(Axe_ImgVis,'Ygrid');
                        axes(Axe_ImgVis);
                        image([1 Img_Size(1)],[1 Img_Size(2)],X);

                        set( Axe_ImgVis,...
                                'Visible','On',                         ...
                                'Xgrid',gx,'Ygrid',gy,                  ...
                                'Xlim',xl,'Ylim',yl,                    ...
                                'XTickLabels',[],'YTickLabels',[],      ...
                                'Xcolor',BoxTitleSel_Col,               ...
                                'Ycolor',BoxTitleSel_Col,               ...
                                'LineWidth',Width_LineSel,              ...
                                'Box','On',                             ...
                                'Tag',tag_axeimgvis                     ...
                                );
                        title(strxlab);

                else            % Drawing (big image)

                        [row,col] = size(X);
                        strxlab = [strxlab '  -- image size : ('        ...
                                        int2str(row) ',' int2str(col) ')'];

                        % Setting enabled values.
                        %------------------------
                        handles = [     pus_anal,                       ...
                                        pop_declev,     pus_visu,       ...
                                        pus_rec,        pop_viewm,      ...
                                        pus_full        ...
                                        ];
                        set(handles,'Enable','Off');
                        set(pus_big,                                    ...
                                'String','End Full Size',               ...
                                'BackGroundColor',Def_TxtBkColor,       ...
                                'Callback',                             ...
                                ['dw2dmngr(''select'',' str_numwin      ...
                                         ',''end_big'');']              ...
                                );
                        axe_figutil     = findobj(win_dw2dtool,         ...
                                                'type','axes',          ...
                                                'Tag',tag_axefigutil    ...
                                                );
                        t_lines         = findobj(axe_figutil,          ...
                                                'type','line',          ...
                                                'Tag',tag_linetree      ...
                                                );
                        t_txt           = findobj(axe_figutil,          ...
                                                'type','text',          ...
                                                'Tag',tag_txttree       ...
                                                );

                        for k=1:4*Level_Anal
                                ax = Axe_ImgDec(k);
                                set(get(ax,'Children'),'Visible','Off');
                                set(ax,'Visible','Off');
                        end
                        mngaxe('vis',[Axe_ImgIni,Axe_ImgVis,...
                                        Axe_ImgSyn,Axe_ImgSel],'off');
                        wboxtitl('vis',Axe_ImgSel,'off');
                        set([t_lines' t_txt'],'Visible','off');
                        dw2darro('vis_arrow',win_dw2dtool,'off');

                        gx = get(Axe_ImgBig,'Xgrid');
                        gy = get(Axe_ImgBig,'Ygrid');
                        axes(Axe_ImgBig);
                        image([1 Img_Size(1)],[1 Img_Size(2)],X);
                        set(Axe_ImgBig,                 ...
                                'Visible','On',         ...
                                'Xgrid',gx,'Ygrid',gy,  ...
                                'XTickLabels',[],       ...
                                'YTickLabels',[],       ...
                                'Xlim',xl,'Ylim',yl,    ...
                                'Tag',tag_axeimgbig     ...
                                );
                        wsetxlab(Axe_ImgBig,strxlab,-15);

                        % Changing View Status.
                        %----------------------
                        view_status = wmemtool('rmb',win_dw2dtool,      ...
                                                n_miscella,ind_view_status);
                        wmemtool('wmb',win_dw2dtool,n_miscella,...
                                        ind_save_status,view_status);
                        view_status = ['b' int2str(indimg) ...
                                        'l' int2str(get(pop_declev,'Value'))];
                        wmemtool('wmb',win_dw2dtool,n_miscella,...
                                        ind_view_status,view_status);
                end
                        
                % End waiting.
                %--------------
                wwaiting('off',win_dw2dtool);
        end

%***************************%
%** OPTION = 'view_mode'  **%
%***************************%
elseif strcmp(option,'view_mode')
        % Getting & Setting View_status.
        %-------------------------------
        view_status = wmemtool('rmb',win_dw2dtool,n_miscella,ind_view_status);
        val             = get(pop_viewm,'Value');
        if view_status(1)=='s'
                if val==square_viewm , return; end
                view_status(1) = 't';
        elseif view_status(1)=='t'
                if val==tree_viewm , return; end
                view_status(1) = 's';
        end
        wmemtool('wmb',win_dw2dtool,n_miscella,         ...
                                ind_view_status,view_status,    ...
                                ind_save_status,view_status     ...
                                );
        % Begin waiting.
        %--------------
        wwaiting('msg',win_dw2dtool,'Wait ... drawing');
        
        pos = zeros(4,4);
        pos(1,:) = get(pus_full(1),'Position');
        if val==square_viewm
                pos(1,3) = (3*pos(1,3))/2;
                pos(2,:) = pos(1,:); pos(2,2) = pos(2,2)-pos(2,4);
                pos(3,:) = pos(1,:); pos(3,1) = pos(3,1)+pos(3,3);
                pos(4,:) = pos(3,:);
                pos(4,2) = pos(4,2)-pos(4,4);
        else
                pos(1,3) = (2*pos(1,3))/3;
                pos(2,:) = pos(1,:); pos(2,1) = pos(2,1)+pos(2,3);
                pos(3,:) = pos(2,:); pos(3,1) = pos(3,1)+pos(3,3);
                pos(4,:) = pos(1,:);
                pos(4,3) = 3*pos(4,3);
                pos(4,2) = pos(4,2)-pos(4,4);
        end

        dw2darro('vis_arrow',win_dw2dtool,'off');

        % Cleaning Selection.
        %--------------------
        dw2dimgs('clean',win_dw2dtool);

        % Drawing.
        %---------
        dw2dmngr('set_graphic',win_dw2dtool,option);

        set([txt_full,pus_full],'Visible','off');
        for k=1:4 , set(pus_full(k),'Position',pos(k,:)); end
        pos_txt = get(txt_full,'Position');
        if val==square_viewm
                hdl_on = [txt_full,pus_full];
                pos_txt(2) = pos(1,2)-pos(1,4)/2;
        else
                hdl_on = [txt_full,pus_full(1:3)];
                pos_txt(2) = pos(1,2);
        end
        set(txt_full,'Position',pos_txt);
        set(hdl_on,'Visible','on');

        if val==square_viewm
                dw2darro('vis_arrow',win_dw2dtool,'on');
        end

        % End waiting.
        %-------------
        wwaiting('off',win_dw2dtool);

%**************************%
%** OPTION = 'fullsize'  **%
%**************************%
elseif strcmp(option,'fullsize')
        % in3 = btn number. 
        %------------------

        % Begin waiting.
        %--------------
        wwaiting('msg',win_dw2dtool,'Wait ... drawing');

        % Getting active option.
        %------------------------
        active_option = wmemtool('rmb',win_dw2dtool,n_param_anal,...
                                                        ind_act_option);

        % Test begin or end.
        %-------------------
        num             = in3;
        btn             = pus_full(num);
        act             = get(btn,'Userdata');
        if act==0
                % begin full size
                %----------------
                dw2darro('vis_arrow',win_dw2dtool,'off');
                param = 'beg';
                for k=1:length(pus_full)
                        act_old = get(pus_full(k),'Userdata');
                        if act_old==1
                                other_btn = pus_full(length(pus_full)+1-k);
                                old_col = get(other_btn,'Backgroundcolor');
                                set(pus_full(k),...
                                        'Backgroundcolor',old_col,      ...
                                        'String',int2str(k),            ...
                                        'Userdata',0);  
                                break;
                        end
                end
                set(btn,'Backgroundcolor',Def_TxtBkColor,       ...
                        'String',['end ' int2str(num)],         ...
                        'Userdata',1);

                % Changing View Status.
                %----------------------
                view_status = wmemtool('rmb',win_dw2dtool,n_miscella,...
                                                ind_view_status);
                if view_status(1)~='f'
                        wmemtool('wmb',win_dw2dtool,n_miscella,...
                                        ind_save_status,view_status);
                end
                view_status     = ['f' int2str(num) 'l' ...
                                        int2str(get(pop_declev,'value'))];
                wmemtool('wmb',win_dw2dtool,n_miscella,...
                                        ind_view_status,view_status);

        else
                % end full size.
                %---------------
                other_btn = pus_full(length(pus_full)+1-num);
                old_col = get(other_btn,'Backgroundcolor');
                param = 'end';
                set(btn,'Backgroundcolor',old_col,      ...
                        'String',int2str(num),          ...
                        'Userdata',0);
        end

        % Setting enabled values.
        %------------------------
        if strcmp(param,'end')
                ena = 'on';
                handles = [     pus_anal,                       ...
                                pop_declev,                     ...
                                pus_visu,       pus_big,        ...
                                pus_rec,        pop_viewm       ...
                                ];
        elseif find(num==[1 2 3])
                ena_val = 0;
                ena = 'off';
                handles = [     pus_anal,                       ...
                                pop_declev,                     ...
                                pus_visu,       pus_big,        ...
                                pus_rec,        pop_viewm       ...
                                ];
        elseif num==4
                ena = 'off';
                handles = [     pus_anal,                       ...
                                pus_visu,       pus_big,        ...
                                pus_rec,        pop_viewm       ...
                                ];
        end

        % Drawing.
        %---------
        if strcmp(ena,'off') , set(handles,'Enable',ena); end
        dw2dmngr('set_graphic',win_dw2dtool,option,param);
        if strcmp(ena,'on')
                set(handles,'Enable',ena);
        elseif num==4
                set(pop_declev,'Enable','On');
        end
        val = get(pop_viewm,'Value');
        if (val==square_viewm) & strcmp(param,'end')
                dw2darro('vis_arrow',win_dw2dtool,'on');
        end

        % End waiting.
        %-------------
        wwaiting('off',win_dw2dtool);

%*************************%
%** OPTION = 'stat' -   **%
%*************************%
elseif strcmp(option,'stat')
        mousefrm(0,'watch');
        drawnow;
        out1 = feval('dw2dstat','create',win_dw2dtool);

%*************************%
%** OPTION = 'hist' -   **%
%*************************%
elseif strcmp(option,'hist')
        mousefrm(0,'watch');
        drawnow;
        out1 = feval('dw2dhist','create',win_dw2dtool);

%*************************%
%** OPTION = 'comp' -   **%
%*************************%
elseif strcmp(option,'comp')
        mousefrm(0,'watch');
        drawnow;
        dw2dutil('enable',win_dw2dtool,option);
        out1 = feval('dw2dcomp','create',win_dw2dtool);

%*************************%
%** OPTION = 'deno' -   **%
%*************************%
elseif strcmp(option,'deno')
        mousefrm(0,'watch');
        drawnow;
        dw2dutil('enable',win_dw2dtool,option);
        out1 = feval('dw2ddeno','create',win_dw2dtool);

%*********************************************%
%** OPTION = 'return_comp' or 'return_deno' **%
%*********************************************%
elseif strcmp(option,'return_comp') | strcmp(option,'return_deno')
        % in3 = 1 : preserve compression
        % in3 = 0 : discard compression
        % in4 = hdl_img (optional)
        %--------------------------------------

        if in3==1

                % Begin waiting.
                %--------------
                wwaiting('msg',win_dw2dtool,'Wait ... computing');

                if strcmp(option,'return_comp')
                        arro_txt = 'comp';      t_simg = 'cs';
                        xlab_str = 'Compressed Image';
                else
                        arro_txt = 'deno';      t_simg = 'ds';
                        xlab_str = 'De-noised Image';
                end
                wmemtool('wmb',win_dw2dtool,n_param_anal,       ...
                                ind_simg_type,t_simg            ...
                                );

                [Wave_Name,Img_Size,NB_ColorsInPal] = ...
                        wmemtool('rmb',win_dw2dtool,n_param_anal,...
                                        ind_wav_name,ind_img_size,ind_nbcolors);

                % Drawing Synthesized Image.
                %--------------------------
                view_status     = wmemtool('rmb',win_dw2dtool,n_miscella,...
                                                        ind_view_status);
                view_mode       = view_status(1);

                if (view_mode=='f') & (view_status(2)~='2')
                        vis = 'Off';
                else
                        vis = 'on';
                end
                if (view_mode=='s')
                        vis_ar = 'On';
                else
                        vis_ar = 'Off';
                end
                xlim = get(Axe_ImgIni,'Xlim');
                ylim = get(Axe_ImgIni,'Ylim');
                axes(Axe_ImgSyn);
                image(...
                        [1 Img_Size(1)],[1 Img_Size(2)],        ...
                        wimgcode('cod',0,get(in4,'Cdata'),NB_ColorsInPal,codemat_v),    ...
                        'Visible',vis                           ...
                        );
                col = get(get(Axe_ImgSyn,'xlabel'),'Color');
                set(Axe_ImgSyn,...
                                'Visible',vis,                          ...
                                'XTicklabelMode','manual',              ...
                                'YTicklabelMode','manual',              ...
                                'XTickLabels',[],'YTickLabels',[],      ...
                                'Xlim',xlim,'Ylim',ylim,                ...
                                'Box','On',                             ...
                                'Tag',tag_axeimgsyn                     ...
                                );
                title(xlab_str,'Color',col,'Visible',vis);

                dw2darro('vis_arrow',win_dw2dtool,vis_ar,arro_txt);
               
                % End waiting.
                %-------------
                wwaiting('off',win_dw2dtool);
        end
        dw2dutil('enable',win_dw2dtool,option);

%******************************%
%** OPTION = 'set_graphic' - **%
%******************************%
elseif strcmp(option,'set_graphic')
        % in3 = calling option.
        %  if in3 = 'fullsize' :
        %       in4 = 'beg' or 'end'.
        %  if in3 = 'select' :
        %       in4 = 'beg' or 'end'.
        %-----------------------------

        % Getting Analysis parameters.
        %-----------------------------
        [Img_Size,Level_Anal] = wmemtool('rmb',win_dw2dtool,n_param_anal,...
                                        ind_img_size,ind_lev_anal);
        level_view      = get(pop_declev,'Value');

        % Getting Axes handles.
        %----------------------
        Axe_ImgDec      = wmemtool('get',win_dw2dtool,tag_axeimgdec);
        Img_Handles     = wmemtool('get',win_dw2dtool,tag_axeimghdls);

        % Getting position parameters.
        %-----------------------------
        [       pos,pos_axeini,pos_axevis,pos_axesel,   ...
                pos_axesyn,pos_axebig,pos_axedec,view_status,save_status] = ...
                        wmemtool('rmb',win_dw2dtool,n_miscella, ...
                                                ind_graph_area,         ...
                                                ind_pos_axeini,         ...
                                                ind_pos_axevis,         ...
                                                ind_pos_axesel,         ...
                                                ind_pos_axesyn,         ...
                                                ind_pos_axebig,         ...
                                                ind_pos_axedec,         ...
                                                ind_view_status,        ...
                                                ind_save_status         ...
                                                );
        k               = findstr(save_status,'l');
        lev_view_old    = str2num(save_status(k+1:length(save_status)));


        % Setting options.
        %-----------------
        obj_sel = [];
        if      strcmp(in3,'fullsize')
                if strcmp(in4,'beg')
                        view_attrb      = 10+str2num(view_status(2));
                else
                        view_status     = save_status;
                        wmemtool('wmb',win_dw2dtool,n_miscella,...
                                                ind_view_status,view_status);
                        if view_status(1)=='s'
                                view_attrb      = 5;
                        elseif  view_status(1)=='t'
                                view_attrb      = 6;
                        end
                        obj_sel = dw2dimgs('get',win_dw2dtool);
                end

        elseif  strcmp(in3,'select')    % end big_image
                view_status     = save_status;
                wmemtool('wmb',win_dw2dtool,n_miscella,...
                                        ind_view_status,view_status);
                if view_status(1)=='s'
                        view_attrb      = 5;
                elseif  view_status(1)=='t'
                        view_attrb      = 6;
                end
                obj_sel = dw2dimgs('get',win_dw2dtool);

        elseif  strcmp(in3,'view_dec')
                save_status     = [save_status(1:k) int2str(level_view)];
                wmemtool('wmb',win_dw2dtool,n_miscella,...
                                        ind_save_status,save_status);

                if      view_status(1)=='s'
                        view_attrb      = 3;
                elseif  view_status(1)=='f'
                        view_attrb      = 3;
                elseif  view_status(1)=='t'
                        view_attrb      = 4;
                end

        elseif  strcmp(in3,'view_mode')
                if      view_status(1)=='s'
                        view_attrb      = 5;
                elseif  view_status(1)=='t'
                        view_attrb      = 6;
                end
        end

        % Computing axes positions.
        %--------------------------
        if view_status(1)=='t'
                % Getting position parameters.
                %-----------------------------
                term_dim        = Terminal_Prop;
                [xpixl,ypixl]   = wfigutil('prop_size',win_dw2dtool,1,1);

                % View boundary parameters.
                %--------------------------
                mx = 0.73;      my = 0.70;

                x_marge = 0.05;
                x_left  = pos(1)+x_marge;
                width   = pos(3)-x_marge;
                NBL     = level_view+1; NBC     = 4;
                w_theo  = width/NBC;    h_theo  = pos(4)/NBL;
                w_pos = w_theo*mx;      h_pos = h_theo*my;
                X_cent = x_left+(w_theo/2)*[1:2:2*NBC-1];
                Y_cent = pos(2)+(h_theo/2)*[1:2:2*NBL-1];
                alpha = (term_dim(2)*h_pos*Img_Size(1))/...
                        (term_dim(1)*w_pos*Img_Size(2));
                w_used  = w_pos*min(1,alpha);
                h_used  = h_pos*min(1,1/alpha);

                dy      = (h_theo-h_used)/2;
                for k = 2:NBL-1
                        Y_cent(k) = Y_cent(k)-(k-1)*dy;
                end
                if NBL>Level_Anal-2
                        Y_cent(NBL) = Y_cent(NBL)-(level_view*dy)/(NBL-1);
                end

                % Correction : Y-Shift
                %---------------------
                if level_view>max_lev_anal-2
                        Y_cent(1:NBL-1) = Y_cent(1:NBL-1)+25*ypixl;
                        bdy     = 3*ypixl;
                else
                        bdy     = 0*ypixl;
                end

                w_u2    = w_used/2;     h_u2    = h_used/2;
                pos_axeini = [  X_cent(1)-w_u2  ,Y_cent(NBL)-h_u2       ,...
                                w_used          ,h_used                 ];
                pos_axesyn = [  X_cent(2)-w_u2  ,Y_cent(NBL)-h_u2       ,...
                                w_used          ,h_used                 ];
                pos_axevis = [  X_cent(3)       ,Y_cent(NBL)-h_u2       ,...
                                w_used          ,h_used                 ];

                bdy     = 0*ypixl;
                xl      = pos(1)+20*xpixl;
                wa      = pos(3)-40*xpixl;
                yd      = Y_cent(1)-h_u2-bdy;
                ha      = Y_cent(NBL-1)-Y_cent(1)+h_used+bdy;

                Screen_size = get(0,'ScreenSize');
                if (Screen_size(4)<700) 
                        dyd  = 10*ypixl;
                        ha = ha+dyd; 
                        yd = yd-dyd;
                end

                pos_axesel = [xl yd wa ha];

                max_l   = max_lev_anal+1;
                l_Xdata = zeros(max_l,2);
                l_Ydata = zeros(max_l,2);
                for k = 1:level_view
                        for l = 1:4
                                ind = 4*(level_view-k+1)+1-l;
                                pos_axedec(ind,:) = [   X_cent(l)-w_u2  ,...
                                                        Y_cent(k)-h_u2  ,...
                                                        w_used          ,...
                                                        h_used  ];
                        end
                        l_Xdata(k,:) = [X_cent(1) X_cent(NBC)];
                        l_Ydata(k,:) = [Y_cent(k) Y_cent(k)];
                end
                l_Xdata(max_l,:) = [    X_cent(1),      X_cent(1)];
                l_Ydata(max_l,:) = [    Y_cent(NBL),    Y_cent(1)];
                
                x_left_txt = pos_axeini(1)-0.035;
        end

        max_a   = 4*Level_Anal;
        max_v   = 4*level_view;
        all_ind = [1:max_a];
        rem_4   = rem(all_ind,4);
        if      view_status(1)=='s'
                vis_ini = 'on';         vis_vis = 'on';
                vis_sel = 'on';         vis_syn = 'on';
                vis_big = 'off';
                ind_On  = [find(all_ind<max_v & rem_4~=0) , max_v];
                ind_Off = [find(all_ind<max_v & rem_4==0) , ...
                                        find(all_ind>max_v)];

        elseif  view_status(1)=='t'
                vis_ini = 'on';         vis_vis = 'on';
                vis_sel = 'on';         vis_syn = 'on';
                vis_big = 'off';
                ind_On  = 1:max_v;      ind_Off = max_v+1:max_a;

        elseif  view_status(1)=='f'
                if      view_status(2)=='1'
                        pos_axeini = pos_axebig;
                        vis_ini = 'on';         vis_vis = 'off';
                        vis_sel = 'off';        vis_syn = 'off';
                        vis_big = 'off';
                        ind_On  = [];           ind_Off = all_ind;

                elseif  view_status(2)=='2'
                        pos_axesyn = pos_axebig;
                        vis_ini = 'off';        vis_vis = 'off';
                        vis_sel = 'off';        vis_syn = 'on';
                        vis_big = 'off';
                        ind_On  = [];           ind_Off = all_ind;

                elseif  view_status(2)=='3'
                        pos_axevis = pos_axebig;
                        vis_ini = 'off';        vis_vis = 'on';
                        vis_sel = 'off';        vis_syn = 'off';
                        vis_big = 'off';
                        ind_On  = [];           ind_Off = all_ind;

                elseif  view_status(2)=='4'
                        pos_axesel      = pos_axebig;
                        xl              = pos_axesel(1);
                        yb              = pos_axesel(2);
                        la              = pos_axesel(3)/2;
                        ha              = pos_axesel(4)/2;
                        ind = 1;
                        for k = 1:max_lev_anal
                                pos_axedec(ind:ind+3,1:4)       = ...
                                        [       xl      ,yb     ,la     ,ha;
                                                xl+la   ,yb     ,la     ,ha;
                                                xl+la   ,yb+ha  ,la     ,ha;
                                                xl      ,yb+ha  ,la     ,ha ...
                                        ];
                                ind = ind+4;
                                yb  = yb+ha;    la  = la/2;     ha  = ha/2;
                        end

                        vis_ini = 'off';        vis_vis = 'off';
                        vis_sel = 'on';         vis_syn = 'off';
                        vis_big = 'off';
                        ind_On  = [find(all_ind<max_v & rem_4~=0) , max_v];
                        ind_Off = [find(all_ind<max_v & rem_4==0) , ...
                                        find(all_ind>max_v)];

                end
        end     

        % Setting graphic area.
        %----------------------
        axe_figutil     = findobj(axe_handles,'Tag',tag_axefigutil);
        t_lines         = findobj(axe_figutil,'type','line','Tag',tag_linetree);
        t_txt           = findobj(axe_figutil,'type','text','Tag',tag_txttree);

        set([t_lines' t_txt'],'Visible','off'); 
        set(Img_Handles,'Visible','Off');

        ind = 4*lev_view_old;
        delete([...
                get(Axe_ImgDec(ind),'Xlabel'),...
                get(Axe_ImgDec(ind-1),'Xlabel'),...
                get(Axe_ImgDec(ind-2),'Xlabel'),...
                get(Axe_ImgDec(ind-3),'Xlabel'),...
                ]);
        if      view_status(1)=='f'
                if      view_status(2)=='1'
                        set(Axe_ImgIni,'Position',pos_axeini);
                elseif  view_status(2)=='2'
                        set(Axe_ImgSyn,'Position',pos_axesyn);
                elseif  view_status(2)=='3'
                        set(Axe_ImgVis,'Position',pos_axevis);
                elseif  view_status(2)=='4'
                        set(Axe_ImgSel,'Position',pos_axesel);
                        for k = 1:4*max_lev_anal
                                set(Axe_ImgDec(k),'Position',pos_axedec(k,:));
                        end
                end
        elseif  view_status(1)=='s' | view_status(1)=='t'
                set(Axe_ImgIni,'Position',pos_axeini);
                set(Axe_ImgVis,'Position',pos_axevis);
                set(Axe_ImgSyn,'Position',pos_axesyn);
                set(Axe_ImgSel,'Position',pos_axesel);
                for k = 1:4*max_lev_anal
                        set(Axe_ImgDec(k),'Position',pos_axedec(k,:));
                end
        end
        mngaxe('vis',Axe_ImgIni,vis_ini);
        mngaxe('vis',Axe_ImgVis,vis_vis);
        mngaxe('vis',Axe_ImgSyn,vis_syn);
        mngaxe('vis',Axe_ImgSel,vis_sel);
        mngaxe('vis',Axe_ImgBig,vis_big);
        s_font = Def_AxeFontSize;
        if view_status(1)=='t'
                bdy = 18;
                strxlab = ['Decomposition at level ' int2str(level_view)];
                box_str = ['Image Selection : ' strxlab];
                wboxtitl('set',Axe_ImgSel,box_str,...
                                s_font,9,10,bdy,vis_sel);
        else
                bdy = 18;
                box_str = 'Image Selection';
                wboxtitl('set',Axe_ImgSel,box_str,s_font,9,18,bdy,vis_sel);
        end

        if      view_attrb==3

        elseif  view_attrb==4
                for k = [1:level_view,max_lev_anal+1]
                        l = findobj(t_lines,'Type','line','Userdata',k);
                        set(l,...
                                'Xdata',l_Xdata(k,:),   ...
                                'Ydata',l_Ydata(k,:),   ...
                                'Visible','On'          ...
                                );
                end
                for k = [1:level_view]
                        txt = findobj(t_txt,'Type','text','Userdata',k);
                        j = level_view+1-k;
                        set(txt,...
                                'Position',[x_left_txt ,l_Ydata(j,1)], ...
                                'Visible','On'                          ...
                                );
                end
                set(Axe_ImgSel,'Visible','Off');

        elseif  view_attrb==5
                set([Axe_ImgDec,Axe_ImgIni,Axe_ImgVis,Axe_ImgSel,Axe_ImgSyn],...
                                'Visible','off');
                ind = 4*level_view;
                delete([...
                        get(Axe_ImgDec(ind),'Xlabel'),  ...
                        get(Axe_ImgDec(ind-1),'Xlabel'),...
                        get(Axe_ImgDec(ind-2),'Xlabel'),...
                        get(Axe_ImgDec(ind-3),'Xlabel') ...
                        ]);

        elseif  view_attrb==6
                set([Axe_ImgDec,Axe_ImgIni,Axe_ImgVis,Axe_ImgSel,Axe_ImgSyn],...
                                'Visible','off');
                for k = [1:level_view,max_lev_anal+1]
                        l = findobj(t_lines,'Type','line','Userdata',k);
                        set(l,...
                                'Xdata',l_Xdata(k,:)    ,...
                                'Ydata',l_Ydata(k,:)    ,...
                                'Visible','On'          ...
                                );
                end
                for k = [1:level_view]
                        txt = findobj(t_txt,'Type','text','Userdata',k);
                        j = level_view+1-k;
                        set(txt,...
                                'Position',[x_left_txt ,l_Ydata(j,1)],  ...
                                'Visible','On'                          ...
                                );
                end
        end

        if find(view_attrb==[5 6])
                if view_attrb==5
                        set(Axe_ImgIni,...
                                'Visible','on',                         ...
                                'Box','On');
                else
                        set(Axe_ImgIni,...
                                'Visible','on',                         ...
                                'XTicklabelMode','manual',              ...
                                'YTicklabelMode','manual',              ...
                                'XTickLabels',[],'YTickLabels',[],      ...
                                'XTick',[],'YTick',[],                  ...
                                'Box','On');

                end

                set(Axe_ImgDec(ind_On),...
                                'Visible','on',...
                                'Xcolor',Col_BoxAxeSel,                 ...
                                'Ycolor',Col_BoxAxeSel,                 ...
                                'XTicklabelMode','manual',              ...
                                'YTicklabelMode','manual',              ...
                                'XTickLabels',[],'YTickLabels',[],      ...
                                'XTick',[],'YTick',[],'Box','On'        ...
                                );

                if ~isempty(obj_sel)
                        axe = get(obj_sel,'parent');
                        set(axe,...
                                'Xcolor',BoxTitleSel_Col,       ...
                                'Ycolor',BoxTitleSel_Col,       ...
                                'LineWidth',Width_LineSel,      ...
                                'Box','On'                      ...
                                );
                end
                                       
                set(Axe_ImgVis,...
                                'Visible','on',                         ...
                                'XTicklabelMode','manual',              ...
                                'YTicklabelMode','manual',              ...
                                'XTickLabels',[],'YTickLabels',[],      ...
                                'Xcolor',BoxTitleSel_Col,               ...
                                'Ycolor',BoxTitleSel_Col,               ...
                                'LineWidth',Width_LineSel,              ...
                                'Box','On'                              ...
                                );
                set(Axe_ImgSyn,...
                                'Visible','on',                         ...
                                'XTicklabelMode','manual',              ...
                                'YTicklabelMode','manual',              ...
                                'XTickLabels',[],'YTickLabels',[],      ...
                                'Box','On'                              ...
                                );
  
        end

        if find(view_attrb==[3 4 5 6 11 12 13 14])
                set(Img_Handles(ind_On),'Visible','On');
                set(Axe_ImgDec(ind_On),'Visible','On');
                if ~isempty(ind_Off)
                        set(Img_Handles(ind_Off),'Visible','Off');
                        set(Axe_ImgDec(ind_Off),'Visible','Off');
                end
        end

        if find(view_attrb==[4 5 6])
                if view_attrb~=5
                        strxlab = '';
                else
                        strxlab = ['Decomposition at level ' ...
                                                 int2str(level_view)];
                end
                wsetxlab(Axe_ImgSel,strxlab,-10);
        end
        if find(view_attrb==[4 6])
                ind = 4*level_view;
                col_lab = get(win_dw2dtool,'DefaultAxesXColor');
                % col_lab = Col_BoxAxeSel;
                drawnow
                wsetxlab(Axe_ImgDec(ind),'Approximations',-10,col_lab);
                wsetxlab(Axe_ImgDec(ind-1),'Horizontal Details',-10,col_lab);
                wsetxlab(Axe_ImgDec(ind-2),'Diagonal Details',-10,col_lab);
                wsetxlab(Axe_ImgDec(ind-3),'Vertical Details',-10,col_lab);
        end
        if find(view_attrb==[3 14])
                strxlab = ['Decomposition at level ' int2str(level_view)];
                wsetxlab(Axe_ImgSel,strxlab,-10);
        end

%*****************************************************%
%** OPTION = 'mode_sel' -  Changing selection mode. **%
%*****************************************************%
elseif strcmp(option,'mode_sel')
        % Getting Select Function.
        %------------------------
        select_funct    = wmemtool('rmb',win_dw2dtool,n_miscella,ind_sel_funct);
        if      in3==1 & strcmp(select_funct,drag_funct) , return;
        elseif  in3==0 & strcmp(select_funct,boxsel_funct), return;
        end
        old_cba_big     = get(pus_big,'Callback');
        cba_pus_big1    = '';
        cba_pus_big2    = ['dw2dmngr(''select'','       ...
                                str_numwin ','          ...
                                num2mstr(pus_big) ');'];
        if in3==1 % drag mode
                % Cleaning Selection.
                %--------------------
                dw2dimgs('clean',win_dw2dtool);

                select_funct    = drag_funct;
                cba_pus_visu    = '';
                cba_pus_big     = cba_pus_big1;
                cba_pus_rec     = '';
        else
                cba_pus_visu = ['dw2dmngr(''select'','  ...
                                str_numwin ','          ...
                                num2mstr(pus_visu) ');'];
                cba_pus_big     = cba_pus_big2;
                cba_pus_rec  = ['dw2dmngr(''select'','  ...
                                str_numwin ','          ...
                                num2mstr(pus_rec) ');'];
                select_funct    = boxsel_funct;
        end

        if      ~strcmp(old_cba_big,cba_pus_big1) & ...
                ~strcmp(old_cba_big,cba_pus_big2)
                cba_pus_big     = old_cba_big;
        end
        set(pus_visu,'Callback',cba_pus_visu);
        set(pus_big,'Callback',cba_pus_big);
        set(pus_rec,'Callback',cba_pus_rec);
        wmemtool('wmb',win_dw2dtool,n_miscella,ind_sel_funct,select_funct);
        Img_Dec = findobj(win_dw2dtool,'type','image','tag',tag_imgdec);
        set(Img_Dec,'ButtonDownFcn',select_funct);

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('dw2dmngr','Unknown Option','msg');
        error('*');
end
