function out1 = dw2drwcd(option,win_dw2dtool)
%DW2DRWCD Discret wavelet 2D read_write cdata for image.
%       out1 = dw2drwcd(option,win_dw2dtool)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:09:40 $

% Tag property of objects.
%-------------------------
tag_axeimgini   = 'Axe_ImgIni';
tag_axeimgsyn   = 'Axe_ImgSyn';

numfig  = int2str(win_dw2dtool);

%***********************************************%
%** OPTION = 'r_orig' -  Read Original Image. **%
%***********************************************%
if      strcmp(option,'r_orig')
        axe_handles     = findobj(win_dw2dtool,'Type','axes');
        Axe_ImgIni      = findobj(axe_handles,'flat','Tag',tag_axeimgini);
        out1            = findobj(Axe_ImgIni,'type','image');

%**************************************************%
%** OPTION = 'r_synt' -  Read Synthesized Image. **%
%**************************************************%
elseif strcmp(option,'r_synt')
        axe_handles     = findobj(win_dw2dtool,'Type','axes');
        Axe_ImgSyn      = findobj(axe_handles,'flat','Tag',tag_axeimgsyn);
        out1            = findobj(Axe_ImgSyn,'type','image');

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('dw2drwcd','Unknown Option','msg');
        error('*');
end
