function out1 = dw2dstat(option,in2,in3,in4,in5,in6,in7,in8)
%DW2DSTAT Discret wavelet 2D statistics.
%       out1 = dw2dstat(option,in2,in3,in4,in5,in6,in7,in8)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.

%       Uses WMEMTOOL.

global  Def_Btn_Height  Def_Btn_Width   ...
        Pop_Min_Width   X_Graph_Ratio   ...
        X_Spacing       Y_Spacing       ...
        Def_TxtBkColor  Def_EdiBkColor  ...
        Def_FraBkColor  Def_FraFgColor

if nargin==0, option = 'create'; end

% Image Coding Value.
%-------------------
codemat_v       = wimgcode('get');

% MemBloc1 of stored values.
%---------------------------
n_param_anal    = 'DWAn2d_Par_Anal';
ind_img_name    =  1;
ind_wav_name    =  2;
ind_lev_anal    =  3;
ind_img_t_name  =  4;
ind_img_size    =  5;
ind_nbcolors    =  6;
ind_act_option  =  7;
ind_simg_type   =  8;
nb1_stored      =  8;

% MemBloc2.1 and 2.2 of stored values.
%------------------------------------
n_coefs         = 'MemCoefs';
n_sizes         = 'MemSizes';

% MemBloc3 of stored values.
%---------------------------
n_miscella      = 'DWStat2D_Misc';
ind_curr_img    = 1;
ind_curr_color  = 2;
nb3_stored      = 2;

% Tag property of objects.
%-------------------------
tag_appdet_txt  = 'Appdet_Txt';
tag_appdet_val  = 'Appdet_Val';
tag_detdir_val  = 'Detdir_Val';
tag_sel_cfs     = 'Sel_Cfs';
tag_sel_rec     = 'Sel_Rec';
tag_orig_img    = 'Orig_img';
tag_synt_img    = 'Synt_img';
tag_app_img     = 'App_img';
tag_det_img     = 'Det_img';
tag_bins_txt    = 'Bins_Txt';
tag_bins_data   = 'Bins_Data';
tag_levels      = 'Levels';
tag_mean_val    = 'Mean_Val';
tag_med_val     = 'Med_Val';
tag_mode_val    = 'Mode_Val';
tag_max_val     = 'Max_Val';
tag_min_val     = 'Min_Val';
tag_range_val   = 'Range_Val';
tag_std_val     = 'Std_Val';
tag_mad_val     = 'Mad_Val';
tag_madm_val    = 'Madm_Val';
tag_ax_image    = 'Ax_Image';
tag_ax_hist     = 'Ax_Hist';
tag_ax_cumhist  = 'Ax_Cumhist';
tag_show_stat   = 'Show_Stat';

%*****************************************************************%
%** OPTION = 'create' - constructs the initial dw2dstat window  **%
%*****************************************************************%
if strcmp(option,'create')

        % Calling figure.
        %----------------
        win_dw2dtool     = in2;
        str_win_dw2dtool = int2str(win_dw2dtool);

        % Window initialization.
        %----------------------
        win_name = 'Wavelet 2-D  --  Statistics';
        [win_dw2dstat,pos_win,cba_close_menu] = ...
                wfigcrea('create',NaN,win_name,'',win_dw2dtool,...
                        str2mat('-p','-0','-w'),'dw2dstat');
        str_numwin = int2str(win_dw2dstat);
        win_units  = 'pixels';
        out1       = win_dw2dstat;

        % Command frame and Dynamical visualization tool construction.
        %-------------------------------------------------------------
        [frame0,pos_frame0,Pos_Graphic_Area] = ...
                        wfigcrea('frame',win_dw2dstat,'','title');

        % Waiting Frame construction & begin waiting.
        %--------------------------------------------
        wwaiting('create',win_dw2dstat,X_Graph_Ratio,...
                        'Wait ... initialization');

        % Getting global variables from dw2dtool figure memory block.
        %------------------------------------------------------------
        [Img_Name,Img_Size,NB_ColorsInPal,Wav_Name,Lev_Anal] = ...
        wmemtool('rmb',win_dw2dtool,n_param_anal,       ...
                                ind_img_name,           ...
                                ind_img_size,           ...
                                ind_nbcolors,           ...
                                ind_wav_name,           ...
                                ind_lev_anal            ...
                                );
        [Wav_Fam,Wav_Num] = wavattrb('fam_num',Wav_Name);

        % General graphical parameters initialization.
        %--------------------------------------------

        % Borders and double borders.
        dx  = X_Spacing;  dx2 = 2*dx;
        dy  = Y_Spacing;  dy2 = 2*dy;

        % X init position and width of frames.
        gra_width       = Pos_Graphic_Area(3);
        x_frame0        = pos_frame0(1);
        cmd_width       = pos_frame0(3);
        h_frame0        = pos_frame0(4);

        % Buttons width
        push_width      = (cmd_width-4*dx)/2;
        txt_width       = Def_Btn_Width;
        pop_width       = Pop_Min_Width;

        % Parameters initialization.
        %---------------------------
        default_bins    = 50;

        % Position property of objects.
        %------------------------------
        Screen_Size = get(0,'ScreenSize');
        if      Screen_Size(4)<700
                chk_heigth      = Def_Btn_Height;
                dy_chk          = Def_Btn_Height/2;
        else
                chk_heigth      = 3*Def_Btn_Height/2;
                dy_chk          = Def_Btn_Height/2;
        end

        pos_input_txt   = [     x_frame0+dx2                            ,...
                                h_frame0-3*dy-Def_Btn_Height            ,...
                                txt_width                               ,...
                                Def_Btn_Height                          ];
        pos_input_data  = [     pos_input_txt(1)+pos_input_txt(3)+dx    ,...
                                pos_input_txt(2)                        ,...
                                2*pop_width                             ,...
                                Def_Btn_Height                          ];
        pos_wav_txt     = pos_input_txt;
        pos_wav_txt(2)  = pos_input_txt(2)-Def_Btn_Height-dy2;
        pos_wav_fams    = [     pos_wav_txt(1)+pos_wav_txt(3)+dx        ,...
                                pos_wav_txt(2)                          ,...
                                pop_width                               ,...
                                Def_Btn_Height                          ];
        pos_wav_nums    = [     pos_wav_fams(1)+pos_wav_fams(3)+dx/2    ,...
                                pos_wav_fams(2)                         ,...
                                pop_width-dx/2                          ,...
                                Def_Btn_Height                          ];
        pos_lev_txt     = pos_wav_txt;
        pos_lev_txt(2)  = pos_wav_txt(2)-Def_Btn_Height-dy2;
        pos_lev_data    = [     pos_lev_txt(1)+pos_lev_txt(3)+dx        ,...
                                pos_lev_txt(2)                          ,...
                                pop_width                               ,...
                                Def_Btn_Height                          ];

        px              = x_frame0+(cmd_width-7*push_width/4)/2;
        pos_orig_img    = [     px                                      ,...
                                pos_lev_txt(2)-Def_Btn_Height-10*dy     ,...
                                7*push_width/4                          ,...
                                chk_heigth                              ];
        pos_synt_img    = [     px                                      ,...
                                pos_orig_img(2)-chk_heigth-dy_chk       ,...
                                7*push_width/4                          ,...
                                chk_heigth                              ];
        pos_app_img     = [     px                                      ,...
                                pos_synt_img(2)-chk_heigth-dy_chk       ,...
                                7*push_width/4                          ,...
                                chk_heigth                              ];
        pos_det_img     = [     px                                      ,...
                                pos_app_img(2)-chk_heigth-dy_chk        ,...
                                7*push_width/4                          ,...
                                chk_heigth                              ];
        pos_close       = [     px                                      ,...
                                pos_frame0(2)+Def_Btn_Height            ,...
                                7*push_width/4                          ,...
                                3*Def_Btn_Height/2                      ];
        px              = x_frame0+(cmd_width-3*push_width/2)/2;
        pos_appdet_txt  = [     px                                      ,...
                                pos_det_img(2)-3*Def_Btn_Height/2       ,...
                                3*push_width/2                          ,...
                                Def_Btn_Height                          ];
        pos_appdet_val  = [     px                                      ,...
                                pos_appdet_txt(2)-3*Def_Btn_Height/2    ,...
                                3*push_width/2                          ,...
                                Def_Btn_Height                          ];
        pos_detdir_val  = [     px                                      ,...
                                pos_appdet_val(2)-3*Def_Btn_Height/2    ,...
                                3*push_width/2                          ,...
                                Def_Btn_Height                          ];
        px              = x_frame0+(cmd_width-5*push_width/4)/2;
        pos_sel_cfs     = [     px                                      ,...
                                pos_detdir_val(2)-2*Def_Btn_Height      ,...
                                5*push_width/4                          ,...
                                Def_Btn_Height                          ];
        pos_sel_rec     = [     pos_sel_cfs(1)                          ,...
                                pos_sel_cfs(2)-3*Def_Btn_Height/2       ,...
                                5*push_width/4                          ,...
                                Def_Btn_Height                          ];
        px              = x_frame0+(cmd_width-3*pop_width)/2;
        pos_bins_txt    = [     px                                      ,...
                                pos_sel_rec(2)-2*Def_Btn_Height         ,...
                                2*pop_width                             ,...
                                Def_Btn_Height                          ];
        pos_bins_data   = pos_bins_txt;
        pos_bins_data(1)= pos_bins_txt(1)+pos_bins_txt(3)+dx;
        pos_bins_data(3)= pop_width;

        px              = x_frame0+(cmd_width-3*push_width/2)/2;
        pos_show_stat   = [     px                                      ,...
                                pos_bins_data(2)-3*Def_Btn_Height       ,...
                                3*push_width/2                          ,...
                                2*Def_Btn_Height                        ];
        h_frame1        = 3*Def_Btn_Height+8*dy;
        pos_frame1      = [     dx2                                     ,...
                                dy2                                     ,...
                                gra_width-2*dx2                         ,...
                                h_frame1                                ];

        wx              = (pos_frame1(3)-4*dx)/8;
        pos_mean_txt    = [     pos_frame1(1)+dx                        ,...
                                pos_frame1(2)+h_frame1-Def_Btn_Height-dy2,...
                                4*wx/5                                  ,...
                                Def_Btn_Height                          ];
        pos_med_txt     = [     pos_mean_txt(1)                         ,...
                                pos_mean_txt(2)-Def_Btn_Height-dy2      ,...
                                4*wx/5                                  ,...
                                Def_Btn_Height                          ];
        pos_mode_txt    = [     pos_mean_txt(1)                         ,...
                                pos_med_txt(2)-Def_Btn_Height-dy2       ,...
                                4*wx/5                                  ,...
                                Def_Btn_Height                          ];
        px              = pos_mean_txt(1)+pos_mean_txt(3)+dx+6*wx/5;
        pos_max_txt     = [     px                                      ,...
                                pos_frame1(2)+h_frame1-Def_Btn_Height-dy2,...
                                wx                                      ,...
                                Def_Btn_Height                          ];
        pos_min_txt     = [     pos_max_txt(1)                          ,...
                                pos_max_txt(2)-Def_Btn_Height-dy2       ,...
                                wx                                      ,...
                                Def_Btn_Height                          ];
        pos_range_txt   = [     pos_max_txt(1)                          ,...
                                pos_min_txt(2)-Def_Btn_Height-dy2       ,...
                                wx                                      ,...
                                Def_Btn_Height                          ];
        px              = pos_max_txt(1)+pos_max_txt(3)+dx+6*wx/5;
        pos_std_txt     = [     px                                      ,...
                                pos_frame1(2)+h_frame1-Def_Btn_Height-dy2,...
                                13*wx/5                                 ,...
                                Def_Btn_Height                          ];
        pos_mad_txt     = [     pos_std_txt(1)                          ,...
                                pos_std_txt(2)-Def_Btn_Height-dy2       ,...
                                13*wx/5                                 ,...
                                Def_Btn_Height                          ];
        pos_madm_txt    = [     pos_mad_txt(1)                          ,...
                                pos_mad_txt(2)-Def_Btn_Height-dy2       ,...
                                13*wx/5                                 ,...
                                Def_Btn_Height                          ];
        pos_mean_val    = [     pos_mean_txt(1)+pos_mean_txt(3)         ,...
                                pos_mean_txt(2)                         ,...
                                6*wx/5                                  ,...
                                Def_Btn_Height                          ];
        pos_med_val     = [     pos_med_txt(1)+pos_med_txt(3)           ,...
                                pos_med_txt(2)                          ,...
                                6*wx/5                                  ,...
                                Def_Btn_Height                          ];
        pos_mode_val    = [     pos_mode_txt(1)+pos_mode_txt(3)         ,...
                                pos_mode_txt(2)                         ,...
                                6*wx/5                                  ,...
                                Def_Btn_Height                          ];
        pos_max_val     = [     pos_max_txt(1)+pos_max_txt(3)           ,...
                                pos_max_txt(2)                          ,...
                                6*wx/5                                  ,...
                                Def_Btn_Height                          ];
        pos_min_val     = [     pos_min_txt(1)+pos_min_txt(3)           ,...
                                pos_min_txt(2)                          ,...
                                6*wx/5                                  ,...
                                Def_Btn_Height                          ];
        pos_range_val   = [     pos_range_txt(1)+pos_range_txt(3)       ,...
                                pos_range_txt(2)                        ,...
                                6*wx/5                                  ,...
                                Def_Btn_Height                          ];
        pos_std_val     = [     pos_std_txt(1)+pos_std_txt(3)           ,...
                                pos_std_txt(2)                          ,...
                                6*wx/5                                  ,...
                                Def_Btn_Height                          ];
        pos_mad_val     = [     pos_mad_txt(1)+pos_mad_txt(3)           ,...
                                pos_mad_txt(2)                          ,...
                                6*wx/5                                  ,...
                                Def_Btn_Height                          ];
        pos_madm_val    = [     pos_madm_txt(1)+pos_madm_txt(3)         ,...
                                pos_madm_txt(2)                         ,...
                                6*wx/5                                  ,...
                                Def_Btn_Height                          ];

        % String property of objects.
        %----------------------------
        str_input_txt   = 'Image';
        str_input_data  = Img_Name;
        str_wav_txt     = 'Wavelet';
        str_wav_fams    = Wav_Fam;
        str_wav_nums    = Wav_Num;
        str_lev_txt     = 'Level';
        str_lev_data    = int2str(Lev_Anal);

        s_i = wmemtool('rmb',win_dw2dtool,n_param_anal,ind_simg_type);
        if      s_i=='ss', str_ss = 'Synthesized image';
        elseif  s_i=='ds', str_ss = 'De_noised image';
        elseif  s_i=='cs', str_ss = 'Compressed image';
        end
        str_synt_img    = str_ss;

        str_orig_img    = 'Original image';
        str_app_img     = 'Approximation';
        str_det_img     = 'Detail';
        str_app_txt     = 'Approximation at';
        str_det_txt     = 'Detail at';
        str_detdir_val  = str2mat('Horizontal','Vertical','Diagonal');
        str_sel_cfs     = 'Coefficients';
        str_sel_rec     = 'Reconstructed';
        str_bins_txt    = 'Number of bins';
        str_bins_data   = int2str(default_bins);
        str_show_stat   = 'Show statistics';
        str_close       = 'Close';
        str_mean_txt    = 'Mean';
        str_med_txt     = 'Median';
        str_mode_txt    = 'Mode';
        str_max_txt     = 'Maximum';
        str_min_txt     = 'Minimum';
        str_range_txt   = 'Range';
        str_std_txt     = 'Standard deviation';
        str_mad_txt     = 'Median absolute deviation';
        str_madm_txt    = 'Mean absolute deviation';
        str_appdet_val  = [];
        for i = 1:Lev_Anal
                str_appdet_val  = str2mat(str_appdet_val,['Level ' int2str(i)]);
        end
        str_appdet_val  = str_appdet_val(2:Lev_Anal+1,:);

        % Command part construction of the window.
        %-----------------------------------------
        figure(win_dw2dstat)
        txt_input_txt   = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_input_txt,...
                                        'String',str_input_txt,...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
        txt_input_data  = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_input_data,...
                                        'String',str_input_data,...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        txt_wav_txt     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_wav_txt,...
                                        'String',str_wav_txt,...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
        txt_wav_fams    = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_wav_fams,...
                                        'String',str_wav_fams,...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        if ~isempty(str_wav_nums)
        txt_wav_nums    = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_wav_nums,...
                                        'String',str_wav_nums,...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        end
        txt_lev_txt     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_lev_txt,...
                                        'String',str_lev_txt,...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
        txt_lev_data    = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_lev_data,...
                                        'String',str_lev_data,...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        drawnow

        rad_orig_img    = uicontrol(...
                                        'Style','Radiobutton',...
                                        'Unit',win_units,...
                                        'Position',pos_orig_img,...
                                        'String',str_orig_img,...
                                        'Enable','off',...
                                        'Value',1,...
                                        'Userdata',1,...
                                        'Tag',tag_orig_img...
                                        );
        rad_synt_img    = uicontrol(...
                                        'Style','Radiobutton',...
                                        'Unit',win_units,...
                                        'Position',pos_synt_img,...
                                        'String',str_synt_img,...
                                        'Enable','off',...
                                        'Tag',tag_synt_img...
                                        );
        rad_app_img     = uicontrol(...
                                        'Style','Radiobutton',...
                                        'Unit',win_units,...
                                        'Position',pos_app_img,...
                                        'String',str_app_img,...
                                        'Enable','off',...
                                        'Tag',tag_app_img...
                                        );
        rad_det_img     = uicontrol(...
                                        'Style','Radiobutton',...
                                        'Unit',win_units,...
                                        'Position',pos_det_img,...
                                        'String',str_det_img,...
                                        'Enable','off',...
                                        'Tag',tag_det_img...
                                        );
        drawnow

        txt_appdet_txt  = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'Position',pos_appdet_txt,...
                                        'String',str_app_txt,...
                                        'Visible','off',...
                                        'Tag',tag_appdet_txt,...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
        pop_appdet_val  = uicontrol(...
                                        'Style','Popup',...
                                        'Unit',win_units,...
                                        'Position',pos_appdet_val,...
                                        'String',str_appdet_val,...
                                        'Visible','off',...
                                        'Userdata',1,...
                                        'Tag',tag_appdet_val...
                                        );
        pop_detdir_val  = uicontrol(...
                                        'Style','Popup',...
                                        'Unit',win_units,...
                                        'Position',pos_detdir_val,...
                                        'String',str_detdir_val,...
                                        'Visible','off',...
                                        'Userdata',1,...
                                        'Tag',tag_detdir_val...
                                        );
        rad_sel_cfs     = uicontrol(...
                                        'Style','Radiobutton',...
                                        'Unit',win_units,...
                                        'Position',pos_sel_cfs,...
                                        'String',str_sel_cfs,...
                                        'Visible','off',...
                                        'Tag',tag_sel_cfs,...
                                        'Userdata',0,...
                                        'Value',0);
        rad_sel_rec     = uicontrol(...
                                        'Style','Radiobutton',...
                                        'Unit',win_units,...
                                        'Position',pos_sel_rec,...
                                        'String',str_sel_rec,...
                                        'Visible','off',...
                                        'Tag',tag_sel_rec,...
                                        'Userdata',1,...
                                        'Value',1);
        drawnow

        txt_bins_txt    = uicontrol(...
                                        'Style','text',...
                                        'Unit',win_units,...
                                        'Position',pos_bins_txt,...
                                        'String',str_bins_txt,...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'Visible','off',...
                                        'Tag',tag_bins_txt...
                                        );
        edi_bins_data   = uicontrol(...
                                        'Style','Edit',...
                                        'Units',win_units,...
                                        'Position',pos_bins_data,...
                                        'String',str_bins_data,...
                                        'Backgroundcolor',Def_EdiBkColor,...
                                        'Visible','off',...
                                        'Tag',tag_bins_data...
                                        );
        pus_show_stat   = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_show_stat,...
                                        'String',str_show_stat,...
                                        'Visible','off',...
                                        'Tag',tag_show_stat...
                                        );
        pus_close       = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_close,...
                                        'String',str_close,...
                                        'Interruptible','yes'...
                                        );
        drawnow




        coeff_vari_pos  = 2;
        pos_bins_txt(2) = pos_det_img(2)-coeff_vari_pos*Def_Btn_Height;
        pos_bins_data(2)= pos_bins_txt(2);
        pos_show_stat(2)= pos_bins_data(2)-3*Def_Btn_Height;
        set(txt_bins_txt,'Position',pos_bins_txt,'Visible','on');
        set(edi_bins_data,'Position',pos_bins_data,'Visible','on');
        set(pus_show_stat,'Position',pos_show_stat,'Visible','on');
        drawnow

        fra_frame1      = uicontrol(...
                                        'Style','frame',...
                                        'Unit',win_units,...
                                        'Position',pos_frame1,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_TxtBkColor,...
                                        'Foregroundcolor','k'...
                                        );
        txt_mean_txt    = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_mean_txt,...
                                        'String',str_mean_txt,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        txt_mean_val    = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_mean_val,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'Tag',tag_mean_val...
                                        );
        txt_med_txt     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_med_txt,...
                                        'String',str_med_txt,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        txt_med_val     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_med_val,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'Tag',tag_med_val...
                                        );
        drawnow
        txt_mode_txt    = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_mode_txt,...
                                        'String',str_mode_txt,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        txt_mode_val    = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_mode_val,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'Tag',tag_mode_val...
                                        );
        txt_max_txt     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_max_txt,...
                                        'String',str_max_txt,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        txt_max_val     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_max_val,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'Tag',tag_max_val...
                                        );
        txt_min_txt     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_min_txt,...
                                        'String',str_min_txt,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        txt_min_val     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_min_val,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'Tag',tag_min_val...
                                        );
        drawnow
        txt_range_txt   = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_range_txt,...
                                        'String',str_range_txt,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        txt_range_val   = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_range_val,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'Tag',tag_range_val...
                                        );
        txt_std_txt     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_std_txt,...
                                        'String',str_std_txt,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        txt_std_val     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_std_val,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'Tag',tag_std_val...
                                        );
        txt_mad_txt     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_mad_txt,...
                                        'String',str_mad_txt,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        txt_mad_val     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_mad_val,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'Tag',tag_mad_val...
                                        );
        txt_madm_txt    = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_madm_txt,...
                                        'String',str_madm_txt,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        txt_madm_val    = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_madm_val,...
                                        'Visible','off',...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'Tag',tag_madm_val...
                                        );
        drawnow

        % Sets of handles.
        %-----------------
        infos_hdls      = [     fra_frame1
                                txt_mean_txt
                                txt_med_txt
                                txt_mode_txt
                                txt_max_txt
                                txt_min_txt
                                txt_range_txt
                                txt_std_txt
                                txt_mad_txt
                                txt_madm_txt
                                txt_mean_val
                                txt_med_val
                                txt_mode_val
                                txt_max_val
                                txt_min_val
                                txt_range_val
                                txt_std_val
                                txt_mad_val
                                txt_madm_val];
        set1_hdls       = [     txt_appdet_txt
                                pop_appdet_val
                                pop_detdir_val
                                rad_sel_cfs
                                rad_sel_rec];
        set2_hdls       = [     txt_bins_txt
                                edi_bins_data
                                pus_show_stat];

        % Selected box limits.
        %---------------------
        Axe_Ref = findobj(win_dw2dtool,'Type','axes');
        Axe_Ref = findobj(Axe_Ref,'Tag','Axe_ImgIni');
        [xlim_selbox ylim_selbox]= dynvtool('getbox',win_dw2dtool); 
        if      ~isempty(xlim_selbox)
                xlim_selbox = [min(xlim_selbox) max(xlim_selbox)];
        else
                xlim_selbox = get(Axe_Ref,'XLim');
        end
        if      ~isempty(ylim_selbox)
                ylim_selbox = [min(ylim_selbox) max(ylim_selbox)];
        else
                ylim_selbox = get(Axe_Ref,'YLim');
        end
        xlim_selbox     = round(xlim_selbox);
        ylim_selbox     = round(ylim_selbox);
        xlim1           = xlim_selbox(1);       
        xlim2           = xlim_selbox(2);
        ylim1           = ylim_selbox(1);       
        ylim2           = ylim_selbox(2);
        if      xlim1<1,                xlim1 = 1;              end
        if      xlim2>Img_Size(1),      xlim2 = Img_Size(1);    end
        if      (xlim2<1) | (xlim1>Img_Size(1)), return,        end
        if      ylim1<1,                ylim1 = 1;              end
        if      ylim2>Img_Size(2),      ylim2 = Img_Size(2);    end
        if      (ylim2<1) | (ylim1>Img_Size(2)), return,        end
        selbox          = [xlim1 xlim2 ylim1 ylim2];

        % Callbacks update.
        %------------------
        str_infos_hdls          = num2mstr(infos_hdls);
        str_group_hdls          = num2mstr([set2_hdls;set1_hdls]);
        str_set2_hdls           = num2mstr(set2_hdls);
        str_rad_orig_img        = num2mstr(rad_orig_img);
        str_rad_synt_img        = num2mstr(rad_synt_img);
        str_rad_app_img         = num2mstr(rad_app_img);
        str_rad_det_img         = num2mstr(rad_det_img);
        str_pop_appdet_val      = num2mstr(pop_appdet_val);
        str_pop_detdir_val      = num2mstr(pop_detdir_val);
        str_rad_sel_rec         = num2mstr(rad_sel_rec);
        str_rad_sel_cfs         = num2mstr(rad_sel_cfs);
        str_edi_bins_data       = num2mstr(edi_bins_data);
        str_selbox              = num2mstr(selbox);

        cba_orig_img            = ['dw2dstat(''select'',' ...
                                        str_numwin ',' ...
                                        str_rad_orig_img ',' ...
                                        str_infos_hdls ',' ...
                                        str_group_hdls ',' ...
                                        str_set2_hdls ...
                                        ');'];
        cba_synt_img            = ['dw2dstat(''select'',' ...
                                        str_numwin ',' ...
                                        str_rad_synt_img ',' ...
                                        str_infos_hdls ',' ...
                                        str_group_hdls ',' ...
                                        str_set2_hdls ...
                                        ');'];
        cba_app_img             = ['dw2dstat(''select'',' ...
                                        str_numwin ',' ...
                                        str_rad_app_img ',' ...
                                        str_infos_hdls ',' ...
                                        str_group_hdls ',' ...
                                        str_group_hdls ...
                                        ');'];
        cba_det_img             = ['dw2dstat(''select'',' ...
                                        str_numwin ',' ...
                                        str_rad_det_img ',' ...
                                        str_infos_hdls ',' ...
                                        str_group_hdls ',' ...
                                        str_group_hdls ...
                                        ');'];
        cba_pop_appdet_val      = ['dw2dstat(''upd'',' ...
                                        str_numwin ',''lvl'','  ...
                                        str_infos_hdls ','      ...
                                        str_pop_appdet_val      ...
                                        ');'];
        cba_pop_detdir_val      = ['dw2dstat(''upd'',' ...
                                        str_numwin ',''lvl'','  ...
                                        str_infos_hdls ','      ...
                                        str_pop_detdir_val      ...
                                        ');'];
        cba_sel_rec             = ['dw2dstat(''upd'',' ...
                                        str_numwin ',''cfs'','  ...
                                        str_infos_hdls ','      ...
                                        str_rad_sel_rec ...
                                        ');'];
        cba_sel_cfs             = ['dw2dstat(''upd'',' ...
                                        str_numwin ',''cfs'','  ...
                                        str_infos_hdls ','      ...
                                        str_rad_sel_cfs ...
                                        ');'];
        cba_bins_data           = ['dw2dstat(''update_bins'',' ...
                                        str_numwin ',' ...
                                        str_edi_bins_data ',' ...
                                        str_infos_hdls ...
                                        ');'];
        cba_show_stat           = ['dw2dstat(''draw'',' ...
                                        str_numwin ',' ...
                                        str_win_dw2dtool ',' ...
                                        str_infos_hdls ',' ...
                                        str_selbox ...
                                        ');'];

        set(rad_orig_img,'Callback',cba_orig_img);
        set(rad_synt_img,'Callback',cba_synt_img);
        set(rad_app_img,'Callback',cba_app_img);
        set(rad_det_img,'Callback',cba_det_img);
        set(pop_appdet_val,'Callback',cba_pop_appdet_val);
        set(pop_detdir_val,'Callback',cba_pop_detdir_val);
        set(rad_sel_rec,'Callback',cba_sel_rec);
        set(rad_sel_cfs,'Callback',cba_sel_cfs);
        set(edi_bins_data,'Callback',cba_bins_data);
        set(pus_show_stat,'Callback',cba_show_stat);
        set(pus_close,'Callback',cba_close_menu);

        % Axes construction.
        %-------------------
        xspace          = gra_width/10;
        yspace          = pos_frame0(4)/10;
        axe_height      = (pos_frame0(4)-Def_Btn_Height-h_frame1-4*dy)/2-yspace;
        axe_width       = gra_width-2*xspace;
        half_width      = axe_width/2-xspace/2;
        cx              = xspace+axe_width/2;
        cy              = h_frame1+2*dy2+axe_height+4*yspace/3+axe_height/2;
        [w_used,h_used] = wpropimg(Img_Size,axe_width,axe_height,'pixels');
        pos_ax_image    = [cx-w_used/2,cy-h_used/2,w_used,h_used];
        pos_ax_hist     = [xspace h_frame1+2*dy2+yspace/3 ...
                                 half_width axe_height];
        pos_ax_cumhist  = [2*xspace+half_width h_frame1+2*dy2+yspace/3 ...
                                 half_width axe_height];
        axe_ax_image    = axes(...
                                'Units',win_units,...
                                'Position',pos_ax_image,...
                                'Visible','Off',...
                                'box','on',...
                                'NextPlot','Replace',...
                                'Drawmode','fast',...
                                'Tag',tag_ax_image...
                                );
        axe_ax_hist     = axes(...
                                'Units',win_units,...
                                'Position',pos_ax_hist,...
                                'Visible','Off',...
                                'box','on',...
                                'NextPlot','Replace',...
                                'Drawmode','fast',...
                                'Tag',tag_ax_hist...
                                );
        axe_ax_cumhist  = axes(...
                                'Units',win_units,...
                                'Position',pos_ax_cumhist,...
                                'Visible','Off',...
                                'box','on',...
                                'NextPlot','Replace',...
                                'Drawmode','fast',...
                                'Tag',tag_ax_cumhist...
                                );
        drawnow

        % Displaying the window title.
        %-----------------------------
        str_nb_val      = [' (' int2str(Img_Size(1)) ' x ' int2str(Img_Size(2)) ')'];
        str_wintitle    = [Img_Name,str_nb_val,' analyzed at level ',...
                           int2str(Lev_Anal),' with ',Wav_Name];
        str_wintitle    = [str_wintitle '  --->  X = ' ,...
                           int2str(selbox(1)) ' : ' ...
                           int2str(selbox(2)) '    Y = ' ...
                           int2str(selbox(3)) ' : ' ...
                           int2str(selbox(4))];
        wfigtitl('string',win_dw2dstat,str_wintitle,'off');

        % Setting units to normalized.
        %-----------------------------
        set(findobj(win_dw2dstat,'Units','pixels'),'Units','Normalized');

        % End waiting.
        %-------------
        wwaiting('off',win_dw2dstat);
        set([rad_orig_img rad_synt_img rad_app_img rad_det_img],'Enable','on');

%***********************************************%
%** OPTION = 'select' - SIGNAL TYPE SELECTION **%
%***********************************************%
elseif strcmp(option,'select')
        win_dw2dstat    = in2;
        sel_rad_btn     = in3;
        infos_hdls      = in4;
        group_hdls      = in5;
        curr_hdls       = in6;

        % Set to the current selection.
        %------------------------------
        rad_handles     = findobj(win_dw2dstat,'Style','radiobutton');
        rad_orig_img    = findobj(rad_handles,'Tag',tag_orig_img);
        rad_synt_img    = findobj(rad_handles,'Tag',tag_synt_img);
        rad_app_img     = findobj(rad_handles,'Tag',tag_app_img);
        rad_det_img     = findobj(rad_handles,'Tag',tag_det_img);
        rad_opt         = [rad_orig_img rad_synt_img rad_app_img rad_det_img];

        old_rad         = findobj(rad_opt,'Userdata',1);
        set(rad_opt,'Value',0,'Userdata',[]);
        set(sel_rad_btn,'Value',1,'Userdata',1)
        if old_rad==sel_rad_btn , return; end

        % Reset all.
        %-----------
        set(infos_hdls,'Visible','off');
        set(group_hdls,'Visible','off');
        axe_handles     = findobj(win_dw2dstat,'Type','axes');
        axe_ax_image    = findobj(axe_handles,'flat','Tag',tag_ax_image);
        axe_ax_hist     = findobj(axe_handles,'flat','Tag',tag_ax_hist);
        axe_ax_cumhist  = findobj(axe_handles,'flat','Tag',tag_ax_cumhist);
        mngaxe('vis',[axe_ax_image axe_ax_hist axe_ax_cumhist],'off');
        drawnow

        % Redraw the command part depending on the current selection.
        %------------------------------------------------------------
        pos_det_img             = get(rad_det_img,'Position');
        pos_bins_txt            = get(curr_hdls(1),'Position');
        pos_bins_data           = get(curr_hdls(2),'Position');
        pos_show_stat           = get(curr_hdls(3),'Position');
        coeff_vari_pos          = 10;

        [nul,ypixl]             = wfigutil('prop_size',win_dw2dstat,0,1);
        deltay                  = Def_Btn_Height*ypixl;
        if      sel_rad_btn==rad_orig_img | sel_rad_btn==rad_synt_img
                coeff_vari_pos          = 2;
        end
        pos_bins_txt(2) = pos_det_img(2)-coeff_vari_pos*deltay;
        pos_bins_data(2)= pos_bins_txt(2);
        pos_show_stat(2)= pos_bins_data(2)-3*deltay;
        set(curr_hdls(1),'Position',pos_bins_txt);
        set(curr_hdls(2),'Position',pos_bins_data);
        set(curr_hdls(3),'Position',pos_show_stat);
        set(curr_hdls,'Visible','On');
        if      sel_rad_btn==rad_app_img
                set(curr_hdls(4),'String','Approximation at')
                set(curr_hdls(6),'Visible','off')
        elseif  sel_rad_btn==rad_det_img
                set(curr_hdls(4),'String','Detail at')
                set(curr_hdls(6),'Visible','on')
        end

%***************************************%
%** OPTION = 'upd' - UPDATE :         **%
%**     COEFFICIENTS TYPE SELECTION   **%
%**     LEVEL NUMBER SELECTION        **%
%**     LEVEL DIRECTION SELECTION     **%
%***************************************%
elseif strcmp(option,'upd')
        win_dw2dstat    = in2;
        opt             = in3;
        infos_hdls      = in4;

        % Set to the current selection.
        %------------------------------
        if      opt=='cfs'
                sel_rad_btn     = in5;
                rad_handles     = findobj(win_dw2dstat,'Style','radiobutton');
                rad_sel_rec     = findobj(rad_handles,'Tag',tag_sel_rec);
                rad_sel_cfs     = findobj(rad_handles,'Tag',tag_sel_cfs);
                rad_opt         = [rad_sel_rec rad_sel_cfs];
                old_rad         = findobj(rad_opt,'Userdata',1);
                set(rad_opt,'Value',0,'Userdata',0);
                set(sel_rad_btn,'Value',1,'Userdata',1)
                if old_rad==sel_rad_btn , return; end

        elseif  opt=='lvl'
                pop_level       = in5;
                val_pop = get(pop_level,'value');
                usr_pop = get(pop_level,'userdata');
                if usr_pop==val_pop , return; end
                set(pop_level,'userdata',val_pop);

        elseif  opt=='dir'
                pop_dir = in5;
                val_pop = get(pop_dir,'value');
                usr_pop = get(pop_dir,'userdata');
                if usr_pop==val_pop , return; end
                set(pop_dir,'userdata',val_pop);
        end

        % Reset all.
        %-----------
        set(infos_hdls,'Visible','off');
        axe_handles     = findobj(win_dw2dstat,'Type','axes');
        axe_ax_image    = findobj(axe_handles,'flat','Tag',tag_ax_image);
        axe_ax_hist     = findobj(axe_handles,'flat','Tag',tag_ax_hist);
        axe_ax_cumhist  = findobj(axe_handles,'flat','Tag',tag_ax_cumhist);
        mngaxe('vis',[axe_ax_image axe_ax_hist axe_ax_cumhist],'off');
        drawnow

%*********************************************%
%** OPTION = 'lvl' - LEVEL NUMBER SELECTION **%
%*********************************************%
elseif strcmp(option,'lvl')
        win_dw2dstat    = in2;
        pop_level       = in3;
        infos_hdls      = in4;

        % Set to the current selection.
        %------------------------------
        val_pop = get(pop_level,'value');
        usr_pop = get(pop_level,'userdata');
        if usr_pop==val_pop , return; end
        set(pop_level,'userdata',val_pop);

        % Reset all.
        %-----------
        set(infos_hdls,'Visible','off');
        axe_handles     = findobj(win_dw2dstat,'Type','axes');
        axe_ax_image    = findobj(axe_handles,'flat','Tag',tag_ax_image);
        axe_ax_hist     = findobj(axe_handles,'flat','Tag',tag_ax_hist);
        axe_ax_cumhist  = findobj(axe_handles,'flat','Tag',tag_ax_cumhist);
        mngaxe('vis',[axe_ax_image axe_ax_hist axe_ax_cumhist],'off');
        drawnow

%**********************************************%
%** OPTION = 'draw' - DRAW AXES              **%
%**********************************************%
elseif strcmp(option,'draw')
        win_dw2dstat    = in2;
        win_dw2dtool    = in3;
        infos_hdls      = in4;
        selbox          = in5;

        % Handles of tagged objects.
        %---------------------------
        pus_show_stat   = findobj(win_dw2dstat,...
                                        'Style','pushbutton',...
                                        'Tag',tag_show_stat...
                                        );
        rad_handles     = findobj(win_dw2dstat,'Style','radiobutton');
        edi_handles     = findobj(win_dw2dstat,'Style','edit');
        txt_handles     = findobj(win_dw2dstat,'Style','text');
        pop_handles     = findobj(win_dw2dstat,'Style','popupmenu');
        rad_sel_cfs     = findobj(rad_handles,'Tag',tag_sel_cfs);
        rad_orig_img    = findobj(rad_handles,'Tag',tag_orig_img);
        rad_synt_img    = findobj(rad_handles,'Tag',tag_synt_img);
        rad_app_img     = findobj(rad_handles,'Tag',tag_app_img);
        rad_det_img     = findobj(rad_handles,'Tag',tag_det_img);
        edi_bins_data   = findobj(edi_handles,'Tag',tag_bins_data);
        txt_mean_val    = findobj(txt_handles,'Tag',tag_mean_val);
        txt_med_val     = findobj(txt_handles,'Tag',tag_med_val);
        txt_mode_val    = findobj(txt_handles,'Tag',tag_mode_val);
        txt_max_val     = findobj(txt_handles,'Tag',tag_max_val)';
        txt_min_val     = findobj(txt_handles,'Tag',tag_min_val);
        txt_range_val   = findobj(txt_handles,'Tag',tag_range_val);
        txt_std_val     = findobj(txt_handles,'Tag',tag_std_val);
        txt_mad_val     = findobj(txt_handles,'Tag',tag_mad_val);
        txt_madm_val    = findobj(txt_handles,'Tag',tag_madm_val);
        pop_appdet_val  = findobj(pop_handles,'Tag',tag_appdet_val);
        pop_detdir_val  = findobj(pop_handles,'Tag',tag_detdir_val);

        % Handles of tagged objects continuing.
        %-------------------------------------
        axe_handles     = findobj(win_dw2dstat,'Type','axes');
        axe_ax_image    = findobj(axe_handles,'flat','Tag',tag_ax_image);
        axe_ax_hist     = findobj(axe_handles,'flat','Tag',tag_ax_hist);
        axe_ax_cumhist  = findobj(axe_handles,'flat','Tag',tag_ax_cumhist);

        % Main parameters selection before drawing.
        %------------------------------------------
        sel_cfs         = (get(rad_sel_cfs,'Value')~=0);
        orig_img        = (get(rad_orig_img,'Value')~=0);
        synt_img        = (get(rad_synt_img,'Value')~=0);
        app_img         = (get(rad_app_img,'Value')~=0);
        det_img         = (get(rad_det_img,'Value')~=0);

        % Check the bins number.
        %-----------------------
        default_bins    = 50;
        old_params      = get(pus_show_stat,'Userdata');
        if ~isempty(old_params)
                default_bins = old_params(1);
        end
        nb_bins         = str2num(get(edi_bins_data,'String'));
        if isempty(nb_bins) 
                nb_bins = default_bins;   
                set(edi_bins_data,'String',int2str(default_bins))
        elseif nb_bins<2
                nb_bins = default_bins;
                set(edi_bins_data,'String',int2str(default_bins))
        end
        level           = get(pop_appdet_val,'value');
        direction       = get(pop_detdir_val,'value');

        new_params = [  nb_bins sel_cfs orig_img synt_img       ...
                        app_img det_img level direction         ...
                        ];

        if      ~isempty(old_params) & (new_params==old_params)
                vis = get(axe_ax_hist,'Visible');
                if vis(1:2)=='on', return, end
        end

        % Updating parameters.
        %--------------------- 
        set(pus_show_stat,'Userdata',new_params);

        % Show the status line.
        %----------------------
        wfigtitl('vis',win_dw2dstat,'on');

        % Cleaning the graphical part.
        %-----------------------------
        set(infos_hdls,'Visible','off');

        % Waiting message.
        %-----------------
        wwaiting('msg',win_dw2dstat,'Wait ... computing');

        % Cleaning the graphical part continuing.
        %----------------------------------------
        mngaxe('vis',[axe_ax_image axe_ax_hist axe_ax_cumhist],'off');
        drawnow

        % Getting memory blocks.
        %-----------------------
        [Img_Name,NB_ColorsInPal,Wav_Name,Lev_Anal] = ...
                        wmemtool('rmb',win_dw2dtool,n_param_anal,...
                                ind_img_name,           ...
                                ind_nbcolors,           ...
                                ind_wav_name,           ...
                                ind_lev_anal            ...
                                );

        coefs = wmemtool('get',win_dw2dtool,n_coefs);
        sizes = wmemtool('get',win_dw2dtool,n_sizes);

        % Current image construction.
        %----------------------------
        if orig_img
                curr_img        = get(dw2drwcd('r_orig',win_dw2dtool),'Cdata');
                flg_code        = 0;
                curr_color      = dw1dcolo('sig');
                str_title       = 'Original image';
        elseif synt_img
                curr_img        = get(dw2drwcd('r_synt',win_dw2dtool),'Cdata');
                flg_code        = 0;
                curr_color      = dw1dcolo('ssig');
                s_i = wmemtool('rmb',win_dw2dtool,n_param_anal,ind_simg_type);
                if      s_i=='ss', str_ss = 'Synthesized image';
                elseif  s_i=='ds', str_ss = 'De_noised image';
                elseif  s_i=='cs', str_ss = 'Compressed image';
                end
                str_title       = str_ss;
        elseif app_img
                if sel_cfs
                        curr_img = appcoef2(coefs,sizes,Wav_Name,level);
                        flg_code = 1;
                        str_title= 'Coefficients of ';
                else
                        curr_img = wrcoef2('a',coefs,sizes,Wav_Name,level);
                        flg_code = 0;
                        str_title= 'Reconstructed ';
                end
                col_app         = dw1dcolo('app',Lev_Anal);
                curr_color      = col_app(level,:);
                str_title       = [str_title 'approximation at level ' ...
                                        int2str(level)];
        elseif det_img
                if      direction==1
                        dir = 'horizontal ';
                elseif  direction==2
                        dir = 'vertival ';
                elseif  direction==3
                        dir = 'diagonal ';
                end
                if sel_cfs
                        curr_img = detcoef2(dir(1),coefs,sizes,level);
                        flg_code = 1;
                        str_title= 'Coefficients of ';
                else
                        curr_img = wrcoef2(dir(1),coefs,sizes,Wav_Name,level);
                        flg_code = 1;
                        str_title= 'Reconstructed ';
                end
                col_det         = dw1dcolo('det',Lev_Anal);
                curr_color      = col_det(level,:);
                str_title       = [str_title dir 'detail at level ' ...
                                        int2str(level)];
        end
        if sel_cfs & ~orig_img & ~synt_img
                selbox  = ceil(selbox./2^level);
        end
        if selbox(2)-selbox(1)<2 | selbox(4)-selbox(3)<2
                warndlg(['          Not enough coefficients ' ...
                        'remaining at level ' ...
                        int2str(level)],...
                        'Wavelet 2-D -- Statistics');
                wwaiting('off',win_dw2dstat);
                return;
        end

        % Deseable new selection.
        %-------------------------
        set([pop_handles;rad_handles;edi_handles],'Enable','off');

        % Displaying the image.
        %-----------------------
        set(win_dw2dstat,'Colormap',get(win_dw2dtool,'Colormap'));
        curr_img        = curr_img(selbox(3):selbox(4),selbox(1):selbox(2));
        axes(axe_ax_image);
        pos_ax_image    = get(axe_ax_image,'Position');
        pos3            = pos_ax_image(3);
        pos_ax_image(3) = min((pos_ax_image(4)/(selbox(4)-selbox(3)+1))...
                        *(selbox(2)-selbox(1)+1),pos3);
        pos_ax_image(1) = pos_ax_image(1)+(pos3-pos_ax_image(3))/2;      
        set(axe_ax_image,'Position',pos_ax_image);
        tag = get(axe_ax_image,'Tag');
        image([selbox(1) selbox(2)],[selbox(3) selbox(4)],...
                        wimgcode('cod',flg_code,curr_img,NB_ColorsInPal,codemat_v));
        title(str_title);
        set(axe_ax_image,'Tag',tag);
        drawnow;

        % Check the bins number.
        %-----------------------
        nb_bins = str2num(get(edi_bins_data,'String'));
        if isempty(nb_bins) 
                nb_bins = default_bins;   
                set(edi_bins_data,'String',int2str(default_bins))
        elseif nb_bins<2
                nb_bins = default_bins;
                set(edi_bins_data,'String',int2str(default_bins))
        end

        % Displaying histogram.
        %----------------------
        his             = wgethist(curr_img(:),nb_bins);
        [xx,imod]       = max(his(2,:));
        mode_val        = (his(1,imod)+his(1,imod+1))/2;
        his(2,:)        = his(2,:)/length(curr_img(:));
        axes(axe_ax_hist);
        wplothis(axe_ax_hist,his,curr_color);
        title('Histogram');

        % Displaying cumulated histogram.
        %--------------------------------
        for i=6:4:length(his(2,:));
                his(2,i)        = his(2,i)+his(2,i-4);
                his(2,i+1)      = his(2,i);
        end
        axes(axe_ax_cumhist);
        wplothis(axe_ax_cumhist,[his(1,:);his(2,:)],curr_color);
        title('Cumulative histogram');
        drawnow;

        % Displaying statistics.
        %-----------------------
        errtol          = 1.0E-12;
        mean_val        = mean(mean(curr_img));
        if abs(mean_val)<errtol , mean_val = 0; end
        max_val         = max(max(curr_img));
        if abs(max_val)<errtol , max_val = 0; end
        min_val         = min(min(curr_img));
        if abs(min_val)<errtol , min_val = 0; end
        range_val       = max_val-min_val;
        if abs(range_val)<errtol , range_val = 0; end
        std_val         = std(curr_img(:));
        if abs(std_val)<errtol , std_val = 0; end
        med_val         = median(curr_img(:));
        if abs(med_val)<errtol , med_val = 0; end
        set(txt_mean_val,'string',sprintf('%1.4g',mean_val));
        set(txt_med_val,'string',sprintf('%1.4g',med_val));
        set(txt_mode_val,'string',sprintf('%1.4g',mode_val));
        set(txt_max_val,'string',sprintf('%1.4g',max_val));
        set(txt_min_val,'string',sprintf('%1.4g',min_val));
        set(txt_range_val,'string',sprintf('%1.4g',range_val));
        set(txt_std_val,'string',sprintf('%1.4g',std_val));
        set(txt_mad_val,'string',...
                        sprintf('%1.4g',median(abs(curr_img(:)-med_val))));
        set(txt_madm_val,'string',...
                        sprintf('%1.4g',mean(mean(abs(curr_img-mean_val)))));

        % Memory blocks update.
        %----------------------
        wmemtool('ini',win_dw2dstat,n_miscella,nb3_stored);
        wmemtool('wmb',win_dw2dstat,n_miscella,                 ...
                                        ind_curr_img,curr_img(:),       ...
                                        ind_curr_color,curr_color       ...
                                        );

        % End waiting.
        %-------------
        wwaiting('off',win_dw2dstat);

        % Setting infos visible.
        %-----------------------
        set(infos_hdls,'Visible','on');

        % Enable new selection.
        %----------------------
        set([pop_handles;rad_handles;edi_handles],'Enable','on');

%**************************************************************%
%** OPTION = 'update_bins' - UPDATE HISTOGRAMS WITH NEW BINS **%
%**************************************************************%
elseif strcmp(option,'update_bins')
        win_dw2dstat    = in2;
        edi_bins_data   = in3;
        infos_hdls      = in4;

        % Handles of tagged objects.
        %---------------------------
        pus_show_stat   = findobj(win_dw2dstat,...
                                        'Style','pushbutton',...
                                        'Tag',tag_show_stat...
                                        );
        axe_handles     = findobj(win_dw2dstat,'Type','axes');
        axe_ax_hist     = findobj(axe_handles,'flat','Tag',tag_ax_hist);
        axe_ax_cumhist  = findobj(axe_handles,'flat','Tag',tag_ax_cumhist);

        % Return if no current display.
        %------------------------------
        vis     = get(axe_ax_hist,'Visible');
        if vis(1:2)=='of', return, end

        % Check the bins number.
        %-----------------------
        default_bins    = 50;
        old_params      = get(pus_show_stat,'Userdata');
        if ~isempty(old_params)
                default_bins = old_params(1);
        end
        nb_bins         = str2num(get(edi_bins_data,'String'));
        if isempty(nb_bins)
                nb_bins = default_bins;   
                set(edi_bins_data,'String',int2str(default_bins))
        elseif nb_bins<2
                nb_bins = default_bins;
                set(edi_bins_data,'String',int2str(default_bins))
        end
        if default_bins==nb_bins , return; end

        % Waiting message.
        %-----------------
        set(infos_hdls,'Visible','off');
        wwaiting('msg',win_dw2dstat,'Wait ... computing');

        % Getting memory blocks.
        %-----------------------
        [curr_img,curr_color] = wmemtool('rmb',win_dw2dstat,n_miscella,...
                                                        ind_curr_img,...
                                                        ind_curr_color);
        % Updating histograms.
        %---------------------
        if ~isempty(curr_img)
                old_params(1) = nb_bins;
                set(pus_show_stat,'Userdata',old_params);

                his             = wgethist(curr_img,nb_bins);
                his(2,:)        = his(2,:)/length(curr_img);
                axes(axe_ax_hist);
                wplothis(axe_ax_hist,his,curr_color);
                title('Histogram');

                for i=6:4:length(his(2,:));
                        his(2,i)        = his(2,i)+his(2,i-4);
                        his(2,i+1)      = his(2,i);
                end
                axes(axe_ax_cumhist);
                wplothis(axe_ax_cumhist,[his(1,:);his(2,:)],curr_color);
                title('Cumulative histogram');
        end

        % End waiting.
        %-------------
        wwaiting('off',win_dw2dstat);
        set(infos_hdls,'Visible','on');

%****************************************%
%** OPTION = 'demo' -  DEMOS or TESTS  **%
%****************************************%
elseif strcmp(option,'demo')
        win_dw2dstat    = in2;
        pus_show_stat   = findobj(win_dw2dstat,...
                                        'Style','pushbutton',...
                                        'Tag',tag_show_stat...
                                        );
        eval(get(pus_show_stat,'Callback'));

%****************************************%
%** OPTION = 'close' -  CLOSE FIGURE   **%
%****************************************%
elseif strcmp(option,'close')

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('dw2dstat','Unknown Option','msg');
        error('*');
end

