function out1 = dw2dtool(option,in2)
%DW2DTOOL Discret wavelet 2D tool.
%       out1 = dw2dtool(option,in2)
%
%       option = 'create' , 'close'

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.

global  Def_Btn_Height  Def_Btn_Width   Pop_Min_Width   ...
        X_Spacing       Y_Spacing                       ...
        X_Graph_Ratio   Def_UICBkColor                  ...
        Lst_ColorMap    Def_TxtBkColor  Def_EdiBkColor  ...
        Def_FraBkColor  Def_FraFgColor  Def_AxeXColor

% Test inputs.
%-------------
if nargin==0
        option  = 'create'; in2 = [];
elseif nargin==1
        in2 = [];
end
[continu,option,in2] = wfigcrea('test',option,in2);
if ~continu , return; end 

% Default values.
%----------------
max_lev_anal     = 5;
min_nbcolors     = 2;
max_nbcolors     = 256;
default_nbcolors = 255;
min_bright       = -2;
max_bright       = 2;
default_bright   = 0;

% Tag property of objects.
%-------------------------
tag_m_files     = 'Files';
tag_m_savesyn   = 'Save_Syn';
tag_m_savecfs   = 'Save_Cfs';
tag_m_savedec   = 'Save_Dec';
tag_txt_input   = 'Type_Input';
tag_input_data  = 'Input_Data';
tag_wav_fams    = 'Wav_Fams';
tag_wav_num     = 'Wav_Num';
tag_pop_lev     = 'Pop_Lev';
tag_pus_anal    = 'Pus_Anal';
tag_pus_deno    = 'Pus_Deno';
tag_pus_comp    = 'Pus_Comp';
tag_pus_hist    = 'Pus_Hist';
tag_pus_stat    = 'Pus_Stat';
tag_pop_declev  = 'Pop_DecLev';
tag_pus_visu    = 'Pus_Visu';
tag_pus_big     = 'Pus_Big';
tag_pus_rec     = 'Pus_Rec';
tag_pop_viewm   = 'Pop_ViewM';
tag_txt_full    = 'Txt_Full';
tag_pus_full    = str2mat(...
                        'Pus_Full.1','Pus_Full.2',...
                        'Pus_Full.3','Pus_Full.4'...
                        );
tag_cfs_map     = 'Pop_ColorMap';
tag_sli_nbc     = 'Sli_NBColors';
tag_edi_nbc     = 'Edi_NBColors';
tag_sli_bri     = 'Sli_Brightness';
tag_btn_close   = 'Wave_Close';

tag_axefigutil  = 'Axe_FigUtil';
tag_linetree    = 'Tree_lines';
tag_txttree     = 'Tree_txt';
tag_axeimgbig   = 'Axe_ImgBig';
tag_axeimgini   = 'Axe_ImgIni';
tag_axeimgvis   = 'Axe_ImgVis';
tag_axeimgsel   = 'Axe_ImgSel';
tag_axeimgdec   = 'Axe_ImgDec';
tag_axeimgsyn   = 'Axe_ImgSyn';
tag_axeimghdls  = 'Img_Handles';

% MemBloc0 of stored values.
%---------------------------
n_InfoInit      = 'DW2D_InfoInit';
ind_filename    =  1;
ind_pathname    =  2;
nb0_stored      =  2;

% MemBloc1 of stored values.
%---------------------------
n_param_anal    = 'DWAn2d_Par_Anal';
ind_img_name    =  1;
ind_wav_name    =  2;
ind_lev_anal    =  3;
ind_img_t_name  =  4;
ind_img_size    =  5;
ind_nbcolors    =  6;
ind_act_option  =  7;
ind_simg_type   =  8;
nb1_stored      =  8;

% MemBloc2.1 and 2.2 of stored values.
%------------------------------------
n_coefs         = 'MemCoefs';
n_sizes         = 'MemSizes';

% MemBloc3 of stored values.
%---------------------------
n_miscella      = 'DWAn2d_Miscella';
ind_graph_area  =  1;
ind_pos_axebig  =  2;
ind_pos_axeini  =  3;
ind_pos_axevis  =  4;
ind_pos_axedec  =  5;
ind_pos_axesyn  =  6;
ind_pos_axesel  =  7;
ind_view_status =  8;
ind_save_status =  9;
ind_sel_funct   = 10;
nb3_stored      = 10;

% Miscellaneous values.
%----------------------
% square_viewm  = 1;
% tree_viewm    = 2;
% BoxTitleSel_Col = 'g';
% drag_funct    = 'wselobj(''dw2dmngr'',0,''Img'');';
% boxsel_funct  = 'dw2dimgs(''get_img'');';
% select_funct  = boxsel_funct;

%*****************************************************************%
%** OPTION = 'create' - constructs the initial dw2dtool window  **%
%*****************************************************************%
if strcmp(option,'create')

        % Variables initialization.
        %--------------------------
        BoxTitleSel_Col = 'g';
        Width_LineSel   = 3;
        drag_funct      = 'wselobj(''dw2dmngr'',0,''Img'');';
        boxsel_funct    = 'dw2dimgs(''get_img'');';
        select_funct    = boxsel_funct;

        % Wavelet 2-D window initialization.
        %-----------------------------------
        win_name = 'Wavelet 2-D';
        [win_dw2dtool,pos_win,cba_close_menu] = ...
                wfigcrea('create',in2,win_name,'DW2Dtool','',3,'dw2dtool');
        str_numwin = int2str(win_dw2dtool);
        win_units  = 'pixels';
        out1       = win_dw2dtool;

        % Menu construction for current figure.
        %--------------------------------------
        lst_menu  = findobj(win_dw2dtool,'type','uimenu','Parent',win_dw2dtool);
        m_files   = wfindmen(lst_menu,'file');
        set(m_files,'tag',tag_m_files);
        m_loadimg = uimenu(m_files,...
                                'Label','Load Image ',          ...
                                'Position',1,                   ...
                                'Callback',                     ...
                                ['dw2dmngr(''load_img'','       ...
                                        str_numwin ');']        ...
                                );

        m_loadcfs = uimenu(m_files,...
                                'Label','Load Coefficients ',   ...
                                'Position',2,                   ...
                                'Callback',                     ...
                                ['dw2dmngr(''load_cfs'','       ...
                                        str_numwin ');']        ...
                                );
        m_loaddec = uimenu(m_files,...
                                'Label','Load Decomposition ',  ...
                                'Position',3,                   ...
                                'Callback',...
                                ['dw2dmngr(''load_dec'','       ...
                                        str_numwin ');']        ...
                                );
        m_savesyn = uimenu(m_files,...
                                'Label','Save Synthesized Image',...
                                'Position',4,                   ...
                                'Separator','on',               ...
                                'Enable','Off',                 ...
                                'Tag',tag_m_savesyn,            ...
                                'Callback',                     ...
                                ['dw2dmngr(''save_synt'','      ...
                                        str_numwin ');']        ...
                                );
        m_savecfs = uimenu(m_files,...
                                'Label','Save Coefficients ',   ...
                                'Position',5,                   ...
                                'Enable','Off',                 ...
                                'Tag',tag_m_savecfs,            ...
                                'Callback',                     ...
                                ['dw2dmngr(''save_cfs'','       ...
                                        str_numwin ');']        ...
                                );
        m_savedec = uimenu(m_files,...
                                'Label','Save Decomposition ',  ...
                                'Position',6,                   ...
                                'Enable','Off',                 ...
                                'Tag',tag_m_savedec,            ...
                                'Callback',                     ...
                                ['dw2dmngr(''save_dec'','       ...
                                        str_numwin ');']        ...
                                );
        m_loadtst = uimenu(m_files,...
                                'Label','Demo Analysis ',       ...
                                'Position',7,                   ...
                                'Separator','on'                ...
                                );

        % Submenu of test signals.
        %-------------------------
        beg_call_str    = ['dw2dmngr(''demo'',' str_numwin];
        tab             = setstr(9);
        sep1            = ['At level '];
        sep2            = [' , with '];
        sep3            = ['    ' tab ' ---> '];

        lab_str = [sep1 '3' sep2 'sym4' sep3 'Detail Durer '];
        cba     = [beg_call_str ',''detail'',''sym4'',3);'];
        uimenu(m_loadtst,'Label',lab_str,'Callback',cba);

        lab_str = [sep1 '2' sep2 'haar' sep3 'Woman '];
        cba     = [beg_call_str ',''woman'',''haar'',2);'];
        uimenu(m_loadtst,'Label',lab_str,'Callback',cba);

        lab_str = [sep1 '3' sep2 'haar' sep3 'Finger '];
        cba     = [beg_call_str ',''detfingr'',''haar'',3);'];
        uimenu(m_loadtst,'Label',lab_str,'Callback',cba);

        lab_str = [sep1 '3' sep2 'haar' sep3 'Tire '];
        cba     = [beg_call_str ',''tire'',''haar'',3);'];
        uimenu(m_loadtst,'Label',lab_str,'Callback',cba);

        lab_str = [sep1 '3' sep2 'sym3' sep3 'Chess '];
        cba     = [beg_call_str ',''chess'',''sym3'',3);'];
        uimenu(m_loadtst,'Label',lab_str,'Callback',cba);

        lab_str = [sep1 '2' sep2 'bior3.7' sep3 'Barb '];
        cba     = [beg_call_str ',''wbarb'',''bior3.7'',2);'];
        uimenu(m_loadtst,'Label',lab_str,'Callback',cba);

        lab_str = [sep1 '3' sep2 'bior3.1' sep3 'Facets '];
        cba     = [beg_call_str ',''facets'',''bior3.1'',3);'];
        uimenu(m_loadtst,'Separator','on','Label',lab_str,'Callback',cba);

        lab_str = [sep1 '3' sep2 'bior4.4' sep3 'Geometry '];
        cba     = [beg_call_str ',''geometry'',''bior4.4'',3);'];
        uimenu(m_loadtst,'Label',lab_str,'Callback',cba);

        lab_str = [sep1 '4' sep2 'db3' sep3 'Sinsin '];
        cba     = [beg_call_str ',''sinsin'',''db3'',4);'];
        uimenu(m_loadtst,'Label',lab_str,'Callback',cba);

        lab_str = [sep1 '3' sep2 'coif2' sep3 'Tartan '];
        cba     = [beg_call_str ',''tartan'',''coif2'',3);'];
        uimenu(m_loadtst,'Label',lab_str,'Callback',cba);

        lab_str = [sep1 '3' sep2 'db1' sep3 'Mandel set '];
        cba     = [beg_call_str ',''mandel'',''db1'',3);'];
        uimenu(m_loadtst,'Separator','on','Label',lab_str,'Callback',cba);

        lab_str = [sep1 '3' sep2 'db1' sep3 'Julia set '];
        cba     = [beg_call_str ',''julia'',''db1'',3);'];
        uimenu(m_loadtst,'Label',lab_str,'Callback',cba);

        lab_str = [sep1 '5' sep2 'coif1' sep3 'Ifs '];
        cba     = [beg_call_str ',''wifs'',''coif1'',5);'];
        uimenu(m_loadtst,'Label',lab_str,'Callback',cba);

        lab_str = [sep1 '3' sep2 'db2' sep3 'Noisy Woman '];
        cba     = [beg_call_str ',''noiswom'',''db2'',3);'];
        uimenu(m_loadtst,'Separator','on','Label',lab_str,'Callback',cba);

        lab_str = [sep1 '3' sep2 'bior3.1' sep3 'Noisy SinSin '];
        cba     = [beg_call_str ',''noissi2d'',''bior3.1'',3);'];
        uimenu(m_loadtst,'Label',lab_str,'Callback',cba);

        lab_str = [sep1 '2' sep2 'haar' sep3 'Mandrill '];
        cba     = [beg_call_str ',''wmandril'',''haar'',2);'];
        uimenu(m_loadtst,'Separator','on','Label',lab_str,'Callback',cba);

        lab_str = [sep1 '2' sep2 'sym5' sep3 'Gatlin '];
        cba     = [beg_call_str ',''wgatlin'',''sym5'',2);'];
        uimenu(m_loadtst,'Label',lab_str,'Callback',cba);

%***********************************************************************
%       m_options       = wfindmen(lst_menu,'options');
%       m_select        = uimenu(m_options,...
%                               'Label','Select Mode ', ...
%                               'Separator','On'        ...
%                               );
%       m_dragsel        = uimenu(m_select,...
%                               'Label','Drag Selection ',      ...
%                               'Callback',                     ...
%                               ['dw2dmngr(''mode_sel'','       ...
%                               str_numwin ',1);']      ...
%                               );
%       m_pointsel       = uimenu(m_select,...
%                               'Label','Box Selection ',       ...
%                               'Callback',                     ...
%                               ['dw2dmngr(''mode_sel'','       ...
%                               str_numwin ',0);']      ...
%                               );
%**********************************************************************
  
        % Command frame and Dynamical visualization tool construction.
        %-------------------------------------------------------------
        [frame0,pos_frame0,Pos_Graphic_Area] = ...
                        wfigcrea('frame',win_dw2dtool,'dynv','title');

        % Waiting Frame construction & begin waiting.
        %--------------------------------------------
        wwaiting('create',win_dw2dtool,X_Graph_Ratio,...
                        'Wait ... initialization');

        % Borders and double borders.
        %----------------------------
        dx  = X_Spacing;        dx2 = 2*dx;
        dy  = Y_Spacing;        dy2 = 2*dy;

        % General graphical parameters initialization.
        %--------------------------------------------
        x_frame0        = pos_frame0(1);
        cmd_width       = pos_frame0(3);
        btn_width       = Def_Btn_Width;
        btn_height      = Def_Btn_Height;
        x_frame         = x_frame0+dx;
        w_frame         = cmd_width-dx2;
        x_subframe      = x_frame+dx;
        w_subframe      = w_frame-dx2;
        push_width      = (w_frame-6*dx)/2;
        txt_width       = Def_Btn_Width;
        pop_width       = Pop_Min_Width;

        % Position property of objects.
        %------------------------------
        x_left          = x_frame0+dx2;
        y_low           = pos_win(4)-btn_height-dy2;
     
        pos_input_txt   = [     x_left                                  ,...
                                y_low                                   ,...
                                txt_width                               ,...
                                btn_height                              ];
        pos_input_data  = [     pos_input_txt(1)+pos_input_txt(3)+dx    ,...
                                pos_input_txt(2)                        ,...
                                2*pop_width                             ,...
                                btn_height                              ];
        pos_wav_txt     = pos_input_txt;
        pos_wav_txt(2)  = pos_input_txt(2)-btn_height-dy2;
        pos_wav_fams    = [     pos_wav_txt(1)+pos_wav_txt(3)+dx        ,...
                                pos_wav_txt(2)                          ,...
                                pop_width                               ,...
                                btn_height                              ];
        pos_wav_nums    = pos_wav_fams;
        pos_wav_nums(1) = pos_wav_nums(1)+pos_wav_fams(3);
        pos_lev_txt     = pos_wav_txt;
        pos_lev_txt(2)  = pos_wav_txt(2)-btn_height-dy2;
        pos_lev_data    = [     pos_lev_txt(1)+pos_lev_txt(3)+dx        ,...
                                pos_lev_txt(2)                          ,...
                                pop_width                               ,...
                                btn_height                              ];
        bdx             = (cmd_width-1.5*btn_width)/2;
        x_left          = x_frame0+bdx;
        y_low           = pos_lev_data(2)-btn_height-3*dy2;
        pos_anal        = [     x_left                                  ,...
                                y_low                                   ,...
                                1.5*btn_width                           ,...
                                1.5*btn_height                  ];

        x_left          = x_frame0+dx2;
        y_low           = pos_anal(2)-1.5*btn_height-2*dy2;
        push_width      = (cmd_width-3*dx2)/2;

        pos_stat        = [     x_left                                  ,...
                                y_low                                   ,...
                                push_width                              ,...
                                1.5*btn_height                  ];

        pos_comp        = pos_stat;
        pos_comp(1)     = pos_stat(1)+pos_stat(3)+dx2;

        y_low           = y_low-1.5*btn_height-dy;
        pos_hist        = [     x_left                                  ,...
                                y_low                                   ,...
                                push_width                              ,...
                                1.5*btn_height                  ];
        pos_deno        = pos_hist;
        pos_deno(1)     = pos_hist(1)+pos_hist(3)+dx2;

        y_low           = y_low-btn_height-2*dy2;
        pos_txt_declev  = [     x_left                  ,...
                                y_low                   ,...
                                2*push_width+dx2-pop_width              ,...
                                btn_height];

        pos_declev      = [     x_left+4*dx2    ,...
                                y_low                   ,...
                                pop_width                               ,...
                                btn_height                              ];
        pos_declev(1)   = pos_txt_declev(1)+pos_txt_declev(3);

        y_low           = y_low-btn_height-2*dy2;
        pos_pop_viewm   = [     x_left                  ,...
                                y_low                   ,...
                                2*push_width+dx2                ,...
                                btn_height                              ];

        y_low           = y_low-btn_height-dy2;
        pos_txt_full    = [     x_left+dx                               ,...
                                y_low-btn_height/2                      ,...
                                dx2+(w_subframe-dx2-3*dx)/3             ,...
                                btn_height                              ];

        pos_pus_full    = zeros(4,4);
        pos_pus_full(1,:) = [   pos_txt_full(1)+pos_txt_full(3)+dx      ,...
                                y_low                                   ,...
                                (w_subframe-dx2-3*dx)/3                 ,...
                                btn_height                              ];

        pos_pus_full(2,:) = pos_pus_full(1,:);
        pos_pus_full(2,2) = pos_pus_full(2,2)-btn_height;

        pos_pus_full(3,:) = pos_pus_full(1,:);
        pos_pus_full(3,1) = pos_pus_full(3,1)+pos_pus_full(3,3);

        pos_pus_full(4,:) = pos_pus_full(3,:);
        pos_pus_full(4,2) = pos_pus_full(4,2)-pos_pus_full(4,4);

        y_low           = y_low-2*btn_height-3*dy2;
        pos_tdrag       = [     x_left                  ,...
                                y_low                   ,...
                                w_subframe                              ,...
                                btn_height                              ];

        h_btn           = 1.25*btn_height;
        w_btn           = 1.25*push_width;
        x_btn           = x_frame0+(cmd_width-w_btn)/2;
        y_low           = y_low-h_btn;
        pos_pus_visu    = [x_btn , y_low , w_btn ,h_btn];
        y_low           = y_low-h_btn;
        pos_pus_big     = [x_btn , y_low , w_btn ,h_btn];
        y_low           = y_low-h_btn;
        pos_pus_rec     = [x_btn , y_low , w_btn ,h_btn];

        px              = x_frame0+(cmd_width-7*push_width/4)/2;
        pos_close       = [     px                                      ,...
                                pos_frame0(2)+btn_height                ,...
                                7*push_width/4                          ,...
                                3*btn_height/2                  ];

        xleft   = x_frame0+(cmd_width-2*Def_Btn_Width-dx-Def_Btn_Width/2.4)/2;
        ylow    = 5.5*Def_Btn_Height;

        pos_map_txt     = [     xleft,          ...
                                ylow,           ...
                                btn_width,      ...
                                btn_height];
        pos_pop_map     = pos_map_txt;
        pos_pop_map(1)  = pos_pop_map(1)+pos_map_txt(3);
        pos_txt_nbc     = pos_map_txt;
        pos_txt_nbc(2)  = pos_txt_nbc(2)-btn_height-dy;
        pos_sli_nbc     = [     pos_txt_nbc(1)+pos_txt_nbc(3),...
                                pos_txt_nbc(2)+dy               ,...
                                btn_width                       ,...
                                pos_txt_nbc(4)-dy2              ...
                                ];
        pos_edi_nbc     = [     pos_sli_nbc(1)+pos_sli_nbc(3)+dx,       ...
                                pos_txt_nbc(2),                         ...
                                btn_width/2.4,                  ...
                                btn_height                              ...
                                ];
        pos_txt_bri     = pos_txt_nbc;
        pos_txt_bri(2)  = pos_txt_bri(2)-btn_height-dy;
        pos_sli_bri     = [     pos_txt_bri(1)+pos_txt_bri(3),...
                                pos_txt_bri(2)+dy               ,...
                                btn_width                       ,...
                                pos_txt_bri(4)-dy2              ...
                                ];


        % String property of objects.
        %----------------------------
        str_input_txt   = 'Image';
        str_input_data  = '';
        str_wav_txt     = 'Wavelet';
        [str_wav_fams,...
        str_wav_nums]   = wavattrb('ini','dwt');
        str_lev_txt     = 'Level';
        str_lev_data    = [int2str(1)];
        for k=2:max_lev_anal
        str_lev_data    = str2mat(str_lev_data,int2str(k)); end;
        str_anal        = 'Analyze';
        str_synt        = 'Synthesize';

        str_stat        = 'Statistics';
        str_comp        = 'Compress';
        str_hist        = 'Histograms';
        str_deno        = 'De-noise';
 
        str_txtlev_dec  = 'Decomposition at level : ';
        str_vallev_dec  = str_lev_data;
        str_txt_drag    = 'Operations on selected image : ';
        str_rec         = 'Reconstruct';
        str_visu        = 'Visualize';
        str_big         = 'Full Size';
        str_pop_viewm   = 'View mode : Square|View mode : Tree';
        str_txt_full    = 'Full Size';
        str_txt_map     = 'Colormap';
        str_txt_nbc     = 'Nb. Colors';
        str_txt_bri     = 'Brightness';
        str_cfs_map     = Lst_ColorMap;
        str_edi_nbc     = int2str(size(get(win_dw2dtool,'Colormap'),1));
        str_close       = 'Close';

        % Backgroundcolor property of objects.
        %-------------------------------------
        bco_frame       = Def_FraBkColor;

        % Enable property of objects.
        %----------------------------
        ena_wav_fams    = 'off';
        ena_wav_nums    = 'off';
        ena_pop_lev     = 'off';
        ena_pus_anal    = 'off';
        ena_compress    = 'off';
        ena_denois      = 'off';
        ena_statistics  = 'off';
        ena_histograms  = 'off';
        ena_declev      = 'off';
        ena_showdec     = 'off';
        ena_rec         = 'off';
        ena_visu        = 'off';
        ena_big         = 'off';
        ena_pop_viewm   = 'off';
        ena_pus_full    = 'off';
        ena_cfs_map     = 'off';
        ena_sli_nbc     = 'off';
        ena_edi_nbc     = 'off';
        ena_sli_bri     = 'off';

        % Callback property of objects.
        %------------------------------
        action          = '';
        cba_pus_anal    = ['dw2dmngr(''analyze'',' str_numwin ');'];
        cba_stat        = ['dw2dmngr(''stat'',' str_numwin ');'];
        cba_comp        = ['dw2dmngr(''comp'',' str_numwin ');'];
        cba_hist        = ['dw2dmngr(''hist'',' str_numwin ');'];
        cba_deno        = ['dw2dmngr(''deno'',' str_numwin ');'];
        cba_pop_declev  = ['dw2dmngr(''view_dec'',' str_numwin ');'];
        cba_pop_viewm   = ['dw2dmngr(''view_mode'',' str_numwin ');'];

        % Command part of the window.
        %----------------------------
        figure(win_dw2dtool);
        txt_input_txt           = uicontrol(...
                                        'Style','text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_input_txt,...
                                        'String',str_input_txt,...
                                        'Backgroundcolor',bco_frame,...
                                        'Tag',tag_txt_input...
                                        );
        txt_input_data          = uicontrol(...
                                        'Style','text',...
                                        'Units',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_input_data,...
                                        'String',str_input_data,...
                                        'Backgroundcolor',Def_TxtBkColor,...
                                        'Tag',tag_input_data...
                                        );
        txt_wav_txt     = uicontrol(...
                                        'Style','text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_wav_txt,...
                                        'String',str_wav_txt,...
                                        'Backgroundcolor',bco_frame...
                                        );
        pop_wav_fams    = uicontrol(...
                                        'Style','Popup',...
                                        'Unit',win_units,...
                                        'Position',pos_wav_fams,...
                                        'String',str_wav_fams,...
                                        'Enable',ena_wav_fams,...
                                        'Tag',tag_wav_fams...
                                        );
        pop_wav_nums    = uicontrol(...
                                        'Style','Popup',...
                                        'Unit',win_units,...
                                        'Position',pos_wav_nums,...
                                        'String',str_wav_nums,...
                                        'Visible','off',...
                                        'Enable',ena_wav_nums,...
                                        'Tag',tag_wav_num...
                                        );
        txt_lev_txt     = uicontrol(...
                                        'Style','text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_lev_txt,...
                                        'String',str_lev_txt,...
                                        'Backgroundcolor',bco_frame...
                                        );
        pop_lev_data    = uicontrol(...
                                        'Style','Popup',...
                                        'Unit',win_units,...
                                        'Position',pos_lev_data,...
                                        'String',str_lev_data,...
                                        'Enable',ena_pop_lev,...
                                        'Tag',tag_pop_lev...
                                        );
        pus_anal        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_anal,...
                                        'String',str_anal,...
                                        'Enable',ena_pus_anal,...
                                        'Tag',tag_pus_anal,...
                                        'Interruptible','yes',...
                                        'Callback',cba_pus_anal...
                                        );
        drawnow

        pus_stat        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_stat,...
                                        'String',str_stat,...
                                        'Enable',ena_statistics,...
                                        'Tag',tag_pus_stat,...
                                        'Callback',cba_stat...
                                        );
        pus_comp        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_comp,...
                                        'String',str_comp,...
                                        'Enable',ena_compress,...
                                        'Tag',tag_pus_comp,...
                                        'Callback',cba_comp...
                                        );
        pus_hist        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_hist,...
                                        'String',str_hist,...
                                        'Enable',ena_histograms,...
                                        'Tag',tag_pus_hist,...
                                        'Callback',cba_hist...
                                        );
        pus_deno        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_deno,...
                                        'String',str_deno,...
                                        'Enable',ena_denois,...
                                        'Tag',tag_pus_deno,...
                                        'Callback',cba_deno...
                                        );

        txt_declev      = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'Position',pos_txt_declev,...
                                        'HorizontalAlignment','left',...
                                        'Backgroundcolor',bco_frame,...
                                        'String',str_txtlev_dec...
                                        );
        pop_declev      = uicontrol(...
                                        'Style','Popup',...
                                        'Unit',win_units,...
                                        'Position',pos_declev,...
                                        'String',str_vallev_dec,...
                                        'Enable',ena_declev,...
                                        'Tag',tag_pop_declev,...
                                        'Callback',cba_pop_declev...
                                        );

        pop_view_mode   = uicontrol(...
                                        'Style','Popup',...
                                        'Unit',win_units,...
                                        'Position',pos_pop_viewm,...
                                        'String',str_pop_viewm,...
                                        'Enable',ena_pop_viewm,...
                                        'Callback',cba_pop_viewm,...
                                        'Tag',tag_pop_viewm...
                                        );


        txt_full        = uicontrol(...
                                        'Style','text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','Center',...
                                        'Position',pos_txt_full,...
                                        'String',str_txt_full,...
                                        'Backgroundcolor',bco_frame,...
                                        'Tag',tag_txt_full...
                                        );

        for k=1:4
                pus_full(k) = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_pus_full(k,:),...
                                        'String',int2str(k),...
                                        'Enable',ena_pus_full,...
                                        'Userdata',0,...
                                        'Tag',tag_pus_full(k,:),...
                                        'Callback',action...
                                        );
        end


        txt_drag        = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'Position',pos_tdrag,...
                                        'HorizontalAlignment','left',...
                                        'String',str_txt_drag,...
                                        'Backgroundcolor',bco_frame...
                                        );

        pus_visu        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_pus_visu,...
                                        'String',str_visu,...
                                        'Enable',ena_visu,...
                                        'Tag',tag_pus_visu,...
                                        'Callback',action...
                                        );
        pus_big         = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_pus_big,...
                                        'String',str_big,...
                                        'Enable',ena_big,...
                                        'Tag',tag_pus_big,...
                                        'Callback',action...
                                        );

        pus_rec         = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_pus_rec,...
                                        'String',str_rec,...
                                        'Enable',ena_rec,...
                                        'Tag',tag_pus_rec,...
                                        'Callback',action...
                                        );

        drawnow;

        map_txt         = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'Position',pos_map_txt,...
                                        'HorizontalAlignment','left',...
                                        'Backgroundcolor',bco_frame,...
                                        'String',str_txt_map...
                                        );
        pop_cfs_map     = uicontrol(...
                                        'Style','Popup',...
                                        'Unit',win_units,...
                                        'Position',pos_pop_map,...
                                        'String',str_cfs_map,...
                                        'Enable',ena_cfs_map,...
                                        'Callback',action,...
                                        'Tag',tag_cfs_map...
                                        );

        txt_nbc         = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'Position',pos_txt_nbc,...
                                        'HorizontalAlignment','left',...
                                        'Backgroundcolor',bco_frame,...
                                        'String',str_txt_nbc...
                                        );
        
        sli_nbc         = uicontrol(...
                                        'Style','Slider',...
                                        'Unit',win_units,...
                                        'Position',pos_sli_nbc,...
                                        'Min',min_nbcolors,...
                                        'Max',max_nbcolors,...
                                        'Value',default_nbcolors,...
                                        'Enable',ena_sli_nbc,...
                                        'Tag',tag_sli_nbc...
                                        );                              

        edi_nbc         = uicontrol(...
                                        'Style','Edit',...
                                        'Unit',win_units,...
                                        'Backgroundcolor',Def_EdiBkColor,...
                                        'Position',pos_edi_nbc,...
                                        'String',str_edi_nbc,...
                                        'Enable',ena_edi_nbc,...
                                        'Callback',action,...
                                        'Tag',tag_edi_nbc...
                                        );
        
        txt_bri         = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'Position',pos_txt_bri,...
                                        'HorizontalAlignment','left',...
                                        'Backgroundcolor',bco_frame,...
                                        'String',str_txt_bri...
                                        );

        sli_bri         = uicontrol(...
                                        'Style','Slider',...
                                        'Unit',win_units,...
                                        'Position',pos_sli_bri,...
                                        'Min',min_bright,...
                                        'Max',max_bright,...
                                        'Value',default_bright,...
                                        'Enable',ena_sli_bri,...
                                        'Tag',tag_sli_bri...
                                        );

        pus_close       = uicontrol(...
                                        'Style','Pushbutton',           ...
                                        'Unit',win_units,               ...
                                        'Position',pos_close,           ...
                                        'String',str_close,             ...
                                        'Interruptible','yes',          ...
                                        'Callback',cba_close_menu,      ...
                                        'Tag',tag_btn_close             ...     
                                        );

        drawnow

        %  Normalisation.
        %----------------
        Pos_Graphic_Area = Pos_Graphic_Area./[pos_win(3:4),pos_win(3:4)];
        set(findobj(win_dw2dtool,'units','pixels'),'units','normalized');

        % Callbacks update.
        %------------------
        cba_pop_wav_fams = [    'wavattrb(''gettnum'','         ...
                                num2mstr(pop_wav_fams) ','      ...
                                num2mstr(pop_wav_nums) ');'];
        set(pop_wav_fams,'Callback',cba_pop_wav_fams);

        cba_pop_wav_nums = [    'wnumbtn(1,'            ...
                                num2mstr([pop_wav_fams pop_wav_nums]) ',' ...
                                num2mstr([m_files pus_anal]) ');'];
        set(pop_wav_nums,'Callback',cba_pop_wav_nums);

        cba_pop_cfs_map = [     'mapcolor(''pal'','     ...
                                str_numwin ','          ...
                                num2mstr(pop_cfs_map) ');'];

        cba_edi_nbc = [ 'mapcolor(''nbc'','             ...
                                str_numwin ','          ...
                                num2mstr([pop_cfs_map edi_nbc]) ');'];
        cba_sli_nbc = [ 'mapcolor(''nbc'','             ...
                                str_numwin ','          ...
                                num2mstr([pop_cfs_map sli_nbc]) ');'];
        cba_sli_bri = [ 'mapcolor(''lum'',' ...
                                str_numwin ',' ...
                                num2mstr(sli_bri) ');'];
        if ~strcmp(select_funct,drag_funct)
                cba_pus_visu = ['dw2dmngr(''select'','  ...
                                str_numwin ','  ...
                                num2mstr(pus_visu) ');'];
                cba_pus_big  = ['dw2dmngr(''select'','  ...
                                str_numwin ','  ...
                                num2mstr(pus_big) ');'];
                cba_pus_rec  = ['dw2dmngr(''select'','  ...
                                str_numwin ','  ...
                                num2mstr(pus_rec) ');'];
                set(pus_visu,'Callback',cba_pus_visu);
                set(pus_big,'Callback',cba_pus_big);
                set(pus_rec,'Callback',cba_pus_rec);
        end
        for k=1:4
                pus = pus_full(k);
                cba_pus_full = ['dw2dmngr(''fullsize'','        ...
                                        str_numwin ','  ...
                                        int2str(k) ');'];
                set(pus,'Callback',cba_pus_full);
        end
        set(pop_cfs_map,'Callback',cba_pop_cfs_map);
        set(edi_nbc,'Callback',cba_edi_nbc);
        set(sli_nbc,'Callback',cba_sli_nbc);
        set(sli_bri,'Callback',cba_sli_bri);

        % Memory for stored values.
        %--------------------------
        wmemtool('ini',win_dw2dtool,n_InfoInit,nb0_stored);
        wmemtool('ini',win_dw2dtool,n_param_anal,nb1_stored);
        wmemtool('ini',win_dw2dtool,n_miscella,nb3_stored);
        wmemtool('wmb',win_dw2dtool,n_param_anal,ind_act_option,option);
        wmemtool('wmb',win_dw2dtool,n_miscella,                 ...
                ind_graph_area,Pos_Graphic_Area,ind_view_status,'none', ...
                ind_save_status,'none',ind_sel_funct,select_funct       ...
                );

        % Setting Colormap.
        %------------------
        mapcolor('set',win_dw2dtool,'pink',...
                                [pop_cfs_map edi_nbc],default_nbcolors);


        % Creating AxeImgIni & AxeImgBig  & AxeImgVis & AxeImgSyn.
        %----------------------------------------------------------
        pos_axeini      = [0 0 1 1];
        Axe_ImgIni = axes(...
                                'Position',pos_axeini,                  ...
                                'Visible','off',                        ...
                                'DrawMode','Fast',                      ...
                                'Box','On',                             ...
                                'XTickLabels',[],'YTickLabels',[],      ...
                                'XGrid','off','YGrid','off',            ...
                                'Tag',tag_axeimgini                     ...
                                );
        pos_axevis      = [0 0 1 1];
        Axe_ImgVis = axes(...
                                'Position',pos_axevis,                  ...
                                'Visible','off',                        ...
                                'DrawMode','Fast',                      ...
                                'XTicklabelMode','manual',              ...
                                'YTicklabelMode','manual',              ...
                                'XTickLabels',[],'YTickLabels',[],      ...
                                'Xcolor',BoxTitleSel_Col,               ...
                                'Ycolor',BoxTitleSel_Col,               ...
                                'LineWidth',Width_LineSel,              ...
                                'Box','On',                             ...
                                'XGrid','off','YGrid','off',            ...
                                'Tag',tag_axeimgvis                     ...
                                );
        pos_axebig      = [0 0 1 1];
        Axe_ImgBig = axes(...
                                'Position',pos_axebig,                  ...
                                'Visible','off',                        ...
                                'DrawMode','Fast',                      ...
                                'XTicklabelMode','manual',              ...
                                'YTicklabelMode','manual',              ...
                                'XTickLabels',[],'YTickLabels',[],      ...
                                'Box','On',                             ...
                                'XGrid','off','YGrid','off',            ...
                                'Tag',tag_axeimgbig                     ...
                                );
        pos_axesyn      = [0 0 1 1];
        Axe_ImgSyn = axes(...
                                'Position',pos_axesyn,                  ...
                                'Visible','off',                        ...
                                'DrawMode','Fast',                      ...
                                'XTicklabelMode','manual',              ...
                                'YTicklabelMode','manual',              ...
                                'XTickLabels',[],'YTickLabels',[],      ...
                                'Box','On',                             ...
                                'XGrid','off','YGrid','off',            ...
                                'Tag',tag_axeimgsyn                     ...
                                );
        % Creating AxeImgSel
        %-------------------
        pos_axesel      = [0 0 1 1];
        Axe_ImgSel = axes(...
                                'Position',pos_axesel,                  ...
                                'Visible','off',                        ...     
                                'DrawMode','Fast',                      ...
                                'XTicklabelMode','manual',              ...
                                'YTicklabelMode','manual',              ...
                                'XTickLabels',[],'YTickLabels',[],      ...
                                'XTick',[],'YTick',[],'Box','On',       ...
                                'Tag',tag_axeimgsel                     ...
                                );

        % Creating AxeImgDec.
        %--------------------
        pos_axedec      = [0 0 1 1];
        Axe_ImgDec      = zeros(1,4*max_lev_anal);
        for ind=1:4*max_lev_anal
                Axe_ImgDec(ind)         = axes(...
                                                'Position',pos_axedec,  ...
                                                'Visible','off',        ...
                                                'DrawMode','Fast',      ...
                                                'XTicklabelMode','manual',...
                                                'YTicklabelMode','manual',...
                                                'XTickLabels',[],       ...
                                                'YTickLabels',[],       ...
                                                'XTick',[],'YTick',[],  ...
                                                'Box','On',             ...
                                                'XGrid','off',          ...
                                                'YGrid','off',          ...
                                                'Tag',tag_axeimgdec     ...
                                                );
        end
        wmemtool('put',win_dw2dtool,tag_axeimgdec,Axe_ImgDec);

        % Creating Tree axes.
        %-------------------
        axe_figutil = axes(...
                                'Position',[0 0 1 1],           ...
                                'Xlim',[0 1],'Ylim',[0 1],      ...
                                'DrawMode','Normal',            ...
                                'Visible','off',                ...
                                'Tag',tag_axefigutil            ...
                                );

        for k = 1:max_lev_anal+1
                line(...
                        'Xdata',[0 0],'Ydata',[0 0],    ...
                        'LineWidth',2,'Color','y',      ...
                        'Visible','off',                ...
                        'Userdata',k,                   ...
                        'Tag',tag_linetree              ...
                        );
        end

        Screen_Size = get(0,'ScreenSize');
        if Screen_Size(4)<700
                fontsize = 12;
        else
                fontsize = 16;
        end

        for k = 1:max_lev_anal
                text(...
                        'String',['L' int2str(k)],      ...
                        'FontSize',fontsize,            ...
                        'FontWeight','bold',            ...
                        'HorizontalAlignment','left',   ...
                        'Visible','off',                ...
                        'Userdata',k,                   ...
                        'Color',Def_AxeXColor,...
                        'Tag',tag_txttree               ...
                        );
        end

        dw2darro('ini_arrow',win_dw2dtool);
        wboxtitl('create',axe_figutil,Axe_ImgSel,BoxTitleSel_Col,...
                                'Image Selection','off');

        % Precompilation.
        %---------------
        dw2dmngr('compile');
        dw2dimgs('compile');

        % End waiting.
        %---------------
        wwaiting('off',win_dw2dtool);

%***********************************************%
%** OPTION = 'close' - close dw2dtool window  **%
%***********************************************%
elseif strcmp(option,'close')
        called_win = findobj(get(0,'children'),'flat','Userdata',in2);
        close(called_win);

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('dw2dtool','Unknown Option','msg');
        error('*');
end
