function extaxe(lst_axe,in2)
%EXTAXE Extend axe functionalities.
%       extaxe(A)
%       A = vector of axes handles.

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:10:59 $

%       Uses ERRARGN, EXTTXT, MNGAXE, NUM2MSTR, WSETAXE.

%       Callbacks WSETAXE.

% Check arguments.
if errargn('extaxe',nargin,[1 2],nargout,[0]), error('*'), end

eval('lst_axe = findobj(lst_axe,''flat'');','lst_axe = [];');
if isempty(lst_axe) , return; end
if nargin==1 , in2 = 'on'; end
if strcmp(lower(in2),'off') , vis = 'off'; else vis = 'on'; end
for k=1:length(lst_axe)
        axe     = lst_axe(k);           
        txt     = findobj(axe,'type','text');
        exttxt(txt);
        btn      = mngaxe('gstb',axe);
        if isempty(btn)
                fig = get(axe,'Parent');
                action = ['wsetaxe(''define'',' num2mstr(axe) ');'];
                btn = uicontrol(fig,...
                                        'Style','PushButton',           ...
                                        'Units','normalized',           ...
                                        'Visible',vis,                  ...
                                        'UserData',axe,                 ...
                                        'Tag','Btn_Axe_Set',            ...
                                        'Callback',action);
        end
        mngaxe('posb',axe,btn);
end
