function extfig(fig,in2,in3,in4)
%EXTFIG Extend figure functionalities.
%       extfig(fig,in2,in3,in4)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.

%       Uses ERRARGN, EXTAXE, EXTTXT, MNGFIG, MNGTXT, NUM2MSTR, WFINDMEN
%            WSETFIG, WSETPRI.

if errargn('extfig',nargin,[0 1 2 4],nargout,[0]), error('*'); end

% Tag property of objects.
%------------------------
tag_fig_title   = 'Txt_Fig_Title';
tag_txt_note    = 'Txt_Note';
tag_m_options   = 'M_Options';
tag_m_windows   = 'M_Windows';
tag_m_extaxe    = 'M_ExtAxe';
tag_m_prnset    = 'M_PrnSet';
tag_m_zoom      = 'M_Zoom';


if nargin==0 , fig = gcf; end
wins    = get(0,'children');
if isempty(wins) , return; end
if isempty(find(wins==fig)) , return; end
strfig  = int2str(fig);

% Menu 1
%-------
flg_files       = 0;
        flg_sprn        = 0;
        flg_print       = 0;
        flg_close       = 0;

% Menu 2
%-------
flg_options     = 0;
        flg_textnote    = 0;
        flg_zoom        = 0;
                flg_nzoom       = 0;
                flg_szoom       = 0;
                flg_dynv        = 0;
        flg_hgset       = 0;
                flg_wset        = 0;
                flg_aset        = 0;
                flg_tset        = 0;
        flg_grid        = 0;

% Menu 3
%-------
flg_windows     = 0;

if nargin<3     % Old version
        if      nargin==0 | nargin==1
                win_type = 0;
        elseif nargin==2
                win_type = in2;
                if isempty((find(win_type)==[0 1 2 3 4 5 6])) , win_type = 0; end
        end
        if find(win_type==[0:6])        
                flg_files       = 1;
                if find(win_type==[2:6])
                        flg_sprn        = 1;
                        flg_print       = 1;
                end
        end
        if find(win_type==[1:6])        
                flg_options     = 1;
                        if win_type>3 , flg_textnote = 1; end
                        flg_zoom        = 1;
                                flg_nzoom       = 1;
                                flg_szoom       = 1;
                                if find(win_type==[3:6]) , flg_dynv = 1; end
                        flg_hgset       = 1;
                                flg_wset        = 1;
                                flg_aset        = 1;
                                flg_tset        = 1;
                        flg_grid        = 1;


        end
        if find(win_type==[2:6]), flg_windows = 1; end

elseif nargin==4
        if ~isempty(in2)
                flg_files = 1;
                if findstr(in2,'p')
                        flg_sprn        = 1;
                        flg_print       = 1;
                end     
        end
        if ~isempty(in3)
                flg_options = 1;
                        if findstr(in2,'t') , flg_textnote = 1; end
                        if findstr(in3,'z')
                                flg_zoom        = 1;
                                        flg_nzoom       = 1;
                                        flg_szoom       = 1;
                                        if findstr(in3,'d') , flg_dynv = 1; end
                        end
                        flg_hgset       = 1;
                                flg_wset        = 1;
                                flg_aset        = 1;
                                flg_tset        = 1;
                        flg_grid        = 1;


        end
        if ~isempty(in4) , flg_windows = 1; end
end

pos_m1 = 1;
if flg_files
        pos_files       = pos_m1;
        pos_m1          = pos_m1+1;
        flg_close       = 1;
        pos_close       = 1;
        if flg_print
                pos_sprn        = 1;
                pos_print       = 2;
                pos_close       = 3;
        end   
end
if flg_options
        pos_options     = pos_m1;
        pos_m1          = pos_m1+1;
        pos_m2          = 1;
        if flg_textnote
                pos_textnote    = pos_m2; pos_m2 = pos_m2+1;
        end
        if flg_zoom
                pos_zoom        = pos_m2; pos_m2 = pos_m2+1;
                pos_m3          = 1;
                if flg_nzoom
                        pos_nzoom = pos_m3; pos_m3 = pos_m3+1;
                end
                if flg_szoom
                        pos_szoom = pos_m3; pos_m3 = pos_m3+1;
                end
                if flg_dynv
                        pos_dynv = pos_m3; pos_m3 = pos_m3+1;
                end
        end
        if flg_hgset
                pos_hgset       = pos_m2; pos_m2 = pos_m2+1;
                pos_m3          = 1;
                if flg_wset
                        pos_wset = pos_m3; pos_m3 = pos_m3+1;
                end
                if flg_aset
                        pos_aset = pos_m3; pos_m3 = pos_m3+1;
                end
                if flg_tset
                        pos_tset = pos_m3; pos_m3 = pos_m3+1;
                end
        end
        if flg_grid
                pos_grid        = pos_m2; pos_m2 = pos_m2+1;
        end
end

if flg_windows
        pos_windows     = pos_m1;
        pos_m1          = pos_m1+1;
end

% Labels for Menus.
%------------------
lab_m_files     = '  File   ';
        lab_m_sprn      = 'Print Settings ';
        lab_m_print     = 'Print ';
        lab_m_close     = 'Close ';

lab_m_options   = '  Options';
        lab_m_textnote  = 'Text Note ';
        lab_m_zoom      = 'Zoom Preference ';
                lab_m_nzoom     = 'None';
                lab_m_szoom     = 'Standard Zoom';
                lab_m_dynv      = 'Dyn. Visu. Tool ';
        lab_m_hgset     = 'Handle Graphics Settings ';
                lab_m_wset      = 'Window Settings ';
                lab_m_aset      = 'Enable Axes Settings ';
                lab_m_tset      = 'Enable Texts Settings ';
        lab_m_grid      = 'Grid ';

lab_m_windows   = '  Windows';

% CallBacks for Menus.
%------------------
cb_sprn         = ['wsetpri(''define'',' strfig ');'];
cb_print        = ['wsetpri(''print'',' strfig ');'];
cb_close        = ['close(' strfig ');'];
cb_textnote     = '';   % FORWARD
cb_nzoom        = ['mngfig(''zoom'',' strfig ',''none'');'];
cb_szoom        = ['mngfig(''zoom'',' strfig ',''szoom'');'];
cb_dynv         = ['mngfig(''zoom'',' strfig ',''dynv'');'];
cb_wset         = ['wsetfig(''define'',' strfig ');'];
cb_aset         = '';   % FORWARD
cb_tset         = ['mngfig(''exttxt'',' strfig ');'];
cb_grid         = '';   % FORWARD


lst_lev0 = findobj(fig,'type','uimenu','Parent',fig);
m_close = [];
if ~isempty(lst_lev0)
        if flg_files
                m_files = wfindmen(lst_lev0,lab_m_files);
                if m_files~=0
                        flg_files = 0;
                        lst_m = findobj(m_files,...
                                'type','uimenu','Parent',m_files);
                        m_close = wfindmen(lst_m,lab_m_close);
                        if m_close~=0 , flg_close = 0; end 
                        if flg_print 
                                m_sprn = wfindmen(lst_m,lab_m_sprn);
                                m_print = wfindmen(lst_m,lab_m_print);
                                if m_sprn~=0 ,   flg_sprn = 0;   end
                                if m_print~=0 ,  flg_print = 0; end
                        end
                end
        end

        if flg_options
                m_options = wfindmen(lst_lev0,lab_m_options);
                if m_options~=0
                        flg_options = 0;
                        lst_m = findobj(m_options,'type','uimenu',...
                                                'Parent',m_options);
                        m_txtnote = wfindmen(lst_m,lab_m_textnote);
                        if m_txtnote~=0 , flg_textnote = 0;     end
                        if flg_zoom
                                m_zoom = wfindmen(lst_m,lab_m_zoom);
                                if m_zoom~=0
                                        flg_zoom = 0;
                                        lst_zm = findobj(m_zoom,        ...
                                                        'type','uimenu',...
                                                        'Parent',m_zoom ...
                                                        );
                                        m_nzoom = wfindmen(lst_zm,lab_m_nzoom);
                                        if m_nzoom~=0 , flg_nzoom = 0; end
                                        m_szoom = wfindmen(lst_zm,lab_m_szoom);
                                        if m_szoom~=0 , flg_szoom = 0; end
                                        if flg_dynv
                                                m_dynv = wfindmen(lst_zm,lab_m_dynv);
                                                if m_dynv~=0 , flg_dynv = 0; end
                                        end
                                end
                        end
                        if flg_hgset
                                m_hgset = wfindmen(lst_m,lab_m_hgset);
                                if m_hgset ~=0
                                        flg_hgset = 0;
                                        lst_sub = findobj(m_hgset,      ...
                                                        'type','uimenu',...
                                                        'Parent',m_hgset...
                                                        );
                                        m_wset = wfindmen(lst_sub,lab_m_wset);
                                        if m_wset~=0 , flg_wset = 0; end
                                        m_aset = wfindmen(lst_sub,lab_m_aset);
                                        if m_aset~=0 , flg_aset = 0; end
                                        m_tset = wfindmen(lst_sub,lab_m_tset);
                                        if m_tset~=0 , flg_tset = 0; end
                                end
                        end
                        m_grid = wfindmen(lst_m,lab_m_grid);
                        if m_grid~=0 ,  flg_grid = 0;   end
                end
        end
        if flg_windows
                m_windows = wfindmen(lst_lev0,lab_m_windows);
                if m_windows~=0 , flg_windows = 0; end
        end
end

if flg_files
        m_files         = uimenu(fig,...
                                        'Label',lab_m_files,...
                                        'Position',pos_files...
                                        );
end
if flg_sprn
        m_sprn  = uimenu(m_files,...
                                        'Label',lab_m_sprn,     ...
                                        'Position',pos_sprn,    ...
                                        'Separator','On',       ...
                                        'Userdata','',          ...
                                        'Tag',tag_m_prnset,     ...
                                        'CallBack',cb_sprn      ...
                                        );
end
if flg_print
        m_print         = uimenu(m_files,...
                                        'Label',lab_m_print,...
                                        'Position',pos_print,...
                                        'Interruptible','yes',...
                                        'CallBack',cb_print...
                                        );
end
if flg_close
        m_close         = uimenu(m_files,...
                                        'Label',lab_m_close,    ...
                                        'Separator','On',       ...
                                        'Position',pos_close,   ...
                                        'CallBack',cb_close     ...
                                        );
end
if flg_options
        m_options       = uimenu(fig,...
                                        'Label',lab_m_options,  ...
                                        'Position',pos_options, ...
                                        'tag',tag_m_options     ...
                                        );
end

if flg_textnote
        m_textnote      = uimenu(m_options,...
                                        'Label',lab_m_textnote,...
                                        'Position',pos_textnote,...
                                        'CallBack',cb_textnote...
                                        );
        postxt          = [0.01 0.5 0.98 0.45];
        t               = uicontrol(fig,...
                                        'Style','Edit',         ...
                                        'Units','normalized',   ...
                                        'Position',postxt,      ...
                                        'Min',0,'Max',100,      ...
                                        'ForeGroundColor','k',  ...
                                        'BackGroundColor','w',  ...
                                        'Visible','Off',        ...
                                        'Tag',tag_txt_note      ...
                                        );
        cb_textnote     = ['mngtxt(''edit'',' num2mstr(t) ');'];
        set(m_textnote,'Callback',cb_textnote);
end
if flg_zoom
        m_zoom          = uimenu(m_options,...
                                        'Label',lab_m_zoom,     ...
                                        'Position',pos_zoom,    ...
                                        'tag',tag_m_zoom        ...
                                        );
end
if flg_nzoom
        m_nzoom         = uimenu(m_zoom,...
                                        'Label',lab_m_nzoom,    ...
                                        'Position',pos_nzoom,   ...
                                        'Callback',cb_nzoom     ...
                                        );
end
if flg_szoom
        m_szoom         = uimenu(m_zoom,...
                                        'Label',lab_m_szoom,    ...
                                        'Position',pos_szoom,   ...
                                        'Callback',cb_szoom     ...
                                        );
end
if flg_dynv
        m_dynv          = uimenu(m_zoom,...
                                        'Label',lab_m_dynv,     ...
                                        'Position',pos_dynv,    ...
                                        'Checked','On',         ...
                                        'Callback',cb_dynv      ...
                                        );
end

if flg_hgset
        m_hgset         = uimenu(m_options,...
                                        'Label',lab_m_hgset,    ...
                                        'Position',pos_hgset    ...
                                        );
end
if flg_wset
        m_wset          = uimenu(m_hgset,...
                                        'Label',lab_m_wset,...
                                        'Position',pos_wset,...
                                        'CallBack',cb_wset...
                                        );
end
if flg_aset
        m_aset          = uimenu(m_hgset,...
                                        'Label',lab_m_aset,     ...
                                        'Position',pos_aset,    ...
                                        'Interruptible','yes',  ...
                                        'Userdata','',          ...
                                        'tag',tag_m_extaxe      ...
                                        );
        cb_aset         = ['mngfig(''extaxe'',' strfig ',' ...
                                        num2mstr(m_aset) ',''on'');'];
        set(m_aset,'CallBack',cb_aset);
end
if flg_tset
        m_tset          = uimenu(m_hgset,...
                                        'Label',lab_m_tset,...
                                        'Position',pos_tset,...
                                        'CallBack',cb_tset...
                                        );
end

if flg_grid
        m_grid          = uimenu(m_options,...
                                        'Label',lab_m_grid,     ...
                                        'Position',pos_grid,    ...
                                        'Separator','on'        ...
                                        );
        cb_grid         = ['mngfig(''gridaxes'',' strfig ',' ...
                                        num2mstr(m_grid) ');'];
        set(m_grid,'CallBack',cb_grid);
end

if flg_windows
        m_windows       = uimenu(fig,...
                                        'Label',lab_m_windows,...
                                        'Position',pos_windows,...
                                        'Tag',tag_m_windows ...
                                        );
        mngfig('fig_stack',fig,'push',lab_m_windows);
        set(m_close,'Callback',...
                ['mngfig(''close'',' strfig ',' num2mstr(m_windows) ');']);
end
%------- Figure title (for printing) -------%
uicontrol(fig,...
                'Style','Text',         ...
                'Visible','Off',        ...
                'String','',            ...
                'Tag',tag_fig_title     ...
                );
