function NBC = mapcolor(option,fig,in3,in4,in5);
%MAPCOLOR Colormap utilities.
%       NBC = mapcolor(option,fig,in3,in4,in5)
%       option :
%               'pal' : change the colormap.
%               'lum' : change the brigthness.
%               'nbc' : change the number of colors.
%               'set' : sets colormap.
%       fig = handle de la figure
%       Hdl = handle(s) du (des) bouton(s) utilise(s)
%       NBC = nombre de couleurs

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:12:42 $

%       Uses ERRARGT, DEBLANKL, MAPCOLOR.

% Tagged Objects.
%----------------
%       'Edi_NBColors'
%       'Sli_NBColors'
%       'Pop_ColorMap'

if isempty(find(get(0,'Children')==fig)) , return; end
mincol = 2;
maxcol = 512;

if option=='nbc'
        edi_nbc = findobj(fig,'Style','edit','Tag','Edi_NBColors');
        sli_nbc = findobj(fig,'Style','slider','Tag','Sli_NBColors');
        pop_pal = findobj(fig,'Style','popupmenu','Tag','Pop_ColorMap');
        max_sli = get(sli_nbc,'Max');

        Hdl = in3;
        pop    = Hdl(1);
        if length(Hdl)==1
                if nargin==4
                        NBC = mapcolor('pal',fig,pop,in4);
                else
                        NBC = mapcolor('pal',fig,pop);
                end
                return; 
        end 
        e_or_s = Hdl(2);
        st = get(e_or_s,'style');
        if strcmp(st,'edit')
                nbcol = str2num(get(e_or_s,'String'));
                continu = 1;
                if isempty(nbcol)
                        continu = 0;
                elseif (nbcol <mincol ) | (nbcol>maxcol)
                        continu = 0 ;
                elseif nbcol>max_sli
                        nbcol = max_sli;
                        set(e_or_s,'String',int2str(nbcol));
                end
                if ~continu
                        map = get(fig,'Colormap');
                        nbcol = size(map,1);
                        set(e_or_s,'String',int2str(nbcol));
                        return;
                end
                if ~isempty(sli_nbc) , set(sli_nbc,'Value',nbcol); end
        elseif strcmp(st,'slider')
                nbcol = round(get(e_or_s,'Value'));
                if ~isempty(edi_nbc) , set(edi_nbc,'String',int2str(nbcol)); end
        end
        NBC = mapcolor('pal',fig,pop,nbcol);

elseif option=='pal'
        Hdl = in3;
        map = get(fig,'Colormap');
        if nargin==3 ,  NBC = size(map,1); else NBC = in4; end
        val  = get(Hdl,'Value');
        name = get(Hdl,'String');
        name = deblankl(name(val,:));
        if strcmp(name,'self')
                map = get(Hdl,'Userdata');
                nbcol = size(map,1);
                edi_nbc = findobj(fig,'Style','edit','Tag','Edi_NBColors');
                sli_nbc = findobj(fig,'Style','slider','Tag','Sli_NBColors');
                if ~isempty(sli_nbc) , set(sli_nbc,'Value',nbcol); end
                if ~isempty(edi_nbc) , set(edi_nbc,'String',int2str(nbcol)); end

        elseif name(1:2)=='1-'
                name = name(3:length(name));
                map = 1-feval(name,NBC);

        else
                map = feval(name,NBC);
        end
        figure(fig);
        colormap(map);

elseif option=='lum'
        Hdl = in3;
        val  = get(Hdl,'Value')/10;
        set(Hdl,'Value',0);
        figure(fig);
        brighten(val);

elseif option=='set'
        edi_nbc = findobj(fig,'Style','edit','Tag','Edi_NBColors');
        sli_nbc = findobj(fig,'Style','slider','Tag','Sli_NBColors');
        pop_pal = findobj(fig,'Style','popupmenu','Tag','Pop_ColorMap');
        max_sli = get(sli_nbc,'Max');
        namepal = in3;
        Hdl = in4;
        pop = Hdl(1);
        if nargin==4 ,  NBC = size(map,1); else NBC = in5; end
        map = get(fig,'Colormap');
        nb_inmap = size(map,1);
        if isempty(NBC)
                NBC = nb_inmap;
        elseif NBC<mincol
                NBC = nb_inmap;
        elseif NBC>maxcol
                NBC = nb_inmap;
        end
        if NBC>max_sli , NBC = max_sli; end
        name = get(pop,'String');
        ind = 0;
        for k = 1:size(name,1)
                if strcmp(deblankl(namepal),deblankl(name(k,:)))
                        ind = k; break;
                end
        end
        if ind
                set(pop,'Value',ind);
                if ~isempty(edi_nbc) , set(edi_nbc,'String',int2str(NBC)); end
                if ~isempty(sli_nbc) , set(sli_nbc,'Value',NBC); end
                NBC = mapcolor('nbc',fig,Hdl,NBC);
        end

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('mapcolor','Unknown Option','msg');
        error('*');
end
