function mexhinfo
%MEXHINFO Information on mexican hat wavelet.
%
%       Mexican hat Wavelet
%
%       Definition: second derivative of the Gaussian 
%       probability density function
%
%       mexh(x) = c * exp(-x^2/2) * (1-x^2)
%       where c = 2/(sqrt(3)*pi^0.25) 
%
%       Family                  Mexican hat
%       Short name              mexh
%
%       Orthogonal              no
%       Biorthogonal            no
%       Compact support         no
%       DWT                     no
%       CWT                     possible
%
%       Support width           infinite
%       Effective support       [-5 5]
%       Symmetry                yes
%
%       Reference: I. Daubechies, 
%       Ten lectures on wavelets, 
%       CBMS, SIAM, 61, 1994, 75.

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:12:47 $
