function mextglob(option,in2)
%MEXTGLOB Module of extended objects globals.
%       mextglob(option,in2)

%       Uses ERRARGT, MEXTGLOB, WSHOWMSG.

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:12:58 $

%       Uses ERRARGT.

global Init_Globals

if      strcmp(option,'ini')
        if      isempty(Init_Globals)
                if nargin==1 ,  pref = 1; else , pref = in2; end
        else
                if      nargin==2
                        if      Init_Globals==in2
                                return; 
                        elseif  isempty(in2)
                                return;
                        else
                                pref = in2;
                        end
                        option = 'pref';
                else
                        return;
                end
        end
        
elseif  strcmp(option,'pref')
        if      isempty(Init_Globals)
                option = 'ini';
                if nargin==1 ,  pref = 1; else , pref = in2; end
        else
                if      nargin==2
                        if      Init_Globals==in2
                                return; 
                        elseif  isempty(in2)
                                return;
                        else
                                pref = in2;
                        end
                else
                        return;
                end
        end

elseif  strcmp(option,'clear')

else
        errargt('mextglob','Unknown Option','msg');
end

global  ...
        Mat_Version     ShiftTop_Fig    ...
        Machine         Terminal_Prop   ...
        Def_Btn_Height  Def_Btn_Width   Pop_Min_Width   ...
        X_Spacing       Y_Spacing                       ...
        X_Graph_Ratio   Y_Graph_Ratio                   ...
        Lst_ColorMap                    ...
        Def_UICBkColor  Def_TxtBkColor  Def_EdiBkColor  ...
        Def_FraBkColor  Def_FraFgColor                  ...
        Def_FigColor    Def_FigNumTit   Def_FigBackSto  ...
        Def_AxeXColor   Def_AxeYColor   Def_AxeZColor   ...
        Def_AxeFontSize Def_TxtColor    Def_TxtFontSize ...
        Def_ZoomColor

if strcmp(option,'ini')
        continu = 1;
        matver  = version;
        Mat_Version  = str2num(matver(1:3));
        if      Mat_Version<4.2
                continu = 0;
        elseif  Mat_Version==4.2
                if      length(matver)==3 ,       continu = 0;
                elseif  abs(matver(4))<abs('c'),  continu = 0;
                end
                ShiftTop_Fig = 0;
        else    % Version 5
                ShiftTop_Fig = 0;
                eval('warning off; err = 0;','err = 1;');        
        end
        if continu==0
                errargt('Wavelet ToolBox',...
                        ['Invalid Matlab Version : ' matver],'msg');
                mextglob('clear');
                error('*');
                return;
        end
        Init_Globals = 0;
        Machine = computer;

        Screen_Size = get(0,'Screensize');
        if      Screen_Size(4) < 600
                Def_Btn_Height  = 16;
                Def_Btn_Width   = 60;
                Pop_Min_Width   = 50;
                X_Spacing       = 2;
                Y_Spacing       = 2;
                Def_AxeFontSize = 8;
                Def_TxtFontSize = 8;

        elseif  Screen_Size(4) <=700
                Def_Btn_Height  = 18;
                Def_Btn_Width   = 70;
                Pop_Min_Width   = 60;
                X_Spacing       = 3;
                Y_Spacing       = 3;
                Def_AxeFontSize = 8;
                Def_TxtFontSize = 8;

        elseif  Screen_Size(4) > 700
                Def_Btn_Height  = 22;
                Def_Btn_Width   = 80;
                Pop_Min_Width   = 60;
                X_Spacing       = 8;
                Y_Spacing       = 5;
                Def_AxeFontSize = 10;
                Def_TxtFontSize = 10;
        end
        X_Graph_Ratio   = 0.71;
        Y_Graph_Ratio   = 1;
        Def_FigNumTit   = 'off';

        Def_UICBkColor  = get(0,'DefaultUicontrolBackgroundcolor');
        if      strcmp(Machine(1:3),'PCW')
                set(0,'Defaultfiguremenubar','none');
                Def_FigBackSto  = 'On';
                Def_TxtBkColor  = [0.75 0.75 0.75];
                if Mat_Version>4.2
                        Def_TxtBkColor  = [247/255 247/255 247/255];
                end
                Def_FraBkColor  = Def_UICBkColor;
                Terminal_Prop   = Screen_Size(3:4);
        elseif  strcmp(Machine(1:3),'MAC')
                set(0,'Defaultfiguremenubar','none');
                Def_FigBackSto  = 'Off';
                Def_TxtBkColor  = [0.90 0.90 0.90];
                Def_FraBkColor  = [0.77 0.77 0.77];
                Terminal_Prop   = Screen_Size(3:4);

        else
                Def_FigBackSto  = 'Off';
                Def_TxtBkColor  = [0.90 0.90 0.90];
                Def_FraBkColor  = [0.77 0.77 0.77];
                Terminal_Prop   = get(0,'TerminalDimension');
        end
        set(0,'DefaultAxesXGrid','Off');
        set(0,'DefaultAxesYGrid','Off');
        Def_PusBkColor  = Def_UICBkColor;
        Def_EdiBkColor  = [1 1 1];
        Def_FraFgColor  = [0 0 0];
        Def_SfraBkColor = Def_FraBkColor;
        Def_SfraFgColor = Def_FraFgColor;
        Def_TxtHAlign   = 'center';
        Def_UICHAlign   = 'center';

        Lst_ColorMap    = str2mat('pink','cool','gray','hot',...
                                        'jet','bone','copper','hsv','prism');
        Lst_ColorMap    = str2mat(Lst_ColorMap,...
                                 '1 - pink','1 - cool','1 - gray',...
                                 '1 - hot','1 - jet','1 - bone');

        if isempty(pref) , pref = 1; end 
        mextglob('pref',pref);

elseif strcmp(option,'pref')
% in2 = preference.
%----------------------
        if     isempty(in2) ,      in2 =   1;
        elseif isstr(in2)   ,      in2 = 'm';  % monochrome
        elseif (in2<1) | (in2>8) , in2 =   1;
        end
        Init_Globals = in2;
        if     find(in2==[1 2 3 4 5])
               if     in2==1, Def_FigColor = get(0,'DefaultFigureColor');
               elseif in2==2, Def_FigColor = [0.2 0.3 0.5];
               elseif in2==3, Def_FigColor = [0.5 0.5 0.5];
               elseif in2==4, Def_FigColor = [0.5 0.3 0.2];
               elseif in2==5, Def_FigColor = [0.3 0.5 0.2];
               end
               Def_AxeXColor = 'w'; Def_AxeYColor = 'w'; Def_AxeZColor = 'w';
               Def_TxtColor  = 'w'; Def_ZoomColor ='r';
               if     strcmp(Machine(1:3),'PCW')
                      Def_TxtBkColor  = [0.75 0.75 0.75];
                      if Mat_Version>=5
                         Def_TxtBkColor  = [247/255 247/255 247/255];
                      end
                      Def_FraBkColor  = Def_UICBkColor;
               elseif in2==1 | in2==3
                      Def_TxtBkColor  = [0.90 0.90 0.90];
                      Def_FraBkColor  = [0.77 0.77 0.77];
               else
                      Def_TxtBkColor  = Def_FigColor.^0.3;
                      Def_FraBkColor  = Def_FigColor.^0.4;
                      set(0,'DefaultUicontrolBackgroundcolor',Def_TxtBkColor);
                      set(0,'DefaultUimenuBackgroundcolor',Def_FraBkColor);
               end

        elseif find(in2==[6 7 8])
               if     in2==6 , Def_FigColor = 'w';
               elseif in2==7 , Def_FigColor = [1 0.9 0.8];
               elseif in2==8 , Def_FigColor = [0.9 0.9 1];
               end
               Def_AxeXColor = 'k'; Def_AxeYColor = 'k'; Def_AxeZColor = 'k';
               Def_TxtColor  = 'k'; Def_ZoomColor = 'r';
               if     strcmp(Machine(1:3),'PCW')
                      Def_TxtBkColor  = [0.75 0.75 0.75];
                      if Mat_Version>=5
                         Def_TxtBkColor  = [247/255 247/255 247/255];
                      end
                      Def_FraBkColor  = Def_UICBkColor;
               elseif in2==6
                      Def_TxtBkColor  = [0.90 0.90 0.90];
                      Def_FraBkColor  = [0.77 0.77 0.77];
               else
                      Def_TxtBkColor  = Def_FigColor.^4;
                      Def_FraBkColor  = Def_FigColor.^3;
                      set(0,'DefaultUicontrolBackgroundcolor',Def_TxtBkColor);
                      set(0,'DefaultUimenuBackgroundcolor',Def_FraBkColor);
               end

        elseif in2=='m'  % monochrome
               Def_FigColor   = get(0,'DefaultFigureColor');
               Def_AxeXColor  = 'w'; Def_AxeYColor = 'w'; Def_AxeZColor = 'w';
               Def_TxtColor   = 'w'; Def_ZoomColor ='r';
               Def_TxtBkColor = [0.90 0.90 0.90];
               Def_FraBkColor = [0.77 0.77 0.77];
               set(0,'DefaultUicontrolBackgroundcolor',Def_FraBkColor);
               set(0,'DefaultUimenuBackgroundcolor',Def_FraBkColor);
        end

elseif strcmp(option,'clear')
        set(0,'DefaultUicontrolBackgroundcolor','remove');
        set(0,'DefaultUimenuBackgroundcolor','remove');
        set(0,'DefaultAxesXGrid','remove');
        set(0,'DefaultAxesYGrid','remove');
        clear global Init_Globals
        clear global  ...
                Mat_Version     ShiftTop_Fig    ...
                Machine         Terminal_Prop   ...
                Def_Btn_Height  Def_Btn_Width   Pop_Min_Width   ...
                X_Spacing       Y_Spacing                       ...
                X_Graph_Ratio   Y_Graph_Ratio                   ...
                Lst_ColorMap                    ...
                Def_UICBkColor  Def_TxtBkColor  Def_EdiBkColor  ...
                Def_FraBkColor  Def_FraFgColor                  ...
                Def_FigColor    Def_FigNumTit   Def_FigBackSto  ...
                Def_AxeXColor   Def_AxeYColor   Def_AxeZColor   ...
                Def_AxeFontSize Def_TxtColor    Def_TxtFontSize ...
                Def_ZoomColor
        global DWT_Ext_Mode
        if isempty(DWT_Ext_Mode) , clear global DWT_Ext_Mode; end

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('mextglob','Unknown Option','msg');
        error('*');
end
