function meyrinfo
%MEYRINFO Information on Meyer wavelet.
%
%       Meyer Wavelet
%
%       General characteristics: Infinitely regular orthogonal wavelet.
%
%       Family                  Meyer
%       Short name              meyr
%
%       Orthogonal              yes
%       Biorthogonal            yes
%       Compact support         no
%       DWT                     possible but without FWT
%       CWT                     possible
%
%       Support width           infinite
%       Effective support       [-8 8]
%       Regularity              indefinitely derivable
%       Symmetry                yes
%
%       Reference: I. Daubechies, 
%       Ten lectures on wavelets, 
%       CBMS, SIAM, 61, 1994, 117-119, 137, 152.

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:13:13 $

