function out1 = mngaxe(option,axe,in3);
%MNGAXE Manage axe modifications.
%       out1 = mngaxe(option,axe,in3);
%       option = 'gstb' : recherche le handle de la barre associee a l'axe.
%               out1 = [] si pas de barre, sinon out1 = handle.
%       option = 'posb' : positionnement de la barre associee a l'axe.
%                       Le handle de la barre est donnee par in3.
%       option = 'del'  : destruction de la barre associee a l'axe.
%                       (si elle existe) et de l'axe.
%       option = 'delbtn'  : destruction de la barre associee a l'axe.
%       option = 'del_in'  : de tout ce qui est dans l'axe et barre (option) .
%       option = 'vis_on'  : axe et barre associee visibles.
%       option = 'vis_off' : axe et barre associee invisibles.
%       option = 'pos' .
%       option = 'vis' .

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:13:19 $

%       Uses ERRARGT, MNGAXE.

tag_btnset = 'Btn_Axe_Set';

%************************************************************%
%** OPTION = 'gstb' : recherche la barre associee a l'axe. **%
%************************************************************%
if strcmp(option,'gstb')
        fig = get(axe(1),'Parent');
        btn = findobj(fig,'Style','pushbutton','Tag',tag_btnset);
        out1 = [];
        for k = 1:length(axe)
                out1 = [out1 findobj(btn,'Userdata',axe(k))];
        end

%*********************%
%** OPTION = 'vis'. **%
%*********************%
elseif strcmp(option,'vis')
        % in3 = visible value
        %--------------------
        if ~strcmp(lower(in3),'on') , in3 = 'off'; end
        h = findobj(axe);
        b = mngaxe('gstb',axe);
        set([h' b],'Visible',in3);

%*************************************************************%
%** OPTION = 'posb' : positionne la barre associee a l'axe. **%
%*************************************************************%
elseif strcmp(option,'posb')
        pos = get(axe,'Position');
        posbouton = [pos(1)+pos(3)+0.005 pos(2) 0.015 pos(4)];
        set(in3,'Position',posbouton);

%*********************************************************************%
%** OPTION = 'del' : destruction de l'axe et de  la barre associee. **%
%*********************************************************************%
elseif strcmp(option,'del')
        btn = mngaxe('gstb',axe);
        delete([axe btn]);

%************************************************%
%** OPTION = 'delbtn' : de  la barre associee. **%
%************************************************%
elseif strcmp(option,'delbtn')
        btn = mngaxe('gstb',axe);
        delete(btn);

%*************************%
%** OPTION = 'del_in' . **%
%*************************%
elseif strcmp(option,'del_in')
        % in3 : del button
        %----------------------
        if nargin==3 , b = mngaxe('gstb',axe); else , b = []; end
        h = findobj(axe);
        for k=1:length(axe) , h = h(find(h~=axe(k))); end
        delete([h' b]);

%*********************************************************%
%** OPTION = 'vis_on' : axe et barre associee visibles. **%
%*********************************************************%
elseif strcmp(option,'vis_on')
        h = findobj(axe);
        b = mngaxe('gstb',axe);
        set([h' b],'Visible','on');

%************************************************************%
%** OPTION = 'vis_off' : axe et barre associee invisibles. **%
%************************************************************%
elseif strcmp(option,'vis_off')
        h = findobj(axe);
        b = mngaxe('gstb',axe);
        set([h' b],'Visible','off');

%*********************%
%** OPTION = 'pos'. **%
%*********************%
elseif strcmp(option,'pos')
        % in3 = axes position
        %--------------------
        b = mngaxe('gstb',axe);
        set(axe,'Position',in3);
        mngaxe('posb',axe,b);

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('mngaxe','Unknown Option','msg');
        error('*');
end
