function [sx,sy] = mngcoor(x,y,axe,in4)
%MNGCOOR Manage display of coordinates values.
%       [sx,sy] = mngcoor(x,y) or
%       [sx,sy] = mngcoor(x,y,axe) or 
%       [sx,sy] = mngcoor(x,y,axe,opt)
%       (x,y)   = point coordinates in the axes axe (not used).
%       opt = 'real' or 'int'   
%       (sx,sy) = strings which give (x,y) position

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:13:25 $

if      nargin<4     , in4 = 'r';
elseif  isempty(in4) , in4 = 'r';
end
if      in4(1)=='r'
        sx = sprintf('X = %7.2f',x);
        sy = sprintf('Y = %7.2f',y);

elseif  in4(1)=='i'
        sx = sprintf('X = %0.f',round(x));
        sy = sprintf('Y = %0.f',round(y));
else
        sx = [];
        sy = [];
end
