function out1 = mngfig(option,in2,in3,in4)
%MNGFIG Manager for figures.
%       out1 = mngfig(option,in2,in3,in4)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:13:30 $

%       Uses ERRARGN, ERRARGT, EXTAXE, EXTTXT, MNGFIG, NUM2MSTR, WFINDMEN
%            WMEMUTIL, WSETAXE, WSTDZOOM, WWAITANS, WCOMMON.

%       Callbacks WSETAXE.

global  Def_FigColor    Def_FigNumTit   Def_FigBackSto  ...
        Def_AxeXColor   Def_AxeYColor   Def_AxeZColor   ...
        Def_AxeFontSize Def_TxtColor    Def_TxtFontSize

global  Figures_Stack

% Tag property of objects.
%------------------------
tag_fig_title   = 'Txt_Fig_Title';
tag_txt_note    = 'Txt_Note';
tag_fig_stack   = 'Figures_Stack';
tag_m_options   = 'M_Options';
tag_m_extaxe    = 'M_ExtAxe';
tag_m_zoom      = 'M_Zoom';

%*************************************************************%
%** OPTION = 'hdl_fig_title' : handle du titre de la figure **%
%*************************************************************%
if strcmp(option,'hdl_fig_title')
        % in2 = fig
        %----------
        out1 = findobj(in2,'style','text','tag',tag_fig_title);

%****************************************************************%
%** OPTION = 'fig_title' : cherche le contenu du titre associe **%
%****************************************************************%
elseif strcmp(option,'fig_title')
        % in2 = fig
        %----------
        txt = mngfig('hdl_fig_title',in2);
        if txt~=0 , out1 = get(txt,'String'); else , out1 = ''; end

%*******************************************************%
%** OPTION = 'hdl_txt_note' : handle du texte associe **%
%*******************************************************%
elseif strcmp(option,'hdl_txt_note')
        % in2 = fig
        %----------
        out1 = findobj(in2,'style','edit','Tag',tag_txt_note);

%***************************************************************%
%** OPTION = 'txt_note' : cherche le contenu du texte associe **%
%***************************************************************%
elseif strcmp(option,'txt_note')
        % in2 = fig
        %----------
        txt = mngfig('hdl_txt_note',in2);
        if ~isempty(txt) , out1 = get(txt,'String'); else , out1 = ''; end

%*******************************************************%
%** OPTION = 'exttxt' : extension des textes visibles **%
%*******************************************************%
elseif strcmp(option,'exttxt')
        % in2 = fig
        %----------
        txt = findobj(in2,...
                        'type','text',          ...
                        'Visible','on'          ...
                        );
        for k = 1:length(txt)
                if ~isempty(get(txt(k),'ButtonDownFcn')) , txt(k) = 0; end
        end
        txt = txt(find(txt));
        exttxt(txt);

%*****************************************************%
%** OPTION = 'extaxe' : extension des axes visibles **%
%*****************************************************%
elseif strcmp(option,'extaxe')
        % in2 = fig
        % in3 = menu
        % in4 = 'on' or 'off'
        %----------------------
        fig     = in2;
        hdl_m   = in3;
        opt     = in4;
        m_opt   = findobj(in2,'type','uimenu','tag',tag_m_options);
        if strcmp(opt,'on')
                axe = findobj(fig,...
                                'type','axes',          ...
                                'Visible','on'          ...
                                );
                if isempty(axe) ,  return; end
                win_btn = get(fig,'windowbuttondownfcn');
                if win_btn
                        if      strcmp(win_btn(1:4),'mngm')
                                msg = 'Disable Dynamical Visualization Tool?'; 
                        elseif  strcmp(win_btn(1:4),'zoom')
                                msg = 'Disable Zoom Tool?';
                        else
                                msg = 'Enable Axes Settings?';
                        end

                        % Test for new Settings.
                        %-----------------------
                        new = wwaitans(fig,msg,2);
                        if new==0 , return; end

                end

                mngfig('zoom',fig,'none')
                for k = 1:length(axe)
                        ax  = axe(k);
                        if ~isempty(get(ax,'ButtonDownFcn'))
                                axe(k) = 0;
                        else
                                set(ax,'ButtonDownFcn', ...
                                ['wsetaxe(''define'',' num2mstr(ax) ');']);
                        end

                end
                axe = axe(find(axe));
                mngfig('exttxt',axe);
                memB = [];
                memB = wmemutil('add',memB,axe);
                memB = wmemutil('add',memB,win_btn);
                action  = ['mngfig(''extaxe'',' int2str(fig) ',' ...
                                        num2mstr(hdl_m) ',''off'');'];
                set(hdl_m,...
                        'Label','Disable Axes Settings ',       ...
                        'Userdata',memB,                        ...
                        'CallBack',action                       ...
                        );
                set(m_opt,'Userdata','extaxe');
        else
                set(m_opt,'Userdata',[]);
                memB = get(hdl_m,'Userdata');
                [axe,memB]      = wmemutil('get',memB);
                [win_btn,memB]  = wmemutil('get',memB);
                axe_hdls = findobj(fig,'type','axes');
                [xind,yind] = wcommon(axe,axe_hdls);
                axe = axe(find(xind));
                set(axe,'ButtonDownFcn', '');
                if      isempty(win_btn)

                elseif  strcmp(win_btn(1:4),'zoom')
                        mngfig('zoom',fig,'szoom')

                elseif  strcmp(win_btn(1:4),'mngm')
                        mngfig('zoom',fig,'dynv')
                end
                action  = ['mngfig(''extaxe'',' int2str(fig) ',' ...
                                        num2mstr(hdl_m) ',''on'');'];
                set(hdl_m,...
                        'Label','Enable Axes Settings ',...
                        'Userdata',[],                  ...
                        'CallBack',action               ...
                        );
        end

%****************************************************************%
%** OPTION = 'hide_show' :  hide or show extended axes buttons **%
%****************************************************************%
elseif strcmp(option,'hide_show')
        % in2 = fig
        %----------
        btn = findobj(in2,'style','pushbutton','tag','Btn_Axe_Set');
        if ~isempty(btn)
                vis = get(btn(1),'Visible');
                if strcmp(vis,'on') , vis ='off'; else , vis = 'on'; end
                axe_fig = findobj(in2,'type','axes','visible','on');
                ind = [];
                for k = 1:length(btn)
                        if find(get(btn(k),'Userdata')==axe_fig)
                                ind = [ind k]; 
                        end
                end
                btn = btn(ind);
                if isempty(btn) , return; end
                set(btn,'Visible',vis);
                menu = in3;
                if strcmp(vis,'on')
                        set(menu,'label','Hide Extended Axes ');
                else
                        set(menu,'label','Show Extended Axes ');
                end
        end

%****************************************************%
%** OPTION = 'gridaxes' :  grid all visible axes   **%
%****************************************************%
elseif strcmp(option,'gridaxes')
        % in2 = fig
        % in3 = menu
        %------------
        axe_fig = findobj(in2,'type','axes','visible','on');
        if ~isempty(axe_fig)
                gval = get(axe_fig(1),'Xgrid');
                if strcmp(gval,'on') , gval ='off'; else , gval = 'on'; end
                set(axe_fig,'Xgrid',gval,'YGrid',gval);
        end

%**************************************%
%** OPTION = 'zoom' :  zoom ON /OFF  **%
%**************************************%
elseif strcmp(option,'zoom')
        % in2 = fig
        % in3 = type of zoom
        %       'none'  = no zoom
        %       'szoom' = standard zoom
        %       'dynv'  = dynamic visualization tool
        %------------------------------------------
        type_z  = in3;
        buffer  = findobj(in2,'style','text','tag','DynV_Handles');
        m_opt   = findobj(in2,'type','uimenu','tag',tag_m_options);
        m_zoom  = findobj(m_opt,'type','uimenu','tag',tag_m_zoom);
        sub_m   = findobj(m_zoom,'type','uimenu','Parent',m_zoom);
        if strcmp(get(m_opt,'Userdata'),'extaxe')
                if ~strcmp(in3,'none')
                        m_ext = findobj(m_opt,'type','uimenu','tag',tag_m_extaxe);
                        if ~isempty(m_ext)
                                memB = get(m_ext,'Userdata');
                                axe  = wmemutil('get',memB);
                                axe_hdls = findobj(in2,'type','axes');
                                [xind,yind] = wcommon(axe,axe_hdls);
                                axe = axe(find(xind));
                                set(axe,'ButtonDownFcn', '');
                                action  = ['mngfig(''extaxe'',' int2str(in2) ',' ...
                                                num2mstr(m_ext) ',''on'');'];
                                set(m_ext,...
                                        'Label','Enable Axes Settings ',...
                                        'Userdata',[],                  ...
                                        'CallBack',action               ...
                                        );
                                set(m_opt,'Userdata',[]);
                        end
                end
        end
        if ~isempty(buffer)
                hdls = get(buffer,'Userdata');
        else
                hdls = [];
        end
        axe_fig = findobj(in2,'type','axes','visible','on');
        old_sub = findobj(sub_m,'checked','on');
        if ~isempty(old_sub)
                pos_m = get(old_sub,'Position');
        else
                pos_m = 0;
        end
        set(sub_m,'Checked','Off');
        if      in3(1)=='n'
                set(findobj(sub_m,'Position',1),'Checked','on');
                if ~isempty(axe_fig) , wstdzoom('off'); end
                if ~isempty(hdls)
                        set(hdls,'Visible','off');
                        dynvtool('get',in2,0);
                        dynvtool('off',in2);
                end
        elseif  in3(1)=='s'
                if ~isempty(hdls)
                        set(hdls,'Visible','off');
                        dynvtool('get',in2,0);
                        dynvtool('off',in2);
                end
                if ~isempty(axe_fig)
                        set(findobj(sub_m,'Position',2),'Checked','on');
                        wstdzoom('on');
                else
                        set(findobj(sub_m,'Position',1),'Checked','on');
                end
        elseif in3(1)=='d'
                if ~isempty(axe_fig) , wstdzoom('off'); end
                if ~isempty(hdls)
                        set(findobj(sub_m,'Position',3),'Checked','on');
                        set(hdls,'Visible','on');
                        if pos_m~=3 , dynvtool('get',in2,0,1); end
                        dynvtool('on',in2);
                end
        end

%*****************************************************************%
%** OPTION = 'create' :  create a figure - with default values  **%
%*****************************************************************%
elseif strcmp(option,'create')
        % in2 = title
        % in3 = position
        % in4 = units
        %----------------
        if nargin<4 , in4 = 'normalized'; end
        out1    = ...
                figure(...
                        'Name',in2,...
                        'Unit',in4,...
                        'Position',in3,...
                        'Color',Def_FigColor,...
                        'BackingStore',Def_FigBackSto,...
                        'NumberTitle',Def_FigNumTit,...
                        'DefaultAxesFontSize',Def_AxeFontSize,...
                        'DefaultAxesXColor',Def_AxeXColor,...
                        'DefaultAxesYColor',Def_AxeYColor,...
                        'DefaultAxesZColor',Def_AxeZColor,...
                        'DefaultTextColor',Def_TxtColor,...
                        'DefaultTextFontSize',Def_TxtFontSize...
                        );

%********************************************************%
%** OPTION = 'fig_stack' : push or pull fig in memory  **%
%********************************************************%
elseif strcmp(option,'fig_stack')
        % in2 = fig
        % in3 = push or pull
        % in4 = menu label
        %---------------------
        no_fig = [];
        if ~isempty(Figures_Stack)
                Figures_Stack = Figures_Stack(find(Figures_Stack~=in2));
                xx = wcommon(Figures_Stack,get(0,'Children'));
                if ~isempty(xx)
                        no_fig = Figures_Stack(find(xx==0));    
                        Figures_Stack = Figures_Stack(find(xx~=0));
                else
                        Figures_Stack = [];
                end
        end
        if      strcmp(in3,'ini')
                Figures_Stack = [in2];

        elseif  strcmp(in3,'push')
                no_fig = [no_fig in2];
                Figures_Stack = [Figures_Stack in2];
                for k=1:length(Figures_Stack)-1;
                        f = Figures_Stack(k);
                        numw = int2str(in2);
                        m = findobj(f,'type','uimenu','label',in4);
                        if ~isempty(m)
                                sub_m = findobj(m,'type','uimenu','parent',m);
                                if ~isempty(sub_m)
                                        m_del = [];
                                        for k=1:length(no_fig)
                                                m_del = [m_del;findobj(sub_m,'Userdata',no_fig(k))];
                                        end
                                        delete(m_del)
                                end
                                uimenu(m,...
                                        'label',['fig. ' numw ' : ' get(in2,'name')],...
                                        'Userdata',in2,...
                                        'CallBack',['figure(' numw ');']...
                                        );
                        end                        
                end
                m = findobj(in2,'type','uimenu','label',in4);
                for k=1:length(Figures_Stack)-1;
                        f = Figures_Stack(k);
                        numf = int2str(f);
                        uimenu(m,...
                                'label',['fig. ' numf ' : ' get(f,'name')],...
                                'Userdata',f,...
                                'CallBack',['figure(' numf ');']...
                                );
                end

        elseif  strcmp(in3,'pull')
                no_fig = [no_fig in2];
                for k=1:length(Figures_Stack);
                        f = Figures_Stack(k);
                        m = findobj(f,'type','uimenu','label',in4);
                        if ~isempty(m)
                                sub_m = findobj(m,'type','uimenu','parent',m);
                                if ~isempty(sub_m)
                                        m_del = [];
                                        for k=1:length(no_fig)
                                                m_del = [m_del;findobj(sub_m,'Userdata',no_fig(k))];
                                        end
                                        delete(m_del)
                                end
                        end
                end
        end

%****************************************%
%** OPTION = 'close' :  close a figure **%
%****************************************%
elseif strcmp(option,'close')
        % in2 = fig
        % in3 = menu handle (optional)
        %----------------------------
        if nargin==3
                lab = get(in3,'Label');
                mngfig('fig_stack',in2,'pull',lab);
        end
        delete(in2)

%******************************************************%
%** OPTION = 'attach_close' :  attach close function **%
%******************************************************%
elseif strcmp(option,'attach_close')
        % in2 = fig
        % in3 = funct name
        % in4 = conditional closing (optional)
        %-------------------------------------
        lst     = findobj(in2,'type','uimenu','Parent',in2);
        m_files = wfindmen(lst,'file');
        lst     = findobj(m_files,'type','uimenu','Parent',m_files);
        m_close = wfindmen(lst,'close');
        set(m_close,'Interruptible','yes');
        cba_close = get(m_close,'callback');
        str1 = ['out1 = ' in3 '(''close'',' int2str(in2) ');'];
        if nargin==3
                str1 = [in3 '(''close'',' int2str(in2) ');'];
                str2 = get(m_close,'callback');
        else
                str1 = ['out1 = ' in3 '(''close'',' int2str(in2) ');'];
                str2 = ['if out1>-1 ' get(m_close,'callback') ' end;'];
        end
        set(m_close,'Callback',[str1,str2]);
        out1    = get(m_close,'Callback');

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('mngfig','Unknown Option','msg');
        error('*');
end
