function nb = ntnode(tree)
%NTNODE Number of terminal nodes.
%       NB = NTNODE(T) returns the number of terminal nodes
%       in the tree structure T. 
%
%       The nodes are numbered from left to right and
%       from top to bottom. The root index is 0.
%
%       See also MAKETREE, WTREEMGR.

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:14:40 $

%       Uses ERRARGN, WTREEMGR.

% Check arguments.
if errargn('ntnode',nargin,[1],nargout,[0:1]), error('*'); end

nb = wtreemgr('ntnode',tree);
