function s = num2mstr(n)
%NUM2MSTR Convert number to string in maximum precision.
%       S = NUM2MSTR(N) converts real numbers of input 
%       matrix N to string output vector S, in 
%       maximum precision.
%
%       See also NUM2STR.

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:14:47 $

if     isstr(n)
        s = n; 
elseif length(n)==1
        s = sprintf('%25.18g',n);
elseif size(n,1)>1
        s = [];
        for k=1:size(n,1)
                s = [s sprintf('%25.18g',n(k,:)) ';'];
        end
        s = ['[' s ']'];
elseif size(n,2)>1
        s = sprintf('%25.18g',n);
        s = ['[' s ']'];
end
