function depth = treedpth(tree)
%TREEDPTH Tree depth. 
%       D = treedpth(T) returns the depth D of the tree T.
%
%       See also MAKETREE, WTREEMGR.

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:17:08 $

%       Uses WTREEMGR.

% Check arguments.
if errargn('treedpth',nargin,[1],nargout,[0:1]), error('*'); end

depth = wtreemgr('depth',tree);
