function [out1,out2] = utlwzoom(fig)
%UTLWZOOM Utilities for standard zoom.

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:18:03 $

% Tagged Objects.
%----------------
%       'DynV_Buf_Mem'
%       'DynV_Buf_Sel'

%-----------------------
% msel_box   = 'normal';
% msel_trans = 'alt';
% msel_txt   = 'extend';
%------------------------
msel_box   = 'n';
msel_trans = 'a';
msel_txt   = 'e';

if isempty(find(get(0,'Children')==fig))
        return;
end
mouse           = get(fig,'SelectionType');
txt_handles     = findobj(fig,'Style','text');
DynV_Buf_Mem    = findobj(txt_handles,'Tag','DynV_Buf_Mem');
DynV_Buf_Sel    = findobj(txt_handles,'Tag','DynV_Buf_Sel');
mem_buffer      = get(DynV_Buf_Mem,'Userdata');
DynV_Axe_Ind    = wmemutil('get',mem_buffer,2);
DynV_Axe_Ind    = findobj(DynV_Axe_Ind,'flat','Visible','on');
DynV_Axe_Sel    = [];
for i=1:length(DynV_Axe_Ind)
        ax = DynV_Axe_Ind(i);
        x  = get(ax,'XLim');
        y  = get(ax,'YLim');
        cp = get(ax,'CurrentPoint');
        q  = cp(1,1:2);
        if      (q(1)>min(x)) & (q(1)<max(x)) & ...
                (q(2)>min(y)) & (q(2)<max(y))
                DynV_Axe_Sel = ax;
                break;
        end
end
if isempty(DynV_Axe_Sel)
        if mouse(1)==msel_txt
                axe_hdls = wmemutil('get',mem_buffer,4);
        else
                axe_hdls= wmemutil('get',mem_buffer,3);
        end
        axe_hdls = findobj(axe_hdls,'flat','Visible','on');
        for i=1:length(axe_hdls)
                ax = axe_hdls(i);
                x  = get(ax,'XLim');
                y  = get(ax,'YLim');
                cp = get(ax,'CurrentPoint');
                q  = cp(1,1:2);
                if      (q(1)>min(x)) & (q(1)<max(x)) & ...
                        (q(2)>min(y)) & (q(2)<max(y))
                        DynV_Axe_Sel = ax;
                        break;
                end
        end
end
set(DynV_Buf_Sel,'Userdata',DynV_Axe_Sel);
out1 = DynV_Axe_Sel;
