function out1 = wavarrow(option,in2,in3,in4,in5,in6,in7,in8)
%WAVARROW Draw arrows and texts for dw2dtool.
%       out1 = wavarrow(option,in2,in3,in4,in5,in6,in7,in8)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:18:33 $

tag_arrow = 'Wave_Arrow';
opt     = option(1:3);

%********************%
%** OPTION = 'ini' **%
%********************%
if      opt=='ini'
        axe     = in2;
        width   = in3;
        color   = in4;
        if findmobj(axe)==0 , axe=gca; end;
        axes(axe);
        out1 = line(    'Xdata',[0 0],'Ydata',[1 1],...
                        'LineWidth',width,'Color',color,...
                        'Visible','off','tag',tag_arrow);

%***********************%
%** OPTION = 'create' **%
%***********************%
elseif  opt=='cre'
        axe     = in2;
        start   = in3;
        stop    = in4;
        scale   = in5;
        width   = in6;
        color   = in7;
        if nargin<8 , vis = 'on'; else , vis= in8; end
        if findmobj(axe)==0 , axe=gca; end;
        if isempty(find(stop-start)) , return; end
        axes(axe);
        hold on
        axis(axis)
        xdif = stop(1) - start(1);
        ydif = stop(2) - start(2);
        if      xdif~=0 , theta = atan(ydif/xdif);
        elseif  ydif>0  , theta = pi/2;
        elseif  ydif<0  , theta = -pi/2; 
        end
        if(xdif>=0) , scale = -scale; end
        xx = [  start(1), stop(1),                                      ...
                (stop(1)+0.02*scale*cos(theta+pi/6)),NaN,stop(1),       ... 
                (stop(1)+0.02*scale*cos(theta-pi/6))]';
        yy = [  start(2), stop(2),                                      ...
                (stop(2)+0.02*scale*sin(theta+pi/6)),NaN,stop(2),       ... 
                (stop(2)+0.02*scale*sin(theta-pi/6))]';
        out1 = line(    'Xdata',xx,'Ydata',yy,...
                        'LineWidth',width,'Color',color,...
                        'Visible',vis,'tag',tag_arrow);
        hold off

%********************%
%** OPTION = 'set' **%
%********************%
elseif  opt=='set'
        arrow   = in2;
        start   = in3;
        stop    = in4;
        scale   = in5;
        width   = in6;
        color   = in7;
        if nargin<8 , vis = 'on'; else , vis= in8; end
        if isempty(find(stop-start)) , return; end
        axes(get(arrow,'Parent'));
        hold on
        axis(axis)
        xdif = stop(1) - start(1);
        ydif = stop(2) - start(2);
        if      xdif~=0 , theta = atan(ydif/xdif);
        elseif  ydif>0  , theta = pi/2;
        elseif  ydif<0  , theta = -pi/2; 
        end
        if(xdif>=0) , scale = -scale; end
        xx = [  start(1), stop(1),                                      ...
                (stop(1)+0.02*scale*cos(theta+pi/6)),NaN,stop(1),       ... 
                (stop(1)+0.02*scale*cos(theta-pi/6))]';
        yy = [  start(2), stop(2),                                      ...
                (stop(2)+0.02*scale*sin(theta+pi/6)),NaN,stop(2),       ... 
                (stop(2)+0.02*scale*sin(theta-pi/6))]';
        set(arrow,'Xdata',xx,'Ydata',yy,'LineWidth',width,'Color',color,...
                                'Visible',vis,'tag',tag_arrow);

        hold off

%********************%
%** OPTION = 'vis' **%
%********************%
elseif  opt=='vis'
        set(in2,'Visible',in3);

%**********************%
%** OPTION = 'width' **%
%**********************%
elseif  opt=='wid'
        set(in2,'LineWidth',in3);

%**********************%
%** OPTION = 'color' **%
%**********************%
elseif  opt=='col'
        set(in2,'Color',in3);

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('wavarrow','Unknown Option','msg');
        error('*');
end
