function [out1,out2,out3,out4] = wavattrb(option,in2,in3,in4)
%WAVATTRB Wavelets properties manager.
%       [out1,out2,out3,out4] = wavattrb(option,in2,in3,in4)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:18:44 $

%       Uses WAVEMNGR, WFILTERS, WNOBLANK

%----- Options -----%
%  'ini'
%  'gettnum'
%  'wname'
%  'set_wname'
%  'fam_num'
%  'length'
%-------------------%

opt = option(1:3);

%********************%
%** OPTION = 'ini' **%
%********************%
if opt=='ini'
        % in2 = type of wavelets (optional)
        %----------------------------------
        if nargin==1
                out1 = wavemngr('tfsn');
        else
                out1 = wavemngr('tfsn',in2);
        end
        out2 = wavemngr('tnum',out1(1,:));
        if isempty(out2) , out2 = 'no'; end

%************************%
%** OPTION = 'gettnum' **%
%************************%
elseif opt=='get'
        % in2 = pop_wav_fams handle
        % in3 = pop_wav_nums handle
        %---------------------------
        % out1 = Tab_Num
        % out2 = Wave_Fam
        %-------------------------------
        numfam  = get(in2,'Value');
        strfam  = get(in2,'String');
        out2    = wnoblank(strfam(numfam,:));
        out1    = wavemngr('tnum',out2);
        siz_tab = size(out1,1);
        vis     = 'on';
        if      siz_tab==0
                vis = 'off';
                out1 = 'no';
        elseif  siz_tab==1
                if strcmp(wnoblank(out1(1,:)),'no'), vis = 'off'; end
        end
        set(in3,'String',out1,'Value',1,'Visible',vis);

%**********************%
%** OPTION = 'wname' **%
%**********************%
elseif opt=='wna'
        % in2  = pop_wav_fams handle
        % in3  = pop_wav_nums handle
        % in4  = option_name (optional)
        %       'name' ,'famnum','all'
        %--------------------------------
        % out1 = Wave_Name
        % or
        % out1 = Wave_Fam
        % out2 = Wave_Num
        % or
        % out1 = Wave_Name
        % out2 = Wave_Fam
        % out3 = Wave_Num
        %-------------------------------
        wf      = get(in2,'Value');
        strf    = get(in2,'String');
        wn      = get(in3,'Value');
        strn    = get(in3,'String');
        if ~isempty(strn)
                strn = wnoblank(strn(wn,:));
                if strcmp(strn,'no')
                        strn = '';
                end
        else
                strn = '';
        end
        if nargin==3 , in4 = 'name'; end
        if strcmp(in4,'name')
                out1 = wnoblank([strf(wf,:) strn]);
        elseif strcmp(in4,'famnum')
                out1 = wnoblank(strf(wf,:));
                out2 = strn;
        elseif strcmp(in4,'all')
                out2 = wnoblank(strf(wf,:));
                if isempty(strn)
                        out1 = out2;
                else
                        out1 = wnoblank([strf(wf,:) strn]);
                end
                out3 = strn;
        end

%**************************%
%** OPTION = 'set_wname' **%
%**************************%
elseif opt=='set'
        % in2  = Wave_Name
        % in3  = pop_wav_fams handle
        % in4  = pop_wav_nums handle
        %---------------------------
        % out1 = Wave_Fam
        % out2 = Tab_Num
        % out3 = numfam
        % out4 = numwav
        %----------------------------
        [Wave_Fam,Tab_Num,numfam,numwav] = wavemngr('ftnu',in2);
        if isempty(Tab_Num)
                Tab_Num = 'no';
                vis     = 'off';
        else
                vis     = 'on';
        end
        set(in3,'Value',numfam);
        set(in4,'Visible',vis,'String',Tab_Num,'Value',numwav);
        out1 = Wave_Fam; out2 = Tab_Num; out3 = numfam; out4 = numwav;

%************************%
%** OPTION = 'fam_num' **%
%************************%
elseif opt=='fam'
        % in2  = Wave_Name
        % out1 = Wave_Fam
        % out2 = Wave_Num
        %-------------------------------
        [out1,out2] = wavemngr('snnu',in2);

%***********************%
%** OPTION = 'length' **%
%***********************%
elseif opt=='len'
        wname   = in2;
        wtype   = wavemngr('type',wname);
        if      (wtype==1) | (wtype==2)
                LoF_D = wfilters(wname);
                out1 = length(LoF_D);
        elseif  (wtype==3) | (wtype==4)
                [lb,ub] = wavemngr('user',wname);
                out1 = ub-lb+1;
        else
                errargt('wavattrb','invalid argument','msg'); error('*');
        end

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('wavattrb','Unknown Option','msg');
        error('*');
end
