function wavemenu(option,in2)
%WAVEMENU Start graphical user interface tools.
%       WAVEMENU brings up a menu for accessing the various 
%       graphical tools provided in the Wavelet Toolbox.

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:19:27 $

%       Uses WMEMTOOL.

global  ShiftTop_Fig Def_Btn_Height Def_Btn_Width

if     nargin==0
        option = 'create';
elseif nargin==1
        if ~isstr(option) 
            in2 = option;
            option = 'pref_b';
        elseif isempty(option)
            in2 = [];
             option = 'pref_b';
        elseif strcmp(option(1),'m')
            in2 = 'mono';
            option = 'pref_b';
        end
end

tag_wav_tool  = 'Wave_Tool';
tag_btn_close = 'Wave_Close';

if      strcmp(option,'pref')
        win = findobj(get(0,'children'),'flat','tag',tag_wav_tool);
        if ~isempty(win) , return; end
        if nargin==1 , in2 = 1; end
        wglobals('pref',in2);
        option = 'create';

elseif  strcmp(option,'pref_b')
        win = findobj(get(0,'children'),'flat','tag',tag_wav_tool);
        if ~isempty(win) , return; end
        wglobals('pref',in2);
        option = 'create';
end

if strcmp(option,'create')
        win = findobj(get(0,'children'),'flat','tag',tag_wav_tool);
        if ~isempty(win) , return; end

        % Waiting Frame construction & begin waiting.
        %--------------------------------------------
        mousefrm(0,'watch');

        % Global variables initialization.
        %---------------------------------
        wglobals('ini');

        % Wavelet main window initialization.
        %------------------------------------
        win_units   = 'pixels';
        Screen_Size = get(0,'ScreenSize');
        win_height  = 35*Def_Btn_Height/2;
        win_width   = 13*Def_Btn_Width/4;
        pos_win     = [Screen_Size(3)*0.01, ...
                       Screen_Size(4)-win_height-ShiftTop_Fig, ...
                       win_width, ...
                       win_height ...
                       ];
        name             = 'Wavelet Toolbox Main Menu  ';
        win_wavemenu     = mngfig('create',name,pos_win,win_units);
        str_win_wavemenu = int2str(win_wavemenu);
        set(win_wavemenu,'tag',tag_wav_tool);
        mngfig('fig_stack',win_wavemenu,'ini');

        % Position property of objects.
        %------------------------------
        btn_width       = 3*Def_Btn_Width;
        btn_heigth      = 3*Def_Btn_Height/2;
        btn_left        = (win_width-btn_width)/2;
        btn_low         = pos_win(4)-5*Def_Btn_Height/2;
        dif_heigth      = 2*Def_Btn_Height;
        pos_wd1d        = [     btn_left                ,...
                                btn_low                 ,...
                                btn_width               ,...
                                btn_heigth        ];
        pos_wd2d        = [     btn_left                ,...
                                pos_wd1d(2)-dif_heigth  ,...
                                btn_width               ,...
                                btn_heigth        ];
        pos_wdis        = [     btn_left                ,...
                                pos_wd2d(2)-dif_heigth  ,...
                                btn_width               ,...
                                btn_heigth        ];
        pos_wp1d        = [     btn_left                ,...
                                pos_wdis(2)-dif_heigth  ,...
                                btn_width               ,...
                                btn_heigth        ];
        pos_wp2d        = [     btn_left                ,...
                                pos_wp1d(2)-dif_heigth  ,...
                                btn_width               ,...
                                btn_heigth        ];
        pos_wpdis        = [    btn_left                ,...
                                pos_wp2d(2)-dif_heigth  ,...
                                btn_width               ,...
                                btn_heigth        ];
        pos_wcont        = [    btn_left                ,...
                                pos_wpdis(2)-dif_heigth ,...
                                btn_width               ,...
                                btn_heigth        ];
        pos_close        = [    btn_left                ,...
                                pos_wcont(2)-dif_heigth ,...
                                btn_width               ,...
                                btn_heigth        ];

        % String property of objects.
        %----------------------------
        str_wd1d        = 'Wavelet 1-D';
        str_wd2d        = 'Wavelet 2-D';
        str_wdis        = 'Wavelet Display';
        str_wp1d        = 'Wavelet Packet 1-D';
        str_wp2d        = 'Wavelet Packet 2-D';
        str_wpdis       = 'Wavelet Packet Display';
        str_wcont       = 'Continuous Wavelet 1-D';
        str_close       = 'Close';

        % Callback property of objects.
        %------------------------------
        cba_wd1d        = 'mousefrm(0,''watch'');eval(''dw1dtool;'')';
        cba_wd2d        = 'mousefrm(0,''watch'');eval(''dw2dtool;'')';
        cba_wdis        = 'mousefrm(0,''watch'');eval('';wvdtool;'')';
        cba_wp1d        = 'mousefrm(0,''watch'');eval('';wp1dtool;'')';
        cba_wp2d        = 'mousefrm(0,''watch'');eval('';wp2dtool;'')';
        cba_wpdis       = 'mousefrm(0,''watch'');eval('';wpdtool;'')';
        cba_wcont       = 'mousefrm(0,''watch'');eval('';cw1dtool;'')';
        cba_close       = ['mousefrm(0,''watch'');wavemenu(''close'',' ...
                                        str_win_wavemenu ');'];

        % Construction of objects.
        %-------------------------
        pus_wd1d        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_wd1d,...
                                        'String',str_wd1d,...
                                        'Callback',cba_wd1d...
                                        );
        pus_wd2d        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_wd2d,...
                                        'String',str_wd2d,...
                                        'Callback',cba_wd2d...
                                        );
        pus_wdis        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_wdis,...
                                        'String',str_wdis,...
                                        'Callback',cba_wdis...
                                        );
        pus_wp1d        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_wp1d,...
                                        'String',str_wp1d,...
                                        'Callback',cba_wp1d...
                                        );
        pus_wp2d        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_wp2d,...
                                        'String',str_wp2d,...
                                        'Callback',cba_wp2d...
                                        );
        pus_wpdis        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_wpdis,...
                                        'String',str_wpdis,...
                                        'Callback',cba_wpdis...
                                        );
        pus_wcont        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_wcont,...
                                        'String',str_wcont,...
                                        'Callback',cba_wcont...
                                        );
        pus_close        = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_close,...
                                        'String',str_close,...
                                        'Callback',cba_close...
                                        );

        % Setting units to normalized.
        %-----------------------------
        set(findobj(win_wavemenu,'Units','pixels'),'Units','Normalized');

        axes('Visible','Off')
        set(win_wavemenu,'NextPlot','New');

        % End waiting.
        %---------------
        mousefrm(0,'arrow');
        drawnow

%***********************************************%
%** OPTION = 'close' - close wavemenu window  **%
%***********************************************%
elseif strcmp(option,'close')
        if nargin==2
                win_wavemenu = in2;
        else
                win_wavemenu = findobj(get(0,'Children'),'flat',...
                                        'tag',tag_wav_tool);
        end

        % Closing all opened main analysis windows.
        %------------------------------------------
        pus_handles = findobj(0,'Style','pushbutton');
        hdls        = findobj(pus_handles,'flat','Tag',tag_btn_close);
        for i=1:length(hdls)
                eval(get(hdls(i),'Callback'));
        end

        % Closing the wavemenu window.
        %-----------------------------
        close(win_wavemenu);
        wglobals('clear')

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('wavemenu','Unknown Option','msg');
        error('*');
end

