function wdstem(x,y,c,in4)
%WDSTEM Plot discrete sequence data.
%       wdstem(x,y,c,in4)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:20:59 $


if      nargin<3
        c = get(gca,'colororder');
        c = c(1,:);
        in4 = 0;
elseif  nargin<4
        in4 = 0;
end

n       = length(x);
xx      = [x;x;nan*ones(size(x))];
yy      = [zeros(1,n);y;nan*ones(size(y))];
cax     = newplot;
tag_axe = get(cax,'Tag');
next    = lower(get(cax,'NextPlot'));
hold_state = strcmp(next,'add') & strcmp('add',lower(get(gcf,'NextPlot')));
h(2)    = plot(xx(:),yy(:),'-','Color',c);
hold on;
h(1)  = plot(x,y,'LineStyle','.','MarkerSize',20,'Color',c);
if in4~=0
        i_nul = find(abs(y)<eps);
                plot(x(i_nul),y(i_nul),'LineStyle','.',...
                        'MarkerSize',20,'Color',get(gca,'xcolor'));
end
q       = axis;
h(3) = plot([q(1) q(2)],[0 0]);
set(h(3),'color',get(gca,'xcolor'))
if ~hold_state, set(cax,'NextPlot',next); end
set(cax,'Tag',tag_axe)
