function wfigtitl(option,fig,in3,in4,in5,in6)
%WFIGTITL Titlebar for figures.
%       wfigtitl(option,fig,in3,in4,in5,in6)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:21:26 $

global Def_Btn_Height

% Tag property of objects.
%-------------------------
tag_fig_title = 'Txt_Fig_Title';

t = findobj(fig,'Style','text','Tag',tag_fig_title);
if isempty(t) , return; end

opt = option(1:3);

%********************%
%** OPTION = 'vis' **%
%********************%
if      opt=='vis'
        set(t,'Visible',in3);

%********************%
%** OPTION = 'set' **%
%********************%
elseif  opt=='set'
        h_tit   = Def_Btn_Height;
        uni     = get(fig,'Units');
        pos_f   = get(fig,'Position');
        if      strcmp(uni,'pixels')
                pos_t = [0,pos_f(4)-h_tit,pos_f(3)*in3,h_tit];
        elseif  strcmp(uni,'normalized')
                h = h_tit/pos_f(4);
                pos_t = [0,1-h,in3,h];
        end
        set(t,...
                'Units',uni,            ...
                'Position',pos_t,       ...
                'String',in4,           ...
                'Backgroundcolor',in6,  ...
                'Visible',in5           ...
                );
%********************%
%** OPTION = 'pos' **%
%********************%
elseif  opt=='set'
        h_tit   = Def_Btn_Height;
        uni     = get(fig,'Units');
        pos_f   = get(fig,'Position');
        if      strcmp(uni,'pixels')
                pos_t = [0,pos_f(4)-h_tit,pos_f(3)*in3,h_tit];
        elseif  strcmp(uni,'normalized')
                h = h_tit/pos_f(4);
                pos_t = [0,1-h,in3,h];
        end
        set(t,'Units',uni,'Position',pos_t);

%***********************%
%** OPTION = 'string' **%
%***********************%
elseif  opt=='str'
        if nargin==3 , in4 = get(t,'Visible'); end
        set(t,'String',in3,'Visible',in4);
end
