function [out1,out2,out3,out4] = wfigutil(option,in2,in3,in4,in5)
%WFIGUTIL Utilities for figures.
%       [xl,yl,pos] = wfigutil('prop_size',fig,nbx,nby)  or
%       pos         = wfigutil('pos',fig) gives position in pixels.               %
%       [left,up] = wfigutil('left_up',fig) or
%       [left,up] = wfigutil('left_up',fig,dx,dy)
%       gives the left_up corner in pixels or left+dx and up+dy.        

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:21:36 $

old_units = get(in2,'Units');
set(in2,'Units','Pixels'); 
pos = get(in2,'Position');
if strcmp(option,'prop_size')
        out1 = in3/pos(3);
        out2 = in4/pos(4);
        out3 = pos;

elseif strcmp(option,'pos')
        out1 = pos;

elseif strcmp(option,'left_up')
        scr = get(0,'Screensize');
        if nargin==2 , in3 = 0; in4 =0; end
        out1 = pos(1)+in3;
        out2 = scr(4)-pos(2)-pos(4)+in4;
end
set(in2,'Units',old_units); 
