function [out1,out2] = whelpfun(option,in2,in3,in4)
%WHELPFUN Help function.
%       function [out1,out2] = whelpfun(option,in2,in3,in4)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:22:11 $

% Tag property of objects.
%------------------------
tag_figinfo     = 'Whelpfig';
tag_axeinfo     = 'Axe_info';
tag_sliinfo     = 'Sli_info';
tag_txt_info    = 'Txt_info';
tag_fra_info    = 'Fra_info';
tag_btn_close   = 'Wave_Close';
dy0             = 20;

if      strcmp(option,'movsli')
        % fighelp = in2;
        %---------------
        s       = findobj(in2,'tag',tag_sliinfo);
        val     = round(get(s,'Value'));
        usr     = get(s,'Userdata');
        if val==usr , return; end
        set(s,'Value',val,'Userdata',val);
        dy      = -(val-usr)*dy0;
        whelpfun('movtxt',in2,dy);
        
elseif  strcmp(option,'movtxt')
        fighelp = in2;
        dy      = in3;
        frame0  = findobj(fighelp,'style','frame');
        usr     = get(frame0,'Userdata');
        len     = length(usr);
        t       = usr(1:len-6);
        usr     = usr(len-5:len);
        btn_p1  = usr(2); 
        btn_p2  = usr(3);
        btn_p3  = usr(4);
        s       = usr(5);       
        a       = usr(6); 
        old_u   = get(a,'units');
        set([a t],'units','pixels');
        p_axe   = get(a,'Position');
        dim     = length(t);
        nbt_vis = floor(p_axe(4)/dy0)-1;
        nb_page = ceil(dim/nbt_vis);
        ena1 = 'off'; ena2 = 'off'; ena3 = 'off';
        for k = 1:dim
                p       = get(t(k),'Position');
                p2      = p(2)+dy;
                p3      = p2+dy0;
                if      (p2<dy0/2) | (p3>p_axe(4))
                        vis     = 'off';
                        if      k<=nbt_vis
                                ena1 = 'on';
                        elseif  (nbt_vis<k) & (k<=2*nbt_vis)
                                ena2 = 'on';
                        else
                                ena3 = 'on';
                        end
                else
                        vis = 'on'; 
                end
                set(t(k),'Position',[p(1) p2],'Visible',vis);
        end
        set(btn_p1,'Enable',ena1);
        set(btn_p2,'Enable',ena2);
        set(btn_p3,'Enable',ena3);    
        set([a t],'units',old_u);

elseif  strcmp(option,'page_ud')
        fighelp = in2;
        nump    = in3;
        frame0  = findobj(fighelp,'style','frame');
        usr     = get(frame0,'Userdata');
        len     = length(usr);
        t       = usr(1:len-6);
        usr     = usr(len-5:len);
        btn_p1  = usr(2); 
        btn_p2  = usr(3);
        btn_p3  = usr(4);
        s       = usr(5);       
        a       = usr(6);       
        old_u   = get(a,'units');
        set([a t(1)],'units','pixels');
        p_axe   = get(a,'Position');
        p_txt   = get(t(1),'Position');
        set([a t(1)],'units',old_u);
        if      nump==1
                dy      = p_axe(4)-dy0-p_txt(2);
                vals    = get(s,'Max');
        elseif  nump==2
                nbt_vis = floor(p_axe(4)/dy0)-1;
                dy      = p_axe(4)-dy0-p_txt(2)+dy0*nbt_vis;
                vals    = get(s,'Max')-nbt_vis;
        elseif  nump==3
                nbt_vis = floor(p_axe(4)/dy0)-1;
                dy      = p_axe(4)-dy0-p_txt(2)+2*dy0*nbt_vis;
                vals    = get(s,'Min');
        end
        set(s,'Value',vals,'Userdata',vals);
        whelpfun('movtxt',fighelp,dy);

elseif  strcmp(option,'create')
        global  ShiftTop_Fig    ...
                Def_Btn_Height  Def_Btn_Width   Y_Spacing       ...
                Def_FigBackSto  Def_FraBkColor  Def_FraFgColor  ...
                Def_TxtBkColor
        if nargin == 3
                fname   = in3; 
        else
                fname   = '';  
        end
        fighelp = findobj(get(0,'Children'),'flat','tag',tag_figinfo);
        if isempty(fighelp)
                win_units       = 'pixels';
                Screen_Size     = get(0,'ScreenSize');
                win_height      = 21*Def_Btn_Height+45*Y_Spacing;
                btn_width       = 3*Def_Btn_Width/4;
                cmd_width       = 2*btn_width;
                win_width       = round(cmd_width/(1-0.83));
                pos_win         = [ Screen_Size(3)-5-win_width, ...
                                    Screen_Size(4)-win_height-ShiftTop_Fig, ...
                                    win_width, ...
                                    win_height ...
                                    ];
                axe_col = Def_TxtBkColor;
                fighelp         = figure(...
                                        'Name','Information window',...
                                        'Visible','off',...
                                        'Unit',win_units,...
                                        'Position',pos_win,...
                                        'Color',axe_col,...
                                        'DefaultAxesXColor',axe_col,...
                                        'DefaultAxesYColor',axe_col,...
                                        'DefaultAxesZColor',axe_col,...
                                        'BackingStore',Def_FigBackSto,...
                                        'NumberTitle','off',...
                                        'Tag',tag_figinfo...
                                        );
                extfig(fighelp,'','','w');

                x_frame0        = pos_win(3)-cmd_width+1;
                w_frame0        = cmd_width;
                pos_frame0      = [     x_frame0                        ,...
                                        0                               ,...
                                        w_frame0                        ,...
                                        pos_win(4)+5                    ];
                ypos            = pos_frame0(2)+pos_frame0(4)-5*Def_Btn_Height;
                pos_close       = [     x_frame0+btn_width/4            ,...
                                        ypos                            ,...
                                        3*btn_width/2                   ,...
                                        2*Def_Btn_Height                ];

                ypos            = ypos-pos_close(4)-2*Def_Btn_Height;
                pos_btn_p1      = [     pos_close(1)                    ,...
                                        ypos                            ,...
                                        pos_close(3)                    ,...
                                        pos_close(4)                    ];

                ypos            = ypos-pos_close(4)-2*Def_Btn_Height;
                pos_btn_p2      = [     pos_close(1)                    ,...
                                        ypos                            ,...
                                        pos_close(3)                    ,...
                                        pos_close(4)                    ];
                ypos            = ypos-pos_close(4)-2*Def_Btn_Height;
                pos_btn_p3      = [     pos_close(1)                    ,...
                                        ypos                            ,...
                                        pos_close(3)                    ,...
                                        pos_close(4)                    ];


                str_close       = 'Close';
                str_btn_p1      = 'Page 1';
                str_btn_p2      = 'Page 2';
                str_btn_p3      = 'Page 3';

                cba_close       = ['whelpfun(''close'');'];
                cba_btn_p1      = ['whelpfun(''page_ud'',' ...
                                                int2str(fighelp) ',1);'];
                cba_btn_p2      = ['whelpfun(''page_ud'',' ...
                                                int2str(fighelp) ',2);'];
                cba_btn_p3      = ['whelpfun(''page_ud'',' ...
                                                int2str(fighelp) ',3);'];

                frame0          = uicontrol(...
                                        'Parent',fighelp,               ...
                                        'Style','frame',                ...
                                        'Visible','off',                ...
                                        'Unit',win_units,               ...
                                        'Position',pos_frame0,          ...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'Foregroundcolor',Def_FraFgColor,...
                                        'Tag',tag_fra_info              ...
                                        );

                btn_close       = uicontrol(...
                                        'Parent',fighelp,               ...
                                        'Style','Pushbutton',           ...
                                        'Unit',win_units,               ...
                                        'Visible','off',                ...
                                        'Position',pos_close,           ...
                                        'String',str_close,             ...
                                        'Interruptible','yes',          ...
                                        'Callback',cba_close,           ...
                                        'Tag',tag_btn_close             ...     
                                        );
                btn_p1          = uicontrol(...
                                        'Parent',fighelp,               ...
                                        'Style','Pushbutton',           ...
                                        'Unit',win_units,               ...
                                        'Visible','off',                ...
                                        'Position',pos_btn_p1,          ...
                                        'String',str_btn_p1,            ...
                                        'Interruptible','yes',          ...
                                        'Callback',cba_btn_p1           ...
                                        );

                btn_p2  = uicontrol(...
                                        'Parent',fighelp,               ...
                                        'Style','Pushbutton',           ...
                                        'Unit',win_units,               ...
                                        'Visible','off',                ...
                                        'Position',pos_btn_p2,          ...
                                        'String',str_btn_p2,            ...
                                        'Interruptible','yes',          ...
                                        'Callback',cba_btn_p2           ...
                                        );

                btn_p3  = uicontrol(...
                                        'Parent',fighelp,               ...
                                        'Style','Pushbutton',           ...
                                        'Unit',win_units,               ...
                                        'Visible','off',                ...
                                        'Position',pos_btn_p3,          ...
                                        'String',str_btn_p3,            ...
                                        'Interruptible','yes',          ...
                                        'Callback',cba_btn_p3           ...
                                        );

                p_axe   = [0 0 win_width-cmd_width win_height];
                a       = axes(...
                        'Parent',fighelp,                       ...
                        'Visible','off',                        ...
                        'Units','pixels',                       ...
                        'Position',p_axe,                       ...
                        'DrawMode','Fast',                      ...
                        'XTicklabelMode','manual',              ...
                        'YTicklabelMode','manual',              ...
                        'XTickLabels',[],'YTickLabels',[],      ...
                        'Box','On',                             ...
                        'XGrid','off','YGrid','off',            ...
                        'color',axe_col,                        ...
                        'Tag',tag_axeinfo                       ...
                        );
                pos_sli = [p_axe(1)+p_axe(3)-15 p_axe(2) 15 p_axe(4)];
                cba_s   = ['whelpfun(''movsli'',' int2str(fighelp) ');'];
                s       = uicontrol(...
                                'Parent',fighelp,                       ...
                                'style','slider',                       ...
                                'Units','pixels',                       ...
                                'Position',pos_sli,                     ...
                                'Visible','off',                        ...
                                'Min',0,                                ...
                                'Max',150,                              ...
                                'Value',150,                            ...
                                'Callback',cba_s,                       ...
                                'Tag',tag_sliinfo                       ...
                                );
                set([fighelp,frame0,btn_close,btn_p1,btn_p2,btn_p3,s,a], ...
                                        'units','normalized');
                set([fighelp,frame0,btn_close,a,s],'Visible','on');

        else
                frame0          = findobj(fighelp,'style','frame');
                usr             = get(frame0,'Userdata');
                len             = length(usr);
                t               = usr(1:len-6);
                usr             = usr(len-5:len);
                btn_close       = usr(1); 
                btn_p1          = usr(2); 
                btn_p2          = usr(3);
                btn_p3          = usr(4);
                s               = usr(5);       
                a               = usr(6); 
                old_name        = get(btn_close,'Userdata');
                if ~isempty(old_name) & strcmp(old_name,fname) , return; end
                delete(t);
                set([s,btn_p1,btn_p2,btn_p3],'Visible','off');
                figure(fighelp);
        end
        set(fighelp,'Name',['Information window : ' in2(1,:)]);
        set(frame0,'Userdata',[btn_close,btn_p1,btn_p2,btn_p3,s,a]);
        set(btn_close,'Userdata',fname);
        dim     = size(in2,1);
        old_u   = get(a,'units');
        set(a,'units','pixels');
        txt_col = [0 0 0];
        p_axe   = get(a,'Position');
        dy      = dy0;
        dx      = 20;
        y1      = p_axe(4);
        nbt_vis = floor(y1/dy0)-1;
        nb_page = ceil(dim/nbt_vis);
        invis   = 0;
        t       = zeros(1,dim);
        axes(a);
        for k = 1:dim
                y1 = y1-dy;
                if y1<dy0/2
                        invis   = invis+1;
                        vis     = 'off';
                else
                        vis     = 'on';
                end
                t(k) = text(dx,y1,in2(k,:),                     ...
                                'units','pixels',               ...
                                'fontname','courier',           ...
                                'fontsize',10,                  ...
                                'Color',txt_col,                ...
                                'Visible',vis,                  ...
                                'Userdata',k,                   ...
                                'tag',tag_txt_info              ...
                                );              
        end
        set(a,'units',old_u);
        if nb_page>1
                set(btn_p1,'Visible','on','Enable','off');
                set(btn_p2,'Visible','on','Enable','on');
                if nb_page>2
                        set(btn_p3,'Visible','on','Enable','on');
                end
                val = (nb_page-1)*nbt_vis;
                set(s,...
                        'Units','pixels',               ...
                        'Max',val,'Value',val,          ...
                        'Userdata',val,'Visible','on'   ...
                        );
        else
                set(s,'Visible','off')
        end
        set([t s],'units','normalized');
        set(frame0,'Userdata',[t get(frame0,'Userdata')]);
        set(fighelp,'NextPlot','new');

elseif  strcmp(option,'getflag')
        out1            = [];
        fighelp         = get(0,'Children');
        fighelp         = findobj(fighelp,'flat','tag',tag_figinfo);
        out2            = fighelp;
        if isempty(fighelp) , return; end
        btn_close       = findobj(fighelp,'tag',tag_btn_close);
        out1            = get(btn_close,'Userdata');

elseif  strcmp(option,'close')
        fighelp = get(0,'Children');
        fighelp = findobj(fighelp,'flat','tag',tag_figinfo);
        close(fighelp);
end
