function [count,y] = wimghist(x,nb)
%WIMGHIST Compute histograms.
%       [N,X] = WIMGHIST(Y,NB)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:22:35 $

x       = x(:);
xlen    = length(x);
if nargin==1 , nb = 1+length(find(diff(sort(x)))) ; end
minx    = min(x);
x       = x - minx;
maxx    = max(x);
if maxx==0
        nn      = (nb-1)/2;
        count   = [xlen zeros(1,nb-1)];
        y       = minx*ones(1,nb);
else
        x       = fix(1 + (nb*x)/maxx);
        ind     = find(x>nb);
        x(ind)  = nb*ones(size(ind));
        count   = full(sum(sparse(1:xlen,x,1,xlen,nb)));
        y       = minx+((maxx*[0.5:nb])/nb);
end
