function axe_legend = wlegend(fig,pos_axe,Wav_Fam)
%WLEGEND Legend for compression scores plot.
%       axe_legend = wlegend(fig,pos_axe,Wav_Fam)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:22:53 $

%       Uses ERRARGT, WMEMTOOL.

        % Displaying legend.
        %-------------------
        old_u           = get(fig,'Units');
        axe_legend      = axes(...
                                'Parent',fig,                           ...
                                'Units','pixels',                       ...
                                'Position',pos_axe,                     ...
                                'XTicklabelMode','manual',              ...
                                'YTicklabelMode','manual',              ...
                                'XTickLabels',[],'YTickLabels',[],      ...
                                'XTick',[],'YTick',[],                  ...
                                'Xlim',[0 180],                         ...
                                'Ylim',[0 20],                          ...
                                'Fontsize',10,                          ...
                                'Drawmode','fast',                      ...
                                'Box','On'                              ...
                                );
        axes(axe_legend)
        line(...
                'Xdata',11:25,...
                'Ydata',ones(1,15)*15,...
                'LineStyle',':',...
                'Color','y');
        line(...
                'Xdata',11:25,...
                'Ydata',ones(1,15)*10,...
                'Color','m');
        line(...
                'Xdata',11:25,...
                'Ydata',ones(1,15)*5,...
                'Color','c');
        text(30,15,'  Global threshold');
        if strcmp(Wav_Fam,'bior')
                str_norm_txt    = '  Norm coefs recover in %';
        else
                str_norm_txt    = '  Retained energy in %';
        end
        text(30,10,str_norm_txt);
        text(30,5,'  Number of zeros in %');
        set(axe_legend,'Units',old_u);
