function wnumbtn(option,in2,in3,in4)
%WNUMBTN Wavelet number (for ** values).
%       WNUMBTN(option,in2,in3,in4)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:23:47 $

%       Uses WNUMBTN.

% Tag property of objects.
%-------------------------
tag_edi_wnum = 'Edi_WNum';

if      option==1
        b_fam   = in2(1);
        b_num   = in2(2);
        ena_hdl = in3;
        lst     = get(b_num,'String');
        val     = get(b_num,'Value');
        item    = deblankl(lst(val,:));
        if strcmp(item,'**')
                pos = get(b_num,'Position');
                uni = get(b_num,'Units');
                ena_hdl = findobj(ena_hdl,'Enable','on');
                set(ena_hdl,'Enable','off');
                set(b_num,'Visible','off');
                edi = uicontrol(...
                        'style','edit',         ...
                        'Units',uni,            ...
                        'Position',pos,         ...
                        'BackGroundColor','w',  ...
                        'Interruptible','no',   ...
                        'string',[],            ...
                        'tag',tag_edi_wnum      ...
                        );
                cba = ['wnumbtn(2,' num2mstr(in2) ',' ...
                                num2mstr(ena_hdl)  ',' num2mstr(edi) ');'];
                set(edi,'Callback',cba);
        end

elseif  option==2
        b_fam   = in2(1);
        b_num   = in2(2);
        ena_hdl = in3;
        edi     = in4;
        rmax    = 16;
        nmax    = 50;
        item    = get(edi,'String');
        num     = fix(str2num(item));
        ok      = 1;
        val     = 1;
        err     = 0;
        if      isempty(num)            , ok = 0;       err = 1;
        elseif  num<1           , ok = 0;       err = 1;
        elseif  num>nmax        , ok = 0;       err = 1;
        else
                lst     = get(b_num,'String');
                [r,c]   = size(lst);
                val     = 0;
                for k=1:r-1
                        num_k = str2num(lst(k,:));
                        if      num==num_k 
                                ok = 0;         val = k;
                                break;
                        elseif  num<num_k 
                                ok = 1;         val = k;
                                item = int2str(num);
                                if k==1 , 
                                        lst_beg  = item;
                                else
                                        lst_beg  = str2mat(lst(1:k-1,:),item);
                                end
                                if      r<rmax
                                        lst = str2mat(  lst_beg,        ...
                                                        lst(k:r-1,:),   ...
                                                        lst(r,:)        ...
                                                        );
                                elseif k<r-1
                                        lst = str2mat(  lst_beg,        ...
                                                        lst(k:r-2,:),   ...
                                                        lst(r,:)        ...
                                                        );
                                else
                                        lst = str2mat(  lst_beg,        ...
                                                        lst(r,:)        ...
                                                        );
                                end
                                break; 
                        end
                end
                if val==0 , 
                        ok = 1;         val = r;
                        item = int2str(num);
                        if r==rmax
                                val = r-1;
                                lst = str2mat(  lst(1:r-2,:),   ...
                                                item,           ...
                                                lst(r,:)        ...
                                                );
                        else
                                val = r;
                                lst = str2mat(  lst(1:r-1,:),   ...
                                                item,           ...
                                                lst(r,:)        ...
                                                );                      
                        end
                end
        end
        if ok
                set(b_num,'string',lst,'Value',val,'visible','on');
        else
                set(b_num,'Value',val,'visible','on');
        
        end
        delete(edi)
        set(ena_hdl,'Enable','on');
        if err
                warndlg('Invalid Wavelet Number.','Select Wavelet Number');
        end
end
