function [sx,sy] = wp1dcoor(x,y,axe,in4)
%WP1DCOOR Wavelet packets 1D coordinates.
%       Write function used by DYNVTOOL.
%       [sx,sy] = wp1dcoor(x,y,axe,in4)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:24:02 $

% Tagged object.
%---------------
tag_img_cfs = 'Img_WPCfs';
tag_nodlab  = 'Pop_NodLab';

sx = sprintf('X = %7.2f',x);
sy = sprintf('Y = %7.2f',y);
if axe==in4
   img = findobj(in4,'type','image','tag',tag_img_cfs);
   if ~isempty(img)
       typelab = get(findobj(get(in4,'parent'),'tag',tag_nodlab),'Value');
       us      = get(img,'Userdata');
       k = find(us(:,3)<y & us(:,4)>y);
       if length(k)==1
          if typelab==1
             sy = ['Pack : (' sprintf('%.0f',us(k,1)) ','     ...
                              sprintf('%.0f',us(k,2)) ')'];
          else
             sy = ['Pack : ' sprintf('%.0f',depo2ind(2,us(k,1:2)))];
          end
       end
    end
end
