function out1 = wp1ddeno(option,in2,in3,in4)
%WP1DDENO Wavelet packets 1D de-noising.
%       out1 = wp1ddeno(option,in2,in3,in4)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:24:09 $

%       Uses WMEMTOOL.

global  Machine                         ...
        Def_Btn_Height  Def_Btn_Width   ...
        Pop_Min_Width   X_Graph_Ratio   ...
        X_Spacing       Y_Spacing       ...
        Def_TxtBkColor  Def_EdiBkColor  ...
        Def_FraBkColor  Def_FraFgColor

if nargin==0, option = 'create'; end

% MemBloc1 of stored values.
%---------------------------
n_param_anal    = 'WP1D_Par_Anal';
ind_sig_name    =  1;
ind_wav_name    =  2;
ind_lev_anal    =  3;
ind_ent_anal    =  4;
ind_ent_par     =  5;
ind_sig_size    =  6;
ind_act_option  =  7;
nb1_stored      =  7;

% MemBloc3 of stored values.
%---------------------------
n_structures    = 'Structures';
ind_tree_st     =  1;
ind_data_st     =  2;
nb3_stored      =  2;

% MemBloc4 of stored values. (Local Bloc)
%----------------------------------------
n_miscella_loc  = 'WPDeno1D_Misc';
ind_status      = 1;
ind_curr_sig    = 2;
ind_curr_color  = 3;
ind_hdl_winorig = 4;
nb4_stored      = 4;

% Tag property of objects.
%-------------------------
tag_mode_val    = 'Mode_Val';
tag_sel_sli     = 'Sel_Sli';
tag_sel_edi     = 'Sel_Edi';
tag_bins_txt    = 'Bins_Txt';
tag_bins_data   = 'Bins_Data';
tag_axe_perfo   = 'Axe_Perfo';
tag_axe_histo   = 'Axe_Histo';
tag_axe_cfs     = 'Axe_Cfs';
tag_txt_deno    = 'Txt_Deno';
tag_lin_deno    = 'Lin_deno';

tag_axe_right_1 = 'axe_right_1';
tag_axe_right_2 = 'axe_right_2';
tag_axe_right_3 = 'axe_right_3';
                
%*****************************************************************%
%** OPTION = 'create' - constructs the initial wp1ddeno window  **%
%*****************************************************************%
if strcmp(option,'create')

        % Calling figure.
        %----------------
        win_wp1dtool     = in2;
        str_win_wp1dtool = int2str(win_wp1dtool);

        % Window initialization.
        %----------------------
        win_name = 'Wavelet Packet 1-D  --  De-noising';
        [win_wp1ddeno,pos_win,cba_close_menu] = ...
                wfigcrea('create',NaN,win_name,'',win_wp1dtool,3,...
                                str2mat('wp1ddeno','cond'));
        str_win_wp1ddeno = int2str(win_wp1ddeno);
        win_units = 'pixels';
        out1      = win_wp1ddeno;

        % Command frame and Dynamical visualization tool construction.
        %-------------------------------------------------------------
        [frame0,pos_frame0,Pos_Graphic_Area] = ...
                        wfigcrea('frame',win_wp1ddeno,'dynv','title');

        % Waiting Frame construction & begin waiting.
        %--------------------------------------------
        wwaiting('create',win_wp1ddeno,X_Graph_Ratio,...
                        'Wait ... initialization');

        % Getting global variables from wp1dtool figure memory block.
        %------------------------------------------------------------
        [WP_Tree,WP_Data]       = wmemtool('rmb',win_wp1dtool,n_structures,...
                                                ind_tree_st,ind_data_st);
        Depth                   = wtreemgr('depth',WP_Tree);
        [Signal_Name,Wave_Name,Ent_Name,Ent_Par] =      ...
                 wmemtool('rmb',win_wp1dtool,n_param_anal,      ...
                                ind_sig_name,ind_wav_name,      ...
                                ind_ent_anal,ind_ent_par);
        [Wav_Fam,Wav_Num] = wavattrb('fam_num',Wave_Name);

        % General graphical parameters initialization.
        %--------------------------------------------

        % Borders and double borders.
        dx  = X_Spacing;  dx2 = 2*dx;
        dy  = Y_Spacing;  dy2 = 2*dy;

        % X init position and width of frames.
        x_frame0        = pos_frame0(1);
        cmd_width       = pos_frame0(3);
        h_frame0        = pos_frame0(4);

        % Buttons width
        push_width      = (cmd_width-4*dx)/2;
        txt_width       = Def_Btn_Width;
        pop_width       = Pop_Min_Width;

        % Position property of objects.
        %------------------------------
        pos_input_txt   = [     x_frame0+dx2                            ,...
                                h_frame0-3*dy-Def_Btn_Height            ,...
                                txt_width                               ,...
                                Def_Btn_Height                          ];
        pos_input_data  = [     pos_input_txt(1)+pos_input_txt(3)+dx    ,...
                                pos_input_txt(2)                        ,...
                                2*pop_width                             ,...
                                Def_Btn_Height                          ];
        pos_wav_txt     = pos_input_txt;
        pos_wav_txt(2)  = pos_input_txt(2)-Def_Btn_Height-dy2;
        pos_wav_fams    = [     pos_wav_txt(1)+pos_wav_txt(3)+dx        ,...
                                pos_wav_txt(2)                          ,...
                                pop_width                               ,...
                                Def_Btn_Height                          ];
        pos_wav_nums    = [     pos_wav_fams(1)+pos_wav_fams(3)+dx/2    ,...
                                pos_wav_fams(2)                         ,...
                                pop_width-dx/2                          ,...
                                Def_Btn_Height                          ];
        pos_lev_txt     = pos_wav_txt;
        pos_lev_txt(2)  = pos_wav_txt(2)-Def_Btn_Height-dy2;
        pos_lev_data    = [     pos_lev_txt(1)+pos_lev_txt(3)+dx        ,...
                                pos_lev_txt(2)                          ,...
                                pop_width                               ,...
                                Def_Btn_Height                          ];
        pos_ent_txt     = pos_lev_txt;
        pos_ent_txt(2)  = pos_ent_txt(2)-Def_Btn_Height-dy2;
        pos_ent_val     = [     pos_ent_txt(1)+pos_ent_txt(3)+dx        ,...
                                pos_ent_txt(2)                          ,...
                                2*Pop_Min_Width                         ,...
                                Def_Btn_Height                          ];
        pos_ent_par     = pos_ent_txt;
        pos_ent_par(2)  = pos_ent_par(2)-Def_Btn_Height-dy2;
        pos_ent_par(3)  = pos_ent_par(3)+dx/2;
        pos_uic_ent     = [     pos_ent_par(1)+pos_ent_par(3)+dx/2      ,...
                                pos_ent_par(2)                          ,...
                                2*Pop_Min_Width                         ,...
                                Def_Btn_Height                          ];
        px              = x_frame0+(cmd_width-13*txt_width/5)/2;
        pos_mode_val    = [     px                                      ,...
                                pos_ent_par(2)-3*Def_Btn_Height         ,...
                                13*txt_width/5                          ,...
                                3*Def_Btn_Height/2                      ];
        px              = x_frame0+(cmd_width-7*push_width/4)/2;
        pos_sel_txt     = [     px                                      ,...
                                pos_mode_val(2)-3*Def_Btn_Height/2      ,...
                                7*push_width/4                          ,...
                                Def_Btn_Height                          ];
        wx              = (cmd_width-13*txt_width/5)/4;
        pos_sel_sli     = [     x_frame0+wx                             ,...
                                pos_sel_txt(2)-5*Def_Btn_Height/4       ,...
                                7*txt_width/5                           ,...
                                Def_Btn_Height/2                        ];
        pos_sel_edi     = [     pos_sel_sli(1)+pos_sel_sli(3)+wx        ,...
                                pos_sel_txt(2)-3*Def_Btn_Height/2       ,...
                                txt_width                               ,...
                                Def_Btn_Height                          ];
        px              = x_frame0+(cmd_width-3*pop_width)/2;
        pos_bins_txt    = [     px                                      ,...
                                pos_sel_sli(2)-2*Def_Btn_Height         ,...
                                2*pop_width                             ,...
                                Def_Btn_Height                          ];
        pos_bins_data   = pos_bins_txt;
        pos_bins_data(1)= pos_bins_txt(1)+pos_bins_txt(3)+dx;
        pos_bins_data(3)= pop_width;
        pos_auto_deno   = [     x_frame0+(cmd_width-3*push_width/2)/2   ,...
                                pos_bins_txt(2)-3*Def_Btn_Height        ,...
                                3*push_width/2                          ,...
                                2*Def_Btn_Height                        ];
        px              = x_frame0+(cmd_width-7*push_width/4)/2;
        pos_close       = [     px                                      ,...
                                pos_frame0(2)+Def_Btn_Height            ,...
                                7*push_width/4                          ,...
                                3*Def_Btn_Height/2                      ];

        % Parameters initialization.
        %---------------------------
        min_sel_sli     = 0;
        max_sel_sli     = 1;
        default_sel_sli = 0;
        default_bins    = 50;

        % String property of objects.
        %----------------------------
        str_input_txt   = 'Signal';
        str_input_data  = Signal_Name;
        str_wav_txt     = 'Wavelet';
        str_wav_fams    = Wav_Fam;
        str_wav_nums    = Wav_Num;
        str_lev_txt     = 'Level';
        str_lev_data    = int2str(Depth);
        str_ent_txt     = 'Entropy';
        [str_ent_val,str_ent_par] = wpentmng('t',Ent_Name);
        str_uic_ent     = num2str(Ent_Par);
        str_mode_val    = str2mat(      'Automatic soft thresholding',...
                                        'Automatic hard thresholding');
        str_sel_txt     = 'Select global threshold';
        str_sel_edi     = '';
        str_bins_txt    = 'Number of bins';
        str_bins_data   = int2str(default_bins);
        str_denoise     = 'De-noise';
        str_close       = 'Close';

        % Command part construction of the window.
        %-----------------------------------------
        figure(win_wp1ddeno);
        txt_input_txt   = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_input_txt,...
                                        'String',str_input_txt,...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
        txt_input_data  = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_input_data,...
                                        'String',str_input_data,...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        txt_wav_txt     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_wav_txt,...
                                        'String',str_wav_txt,...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
        txt_wav_fams    = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_wav_fams,...
                                        'String',str_wav_fams,...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        if ~isempty(str_wav_nums)
        txt_wav_nums    = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_wav_nums,...
                                        'String',str_wav_nums,...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        end
        txt_lev_txt     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','left',...
                                        'Position',pos_lev_txt,...
                                        'String',str_lev_txt,...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
        txt_lev_data    = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_lev_data,...
                                        'String',str_lev_data,...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        txt_ent_txt     = uicontrol(...
                                        'Style','text',                 ...
                                        'Unit',win_units,               ...
                                        'HorizontalAlignment','left',   ...
                                        'Position',pos_ent_txt,         ...
                                        'String',str_ent_txt,           ...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
        txt_ent_val     = uicontrol(...
                                        'Style','text', ...
                                        'Unit',win_units,       ...
                                        'HorizontalAlignment','center',...
                                        'Position',pos_ent_val, ...
                                        'String',str_ent_val,   ...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        nument          = wpentmng('g',Ent_Name);
        if find(nument==[2 3 5 6])
                txt_ent_par     = uicontrol(...
                                        'Style','text',                 ...
                                        'Unit',win_units,               ...
                                        'HorizontalAlignment','left',   ...
                                        'Position',pos_ent_par,         ...
                                        'String',str_ent_par,           ...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
                uic_ent         = uicontrol(...
                                        'Style','text',         ...
                                        'Unit',win_units,       ...
                                        'Position',pos_uic_ent, ...
                                        'HorizontalAlignment','center', ...
                                        'String',str_uic_ent,   ...
                                        'Backgroundcolor',Def_TxtBkColor...
                                        );
        end
        
        pop_mode_val    = uicontrol(...
                                        'Style','Popup',...
                                        'Unit',win_units,...
                                        'Position',pos_mode_val,...
                                        'String',str_mode_val,...
                                        'Userdata',1,...
                                        'Tag',tag_mode_val...
                                        );
        txt_sel_txt     = uicontrol(...
                                        'Style','Text',...
                                        'Unit',win_units,...
                                        'Position',pos_sel_txt,...
                                        'String',str_sel_txt,...
                                        'Backgroundcolor',Def_FraBkColor...
                                        );
        sli_sel_sli     = uicontrol(...
                                        'Style','Slider',...
                                        'Unit',win_units,...
                                        'Position',pos_sel_sli,...
                                        'Min',min_sel_sli,...
                                        'Max',max_sel_sli,...
                                        'Value',default_sel_sli,...
                                        'tag',tag_sel_sli...
                                        );
        edi_sel_edi     = uicontrol(...
                                        'Style','Edit',...
                                        'Unit',win_units,...
                                        'Position',pos_sel_edi,...
                                        'String',str_sel_edi,...
                                        'Backgroundcolor',Def_EdiBkColor,...
                                        'HorizontalAlignment','center',...
                                        'tag',tag_sel_edi...
                                        );
        txt_bins_txt    = uicontrol(...
                                        'Style','text',...
                                        'Unit',win_units,...
                                        'Position',pos_bins_txt,...
                                        'String',str_bins_txt,...
                                        'Backgroundcolor',Def_FraBkColor,...
                                        'Tag',tag_bins_txt...
                                        );
        edi_bins_data   = uicontrol(...
                                        'Style','Edit',...
                                        'Units',win_units,...
                                        'Position',pos_bins_data,...
                                        'String',str_bins_data,...
                                        'Backgroundcolor',Def_EdiBkColor,...
                                        'Tag',tag_bins_data...
                                        );
        pus_auto_deno   = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_auto_deno,...
                                        'String',str_denoise...
                                        );
        pus_close       = uicontrol(...
                                        'Style','Pushbutton',...
                                        'Unit',win_units,...
                                        'Position',pos_close,...
                                        'String',str_close,...
                                        'Interruptible','yes'...
                                        );

        drawnow

        % Parameters initialization.
        %---------------------------
        Signal_Anal     = get(wp1ddraw('r_orig',win_wp1dtool),'Ydata');
        suggthr         = ddencmp('den','wp',Signal_Anal);
        thresh          = wdatamgr('rallcfs',WP_Data);
        thresh          = sort(abs(thresh));
        min_sel_sli     = 0;
        max_sel_sli     = thresh(length(thresh));
        default_sel_sli = suggthr;
        str_sel_edi     = sprintf('%1.4g',default_sel_sli);

        % Callbacks update.
        %------------------
        str_pop_mode_val        = num2mstr(pop_mode_val);
        str_edi_bins_data       = num2mstr(edi_bins_data);
        cba_mode_val    = ['wp1ddeno(''mode'',' ...
                                str_win_wp1ddeno ',' ...
                                str_pop_mode_val ');'];
        cba_sel_sli     = ['wp1ddeno(''update_selglo'',' ...
                                str_win_wp1ddeno ',' ...
                                '''sli''' ');'];
        cba_sel_edi     = ['wp1ddeno(''update_selglo'',' ...
                                str_win_wp1ddeno ',' ...
                                '''edi''' ');'];
        cba_bins_data   = ['wp1ddeno(''update_bins'',' ...
                                str_win_wp1ddeno ',' ...
                                str_edi_bins_data ',' ...
                                str_bins_data ');'];
        cba_denoise     = ['wp1ddeno(''denoise'',' ...
                                str_win_wp1ddeno ',' ...
                                str_win_wp1dtool ');'];
        set(pop_mode_val,'Callback',cba_mode_val);
        set(sli_sel_sli,'Max',max_sel_sli,'Value',default_sel_sli,...
                        'Callback',cba_sel_sli);
        set(edi_sel_edi,'String',str_sel_edi,'Callback',cba_sel_edi);
        set(edi_bins_data,'Callback',cba_bins_data);
        set(pus_auto_deno,'Callback',cba_denoise);
        set(pus_close,'Callback',cba_close_menu);

        % General graphical parameters initialization.
        %--------------------------------------------
        bdx             = 0.08*pos_win(3);
        bdy             = 0.06*pos_win(4);
        ecy             = 0.03*pos_win(4);
        y_graph         = 2*Def_Btn_Height+dy;
        h_graph         = pos_frame0(4)-y_graph;
        w_graph         = pos_frame0(1);

        % Axes construction parameters.
        %------------------------------
        w_left          = (w_graph-3*bdx)/2;
        x_left          = bdx;
        w_right         = w_left;
        x_right         = x_left+w_left+5*bdx/4;
        n_axeright      = 3;
        ind_right       = n_axeright;

        % Vertical separation.
        %---------------------
        w_fra   = 0.01*pos_win(3);
        x_fra   = (w_graph-w_fra)/2;
        uicontrol(...
                        'Style','frame',...
                        'Unit',win_units,...
                        'Position',[x_fra,y_graph,w_fra,h_graph],...
                        'Backgroundcolor',Def_FraBkColor,...
                        'Tag','Dw1ddeno_obj'...
                        );

        % Building axes on the right part.
        %---------------------------------
        ecy_right = 2*ecy;
        h_right =(h_graph-2*bdy-(n_axeright-1)*ecy_right)/n_axeright;
        y_right = y_graph+bdy-ecy/2;
        axe_right = zeros(1,n_axeright);
        pos_right = [x_right y_right w_right h_right];
        for k = 1:n_axeright
                axe_right(k) = axes(...
                                'Units',win_units,...
                                'Position',pos_right,...
                                'Drawmode','fast',...
                                'Box','On',...
                                'Tag',['axe_right_' int2str(k)]...
                                );
                pos_right(2) = pos_right(2)+pos_right(4)+ecy_right;
        end
        set(axe_right(1),'visible','off');

        % Computing and Drawing Original Signal.
        %---------------------------------------
        axes(axe_right(3))
        curr_color      = dw1dcolo('sig');
        hdl_sig = line(1:length(Signal_Anal),Signal_Anal,'erasemode','none',...
                        'Color',curr_color);
        title('Original signal');      
        xmin = 1;                       
        xmax = length(Signal_Anal);
        ymin = min(Signal_Anal);
        ymax = max(Signal_Anal);
        if ymin==ymax
                ymin = ymin-0.0001;
                ymax = ymax+0.0001;
        end
        set(axe_right(3),'Xlim',[xmin xmax],'Ylim',[ymin ymax]);

        % Displaying original details coefficients.
        %------------------------------------------
        set(win_wp1ddeno,'Colormap',get(win_wp1dtool,'Colormap'));
        axe_handles     = findobj(win_wp1dtool,'type','axes');
        WP_Axe_Cfs      = findobj(axe_handles,'flat','Tag',tag_axe_cfs);
        xaxis   = get(WP_Axe_Cfs,'Xlim');
        yaxis   = get(WP_Axe_Cfs,'Ylim');
        axes(axe_right(2))
        title('Original coefficients');
        set(axe_right(2),...
                        'Xlim',xaxis,                           ...
                        'Ylim',yaxis,                           ...
                        'YTicklabelMode','manual',              ...
                        'YTickLabels',[],                       ...
                        'YTick',[],                             ...
                        'Box','On'                              ...
                        );
        wpplotcf(axe_right(2),WP_Tree,WP_Data,win_wp1dtool);
        set(axe_right(1),...
                        'Xlim',xaxis,                           ...
                        'Ylim',yaxis,                           ...
                        'YTicklabelMode','manual',              ...
                        'YTickLabels',[],                       ...
                        'YTick',[],                             ...
                        'Box','On'                              ...
                        );

        % Displaying perfos.
        %-------------------
        curr_sig        = sort(abs(thresh));
        curr_color      = 'magenta';
        y_axe_perfo     = y_graph+bdy+3*h_right/2+3*ecy;
        h_axe_perfo     = 3*h_right/2+ecy/2;
        pos_axe_perfo   = [x_left y_axe_perfo w_left h_axe_perfo];
        len_sig         = length(curr_sig);
        if len_sig==0
                xaxis           = [0    1];
                yaxis           = [0    1];
        else
                xaxis           = [0    curr_sig(len_sig)];
                yaxis           = [0    len_sig];
        end
        axe_perfo       = axes(...
                                'Units',win_units,...
                                'Position',pos_axe_perfo,...
                                'Drawmode','fast',...
                                'Box','On',...
                                'Xlim',xaxis,...
                                'Ylim',yaxis,...
                                'Tag',tag_axe_perfo);

        % Set a text as a super title.
        %-----------------------------
        title('Sorted absolute values of coefs')
        wtxttitl(axe_perfo,'Automatic soft thresholding',tag_txt_deno);

        line(   curr_sig,1:length(curr_sig),...
                'erasemode','none',...
                'color',curr_color);
        lin_perfo       = line( 'EraseMode','xor',...
                                'xdata',[suggthr suggthr],...
                                'ydata',[0       len_sig],...
                                'Color','y',...
                                'linestyle',':');
        set(axe_perfo,'Userdata',lin_perfo);

        % Check the bins number.
        %-----------------------
        nb_bins = str2num(get(edi_bins_data,'String'));
        if isempty(nb_bins) 
                nb_bins = default_bins; 
                set(edi_bins_data,'String',str_bins_data)
        elseif nb_bins<2
                nb_bins = default_bins;
                set(edi_bins_data,'String',str_bins_data)
        end

        % Displaying histogram.
        %----------------------
        y_axe_histo     = y_graph+bdy-ecy/2;
        h_axe_histo     = 3*h_right/2+ecy/2;
        pos_axe_histo   = [x_left y_axe_histo w_left h_axe_histo];
        axe_histo       = axes(...
                                'Units',win_units,...
                                'Position',pos_axe_histo,...
                                'NextPlot','Replace',...
                                'Drawmode','fast',...
                                'Box','On',...
                                'Tag',tag_axe_histo);
        his             = wgethist(curr_sig,nb_bins);
        [xx,imod]       = max(his(2,:));
        mode_val        = (his(1,imod)+his(1,imod+1))/2;
        his(2,:)        = his(2,:)/length(curr_sig);
        axes(axe_histo);
        wplothis(axe_histo,his,curr_color);
        ylim            = get(axe_histo,'Ylim');
        lin_perfh       = line( 'EraseMode','xor',...
                                'xdata',[suggthr suggthr],...
                                'ydata',[ylim(1)+eps ylim(2)-eps],...
                                'Color','y',...
                                'linestyle',':');
        title('Histogram of absolute values of coefs');
        set(axe_histo,'Userdata',lin_perfh);

        % Memory blocks update.
        %----------------------
        wmemtool('ini',win_wp1ddeno,n_miscella_loc,nb4_stored);
        wmemtool('wmb',win_wp1ddeno,n_miscella_loc,                     ...
                                        ind_status,0,                   ...
                                        ind_curr_sig,curr_sig,          ...
                                        ind_curr_color,curr_color,      ...
                                        ind_hdl_winorig,win_wp1dtool    ...
                                        );

        % Axes attachment.
        %-----------------
        axe_cmd = axe_right(3);
        axe_act = axe_right(1:2);
        dynvtool('attach',win_wp1ddeno,[],axe_cmd,axe_act,[1 0],'','','');
        dynvtool('put',win_wp1ddeno);

        % Setting units to normalized.
        %-----------------------------
        set(findobj(win_wp1ddeno,'Units','pixels'),'Units','Normalized');

        % End waiting.
        %-------------
        wwaiting('off',win_wp1ddeno);

%*************************************%
%** OPTION = 'denoise' - DE-NOISING **%
%*************************************%
elseif strcmp(option,'denoise')
        win_wp1ddeno    = in2;
        win_wp1dtool    = in3;

        % Waiting message.
        %-----------------
        wwaiting('msg',win_wp1ddeno,'Wait ... computing');

        % Handles of tagged objects.
        %---------------------------
        axe_handles     = findobj(win_wp1ddeno,'Type','axes');
        sli_handles     = findobj(win_wp1ddeno,'Style','slider');
        pop_handles     = findobj(win_wp1ddeno,'Style','popupmenu');
        axe_right_1     = findobj(axe_handles,'flat','Tag',tag_axe_right_1);
        axe_right_2     = findobj(axe_handles,'flat','Tag',tag_axe_right_2);
        axe_right_3     = findobj(axe_handles,'flat','Tag',tag_axe_right_3);
        sli_sel_sli     = findobj(sli_handles,'Tag',tag_sel_sli);
        pop_mode_val    = findobj(pop_handles,'Tag',tag_mode_val);

        % Setting the de-noised coefs axes invisible.
        %--------------------------------------------
        lin_denosig     = get(axe_right_3,'Userdata');
        if ~isempty(lin_denosig)
                vis = get(lin_denosig,'Visible');
                if vis(1:2)=='on'
                        axes(axe_right_3);
                        set(lin_denosig,'Visible','off');
                        title('Original signal');      
                        axe_right_1 = findobj(axe_handles,'flat','Tag',tag_axe_right_1);
                        mngaxe('vis',axe_right_1,'off');
                end
        end
        drawnow

        % Getting memory blocks.
        %-----------------------
        [WP_Tree,WP_Data] = wmemtool('rmb',win_wp1dtool,n_structures,...
                                                ind_tree_st,ind_data_st);
        Depth     = wtreemgr('depth',WP_Tree);
        Wave_Name = wmemtool('rmb',win_wp1dtool,n_param_anal,ind_wav_name);

        % De-noising depending on the selected thresholding mode.
        %--------------------------------------------------------
        threshold       = get(sli_sel_sli,'Value');
        mode_val        = get(pop_mode_val,'value');
        str_sorh        = ['s' 'h'];
        sorh            = str_sorh(mode_val);
        [C_Sig,C_Tree,C_Data] = wpdencmp(WP_Tree,WP_Data,...
                                    sorh,'nobest',threshold,1);

        % Displaying de-noised signal.
        %-----------------------------
        axes(axe_right_3);
        lin_denosig = get(axe_right_3,'userdata');
        if ~isempty(lin_denosig)
                set(lin_denosig,'Ydata',C_Sig);
                set(lin_denosig,'Visible','on');
        else
                curr_color      = dw1dcolo('ssig');
                lin_denosig     = line( 'Xdata',1:length(C_Sig),...
                                        'Ydata',C_Sig,...
                                        'color',curr_color,...
                                        'tag',tag_lin_deno);
                set(axe_right_3,'userdata',lin_denosig)
        end     
        title('Original and de-noised signals');

        % Displaying thresholded details coefficients.
        %---------------------------------------------
        delete(findobj(axe_right_1,'type','image'));
        wpplotcf(axe_right_1,C_Tree,C_Data,win_wp1dtool);
        axes(axe_right_1);
        set(axe_right_1,...
                        'Xlim',get(axe_right_2,'Xlim'),...
                        'Ylim',get(axe_right_2,'Ylim'),...
                        'Tag',tag_axe_right_1);
        title('Thresholded coefficients');
        mngaxe('vis',axe_right_1,'on');

        % Memory blocks update.
        %----------------------
        wmemtool('wmb',win_wp1ddeno,n_miscella_loc,ind_status,1);

        % End waiting.
        %-------------
        wwaiting('off',win_wp1ddeno);

%***********************************%
%** OPTION = 'mode' - MODE CHOICE **%
%***********************************%
elseif strcmp(option,'mode')
        win_wp1ddeno    = in2;
        pop_mode_val    = in3;

        mode_val        = get(pop_mode_val,'value');
        old_mode        = get(pop_mode_val,'userdata');
        if mode_val==old_mode
                return;
        else
                set(pop_mode_val,'userdata',mode_val);
        end

        % Handles of tagged objects.
        %---------------------------
        axe_handles     = findobj(win_wp1ddeno,'Type','axes');
        txt_handles     = findobj(win_wp1ddeno,'Type','text');
        axe_right_3     = findobj(axe_handles,'flat','Tag',tag_axe_right_3);
        axe_perfo       = findobj(axe_handles,'flat','Tag',tag_axe_perfo);
        txt_deno        = findobj(txt_handles,'Tag',tag_txt_deno);

        % Setting the de-noised coefs axes invisible.
        %--------------------------------------------
        lin_denosig     = get(axe_right_3,'Userdata');
        if ~isempty(lin_denosig)
                vis = get(lin_denosig,'Visible');
                if vis(1:2)=='on'
                        axes(axe_right_3);
                        set(lin_denosig,'Visible','off');
                        title('Original signal');      
                        axe_right_1 = findobj(axe_handles,'flat','Tag',tag_axe_right_1);
                        mngaxe('vis',axe_right_1,'off');
                end
        end
        drawnow

        % Changing mode.
        %---------------
        axes(axe_perfo);
        if mode_val==2
                set(txt_deno,'String','Automatic hard thresholding')
        else
                set(txt_deno,'String','Automatic soft thresholding')
        end

        % Memory blocks update.
        %----------------------
        wmemtool('wmb',win_wp1ddeno,n_miscella_loc,ind_status,0);

%***************************************************************%
%** OPTION = 'update_selglo' - UPDATE INFOS FOR GLOBAL THRESH **%
%***************************************************************%
elseif strcmp(option,'update_selglo')
        win_wp1ddeno    = in2;
        upd_orig        = in3;

        % Handles of tagged objects continuing.
        %-------------------------------------
        axe_handles     = findobj(win_wp1ddeno,'Type','axes');
        axe_perfo       = findobj(axe_handles,'flat','Tag',tag_axe_perfo);
        axe_histo       = findobj(axe_handles,'flat','Tag',tag_axe_histo);
        axe_right_3     = findobj(axe_handles,'flat','Tag',tag_axe_right_3);
        sli_handles     = findobj(win_wp1ddeno,'Style','slider');
        edi_handles     = findobj(win_wp1ddeno,'Style','edit');
        sli_sel_sli     = findobj(sli_handles,'Tag',tag_sel_sli);
        edi_sel_edi     = findobj(edi_handles,'Tag',tag_sel_edi);

        % Setting the de-noised coefs axes invisible.
        %--------------------------------------------
        lin_denosig     = get(axe_right_3,'Userdata');
        if ~isempty(lin_denosig)
                vis = get(lin_denosig,'Visible');
                if vis(1:2)=='on'
                        axes(axe_right_3);
                        set(lin_denosig,'Visible','off');
                        title('Original signal');      
                        axe_right_1 = findobj(axe_handles,'flat','Tag',tag_axe_right_1);
                        mngaxe('vis',axe_right_1,'off');
                end
        end
        drawnow

        % Getting memory blocks.
        %-----------------------
        if      upd_orig=='sli'
                new_thresh      = get(sli_sel_sli,'value');
        elseif  upd_orig=='edi'
                new_thresh      = str2num(get(edi_sel_edi,'string'));
                if isempty(new_thresh)
                        new_thresh      = get(sli_sel_sli,'value');
                end
                if new_thresh > get(sli_sel_sli,'Max')
                        new_thresh      = get(sli_sel_sli,'Max');
                end
        end

        set(sli_sel_sli,'value',new_thresh);
        set(edi_sel_edi,'string',sprintf('%1.4g',new_thresh));
        newline = 1;
        xnew    = [new_thresh new_thresh];
        lin_per = get(axe_perfo,'Userdata');
        lin_his = get(axe_histo,'Userdata');
        xold    = get(lin_per,'Xdata');
        if ~isempty(xold)
                if size(xold)==[1 2]
                        if abs(xold - xnew)<sqrt(eps)
                                newline = 0;
                        end
                end
        end
        if newline
                if      strcmp(Machine(1:3),'PCW')
                        yper = get(lin_per,'Ydata');
                        yhis = get(lin_his,'Ydata');
                        delete([lin_per lin_his])
                        axes(axe_perfo);
                        lin_per = line(...
                                        'Xdata',xnew,...
                                        'ydata',yper,...
                                        'Color','y',...
                                        'linestyle',':');
                        axes(axe_histo);
                        lin_his = line( ...
                                        'Xdata',xnew,...
                                        'ydata',yhis,...
                                        'Color','y',...
                                        'linestyle',':');
                        set(axe_perfo,'Userdata',lin_per);
                        set(axe_histo,'Userdata',lin_his);
                else
                        set([lin_per lin_his],'Xdata',xnew);
                end

        end

        % Memory blocks update.
        %----------------------
        wmemtool('wmb',win_wp1ddeno,n_miscella_loc,ind_status,0);

%**************************************************************%
%** OPTION = 'update_bins' - UPDATE HISTOGRAMS WITH NEW BINS **%
%**************************************************************%
elseif strcmp(option,'update_bins')
        win_wp1ddeno    = in2;
        edi_bins_data   = in3;
        default_bins    = in4;

        % Handles of tagged objects.
        %---------------------------
        axe_handles     = findobj(win_wp1ddeno,'Type','axes');
        axe_histo       = findobj(axe_handles,'flat','Tag',tag_axe_histo);
        axe_perfo       = findobj(axe_handles,'flat','Tag',tag_axe_perfo);

        % Getting memory blocks.
        %-----------------------
        [curr_sig,curr_color] = wmemtool('rmb',win_wp1ddeno,n_miscella_loc,...
                                                ind_curr_sig,ind_curr_color);

        % Updating histograms.
        %---------------------
        if ~isempty(curr_sig)
                nb_bins = str2num(get(edi_bins_data,'String'));
                if isempty(nb_bins) 
                        nb_bins = default_bins; 
                        set(edi_bins_data,'String',int2str(default_bins))
                elseif nb_bins<2
                        nb_bins = default_bins;
                        set(edi_bins_data,'String',int2str(default_bins))
                end

                his             = wgethist(curr_sig,nb_bins);
                his(2,:)        = his(2,:)/length(curr_sig);
                axes(axe_histo);
                wplothis(axe_histo,his,curr_color);
                thresh = get(get(axe_perfo,'Userdata'),'Xdata');
                ylim            = get(axe_histo,'Ylim');        
                lin_perfh       = line( 'EraseMode','xor',...
                                        'Xdata',thresh,...
                                        'ydata',[ylim(1)+eps ylim(2)-eps],...
                                        'Color','y',...
                                        'linestyle',':');
                title('Histogram of absolute values of coefs');
                set(axe_histo,'Userdata',lin_perfh);
                drawnow
        end

%**************************************%
%** OPTION = 'close' -  CLOSE FIGURE **%
%**************************************%
elseif strcmp(option,'close')
        win_wp1ddeno    = in2;
        [status,hdl_winorig] = wmemtool('rmb',win_wp1ddeno,n_miscella_loc,...
                                        ind_status,ind_hdl_winorig);
        if status==1

                % Test for Updating.
                %--------------------
                status = wwaitans(win_wp1ddeno,...
                                  'Update the synthesized signal ?',2,'cancel');
        end
        if status==1
                wwaiting('msg',win_wp1ddeno,'Wait ... computing');
                lin_handles     = findobj(win_wp1ddeno,'Type','line');
                lin_denosig     = findobj(lin_handles,'tag',tag_lin_deno);
                wp1dmngr('return_deno',hdl_winorig,status,lin_denosig);
                wwaiting('off',win_wp1ddeno);
        elseif status==0
                wp1dmngr('return_deno',hdl_winorig,status);
        else

        end
        out1 = status;

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('wp1ddeno','Unknown Option','msg');
        error('*');
end
