function out1 = wp1ddraw(option,win_wptool,in3)
%WP1DDRAW Wavelet packets 1D drawing manager. 
%       out1 = wp1ddraw(option,win_wptool,in3)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:24:16 $

% MemBloc1 of stored values.
%---------------------------
n_param_anal    = 'WP1D_Par_Anal';
ind_sig_name    =  1;
ind_wav_name    =  2;
ind_lev_anal    =  3;
ind_ent_anal    =  4;
ind_ent_par     =  5;
ind_sig_size    =  6;
ind_act_option  =  7;
nb1_stored      =  7;

% MemBloc2 of stored values.
%---------------------------
n_wp1d2d_utils  = 'WP1D2D_Utils';
ind_tree_lin    =  1;
ind_tree_txt    =  2;
ind_type_txt    =  3;
ind_sel_nodes   =  4;
ind_gra_area    =  5;
ind_nb_colors   =  6;
ind_wav_len     =  7;
nb2_stored      =  7;

% MemBloc3 of stored values.
%---------------------------
n_structures    = 'Structures';
ind_tree_st     =  1;
ind_data_st     =  2;
nb3_stored      =  2;

% MemBloc4 of stored values.
%---------------------------
n_sav_struct    = 'Sav_Struct';
ind_sav_tree_st =  1;
ind_sav_data_st =  2;
nb4_stored      =  2;

% Tag property of objects.
%-------------------------
tag_pop_colm    = 'Txt_PopM';
tag_curtree     = 'Pop_CurTree';
tag_nodact      = 'Pop_NodAct';

tag_axe_t_lin   = 'Axe_TreeLines';
tag_axe_t_txt   = 'Axe_TreeTexts';
tag_axe_sig     = 'Axe_Sig';
tag_lin_sig     = 'Lin_sig';
tag_axe_pack    = 'Axe_Pack';
tag_axe_cfs     = 'Axe_Cfs';
tag_axe_col     = 'Axe_Col';
tag_sli_size    = 'Sli_Size';
tag_sli_pos     = 'Sli_Pos';

% Miscellaneous values.
%----------------------
Col_SigIni      = 'r';

axe_handles     = findobj(win_wptool,'type','axes');
uic_handles     = findobj(win_wptool,'type','uicontrol');

WP_Axe_TreeTxt  = findobj(axe_handles,'flat','Tag',tag_axe_t_txt);
WP_Axe_TreeLin  = findobj(axe_handles,'flat','Tag',tag_axe_t_lin);
WP_Axe_Sig      = findobj(axe_handles,'flat','Tag',tag_axe_sig);
WP_Axe_Pack     = findobj(axe_handles,'flat','Tag',tag_axe_pack);
WP_Axe_Cfs      = findobj(axe_handles,'flat','Tag',tag_axe_cfs);
WP_Axe_Col      = findobj(axe_handles,'flat','Tag',tag_axe_col);
WP_Slider_Size  = findobj(uic_handles,'Tag',tag_sli_size);
WP_Slider_Pos   = findobj(uic_handles,'Tag',tag_sli_pos);

%***********************%
%** OPTION = 'sig' -  **%
%***********************%
if strcmp(option,'sig')
        % Signal_Anal = in3;
        %------------------
        set([   WP_Axe_TreeTxt,WP_Axe_Cfs,WP_Axe_Sig,WP_Axe_Pack,       ...
                WP_Axe_Col,WP_Slider_Size,WP_Slider_Pos],'Visible','on');
        drawnow;
        xmin = 1;               xmax = length(in3);
        ymin = min(in3);        ymax = max(in3);
        if ymin==ymax , dy = 0.01; else , dy = (ymax-ymin)/25; end
        ymin = ymin-dy;         ymax = ymax+dy;
        axes(WP_Axe_Sig);
        plot(in3,'Color',Col_SigIni,'tag',tag_lin_sig);
        set(WP_Axe_Sig,'Xlim',[xmin xmax],'Ylim',[ymin ymax],'Tag',tag_axe_sig);
        title(['Analyzed Signal : length = ' int2str(xmax)]);
        axes(WP_Axe_TreeTxt);
        title('Decomposition Tree');
        axes(WP_Axe_Pack);
        title('Node Action Result');
        axes(WP_Axe_Cfs);
        set(WP_Axe_Cfs,'Xlim',[xmin xmax]);
        title('Colored Coefficients for Terminal Nodes');
        drawnow
        pop_colm = findobj(win_wptool,'style','popupmenu',...
                                        'tag',tag_pop_colm);
        col_mode = get(pop_colm,'Value');
        if      find(col_mode==[1 2 3 4])
                strlab = ['frequency ordered coefficients'];
        else
                strlab = ['(down -> up) for Cfs <==> (left -> right) in Tree'];
        end
        wsetxlab(WP_Axe_Cfs,strlab,-15);
        NB_ColorsInPal  = wmemtool('rmb',win_wptool,    ...
                                        n_wp1d2d_utils,ind_nb_colors);
        axes(WP_Axe_Col);
        image([0 1],[0 1],[1:NB_ColorsInPal]);
        set(WP_Axe_Col,...
                'XTickLabels',[],'YTickLabels',[],...
                'XTick',[],'YTick',[],'Tag',tag_axe_col);
        wsetxlab(WP_Axe_Col,'Scale of Colors from Min to Max',-15);

%***********************%
%** OPTION = 'anal' - **%
%***********************%
elseif strcmp(option,'anal')
        pop_handles     = findobj(win_wptool,'style','popupmenu');
        pop_curtree     = findobj(pop_handles,'Tag',tag_curtree);
        pop_nodact      = findobj(pop_handles,'Tag',tag_nodact);

        % Reading structures.
        %--------------------
        [tree_struct,data_struct] = ...
                        wmemtool('rmb',win_wptool,n_structures,...
                                        ind_tree_st,ind_data_st);
        wptreeop('input_tree',win_wptool,tree_struct,data_struct);
        depth = treedpth(tree_struct);
        str_depth = '0';
        for k=1:depth , str_depth = str2mat(str_depth,int2str(k)); end
        set(pop_curtree,'String',str_depth,'Value',depth+1);
        axes(WP_Axe_Pack);
        title('Node Action Result');

        % Setting Dynamic Visualization tool.
        %------------------------------------
        dynvtool('attach',win_wptool,...
                        [WP_Axe_Pack],[WP_Axe_Sig,WP_Axe_Cfs],[],[1 0],'','',...
                                                        'wp1dcoor',WP_Axe_Cfs);
        dynvtool('put',win_wptool);
        wptreeop('nodact',win_wptool,pop_nodact);

%**************************%
%** OPTION = 'r_orig' -  **%
%**************************%
elseif strcmp(option,'r_orig')
        out1 = findobj(WP_Axe_Sig,'type','line','tag',tag_lin_sig);

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('wp1ddraw','Unknown Option','msg');
        error('*');
end
