function out1 = wp1dmngr(option,win_wptool,in3,in4,in5,in6,in7)
%WP1DMNGR Wavelet packets 1D general manager.
%       out1 = wp1dmngr(option,win_wptool,in3,in4,in5,in6,in7)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:24:25 $

% Default values.
%----------------
max_lev_anal     = 12;
min_nbcolors     = 2;
max_nbcolors     = 128;
default_nbcolors = 128;

% MemBloc0 of stored values.
%---------------------------
n_InfoInit      = 'WP1D_InfoInit';
ind_filename    =  1;
ind_pathname    =  2;
nb0_stored      =  2;

% MemBloc1 of stored values.
%---------------------------
n_param_anal    = 'WP1D_Par_Anal';
ind_sig_name    =  1;
ind_wav_name    =  2;
ind_lev_anal    =  3;
ind_ent_anal    =  4;
ind_ent_par     =  5;
ind_sig_size    =  6;
ind_act_option  =  7;
nb1_stored      =  7;

% MemBloc2 of stored values.
%---------------------------
n_wp1d2d_utils  = 'WP1D2D_Utils';
ind_tree_lin    =  1;
ind_tree_txt    =  2;
ind_type_txt    =  3;
ind_sel_nodes   =  4;
ind_gra_area    =  5;
ind_nb_colors   =  6;
ind_wav_len     =  7;
nb2_stored      =  7;

% MemBloc3 of stored values.
%---------------------------
n_structures    = 'Structures';
ind_tree_st     =  1;
ind_data_st     =  2;
nb3_stored      =  2;

% MemBloc4 of stored values.
%---------------------------
n_sav_struct    = 'Sav_Struct';
ind_sav_tree_st =  1;
ind_sav_data_st =  2;
nb4_stored      =  2;

% Tag property of objects.
%-------------------------
tag_wav_fams    = 'Wav_Fams';
tag_wav_nums    = 'Wav_Nums';
tag_lev_data    = 'Lev_Data';
tag_pop_ent     = 'Pop_Ent';
tag_uic_ent     = 'Uic_Ent';

tag_axe_t_lin   = 'Axe_TreeLines';
tag_axe_t_txt   = 'Axe_TreeTexts';
tag_axe_sig     = 'Axe_Sig';
tag_axe_pack    = 'Axe_Pack';
tag_axe_cfs     = 'Axe_Cfs';

% Miscellaneous values.
%----------------------
Col_SigIni      = 'r';

axe_handles     = findobj(win_wptool,'type','axes');
uic_handles     = findobj(win_wptool,'type','uicontrol');
pop_handles     = findobj(uic_handles,'style','popupmenu');
pus_handles     = findobj(uic_handles,'style','pushbutton');
txt_handles     = findobj(uic_handles,'Style','text');

pop_wav_fams    = findobj(pop_handles,'Tag',tag_wav_fams);
pop_wav_nums    = findobj(pop_handles,'Tag',tag_wav_nums);
pop_lev_data    = findobj(pop_handles,'Tag',tag_lev_data);
pop_ent         = findobj(pop_handles,'Tag',tag_pop_ent);
uic_ent         = findobj(uic_handles,'Tag',tag_uic_ent);

WP_Axe_TreeTxt  = findobj(axe_handles,'flat','Tag',tag_axe_t_txt);
WP_Axe_TreeLin  = findobj(axe_handles,'flat','Tag',tag_axe_t_lin);
WP_Axe_Sig      = findobj(axe_handles,'flat','Tag',tag_axe_sig);
WP_Axe_Pack     = findobj(axe_handles,'flat','Tag',tag_axe_pack);
WP_Axe_Cfs      = findobj(axe_handles,'flat','Tag',tag_axe_cfs);

%****************************%
%** OPTION = 'load_sig' -  **%
%****************************%
if strcmp(option,'load_sig')
        % in3 optional (new_anal)
        %------------------------

        % Testing file.
        %-------------
        [xpos,ypos] = wfigutil('left_up',win_wptool,10,30);
        [filename,pathname] = uigetfile('*.mat','Load Signal',xpos,ypos);
        if filename~=0 & ~isempty(filename)
                [Signal_Name,ext] = strtok(filename,'.');
                % PROVISOIRE PROBLEME UIGETFILE PC (MAJ/MIN)
                Signal_Name = lower(Signal_Name);
                ext  = lower(ext);
                if ~strcmp(ext,'.mat')
                        msg = 'Invalid file name (ext = .mat) !';
                        errordlg(msg,'Load Signal ERROR','off');
                        return; 
                end
        else
                return;
        end

        % Loading file.
        %--------------
        wwaiting('msg',win_wptool,'Wait ... loading');
        LoSaFlag = 'load'; wloasavf;
        if err
                wwaiting('off',win_wptool);
                msg = ['File ' Signal_Name ' not found!'];
                errordlg(msg,'Load Signal ERROR','off');
                return
        end
        err = 0;
        if exist(deblank(Signal_Name))~=1
                err = 1;
                msg = ['File ' Signal_Name ' doesn''t contain variable ' ...
                               Signal_Name '.'];
        else
                Signal_Anal     = eval(Signal_Name);
                siz             = size(Signal_Anal);
                if min(siz)>1
                        err = 1;
                        msg = [Signal_Name ' is not a one dimensional Signal.'];
                elseif  siz(1)>1
                        Signal_Anal = (Signal_Anal)';
                end
        end
        if err
                wwaiting('off',win_wptool);
                errordlg(msg,'Load Signal ERROR','off');
                return
        end
        Signal_Size     = length(Signal_Anal);

        % Cleaning. 
        %----------
        wwaiting('msg',win_wptool,'Wait ... cleaning');
        wp1dutil('clean',win_wptool,option,'');

        % Setting Analysis parameters
        %-----------------------------
        wmemtool('wmb',win_wptool,n_param_anal,   ...
                        ind_act_option,option,    ...
                        ind_sig_name,Signal_Name, ...
                        ind_sig_size,Signal_Size  ...
                        );
        wmemtool('wmb',win_wptool,n_InfoInit, ...
                        ind_filename,filename,        ...
                        ind_pathname,pathname         ...
                        );
        wmemtool('wmb',win_wptool,n_wp1d2d_utils,...
                        ind_nb_colors,default_nbcolors);

        % Setting GUI values.
        %--------------------
        wp1dutil('set_gui',win_wptool,option);

        % Drawing.
        %---------
        wp1ddraw('sig',win_wptool,Signal_Anal);

        % Setting enabled values.
        %------------------------
        wp1dutil('enable',win_wptool,option);

        % End waiting.
        %-------------
        wwaiting('off',win_wptool);

%*************************%
%** option = 'load_dec' **%
%*************************%
elseif strcmp(option,'load_dec')

        if nargin==2
                % Testing file.
                %--------------
                [xpos,ypos] = wfigutil('left_up',win_wptool,10,30);
                [filename,pathname] = uigetfile('*.wp1',...
                                'Load Wavelet Packet Analysis (1D)',xpos,ypos);
                if filename==0 | isempty(filename) , return; end

                % Begin waiting.
                %--------------
                wwaiting('msg',win_wptool,'Wait ... loading');

                % Loading file.
                %--------------
                LoSaFlag = 'load'; wloasavf;
                if err==1
                        wwaiting('off',win_wptool);
                        msg = ['File ' filename ' not found!'];
                        errordlg(msg,'Load ERROR','off');
                        return
                end
                if      ~exist('tree_struct') , err = 1; var = 'tree_struct';
                elseif  ~exist('data_struct') , err = 1; var = 'data_struct';
                elseif  ~exist('data_name')
                                data_name = 'noname';
                end
                if err==1
                        wwaiting('off',win_wptool);
                        msg = ['variable : ' var ' , not found !'];
                        errargt('wp1dmngr',msg,'msg');
                        return; 
                end

                order = wtreemgr('order',tree_struct);
                if order~=2
                        wwaiting('off',win_wptool);
                        msg = ['The decomposition is not a '...
                                        'one dimensional analysis.'];
                        errordlg(msg,'Load Wavelet Packet Analysis (1D)','off');
                        return
                end

        elseif nargin==4
                filename     = '';
                pathname     = '';
                tree_struct  = in3;
                data_struct  = in4;
                data_name    = 'input var';
        end

        % Cleaning.
        %----------
        wwaiting('msg',win_wptool,'Wait ... cleaning');
        wp1dutil('clean',win_wptool,option);

        % Getting Analysis parameters.
        %-----------------------------
        Wave_Name       = wdatamgr('read_wave',data_struct);
        Wave_Len        = wavattrb('length',Wave_Name);
        [Ent_Name,Ent_Par] = wdatamgr('read_tp_ent',data_struct);
        Level_Anal      = wtreemgr('depth',tree_struct);
        Signal_Name     = data_name;
        sizes           = wdatamgr('rsizes',data_struct);
        Signal_Size     = sizes(1,1);

        % Setting Analysis parameters
        %-----------------------------
        wmemtool('wmb',win_wptool,n_param_anal,         ...
                                ind_act_option,option,          ...
                                ind_sig_name,Signal_Name,       ...
                                ind_wav_name,Wave_Name,         ...
                                ind_lev_anal,Level_Anal,        ...
                                ind_sig_size,Signal_Size,       ...
                                ind_ent_anal,Ent_Name,          ...
                                ind_ent_par,Ent_Par             ...
                                );
        wmemtool('wmb',win_wptool,n_wp1d2d_utils,               ...
                                ind_nb_colors,default_nbcolors, ...
                                ind_wav_len,Wave_Len            ...
                                );
        % Writing structures.
        %----------------------
        wmemtool('wmb',win_wptool,n_sav_struct, ...
                        ind_sav_tree_st,tree_struct,    ...
                        ind_sav_data_st,data_struct);
        wmemtool('wmb',win_wptool,n_structures, ...
                        ind_tree_st,tree_struct,        ...
                        ind_data_st,data_struct);

        % Setting GUI values.
        %--------------------
        wp1dutil('set_gui',win_wptool,option);

        % Computing and Drawing Original Signal.
        %---------------------------------------
        wwaiting('msg',win_wptool,'Wait ... computing');
        Signal_Anal = wprec(tree_struct,data_struct);
        wp1ddraw('sig',win_wptool,Signal_Anal);

        % Decomposition drawing
        %----------------------
        wp1ddraw('anal',win_wptool);

        % Setting enabled values.
        %------------------------
        wp1dutil('enable',win_wptool,option);

        % End waiting.
        %-------------
        wwaiting('off',win_wptool);

%*********************%
%** option = 'demo' **%
%*********************%
elseif strcmp(option,'demo')
        % in3 = Signal_Name
        % in4 = Wave_Name
        % in5 = Level_Anal
        % in6 = Ent_Name
        % in7 = Ent_Par (optional)
        %--------------------------
        Signal_Name     = in3;
        Wave_Name       = in4;
        Level_Anal      = in5;
        Ent_Name        = in6;
        if nargin==6 ,  Ent_Par = 0 ; else , Ent_Par = in7; end

        % Begin waiting.
        %--------------
        wwaiting('msg',win_wptool,'Wait ... loading');

        % Loading Signal.
        %----------------
        filename = Signal_Name;
        pathname = 'Wave_TBDemo';
        LoSaFlag = 'load'; wloasavf;
        if err==1
                wwaiting('off',win_wptool);
                msg = ['File ' Signal_Name ' not found!'];
                errordlg(msg,'Load ERROR','off');
                return
        end
        Signal_Anal     = eval(Signal_Name);
        Signal_Size     = length(Signal_Anal);

        % Cleaning.
        %----------
        wwaiting('msg',win_wptool,'Wait ... cleaning');
        wp1dutil('clean',win_wptool,option);

        % Setting Analysis parameters
        %-----------------------------
        wmemtool('wmb',win_wptool,n_param_anal,            ...
                                ind_act_option,option,     ...
                                ind_sig_name,Signal_Name,  ...
                                ind_wav_name,Wave_Name,    ...
                                ind_lev_anal,Level_Anal,   ...
                                ind_sig_size,Signal_Size,  ...
                                ind_ent_anal,Ent_Name,     ...
                                ind_ent_par,Ent_Par        ...
                        );
        wmemtool('wmb',win_wptool,n_InfoInit, ...
                        ind_filename,filename,  ...
                        ind_pathname,pathname   ...
                        );
        Wave_Len        = wavattrb('length',Wave_Name);
        wmemtool('wmb',win_wptool,n_wp1d2d_utils,               ...
                                ind_nb_colors,default_nbcolors, ...
                                ind_wav_len,Wave_Len            ...
                                );

        % Setting GUI values.
        %--------------------
        wp1dutil('set_gui',win_wptool,option);

        % Drawing.
        %---------
        wp1ddraw('sig',win_wptool,Signal_Anal);

        % Calling Analysis.
        %-----------------
        wp1dmngr('step2',win_wptool,option);

        % Setting enabled values.
        %------------------------
        wp1dutil('enable',win_wptool,option);

        % End waiting.
        %-------------
        wwaiting('off',win_wptool);

%**************************%
%** option = 'save_synt' **%
%**************************%
elseif strcmp(option,'save_synt')
        % Testing file.
        %--------------
        [xpos,ypos] = wfigutil('left_up',win_wptool,10,30);
        [filename,pathname] = uiputfile('*.mat',...
                        'Save Synthesized Signal',xpos,ypos);
        if filename==0 | isempty(filename) , return; end
        [name,ext] = strtok(filename,'.');
        ext = '.mat';
        filename = [name ext];

        % Begin waiting.
        %--------------
        wwaiting('msg',win_wptool,'Wait ... saving');

        % Saving Synthesized Signal.
        %---------------------------
        str_name = lower(name);
        hdl_node = wpssnode('r_synt',win_wptool);
        if ~isempty(hdl_node)
                eval([str_name '= get(hdl_node,''userdata'');']);       
        else
                % Reading structures.
                %--------------------
                [tree_struct,data_struct] =     ...
                        wmemtool('rmb',win_wptool,n_structures,...
                                        ind_tree_st,ind_data_st);
                eval([str_name '= wprec(tree_struct,data_struct);']);
        end

        % Saving file.
        %--------------
        saveStr = str_name;
        LoSaFlag = 'save'; wloasavf;

        % End waiting.
        %-------------
        wwaiting('off',win_wptool);

        if err
                errargt('wp1dmngr','Save FAILED !','msg');
        end

%*************************%
%** option = 'save_dec' **%
%*************************%
elseif strcmp(option,'save_dec')
        % Testing file.
        %--------------
        [xpos,ypos] = wfigutil('left_up',win_wptool,10,30);
        [filename,pathname] = uiputfile('*.wp1',...
                        'Save Wavelet Packet Analysis (1D)',xpos,ypos);
        if filename==0 | isempty(filename) , return; end

        % Begin waiting.
        %--------------
        wwaiting('msg',win_wptool,'Wait ... saving decomposition');

        [name,ext] = strtok(filename,'.');
        ext = '.wp1';
        filename = [name ext];

        % Getting Analysis parameters.
        %-----------------------------
        data_name = wmemtool('rmb',win_wptool,n_param_anal,ind_sig_name);

        % Reading structures.
        %--------------------
        [tree_struct,data_struct] = wmemtool('rmb',win_wptool,n_structures,...
                                        ind_tree_st,ind_data_st);

        % Saving file.
        %--------------
        saveStr = [' tree_struct data_struct data_name'];
        LoSaFlag = 'save'; wloasavf;

        % End waiting.
        %-------------
        wwaiting('off',win_wptool);

        if err
                errargt('wp1dmngr','Save FAILED !','msg');
        end

%*************************%
%** OPTION = 'anal' -   **%
%*************************%
elseif strcmp(option,'anal')
        active_option = wmemtool('rmb',win_wptool,n_param_anal,...
                                        ind_act_option);
        if ~strcmp(active_option,'load_sig')

                % Test for new Analysis.
                %-----------------------
                % new = wwaitans(win_wptool,'New Analysis ?');
                % if new==0 , return; end

                % Cleaning. 
                %----------
                wwaiting('msg',win_wptool,'Wait ... cleaning');
                wp1dutil('clean',win_wptool,'load_sig','new_anal');
                wp1dutil('enable',win_wptool,'load_sig');
        else
                wmemtool('wmb',win_wptool,n_param_anal,ind_act_option,'anal');
        end

        % Waiting message.
        %-----------------
        wwaiting('msg',win_wptool,'Wait ... computing');

        % Setting Analysis parameters
        %-----------------------------
        [Wave_Name,Wave_Fam,Wave_Num] = ...
                wavattrb('wname',pop_wav_fams,pop_wav_nums,'all');
        Wave_Len        = wavattrb('length',Wave_Name);
        Level_Anal      = get(pop_lev_data,'Value');
        ent_str         = get(pop_ent,'String');
        val_ent         = get(pop_ent,'Value');
        Ent_Name        = deblankl(ent_str(val_ent,:));
        Ent_Par         = deblankl(get(uic_ent,'String'));
        if      (val_ent==1) | (val_ent==4)
                Ent_Par = 0;
        elseif  (val_ent==2) | (val_ent==3) | (val_ent==5)
                err = 0;
                if isempty(abs(Ent_Par))
                        err = 1;
                else
                        Ent_Par = str2num(Ent_Par);
                        if      isempty(abs(Ent_Par))
                                err = 1;
                        elseif  (val_ent==2) | (val_ent==5)
                                if Ent_Par<=0 , err = 1; end;
                        elseif  (val_ent==3)
                                if (Ent_Par<1) | (Ent_Par>=2) , err = 1; end;
                        end             
                end

                if err
                        wwaiting('off',win_wptool);
                        errargt('wp1dmngr',...
                                'Invalid entropy parameter value! ','msg');
                        set(uic_ent,'String','');
                        return
                end                     
        elseif  val_ent==6

        end
        wmemtool('wmb',win_wptool,n_param_anal,         ...
                                ind_wav_name,Wave_Name,         ...
                                ind_lev_anal,Level_Anal,        ...
                                ind_ent_anal,Ent_Name,          ...
                                ind_ent_par,Ent_Par             ...
                                );
        wmemtool('wmb',win_wptool,n_wp1d2d_utils,               ...
                                ind_wav_len,Wave_Len            ...
                                );
        % Calling Analysis.
        %------------------
        wp1dmngr('step2',win_wptool,option);

        % Setting enabled values.
        %------------------------
        wp1dutil('enable',win_wptool,option);

        % End waiting.
        %-------------
        wwaiting('off',win_wptool);

%*************************%
%** OPTION = 'step2' -  **%
%*************************%
elseif strcmp(option,'step2')

        % Begin waiting.
        %---------------
        wwaiting('msg',win_wptool,'Wait ... computing');

        % Getting  Analysis parameters.
        %------------------------------
        [Signal_Name,Signal_Size,Wave_Name,Level_Anal,Ent_Name,Ent_Par] = ...
                wmemtool('rmb',win_wptool,n_param_anal, ...
                                ind_sig_name,ind_sig_size,   ...
                                ind_wav_name,ind_lev_anal,   ...
                                ind_ent_anal,ind_ent_par);
        active_option = wmemtool('rmb',win_wptool,n_param_anal,ind_act_option);
        [filename,pathname] = wmemtool('rmb',win_wptool,n_InfoInit, ...
                                        ind_filename,ind_pathname);

        if strcmp(active_option,'demo') | strcmp(active_option,'anal')
                numopt = 1;
        elseif strcmp(active_option,'load_dec')
                numopt = 2;     
        end

        % Computing.
        %-----------
        if      numopt==1
                LoSaFlag = 'load'; wloasavf;
                if      err==1
                        msg = ['File ' filename ' not found!'];
                        wwaiting('off',win_wptool);
                        errordlg(msg,'Load Signal ERROR','off');
                        return
                end
                Signal_Anal = eval(Signal_Name);

        elseif  numopt==2       % second time only for load_dec
                Signal_Anal = get(wp1ddraw('r_orig',win_wptool),'Ydata');
        end
        [tree_struct,data_struct] = ...
                wpdec(Signal_Anal,Level_Anal,Wave_Name,Ent_Name,Ent_Par);

        % Writing structures.
        %----------------------
        wmemtool('wmb',win_wptool,n_sav_struct,      ...
                        ind_sav_tree_st,tree_struct, ...
                        ind_sav_data_st,data_struct);

        wmemtool('wmb',win_wptool,n_structures,   ...
                        ind_tree_st,tree_struct,  ...
                        ind_data_st,data_struct);

        % Decomposition drawing
        %----------------------
        wp1ddraw('anal',win_wptool);

        % End waiting.
        %-------------
        wwaiting('off',win_wptool);

%*************************%
%** OPTION = 'comp' -   **%
%*************************%
elseif strcmp(option,'comp')
        mousefrm(0,'watch');
        drawnow;
        wp1dutil('enable',win_wptool,option);
        out1 = feval('wp1dcomp','create',win_wptool);

%*************************%
%** OPTION = 'deno' -   **%
%*************************%
elseif strcmp(option,'deno')
        mousefrm(0,'watch');
        drawnow;
        wp1dutil('enable',win_wptool,option);
        out1 = feval('wp1ddeno','create',win_wptool);

%********************************************%
%** OPTION = 'return_comp' or 'return_deno'**%
%********************************************%
elseif strcmp(option,'return_comp') | strcmp(option,'return_deno')
        % in3 = 1 : preserve compression
        % in3 = 0 : discard compression
        % in4 = hdl_line (optional)
        %--------------------------------------

        if in3==1
                % Begin waiting.
                %--------------
                wwaiting('msg',win_wptool,'Wait ... drawing');
                
                if strcmp(option,'return_comp')
                        namesig = 'cs';
                else
                        namesig = 'ds';
                end
                wpssnode('plot',win_wptool,namesig,1,in4);

                % End waiting.
                %-------------
                wwaiting('off',win_wptool);
        end
        wp1dutil('enable',win_wptool,option);

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('wp1dmngr','Unknown Option','msg');
        error('*');
end
