function out1 = wp2dmngr(option,win_wptool,in3,in4,in5,in6,in7)
%WP2DMNGR Wavelet packets 2D general manager.
%       out1 = wp2dmngr(option,win_wptool,in3,in4,in5,in6,in7)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:26:03 $

global Lst_ColorMap

% Default values.
%----------------
max_lev_anal     = 5;
min_nbcolors     = 2;
max_nbcolors     = 256;
default_nbcolors = 255;
min_bright       = -2;
max_bright       = 2;
default_bright   = 0;

% MemBloc0 of stored values.
%---------------------------
n_InfoInit      = 'WP2D_InfoInit';
ind_filename    =  1;
ind_pathname    =  2;
nb0_stored      =  2;

% MemBloc1 of stored values.
%---------------------------
n_param_anal    = 'WP2D_Par_Anal';
ind_img_name    =  1;
ind_wav_name    =  2;
ind_lev_anal    =  3;
ind_ent_anal    =  4;
ind_ent_par     =  5;
ind_img_size    =  6;
ind_img_t_name  =  7;
ind_act_option  =  8;
nb1_stored      =  8;

% MemBloc2 of stored values.
%---------------------------
n_wp1d2d_utils  = 'WP1D2D_Utils';
ind_tree_lin    =  1;
ind_tree_txt    =  2;
ind_type_txt    =  3;
ind_sel_nodes   =  4;
ind_gra_area    =  5;
ind_nb_colors   =  6;
ind_wav_len     =  7;
nb2_stored      =  7;

% MemBloc3 of stored values.
%---------------------------
n_structures    = 'Structures';
ind_tree_st     =  1;
ind_data_st     =  2;
nb3_stored      =  2;

% MemBloc4 of stored values.
%---------------------------
n_sav_struct    = 'Sav_Struct';
ind_sav_tree_st =  1;
ind_sav_data_st =  2;
nb4_stored      =  2;

% Tag property of objects.
%-------------------------
tag_wav_fams    = 'Wav_Fams';
tag_wav_nums    = 'Wav_Nums';
tag_lev_data    = 'Lev_Data';
tag_pop_ent     = 'Pop_Ent';
tag_uic_ent     = 'Uic_Ent';
tag_cfs_map     = 'Pop_ColorMap';
tag_edi_nbc     = 'Edi_NBColors';

tag_axe_t_lin   = 'Axe_TreeLines';
tag_axe_t_txt   = 'Axe_TreeTexts';
tag_axe_sig     = 'Axe_Sig';
tag_axe_pack    = 'Axe_Pack';
tag_axe_cfs     = 'Axe_Cfs';

axe_handles     = findobj(win_wptool,'type','axes');
uic_handles     = findobj(win_wptool,'type','uicontrol');
pop_handles     = findobj(uic_handles,'style','popupmenu');
pus_handles     = findobj(uic_handles,'style','pushbutton');
txt_handles     = findobj(uic_handles,'Style','text');

pop_wav_fams    = findobj(pop_handles,'Tag',tag_wav_fams);
pop_wav_nums    = findobj(pop_handles,'Tag',tag_wav_nums);
pop_lev_data    = findobj(pop_handles,'Tag',tag_lev_data);
pop_ent         = findobj(pop_handles,'Tag',tag_pop_ent);
uic_ent         = findobj(uic_handles,'Tag',tag_uic_ent);
pop_cfs_map     = findobj(pop_handles,'Tag',tag_cfs_map);
edi_nbc         = findobj(uic_handles,'Tag',tag_edi_nbc);

WP_Axe_TreeTxt  = findobj(axe_handles,'flat','Tag',tag_axe_t_txt);
WP_Axe_TreeLin  = findobj(axe_handles,'flat','Tag',tag_axe_t_lin);
WP_Axe_Sig      = findobj(axe_handles,'flat','Tag',tag_axe_sig);
WP_Axe_Pack     = findobj(axe_handles,'flat','Tag',tag_axe_pack);
WP_Axe_Cfs      = findobj(axe_handles,'flat','Tag',tag_axe_cfs);

%****************************%
%** OPTION = 'load_img' -  **%
%****************************%
if strcmp(option,'load_img')
        % Testing file.
        %-------------
        [xpos,ypos] = wfigutil('left_up',win_wptool,10,30);
        [filename,pathname] = uigetfile('*.mat','Load Image',xpos,ypos);
        if filename~=0 & ~isempty(filename)
                [Img_Name,ext] = strtok(filename,'.');
                % PROVISOIRE PROBLEME UIGETFILE PC (MAJ/MIN)
                Img_Name = lower(Img_Name);
                ext  = lower(ext);
                if ~strcmp(ext,'.mat')
                        msg = 'Invalid file name (ext = .mat) !';
                        errordlg(msg,'Load Image ERROR','off');
                        return; 
                end
        else
                return;
        end

        % Loading file.
        %--------------
        wwaiting('msg',win_wptool,'Wait ... loading');
        LoSaFlag = 'load'; wloasavf;
        if      err==1
                msg = ['File ' Img_Name ' not found!'];
        elseif  exist('X')==1           
                Img_True_Name   = 'X';
        elseif  exist(deblank(Img_Name))==1             
                Img_True_Name   = Img_Name;
        else
                err = 1;
                msg = ['File ' Img_Name ' doesn''t contain variable ' ...
                                Img_Name ' nor variable X.'];
        end
        if (nargin==2) & (err==0)
                Image_Size      = fliplr(size(eval(Img_True_Name)));
                if min(Image_Size)<2
                        err = 1;
                        msg = [Img_Name ' is not an Image.'];
                end
        end
        if err
                wwaiting('off',win_wptool);
                errordlg(msg,'Load Image ERROR','off');
                return
        end
        if exist('map')==1
                self_map        = 1;
        else
                mi = min(min(eval(Img_True_Name)));
                ma = max(max(eval(Img_True_Name)));
                if mi<=0 , ma = ma-mi+1; end
                if ma>default_nbcolors
                        ma = default_nbcolors; 
                elseif ma<2
                        ma = 2;
                end
                map             = pink(ma);
                self_map        = 0;
        end
        NB_ColorsInPal = size(map,1);

        % Cleaning. 
        %----------
        wwaiting('msg',win_wptool,'Wait ... cleaning');
        wp2dutil('clean',win_wptool,option,'');

        % Setting Analysis parameters.
        %-----------------------------
        wmemtool('wmb',win_wptool,n_param_anal,       ...
                        ind_act_option,option,        ...
                        ind_img_name,Img_Name,        ...
                        ind_img_t_name,Img_True_Name, ...
                        ind_img_size,Image_Size       ...
                        );
        wmemtool('wmb',win_wptool,n_InfoInit,     ...
                        ind_filename,filename,    ...
                        ind_pathname,pathname     ...
                        );
        wmemtool('wmb',win_wptool,n_wp1d2d_utils,  ...
                        ind_nb_colors,NB_ColorsInPal);

        % Setting GUI values.
        %--------------------
        wp2dutil('set_gui',win_wptool,option,'');
        str_pop_map = Lst_ColorMap;
        if self_map
                str_pop_map = str2mat(str_pop_map,'self');
                set(pop_cfs_map,'String',str_pop_map,'Userdata',map);
        else
                set(pop_cfs_map,'String',str_pop_map,'Userdata','');
        end
        mapcolor('set',win_wptool,'pink',[pop_cfs_map edi_nbc],NB_ColorsInPal);

        % Drawing.
        %---------
        wp2ddraw('sig',win_wptool,eval(Img_True_Name));

        % Setting enabled values.
        %------------------------
        wp2dutil('enable',win_wptool,option);

        % End waiting.
        %-------------
        wwaiting('off',win_wptool);

%*************************%
%** option = 'load_dec' **%
%*************************%
elseif strcmp(option,'load_dec')
        if nargin==2
                % Testing file.
                %--------------
                [xpos,ypos] = wfigutil('left_up',win_wptool,10,30);
                [filename,pathname] = uigetfile('*.wp2',...
                                'Load Wavelet Packet Analysis (2D)',xpos,ypos);
                if filename==0 | isempty(filename) , return; end

                % Begin waiting.
                %--------------
                wwaiting('msg',win_wptool,'Wait ... loading');

                % Loading file.
                %--------------
                LoSaFlag = 'load'; wloasavf;
                if err==1
                        wwaiting('off',win_wptool);
                        msg = ['File ' filename ' not found!'];
                        errordlg(msg,'Load ERROR','off');
                        return
                end
                if      ~exist('tree_struct') , err = 1; var = 'tree_struct';
                elseif  ~exist('data_struct') , err = 1; var = 'data_struct';
                else
                    if  ~exist('map'), map = pink(default_nbcolors); end
                    if  ~exist('data_name') , data_name = 'no name'; end
                end
                if err==1
                        wwaiting('off',win_wptool);
                        msg = ['variable : ' var ' , not found !'];
                        errargt('wp2dmngr',msg,'msg');
                        return;
                end

                order = wtreemgr('order',tree_struct);
                if order~=4
                        wwaiting('off',win_wptool);
                        msg = ['The decomposition is not a '...
                                        'two dimensional analysis.'];
                        errordlg(msg,'Load Wavelet Packet Analysis (2D)','off');
                        return
                end

        elseif nargin==4
                tree_struct     = in3;
                data_struct     = in4;
                map             = pink(default_nbcolors);
                data_name       = 'input var';
        end

        % Cleaning.
        %----------
        wwaiting('msg',win_wptool,'Wait ... cleaning');
        wp2dutil('clean',win_wptool,option);

        % Getting Analysis parameters.
        %-----------------------------
        Wave_Name       = wdatamgr('read_wave',data_struct);
        Wave_Len        = wavattrb('length',Wave_Name);
        [Ent_Name,Ent_Par] = wdatamgr('read_tp_ent',data_struct);
        Level_Anal      = wtreemgr('depth',tree_struct);
        Img_Name        = data_name;
        sizes           = wdatamgr('rsizes',data_struct);
        Img_Size        = sizes(:,1);
        NB_ColorsInPal  = size(map,1);

        % Setting Analysis parameters
        %-----------------------------
        wmemtool('wmb',win_wptool,n_param_anal,         ...
                                ind_act_option,option,          ...
                                ind_img_name,Img_Name,          ...
                                ind_wav_name,Wave_Name,         ...
                                ind_lev_anal,Level_Anal,        ...
                                ind_img_size,Img_Size,          ...
                                ind_ent_anal,Ent_Name,          ...
                                ind_ent_par,Ent_Par             ...
                                );
        wmemtool('wmb',win_wptool,n_InfoInit, ...
                        ind_filename,filename,  ...
                        ind_pathname,pathname   ...
                        );
        wmemtool('wmb',win_wptool,n_wp1d2d_utils,               ...
                                ind_nb_colors,NB_ColorsInPal,   ...
                                ind_wav_len,Wave_Len            ...
                                );
        % Writing structures.
        %----------------------
        wmemtool('wmb',win_wptool,n_sav_struct, ...
                        ind_sav_tree_st,tree_struct,    ...
                        ind_sav_data_st,data_struct);
        wmemtool('wmb',win_wptool,n_structures, ...
                        ind_tree_st,tree_struct,        ...
                        ind_data_st,data_struct);

        % Setting GUI values.
        %--------------------
        wp2dutil('set_gui',win_wptool,option);
        str_pop_map = str2mat(Lst_ColorMap,'self');
        set(pop_cfs_map,'String',str_pop_map,'Userdata',map);
        mapcolor('set',win_wptool,'pink',[pop_cfs_map edi_nbc],NB_ColorsInPal);

        % Computing Original Signal.
        %--------------------------
        wwaiting('msg',win_wptool,'Wait ... computing');
        Img_Anal = wprec2(tree_struct,data_struct);

        % Drawing.
        %---------
        wp2ddraw('sig',win_wptool,Img_Anal);

        % Decomposition drawing
        %----------------------
        wp2ddraw('anal',win_wptool);

        % Setting enabled values.
        %------------------------
        wp2dutil('enable',win_wptool,option);

        % End waiting.
        %-------------
        wwaiting('off',win_wptool);

%*********************%
%** option = 'demo' **%
%*********************%
elseif strcmp(option,'demo')
        % in3 = Img_Name
        % in4 = Wave_Name
        % in5 = Level_Anal
        % in6 = Ent_Name
        % in7 = Ent_Par (optional)
        %------------------
        Img_Name        = in3;
        Wave_Name       = in4;
        Level_Anal      = in5;
        Ent_Name        = in6;
        if nargin==6 ,  Ent_Par = 0 ; else , Ent_Par = in7; end

        % Loading Image.
        %---------------
        wwaiting('msg',win_wptool,'Wait ... loading');
        filename = Img_Name;
        pathname = 'Wave_TBDemo';
        LoSaFlag = 'load'; wloasavf;
        if      err==1
                wwaiting('off',win_wptool);
                msg = ['File ' Img_Name ' not found!'];
                errordlg(msg,'Load ERROR','off');
                return
        elseif  exist('X')              
                Img_True_Name   = 'X';
                self_map        = 1;
        else                    
                Img_True_Name   = Img_Name;
                mi = min(min(Img_Anal));
                ma = max(max(Img_Anal));
                if mi<=0 , ma = ma-mi+1; end
                if ma>default_nbcolors
                        ma = default_nbcolors; 
                elseif ma<2
                        ma = 2;
                end
                map             = pink(ma);
                self_map        = 0;
        end
        NB_ColorsInPal  = size(map,1);
        Img_Anal        = eval(Img_True_Name);
        Image_Size      = fliplr(size(Img_Anal));

        % Cleaning.
        %----------
        wwaiting('msg',win_wptool,'Wait ... cleaning');
        wp2dutil('clean',win_wptool,option);

        % Setting Analysis parameters
        %-----------------------------
        wmemtool('wmb',win_wptool,n_param_anal,               ...
                                ind_act_option,option,        ...
                                ind_img_name,Img_Name,        ...
                                ind_img_t_name,Img_True_Name, ...
                                ind_wav_name,Wave_Name,       ...
                                ind_lev_anal,Level_Anal,      ...
                                ind_img_size,Image_Size,      ...
                                ind_ent_anal,Ent_Name,        ...
                                ind_ent_par,Ent_Par           ...
                                );
        wmemtool('wmb',win_wptool,n_InfoInit, ...
                        ind_filename,filename,...
                        ind_pathname,pathname ...
                        );
        Wave_Len        = wavattrb('length',Wave_Name);
        wmemtool('wmb',win_wptool,n_wp1d2d_utils,               ...
                                ind_nb_colors,NB_ColorsInPal,   ...
                                ind_wav_len,Wave_Len            ...
                                );
        % Setting GUI values.
        %--------------------
        wp2dutil('set_gui',win_wptool,option);
        str_pop_map = Lst_ColorMap;
        if self_map
                str_pop_map = str2mat(str_pop_map,'self');
                set(pop_cfs_map,'String',str_pop_map,'Userdata',map);
        else
                set(pop_cfs_map,'String',str_pop_map,'Userdata','');
        end
        mapcolor('set',win_wptool,'pink',[pop_cfs_map edi_nbc],NB_ColorsInPal);

        % Drawing.
        %---------
        wp2ddraw('sig',win_wptool,Img_Anal);

        % Calling Analysis.
        %-----------------
        wwaiting('msg',win_wptool,'Wait ... computing');
        wp2dmngr('step2',win_wptool,option);

        % Setting enabled values.
        %------------------------
        wp2dutil('enable',win_wptool,option);

        % End waiting.
        %-------------
        wwaiting('off',win_wptool);

%**************************%
%** option = 'save_synt' **%
%**************************%
elseif strcmp(option,'save_synt')
        % Testing file.
        %--------------
        [xpos,ypos] = wfigutil('left_up',win_wptool,10,30);
        [filename,pathname] = uiputfile('*.mat',...
                        'Save Synthesized Signal',xpos,ypos);
        if filename==0 | isempty(filename) , return; end
        [name,ext] = strtok(filename,'.');
        ext = '.mat';
        filename = [name ext];

        % Begin waiting.
        %--------------
        wwaiting('msg',win_wptool,'Wait ... saving');

        % Getting ColorMap.
        %--------------------
        str_pop_map     = get(pop_cfs_map,'String');
        map             = get(pop_cfs_map,'Userdata');
        if isempty(map)
                NB_ColorsInPal  = wmemtool('rmb',win_wptool,...
                                        n_wp1d2d_utils,ind_nb_colors);
                map = pink(NB_ColorsInPal);
        end

        % Getting Synthesized Image.
        %---------------------------
        str_name = lower(name);
        hdl_node = wpssnode('r_synt',win_wptool);
        if ~isempty(hdl_node)
                eval([str_name '= get(hdl_node,''userdata'');']);       
        else
                % Reading structures.
                %--------------------
                [tree_struct,data_struct] = ...
                        wmemtool('rmb',win_wptool,n_structures,...
                                                ind_tree_st,ind_data_st);
                eval([str_name '= wprec2(tree_struct,data_struct);']);
        end

        % Saving file.
        %--------------
        saveStr = [str_name ' map'];
        LoSaFlag = 'save'; wloasavf;

        % End waiting.
        %-------------
        wwaiting('off',win_wptool);

        if err
                errargt('wp2dmngr','Save FAILED !','msg');
        end

%*************************%
%** option = 'save_dec' **%
%*************************%
elseif strcmp(option,'save_dec')
        % Testing file.
        %--------------
        [xpos,ypos] = wfigutil('left_up',win_wptool,10,30);
        [filename,pathname] = uiputfile('*.wp2',...
                        'Save Wavelet Packet Analysis (2D)',xpos,ypos);
        if filename==0 | isempty(filename) , return; end

        % Begin waiting.
        %--------------
        wwaiting('msg',win_wptool,'Wait ... saving decomposition');

        [name,ext] = strtok(filename,'.');
        ext = '.wp2';
        filename = [name ext];

        % Getting Analysis parameters.
        %-----------------------------
        data_name = wmemtool('rmb',win_wptool,n_param_anal,ind_img_name);

        % Reading structures.
        %--------------------
        [tree_struct,data_struct] = wmemtool('rmb',win_wptool,n_structures,...
                                        ind_tree_st,ind_data_st);

        % Getting ColorMap.
        %--------------------
        str_pop_map     = get(pop_cfs_map,'String');
        map             = get(pop_cfs_map,'Userdata');
        NB_ColorsInPal  = wmemtool('rmb',win_wptool,n_wp1d2d_utils,...
                                                        ind_nb_colors);
        if isempty(map) , map = pink(NB_ColorsInPal); end

        % Saving file.
        %--------------
        saveStr = ['tree_struct data_struct map data_name'];
        LoSaFlag = 'save'; wloasavf;

        % End waiting.
        %-------------
        wwaiting('off',win_wptool);

        if err
                errargt('wp2dmngr','Save FAILED !','msg');
        end

%*************************%
%** OPTION = 'anal' -   **%
%*************************%
elseif strcmp(option,'anal')
        active_option = wmemtool('rmb',win_wptool,n_param_anal,...
                                        ind_act_option);
        if ~strcmp(active_option,'load_img')

                % Test for new Analysis.
                %-----------------------
                % new = wwaitans(win_wptool,'New Analysis ?');
                % if new==0 , return; end

                % Cleaning. 
                %----------
                wwaiting('msg',win_wptool,'Wait ... cleaning');
                wp2dutil('clean',win_wptool,'load_img','new_anal');
                wp2dutil('enable',win_wptool,'load_img');
        else
                wmemtool('wmb',win_wptool,n_param_anal,ind_act_option,'anal');
        end

        % Waiting message.
        %-----------------
        wwaiting('msg',win_wptool,'Wait ... computing');

        % Setting Analysis parameters
        %-----------------------------
        [Wave_Name,Wave_Fam,Wave_Num] = ...
                wavattrb('wname',pop_wav_fams,pop_wav_nums,'all');
        Wave_Len        = wavattrb('length',Wave_Name);
        Level_Anal      = get(pop_lev_data,'Value');
        ent_str         = get(pop_ent,'String');
        val_ent         = get(pop_ent,'Value');
        Ent_Name        = deblankl(ent_str(val_ent,:));
        Ent_Par         = deblankl(get(uic_ent,'String'));
        if      (val_ent==1) | (val_ent==4)
                Ent_Par = 0;
        elseif  (val_ent==2) | (val_ent==3) | (val_ent==5)
                err = 0;
                if isempty(abs(Ent_Par))
                        err = 1;
                else
                        Ent_Par = str2num(Ent_Par);
                        if      isempty(abs(Ent_Par))
                                err = 1;
                        elseif  (val_ent==2) | (val_ent==5)
                                if Ent_Par<=0 , err = 1; end;
                        elseif  (val_ent==3)
                                if (Ent_Par<1) | (Ent_Par>=2) , err = 1; end;
                        end             
                end

                if err
                        wwaiting('off',win_wptool);
                        errargt('wp1dmngr',...
                                'Invalid entropy parameter value! ','msg');
                        set(uic_ent,'String','');
                        return
                end                     
        elseif  val_ent==6

        end
        wmemtool('wmb',win_wptool,n_param_anal,         ...
                                ind_wav_name,Wave_Name,         ...
                                ind_lev_anal,Level_Anal,        ...
                                ind_ent_anal,Ent_Name,          ...
                                ind_ent_par,Ent_Par             ...
                                );
        wmemtool('wmb',win_wptool,n_wp1d2d_utils,               ...
                                ind_wav_len,Wave_Len            ...
                                );

        % Calling Analysis.
        %------------------
        wp2dmngr('step2',win_wptool,option);

        % Setting enabled values.
        %------------------------
        wp2dutil('enable',win_wptool,option);

        % End waiting.
        %-------------
        wwaiting('off',win_wptool);

%*************************%
%** OPTION = 'step2' -  **%
%*************************%
elseif strcmp(option,'step2')

        % Begin waiting.
        %---------------
        wwaiting('msg',win_wptool,'Wait ... computing');

        % Getting  Analysis parameters.
        %------------------------------
        [Img_Name,Img_Size,Wave_Name,Level_Anal,...
                        Img_True_Name,Ent_Name,Ent_Par] = ...
                        wmemtool('rmb',win_wptool,n_param_anal, ...
                                        ind_img_name,ind_img_size,   ...
                                        ind_wav_name,ind_lev_anal,   ...
                                        ind_img_t_name, ...
                                        ind_ent_anal,ind_ent_par);
        active_option = wmemtool('rmb',win_wptool,n_param_anal,ind_act_option);
        [filename,pathname] = wmemtool('rmb',win_wptool,n_InfoInit, ...
                                        ind_filename,ind_pathname);

        if strcmp(active_option,'demo') | strcmp(active_option,'anal')
                numopt = 1;
        elseif strcmp(active_option,'load_dec')
                numopt = 2;     
        end

        % Computing.
        %-----------
        if      numopt==1
                LoSaFlag = 'load'; wloasavf;
                if      err==1
                        msg = ['File ' filename ' not found!'];
                        wwaiting('off',win_wptool);
                        errordlg(msg,'Load Image ERROR','off');
                        return
                end
                Img_Anal = eval(Img_True_Name);

        elseif  numopt==2       % second time only for load_dec
                Img_Anal = get(wp2ddraw('r_orig',win_wptool),'Cdata');
        end
        [tree_struct,data_struct] = ...
                wpdec2(Img_Anal,Level_Anal,Wave_Name,Ent_Name,Ent_Par);

        % Writing structures.
        %----------------------
        wmemtool('wmb',win_wptool,n_sav_struct, ...
                        ind_sav_tree_st,tree_struct,    ...
                        ind_sav_data_st,data_struct);
        wmemtool('wmb',win_wptool,n_structures, ...
                        ind_tree_st,tree_struct,        ...
                        ind_data_st,data_struct);

        % Decomposition drawing
        %----------------------
        wp2ddraw('anal',win_wptool);

        % End waiting.
        %-------------
        wwaiting('off',win_wptool);

%*************************%
%** OPTION = 'comp' -   **%
%*************************%
elseif strcmp(option,'comp')
        mousefrm(0,'watch');
        drawnow;
        wp2dutil('enable',win_wptool,option);
        out1 = feval('wp2dcomp','create',win_wptool);

%*************************%
%** OPTION = 'deno' -   **%
%*************************%
elseif strcmp(option,'deno')
        mousefrm(0,'watch');
        drawnow;
        wp2dutil('enable',win_wptool,option);
        out1 = feval('wp2ddeno','create',win_wptool);

%********************************************%
%** OPTION = 'return_comp' or 'return_deno'**%
%********************************************%
elseif strcmp(option,'return_comp') | strcmp(option,'return_deno')
        % in3 = 1 : preserve compression
        % in3 = 0 : discard compression
        % in4 = hdl_img (optional)
        %--------------------------------------

        if in3==1
                % Begin waiting.
                %--------------
                wwaiting('msg',win_wptool,'Wait ... drawing');
                
                if strcmp(option,'return_comp')
                        namesig = 'cs';
                else
                        namesig = 'ds';
                end
                wpssnode('plot',win_wptool,namesig,2,in4)

                % End waiting.
                %-------------
                wwaiting('off',win_wptool);
        end
        wp2dutil('enable',win_wptool,option);

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('wp2dmngr','Unknown Option','msg');
        error('*');
end
