function wp2dutil(option,win_wptool,in3,in4)
%WP2DUTIL Wavelet packets 2D utilities.
%       wp2dutil(option,win_wptool,in3,in4)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.

% Default values.
%----------------
max_lev_anal     = 5;
min_nbcolors     = 2;
max_nbcolors     = 256;
default_nbcolors = 255;
min_bright       = -2;
max_bright       = 2;
default_bright   = 0;

% MemBloc1 of stored values.
%---------------------------
n_param_anal    = 'WP2D_Par_Anal';
ind_img_name    =  1;
ind_wav_name    =  2;
ind_lev_anal    =  3;
ind_ent_anal    =  4;
ind_ent_par     =  5;
ind_img_size    =  6;
ind_img_t_name  =  7;
ind_act_option  =  8;
nb1_stored      =  8;

% MemBloc2 of stored values.
%---------------------------
n_wp1d2d_utils  = 'WP1D2D_Utils';
ind_tree_lin    =  1;
ind_tree_txt    =  2;
ind_type_txt    =  3;
ind_sel_nodes   =  4;
ind_gra_area    =  5;
ind_nb_colors   =  6;
ind_wav_len     =  7;
nb2_stored      =  7;

% MemBloc3 of stored values.
%---------------------------
n_structures    = 'Structures';
ind_tree_st     =  1;
ind_data_st     =  2;
nb3_stored      =  2;

% MemBloc4 of stored values.
%---------------------------
n_sav_struct    = 'Sav_Struct';
ind_sav_tree_st =  1;
ind_sav_data_st =  2;
nb4_stored      =  2;

% Tag property of objects.
%-------------------------
tag_m_files     = 'Files';
tag_m_savesyn   = 'Save_Syn';
tag_m_savedec   = 'Save_Dec';

tag_input_txt   = 'Input_Txt';
tag_input_data  = 'Input_Data';
tag_wav_fams    = 'Wav_Fams';
tag_wav_nums    = 'Wav_Nums';
tag_lev_data    = 'Lev_Data';
tag_pop_ent     = 'Pop_Ent';
tag_txt_entp    = 'Txt_EntP';
tag_uic_ent     = 'Uic_Ent';
tag_pus_anal    = 'Pus_Anal';
tag_pus_deno    = 'Pus_Deno';
tag_pus_comp    = 'Pus_Comp';
tag_pus_btree   = 'Pus_Btree';
tag_pus_blev    = 'Pus_Blev';
tag_inittree    = 'Pus_InitTree';
tag_wavtree     = 'Pus_WavTree';
tag_curtree     = 'Pop_CurTree';
tag_nodlab      = 'Pop_NodLab';
tag_nodact      = 'Pop_NodAct';
tag_nodsel      = 'Pus_NodSel';
tag_txt_full    = 'Txt_Full';
tag_pus_full    = str2mat(...
                        'Pus_Full.1','Pus_Full.2',...
                        'Pus_Full.3','Pus_Full.4'...
                        );
tag_cfs_map     = 'Pop_ColorMap';
tag_sli_nbc     = 'Sli_NBColors';
tag_edi_nbc     = 'Edi_NBColors';

tag_axe_t_lin   = 'Axe_TreeLines';
tag_axe_t_txt   = 'Axe_TreeTexts';
tag_axe_sig     = 'Axe_Sig';
tag_axe_pack    = 'Axe_Pack';
tag_axe_cfs     = 'Axe_Cfs';
tag_axe_col     = 'Axe_Col';
tag_sli_size    = 'Sli_Size';
tag_sli_pos     = 'Sli_Pos';

% Miscellaneous values.
%----------------------
Col_SigIni      = 'r';
axe_handles     = findobj(win_wptool,'type','axes');
uic_handles     = findobj(win_wptool,'type','uicontrol');
pop_handles     = findobj(uic_handles,'style','popupmenu');
pus_handles     = findobj(uic_handles,'style','pushbutton');
sli_handles     = findobj(uic_handles,'style','slider');

uim_handles     = findobj(win_wptool,'Type','uimenu');
txt_handles     = findobj(uic_handles,'Style','text');
m_files         = findobj(uim_handles,'flat','Tag',tag_m_files);
m_savesyn       = findobj(m_files,'Tag',tag_m_savesyn);
m_savedec       = findobj(m_files,'Tag',tag_m_savedec);

txt_input_txt   = findobj(txt_handles,'Tag',tag_input_txt);
txt_input_data  = findobj(txt_handles,'Tag',tag_input_data);
pop_wav_fams    = findobj(pop_handles,'Tag',tag_wav_fams);
pop_wav_nums    = findobj(pop_handles,'Tag',tag_wav_nums);
pop_lev_data    = findobj(pop_handles,'Tag',tag_lev_data);
pop_ent         = findobj(pop_handles,'Tag',tag_pop_ent);
txt_entp        = findobj(txt_handles,'Tag',tag_txt_entp);
uic_ent         = findobj(uic_handles,'Tag',tag_uic_ent);
pus_anal        = findobj(pus_handles,'Tag',tag_pus_anal);
pus_deno        = findobj(pus_handles,'Tag',tag_pus_deno);
pus_comp        = findobj(pus_handles,'Tag',tag_pus_comp);
pus_inittree    = findobj(pus_handles,'Tag',tag_inittree);
pus_wavtree     = findobj(pus_handles,'Tag',tag_wavtree);
pus_btree       = findobj(pus_handles,'Tag',tag_pus_btree);
pus_blev        = findobj(pus_handles,'Tag',tag_pus_blev);
pop_curtree     = findobj(pop_handles,'Tag',tag_curtree);
pop_nodlab      = findobj(pop_handles,'Tag',tag_nodlab);
pop_nodact      = findobj(pop_handles,'Tag',tag_nodact);
for k =1:size(tag_pus_full,1)
        pus_full(k) = (findobj(pus_handles,'Tag',tag_pus_full(k,:)))';
end
pus_nodsel      = findobj(pus_handles,'Tag',tag_nodsel);
pop_cfs_map     = findobj(pop_handles,'Tag',tag_cfs_map);
sli_nbc         = findobj(sli_handles,'Tag',tag_sli_nbc);
edi_nbc         = findobj(uic_handles,'Tag',tag_edi_nbc);
WP_Axe_TreeTxt  = findobj(axe_handles,'flat','Tag',tag_axe_t_txt);
WP_Axe_TreeLin  = findobj(axe_handles,'flat','Tag',tag_axe_t_lin);
WP_Axe_Sig      = findobj(axe_handles,'flat','Tag',tag_axe_sig);
WP_Axe_Pack     = findobj(axe_handles,'flat','Tag',tag_axe_pack);
WP_Axe_Cfs      = findobj(axe_handles,'flat','Tag',tag_axe_cfs);
WP_Axe_Col      = findobj(axe_handles,'flat','Tag',tag_axe_col);

%*************************%
%** OPTION = 'clean' -  **%
%*************************%
if strcmp(option,'clean')
        % Type of loading.
        %-----------------
        if      strcmp(in3,'load_img') , str_input_txt  = 'Image';
        elseif  strcmp(in3,'load_dec') , str_input_txt  = 'Decompos.';
        elseif  strcmp(in3,'demo')     , str_input_txt  = 'Test-signal';
        end
        if nargin<4 , in4 = ''; end

        str_btn = 'Analyze';
        cba_btn = ['wp2dmngr(''anal'',' int2str(win_wptool) ');'];
        set(pus_anal,'String',str_btn,'Callback',cba_btn);

        % Testing first use.
        %-------------------
        active_option = wmemtool('rmb',win_wptool,n_param_anal, ...
                                                        ind_act_option);
        if isempty(active_option) , first = 1; else, first = 0; end

        % End of Cleaning when first is true.
        %------------------------------------
        if first , set(txt_input_txt,'String',str_input_txt); return; end

        % Setting enable property of objects.
        %------------------------------------
        set([m_savesyn , m_savedec],'Enable','Off');
        set([   pop_wav_fams,   pop_wav_nums,   pop_lev_data,   ...
                pop_ent,        uic_ent,        pus_anal,       ...
                pus_deno,       pus_comp,                       ...
                pus_inittree,   pus_wavtree,                    ...
                pus_btree,      pus_blev,       pop_curtree,    ...
                pop_nodlab,     pop_nodact,     pus_nodsel,     ...
                pus_full,                                       ...             
                        ],...
                'Enable','off'...
                );

        % Cleaning DynVTool.
        %-------------------
        dynvtool('stop',win_wptool);

        % Cleaning Axes.
        %--------------
        wpfullsi('clean',win_wptool);
        axe_hld = [WP_Axe_TreeTxt,WP_Axe_TreeLin,WP_Axe_Cfs, WP_Axe_Pack];
        if ~strcmp(in4,'new_anal')
                axe_hld = [axe_hld , WP_Axe_Sig, WP_Axe_Col];
        	mngaxe('del_in',axe_hld);
	else      
        	titl    = get(WP_Axe_Cfs,'title');
        	strtitl = get(titl,'String');
            	mngaxe('del_in',axe_hld);       
         	axes(WP_Axe_Cfs)
        	title(strtitl,'Visible','on');
        end
        wmemtool('wmb',win_wptool,n_wp1d2d_utils,...
                        ind_tree_lin,[],ind_tree_txt,[],ind_sel_nodes,[]);

        % Cleaning GUI.
        %--------------
        str_input_data  = '';
        set(txt_input_txt,'String',str_input_txt);
        set(pop_nodlab,'Value',1,'Userdata',1);
        set(pop_nodact,'Value',1,'Userdata',1);
        if ~strcmp(in4,'new_anal')
                str_lev_data    = [int2str(1)];
                for k=2:max_lev_anal
                        str_lev_data = str2mat(str_lev_data,int2str(k));
                end;
                [str_wav_fams,str_wav_nums] = wavattrb('ini','dwt');
                set(txt_input_data,'String',str_input_data);
                set(pop_wav_fams,'String',str_wav_fams,'Value',1);
                set(pop_wav_nums,'String',str_wav_nums,'Value',1,'Visible','off');
                set(pop_lev_data,'String',str_lev_data,'Value',1);
                wpentmng('clean',[pop_ent txt_entp uic_ent]);
        end

%**********************************************%
%** OPTION = 'set_gui' -  Setting GUI values.**%
%**********************************************%
elseif strcmp(option,'set_gui')
        % in3 = calling option.
        % in4  optional (new_anal).
        %-----------------------------
        if      strcmp(in3,'load_img')  , optnum = 1;
        elseif  strcmp(in3,'demo')      , optnum = 2;
        elseif  strcmp(in3,'load_dec')  , optnum = 3;
        elseif  strcmp(in3,'anal')      , optnum = 4;
        end
        if nargin<4 , in4 = ''; end
        if      optnum==1
                [Img_Name,Img_Size] = ...
                        wmemtool('rmb',win_wptool,n_param_anal,...
                                        ind_img_name,ind_img_size);
                levm            = wmaxlev(Img_Size,'haar');
                levmax          = min(levm,max_lev_anal);
                str_lev_data    = get(pop_lev_data,'String');
                str_lev_data    = str_lev_data(1:levmax,:);
                if isempty(in4)
                        set(pop_lev_data,'String',str_lev_data,...
                                                'Value',min(levmax,2));
                else
                        set(pop_lev_data,'String',str_lev_data);
                end
                set(txt_input_data,'String',Img_Name);

        elseif  optnum==2 | optnum==3
                [Img_Name,Img_Size,Wave_Name,Level_Anal,...
                        Ent_Name,Ent_Par] =     ...
                        wmemtool('rmb',win_wptool,n_param_anal, ...
                                        ind_img_name,ind_img_size,      ...
                                        ind_wav_name,ind_lev_anal,      ...
                                        ind_ent_anal,ind_ent_par);
                levm            = wmaxlev(Img_Size,'haar');
                levmax          = min(levm,max_lev_anal);
                levs            = get(pop_lev_data,'String');
                set(txt_input_data,'String',Img_Name);
                wavattrb('set_wname',Wave_Name,pop_wav_fams,pop_wav_nums);
                set(pop_lev_data,'String',levs(1:levmax,:),'Value',Level_Anal);
                wpentmng('set_ent',[pop_ent txt_entp uic_ent],Ent_Name,Ent_Par);

        elseif  optnum==4
                Level_Anal = wmemtool('rmb',win_wptool,n_param_anal,...
                                                        ind_lev_anal);
                levels  = [int2str(1)];
                for k=2:Level_Anal , levels = str2mat(levels,int2str(k)); end
        end
        if find(optnum==[1 2 3])
                pos_g = wmemtool('rmb',win_wptool,n_wp1d2d_utils,ind_gra_area);
                [       pos_axe_pack,   pos_axe_tree,   pos_axe_cfs,    ...
                        pos_axe_sig,    pos_sli_size,   pos_sli_pos,    ...
                        pos_axe_col] =  wpposaxe(win_wptool,2,pos_g,Img_Size);
                WP_Slider_Size  = findobj(sli_handles,'Tag',tag_sli_size);
                WP_Slider_Pos   = findobj(sli_handles,'Tag',tag_sli_pos);
                set(WP_Axe_TreeTxt,'Position',pos_axe_tree);
                set(WP_Axe_TreeLin,'Position',pos_axe_tree);
                set(WP_Slider_Size,'Position',pos_sli_size);
                set(WP_Slider_Pos,'Position',pos_sli_pos);
                set(WP_Axe_Sig,'Position',pos_axe_sig);
                set(WP_Axe_Pack,'Position',pos_axe_pack);
                set(WP_Axe_Cfs,'Position',pos_axe_cfs);
        end
        
%*************************************************%
%** OPTION = 'enable' -  Setting enabled values.**%
%*************************************************%
elseif strcmp(option,'enable')
        % in3 = calling option.
        %----------------------
        if strcmp(in3,'load_img') | strcmp(in3,'demo') | strcmp(in3,'load_dec')
                set([   pop_wav_fams,   pop_wav_nums,   pop_lev_data,   ...
                        pop_ent,        uic_ent,        pus_anal        ...
                        ],      ...
                        'Enable','On'   ...
                        );
        end
        if      strcmp(in3,'demo') | strcmp(in3,'anal') | ...
                strcmp(in3,'synt') | strcmp(in3,'load_dec')
                set([   pus_deno,       pus_comp,       pus_btree,      ...
                        pus_blev,       pus_inittree,   pus_wavtree,    ...
                        pop_curtree,    pop_nodlab,     pop_nodact,     ...
                        pus_nodsel,     pus_full,                       ...
                        pop_cfs_map,    sli_nbc,        edi_nbc         ...
                        ],      ...
                        'Enable','on'...
                        );
                set([m_savesyn, m_savedec],'Enable','on');

        elseif  strcmp(in3,'comp') |strcmp(in3,'deno')
                set([m_files , pus_anal , pus_deno , pus_comp],'Enable','off');

        elseif  strcmp(in3,'return_comp') |strcmp(in3,'return_deno')
                set([m_files , pus_anal , pus_deno , pus_comp],'Enable','on');

        end

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('wp2dutil','Unknown Option','msg');
        error('*');
end
