function pack = wpcoef(structure,data,node)
%WPCOEF Wavelet packet coefficients.
%       X = WPCOEF(S,D,N) returns the coefficients associated
%       with the node N. S is the tree structure and D
%       the data structure (see MAKETREE).
%       If N doesn't exist, X = [];
%
%       X = WPCOEF(S,D) is equivalent to X = WPCOEF(S,D,0) 
%
%       See also MAKETREE, WPDEC, WPDEC2.

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:26:59 $

%       Uses WPJOIN.

% Check arguments.
if errargn('wpcoef',nargin,[2 3],nargout,[0 1]), error('*'); end
if nargin==2, node = 0; end

[nul,nul,pack] = wpjoin(structure,data,node);
