function [out1,out2] = wpentmng(option,in2,in3,in4)
%WPENTMNG Wavelet packets entropy manager.
%       out1 = wpentmng(option,in2,in3,in4)
%               out1 = 1 : 'shannon'
%               out1 = 2 : 'threshold'
%               out1 = 3 : 'norm' 
%               out1 = 4 : 'log energy'
%               out1 = 5 : 'sure'
%               out1 = 6 : 'user'

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:27:55 $

%       Uses WPENTMNG.

opt     = option(1);

%**************************************************%
%** OPTION = 'get_num' -  Getting Entropy Number.**%
%**************************************************%
if      opt=='g'
        % in2 = Ent_Name
        %---------------        
        in2 = deblankl(in2);
        if      strcmp(in2,'shannon')   ,       out1 = 1;
        elseif  strcmp(in2,'threshold') ,       out1 = 2;
        elseif  strcmp(in2,'norm')      ,       out1 = 3;
        elseif  strcmp(in2,'logenergy') ,       out1 = 4;
        elseif  strcmp(in2,'sure')      ,       out1 = 5;
        elseif  strcmp(in2,'user')      ,       out1 = 6;
        end

%*******************************************%
%** OPTION = 'set_ent' -  Setting Entropy.**%
%*******************************************%
elseif opt=='s'
        % in2 = [pop txt uic]
        % in3 = Ent_Name (optional)
        % in4 = Ent_Par (optional)
        %-------------------------
        pop_ent = in2(1);
        txt_ent = in2(2);
        uic_ent = in2(3);
        if      nargin==2
                v = get(pop_ent,'Value'); in4 = '';
        elseif  nargin>2
                v = wpentmng('get_num',in3);
                set(pop_ent,'Value',v);
                if nargin==3 , in4 = '';  end
        end

        if      (v==1) | (v==4)

        elseif  v==2
                set(txt_ent,'String','Threshold');
                set(uic_ent,'String',num2str(in4));
        elseif  v==3
                set(txt_ent,'String','Power');
                set(uic_ent,'String',num2str(in4));      
        elseif  v==5
                set(txt_ent,'String','Threshold');
                set(uic_ent,'String',num2str(in4));      
        elseif  v==6
                set(txt_ent,'String','Funct. Name');
                set(uic_ent,'String',in4);                      
        end
        if      (v==1) | (v==4)
                set([txt_ent,uic_ent],'Visible','off');
        else
                set([txt_ent,uic_ent],'Visible','on');
        end

%************************************************%
%** OPTION = 'txt_str' -  Getting Text for GUI.**%
%************************************************%
elseif opt=='t'
        % in2 = Ent_Name
        %---------------
        % out1 = Exact Ent_Name
        % out2 = String for text
        %------------------------        
        in2 = deblankl(in2);
        if      strcmp(in2,'shannon')
                out1 = in2;
                out2 = '';
        elseif  strcmp(in2,'threshold')
                out1 = in2;
                out2 = 'Threshold';
        elseif  strcmp(in2,'norm')
                out1 = in2;
                out2 = 'Power';
        elseif  strcmp(in2,'logenergy')
                out1 = 'log energy';
                out2 = '';
        elseif  strcmp(in2,'sure')
                out1 = in2;
                out2 = 'Threshold';
        elseif  strcmp(in2,'user')
                out1 = in2;
                out2 = 'Funct. Name';
        end

%*******************************************%
%** OPTION = 'clean' -  Cleaning Entropy.**%
%*******************************************%
elseif opt=='c'
        wpentmng('set_ent',in2,'shannon');

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('wpentmng','Unknown Option','msg');
        error('*');
end

