function ord = wpfrqord(node)
%WPFRQORD Frequential order for wavelet packets.
%       ord = wpfrqord(node)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:28:05 $

%       Uses ERRARGN, IND2DEPO, ERRARGT.

% Check arguments.
if errargn('wpfrqord',nargin,[1],nargout,[0:1]), error('*'); end

order   = 2;
[depths,pos_nat]= ind2depo(order,node);
nbtn    = length(pos_nat);
out2    = zeros(size(pos_nat));
dmax    = max(depths);

tmp     = zeros(1,2^dmax);
beg = 1;
for k = 1:nbtn
        d       = depths(k);
        len     = 2^(dmax-d);
        tmp(beg:beg+len-1) = d*ones(1,len);
        beg     = beg+len;
end
depths  = tmp;
pos     = 0;
for d = 1:dmax
        rem2    = rem(pos,order);
        tmp     = order*pos;
        pos     = [tmp+rem2;tmp+1-rem2];
        pos     = pos(:)';
end
[nul,pos] = sort(pos);
depths  = depths(pos);
pos     = pos+2^dmax-2;
for d=dmax-1:-1:1
        tmp     = find(depths==d);
        if ~isempty(tmp)
                dd      = dmax-d;
                pow     = 2^dd;
                beg     = tmp(1:pow:length(tmp));
                tmp(1:pow:length(tmp)) = [];
                pos(beg) = floor((pos(beg)+1-pow)/pow);
                ttt     = NaN;
                pos(tmp)= ttt(ones(size(tmp)));
        end
end
pos = pos(~isnan(pos));
[nul,tmp] = sort(node);
[nul,pos] = sort(pos);
[nul,pos] = sort(pos);
ord       = tmp(pos);
