function wpnodlab(win_wptool)
%WPNODLAB Set the nodes label.
%       WPNODLAB(WIN)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:28:45 $

%       Uses WDATAMGR, WTREEMGR.

%--------------------------------
% v_lab = 1 : option = 'depo'
% v_lab = 2 : option = 'indexs'
% v_lab = 3 : option = 'ent'
% v_lab = 4 : option = 'ento'
% v_lab = 5 : option = 'size'
% v_lab = 6 : option = 'none'
% v_lab = 7 : option = 'type'
%--------------------------------

% MemBloc3 of stored values.
%---------------------------
n_structures    = 'Structures';
ind_tree_st     =  1;
ind_data_st     =  2;
nb3_stored      =  2;

% MemBloc2 of stored values.
%---------------------------
n_wp1d2d_utils  = 'WP1D2D_Utils';
ind_tree_lin    =  1;
ind_tree_txt    =  2;
ind_type_txt    =  3;
ind_sel_nodes   =  4;
ind_gra_area    =  5;
ind_nb_colors   =  6;
ind_wav_len     =  7;
nb2_stored      =  7;

% Tag property of objects.
%-------------------------
tag_axe_t_lin   = 'Axe_TreeLines';
tag_axe_t_txt   = 'Axe_TreeTexts';
tag_txt_in_t    = 'Txt_In_tree';
tag_lin_in_t    = 'Lin_In_tree';
tag_nodlab      = 'Pop_NodLab';
tag_nodact      = 'Pop_NodAct';

pop_handles     = findobj(win_wptool,'style','popupmenu');
pop_nodlab      = findobj(pop_handles,'Tag',tag_nodlab);
pop_nodact      = findobj(pop_handles,'Tag',tag_nodact);

v_lab           = get(pop_nodlab,'Value');
v_act           = get(pop_nodact,'Value');
if v_act==7
        axe_handles     = findobj(win_wptool,'type','axes');
        WP_Axe_TreeTxt  = findobj(axe_handles,'flat','Tag',tag_axe_t_txt);
        txt_in_tree     = findobj(WP_Axe_TreeTxt,'tag',tag_txt_in_t);
        txt_off         = findobj(txt_in_tree,'Visible','off');
end

tree    = wmemtool('rmb',win_wptool,n_structures,ind_tree_st);
if find(v_lab==[3 4 5])
        data    = wmemtool('rmb',win_wptool,n_structures,ind_data_st);
end

depth           = wtreemgr('depth',tree);
order           = wtreemgr('order',tree);
Tree_Texts      = wmemtool('rmb',win_wptool,n_wp1d2d_utils,ind_tree_txt);

if      v_lab==1
        set(Tree_Texts(1),'String','(0,0)')
        n = 2;
        for d=1:depth
                nd_str = int2str(d);
                for b=0:order:order^d-1
                        if Tree_Texts(n) ~= 0
                                for i=0:order-1
                                        set(Tree_Texts(n+i),'String',...
                                        ['(' nd_str ',' int2str(b+i) ')']);
                                end
                        end
                        n = n+order;
                end
        end
        set(Tree_Texts,'Visible','on');
        Tree_Type_TxtV = 'p';

elseif  v_lab==2
        set(Tree_Texts(1),'String','(0)')
        n = 2;
        for d=1:depth
                for b=0:order:order^d-1
                        if Tree_Texts(n) ~= 0
                                for i=0:order-1
                                        set(Tree_Texts(n+i),'String',...
                                        ['(' int2str(depo2ind(order,[d b+i])) ')']);
                                end
                        end
                        n = n+order;
                end
        end
        set(Tree_Texts,'Visible','on');
        Tree_Type_TxtV = 'i';

elseif  v_lab==3
        entropies = wdatamgr('read_ent',data);
        set(Tree_Texts(1),'String',num2str(entropies(1)))
        n = 2;
        for d=1:depth
                for b=0:order:order^d-1
                        if Tree_Texts(n) ~= 0
                                for i=0:order-1
                                        ni = n+i;
                                        set(Tree_Texts(ni),'String',...
                                                num2str(entropies(ni)));
                                end
                        end
                        n = n+order;
                end
        end
        set(Tree_Texts,'Visible','on');
        Tree_Type_TxtV = 'e';

elseif  v_lab==4
        entropies_opt = wdatamgr('read_ento',data);
        set(Tree_Texts(1),'String',num2str(entropies_opt(1)))
        n = 2;
        for d=1:depth
                for b=0:order:order^d-1
                        if Tree_Texts(n) ~= 0
                                for i=0:order-1
                                        ni = n+i;
                                        set(Tree_Texts(ni),'String',...
                                                num2str(entropies_opt(ni)))
                                end
                        end
                        n = n+order;
                end
        end
        set(Tree_Texts,'Visible','on');
        Tree_Type_TxtV = 'eo';

elseif  v_lab==5
        sizes = wdatamgr('rsizes',data);
        [r,c] = size(sizes);
        if r==1
                txt = int2str(sizes(1));
        else
                txt = ['(' int2str(sizes(1,1)) ',' int2str(sizes(2,1)) ')'];
        end
        set(Tree_Texts(1),'String',txt);
        n = 2;
        for d=1:depth
                dp1 = d+1;
                if r==1
                        txt = int2str(sizes(dp1));
                else
                        txt = ['(' int2str(sizes(1,dp1)) ',' int2str(sizes(2,dp1)) ')'];
                end
                for b=0:order:order^d-1
                        if Tree_Texts(n) ~= 0
                                for i=0:order-1
                                        ni = n+i;
                                        set(Tree_Texts(ni),'String',txt)
                                end
                        end
                        n = n+order;
                end
        end
        set(Tree_Texts,'Visible','on');
        Tree_Type_TxtV = 's';


elseif  v_lab==6
        set(Tree_Texts,'Visible','off');

elseif  v_lab==7
        set(Tree_Texts(1),'String','(a)')
        n = 2;
        if order==2
                for d=1:depth
                        for b=0:order:order^d-1
                                if Tree_Texts(n) ~= 0
                                        set(Tree_Texts(n),'String','(a)');
                                        set(Tree_Texts(n+1),'String','(d)');
                                end
                                n = n+order;
                        end
                end
        else
                for d=1:depth
                        for b=0:order:order^d-1
                                if Tree_Texts(n) ~= 0
                                        set(Tree_Texts(n),'String','(a)');
                                        set(Tree_Texts(n+1),'String','(h)');
                                        set(Tree_Texts(n+2),'String','(v)');
                                        set(Tree_Texts(n+3),'String','(d)');
                                end
                                n = n+order;
                        end
                end
        end
        set(Tree_Texts,'Visible','on');
        Tree_Type_TxtV = 't';
end
wmemtool('wmb',win_wptool,n_wp1d2d_utils,ind_type_txt,Tree_Type_TxtV);

if v_act==7
        set(txt_off,'Visible','off');
end

