function x = wprec(tree,data)
%WPREC Wavelet packet reconstruction 1-D.
%       X = WPREC(T,D) returns the reconstructed vector
%       corresponding to a wavelet packet decomposition
%       structure [T,D] (see MAKETREE).
%
%       T is the tree structure and D the data structure.
%
%       See also MAKETREE, WPDEC, WPDEC2, WPJOIN, WPREC, WPREC2,
%                WPSPLT.

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:29:25 $

%       Uses ERRARGN, WPJOIN.

% Check arguments.
if errargn('wprec',nargin,[2],nargout,[0 1]), error('*'); end

[tree,data,x] = wpjoin(tree,data);
