function x = wprec2(tree,data)
%WPREC2 Wavelet packet reconstruction 2-D.
%       X = WPREC2(T,D) returns the reconstructed matrix
%       X corresponding to a wavelet packet decomposition
%       structure [T,D] (see MAKETREE).
%
%       T is the tree structure and D the data structure. 
%
%       See also MAKETREE, WPDEC, WPDEC2, WPJOIN, WPREC, WPREC2,
%                WPSPLT.

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:29:31 $

%       Uses ERRARGN, WPJOIN.

% Check arguments.
if errargn('wprec2',nargin,[2],nargout,[0 1]), error('*'); end

[tree,data,x] = wpjoin(tree,data);
