function [w,h] = wpropimg(is,wmax,hmax,in4)
%WPROPIMG Give image proportions.
%       [w,h] = wpropimg(is,wmax,hmax,in4)
%
%       is      = image size
%       wmax    = maximum width possible
%       hmax    = maximum height possible
%
%       in4 = 'pixels' or in4 = 'normalized'
%       wpropimg(is,wmax,hmax) is equivalent to 
%       wpropimg(is,wmax,hmax,'normalized')
%
%       w       = image width
%       h       = image height

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:29:37 $

global  Terminal_Prop

if nargin==3 , in4 = 'normalized'; end
in4 = deblankl(in4);
if strcmp(in4,'pixels')
        td = [1 1];             % Units = 'pixels'
else
        td = Terminal_Prop;     % Units = 'normalized'
end
a = (td(2)*hmax*is(1))/(td(1)*wmax*is(2));
w = wmax*min(1,a);
h = hmax*min(1,1/a);
