function out1 = wpssnode(option,win_wptool,in3,in4,in5)
%WPSSNODE Plot wavelet packets synthesized node.
%       out1 = wpssnode(option,win_wptool,in3,in4,in5)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:29:48 $

% Image Coding Value.
%-------------------
codemat_v       = wimgcode('get');

% MemBloc2 of stored values.
%---------------------------
n_wp1d2d_utils  = 'WP1D2D_Utils';
ind_tree_lin    =  1;
ind_tree_txt    =  2;
ind_type_txt    =  3;
ind_sel_nodes   =  4;
ind_gra_area    =  5;
ind_nb_colors   =  6;
ind_wav_len     =  7;
nb2_stored      =  7;

% Tag property of objects.
%-------------------------
tag_nodact      = 'Pop_NodAct';
tag_ss_node     = 'SS_Node';
tag_ss_obj      = 'SS_Obj';
tag_axe_t_txt   = 'Axe_TreeTexts';
tag_axe_t_lin   = 'Axe_TreeLines';
tag_axe_pack    = 'Axe_Pack';

axe_handles     = findobj(win_wptool,'type','axes');
WP_Axe_TreeTxt  = findobj(axe_handles,'flat','Tag',tag_axe_t_txt);
WP_Axe_Pack     = findobj(axe_handles,'flat','Tag',tag_axe_pack);
SS_text         = findobj(WP_Axe_TreeTxt,'Tag',tag_ss_node);
SS_Obj          = findobj(WP_Axe_Pack,'Tag',tag_ss_obj);

% Miscellaneous Values.
%-------------------------
[txt_color,pack_color,ftn_size] = ...
        wpmisval('ss_node',get(WP_Axe_TreeTxt,'Xcolor'));

%*********************%
%** OPTION = 'plot' **%
%*********************%
if      strcmp(option,'plot')
        % in3 = type ('cs' or 'ds')
        % in4 = dim
        % in5 = handle (line or image)
        %------------------------------
        axes(WP_Axe_TreeTxt)
        if ~isempty(SS_Obj)
                delete(SS_Obj);
                hdl = get(WP_Axe_Pack,'title');
                col = get(WP_Axe_Pack,'Xcolor');
                set(hdl,'String','Node Action Result ','Color',col);
        end
        str_txt = ['(' in3 ')'];
        if isempty(SS_text)
                btndown_fcn  = ['wpssnode(''cba'',' int2str(win_wptool) ...
                                ',' int2str(in4) ');'];
                SS_text = text(...
                                'Clipping','on',                ...
                                'String', str_txt,              ...
                                'Position',[0.25 0.1 0],        ...
                                'Color',txt_color,              ...
                                'HorizontalAlignment','center', ...
                                'VerticalAlignment','middle',   ...
                                'FontSize',ftn_size,            ...
                                'FontWeight','bold',            ...
                                'ButtonDownFcn',btndown_fcn,    ...
                                'Tag',tag_ss_node               ...
                                );
        else
                set(SS_text,'String', str_txt);
        end
        if      in4==1
                set(SS_text,'UserData',get(in5,'Ydata'));
        elseif  in4==2
                set(SS_text,'UserData',get(in5,'Cdata'));
        end

%********************%
%** OPTION = 'cba' **%
%********************%
elseif  strcmp(option,'cba')
        pop_act = findobj(win_wptool,'Tag',tag_nodact);
        v       = get(pop_act,'Value');
        if      v==1
                wpssnode('vis',win_wptool,in3);
        elseif  v==2

        elseif  v==3

        elseif  v==4

        elseif  v==5

        elseif  v==6
                wpssnode('stat',win_wptool,in3);
        elseif  v==7

        end

%********************%
%** OPTION = 'vis' **%
%********************%
elseif  strcmp(option,'vis')

        % Begin waiting.
        %--------------
        wwaiting('msg',win_wptool,'Wait ... computing');

        dim     = in3;
        ssig_rec = get(SS_text,'UserData');
        siz     = size(ssig_rec);
        type_ss = get(SS_text,'String');
        if findstr('cs',type_ss)
                str_txt = ['Compressed ']; 
        else
                str_txt = ['De-noised ']; 
        end
        delete(get(WP_Axe_Pack,'Children'));
        dynvtool('new_his',win_wptool)
        axes(WP_Axe_Pack)
        if dim==1
                str_txt = [str_txt 'Signal']; 
                xmax = max(siz);
                if xmax==1 , xmax = 1+0.01; end
                ymin = min(ssig_rec);   ymax = max(ssig_rec);
                if ymin==ymax , ymin = ymin-0.0001; ymax = ymax+0.0001; end
                plot(ssig_rec,'Color',pack_color,'tag',tag_ss_obj);
                set(WP_Axe_Pack,'XLim',[1 xmax],'Ylim',[ymin ymax],'Tag',tag_axe_pack);
                title(str_txt,'FontSize',ftn_size,'Color',pack_color);
        else
                str_txt = [str_txt 'Image']; 
                NB_Col = wmemtool('rmb',win_wptool,...
                                n_wp1d2d_utils,ind_nb_colors);
                image(  'CData',wimgcode('cod',0,ssig_rec,NB_Col,codemat_v),...
                        'tag',tag_ss_obj);
                title(str_txt,'FontSize',ftn_size,'Color',pack_color);
                set(WP_Axe_Pack,'Tag',tag_axe_pack);
        end
        dynvtool('put',win_wptool)
        axes(WP_Axe_TreeTxt);

        % End waiting.
        %-------------
        wwaiting('off',win_wptool);

%*********************%
%** OPTION = 'stat' **%
%*********************%
elseif  strcmp(option,'stat')
        dim     = in3;
        type_ss = get(SS_text,'String');
        if findstr('cs',type_ss)
                node = -1;
        else
                node = -2;
        end
        if      dim==1
                feval('wp1dstat','create',win_wptool,node);
        else
                feval('wp2dstat','create',win_wptool,node);
        end

%***********************%
%** OPTION = 'r_synt' **%
%***********************%
elseif  strcmp(option,'r_synt')
        out1 = SS_text;

%********************%
%** OPTION = 'del' **%
%********************%
elseif  strcmp(option,'del')
        delete(SS_text);
        if ~isempty(SS_Obj)
                delete(SS_Obj);
                hdl = get(WP_Axe_Pack,'title');
                col = get(WP_Axe_Pack,'Xcolor');
                set(hdl,'String','Node Action Result ','Color',col);
        end
end
