function out1 = wptreeop(option,win_wptool,in3,in4)
%WPTREEOP Operations on wavelet packets tree.
%       out1 = wptreeop(option,win_wptool,in3,in4)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:30:00 $

%       Uses WPTREEOP.

%       Callbacks WPTREEOP.

global Mat_Version

% Image Coding Value.
%-------------------
codemat_v       = wimgcode('get');              % WP-2D only

% MemBloc2 of stored values.
%---------------------------
n_wp1d2d_utils  = 'WP1D2D_Utils';
ind_tree_lin    =  1;
ind_tree_txt    =  2;
ind_type_txt    =  3;
ind_sel_nodes   =  4;
ind_gra_area    =  5;
ind_nb_colors   =  6;
ind_wav_len     =  7;
nb2_stored      =  7;

% MemBloc3 of stored values.
%---------------------------
n_structures    = 'Structures';
ind_tree_st     =  1;
ind_data_st     =  2;
nb3_stored      =  2;

% MemBloc4 of stored values.
%---------------------------
n_sav_struct    = 'Sav_Struct';
ind_sav_tree_st =  1;
ind_sav_data_st =  2;
nb4_stored      =  2;

% Tag property of objects.
%-------------------------
tag_pop_colm    = 'Txt_PopM';           % WP-1D only
tag_axe_t_lin   = 'Axe_TreeLines';
tag_axe_t_txt   = 'Axe_TreeTexts';
tag_txt_in_t    = 'Txt_In_tree';
tag_lin_in_t    = 'Lin_In_tree';

tag_axe_sig     = 'Axe_Sig';
tag_axe_pack    = 'Axe_Pack';
tag_axe_cfs     = 'Axe_Cfs';
tag_sli_nbc     = 'Sli_NBColors';
tag_curtree     = 'Pop_CurTree';
tag_nodlab      = 'Pop_NodLab';
tag_nodact      = 'Pop_NodAct';

tag_img_cfs     = 'Img_WPCfs';
tag_img_nod     = 'Img_NodCfs';

pop_handles     = findobj(win_wptool,'style','popupmenu');
axe_handles     = findobj(win_wptool,'type','axes');
WP_Axe_TreeTxt  = findobj(axe_handles,'flat','Tag',tag_axe_t_txt);
WP_Axe_TreeLin  = findobj(axe_handles,'flat','Tag',tag_axe_t_lin);
WP_Axe_Sig      = findobj(axe_handles,'flat','Tag',tag_axe_sig);
WP_Axe_Pack     = findobj(axe_handles,'flat','Tag',tag_axe_pack);
WP_Axe_Cfs      = findobj(axe_handles,'flat','Tag',tag_axe_cfs);

% Miscellaneous Values.
%-------------------------
[txt_color,sel_color,pack_color,ftn_size] = ...
                wpmisval('tree_op',get(WP_Axe_TreeLin,'Xcolor'));

if      strcmp(option,'nodact')
        pop_nodact = findobj(pop_handles,'Tag',tag_nodact);
        v       = get(pop_nodact,'Value');
        old_v   = get(pop_nodact,'Userdata');
        if isempty(old_v) , old_v = 0; end
%       if v==old_v , return; end
        set(pop_nodact,'Userdata',v);
        if      (find(v==[1:6]) & old_v==7)  , ok = 1;
        elseif  (find(old_v==[1:6]) & v==7)  , ok = 1;
        elseif  old_v==7 & v==7
                if nargin==3
                   if strcmp(in3,'reset')
                        set(pop_nodact,'Value',1);
                        set(pop_nodact,'Userdata',1);
                        v  = 1;                ok = 1;
                   else
                       return;
                   end
                else
                   return;
                end
        else                                  , ok = 0;
        end
        if ok 
                WP_Tree = wmemtool('rmb',win_wptool,n_structures,ind_tree_st);
                order = wtreemgr('order',WP_Tree);
                img_handles = findobj(WP_Axe_Cfs,'tag',tag_img_cfs);
        end

        Tree_Texts = wmemtool('rmb',win_wptool,n_wp1d2d_utils,ind_tree_txt);
        str_win = int2str(win_wptool);
        if      v==1
                btndown_fcn = ['wptreeop(''vis'',' str_win ');'];
        elseif  v==2
                wptreeop('select_off',win_wptool);
                btndown_fcn = ['wptreeop(''split_merge'',' str_win ');'];
        elseif  v==3
                wptreeop('select_off',win_wptool);
                btndown_fcn = ['wptreeop(''rec'',' str_win ');'];
        elseif  v==4
                btndown_fcn = ['wptreeop(''select_on'',' str_win ');'];
        elseif  v==5
                wptreeop('select_off',win_wptool);
                set(pop_nodact,'Value',1);
                btndown_fcn = ['wptreeop(''vis'',' str_win ');'];
        elseif  v==6
                btndown_fcn = ['wptreeop(''stat'',' str_win ');'];
        elseif  v==7
                tnodes = wtreemgr('tnodes',WP_Tree);
                nodes = [];
                for k = 1:length(Tree_Texts)
                        us = get(Tree_Texts(k),'Userdata');
                        if find(tnodes==us)

                        else
                                nodes = [nodes k];
                        end
                end
                set(Tree_Texts(nodes),'Visible','off');
                btndown_fcn = ['wptreeop(''colcfs'',' str_win ');'];
                set(img_handles,'Visible','off');
        end
        if find(v==[1:6]) & old_v==7
                if order==2
                        delete(findobj(WP_Axe_Cfs,'tag',tag_img_nod));
                        set(WP_Axe_Cfs,'Nextplot','replace');
                end
                set(Tree_Texts,'Visible','on');
                set(img_handles,'Visible','on');
                drawnow
                if order==2
                        pop_colm = findobj(win_wptool,'style','popupmenu',...
                                        'tag',tag_pop_colm);
                        col_mode = get(pop_colm,'Value');
                        if      find(col_mode==[1 2 3 4])
                                strlab = ['frequency ordered coefficients'];
                        else
                                strlab = ...
                        ['(down -> up) for Cfs <==> (left -> right) in Tree'];
                        end
                        wsetxlab(WP_Axe_Cfs,strlab,-15);
                else
                        wsetxlab(WP_Axe_Cfs,'',-15);
                end
        elseif find(old_v==[1:6]) & v==7
                wsetxlab(WP_Axe_Cfs,'',-15);
        end
        set(Tree_Texts,'ButtonDownFcn',btndown_fcn);
        return

elseif  strcmp(option,'select_off')
        Selected_Nodes = wmemtool('rmb',win_wptool,n_wp1d2d_utils,ind_sel_nodes);
        if ~isempty(Selected_Nodes)
                set(Selected_Nodes(2,:),'Color',txt_color);
                wmemtool('wmb',win_wptool,n_wp1d2d_utils,ind_sel_nodes,[]);
        end
        return

elseif  strcmp(option,'select_on')
        obj = get(win_wptool,'CurrentObject');
        if isempty(obj)
                return
        elseif get(obj,'Parent') ~= WP_Axe_TreeTxt
                return
        end
        node = get(obj,'UserData');
        Selected_Nodes = wmemtool('rmb',win_wptool,n_wp1d2d_utils,ind_sel_nodes);
        col = get(obj,'Color');
        if col==txt_color
                Selected_Nodes = [Selected_Nodes [node;obj]];
                set(obj,'Color',sel_color);
        else
                k = find(Selected_Nodes(2,:)==obj);
                Selected_Nodes(:,k) = [];
                set(obj,'Color',txt_color);
        end
        wmemtool('wmb',win_wptool,n_wp1d2d_utils,ind_sel_nodes,Selected_Nodes);
        return;
end

if      strcmp(option,'vis') | strcmp(option,'rec') | ...
        strcmp(option,'split_merge') | strcmp(option,'stat') | ...
        strcmp(option,'colcfs')
        axes(WP_Axe_TreeTxt);
        obj = get(win_wptool,'CurrentObject');
        if isempty(obj)
                return
        elseif get(obj,'Parent') ~= WP_Axe_TreeTxt
                return
        end
        node = get(obj,'UserData');
end

% Begin waiting.
%--------------
wwaiting('msg',win_wptool,'Wait ... computing');

[WP_Tree,WP_Data] = wmemtool('rmb',win_wptool,n_structures,...
                                        ind_tree_st,ind_data_st);
if ~isempty(WP_Tree) , order = wtreemgr('order',WP_Tree); end

if      strcmp(option,'vis') | strcmp(option,'rec')
        [d,p]   = ind2depo(order,node);
        sizes   = wdatamgr('rsizes',WP_Data);
        size0   = sizes(:,1)';

        if option(1)=='v'
                pack    = wpcoef(WP_Tree,WP_Data,node);
                flg_code = 1;
                trunc_p = [d size0];
                str_pck = [];
        else
                pack = wprcoef(WP_Tree,WP_Data,node);
                if p==0 , flg_code = 0; else , flg_code = 1; end
                trunc_p = [0 size0];
                str_pck = ['Reconstructed '];
        end
        str_pck = [str_pck 'Packet : (' int2str(d) ',' int2str(p) ') or (' int2str(node) ')'];
        delete(get(WP_Axe_Pack,'Children'));
        dynvtool('new_his',win_wptool)
        axes(WP_Axe_Pack)
        if size(pack,1) == 1
                xmax = size(pack,2);
                if xmax==1, xmax = 1+0.01; end
                ymin = min(pack);       ymax = max(pack);
                if ymin==ymax , ymin = ymin-0.0001; ymax = ymax+0.0001; end
                plot(pack,'Color',pack_color);
                set(WP_Axe_Pack,'XLim',[1 xmax],'Ylim',[ymin ymax],'Tag',tag_axe_pack);
                title(str_pck,'FontSize',ftn_size,'Color',pack_color);
        else
                NB_Colors2D = wmemtool('rmb',win_wptool,n_wp1d2d_utils,ind_nb_colors);
                image('CData',wimgcode('cod',flg_code,pack,NB_Colors2D,codemat_v,trunc_p));
                title(str_pck,'FontSize',ftn_size,'Color',get(WP_Axe_TreeLin,'Xcolor'));
                set(WP_Axe_Pack,'Tag',tag_axe_pack);

                %%%%%%%%%%%%  version 5 %%%%%%%%%%%%%
                if (Mat_Version>=5)
                        set(WP_Axe_Pack,...
                                'Ydir','Reverse',       ...
                                'XLim',[1 size(pack,2)],...
                                'Ylim',[1 size(pack,1)] ...
                                );
                end
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        end
        dynvtool('put',win_wptool)
        axes(WP_Axe_TreeTxt);

elseif  strcmp(option,'stat')
        if      order==2
                out1 = feval('wp1dstat','create',win_wptool,node);
        elseif  order==4
                out1 = feval('wp2dstat','create',win_wptool,node);
        else
                return
        end

elseif  strcmp(option,'colcfs')
        img_handles = findobj(WP_Axe_Cfs,'tag',tag_img_cfs);
        if      order==2
                us = get(img_handles,'Userdata');
                tn = depo2ind(order,us(:,1:2));
                for k = 1:size(tn,1)
                        if node==tn(k) 
                                num_img = k;break;
                        end
                end
                set(img_handles,'Visible','off');
                if num_img~=0
                        xd = get(img_handles,'xdata');
                        yd = get(img_handles,'ydata');
                        nd = get(img_handles,'Cdata');
                        NBrows = size(nd,1);
                        y1 = us(num_img,3);
                        y2 = us(num_img,4); 
                        r1 = ceil(y1*NBrows)+1;
                        r2 = floor(y2*NBrows);
                        nd = nd(r1:r2,:);
                        if r1==r2
                                ydata(1) = (y2+y1)/2;
                                ydata(2) = y2;
                        else
                                alfa = 1/(2*(r2-r1+1));
                                ydata = [(1-alfa)*y1+alfa*y2 (1-alfa)*y2+alfa*y1];
                        end
                        set(WP_Axe_Cfs,'Nextplot','add');
                        axes(WP_Axe_Cfs);
                        delete(findobj(WP_Axe_Cfs,'tag',tag_img_nod));
                        image(...
                                'Xdata',xd,'Ydata',ydata,       ...
                                'Cdata',nd,'tag',tag_img_nod    ...
                                );
                        strlab = ...
                        ['Packet : (' int2str(us(num_img,1)) ',' ...
                                int2str(us(num_img,2)) ') or (' int2str(node) ')'];
                        wsetxlab(WP_Axe_Cfs,strlab,-15);
                        set(WP_Axe_Cfs,'Tag',tag_axe_cfs)
                end

        elseif  order==4
                num_img = 0;
                for k=1:length(img_handles)
                        us = get(img_handles(k),'Userdata');
                        us = us(1:2);
                        if node==depo2ind(order,us)
                                num_img = k; break;
                        end
                end
                img_on = findobj(img_handles,'Visible','on');
                set(img_on,'Visible','off');
                if num_img~=0
                        set(img_handles(num_img),'Visible','on');
                        strlab = ...
                        ['Packet : (' int2str(us(1)) ',' ...
                                int2str(us(2)) ') or (' int2str(node) ')'];
                        wsetxlab(WP_Axe_Cfs,strlab,-15);
                end
        end

elseif  strcmp(option,'split_merge')
        %
        % Decomposition/recomposition
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        pack_exist = wtreemgr('istnode',WP_Tree,node);
        contenu = [];
        if pack_exist == 0
                [WP_Tree,WP_Data] = wpjoin(WP_Tree,WP_Data,node);
        else
                [WP_Tree,WP_Data] = wpsplt(WP_Tree,WP_Data,node);
                entropies     = wdatamgr('read_ent',WP_Data);
                entropies_opt = wdatamgr('read_ento',WP_Data);
                sizes = wdatamgr('rsizes',WP_Data);
                [r,c] = size(sizes);
                Tree_Type_TxtV = wmemtool('rmb',win_wptool,n_wp1d2d_utils,...
                                                ind_type_txt);
                for desc=node*order+2:(node+1)*order+1
                        if strcmp(Tree_Type_TxtV,'e')
                                chaine = num2str(entropies(desc));
                        elseif strcmp(Tree_Type_TxtV,'eo')
                                chaine = num2str(entropies_opt(desc));
                        elseif strcmp(Tree_Type_TxtV,'i')
                                chaine = ['(' int2str(desc-1) ')'];
                        elseif strcmp(Tree_Type_TxtV,'p')
                                [d,b] = ind2depo(order,desc-1);
                                chaine = ['(' int2str(d) ',' int2str(b) ')'];
                        elseif strcmp(Tree_Type_TxtV,'s')
                                [d,b] = ind2depo(order,desc-1);
                                dp1 = d+1;
                                if order==2
                                        chaine = int2str(sizes(dp1));
                                else
                                        chaine = ['(' int2str(sizes(1,dp1)) ',' ...
                                                        int2str(sizes(2,dp1)) ')'];
                                end
                        elseif strcmp(Tree_Type_TxtV,'t')
                                [d,b] = ind2depo(order,desc-1);
                                b = rem(b,order);
                                if order==2
                                        if b==0 , chaine = '(a)';  else , chaine = '(d)'; end
                                else
                                        if      b==0 , chaine = '(a)';  
                                        elseif  b==1 , chaine = '(h)';
                                        elseif  b==2 , chaine = '(v)';
                                        elseif  b==3 , chaine = '(d)';
                                        end
                                end
                        end
                        contenu = [contenu size(chaine,2) abs(chaine)];
                end
        end
        wmemtool('wmb',win_wptool,n_structures, ...
                                ind_tree_st,WP_Tree,    ...
                                ind_data_st,WP_Data     ...
                        );
        depth = treedpth(WP_Tree);
        str_depth = '0';
        for k=1:depth , str_depth = str2mat(str_depth,int2str(k)); end
        pop_cur = findobj(pop_handles,'Tag',tag_curtree);
        set(pop_cur,'String',str_depth,'Value',depth+1);

        % Drawing New Tree.
        %------------------
        axes(WP_Axe_TreeTxt);
        title('Decomposition Tree');
        wpplottr('split_merge',win_wptool,WP_Tree,node,contenu);
        wptreeop('cfs',win_wptool);

elseif  strcmp(option,'slide_size')
        % in3 = slider_size.
        % in4 = slider_pos.
        %--------------------
        v = get(in3,'Value');
        u = get(in3,'UserData');
        set(in3,'UserData',v);
        demi_ecart = 1/(2*v);
        %
        % Mise a jour des bornes du taquet de positionnement
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        if v > 1
                anc_borne = get(in4,'Max');
                anc_val = get(in4,'Value');
                nouv_borne = 0.5-demi_ecart;
                if anc_borne ~= 0
                        nouv_val = -nouv_borne + ...
                                (anc_val+anc_borne)*(nouv_borne/anc_borne);
                else
                        nouv_val = 0;
                end
                set(in4,'Min',-nouv_borne,'Max',nouv_borne,...
                        'Value', nouv_val,'Visible','on');
        else
                nouv_val = 0;
                set(in4,'Min',0,'Max',0,'Value',0,'Visible','off');
        end
        set([WP_Axe_TreeLin WP_Axe_TreeTxt],...
                'XLim',[nouv_val-demi_ecart nouv_val+demi_ecart]);

elseif  strcmp(option,'slide_pos')
        % in3 = slider_pos.
        %------------------
        x0 = get(in3,'Value');
        u = get(WP_Axe_TreeLin,'XLim');
        demi_ecart = (u(2)-u(1))/2;
        set([WP_Axe_TreeLin WP_Axe_TreeTxt],...
                'XLim',[x0-demi_ecart x0+demi_ecart]);

elseif  strcmp(option,'best')       | strcmp(option,'blvl')    |  ...
        strcmp(option,'wp2wtree')   | strcmp(option,'restore') |  ...
        strcmp(option,'input_tree') | strcmp(option,'cuttree')
        pop_nodlab = findobj(pop_handles,'Tag',tag_nodlab);
        wptreeop('select_off',win_wptool);
        if      strcmp(option,'best')
                [WP_Tree,WP_Data] = ...
                        besttree(WP_Tree,WP_Data);
                        Axe_TreeTitle = 'Best Tree';
        elseif  strcmp(option,'blvl')
                [WP_Tree,WP_Data] = ...
                        bestlevt(WP_Tree,WP_Data);
                        Axe_TreeTitle = 'Best Level Tree';
        elseif strcmp(option,'wp2wtree')
                [WP_Tree,WP_Data] = ...
                        wp2wtree(WP_Tree,WP_Data);
                        Axe_TreeTitle = 'Wavelet Tree';
        elseif strcmp(option,'restore')
                [WP_Tree,WP_Data] = ...
                        wmemtool('rmb',win_wptool,n_sav_struct,...
                                        ind_sav_tree_st,ind_sav_data_st);
                        Axe_TreeTitle = 'Decomposition Tree';
        elseif strcmp(option,'input_tree')
                WP_Tree = in3;  WP_Data = in4;
                Axe_TreeTitle = 'Decomposition Tree';
        elseif  strcmp(option,'cuttree')
                % in3 = pop_hdl
                %--------------
                val = get(in3,'Value');
                lev = val-1;
                depth = treedpth(WP_Tree);
                if lev==depth , wwaiting('off',win_wptool); return; end

                [WP_Tree,WP_Data,n2m] = ...
                        wpcutree(WP_Tree,WP_Data,lev);
                if isempty(n2m) , wwaiting('off',win_wptool); return; end
                Axe_TreeTitle = 'Cut Tree';
        end

        depth = treedpth(WP_Tree);
        str_depth = '0';
        for k=1:depth , str_depth = str2mat(str_depth,int2str(k)); end
        pop_cur = findobj(pop_handles,'Tag',tag_curtree);
        set(pop_cur,'String',str_depth,'Value',depth+1);

        xlab    = get(WP_Axe_Cfs,'xlabel');
        strxlab = get(xlab,'String');
        titl    = get(WP_Axe_Cfs,'title');
        strtitl = get(titl,'String');

        hdl_in_axes = [...
                        get(WP_Axe_TreeTxt,'Children'); ...
                        get(WP_Axe_TreeLin,'Children'); ...
                        get(WP_Axe_Cfs,'Children');     ...
                        get(WP_Axe_Pack,'Children')     ...
                        ];

        %%%%%%%%%%%%  version 5 %%%%%%%%%%%%%
        if Mat_Version<5
                hdl_in_axes = [hdl_in_axes;get(WP_Axe_Pack,'title')];
                delete([xlab;hdl_in_axes]); drawnow
        else
                delete(hdl_in_axes); drawnow
        end
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

        wmemtool('wmb',win_wptool,n_wp1d2d_utils,...
                        ind_tree_lin,[],ind_tree_txt,[]);
        wmemtool('wmb',win_wptool,n_structures, ...
                                ind_tree_st,WP_Tree,    ...
                                ind_data_st,WP_Data     ...
                                );
        nb_col = wmemtool('rmb',win_wptool,n_wp1d2d_utils,ind_nb_colors);
        axes(WP_Axe_TreeTxt);
        title(Axe_TreeTitle);
        wpplottr('first',win_wptool,WP_Tree);
        wpnodlab(win_wptool);
        pop_nodact = findobj(pop_handles,'Tag',tag_nodact);
        act = get(pop_nodact,'Value');
        wptreeop('nodact',win_wptool,'reset');
        wpplotcf(WP_Axe_Cfs,WP_Tree,WP_Data,win_wptool,nb_col);
        axes(WP_Axe_Cfs)
        title(strtitl);
        if order==2
           if act==7
                xlab    = get(WP_Axe_Cfs,'xlabel');
                strxlab = get(xlab,'String');
           end
           wsetxlab(WP_Axe_Cfs,strxlab,-15);
        end
        if ~strcmp(option,'input_tree')
                dynvtool('get',win_wptool,0);
        end

elseif  strcmp(option,'cfs')
        xlab    = get(WP_Axe_Cfs,'xlabel');
        strxlab = get(xlab,'String');
        titl    = get(WP_Axe_Cfs,'title');
        strtitl = get(titl,'String');
        delete(get(WP_Axe_Cfs,'Children'));
        nb_col = wmemtool('rmb',win_wptool,n_wp1d2d_utils,ind_nb_colors);
        wpplotcf(WP_Axe_Cfs,WP_Tree,WP_Data,win_wptool,nb_col);
        axes(WP_Axe_Cfs)
        title(strtitl)
        if order==2     
                wsetxlab(WP_Axe_Cfs,strxlab,-15);
        end

elseif  strcmp(option,'col_mode') % only for WP-1D
        % b_pop = in3.
        %-------------
        val     = get(in3,'Value');
        user    = get(in3,'Userdata');
        if val~=user
                set(in3,'Userdata',val);
                titl    = get(WP_Axe_Cfs,'title');
                strtitl = get(titl,'String');
                delete(get(WP_Axe_Cfs,'Children'));
                nb_col = wmemtool('rmb',win_wptool,n_wp1d2d_utils,ind_nb_colors);
                wpplotcf(WP_Axe_Cfs,WP_Tree,WP_Data,win_wptool,nb_col);
                axes(WP_Axe_Cfs)
                title(strtitl)
                if order==2
                        if      find(val==[1 2 3 4])
                                strxlab = ['frequency ordered coefficients'];
                        else
                                strxlab = ...
                                ['(down -> up) for Cfs <==> (left -> right) in Tree'];
                        end
                        wsetxlab(WP_Axe_Cfs,strxlab,-15);
                end
        end

elseif  strcmp(option,'recons')
        Selected_Nodes = wmemtool('rmb',win_wptool,n_wp1d2d_utils,ind_sel_nodes);
        if isempty(Selected_Nodes) , wwaiting('off',win_wptool); return; end

        nodes   = sort(Selected_Nodes(1,:));
        n2m     = [];
        un_sel  = [];
        ter_nod = [];
        k = 1;
        while k<=length(nodes)
                nod_sel = nodes(k);
                desc    = nodedesc(WP_Tree,nod_sel);
                desc    = desc(2:length(desc));
                if isempty(desc)
                        ter_nod = [ter_nod nod_sel];
                else
                        [xind,yind] = wcommon(nodes,desc);
                        indx = find(xind);
                        un_sel = [un_sel nodes(indx)];
                        nodes(indx) = [];
                        n2m = [n2m nod_sel];
                end
                k = k+1;
        end
        if ~isempty(un_sel)
                [xind,yind] = wcommon(Selected_Nodes(1,:),un_sel);
                indx = find(xind);
                set(Selected_Nodes(2,indx),'Color',txt_color);
                Selected_Nodes(:,indx) = [];
                wmemtool('wmb',win_wptool,n_wp1d2d_utils,...
                                ind_sel_nodes,Selected_Nodes);
        end

        Tree_Texts = wmemtool('rmb',win_wptool,n_wp1d2d_utils,ind_tree_txt);
        set(Tree_Texts,'Visible','off');
        set(Selected_Nodes(2,:),'Visible','on');
        drawnow

        for n = n2m
                [WP_Tree,WP_Data] = wpjoin(WP_Tree,WP_Data,n);
        end

        [tnods,sizes,order] = wtreemgr('readall',WP_Tree);
        [xind,yind] = wcommon(tnods,[ter_nod n2m]);

        if order==2 , sizes = [ones(length(sizes),1) sizes]; end
        for k = 1:length(tnods)
                if xind(k)==0
                        WP_Data = wdatamgr('write_cfs',WP_Data,WP_Tree,...
                                tnods(k),zeros(sizes(k,1),sizes(k,2)));
                end
        end
        [WP_Tree,WP_Data,pack] = wpjoin(WP_Tree,WP_Data,0);

        % Drawing Packet.
        %----------------
        nodes = (sort(Selected_Nodes(1,:)))';
        Tree_Type_TxtV = wmemtool('rmb',win_wptool,n_wp1d2d_utils,ind_type_txt);
        str_pck = ['Rec. Pack. : '];
        len     =  length(nodes);
        if strcmp(Tree_Type_TxtV,'i')
                ind = depo2ind(order,nodes);
                for k=1:len
                        str_pck = [str_pck '('  int2str(ind(k)) ')'];
                        if k<len , str_pck = [str_pck '+']; end
                end
        else
                [d,p]   = ind2depo(order,nodes);
                for k=1:len
                        str_pck = [str_pck '(' int2str(d(k)) ',' ...
                                                int2str(p(k)), ')'];
                        if k<len , str_pck = [str_pck '+']; end
                end
        end

        delete(get(WP_Axe_Pack,'Children'));
        dynvtool('new_his',win_wptool)
        axes(WP_Axe_Pack)
        if size(pack,1) == 1
                xmax = size(pack,2);
                if xmax==1, xmax = 1+0.01; end
                ymin = min(pack);       ymax = max(pack);
                if ymin==ymax , ymin = ymin-0.0001; ymax = ymax+0.0001; end
                line('Xdata',[1:length(pack)],'Ydata',pack,'Color',pack_color);
                set(WP_Axe_Pack,'XLim',[1 xmax],'Ylim',[ymin ymax]);
                title(str_pck,'FontSize',ftn_size,'Color',pack_color);
        else
                NB_Colors2D = ...
                        wmemtool('rmb',win_wptool,n_wp1d2d_utils,ind_nb_colors);
                image('CData',wimgcode('cod',0,pack,NB_Colors2D,codemat_v));
                title(str_pck,'FontSize',ftn_size,'Color',get(WP_Axe_TreeLin,'Xcolor'));
                set(WP_Axe_Pack,'Tag',tag_axe_pack)

                %%%%%%%%%%%%  version 5 %%%%%%%%%%%%%
                if (Mat_Version>=5)
                        set(WP_Axe_Pack,...
                                'Ydir','Reverse',       ...
                                'XLim',[1 size(pack,2)],...
                                'Ylim',[1 size(pack,1)] ...
                                );
                end
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        end
        dynvtool('put',win_wptool)
        axes(WP_Axe_TreeTxt);
        set(Tree_Texts,'Visible','on');
end

% End waiting.
%-------------
wwaiting('off',win_wptool);
