function [out1,fid] = wreadinf(fname)
%WREADINF Read ascii files.
%       [out1,fid] = wreadinf(fname) or

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:30:18 $

fid     = fopen(fname,'r');
if fid==-1
        if nargin==2 , return; end
        errargt('wreadinf','File Error ...','msg');
        error('*');     
end
winfo   = fread(fid);
fclose(fid);
winfo   = (abs(winfo))';

% tabulation
j = find(winfo==9);
winfo(j) = 32*ones(size(j));

out1    = [];
if length(winfo)>0
        ind1  = find(winfo==10);
        ind2  = find(winfo==13);
        if length(ind1)>0
                if length(ind2)>0 , back = 1; else , back = 0; end
                i_end = -1;
                for k = 1:length(ind1)
                        i_beg = i_end+2;
                        i_end = ind1(k)-1;
                        out1  = str2mat(out1,setstr(winfo(i_beg:i_end-back)));
                end
                out1 = out1(2:size(out1,1)-3,:);
        elseif length(ind2)>0
                i_end = -1;
                for k = 1:length(ind2)
                        i_beg = i_end+2;
                        i_end = ind2(k)-1;
                        out1 = str2mat(out1,setstr(winfo(i_beg:i_end)));
                end
                out1 = out1(2:size(out1,1)-3,:);
        else
                out1 = setstr(winfo);
        end
end
