function y = wrev(x)
%WREV   Flip vector.
%       Y = WREV(X) reverses the vector X.
%
%       See also FLIPLR, FLIPUD.

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:30:25 $

%       Uses ERRARGN.

% Check arguments.
if errargn('wrev',nargin,[1],nargout,[0:1]), error('*'), end

y = x(length(x):-1:1);
