function wselobj(funmove,arg,txt);
%WSELOBJ Object selection utilities.
%       wselobj(funmove,arg,txt)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:30:43 $

%       Uses NUM2STR.

%       Callbacks WSELOBJ.

global Selobj_Axe_Sel Selobj_Txt_Sel Selobj_Ptn_Sel
global Selobj_Sel_Obj

if nargin<1
        funmove = '';   arg = 0;        txt = 'Sel';
elseif nargin<2
        arg = 0;        txt = 'Sel';
elseif nargin<3
        txt = 'Sel';    
end

if arg==0
        fig = gcf;
        Selobj_Sel_Obj = get(fig,'currentobject');

        if ~isempty(Selobj_Sel_Obj)
                ty = get(Selobj_Sel_Obj,'type');
        else
                ty = 'none';
        end
        txt = ty(1:3);
        txt(1) = upper(txt(1));

        set(fig,'pointer','fleur');
        coul = [1 1 1] - get(fig,'Color');

%---------- A VOIR POUR UNITES QUELCONQUE ---------%
        p1 = get(0,'PointerLocation');
        old_unit = get(fig,'Units');
        set(fig,'units','pixels');
        pg = get(fig,'Position');
        p0 = [p1(1)-pg(1) p1(2)-pg(2)];
        set(fig,'Units',old_unit);

        if isempty(Selobj_Axe_Sel)
                Selobj_Axe_Sel = axes('Units','Pixels','Visible','off',...
                                        'Position',[p0 3 3]);
        end

        if isempty(Selobj_Txt_Sel)
                font_n = 'Times'; font_s = 25; font_b = 'bold'; font_w = 'italic';
                Selobj_Txt_Sel = text('Parent',Selobj_Axe_Sel,...
                        'Position',[0 0],'String',txt,'ButtonDownFcn','',...
                        'FontName',font_n,'FontSize',font_s,...
                        'FontWeight',font_b,'FontAngle',font_w,...
                        'Color',coul,...
                        'erasemode','xor');
        else
                set(Selobj_Txt_Sel,'String',txt)
        end
        numa = num2mstr(Selobj_Axe_Sel);
        numt = num2mstr(Selobj_Txt_Sel);

        motionfcn = ['global Selobj_Ptn_Sel; '...
                'Selobj_Ptn_Sel = get(' numa ',''CurrentPoint''); '...
                'set(' numt ',''Position'',[Selobj_Ptn_Sel(1,1) Selobj_Ptn_Sel(1,2)]);'];

        set(fig,'WindowButtonMotionFcn',motionfcn);
        action = ['wselobj(''' funmove ''',1);'];
        set(fig,'WindowButtonUpfcn',action);

elseif arg==1
        fig = gcf;
        set(fig,'WindowButtonMotionfcn','', ...
                'pointer','arrow',...
                'windowbuttonupfcn','');
        delete(Selobj_Txt_Sel);
        delete(Selobj_Axe_Sel);
        clear global Selobj_Axe_Sel Selobj_Txt_Sel Selobj_Ptn_Sel

        %---------- A VOIR POUR UNITES QUELCONQUE ---------%
        fig_units = get(fig,'units');
        set(fig,'units','pixels');
        p = get(fig,'Position');
        end_point = (get(0,'PointerLocation')-p(1:2))./p(3:4);
        set(fig,'units',fig_units);

        if ~isempty(funmove) , feval(funmove,'select',fig,Selobj_Sel_Obj,end_point); end
        clear global Selobj_Sel_Obj
end
