function wsetaxe(option,axe)
%WSETAXE Setting property values for axes.
%
%       wsetaxe('close')        : close dialog window.
%       wsetaxe('define',axe)   : define property values.
%       wsetaxe('apply',axe)    : validate property values.
%               axe     = handle of the axes.

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:30:48 $

%       Uses MNGAXE, MOUSEFRM, NUM2MSTR, UTSETCOL, UTSETFON, WMEMUTIL.

%       Callbacks WSETAXE.

tag_set = 'Win_Setaxe';
Win_Set = findobj(get(0,'children'),'flat','tag',tag_set);

%***********************************%
%** OPTION = 'close' QUIT WSETAXE **%
%***********************************%
if strcmp(option,'close')
        close(Win_Set);

%***********************************************%
%** OPTION = 'apply' VALIDATE PROPERTY VALUES **%
%***********************************************%
elseif strcmp(option,'apply')
        Setaxe_Glob = get(Win_Set,'Userdata');
        Setaxe_Axe_Act = wmemutil('get',Setaxe_Glob,4);
        axe = Setaxe_Axe_Act;
        eval('axe = findobj(axe,''flat'');','axe = [];');
        if ~isempty(axe)
                if strcmp(get(axe,'Visible'),'off') ,  return; end
                %--------------------%
                mousefrm(0,'watch');
                %--------------------%
                Setaxe_Handles = wmemutil('get',Setaxe_Glob,1);
                Setaxe_Hdls_Color = wmemutil('get',Setaxe_Glob,2);
                Setaxe_Hdls_Font = wmemutil('get',Setaxe_Glob,3);
                RbA_add = Setaxe_Handles(2);    RbA_rep = Setaxe_Handles(3);
                CbA_GridX = Setaxe_Handles(4);  CbA_GridY = Setaxe_Handles(5);
                CbA_XTick = Setaxe_Handles(6);  CbA_YTick = Setaxe_Handles(7);
                EdA_XLabel = Setaxe_Handles(8); EdA_YLabel = Setaxe_Handles(9);
                EdA_Name = Setaxe_Handles(10);
                EdA_XPos = Setaxe_Handles(11);  EdA_YPos = Setaxe_Handles(12);
                EdA_LPos = Setaxe_Handles(13);  EdA_HPos = Setaxe_Handles(14);

                %---- Mise a jour Color
                col = utsetcol('get',Setaxe_Hdls_Color);
                set(axe,'Color',col);
                %---- Mise a jour XGrid YGrid
                etat = str2mat('off','on');
                set(axe,'XGrid',etat(get(CbA_GridX,'Value')+1,:),...
                        'YGrid',etat(get(CbA_GridY,'Value')+1,:));

                %---- Mise a jour NextPlot
                if get(RbA_add,'Value')
                        set(axe,'NextPlot','add');
                else
                        set(axe,'NextPlot','replace');
                end

                %---- Mise a jour Title XLabel YLabel
                set(get(axe,'Title'),'String',get(EdA_Name,'String'));
                set(get(axe,'XLabel'),'String',get(EdA_XLabel,'String'));
                set(get(axe,'YLabel'),'String',get(EdA_YLabel,'String'));

                %---- Mise a jour XTick YTick
                if get(CbA_XTick,'Value')
                        if length(get(axe,'XTick'))==0
                                set(axe,'XTickMode','auto');
                        end
                else
                        set(axe,'XTick',[]);
                end
                if get(CbA_YTick,'Value')
                        if length(get(axe,'YTick'))==0
                                set(axe,'YTickMode','auto');
                        end
                else
                        set(axe,'YTick',[]);
                end

                %---- Mise a jour fonte de caracteres
                utsetfon('write',Setaxe_Hdls_Font,axe);

                %---- Mise a jour position
                pos = [eval(get(EdA_XPos,'String')) eval(get(EdA_YPos,'String')) ...
                eval(get(EdA_LPos,'String')) eval(get(EdA_HPos,'String'))]/100;

                if (pos(1)<0) | (pos(1)>=1-0.025) , pos(1) = 0; end
                if (pos(2)<0) | (pos(2)>=1-0.025) , pos(2) = 0; end
                if (pos(3)<0) | (pos(1)+pos(3)>1-0.025)
                        pos(3) = 1-0.025-pos(1);
                end
                if (pos(4)<0) | (pos(2)+pos(4)>1-0.025)
                        pos(4) = 1-0.025-pos(2);
                end
                set(axe,'Position',pos);
                btn = mngaxe('gstb',axe);
                if ~isempty(btn) , mngaxe('posb',axe,btn); end
                %--------------------%
                mousefrm(0,'arrow');
                %--------------------%
        end

%**********************************************%
%** OPTION = 'define' DEFINE PROPERTY VALUES **%
%**********************************************%
elseif strcmp(option,'define')
        %---------------------%
        mousefrm(0,'watch');
        %---------------------%
        Setaxe_Axe_Act = axe;
        %----- Si la fenetre de dialogue n'existe pas, on la construit -----%
        if isempty(Win_Set)
                Def_FraBkColor  = [0.9 0.9 0.9];
                fig_col         = get(0,'DefaultUiCOntrolBackGroundcolor');
                % Def_EdiBkColor = fig_col;
                Def_EdiBkColor = 'w';
                Def_Btn_Height = 22;
                X_Spacing = 4;    Y_Spacing = 4;
                large = 90;     y = 5;  dy = 5;
                Win_Set = figure('Name','Axes Parameters',...
                        'NumberTitle','off',    ...
                        'Resize','off',         ...
                        'Visible','off',        ...
                        'Color',fig_col,        ...
                        'Position',[300 200 365 15*dy+13*Def_Btn_Height],...
                        'Tag',tag_set);
                strwinset = int2str(Win_Set);

                action = ['wsetaxe(''apply'',' num2mstr(axe) ');'];
                uicontrol('Style','Pushbutton',...
                        'Position',[65 y large Def_Btn_Height],...
                        'String','Apply',...
                        'Callback',action);
                        
%               action = ['set(' strwinset ',''Visible'',''off'');'];
                action = ['close(' strwinset ');'];
                uicontrol('Style','PushButton',...
                        'Position',[115+large y large Def_Btn_Height],...
                        'String','Close',...
                        'Callback',action);

                y = y+dy+Def_Btn_Height;
                large = 150;
                [Setaxe_Hdls_Color,pos] = utsetcol('define',[10 y],'Background color');

                large = 90;
                y = pos(2)+pos(4)+dy;
                [Setaxe_Hdls_Font,pos] = utsetfon('define',[10 y]);

                y = pos(2)+pos(4)+dy;
                uicontrol('Style','Frame',...
                        'BackGroundColor',Def_FraBkColor,...
                        'Position',[20 y large Def_Btn_Height]);
                uicontrol('Style','Text',...
                        'BackGroundColor',Def_FraBkColor,...
                        'Position',[23,y+3,large-6,Def_Btn_Height-6],...
                        'String','NextPlot :');
                RbA_add = uicontrol('Style','RadioButton',...
                        'Position',[30+large,y,107,Def_Btn_Height],...
                        'String','Add');
                RbA_rep = uicontrol('Style','RadioButton',...
                        'Position',[148+large,y,107,Def_Btn_Height],...
                        'String','Replace');
                RbA_add_off=['set(' num2mstr(RbA_add) ',''Value'',0); '];
                RbA_rep_off=['set(' num2mstr(RbA_rep) ',''Value'',0); '];
                set(RbA_add,'CallBack',RbA_rep_off);
                set(RbA_rep,'CallBack',RbA_add_off);
                y = y+dy+Def_Btn_Height;
                CbA_GridX = uicontrol('Style','CheckBox',...
                        'Position',[20,y,75,Def_Btn_Height],...
                        'String','XGrid');
                CbA_GridY = uicontrol('Style','CheckBox',...
                        'Position',[105,y,75,Def_Btn_Height],...
                        'String','YGrid');
                CbA_XTick = uicontrol('Style','CheckBox',...
                        'Position',[195,y,70,Def_Btn_Height],...
                        'String','XTick');
                CbA_YTick = uicontrol('Style','CheckBox',...
                        'Position',[275,y,70,Def_Btn_Height],...
                        'String','YTick');
                y = y+dy+Def_Btn_Height;
                uicontrol('Style','Frame',...
                        'BackGroundColor',Def_FraBkColor,...
                        'Position',[20 y large+28 Def_Btn_Height]);
                uicontrol('Style','Text',...
                        'BackGroundColor',Def_FraBkColor,...
                        'Position',[23,y+3,large+22,Def_Btn_Height-6],...
                        'String','Pos : [X Y L H]');
                EdA_XPos = uicontrol('Style','Edit',...
                        'BackGroundColor',Def_EdiBkColor,       ...
                        'Position',[58+large,y,42,Def_Btn_Height]);
                EdA_YPos = uicontrol('Style','Edit',...
                        'BackGroundColor',Def_EdiBkColor,       ...
                        'Position',[59+large+50,y,42,Def_Btn_Height]);
                EdA_LPos = uicontrol('Style','Edit',...
                        'BackGroundColor',Def_EdiBkColor,       ...
                        'Position',[61+large+100,y,42,Def_Btn_Height]);
                EdA_HPos = uicontrol('Style','Edit',...
                        'BackGroundColor',Def_EdiBkColor,       ...
                        'Position',[63+large+150,y,42,Def_Btn_Height]);
                y = y+dy+Def_Btn_Height;
                uicontrol('Style','Frame',...
                        'BackGroundColor',Def_FraBkColor,...
                        'Position',[20 y large Def_Btn_Height]);
                uicontrol('Style','Text',...
                        'BackGroundColor',Def_FraBkColor,...
                        'Position',[23,y+3,large-6,Def_Btn_Height-6],...
                        'String','YLabel :');
                EdA_YLabel = uicontrol('Style','Edit',...
                        'BackGroundColor',Def_EdiBkColor,       ...
                        'Position',[30+large,y,225,Def_Btn_Height]);
                y = y+dy+Def_Btn_Height;
                uicontrol('Style','Frame',...
                        'BackGroundColor',Def_FraBkColor,...
                        'Position',[20 y large Def_Btn_Height]);
                uicontrol('Style','Text',...
                        'BackGroundColor',Def_FraBkColor,...
                        'Position',[23,y+3,large-6,Def_Btn_Height-6],...
                        'String','XLabel :');
                EdA_XLabel = uicontrol('Style','Edit',...
                        'BackGroundColor',Def_EdiBkColor,       ...
                        'Position',[30+large,y,225,Def_Btn_Height]);
                y = y+dy+Def_Btn_Height;
                uicontrol('Style','Frame',...
                        'BackGroundColor',Def_FraBkColor,...
                        'Position',[20 y large Def_Btn_Height]);
                uicontrol('Style','Text',...
                        'BackGroundColor',Def_FraBkColor,...
                        'Position',[23,y+3,large-6,Def_Btn_Height-6],...
                        'String','Title :');
                EdA_Name = uicontrol('Style','Edit',...
                        'BackGroundColor',Def_EdiBkColor,       ...
                        'Position',[30+large,y,225,Def_Btn_Height]);

                Setaxe_Handles = ...
                         [      Win_Set...
                                RbA_add RbA_rep...
                                CbA_GridX CbA_GridY CbA_XTick CbA_YTick...
                                EdA_XLabel EdA_YLabel EdA_Name...
                                EdA_XPos EdA_YPos EdA_LPos EdA_HPos];

                Setaxe_Glob = [];
                Setaxe_Glob = wmemutil('add',Setaxe_Glob,Setaxe_Handles);
                Setaxe_Glob = wmemutil('add',Setaxe_Glob,Setaxe_Hdls_Color);
                Setaxe_Glob = wmemutil('add',Setaxe_Glob,Setaxe_Hdls_Font);
                Setaxe_Glob = wmemutil('add',Setaxe_Glob,Setaxe_Axe_Act);

                axes('Visible','Off');
                set(Win_Set,'NextPlot','new');

        else
                Setaxe_Glob = get(Win_Set,'Userdata');
                Setaxe_Handles = wmemutil('get',Setaxe_Glob,1);
                Setaxe_Hdls_Color = wmemutil('get',Setaxe_Glob,2);
                Setaxe_Hdls_Font = wmemutil('get',Setaxe_Glob,3);
                Setaxe_Glob = wmemutil('set',Setaxe_Glob,4,Setaxe_Axe_Act);
                Win_Set = Setaxe_Handles(1);
                RbA_add = Setaxe_Handles(2);    RbA_rep = Setaxe_Handles(3);
                CbA_GridX = Setaxe_Handles(4);  CbA_GridY = Setaxe_Handles(5);
                CbA_XTick = Setaxe_Handles(6);  CbA_YTick = Setaxe_Handles(7);
                EdA_XLabel = Setaxe_Handles(8); EdA_YLabel = Setaxe_Handles(9);
                EdA_Name = Setaxe_Handles(10);
                EdA_XPos = Setaxe_Handles(11);  EdA_YPos = Setaxe_Handles(12);
                EdA_LPos = Setaxe_Handles(13);  EdA_HPos = Setaxe_Handles(14);
                figure(Win_Set);
        end
        set(Win_Set,'Userdata',Setaxe_Glob);

        col = get(axe,'Color');
        if strcmp(col,'none') , col = get(get(axe,'Parent'),'Color'); end
        utsetcol('set',Setaxe_Hdls_Color,col);
        set(RbA_add,'Value',strcmp(get(axe,'NextPlot'),'add'));
        set(RbA_rep,'Value',strcmp(get(axe,'NextPlot'),'replace'));
        set(CbA_GridX,'Value',strcmp(get(axe,'XGrid'),'on'));
        set(CbA_GridY,'Value',strcmp(get(axe,'XGrid'),'on'));
        set(CbA_XTick,'Value',(length(get(axe,'XTick'))~=0));
        set(CbA_YTick,'Value',(length(get(axe,'YTick'))~=0));
        set(EdA_Name,'String',get(get(axe,'Title'),'String'));
        set(EdA_XLabel,'String',get(get(axe,'XLabel'),'String'));
        set(EdA_YLabel,'String',get(get(axe,'YLabel'),'String'));
        pos = round(get(axe,'Position')*10000)/100;
        set(EdA_XPos,'String',sprintf('%5.2f',pos(1)));
        set(EdA_YPos,'String',sprintf('%5.2f',pos(2)));
        set(EdA_LPos,'String',sprintf('%5.2f',pos(3)));
        set(EdA_HPos,'String',sprintf('%5.2f',pos(4)));
        utsetfon('read',Setaxe_Hdls_Font,axe);
        set(Win_Set,'Visible','on');
        %------------------%
        mousefrm(0,'arrow');
        %------------------%

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('wsetaxe','Unknown Option','msg');
        error('*');
end
