function wsetfig(option,fig)
%WSETFIG Setting property values for figures.
%
%       wsetfig('close')        : close dialog window.
%       wsetfig('define',fig)   : define property values.
%       wsetfig('apply',fig)    : validate property values.
%               fig     = handle of the figure.

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:30:54 $

%       Uses ERRARGT, MNGFIG, MOUSEFRM, NUM2MSTR, UTSETCOL, WMEMUTIL.

%       Callbacks WSETFIG.

tag_set = 'Win_Setfig';
Win_Set = findobj(get(0,'children'),'flat','tag',tag_set);

%************************************%
%** OPTION = 'close' QUIT WSETFIG  **%
%************************************%
if strcmp(option,'close')
        close(Win_Set);

%***********************************************%
%** OPTION = 'apply' VALIDATE PROPERTY VALUES **%
%***********************************************%
elseif strcmp(option,'apply')
        if isempty(find(get(0,'children')==fig)) , return; end
        %----------------------%
        mousefrm(0,'watch');
        %----------------------%
        Setfig_Glob = get(Win_Set,'Userdata');
        Setfig_Handles = wmemutil('get',Setfig_Glob,1);
        Setfig_Hdls_Color = wmemutil('get',Setfig_Glob,2);
        Pb_ok   = Setfig_Handles(2);
        Rb_new  = Setfig_Handles(3);
        Rb_add  = Setfig_Handles(4);
        Rb_rep  = Setfig_Handles(5);
        Cb_Num = Setfig_Handles(6);
        Ed_Name = Setfig_Handles(7);

        %---- Mise a jour Color ----%
        col = utsetcol('get',Setfig_Hdls_Color);
        set(fig,'Color',col);

        %---- Mise a jour No figure ----%
        etat = str2mat('off','on');
        set(fig,'NumberTitle',etat(get(Cb_Num,'Value')+1,:));
        % Mise a jour NextPlot
        if get(Rb_new,'Value')
                set(fig,'NextPlot','new');
        elseif get(Rb_add,'Value')
                set(fig,'NextPlot','add');
        else
                set(fig,'NextPlot','replace');
        end
        %---- Mise a jour Titre ----%
        set(fig,'Name',get(Ed_Name,'String'));
        %----------------------%
        mousefrm(0,'arrow');
        %----------------------%

%**********************************************%
%** OPTION = 'define' DEFINE PROPERTY VALUES **%
%**********************************************%
elseif strcmp(option,'define')
        %----------------------%
        mousefrm(0,'watch');
        %----------------------%
        strHfig = int2str(fig);
        %--- Construction de la fenetre de dialogue si elle n'existe pas ---%
        if isempty(Win_Set)
                Def_FraBkColor  = [0.9 0.9 0.9];
                fig_col         = get(0,'DefaultUiCOntrolBackGroundcolor');
                % Def_EdiBkColor = fig_col;
                Def_EdiBkColor = 'w';
                Def_Btn_Height = 22;
                X_Spacing = 4;    Y_Spacing = 4;
                large   = 90;   y = 8;  dy = 6;
                Win_Set = figure('Name','Figure Parameters',...
                        'NumberTitle','off',    ...
                        'Resize','off',         ...
                        'Visible','off',        ...
                        'Color',fig_col,        ...
                        'Position',[300 200 365 2*y+5*dy+7*Def_Btn_Height],...
                        'Tag',tag_set);
                strwinset = int2str(Win_Set);

                Pb_ok = uicontrol('Style','Pushbutton',...
                        'Position',[65 y large Def_Btn_Height],...
                        'String','Apply');
                        
%               action = ['set(' strwinset ',''Visible'',''off'');'];
                action = ['close(' strwinset ');'];
                uicontrol('Style','PushButton',...
                        'Position',[120+large y large Def_Btn_Height],...
                        'String','Close',...
                        'Callback',action);

                y = y+dy+Def_Btn_Height;
                large = 150;
                [Setfig_Hdls_Color,pos] = utsetcol('define',[10 y],'Background color');

                large = 90;
                y = pos(2)+pos(4)+dy;
                uicontrol('Style','Frame',...
                        'BackGroundColor',Def_FraBkColor,...
                        'Position',[20 y large Def_Btn_Height]);
                uicontrol('Style','Text',...
                        'BackGroundColor',Def_FraBkColor,...
                        'Position',[23,y+3,large-6,Def_Btn_Height-6],...
                        'String','NextPlot :');
                Rb_new = uicontrol('Style','RadioButton',...
                        'Position',[30+large,y,60,Def_Btn_Height],...
                        'String','New');
                Rb_add = uicontrol('Style','RadioButton',...
                        'Position',[40+60+large,y,60,Def_Btn_Height],...
                        'String','Add');
                Rb_rep = uicontrol('Style','RadioButton',...
                        'Position',[50+120+large,y,85,Def_Btn_Height],...
                        'String','Replace');
                Rb_new_off=['set(' num2mstr(Rb_new) ',''Value'',0); '];
                Rb_add_off=['set(' num2mstr(Rb_add) ',''Value'',0); '];
                Rb_rep_off=['set(' num2mstr(Rb_rep) ',''Value'',0); '];
                set(Rb_new,'CallBack',[Rb_add_off Rb_rep_off]);
                set(Rb_add,'CallBack',[Rb_new_off Rb_rep_off]);
                set(Rb_rep,'CallBack',[Rb_new_off Rb_add_off]);
                y = y+dy+Def_Btn_Height;
                Cb_Num = uicontrol('Style','CheckBox',...
                        'Position',[92,y,2*large,Def_Btn_Height],...
                        'String','Figure number');
                y = y+dy+Def_Btn_Height;
                uicontrol('Style','Frame',...
                        'BackGroundColor',Def_FraBkColor,...
                        'Position',[20 y large Def_Btn_Height]);
                uicontrol('Style','Text',...
                        'BackGroundColor',Def_FraBkColor,...
                        'Position',[23,y+3,large-6,Def_Btn_Height-6],...
                        'String','Name :');
                Ed_Name = uicontrol('Style','Edit',...
                        'BackGroundColor',Def_EdiBkColor,       ...
                        'Position',[30+large,y,225,Def_Btn_Height]);
                Setfig_Handles = [Win_Set Pb_ok ...
                                Rb_new Rb_add Rb_rep Cb_Num Ed_Name];
                Setfig_Glob = [];
                Setfig_Glob = wmemutil('add',Setfig_Glob,Setfig_Handles);
                Setfig_Glob = wmemutil('add',Setfig_Glob,Setfig_Hdls_Color);
                set(Win_Set,'Userdata',Setfig_Glob);

                axes('Visible','Off');
                set(Win_Set,'NextPlot','new');

        else
                Setfig_Glob = get(Win_Set,'Userdata');
                Setfig_Handles = wmemutil('get',Setfig_Glob,1); 
                Setfig_Hdls_Color = wmemutil('get',Setfig_Glob,2);

                Win_Set = Setfig_Handles(1);
                Pb_ok   = Setfig_Handles(2);
                Rb_new  = Setfig_Handles(3);
                Rb_add  = Setfig_Handles(4);
                Rb_rep  = Setfig_Handles(5);
                Cb_Num  = Setfig_Handles(6);
                Ed_Name = Setfig_Handles(7);
                figure(Win_Set);
        end

        %--- Ecriture des parametres a modifier ---%
        utsetcol('set',Setfig_Hdls_Color,get(fig,'Color'));
        set(Rb_new,'Value',strcmp(get(fig,'NextPlot'),'new'));
        set(Rb_add,'Value',strcmp(get(fig,'NextPlot'),'add'));
        set(Rb_rep,'Value',strcmp(get(fig,'NextPlot'),'replace'));
        set(Cb_Num,'Value',strcmp(get(fig,'NumberTitle'),'on'));
        set(Ed_Name,'String',get(fig,'Name'));
        action = ['wsetfig(''apply'',' strHfig ');'];
        set(Pb_ok,'Callback',action);
        set(Win_Set,'Visible','on');
        %----------------------%
        mousefrm(0,'arrow');
        %----------------------%

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('wsetfig','Unknown Option','msg');
        error('*');
end
