function wsetpri(option,fig)
%WSETPRI Setting parameters for printing figure.
%
%       wsetpri('close')        : close dialog window.
%       wsetpri('define',fig)   : define printing parameters.
%       wsetpri('validate',fig) : validate printing parameters.
%               fig     = handle of the printed figure.

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:31:02 $

%       Uses MNGFIG, MOUSEFRM, NUM2STR, WMEMUTIL.

%       Callbacks WSETPRI.

global Machine X_Graph_Ratio

% Tag property of objects.
%------------------------
tag_set         = 'Win_Setpri';
tag_m_prnset    = 'M_PrnSet';

Win_Set = findobj(get(0,'children'),'flat','tag',tag_set);

%**************************************************%
%** OPTION = 'define' DEFINE PRINTING PARAMETERS **%
%**************************************************%
if strcmp(option,'define')
        %---------------------%
        mousefrm(0,'watch');
        %---------------------%
        if isempty(Win_Set)
                Def_FraBkColor = [0.9 0.9 0.9];
                fig_col        = get(0,'DefaultUiCOntrolBackGroundcolor');
                % Def_EdiBkColor = fig_col;
                Def_EdiBkColor = 'w';
                Def_Btn_Height = 22;
                X_Spacing = 4;  Y_Spacing = 4;
                x_left1 = 20;
                large   = 90;   y = 8;  dy = 6;
                width_1 = 120;
                Win_Set = figure('Name','Print Parameters',...
                        'NumberTitle','off',    ...
                        'Resize','off',         ...
                        'Visible','off',        ...
                        'Color',fig_col,        ...
                        'Position',[300 200 385 2*y+5*dy+6*Def_Btn_Height],...
                        'Tag',tag_set);
                strHfig = int2str(fig);
                strHdialfig = int2str(Win_Set);

                action = ['wsetpri(''apply'',' strHfig ');'];
                uicontrol('Style','Pushbutton',...
                        'Position',[70 y large Def_Btn_Height],...
                        'String','Apply',...
                        'Callback',action);
                        
%               action = ['set(' strHdialfig ',''Visible'',''off'');'];
                action = ['close(' strHdialfig ');'];
                uicontrol('Style','PushButton',...
                        'Position',[135+large y large Def_Btn_Height],...
                        'String','Close',...
                        'Callback',action);

                y = y+dy+Def_Btn_Height;
                uicontrol('Style','Frame',...
                        'BackGroundColor',Def_FraBkColor,...
                        'Position',[x_left1 y large Def_Btn_Height]);
                uicontrol('Style','Text',...
                        'BackGroundColor',Def_FraBkColor,...
                        'Position',[x_left1+3,y+3,large-6,Def_Btn_Height-6],...
                        'String','Paper type');
                Rb_uslet = uicontrol('Style','RadioButton',...
                        'Position',[30+large,y,75,Def_Btn_Height],...
                        'String','Usletter');
                Rb_usleg = uicontrol('Style','RadioButton',...
                        'Position',[40+75+large,y,75,Def_Btn_Height],...
                        'String','Uslegal');
                Rb_a4let = uicontrol('Style','RadioButton',...
                        'Position',[50+150+large,y,80,Def_Btn_Height],...
                        'String','a4letter');
                Rb_uslet_off=['set(' num2mstr(Rb_uslet) ',''Value'',0); '];
                Rb_usleg_off=['set(' num2mstr(Rb_usleg) ',''Value'',0); '];
                Rb_a4let_off=['set(' num2mstr(Rb_a4let) ',''Value'',0); '];
                set(Rb_uslet,'CallBack',[Rb_usleg_off Rb_a4let_off]);
                set(Rb_usleg,'CallBack',[Rb_uslet_off Rb_a4let_off]);
                set(Rb_a4let,'CallBack',[Rb_uslet_off Rb_usleg_off]);

                y = y+dy+Def_Btn_Height;
                uicontrol('Style','Frame',...
                        'BackGroundColor',Def_FraBkColor,...
                        'Position',[x_left1 y large+55 Def_Btn_Height]);
                uicontrol('Style','Text',...
                        'BackGroundColor',Def_FraBkColor,...
                        'Position',[x_left1+3,y+3,large+49,Def_Btn_Height-6],...
                        'String','Paper orientation :');
                Rb_port = uicontrol('Style','RadioButton',...
                        'Position',[30+large+55,y,large,Def_Btn_Height],...
                        'String','Portrait');
                Rb_pays = uicontrol('Style','RadioButton',...
                        'Position',[40+2*large+55,y,large+5,Def_Btn_Height],...
                        'String','Landscape');
                Rb_port_off=['set(' num2mstr(Rb_port) ',''Value'',0); '];
                Rb_pays_off=['set(' num2mstr(Rb_pays) ',''Value'',0); '];
                set(Rb_port,'CallBack',Rb_pays_off);
                set(Rb_pays,'CallBack',Rb_port_off);

                y = y+dy+Def_Btn_Height;
                Cb_invHC = uicontrol('Style','CheckBox',...
                        'Position',[100,y,width_1+20,Def_Btn_Height],...
                        'String','Invert mode');

                y = y+dy+Def_Btn_Height;
                uicontrol('Style','Frame',...
                        'BackGroundColor',Def_FraBkColor,...
                        'Position',[20 y large Def_Btn_Height]);
                uicontrol('Style','Text',...
                        'BackGroundColor',Def_FraBkColor,...
                        'Position',[23,y+3,large-6,Def_Btn_Height-6],...
                        'String','Type :');

                prn_mode = str2mat(...
                                'dps','dpsc','dps2','dpsc2',     ...
                                'deps','depsc','deps2','depsc2'  ...
                                );
                prn_mode = str2mat(prn_mode,...
                                'dgif8','dpcx16','dpcx256', ...
                                'dhpgl','dill','dmfile'     ...
                                );
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                if ~strcmp(Machine(1:3),'MAC')
                        prn_mode = str2mat(prn_mode,'dlaserjet','dljetplus','dljet2p');
                        prn_mode = str2mat(prn_mode,'dljet3','dcdeskjet','dcdjcolor');
                        prn_mode = str2mat(prn_mode,'dcdjmono','ddeskjet','dpaintjet');
                        prn_mode = str2mat(prn_mode,'dpjetxl','dbj10e','dln03');
                        prn_mode = str2mat(prn_mode,'depson','deps9high');
                end
                if strcmp(Machine(1:3),'PCW')
                        prn_mode = str2mat(prn_mode,'dwin','dwinc','dmeta','dbitmap');
                end
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                Po_Typ_imp = uicontrol(...
                                        'Style','Popup',...
                                        'Position',[30+large,y,width_1,Def_Btn_Height],...
                                        'String',prn_mode);

                y = y+dy+Def_Btn_Height;
                uicontrol('Style','Frame',...
                        'BackGroundColor',Def_FraBkColor,...
                        'Position',[20 y large Def_Btn_Height]);
                uicontrol('Style','Text',...
                        'BackGroundColor',Def_FraBkColor,...
                        'Position',[23,y+3,large-6,Def_Btn_Height-6],...
                        'String','Name :');
                Ed_Name_imp = uicontrol(...
                                'Style','Edit',...
                                'Position',[30+large,y,width_1,Def_Btn_Height],...
                                'BackGroundColor',Def_EdiBkColor);

%--------------------------------------------------------
%               pos     = get(Ed_Name_imp,'Position');
%               pos(1)  = pos(1)+pos(3)+10;
%               uicontrol('Style','Frame',...
%                       'BackGroundColor',Def_FraBkColor,...
%                       'Position',pos);
%               uicontrol('Style','Text',...
%                       'BackGroundColor',Def_FraBkColor,...
%                       'Position',[pos(1)+3,pos(2)+3,pos(3)-6,pos(4)-6],...
%                       'String','Print Text Note :');
%               pos(2)  = pos(2)-Def_Btn_Height-dy;
%               pos(3) = pos(3)/2-5;
%               Rb_TN_Yes       = uicontrol(...
%                               'Style','RadioButton',  ...
%                               'Position',pos,         ...
%                               'String','Yes',         ...
%                               'Value',0);
%
%               pos(1)  = pos(1)+pos(3)+10;
%               Rb_TN_No = uicontrol(...
%                               'Style','RadioButton',  ...
%                               'Position',pos,         ...
%                               'String','No',          ...
%                               'Value',1);
%               Rb_TN_Yes_off =['set(' num2mstr(Rb_TN_Yes) ',''Value'',0); '];
%               Rb_TN_No_off =['set(' num2mstr(Rb_TN_No) ',''Value'',0); '];
%               set(Rb_TN_Yes,'CallBack',Rb_TN_No_off);
%               set(Rb_TN_No,'CallBack',Rb_TN_Yes_off);
%-------------------------------------------------------------------

                Setpri_Handles = [ Win_Set ...
                                Rb_uslet Rb_usleg Rb_a4let Rb_port Rb_pays...
                                Cb_invHC Po_Typ_imp Ed_Name_imp];
%               Setpri_Handles = [Setpri_Handles Rb_TN_Yes Rb_TN_No];
                Setpri_Glob = [];
                Setpri_Glob = wmemutil('add',Setpri_Glob,Setpri_Handles);
                set(Win_Set,'Userdata',Setpri_Glob);

                axes('Visible','Off');
                set(Win_Set,'NextPlot','new');

        else
                Setpri_Glob = get(Win_Set,'Userdata');
                Setpri_Handles = wmemutil('get',Setpri_Glob,1);
                Win_Set         = Setpri_Handles(1);
                Rb_uslet        = Setpri_Handles(2);
                Rb_usleg        = Setpri_Handles(3);
                Rb_a4let        = Setpri_Handles(4);
                Rb_port         = Setpri_Handles(5);
                Rb_pays         = Setpri_Handles(6);
                Cb_invHC        = Setpri_Handles(7);
                Po_Typ_imp      = Setpri_Handles(8);
                Ed_Name_imp     = Setpri_Handles(9);
%               Rb_TN_Yes       = Setpri_Handles(10);
%               Rb_TN_No        = Setpri_Handles(11);    
 
                figure(Win_Set);
        end 
        set(Rb_uslet,'Value',strcmp(get(fig,'PaperType'),'usletter'));
        set(Rb_usleg,'Value',strcmp(get(fig,'PaperType'),'uslegal'));
        set(Rb_a4let,'Value',strcmp(get(fig,'PaperType'),'a4letter'));
        set(Rb_port,'Value',strcmp(get(fig,'PaperOrientation'),'portrait'));
        set(Rb_pays,'Value',strcmp(get(fig,'PaperOrientation'),'landscape'));
        set(Cb_invHC,'Value',strcmp(get(fig,'InvertHardCopy'),'on'));
        m_prnset = findobj(fig,'type','uimenu','tag',tag_m_prnset);
        memB = get(m_prnset,'Userdata');
        if ~isempty(memB)
                [num_mode,memB] = wmemutil('get',memB);
                [prn_mode,memB] = wmemutil('get',memB);
                [filename,memB] = wmemutil('get',memB);
%               [flg_TN,memB]   = wmemutil('get',memB);
        else
                num_mode        = 1;
                filename        = '';
%               flg_TN          = 0;    
        end
        set(Po_Typ_imp,'Value',num_mode);
        set(Ed_Name_imp,'String',filename);
%       set(Rb_TN_Yes,'Value',flg_TN);
%       set(Rb_TN_No,'Value',1-flg_TN);

        set(Win_Set,'Visible','on');

        %------------------%
        mousefrm(0,'arrow');
        %------------------%

%*****************************************%
%** OPTION = 'apply' SAVE PRINT SETTINGS **%
%*****************************************%
elseif strcmp(option,'apply')
        if isempty(find(get(0,'children')==fig)) , return; end
        Setpri_Glob     = get(Win_Set,'Userdata');
        Setpri_Handles  = wmemutil('get',Setpri_Glob,1);
        %---------------------%
        mousefrm(0,'watch');
        %---------------------%
        Rb_uslet        = Setpri_Handles(2);
        Rb_usleg        = Setpri_Handles(3);
        Rb_a4let        = Setpri_Handles(4);
        Rb_port         = Setpri_Handles(5);
        Rb_pays         = Setpri_Handles(6);
        Cb_invHC        = Setpri_Handles(7);
        Po_Typ_imp      = Setpri_Handles(8);
        Ed_Name_imp     = Setpri_Handles(9);
%       Rb_TN_Yes       = Setpri_Handles(10);
%       Rb_TN_No        = Setpri_Handles(11);

        %---- Mise a jour InvertHardCopy
        etat = str2mat('off','on');
        set(fig,'InvertHardCopy',etat(get(Cb_invHC,'Value')+1,:));

        %---- Mise a jour PaperType
        if      get(Rb_uslet,'Value')
                set(fig,'PaperType','usletter');
        elseif get(Rb_usleg,'Value')
                set(fig,'PaperType','uslegal');
        else
                set(fig,'PaperType','a4letter');
        end

        %---- Mise a jour PaperOrientation
        if get(Rb_port,'Value')
                set(fig,'PaperOrientation','portrait');
        else
                set(fig,'PaperOrientation','landscape');
        end

        %---- Mise a jour PaperPosition
        old_u   = get(fig,'Units');
        set(fig,'Units','pixels');
        pos     = get(fig,'Position');
        set(fig,'Units',old_u);
        coef    = pos(3)/pos(4);
        dim     = get(fig,'PaperSize');
        marge   = 0.25;
        dim     = dim-2*marge;
        r       = dim(1)/dim(2);
        if coef>r
                left    = marge;
                width   = dim(1);
                height  = width/coef;
                bottom  = marge+(dim(2)-height)/2;
        else
                bottom  = marge;
                height  = dim(2);
                width   = height*coef;
                left    = marge+(dim(1)-width)/2;
        end
        set(fig,'PaperPosition',[left, bottom, width, height]);

        %----- Saisie des autres parametres d'impression
        num_mode        = get(Po_Typ_imp,'Value');
        prn_mode        = get(Po_Typ_imp,'String');
        prn_mode        = prn_mode(num_mode,:);
        filename        = get(Ed_Name_imp,'String');
%       flg_TN          = get(Rb_TN_Yes,'Value');

        %----- Sauvegarde des parametres d'impression
        m_prnset = findobj(fig,'type','uimenu','tag',tag_m_prnset);
        memB = [];
        memB = wmemutil('add',memB,num_mode);
        memB = wmemutil('add',memB,prn_mode);
        memB = wmemutil('add',memB,filename);
%       memB = wmemutil('add',memB,flg_TN);
        set(m_prnset,'Userdata',memB);
%       set(Win_Set,'Visible','off');
        close(Win_Set);

        %------------------%
        mousefrm(0,'arrow');
        %------------------%

%*******************************%
%** OPTION = 'print' PRINTING **%
%*******************************%
elseif strcmp(option,'print')
        mousefrm(0,'watch');
        m_prnset = findobj(fig,'type','uimenu','tag',tag_m_prnset);
        memB = get(m_prnset,'Userdata');
        if ~isempty(memB)
                [num_mode,memB] = wmemutil('get',memB);
                [prn_mode,memB] = wmemutil('get',memB);
                [filename,memB] = wmemutil('get',memB);
%               [flg_TN,memB]   = wmemutil('get',memB);
                prn_mode        = ['-' deblank(prn_mode)];
        else
                [pcmd,dev]      = printopt;
                prn_mode        = dev;
                filename        = '';
%               flg_TN          = 0;    
        end
        numfig  = ['-f' int2str(fig)];
        if isempty(filename)
           call_prn = ['print(''' prn_mode ''',''' numfig ''')'];
        else
           call_prn = ['print(''' filename ''',''' prn_mode ''',''' numfig ''')'];
        end
        mul_w = X_Graph_Ratio;
        dynV  = findobj(fig,'tag','DynV_Fra_Ini');
        if ~isempty(dynV) , delta_h = 50; else , delta_h = 0; end
        uic    = findobj(fig,'type','uicontrol');
        uic_on = findobj(uic,'Visible','on');
        axe    = findobj(fig,'type','axes');
        set(uic_on,'Visible','off');
        set(fig,'Units','Pixels');
        set(axe,'Units','Pixels');
        pos_fig    = get(fig,'Position');
        pos_fig(3) = pos_fig(3)*mul_w;
        pos_fig(4) = pos_fig(4)-delta_h;
        set(fig,'position',pos_fig);
        for k=1:length(axe)
                set(axe(k),'Position',get(axe(k),'Position')-[0 delta_h 0 0]);
        end
        set(fig,'Units','normalized');
        set(axe,'Units','normalized');

        %%%%%%%%%%%% Problem to print on MAC %%%%%%%%%%%
        if strcmp(Machine(1:3),'MAC')
                hdl_fra = findobj(uic,'style','frame');
                if ~isempty(hdl_fra)
			hdl_pop = findobj(uic,'style','popupmenu');
               		hdl_pus = findobj(uic,'style','pushbutton');
                	hdl_txt = findobj(uic,'style','text');
               		hdl_rad = findobj(uic,'style','radiobutton');
                	hdl_chk = findobj(uic,'style','checkbox');
                    	hdl_edi = findobj(uic,'style','edit');
                    	set(hdl_fra,'style','text');
                    	set(hdl_rad,'style','text');
                    	set(hdl_edi,'style','text');
                    	set(hdl_chk,'style','text');
                    	set(hdl_txt,'style','pushbutton');
                    	set(hdl_pop,'style','text');
                    	set(hdl_pus,'style','text');
                    	drawnow
                end
                pause(1)
        end
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

        err = 0;
        eval(call_prn,'err = 1;');
        if err
                errordlg('Print FAILED !','PRINTING ...','off');
        end

        set(fig,'Units','Pixels');
        set(axe,'Units','Pixels');
        pos_fig(3) = pos_fig(3)/mul_w;
        pos_fig(4) = pos_fig(4)+delta_h;
        set(fig,'position',pos_fig);
        for k=1:length(axe)
                set(axe(k),'Position',get(axe(k),'Position')+[0 delta_h 0 0]);
        end
        set(fig,'Units','normalized');
        set(axe,'Units','normalized');
        drawnow;

        %%%%%%%%%%%% Problem to print on MAC %%%%%%%%%%%
        if strcmp(Machine(1:3),'MAC')
                if ~isempty(hdl_fra)
                    set(hdl_fra,'style','frame');
                    set(hdl_rad,'style','radiobutton');
                    set(hdl_edi,'style','edit');
                    set(hdl_chk,'style','checkbox');
                    set(hdl_txt,'style','text');
                    set(hdl_pop,'style','popupmenu');
                    set(hdl_pus,'style','pushbutton');
                end
        end
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

        if ~isempty(uic_on) , set(uic_on,'Visible','on'); end

%-------------------------------------------------------------------
%       txt = mngfig('txt_note',fig);
%       if length(txt)>0
%               titre   = mngfig('fig_title',fig);
%               txtimp  = str2mat(titre,'------------',txt);
%               if isempty(filename) ,  filename = 'wtxtnote'; end
%               nomtxt  = [filename '.t' numfig];
%               fich    = fopen(nomtxt,'w');
%               for i=1:size(txtimp,1)
%                       ligne = setstr(txtimp(i,:));
%                       ligne = ['\n' ligne];
%                       fprintf(fich,ligne);
%               end     
%               fclose(fich);
%       end
%-------------------------------------------------------------------

        mousefrm(0,'arrow');

%***********************************%
%** OPTION = 'close' QUIT WSETPRI **%
%***********************************%
elseif strcmp(option,'close')
        close(Win_Set);

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('wsetpri','Unknown Option','msg');
        error('*');
end
