function wsettxt(option,txt)
%WSETTXT Setting property values for texts.
%
%       wsettxt('close')        : close dialog window.
%       wsettxt('define',txt)   : define property values.
%       wsettxt('apply',txt)    : validate property values.
%               txt     = handle of the text.
%       wsettxt            <==> wsettxt('apply',gco)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:31:07 $

%       Uses MOUSEFRM, NUM2MSTR, UTSETCOL, UTSETFON, WMEMUTIL.

%       Callbacks WSETTXT.

if nargin==0 
        if strcmp(get(gcf,'SelectionType'),'open')
                option = 'define';
                txt = get(gcf,'CurrentObject');
                if ~strcmp(get(txt,'type'),'text'), return; end
        else
                break
        end
end

tag_set = 'Win_Settxt';
Win_Set = findobj(get(0,'children'),'flat','tag',tag_set);

%***********************************%
%** OPTION = 'close' QUIT WSETTXT **%
%***********************************%
if strcmp(option,'close')
        close(Win_Set);

%***********************************************%
%** OPTION = 'apply' VALIDATE PROPERTY VALUES **%
%***********************************************%
elseif strcmp(option,'apply')
        Settxt_Glob     = get(Win_Set,'Userdata');
        Settxt_Txt_Act  = wmemutil('get',Settxt_Glob,4);
        txt   = Settxt_Txt_Act;
        if strcmp(get(txt,'Visible'),'off') ,  return; end
        Axe_P = get(txt,'Parent');
        %-------------------%
        mousefrm(0,'watch');
        %-------------------%
        Settxt_Handles          = wmemutil('get',Settxt_Glob,1);
        Settxt_Hdls_Color       = wmemutil('get',Settxt_Glob,2);
        Settxt_Hdls_Font        = wmemutil('get',Settxt_Glob,3);
        EdT_Name                = Settxt_Handles(2);
        EdT_XPos                = Settxt_Handles(3);
        EdT_YPos                = Settxt_Handles(4);
        EdT_ZPos                = Settxt_Handles(5);

        %---- Mise a jour Color
        col = utsetcol('get',Settxt_Hdls_Color);
        set(txt,'Color',col);

        %---- Mise a jour String
        set(txt,'String',get(EdT_Name,'String'));

        %---- Mise a jour fonte de caracteres
        utsetfon('write',Settxt_Hdls_Font,txt);

        %---- Mise a jour position
        X = eval(get(EdT_XPos,'String'));
        Y = eval(get(EdT_YPos,'String'));
        Z = eval(get(EdT_ZPos,'String'));
        u = get(txt,'Units');
        set(txt,'Units','pixels');
        set(txt,'Position',[X Y Z]);
        set(txt,'Units',u);

        %-------------------%
        mousefrm(0,'arrow');
        %-------------------%

%**********************************************%
%** OPTION = 'define' DEFINE PROPERTY VALUES **%
%**********************************************%
elseif strcmp(option,'define')
        %---------------------%
        mousefrm(0,'watch');
        %---------------------%
        Settxt_Txt_Act = txt;
        if isempty(Win_Set)
                Def_FraBkColor  = [0.9 0.9 0.9];
                fig_col         = get(0,'DefaultUiCOntrolBackGroundcolor');
                % Def_EdiBkColor = fig_col;
                Def_EdiBkColor = 'w';
                Def_Btn_Height = 22;
                X_Spacing = 4;  Y_Spacing = 4;
                large = 90;     y = 5;  dy = 5;
                Win_Set = figure('Name','Text Parameters',...
                        'NumberTitle','off',    ...
                        'Resize','off',         ...
                        'Visible','off',        ...
                        'Color',fig_col,        ...
                        'Position',[300 200 365 11*dy+9*Def_Btn_Height],...
                        'Tag',tag_set);
                strHdialtxt = int2str(Win_Set);

                action = ['wsettxt(''apply'');'];
                uicontrol('Style','Pushbutton',...
                        'Position',[65 y large Def_Btn_Height],...
                        'String','Apply',...
                        'Callback',action);
                        
%               action = ['set(' strHdialtxt ',''Visible'',''off'');'];
                action = ['close(' strHdialtxt ');'];
                uicontrol('Style','PushButton',...
                        'Position',[115+large y large Def_Btn_Height],...
                        'String','Close',...
                        'Callback',action);

                y = y+dy+Def_Btn_Height;
                large = 150;
                [Settxt_Hdls_Color,pos] = ...
                        utsetcol('define',[10 y],'Text color');

                large = 90;
                y = pos(2)+pos(4)+dy;
                [Settxt_Hdls_Font,pos] = utsetfon('define',[10 y]);

                y = pos(2)+pos(4)+dy;
                uicontrol('Style','Frame',...
                        'BackGroundColor',Def_FraBkColor,...
                        'Position',[20 y large+15 Def_Btn_Height]);
                uicontrol('Style','Text',...
                        'BackGroundColor',Def_FraBkColor,...
                        'Position',[23,y+3,large+9,Def_Btn_Height-6],...
                        'String','Pos : [X Y Z]');
                EdT_XPos = uicontrol('Style','Edit',...
                                'BackGroundColor',Def_EdiBkColor,       ...
                                'Position',[45+large,y,65,Def_Btn_Height]);
                EdT_YPos = uicontrol('Style','Edit',...
                                'BackGroundColor',Def_EdiBkColor,       ...
                                'Position',[45+large+75,y,65,Def_Btn_Height]);
                EdT_ZPos = uicontrol('Style','Edit',...
                                'BackGroundColor',Def_EdiBkColor,       ...
                                'Position',[45+large+150,y,60,Def_Btn_Height]);
                y = y+dy+Def_Btn_Height;
                uicontrol('Style','Frame',...
                        'BackGroundColor',Def_FraBkColor,...
                        'Position',[20 y large Def_Btn_Height]);
                uicontrol('Style','Text',...
                        'BackGroundColor',Def_FraBkColor,...
                        'Position',[23,y+3,large-6,Def_Btn_Height-6],...
                        'String','String :');
                EdT_Name = uicontrol('Style','Edit',...
                                'BackGroundColor',Def_EdiBkColor,       ...
                                'Position',[30+large,y,225,Def_Btn_Height]);
                Settxt_Handles = [Win_Set EdT_Name EdT_XPos EdT_YPos EdT_ZPos];
                Settxt_Glob = [];
                Settxt_Glob = wmemutil('add',Settxt_Glob,Settxt_Handles);
                Settxt_Glob = wmemutil('add',Settxt_Glob,Settxt_Hdls_Color);
                Settxt_Glob = wmemutil('add',Settxt_Glob,Settxt_Hdls_Font);
                Settxt_Glob = wmemutil('add',Settxt_Glob,Settxt_Txt_Act);

                axes('Visible','Off');
                set(Win_Set,'NextPlot','new');

        else
                Settxt_Glob = get(Win_Set,'Userdata');
                Settxt_Handles = wmemutil('get',Settxt_Glob,1);
                Settxt_Hdls_Color = wmemutil('get',Settxt_Glob,2);
                Settxt_Hdls_Font = wmemutil('get',Settxt_Glob,3);
                Settxt_Glob = wmemutil('set',Settxt_Glob,4,Settxt_Txt_Act);
                Win_Set  = Settxt_Handles(1);
                EdT_Name = Settxt_Handles(2);
                EdT_XPos = Settxt_Handles(3);
                EdT_YPos = Settxt_Handles(4);
                EdT_ZPos = Settxt_Handles(5);
                figure(Win_Set);
        end
        set(Win_Set,'Userdata',Settxt_Glob);

        col = get(txt,'Color');
        if strcmp(col,'none') , col = get(get(txt,'Parent'),'Color'); end
        utsetcol('set',Settxt_Hdls_Color,col);
        set(EdT_Name,'String',get(txt,'String'));
        u = get(txt,'Units');
        set(txt,'Units','pixels');
        pos = round(get(txt,'Position'));
        set(txt,'Units',u);
        if length(pos)==2 , pos = [pos 0]; end
        set(EdT_XPos,'String',sprintf('%d',pos(1)));
        set(EdT_YPos,'String',sprintf('%d',pos(2)));
        set(EdT_ZPos,'String',sprintf('%d',pos(3)));
        utsetfon('read',Settxt_Hdls_Font,txt);

        set(Win_Set,'Visible','on');

        %------------------%
        mousefrm(0,'arrow');
        %------------------%

%********************%
%** UNKNOWN OPTION **%
%********************%
else
        errargt('wsettxt','Unknown Option','msg');
        error('*');
end
