function wtxttitl(in1,in2,in3)
%WTXTTITL Set a text as a super title in an axes.
%        wtxttitl(in1,in2,in3)

%       M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%       Copyright (c) 1995-96 by The Mathworks, Inc.
%       $Revision: 1.1 $  $Date: 1996/03/05 21:31:53 $

% in1  = axes;
% in2  = str text
% in3  = tag (optional)
%----------------------
if nargin==2 ,  in3 = ''; end
axes(in1);
h_tit   = get(in1,'title');
s_tit   = get(h_tit,'string');
if isempty(s_tit) , title(' '); drawnow; end
u_tit   = get(h_tit,'Units');
u_txt   = 'pixels';
set(h_tit,'Units',u_txt);
h_txt   = text(0,0,in2,                         ...
                'Units',u_txt,                  ...
                'Color','y',                    ...
                'FontWeight','bold',            ...
                'HorizontalAlignment','center', ...
                'Visible','off',                ...
                'Tag',in3                       ...
                );
e_tit   = get(h_tit,'Extent');
e_txt   = get(h_txt,'Extent');
p_tit   = get(h_tit,'Position');
px_txt  = p_tit(1);
if e_tit(4)>0
        py_txt = e_tit(2)+1.33*e_tit(4);
else
        py_txt = e_tit(2)-0.32*e_tit(4);
end
set(h_txt,'Position',[px_txt py_txt+3],'Visible','on');
% drawnow('discard')
set(h_txt,'Units',get(in1,'Units'));
set(h_tit,'Units',u_tit);
